RIVESCRIPTS.push(`

+ reset pose [please]
- Resetting pose!{js}brain_alive_reset_pose(RIVE_chat);{/js}

+ (move to me|come to me|come here) [please]
- {js}brain_alive_person_come_here(RIVE_chat);{/js}

+ (move to center|go to center|recenter)
- Going to center!{js}brain_alive_person_move_recenter(RIVE_chat);{/js}

+ (move to flag/go to center)
- Moving to flag!{js}brain_alive_person_move_flag(RIVE_chat);{/js}

+ (come to me|Komm zu mir|Ven a mí|Viens à moi|Vieni da me|こっちに来て|내게 와|Venha até mim|过来|Подойди ко мне)
- {ai}{js}brain_alive_person_come_here(RIVE_chat);{/js}

+ (turn around|Dich umdrehen|Girar|Tourne-toi|Girati|回れ|돌아서다|Gire-se|转身|Повернись)
- {ai}{js}brain_alive_person_turn_around(RIVE_chat);{/js}

+ turn left [please]
- Ok, I'm turning to my left.{js}brain_alive_person_turn_left(RIVE_chat);{/js}

+ turn right [please]
- Ok, I'm turning to my right.{js}brain_alive_person_turn_right(RIVE_chat);{/js}

+ smile [please]
- {js}brain_alive_person_expression(RIVE_chat,'smile','medium');{/js}

+ frown [please]
- {js}brain_alive_person_expression(RIVE_chat,'frown','medium');{/js}

+ move (up|further|further away|away) (*m|#|* meter|* meters) [please]
- Ok, I'm moving away: {js}brain_alive_person_move(RIVE_chat,"w", "<star2>");{/js}

+ move (up|further|further away|away)[please]
- Ok, I'm moving away: {js}brain_alive_person_move(RIVE_chat,"w", "<star2>");{/js}

+ move (down|closer) (*m|#|* meter|* meters) [please]
- Ok, I'm moving closer: {js}brain_alive_person_move(RIVE_chat,"s","<star2>");{/js}

+ move (down|closer) [please]
- Ok, I'm moving closer: {js}brain_alive_person_move(RIVE_chat,"s","<star2>");{/js}

+ move (left) (*m|#|* meter|* meters) [please]
- Ok, I'm moving left: {js}brain_alive_person_move(RIVE_chat,"a","<star2>");{/js}

+ move (left) [please]
- Ok, I'm moving left: {js}brain_alive_person_move(RIVE_chat,"a","<star2>");{/js}

+ move (right) (*m|#|* meter|* meters) [please]
- Ok, I'm moving right: {js}brain_alive_person_move(RIVE_chat,"d","<star2>");{/js}

+ move (right) [please]
- Ok, I'm moving right: {js}brain_alive_person_move(RIVE_chat,"d","<star2>");{/js}

+ echo *
- {js}brain_debug_echo(RIVE_chat,"<star>");{/js}

+ do (standing|sitting|lying|crouching) pose (#|random)
- Changing pose to <star1> <star2> {js}brain_alive_person_pose(RIVE_chat,"<star1>","<star2>");{/js}

+ change pose (standing|sitting|lying|crouching) (#|random)
- Changing pose to <star1>:  {js}brain_alive_person_pose(RIVE_chat,"<star1>","<star2>");{/js}

+ change pose (standing|sitting|lying|crouching)
- Picking a random <star1> pose: {js}brain_alive_person_pose(RIVE_chat,"<star1>","random");{/js}

+ (trigger|auslösen|activar|déclencher|attivare|トリガー|트리거|acionar|触发|запуск) *
- {js}brain_vam_trigger(RIVE_chat,"<star2>");{/js}

+ (show me what you see|you see *|you are seeing|you are seeing *)
- {js}brain_vam_show_sight(RIVE_chat);{/js}

+ (react|What do you see?|Was siehst du?|¿Qué ves?|Que vois-tu ?|Cosa vedi?|何を見ているの？|何が見えますか？|무엇을 보고 있나요?|O que você vê?|你看到了什么？|Что ты видишь?)
- {js}brain_vam_show_sight(RIVE_chat);{/js}

+ (loreipsum|loremipsum)
- "The quick brown fox jumps over the lazy dog" is an English-language pangram – a sentence that contains all the letters of the alphabet. The phrase is commonly used for touch-typing practice, testing typewriters and computer keyboards, displaying examples of fonts, and other applications.

+ poeme 1
- Oui. Je comprends qu'on aille aux fêtes.

+ poeme 2
- Oui. Je comprends qu'on aille aux fêtes. Qu'on soit foule, qu'on brille aux yeux. Qu'on fasse, amis, ce que vous faites. Et qu'on trouve cela joyeux ; Mais vivre seul sous les étoiles, Aller et venir sous les voiles. Du désert où nous oublions, Respirer l'immense atmosphère ; C'est âpre et triste, et je préfère... Cette habitude des lions.



`);




function brain_alive_reset_pose(callback, payload) {
    aevent({action: "aliveResetPose"});
    callback("", payload);
}

function brain_alive_person_come_here(callback, payload) {
    aevent({action: "personComeHere"});
    callback("", payload);
}
function brain_alive_person_move_recenter(callback, payload) {
    aevent({action: "aliveRecenterPerson"});
    callback("", payload);
}
function brain_alive_person_move_flag(callback, payload) {
    aevent({action: "personMoveToFlag"});
    callback("", payload);
}

function brain_alive_person_turn_around(callback, payload) {
    aevent({action: 'poseRotationAdd', value: 180, direct: true});
    callback("", payload);
}

function brain_alive_person_turn_left(callback, payload) {
    aevent({action: 'poseRotationAdd', value: 90, direct: true});
    callback("", payload);
}

function brain_alive_person_turn_right(callback, payload) {
    aevent({action: 'poseRotationAdd', value: -90, direct: true});
    callback("", payload);
}

function brain_alive_person_expression(callback, expression, duration, payload) {
    aevent({action: 'setExpression', expression: expression, duration: duration});
    callback("", payload);
}

function brain_alive_person_move(callback, direction, distance, payload) {
    var val = 0.5;
    if (distance !== null && distance != "") {
        distance = distance.replace(" meters");
        distance = distance.replace("m");
        distance = parseFloat(distance);
        if (distance > 0)
            val = distance;
    }
    aevent({action: "poseMove", value: val, direction: direction});
    callback(distance + " meters.", payload);
}

function brain_debug_echo(callback, text, payload) {
    msg = payload.message.replace("echo ", "");
    callback(msg , payload);
}

function brain_alive_person_pose(callback, pose, number, payload) {
    var poses = JSON.parse(EPHEMERAL.vamdata.poses);
    var keys = Object.keys(poses).reverse();
    if (keys.length > 1) {
        for (var key of keys) {
            if (key.toLowerCase() === "aes-" + pose) {
                var posesCount = parseInt(poses[key]);
                if (posesCount !== null) {
                    if (number === "random") {
                        number = randomIntFromInterval(1, posesCount);
                    } else {
                        number = parseInt(number);
                    }
                    if (number < 0 ) number = 0;
                    if(number > posesCount) number = posesCount;
                    var poseid = number.toString().padStart(3, '0');
                    aevent({action: 'changePose', posefolder: key, poseid: poseid});
                    break;
                }
            }
        }
    }

    callback(number, payload);
}

function brain_vam_trigger(callback,trigger,payload){
    trigger = trigger.replace(/[^a-z0-9]/gi, "");
    aevent({action:"vamTriggerButton",id:trigger});
    callback(trigger, payload);
}

function brain_vam_show_sight(callback, payload) {
    var msg = "";
    aevent({ action: "query", context: "android", query: "showSight" });
    callback(msg, payload);
}