﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class AeternumCleanup : MVRScript {
		
		bool sceneLoaded = false;

		public JSONStorableFloat ping_p67;
		float pingLimit_p67 = 3f;

		private Camera mainCamera;
		private Camera screenshotCamera;
		private Camera screenshotCamera2;


		public override void Init() {
			ping_p67 = new JSONStorableFloat("ping", Time.time,0f,0f,false);
			RegisterFloat(ping_p67);
			InvokeRepeating("UpdateSecond", 1f, 1f);
			InvokeRepeating("UpdateConstant", 1f, 1f / 30f);
			InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);
			SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;

			mainCamera = CameraTarget.centerTarget.targetCamera;
			mainCamera.clearFlags = CameraClearFlags.SolidColor;
			screenshotCamera = SuperController.singleton.hiResScreenshotCamera;
			screenshotCamera.clearFlags = CameraClearFlags.SolidColor;
			screenshotCamera2 = SuperController.singleton.screenshotCamera;
			screenshotCamera2.clearFlags = CameraClearFlags.SolidColor;


		}

	
		void Start() {
			ping_p67.val = Time.time;
		}

	
		void Update() {
		
		}

	
		void FixedUpdate() {
		
		}
		void UpdateSecond()
		{
			CheckCleanup_p67();
			if (IsDisabled()) return;

		}
		void UpdateConstant()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant5()
		{
			if (IsDisabled()) return;

		}
		void OnDestroy()
		{
			CancelInvoke();
			SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
		}

		void OnSceneLoaded()
		{
			sceneLoaded = true;
			
		}
		bool IsDisabled()
        {
			if (!enabledJSON.val)
			{
				return true;
			}
			return false;
		}

		void CheckCleanup_p67()
        {
			if(Time.time - ping_p67.val > pingLimit_p67){
				DoCleanup_p67();
            }
        }
		void DoCleanup_p67(){
			var color = new HSVColor();
			color.H = 0f;
			color.S = 0f;
			color.V = 0f;
			SetMainBackgroundColor_p67(color);
			var atoms = SuperController.singleton.GetAtoms();
			foreach (var atom in atoms)
			{
				if (atom.uid.StartsWith("AEMainMenu") || atom.uid.StartsWith("AliveMoveMarker"))
                {
					if(atom.uid != containingAtom.uid)
                    {
						SuperController.singleton.RemoveAtom(atom);
                    }
                }
			}
			SuperController.singleton.RemoveAtom(containingAtom);
        }

		
        
		public void SetMainBackgroundColor_p67(HSVColor h)
		{
			var c = Color.HSVToRGB(h.H, h.S, h.V);
			mainCamera.backgroundColor = c;
			screenshotCamera.backgroundColor = c;
			screenshotCamera2.backgroundColor = c;
		}
	}
}