﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class AliveButtons : MVRScript {


		public Dictionary<string, EventTrigger> myEventTriggers_p67 = new Dictionary<string, EventTrigger>();
		public Dictionary<string, UIDynamicButton> buttons_p67 = new Dictionary<string, UIDynamicButton>();
		public Dictionary<string, JSONStorableString> strings_p67 = new Dictionary<string, JSONStorableString>();
		public Dictionary<string, JSONStorableAction> actions_p67 = new Dictionary<string, JSONStorableAction>();
		public Dictionary<string, JSONStorableStringChooser> choosers_p67 = new Dictionary<string, JSONStorableStringChooser>();
		Dictionary<string, JSONStorableString> titles = new Dictionary<string, JSONStorableString>();

		private Atom coreControl;

		public override void Init() {
			coreControl = SPQRUtils.GetAtomById_p67("CoreControl");

			CreateSpacer_p67(10f, false);
			CreateTitle_p67("t1", "Button Name:", 40, false);
			CreateSpacer_p67( 5f, false);
			CreateSpacer_p67(20f, true);
			strings_p67.Add("Name", new JSONStorableString("Name", "Untitled"));
			RegisterString(strings_p67["Name"]);
			var t1 = SPQRUtils.CreateTextInput_p67(this, null, strings_p67["Name"], true);
			t1[0].height = 10f;

			CreateTitle_p67("t2", "Button Page:", 40, false);
			CreateSpacer_p67(15f, false);
			CreateSpacer_p67(0f, true);
			List<string> options = new List<string>(new string[] { "1","2","3","4","5" });
			choosers_p67.Add("Page", new JSONStorableStringChooser("Page", options, "1", "Page"));
			RegisterStringChooser(choosers_p67["Page"]);
			CreatePopup(choosers_p67["Page"], true);


			CreateTitle_p67("t3", "Button CSS style:", 40, false);
			CreateSpacer_p67(0f, false);
			CreateSpacer_p67(20f, true);
			strings_p67.Add("Style", new JSONStorableString("Style", "background:#ccc; color:#333;"));
			RegisterString(strings_p67["Style"]);
			var t2 = SPQRUtils.CreateTextInput_p67(this, null, strings_p67["Style"], true);
			t2[0].height = 10f;


		}


        void Start() {
		
		}

	
		void Update() {
		
		}

	
		void FixedUpdate() {
		
		}


		UIDynamic CreateSpacer_p67(float height, bool rightSide)
		{
			UIDynamic spacer = CreateSpacer(rightSide);
			spacer.height = height;
			return spacer;
		}

		void CreateTitle_p67(string id, string text, int fontsize, bool right)
		{
			if (!titles.ContainsKey(id))
				titles.Add(id, new JSONStorableString("title " + id, "\n<size=" + fontsize + "><b>" + text + "</b></size>"));
			UIDynamicTextField title1text = CreateTextField(titles[id], right);
			title1text.UItext.supportRichText = true;
			title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
			title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
			title1text.height = 100f;
			title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
		}




	}
}