﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class AliveEvents : MVRScript {
		
		bool sceneLoaded = false;

		Dictionary<string, EventTrigger> myEventTriggers_p67 = new Dictionary<string, EventTrigger>();
		Dictionary<string, UIDynamicButton> buttons_p67 = new Dictionary<string, UIDynamicButton>();
		Dictionary<string, JSONStorableString> strings_p67 = new Dictionary<string, JSONStorableString>();
		Dictionary<string, JSONStorableAction> actions_p67 = new Dictionary<string, JSONStorableAction>();

		string browserIdMainMenu_p67 = "AEMainMenu";
		private Atom coreControl;

		public override void Init() {
			coreControl = SPQRUtils.GetAtomById_p67("CoreControl");
			strings_p67.Add("AliveData", new JSONStorableString("AliveData", "{}", AliveSendEvent));
			RegisterString(strings_p67["AliveData"]);
			SPQRUtils.CreateTextInput_p67(this, null, strings_p67["AliveData"], false);
            //buttons_p67.Add("AliveSendEvent", SPQRUtils.CreateButton_p67(this, "AliveSendEvent", AliveSendEvent, true));
			//actions_p67.Add("AliveSendEvent", new JSONStorableAction("AliveSendEvent", AliveSendEvent));

		}


        void Start() {
		
		}

	
		void Update() {
		
		}

	
		void FixedUpdate() {
		
		}
	
		void AliveSendEvent(string aJSON)
        {
			if (aJSON == "") return;
			if (aJSON == "{}") return;

			aJSON = aJSON.Replace("<%id%>", containingAtom.GetInstanceID().ToString());

			try
			{
				bool foundPersonId = false;
				bool foundTime = false;
				JSONNode jSONNode = JSON.Parse(aJSON);
				jSONNode.Add("isApi", "true");
				foreach (var item in jSONNode.AsObject.Keys)
				{
					if(item == "person" && containingAtom.type == "Person")
                    {
						foundPersonId = true;
						jSONNode[item].Value = containingAtom.GetInstanceID().ToString();
					}
					if (item == "t")
					{
						foundTime = true;
						jSONNode[item].Value = SPQRUtils.Timestamp_p67();
					}
				}
                if (!foundPersonId && containingAtom.type == "Person") jSONNode.Add("person", containingAtom.GetInstanceID().ToString());
				if (!foundTime) jSONNode.Add("t", SPQRUtils.Timestamp_p67());
				if (jSONNode["android"] == null) jSONNode.Add("android", "0");


                if (coreControl != null)
				{
					coreControl.BroadcastMessage("AeMainmenuCallback", jSONNode.ToString());
				}


			} catch(Exception e)
            {
				SuperController.LogError("AliveEvents: failed processing data, not valid json: " + aJSON);
            }
			strings_p67["AliveData"].val = "{}";
		}



	}
}