using System;
using UnityEngine;
using System.Collections;
using System.Linq;
using System.Collections.Generic;
using MeshVR;
using SimpleJSON;
using MVR.FileManagementSecure;
using UnityEngine.PostProcessing;
using UnityStandardAssets.ImageEffects;
using Leap;

namespace SPQR
{

    public class AeSettings
    {
        public Dictionary<string, string> settings_p67;

        string localSavesPath = @"Saves/PluginData/Aeternum/";

    

        public AeSettings()
        {
            
            settings_p67 = new Dictionary<string, string>() { };
        }

        public void Init_p67()
        {
            try
            {
                CreateAEDirectories_p67();
                InitSettingsFile_p67();
                //LoadSetings_p67();
            }
            catch (Exception e)
            {
                SuperController.LogError("err1:" + e);
            }
        }



      

        public void Update_p67()
        {
        }
        public void UpdateSecond_p67()
        {
            //SuperController.LogMessage("phytime:" + Time.fixedDeltaTime);
        }
        public void FixedUpdate_p67()
        {
        }


        private void CreateAEDirectories_p67()
        {
            if (!FileManagerSecure.DirectoryExists(localSavesPath)) FileManagerSecure.CreateDirectory(localSavesPath);
            if (!FileManagerSecure.DirectoryExists(getDataSaveDir1_p67())) FileManagerSecure.CreateDirectory(getDataSaveDir1_p67());
            if (!FileManagerSecure.DirectoryExists(getDataCacheDir_p67())) FileManagerSecure.CreateDirectory(getDataCacheDir_p67());
            if (!FileManagerSecure.DirectoryExists(getDataSaveDir_p67())) FileManagerSecure.CreateDirectory(getDataSaveDir_p67());
            if (!FileManagerSecure.DirectoryExists(getDataSaveDir_p67()+ "data/")) FileManagerSecure.CreateDirectory(getDataSaveDir_p67()+ "data/");

        }

        public string getDataSaveDir_p67()
        {
            return localSavesPath + "Ae/Html/";
        }
        public string getDataSaveDir1_p67()
        {
            return localSavesPath + "Ae/";
        }
        public string getDataCacheDir_p67()
        {
            return localSavesPath + "Ae/cache/";
        }

        public void ReadSettings_p67()
        {
            var fname = GetSettingsFileName_p67()+".json";
            if (!FileManagerSecure.FileExists(fname))
            {
                return;
            }
            ClearAllSettings_p67();

            string aJSON = SuperController.singleton.ReadFileIntoString(fname);
            
            bool fail = false;
            if (aJSON.Length <= 0)
            {
                fail = true;
                
            }
            JSONNode jSONNode = null;
            if (!fail)
            {
                
                try
                {
                    jSONNode = JSON.Parse(aJSON);
                }
                catch (Exception e)
                {
                    SuperController.LogError("ALIVE: failed reading settings. Resetting settings." + e);
                    fail = true;
                }
                if (!fail && jSONNode.AsObject.Keys.Count() < 1) fail = true;
            }

            if (fail)
            {
                SetDefaultSettings_p67();
            }
            else
            {
                foreach (var item in jSONNode.AsObject.Keys)
                {
                    SetSetting_p67(item, jSONNode[item].Value);
                }
            }

        }

        List<string> cachedGetSettingsString_p67 = null;
        public string GetSettingsString_p67()
        {
            JSONClass jsdata = new JSONClass();
            cachedGetSettingsString_p67 = new List<string>(settings_p67.Keys);
            foreach (var key in cachedGetSettingsString_p67)
            {
                jsdata.Add(key, new JSONData(settings_p67[key]));
            }
            return jsdata.ToString();

        }



        public void SaveSettings_p67()
        {
            var fname = GetSettingsFileName_p67()+".json";
            if (!FileManagerSecure.FileExists(fname)) return;
            var jsdata = GetSettingsString_p67();
            FileManagerSecure.WriteAllText(fname, jsdata);
        }

        string GetSettingsFileName_p67()
        {
            var s = getDataSaveDir_p67() + "data/settings";
            return s;
        }
        void InitSettingsFile_p67()
        {
            var fname = GetSettingsFileName_p67()+".json";

            if (!FileManagerSecure.FileExists(fname)) {
                CreateAEDirectories_p67();
                SetDefaultSettings_p67();
            } else
            {
                ReadSettings_p67();
                SetDefaultSettingsIfMissing_p67();
            }
        }

        public void SetDefaultSettings_p67()
        {
            ClearAllSettings_p67();
            SetDefaultSettingsIfMissing_p67();
            SaveSettings_p67();

        }

        public void ResetDefaultSettingsCustom_p67(List<string> vals)
        {
            foreach(var val in vals)
            {
                if (settings_p67.ContainsKey(val)) settings_p67.Remove(val);
            }
            SetDefaultSettingsIfMissing_p67();
            //SuperController.LogMessage("ALIVE: reset settings!");
        }
        public void ResetDefaultSettingsPrefix_p67(string prefix)
        {
            if(cachedGetSettingsString_p67 == null) cachedGetSettingsString_p67 = new List<string>(settings_p67.Keys);
            foreach (var val in cachedGetSettingsString_p67)
            {
                if (val.StartsWith(prefix)) settings_p67.Remove(val);
            }
            SetDefaultSettingsIfMissing_p67();
            //SuperController.LogMessage("ALIVE: reset settings!");
        }
        public void SetDefaultSettingsIfMissing_p67()
        {
            bool changed = false;
            if (!settings_p67.ContainsKey("defaultTime")) { changed = true; SetSetting_p67("defaultTime", SPQRUtils.TimePretty_p67()); }
            if (!settings_p67.ContainsKey("aliveUiEnabled")) { changed = true; SetSetting_p67("aliveUiEnabled", true); }


            /* player info */
            if (!settings_p67.ContainsKey("aplName")) { changed = true; SetSetting_p67("aplName", "John"); }
            if (!settings_p67.ContainsKey("aplGender")) { changed = true; SetSetting_p67("aplGender", "male"); }
            if (!settings_p67.ContainsKey("aplPronouns")) { changed = true; SetSetting_p67("aplPronouns", "he/him"); }
            if (!settings_p67.ContainsKey("aplAge")) { changed = true; SetSetting_p67("aplAge", 69); }
            if (!settings_p67.ContainsKey("aplDescription")) { changed = true; SetSetting_p67("aplDescription", "{{user}} enjoys playing a naughty video game called VAM."); }


            if (!settings_p67.ContainsKey("sedAutoRefresh")) { changed = true; SetSetting_p67("sedAutoRefresh", false); }


            /* Other features */
            if (!settings_p67.ContainsKey("sttCompositePosing2")) { changed = true; SetSetting_p67("sttCompositePosing2", false); }
            if (!settings_p67.ContainsKey("sttAutodropHands")) { changed = true; SetSetting_p67("sttAutodropHands", false); }
            if (!settings_p67.ContainsKey("sttOptimizeOutofviewAlive")) { changed = true; SetSetting_p67("sttOptimizeOutofviewAlive", true); }
            if (!settings_p67.ContainsKey("sttEnabledLodMorphs")) { changed = true; SetSetting_p67("sttEnabledLodMorphs", true); }
            if (!settings_p67.ContainsKey("stgEnableHeadlightShadows")) { changed = true; SetSetting_p67("stgEnableHeadlightShadows", false); }
            if (!settings_p67.ContainsKey("stgHeadlightRange")) { changed = true; SetSetting_p67("stgHeadlightRange", 25f); }
            if (!settings_p67.ContainsKey("stgHeadlightAngle")) { changed = true; SetSetting_p67("stgHeadlightAngle", 140f); }
            if (!settings_p67.ContainsKey("stgHeadlightsForced")) { changed = true; SetSetting_p67("stgHeadlightsForced", false); }
            if (!settings_p67.ContainsKey("stgHeadlightsForceOne")) { changed = true; SetSetting_p67("stgHeadlightsForceOne", false); }
            if (!settings_p67.ContainsKey("stgForceGlutesOff")) { changed = true; SetSetting_p67("stgForceGlutesOff", false); }
            if (!settings_p67.ContainsKey("stgForceBreastsOff")) { changed = true; SetSetting_p67("stgForceBreastsOff", false); }
            if (!settings_p67.ContainsKey("stgAutoTonguePhysics")) { changed = true; SetSetting_p67("stgAutoTonguePhysics", true); }
            if (!settings_p67.ContainsKey("stgAliveIndicator")) { changed = true; SetSetting_p67("stgAliveIndicator", true); }
            if (!settings_p67.ContainsKey("stLookgeneratorMorphchance")) { changed = true; SetSetting_p67("stLookgeneratorMorphchance", 5); }
            if (!settings_p67.ContainsKey("stLookgeneratorMorphmin")) { changed = true; SetSetting_p67("stLookgeneratorMorphmin", 0.05f); }
            if (!settings_p67.ContainsKey("stLookgeneratorMorphmax")) { changed = true; SetSetting_p67("stLookgeneratorMorphmax", 0.33f); }

            if (!settings_p67.ContainsKey("stAmbienceLoopCutoff")) { changed = true; SetSetting_p67("stAmbienceLoopCutoff", 0.20f); }

            /* VFX */
            //if (!settings_p67.ContainsKey("vfxTime")) { changed = true; SetSetting_p67("vfxTime", 1f); }
            //if (!settings_p67.ContainsKey("vfxWorldscale")) { changed = true; SetSetting_p67("vfxWorldscale", 1f); }
            //if (!settings_p67.ContainsKey("vfxFrameByFrame")) { changed = true; SetSetting_p67("vfxFrameByFrame", false); }

            /* FPS */
            if (!settings_p67.ContainsKey("fpsEnabled")) { changed = true; SetSetting_p67("fpsEnabled", true); }
            if (!settings_p67.ContainsKey("3rdpersonEnabled")) { changed = true; SetSetting_p67("3rdpersonEnabled", true); }
            if (!settings_p67.ContainsKey("fpsPlayerHeight")) { changed = true; SetSetting_p67("fpsPlayerHeight", 1.75f); }
            if (!settings_p67.ContainsKey("fpsMouseSensitivity")) { changed = true; SetSetting_p67("fpsMouseSensitivity", 0.65f); }
            if (!settings_p67.ContainsKey("fpsWalkSpeed")) { changed = true; SetSetting_p67("fpsWalkSpeed", 3f); }
            if (!settings_p67.ContainsKey("fpsAcceleration")) { changed = true; SetSetting_p67("fpsAcceleration", 1.5f); }
            if (!settings_p67.ContainsKey("fpsJumpHeight")) { changed = true; SetSetting_p67("fpsJumpHeight", 0.6f); }
            if (!settings_p67.ContainsKey("fpsJumpDuration")) { changed = true; SetSetting_p67("fpsJumpDuration", 0.7f); }
            if (!settings_p67.ContainsKey("fpsFovNormal")) { changed = true; SetSetting_p67("fpsFovNormal", 60f); }
            if (!settings_p67.ContainsKey("fpsFovZoom")) { changed = true; SetSetting_p67("fpsFovZoom", 30f); }

            /*CMD settings*/
            if (!settings_p67.ContainsKey("sttCmdBjSpeed")) { changed = true; SetSetting_p67("sttCmdBjSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdBjPower")) { changed = true; SetSetting_p67("sttCmdBjPower", 1f); }
            if (!settings_p67.ContainsKey("sttCmdRideSpeed")) { changed = true; SetSetting_p67("sttCmdRideSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdRidePower")) { changed = true; SetSetting_p67("sttCmdRidePower", 1f); }
            if (!settings_p67.ContainsKey("sttCmdRideGentleSpeed")) { changed = true; SetSetting_p67("sttCmdRideGentleSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdRideGentlePower")) { changed = true; SetSetting_p67("sttCmdRideGentlePower", 1f); }
            if (!settings_p67.ContainsKey("sttCmdThrustSpeed")) { changed = true; SetSetting_p67("sttCmdThrustSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdThrustPower")) { changed = true; SetSetting_p67("sttCmdThrustPower", 1f); }
            if (!settings_p67.ContainsKey("sttCmdHipsideSpeed")) { changed = true; SetSetting_p67("sttCmdHipsideSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdHipsidePower")) { changed = true; SetSetting_p67("sttCmdHipsidePower", 1f); }
            if (!settings_p67.ContainsKey("sttCmdTwerkSpeed")) { changed = true; SetSetting_p67("sttCmdTwerkSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdTwerkPower")) { changed = true; SetSetting_p67("sttCmdTwerkPower", 1f); }
            if (!settings_p67.ContainsKey("sttCmdVibeSpeed")) { changed = true; SetSetting_p67("sttCmdVibeSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdVibePower")) { changed = true; SetSetting_p67("sttCmdVibePower", 1f); }
            if (!settings_p67.ContainsKey("sttCmdVibe2Speed")) { changed = true; SetSetting_p67("sttCmdVibe2Speed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdVibe2Power")) { changed = true; SetSetting_p67("sttCmdVibe2Power", 1f); }
            if (!settings_p67.ContainsKey("sttCmdHeadbopSpeed")) { changed = true; SetSetting_p67("sttCmdHeadbopSpeed", 1f); }
            if (!settings_p67.ContainsKey("sttCmdHeadbopPower")) { changed = true; SetSetting_p67("sttCmdHeadbopPower", 1f); }

            if (!settings_p67.ContainsKey("tmpCmdChesttwisterSpeed")) { changed = true; SetSetting_p67("tmpCmdChesttwisterSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdChesttwisterPower")) { changed = true; SetSetting_p67("tmpCmdChesttwisterPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdChestgrindSpeed")) { changed = true; SetSetting_p67("tmpCmdChestgrindSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdChestgrindPower")) { changed = true; SetSetting_p67("tmpCmdChestgrindPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdBootygrindSpeed")) { changed = true; SetSetting_p67("tmpCmdBootygrindSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdBootygrindPower")) { changed = true; SetSetting_p67("tmpCmdBootygrindPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLefthandjobSpeed")) { changed = true; SetSetting_p67("tmpCmdLefthandjobSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLefthandjobPower")) { changed = true; SetSetting_p67("tmpCmdLefthandjobPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRighthandjobSpeed")) { changed = true; SetSetting_p67("tmpCmdRighthandjobSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRighthandjobPower")) { changed = true; SetSetting_p67("tmpCmdRighthandjobPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLefthandrubSpeed")) { changed = true; SetSetting_p67("tmpCmdLefthandrubSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLefthandrubPower")) { changed = true; SetSetting_p67("tmpCmdLefthandrubPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRighthandrubSpeed")) { changed = true; SetSetting_p67("tmpCmdRighthandrubSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRighthandrubPower")) { changed = true; SetSetting_p67("tmpCmdRighthandrubPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLefthandslapSpeed")) { changed = true; SetSetting_p67("tmpCmdLefthandslapSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLefthandslapPower")) { changed = true; SetSetting_p67("tmpCmdLefthandslapPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRighthandslapSpeed")) { changed = true; SetSetting_p67("tmpCmdRighthandslapSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRighthandslapPower")) { changed = true; SetSetting_p67("tmpCmdRighthandslapPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdFeetjobSpeed")) { changed = true; SetSetting_p67("tmpCmdFeetjobSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdFeetjobPower")) { changed = true; SetSetting_p67("tmpCmdFeetjobPower", 1f); }

            if (!settings_p67.ContainsKey("tmpCmdLeftfootjobSpeed")) { changed = true; SetSetting_p67("tmpCmdLeftfootjobSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLeftfootjobPower")) { changed = true; SetSetting_p67("tmpCmdLeftfootjobPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRightfootjobSpeed")) { changed = true; SetSetting_p67("tmpCmdRightfootjobSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRightfootjobPower")) { changed = true; SetSetting_p67("tmpCmdRightfootjobPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLeftfootrubSpeed")) { changed = true; SetSetting_p67("tmpCmdLeftfootrubSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdLeftfootrubPower")) { changed = true; SetSetting_p67("tmpCmdLeftfootrubPower", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRightfootrubSpeed")) { changed = true; SetSetting_p67("tmpCmdRightfootrubSpeed", 1f); }
            if (!settings_p67.ContainsKey("tmpCmdRightfootrubPower")) { changed = true; SetSetting_p67("tmpCmdRightfootrubPower", 1f); }


            /* Handling */
            if (!settings_p67.ContainsKey("sttTposeAutoCorrect")) { changed = true; SetSetting_p67("sttTposeAutoCorrect", true); }
            if (!settings_p67.ContainsKey("sttMouthAutoOpen")) { changed = true; SetSetting_p67("sttMouthAutoOpen", true); }
            //if (!settings_p67.ContainsKey("sttStickyHead")) { changed = true; SetSetting_p67("sttStickyHead", true); }
            //if (!settings_p67.ContainsKey("sttStickyHeadTreshold")) { changed = true; SetSetting_p67("sttStickyHeadTreshold", 0.25f); }
            //if (!settings_p67.ContainsKey("sttStickyHip")) { changed = true; SetSetting_p67("sttStickyHip", true); }
            //if (!settings_p67.ContainsKey("sttStickyHipTreshold")) { changed = true; SetSetting_p67("sttStickyHipTreshold", 0.25f); }
            if (!settings_p67.ContainsKey("sttSelectedController")) { changed = true; SetSetting_p67("sttSelectedController", true); }
            if (!settings_p67.ContainsKey("sttControllersCorrect")) { changed = true; SetSetting_p67("sttControllersCorrect", false); }
            //if (!settings_p67.ContainsKey("sttStickyParentMode")) { changed = true; SetSetting_p67("sttStickyParentMode", true); }


            /* Cinematic */

            if (!settings_p67.ContainsKey("cinematicDuration")) { changed = true; SetSetting_p67("cinematicDuration", 3f); }
            if (!settings_p67.ContainsKey("cinematicSpeed")) { changed = true; SetSetting_p67("cinematicSpeed", 1f); }



            /* Display */
            if (!settings_p67.ContainsKey("sttUiColor")) { changed = true; SetSetting_p67("sttUiColor", "#9c23bb"); }
            if (!settings_p67.ContainsKey("sttAnisotropicFiltering")) { changed = true; SetSetting_p67("sttAnisotropicFiltering", true); }
            if (!settings_p67.ContainsKey("sttDisplayFPSLimit")) { changed = true; SetSetting_p67("sttDisplayFPSLimit", -1); }
            if (!settings_p67.ContainsKey("sttDesktopUIWidth")) { changed = true; SetSetting_p67("sttDesktopUIWidth", 400); }
            if (!settings_p67.ContainsKey("sttFloatingScale")) { changed = true; SetSetting_p67("sttFloatingScale", 0.5f); }
            if (!settings_p67.ContainsKey("sttFloatingWidth")) { changed = true; SetSetting_p67("sttFloatingWidth",800); }
            if (!settings_p67.ContainsKey("sttFloatingHeight")) { changed = true; SetSetting_p67("sttFloatingHeight", 600); }
            //if (!settings_p67.ContainsKey("sttVrRoomscale")) { changed = true; SetSetting_p67("sttVrRoomscale", false); }
            if (!settings_p67.ContainsKey("sttFloatingScaleVR")) { changed = true; SetSetting_p67("sttFloatingScaleVR", 0.5f); }
            if (!settings_p67.ContainsKey("sttFloatingWidthVR")) { changed = true; SetSetting_p67("sttFloatingWidthVR", 800); }
            if (!settings_p67.ContainsKey("sttFloatingHeightVR")) { changed = true; SetSetting_p67("sttFloatingHeightVR", 600); }
            if (!settings_p67.ContainsKey("sttFloatingExtras")) { changed = true; SetSetting_p67("sttFloatingExtras", true); }
            if (!settings_p67.ContainsKey("sttFloatingVRExtras")) { changed = true; SetSetting_p67("sttFloatingVRExtras", true); }
            if (!settings_p67.ContainsKey("sttFloatingAsSidebar")) { changed = true; SetSetting_p67("sttFloatingAsSidebar", false); }
            if (!settings_p67.ContainsKey("sttFloatingAsSidebarX")) { changed = true; SetSetting_p67("sttFloatingAsSidebarX", -0.2028f); }
            if (!settings_p67.ContainsKey("sttFloatingAsSidebarY")) { changed = true; SetSetting_p67("sttFloatingAsSidebarY", 0.0288f); }
            if (!settings_p67.ContainsKey("sttFloatingAsSidebarZ")) { changed = true; SetSetting_p67("sttFloatingAsSidebarZ", 0.9869f); }


            //if (!settings_p67.ContainsKey("sttPhysicsFPSLimit")) { changed = true; SetSetting_p67("sttPhysicsFPSLimit", 30); }
            if (!settings_p67.ContainsKey("sttRunInBackground")) { changed = true; SetSetting_p67("sttRunInBackground", true); }
            if (!settings_p67.ContainsKey("sttOptimizePhysicsRate")) { changed = true; SetSetting_p67("sttOptimizePhysicsRate", false); }
           
            /* Settings Audio */
            if (!settings_p67.ContainsKey("sttSoundVolume")) { changed = true; SetSetting_p67("sttSoundVolume", 1f); }
            if (!settings_p67.ContainsKey("staEnableAliveAudio")) { changed = true; SetSetting_p67("staEnableAliveAudio", true); }
            if (!settings_p67.ContainsKey("staEnableAliveSpanking")) { changed = true; SetSetting_p67("staEnableAliveSpanking", true); }
            if (!settings_p67.ContainsKey("staEnableAliveBreathingSounds")) { changed = true; SetSetting_p67("staEnableAliveBreathingSounds", true); }
            if (!settings_p67.ContainsKey("staEnableAliveMoaningSounds")) { changed = true; SetSetting_p67("staEnableAliveMoaningSounds", true); }
            if (!settings_p67.ContainsKey("staEnableAlivePenetrationSounds")) { changed = true; SetSetting_p67("staEnableAlivePenetrationSounds", true); }
            if (!settings_p67.ContainsKey("staEnableAliveBlowjobSounds")) { changed = true; SetSetting_p67("staEnableAliveBlowjobSounds", true); }
            if (!settings_p67.ContainsKey("staEnableAliveKissingSounds")) { changed = true; SetSetting_p67("staEnableAliveKissingSounds", true); }
            if (!settings_p67.ContainsKey("sttEnableSFX")) { changed = true; SetSetting_p67("sttEnableSFX", true); }
            if (!settings_p67.ContainsKey("sttSoundFXVolume")) { changed = true; SetSetting_p67("sttSoundFXVolume", 0.5f); }
            if (!settings_p67.ContainsKey("staLipsyncVolume")) { changed = true; SetSetting_p67("staLipsyncVolume", 1f); }
            if (!settings_p67.ContainsKey("staLipsyncForce")) { changed = true; SetSetting_p67("staLipsyncForce", true); }


            if (!settings_p67.ContainsKey("stAutosavesEnabled")) { changed = true; SetSetting_p67("stAutosavesEnabled", true); }
            if (!settings_p67.ContainsKey("stAutosavesCount")) { changed = true; SetSetting_p67("stAutosavesCount", 10f); }
            if (!settings_p67.ContainsKey("stAutosavesInterval")) { changed = true; SetSetting_p67("stAutosavesInterval", 15f); }

            /* Settings lively */
            if (!settings_p67.ContainsKey("stlLivelyTics")) { changed = true; SetSetting_p67("stlLivelyTics", true); }
            if (!settings_p67.ContainsKey("stlLivelyFacialStates")) { changed = true; SetSetting_p67("stlLivelyFacialStates", true); }
            if (!settings_p67.ContainsKey("stlLivelyFacialStrength")) { changed = true; SetSetting_p67("stlLivelyFacialStrength", 1f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesOn")) { changed = true; SetSetting_p67("stlLivelyEyesOn", true); }
            if (!settings_p67.ContainsKey("stlLivelyEyesChance")) { changed = true; SetSetting_p67("stlLivelyEyesChance", 1f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesFactor")) { changed = true; SetSetting_p67("stlLivelyEyesFactor", 1f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesBlinkChance")) { changed = true; SetSetting_p67("stlLivelyEyesBlinkChance", 12f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesBlinkValue")) { changed = true; SetSetting_p67("stlLivelyEyesBlinkValue", 0.7f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesBlinkMin")) { changed = true; SetSetting_p67("stlLivelyEyesBlinkMin", 0.25f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesBlinkMax")) { changed = true; SetSetting_p67("stlLivelyEyesBlinkMax", 0.65f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesEyelidsFactor")) { changed = true; SetSetting_p67("stlLivelyEyesEyelidsFactor", 0.75f); }
            if (!settings_p67.ContainsKey("stlLivelyEyesEyelidsoffset")) { changed = true; SetSetting_p67("stlLivelyEyesEyelidsoffset", -2f); }
            if (!settings_p67.ContainsKey("sttlLivelyEyesAutoIrisDistance")) { changed = true; SetSetting_p67("sttlLivelyEyesAutoIrisDistance", true); }

            if (!settings_p67.ContainsKey("stlLivelyMouthOn")) { changed = true; SetSetting_p67("stlLivelyMouthOn", true); }
            if (!settings_p67.ContainsKey("stlLivelyMouthChance")) { changed = true; SetSetting_p67("stlLivelyMouthChance", 1f); }
            if (!settings_p67.ContainsKey("stlLivelyMouthFactor")) { changed = true; SetSetting_p67("stlLivelyMouthFactor", 1f); }

            if (!settings_p67.ContainsKey("stlLivelyBrowsOn")) { changed = true; SetSetting_p67("stlLivelyBrowsOn", true); }
            if (!settings_p67.ContainsKey("stlLivelyBrowsChance")) { changed = true; SetSetting_p67("stlLivelyBrowsChance", 1f); }
            if (!settings_p67.ContainsKey("stlLivelyBrowsFactor")) { changed = true; SetSetting_p67("stlLivelyBrowsFactor", 1f); }

            if (!settings_p67.ContainsKey("staMacrosaccadesRate")) { changed = true; SetSetting_p67("staMacrosaccadesRate", 35f); }
            if (!settings_p67.ContainsKey("staSaccadesRate")) { changed = true; SetSetting_p67("staSaccadesRate", 75f); }



            /* Settings vision */
            if (!settings_p67.ContainsKey("staEnableGaze")) { changed = true; SetSetting_p67("staEnableGaze", true); }
            if (!settings_p67.ContainsKey("staEnableGazeBody")) { changed = true; SetSetting_p67("staEnableGazeBody", true); }
            if (!settings_p67.ContainsKey("staEnableGazeBodyLower")) { changed = true; SetSetting_p67("staEnableGazeBodyLower", false); }
            if (!settings_p67.ContainsKey("staEnableGazeHands")) { changed = true; SetSetting_p67("staEnableGazeHands", false); }
            if (!settings_p67.ContainsKey("staBodyBending")) { changed = true; SetSetting_p67("staBodyBending", 1f); }
            //if (!settings_p67.ContainsKey("staEnableAutoDropHands")) { changed = true; SetSetting_p67("staEnableAutoDropHands", false); }
            if (!settings_p67.ContainsKey("staEnableSexAutoAlign")) { changed = true; SetSetting_p67("staEnableSexAutoAlign", true); }

            /* Settings General */
            if (!settings_p67.ContainsKey("sttlanguage")) { changed = true; SetSetting_p67("sttlanguage", "en"); }
            if (!settings_p67.ContainsKey("sttvambackgroundcolor")) { changed = true; SetSetting_p67("sttvambackgroundcolor", "#000000"); }
            if (!settings_p67.ContainsKey("sttvamfov")) { changed = true; SetSetting_p67("sttvamfov", 40); }
            if (!settings_p67.ContainsKey("sttvamworldscale")) { changed = true; SetSetting_p67("sttvamworldscale", 50000); }
            if (!settings_p67.ContainsKey("sttPlayerName")) { changed = true; SetSetting_p67("sttPlayerName", "Player"); }
            if (!settings_p67.ContainsKey("sttAIName")) { changed = true; SetSetting_p67("sttAIName", "Vam"); }
            if (!settings_p67.ContainsKey("sttFirstPersonVR")) { changed = true; SetSetting_p67("sttFirstPersonVR", false); }
            if (!settings_p67.ContainsKey("sttFirstPersonVRangle")) { changed = true; SetSetting_p67("sttFirstPersonVRangle", 30f); }
            if (!settings_p67.ContainsKey("sttFirstPersonVRheight")) { changed = true; SetSetting_p67("sttFirstPersonVRheight", 0.5f); }
            if (!settings_p67.ContainsKey("sttFirstPersonVRspeed")) { changed = true; SetSetting_p67("sttFirstPersonVRspeed", 1f); }
            if (!settings_p67.ContainsKey("sttVRPointers")) { changed = true; SetSetting_p67("sttVRPointers", false); }
            if (!settings_p67.ContainsKey("sttVRMicrophoneKey")) { changed = true; SetSetting_p67("sttVRMicrophoneKey", 0.18f); }
            if (!settings_p67.ContainsKey("sttVRMicrophone")) { changed = true; SetSetting_p67("sttVRMicrophone", true); }

            if (!settings_p67.ContainsKey("sttHapticForcefield")) { changed = true; SetSetting_p67("sttHapticForcefield", true); }
            if (!settings_p67.ContainsKey("sttHapticStrength")) { changed = true; SetSetting_p67("sttHapticStrength", 1); }
            if (!settings_p67.ContainsKey("sttHapticOccurance")) { changed = true; SetSetting_p67("sttHapticOccurance", 0.5f); }
            if (!settings_p67.ContainsKey("sttvamcameraflash")) { changed = true; SetSetting_p67("sttvamcameraflash", true); }
            if (!settings_p67.ContainsKey("sttvamhideloadingicon")) { changed = true; SetSetting_p67("sttvamhideloadingicon", true); }
            if (!settings_p67.ContainsKey("sttVamPersonalSpace")) { changed = true; SetSetting_p67("sttVamPersonalSpace", true); }

            /* Settings UI */
            if (!settings_p67.ContainsKey("stUiDesktop")) { changed = true; SetSetting_p67("stUiDesktop", "Sidebar"); }
            if (!settings_p67.ContainsKey("stUiHand")) { changed = true; SetSetting_p67("stUiHand", "Right"); }
            if (!settings_p67.ContainsKey("stUiOffsetX")) { changed = true; SetSetting_p67("stUiOffsetX", "0.026"); }
            if (!settings_p67.ContainsKey("stUiOffsetY")) { changed = true; SetSetting_p67("stUiOffsetY", "0.0001"); }
            if (!settings_p67.ContainsKey("stUiOffsetZ")) { changed = true; SetSetting_p67("stUiOffsetZ", "-0.1688"); }
            if (!settings_p67.ContainsKey("stUiOffsetRotX")) { changed = true; SetSetting_p67("stUiOffsetRotX", "268.8463"); }
            if (!settings_p67.ContainsKey("stUiOffsetRotY")) { changed = true; SetSetting_p67("stUiOffsetRotY", "272.3443"); }
            if (!settings_p67.ContainsKey("stUiOffsetRotZ")) { changed = true; SetSetting_p67("stUiOffsetRotZ", "0"); }

            /* Settings Services*/

            if (!settings_p67.ContainsKey("sttServicesTextAI")) { changed = true; SetSetting_p67("sttServicesTextAI", false); }
            if (!settings_p67.ContainsKey("sttServicesLocalSpeechtotext")) { changed = true; SetSetting_p67("sttServicesLocalSpeechtotext", false); }
            if (!settings_p67.ContainsKey("sttServicesLocalTTS")) { changed = true; SetSetting_p67("sttServicesLocalTTS", false); }
            if (!settings_p67.ContainsKey("sttServicesLocalVoice")) { changed = true; SetSetting_p67("sttServicesLocalVoice", ""); }
            if (!settings_p67.ContainsKey("sttServicesOogaBoogaApiUrlNew")) { changed = true; SetSetting_p67("sttServicesOogaBoogaApiUrlNew", "http:/"+"/127.0.0.1:5000/"); }
            if (!settings_p67.ContainsKey("sttServicesOogaBoogaLegacy")) { changed = true; SetSetting_p67("sttServicesOogaBoogaLegacy", false); }
            if (!settings_p67.ContainsKey("sttServicesElevenlabsTTS")) { changed = true; SetSetting_p67("sttServicesElevenlabsTTS", false); }
            if (!settings_p67.ContainsKey("sttServicesElevenlabsKey")) { changed = true; SetSetting_p67("sttServicesElevenlabsKey", ""); }
            if (!settings_p67.ContainsKey("sttServicesElevenlabsVoice")) { changed = true; SetSetting_p67("sttServicesElevenlabsVoice", ""); }
            if (!settings_p67.ContainsKey("sttServicesElevenlabsModel")) { changed = true; SetSetting_p67("sttServicesElevenlabsModel", ""); }
            if (!settings_p67.ContainsKey("sttServicesAutomatic1111")) { changed = true; SetSetting_p67("sttServicesAutomatic1111", false); }
            if (!settings_p67.ContainsKey("sttServicesElevenlabsStability")) { changed = true; SetSetting_p67("sttServicesElevenlabsStability", 0.5f); }
            if (!settings_p67.ContainsKey("sttServicesElevenlabsSimilarity")) { changed = true; SetSetting_p67("sttServicesElevenlabsSimilarity", 0.5f); }
            if (!settings_p67.ContainsKey("sttServicesElevenlabsStyle")) { changed = true; SetSetting_p67("sttServicesElevenlabsStyle", 0f); }



            if (!settings_p67.ContainsKey("sttServiceImageaiChat")) { changed = true; SetSetting_p67("sttServiceImageaiChat", false); }
            if (!settings_p67.ContainsKey("sttServiceImageaiVision")) { changed = true; SetSetting_p67("sttServiceImageaiVision", false); }
            if (!settings_p67.ContainsKey("sttServiceImageaiVisionType")) { changed = true; SetSetting_p67("sttServiceImageaiVisionType", "clip"); }


            /* Settings Other*/
            if (!settings_p67.ContainsKey("lightsPreset")) { changed = true; SetSetting_p67("lightsPreset", "None"); }
            if (!settings_p67.ContainsKey("headlightsEnabled")) { changed = true; SetSetting_p67("headlightsEnabled", true); }


            /* Settings Alive */
            if (!settings_p67.ContainsKey("staEnableAutoAlive")) { changed = true; SetSetting_p67("staEnableAutoAlive", true); }
            if (!settings_p67.ContainsKey("staAliveMalesExpressionsOnly")) { changed = true; SetSetting_p67("staAliveMalesExpressionsOnly", true); }
            if (!settings_p67.ContainsKey("staAliveFemalesExpressionsOnly")) { changed = true; SetSetting_p67("staAliveFemalesExpressionsOnly", false); }
            if (!settings_p67.ContainsKey("staAliveFutaExpressionsOnly")) { changed = true; SetSetting_p67("staAliveFutaExpressionsOnly", true); }

            if (!settings_p67.ContainsKey("staEnableKissing")) { changed = true; SetSetting_p67("staEnableKissing", true); }
            if (!settings_p67.ContainsKey("staEnableTongueKissing")) { changed = true; SetSetting_p67("staEnableTongueKissing", false); }
            if (!settings_p67.ContainsKey("staEnableKissingDistance")) { changed = true; SetSetting_p67("staEnableKissingDistance", 0.25f); }
            //if (!settings_p67.ContainsKey("staEnableShakeControllers")) { changed = true; SetSetting_p67("staEnableShakeControllers", true); }
            //if (!settings_p67.ContainsKey("staShakeTreshold")) { changed = true; SetSetting_p67("staShakeTreshold", 5); }

            if (!settings_p67.ContainsKey("staSmartHands")) { changed = true; SetSetting_p67("staSmartHands", true); }
            //if (!settings_p67.ContainsKey("staFingerMovement")) { changed = true; SetSetting_p67("staFingerMovement", true); }
            if (!settings_p67.ContainsKey("staToesMovement")) { changed = true; SetSetting_p67("staToesMovement", true); }
            //if (!settings_p67.ContainsKey("staKeepFeetAboveFloor")) { changed = true; SetSetting_p67("staKeepFeetAboveFloor", false); }
            //if (!settings_p67.ContainsKey("staEnableTeleport")) { changed = true; SetSetting_p67("staEnableTeleport", true); }
            if (!settings_p67.ContainsKey("staEnableAutoTongue")) { changed = true; SetSetting_p67("staEnableAutoTongue", true); }
            if (!settings_p67.ContainsKey("staEnableMaleArouse")) { changed = true; SetSetting_p67("staEnableMaleArouse", true); }
            if (!settings_p67.ContainsKey("staEnableSweat")) { changed = true; SetSetting_p67("staEnableSweat", true); }
            if (!settings_p67.ContainsKey("staEnableNippleErection")) { changed = true; SetSetting_p67("staEnableNippleErection", true); }
            if (!settings_p67.ContainsKey("staEnableEyeReflection")) { changed = true; SetSetting_p67("staEnableEyeReflection", true); }
            //if (!settings_p67.ContainsKey("staEnableNotifications")) { changed = true; SetSetting_p67("staEnableNotifications", false); }
            //if (!settings_p67.ContainsKey("staEnableDialogue")) { changed = true; SetSetting_p67("staEnableDialogue", true); }
            if (!settings_p67.ContainsKey("staEnableVoiceFeedback")) { changed = true; SetSetting_p67("staEnableVoiceFeedback", true); }
            //if (!settings_p67.ContainsKey("staEnableExpressionFeedback")) { changed = true; SetSetting_p67("staEnableExpressionFeedback", true); }
            if (!settings_p67.ContainsKey("staEnableLegsSpreadMorph")) { changed = true; SetSetting_p67("staEnableLegsSpreadMorph", true); }
            if (!settings_p67.ContainsKey("staEnableVagArousal")) { changed = true; SetSetting_p67("staEnableVagArousal", true); }
            if (!settings_p67.ContainsKey("staEnableAutobj")) { changed = true; SetSetting_p67("staEnableAutobj", true); }
            if (!settings_p67.ContainsKey("staEnableAutohj")) { changed = true; SetSetting_p67("staEnableAutohj", true); }
            if (!settings_p67.ContainsKey("staEnableAutotj")) { changed = true; SetSetting_p67("staEnableAutotj", true); }
            if (!settings_p67.ContainsKey("staAutobjSpeed")) { changed = true; SetSetting_p67("staAutobjSpeed", 1f); }
            if (!settings_p67.ContainsKey("staAutobjForce")) { changed = true; SetSetting_p67("staAutobjForce", 1f); }
            if (!settings_p67.ContainsKey("staEnableAutoride")) { changed = true; SetSetting_p67("staEnableAutoride", true); }
            if (!settings_p67.ContainsKey("staAutorideSpeed")) { changed = true; SetSetting_p67("staAutorideSpeed", 1f); }
            if (!settings_p67.ContainsKey("staAutorideForce")) { changed = true; SetSetting_p67("staAutorideForce", 1f); }

            if (!settings_p67.ContainsKey("staArouseFactor")) { changed = true; SetSetting_p67("staArouseFactor", 1f); }
            if (!settings_p67.ContainsKey("staDiscomfortFactor")) { changed = true; SetSetting_p67("staDiscomfortFactor", 1f); }


            if (!settings_p67.ContainsKey("animMaxDistance")) { changed = true; SetSetting_p67("animMaxDistance", 10f); }
            if (!settings_p67.ContainsKey("animMaxDistanceJoints")) { changed = true; SetSetting_p67("animMaxDistanceJoints", 0.75f); }
            if (!settings_p67.ContainsKey("animMaxDistanceRotation")) { changed = true; SetSetting_p67("animMaxDistanceRotation", 20f); }
            if (!settings_p67.ContainsKey("animSpeed")) { changed = true; SetSetting_p67("animSpeed", 1f); }
            if (!settings_p67.ContainsKey("animLoop")) { changed = true; SetSetting_p67("animLoop", false); }
            if (!settings_p67.ContainsKey("animHeadAngleOffset")) { changed = true; SetSetting_p67("animHeadAngleOffset", 17f); }
            if (!settings_p67.ContainsKey("animSmooth")) { changed = true; SetSetting_p67("animSmooth", true); }
            if (!settings_p67.ContainsKey("animSmoothLevel")) { changed = true; SetSetting_p67("animSmoothLevel", 15f); }


            //if (!settings_p67.ContainsKey("staJittersEnable")) { changed = true; SetSetting_p67("staJittersEnable", true); }
            //if (!settings_p67.ContainsKey("staJittersStrength")) { changed = true; SetSetting_p67("staJittersStrength", 1f); }

            if (!settings_p67.ContainsKey("staEnableIdleBodyMovement")) { changed = true; SetSetting_p67("staEnableIdleBodyMovement", true); }
            if (!settings_p67.ContainsKey("staEnableIdleBodyMovement2")) { changed = true; SetSetting_p67("staEnableIdleBodyMovement2", true); }
            if (!settings_p67.ContainsKey("staIdleBodyMovementForce")) { changed = true; SetSetting_p67("staIdleBodyMovementForce", 1f); }
            if (!settings_p67.ContainsKey("staIdleBodyMovement2Force")) { changed = true; SetSetting_p67("staIdleBodyMovement2Force", 1f); }
            if (!settings_p67.ContainsKey("staEnableBreathingChest")) { changed = true; SetSetting_p67("staEnableBreathingChest", true); }
            if (!settings_p67.ContainsKey("staBreathingChestInhale")) { changed = true; SetSetting_p67("staBreathingChestInhale", 3f); }
            if (!settings_p67.ContainsKey("staBreathingChestExhale")) { changed = true; SetSetting_p67("staBreathingChestExhale", 6f); }
            if (!settings_p67.ContainsKey("staTouchTresholdTease")) { changed = true; SetSetting_p67("staTouchTresholdTease", 0.05f); }
            if (!settings_p67.ContainsKey("staTouchTresholdCaress")) { changed = true; SetSetting_p67("staTouchTresholdCaress", 0.20f); }
            if (!settings_p67.ContainsKey("staTouchTresholdSpank")) { changed = true; SetSetting_p67("staTouchTresholdSpank", 0.45f); }
            if (!settings_p67.ContainsKey("staEnableTouchReactions")) { changed = true; SetSetting_p67("staEnableTouchReactions", true); }

            if (!settings_p67.ContainsKey("staAutoposeHead")) { changed = true; SetSetting_p67("staAutoposeHead", true); }
            if (!settings_p67.ContainsKey("staAutoposeChest")) { changed = true; SetSetting_p67("staAutoposeChest", true); }
            if (!settings_p67.ContainsKey("staAutoposeHands")) { changed = true; SetSetting_p67("staAutoposeHands", true); }
            if (!settings_p67.ContainsKey("staAutoposeHip")) { changed = true; SetSetting_p67("staAutoposeHip", false); }
            if (!settings_p67.ContainsKey("staAutoposeLegs")) { changed = true; SetSetting_p67("staAutoposeLegs", false); }
            if (!settings_p67.ContainsKey("staAutoposeHeadChance")) { changed = true; SetSetting_p67("staAutoposeHeadChance", 75f); }
            if (!settings_p67.ContainsKey("staAutoposeChestChance")) { changed = true; SetSetting_p67("staAutoposeChestChance", 75f); }
            if (!settings_p67.ContainsKey("staAutoposeHandsChance")) { changed = true; SetSetting_p67("staAutoposeHandsChance", 75f); }
            if (!settings_p67.ContainsKey("staAutoposeHipChance")) { changed = true; SetSetting_p67("staAutoposeHipChance", 75f); }
            if (!settings_p67.ContainsKey("staAutoposeLegsChance")) { changed = true; SetSetting_p67("staAutoposeLegsChance", 75f); }
            if (!settings_p67.ContainsKey("staAutoposeDuration")) { changed = true; SetSetting_p67("staAutoposeDuration", 4f); }
            if (!settings_p67.ContainsKey("staAutoposeDurationMax")) { changed = true; SetSetting_p67("staAutoposeDurationMax", 7f); }

            if (!settings_p67.ContainsKey("staAutoposeSpeedMin")) { changed = true; SetSetting_p67("staAutoposeSpeedMin", 1f); }
            if (!settings_p67.ContainsKey("staAutoposeSpeedMax")) { changed = true; SetSetting_p67("staAutoposeSpeedMax", 2f); }


            if (!settings_p67.ContainsKey("aiKnowCustom")) { changed = true; SetSetting_p67("aiKnowCustom", ""); }
            if (!settings_p67.ContainsKey("aiKnowChat")) { changed = true; SetSetting_p67("aiKnowChat", true); }
            if (!settings_p67.ContainsKey("aiKnowTime")) { changed = true; SetSetting_p67("aiKnowTime", true); }
            if (!settings_p67.ContainsKey("aiKnowClothing")) { changed = true; SetSetting_p67("aiKnowClothing", true); }
            if (!settings_p67.ContainsKey("aiKnowKinky")) { changed = true; SetSetting_p67("aiKnowKinky", true); }
            if (!settings_p67.ContainsKey("aiKnowPlayer")) { changed = true; SetSetting_p67("aiKnowPlayer", true); }
            if (!settings_p67.ContainsKey("aiKnowCharacter")) { changed = true; SetSetting_p67("aiKnowCharacter", true); }
            if (!settings_p67.ContainsKey("aiKnowCharacterClothing")) { changed = true; SetSetting_p67("aiKnowCharacterClothing", true); }


            if (!settings_p67.ContainsKey("stcMessagesCleanup")) { changed = true; SetSetting_p67("stcMessagesCleanup", true); }
            if (!settings_p67.ContainsKey("stcMessagesAiLimit")) { changed = true; SetSetting_p67("stcMessagesAiLimit", 250f); }
            if (!settings_p67.ContainsKey("stcMessagesAiShortFerquency")) { changed = true; SetSetting_p67("stcMessagesAiShortFerquency", 5f); }
            if (!settings_p67.ContainsKey("stcMessagesContinueFrequency")) { changed = true; SetSetting_p67("stcMessagesContinueFrequency", 10f); }
            if (!settings_p67.ContainsKey("stcMessagesContinueShortFrequency")) { changed = true; SetSetting_p67("stcMessagesContinueShortFrequency", 25f); }
            if (!settings_p67.ContainsKey("stcAiTemperature")) { changed = true; SetSetting_p67("stcAiTemperature", 0.7f); }
            if (!settings_p67.ContainsKey("stcEnableDynamicTemperature")) { changed = true; SetSetting_p67("stcEnableDynamicTemperature", true); }
            if (!settings_p67.ContainsKey("stcAiTemperatureMax")) { changed = true; SetSetting_p67("stcAiTemperatureMin", 0.65f); }
            if (!settings_p67.ContainsKey("stcAiTemperatureMax")) { changed = true; SetSetting_p67("stcAiTemperatureMax", 0.75f); }
            if (!settings_p67.ContainsKey("stcEnableSpeechBubble")) { changed = true; SetSetting_p67("stcEnableSpeechBubble", false); }
            if (!settings_p67.ContainsKey("stcAiTouchPercentage")) { changed = true; SetSetting_p67("stcAiTouchPercentage", 15); }
            if (!settings_p67.ContainsKey("stcAiContextSize")) { changed = true; SetSetting_p67("stcAiContextSize", 0.7f); }

            if (!settings_p67.ContainsKey("stcAirepetition_penalty")) { changed = true; SetSetting_p67("stcAirepetition_penalty", 1.15f); }
            if (!settings_p67.ContainsKey("stcAitop_k")) { changed = true; SetSetting_p67("stcAitop_k", 20f); }
            if (!settings_p67.ContainsKey("stcAimin_length")) { changed = true; SetSetting_p67("stcAimin_length", 10f); }
            if (!settings_p67.ContainsKey("stcAilength_penalty")) { changed = true; SetSetting_p67("stcAilength_penalty", 1.05f); }
            if (!settings_p67.ContainsKey("stcAitop_p")) { changed = true; SetSetting_p67("stcAitop_p", 0.9f); }
            if (!settings_p67.ContainsKey("stcAiguidance_scale")) { changed = true; SetSetting_p67("stcAiguidance_scale", 1f); }
            if (!settings_p67.ContainsKey("stcAitruncation_length")) { changed = true; SetSetting_p67("stcAitruncation_length", 2048f); }



            if (!settings_p67.ContainsKey("gMinigolfLefthand")) { changed = true; SetSetting_p67("gMinigolfLefthand", false); }
            if (!settings_p67.ContainsKey("gMinigolfClubDistance")) { changed = true; SetSetting_p67("gMinigolfClubDistance", 1f); }
            if (!settings_p67.ContainsKey("gMinigolfClubRotation")) { changed = true; SetSetting_p67("gMinigolfClubRotation", 90f); }

            /* gameplay mechanics */
            if (!settings_p67.ContainsKey("xMoney")) { changed = true; SetSetting_p67("xMoney", 20000f); }
            if (!settings_p67.ContainsKey("xDebt")) { changed = true; SetSetting_p67("xDebt", 0f); }




            /* vamdiffusion */
            if (!settings_p67.ContainsKey("diffA111Url")) { changed = true; SetSetting_p67("diffA111Url", "http:/"+"/127.0.0.1:7860"); }
            if (!settings_p67.ContainsKey("diffPrompt")) { changed = true; SetSetting_p67("diffPrompt", "photo of beautiful woman, photorealistic, highly detailed"); }
            if (!settings_p67.ContainsKey("diffNprompt")) { changed = true; SetSetting_p67("diffNprompt", "blurry, drawing"); }
            if (!settings_p67.ContainsKey("diffSize")) { changed = true; SetSetting_p67("diffSize", 720); }
            if (!settings_p67.ContainsKey("diffSizeX")) { changed = true; SetSetting_p67("diffSizeX", 512); }
            if (!settings_p67.ContainsKey("diffSizeY")) { changed = true; SetSetting_p67("diffSizeY", 512); }
            if (!settings_p67.ContainsKey("diffCfg")) { changed = true; SetSetting_p67("diffCfg", 7); }
            if (!settings_p67.ContainsKey("diffDenoise")) { changed = true; SetSetting_p67("diffDenoise", 0.4f); }
            if (!settings_p67.ContainsKey("diffFaces")) { changed = true; SetSetting_p67("diffFaces", false); }
            if (!settings_p67.ContainsKey("diffSteps")) { changed = true; SetSetting_p67("diffSteps", 17); }
            if (!settings_p67.ContainsKey("diffSampler")) { changed = true; SetSetting_p67("diffSampler", "Euler a"); }
            if (!settings_p67.ContainsKey("diffSeed")) { changed = true; SetSetting_p67("diffSeed", 0); }
            if (!settings_p67.ContainsKey("diffImagetype")) { changed = true; SetSetting_p67("diffImagetype", "9:16"); }
            if (!settings_p67.ContainsKey("diffPreviewfps")) { changed = true; SetSetting_p67("diffPreviewfps", 5f); }
            if (!settings_p67.ContainsKey("diffSaveVam")) { changed = true; SetSetting_p67("diffSaveVam", true); }

            if (!settings_p67.ContainsKey("diffMode")) { changed = true; SetSetting_p67("diffMode", "vam"); }
            if (!settings_p67.ContainsKey("diffControlnetWeight")) { changed = true; SetSetting_p67("diffControlnetWeight", 1f); }
            if (!settings_p67.ContainsKey("diffControlnetPreprocessorUpdated")) { changed = true; SetSetting_p67("diffControlnetPreprocessorUpdated", "canny"); }
            if (!settings_p67.ContainsKey("diffControlnetModelUpdated")) { changed = true; SetSetting_p67("diffControlnetModelUpdated", "control_v11p_sd15_canny [d14c016b]"); }
            if (!settings_p67.ContainsKey("diffControlnetLowvram")) { changed = true; SetSetting_p67("diffControlnetLowvram", true); }
            if (!settings_p67.ContainsKey("diffControlMode")) { changed = true; SetSetting_p67("diffControlMode", "Balanced"); }

            if (!settings_p67.ContainsKey("diffControlnetLowTreshold")) { changed = true; SetSetting_p67("diffControlnetLowTreshold", 64); }
            if (!settings_p67.ContainsKey("diffControlnetHighTreshold")) { changed = true; SetSetting_p67("diffControlnetHighTreshold", 64); }
            if (!settings_p67.ContainsKey("diffControlnetResolution")) { changed = true; SetSetting_p67("diffControlnetResolution", 512); }


            if (!settings_p67.ContainsKey("shakycamForce")) { changed = true; SetSetting_p67("shakycamForce", 1f); }
            if (!settings_p67.ContainsKey("shakyCamEnable")) { changed = true; SetSetting_p67("shakyCamEnable", false); }


            //EPHEMERAL SETTINGS
            //SetSetting_p67("eph_shakycam", false);




            // Alive home
            if (!settings_p67.ContainsKey("ahIntTrafficCars")) { changed = true; SetSetting_p67("ahIntTrafficCars", 5); }


            if (changed) SaveSettings_p67();
        }
        public bool SettingExists_p67(string k)
        {
            return settings_p67.ContainsKey(k);
        }
        public string GetSettingString_p67(string k)
        {
            if (!SettingExists_p67(k)) return null;
            return settings_p67[k];
        }

        public float GetSettingFloat_p67(string k)
        {
            if (!SettingExists_p67(k)) return 0f;
            try
            {
                var val = float.Parse(settings_p67[k]);
                return val;
            }
            catch (Exception e) { if (e.ToString().Length > 0) { } 
            }
            return 0f;
        }

        public int GetSettingInt_p67(string k)
        {
            if (!SettingExists_p67(k)) return 0;
            try
            {
                var val = SPQRUtils.ToInt_p67(settings_p67[k]);
                return val;
            }
            catch (Exception e)
            {
                if (e.ToString().Length > 0) { }
            }
            return 0;
        }

        public bool GetSettingBool_p67(string k)
        {
            if (!SettingExists_p67(k)) return false;
            return settings_p67[k] == "true" || settings_p67[k] == "True";
        }
        public void ClearAllSettings_p67(){settings_p67 = new Dictionary<string, string>() { };}
        public void SetSetting_p67(string k, float v){SetSetting_p67(k, v.ToString());}
        public void SetSetting_p67(string k, int v) { SetSetting_p67(k, v.ToString()); }
        public void SetSetting_p67(string k, bool v) { SetSetting_p67(k, (v ? "true" : "false")); }
        public void SetSetting_p67(string k, string v)
        {
            if (settings_p67.ContainsKey(k)) settings_p67[k] = v;
            else settings_p67.Add(k, v);
        }

        public void LoadSetings_p67()
        {
            Application.targetFrameRate = GetSettingInt_p67("sttDisplayFPSLimit");
            if(GetSettingBool_p67("sttOptimizePhysicsRate")) Time.fixedDeltaTime = 1 / 30f;
            else Time.fixedDeltaTime = 1 / 72f;
            Application.runInBackground = true;
            Application.runInBackground = GetSettingBool_p67("sttRunInBackground");
            AudioListener.volume = GetSettingFloat_p67("sttSoundVolume");

            LoadSetingsAnistropicFiltering_p67();
            SetSetting_p67("vfxFrameByFrame", false);
            //LoadSettinsgsVfxTime_p67();
            //LoadSettinsgsVfxWorldscale_p67();

        }

        //void LoadSettinsgsVfxTime_p67()
        //{
        //    var t = GetSettingFloat_p67("vfxTime");
        //    t = Mathf.Clamp(t, 0.001f, 2f);
        //    Time.timeScale = t;
        //}
        //void LoadSettinsgsVfxWorldscale_p67()
        //{
        //    var t = GetSettingFloat_p67("vfxWorldscale");
        //    t = Mathf.Clamp(t, 0.001f, 100f);
        //    SuperController.singleton.worldScale = t;
        //}

        void LoadSetingsAnistropicFiltering_p67()
        {
            if (GetSettingBool_p67("sttAnisotropicFiltering"))
            {
                UnityEngine.QualitySettings.anisotropicFiltering = AnisotropicFiltering.ForceEnable;
            }
            else
            {
                UnityEngine.QualitySettings.anisotropicFiltering = AnisotropicFiltering.Disable;
            }
        }
    }
}