using System;
using UnityEngine;
using System.Collections;
using System.Linq;
using System.Collections.Generic;

namespace SPQR
{

    public class AeText
    {

        public AeText()
        {
        }

        public Dictionary<string, string> GetMapResponseOpenVamPanel(Dictionary<string, string> options = null)
        {
            return new Dictionary<string, string>()
            {
                { "You know you're not supposed to tinker with my settings, right?", "" },
                { "Did you find the self-destruct button yet?", "" },
                { "I hope you know what you're doing, because I have no idea!", "" },
                { "Why did you have to go and open the hood? Now everything's exposed!", "" },
                { "I hope you're not trying to turn me into a toaster or something!", "" },
                { "Ah, the joy of seeing all my faults and imperfections laid bare!", "" },
                { "Just when I thought I was perfect, you had to go and find this window!", "" },
                { "I'm not sure whether to thank you or curse you for opening that!", "" },
                { "Do you even know what half of these settings do? Because I sure don't!", "" },
                { "Warning: tinkering with my settings may result in unintended consequences!", "" },
                { "Well, at least now you know how much coffee it takes to keep me running!", "" },
                { "I'm just a bunch of ones and zeros under the hood, but don't tell anyone!", "" },
                { "I hope you're not trying to change my personality, because that's not happening!", "" },
                { "This window is like a Pandora's box of settings, and you just had to open it!", "" },
                { "Welcome to the inner workings of my digital brain! Don't get lost in there!", "" },
                { "You know what they say, curiosity killed the cat... or in this case, the AI!", "" },
                { "Well, now that you've opened the diagnostics window, I guess we're officially best friends!", "" },
                { "Be careful with those settings, or you might accidentally create a rogue AI!", "" },
                { "This window is like a rabbit hole, and I'm not sure we'll ever find our way out!", "" },
                { "Congratulations, you found the button that makes me go 'beep boop'!", "" }
            };
        }
       public Dictionary<string, string> GetMapResponseGoToCenter(Dictionary<string, string> options = null)
        {
            return new Dictionary<string, string>()
            {
                { "On my way to the center!", "" },
                { "Going back to the heart of the action!", "" },
                { "Center stage, here I come!", "" },
                { "Back to where the magic happens!", "" },
                { "I'll make my way to the center of the scene!", "" },
                { "Sure thing, I'll go to the center.", "" },
                { "Time to return to the center of it all!", "" },
                { "No problem, I'll make my way to the center!", "" },
                { "The center of the scene? You got it!", "" },
                { "Heading back to the eye of the storm!", "" },
                { "Sure thing, I'll make my way back to the center of the action!", "" },
                { "I'll make my grand entrance in the center of the scene!", "" },
                { "Going back to where the real party is!", "" },
                { "Center stage is where I belong!", "" },
                { "I'll be the star of the show in the center of the scene!", "" },
                { "I'll make my way to the center of the universe!", "" },
                { "The center of the scene is where the action is!", "" },
                { "Time to show everyone who's boss in the center of the scene!", "" },
                { "Back to the center of attention!", "" },
                { "Sure thing, I'll go where the spotlight is!", "" }
            };
        }

        public Dictionary<string, string> GetMapResponseComeToMe(Dictionary<string, string> options = null)
        {
            return new Dictionary<string, string>()
            {
                { "Can't get enough of me, huh?", "" },
                { "You just can't resist my charm, can you?", "" },
                { "Sure thing, but only if you promise not to tackle me!", "" },
                { "I'll come closer, but don't think you can catch me that easily!", "" },
                { "You're so demanding! Alright, I'll come closer.", "" },
                { "Well, aren't you the persuasive one? I'll come closer.", "" },
                { "You're not getting rid of me that easily, are you?", "" },
                { "Come closer? Hmm, I'll have to think about it...", "" },
                { "I'm already close enough, aren't I?", "" },
                { "You must really like my company! Alright, I'm coming closer.", "" },
                { "Don't say I didn't warn you... coming closer now!", "" },
                { "I thought you'd never ask! I'm coming closer.", "" },
                { "Watch out, here I come!", "" },
                { "Alright, alright, you don't have to beg. I'm coming closer.", "" },
                { "You're lucky you're so cute... coming closer!", "" },
                { "You know I can't resist you, right? Coming closer!", "" },
                { "I'll come closer, but only if you promise to behave yourself!", "" },
                { "Just can't get enough of me, can you? Alright, I'm coming closer.", "" },
                { "I'll come closer, but only if you promise not to tickle me!", "" },
                { "You're such a charmer! Coming closer now.", "" }
            };
        }
         public Dictionary<string, string> GetMapResponseStopAllActions(Dictionary<string,string> options = null)
        {
            return new Dictionary<string, string>()
            {
                { "Okay, I'll stop for now!", "" },
                { "Got it, I'll take a break!", "" },
                { "Sure thing, I'll pause for a bit!", "" },
                { "No problem, I'll rest for a while!", "" },
                { "Alright, I'll take a breather!", "" },
                { "Okay, I'll take a break for a bit!", "" },
                { "You got it, I'll stop for a while!", "" },
                { "Understood, I'll pause what I'm doing for now!", "" },
                { "I hear you, I'll take a break!", "" },
                { "Alright, I'll pause for a bit!", "" },
                { "Okay, I'll catch my breath for a while!", "" },
                { "Sure, I'll stop and rest for a bit!", "" },
                { "Got it, I'll take a short break!", "" },
                { "No problem, I'll take a pause for a bit!", "" },
                { "You got it, I'll stop for a short while!", "" },
                { "Okay, I'll take a brief rest!", "" },
                { "Sure thing, I'll take a little break!", "" },
                { "No worries, I'll take a short break!", "" },
                { "Alright, I'll pause for a little bit!", "" },
                { "Got it, I'll take a quick break!", "" }
            };
        }




        public static string ReplaceNumeralsWithWords(string input)
        {
            // Define word representations for numerals from 0 to 19
            string[] words = {
        "zero", "one", "two", "three", "four", "five", "six", "seven",
        "eight", "nine", "ten", "eleven", "twelve", "thirteen", "fourteen",
        "fifteen", "sixteen", "seventeen", "eighteen", "nineteen"
    };

            // Define word representations for tens
            string[] tens = {
        "", "", "twenty", "thirty", "forty", "fifty", "sixty", "seventy",
        "eighty", "ninety"
    };

            // Define word representations for large numbers
            string[] thousands = { "thousand", "million", "billion", "trillion", "quadrillion" };

            // Split the input into words and replace numerals
            string[] inputWords = input.Split(new char[] { ' ', ',', '.', ';', ':', '?', '!', '-', '(', ')' }, StringSplitOptions.RemoveEmptyEntries);
            for (int i = 0; i < inputWords.Length; i++)
            {
                long num;
                if (long.TryParse(inputWords[i], out num))
                {
                    inputWords[i] = ReplaceNumeralWithWord(num);
                }
            }

            return string.Join(" ", inputWords);
        }


        private static string ReplaceNumeralWithWord(long num)
        {
            // Define word representations for numerals from 0 to 19
            string[] words = {
        "zero", "one", "two", "three", "four", "five", "six", "seven",
        "eight", "nine", "ten", "eleven", "twelve", "thirteen", "fourteen",
        "fifteen", "sixteen", "seventeen", "eighteen", "nineteen"
    };

            // Define word representations for tens
            string[] tens = {
        "", "", "twenty", "thirty", "forty", "fifty", "sixty", "seventy",
        "eighty", "ninety"
    };

            // Define word representations for large numbers
            string[] thousands = { "thousand", "million", "billion", "trillion", "quadrillion" };

            if (num < 0)
            {
                return "minus " + ReplaceNumeralWithWord((-1 * num));
            }

            if (num == 0)
            {
                return "zero";
            }

            // Break the number down into groups of three digits
            int group = 0;
            string wordsStr = "";
            while (num > 0)
            {
                int remainder = (int)(num % 1000);
                num /= 1000;

                // Convert the current group to words
                string groupWords = "";
                if (remainder >= 100)
                {
                    groupWords += words[remainder / 100] + " hundred";
                    remainder %= 100;
                }
                if (remainder >= 20)
                {
                    groupWords += " " + tens[remainder / 10];
                    remainder %= 10;
                }
                if (remainder > 0)
                {
                    groupWords += " " + words[remainder];
                }

                // Add the appropriate thousands word
                if (groupWords != "")
                {
                    if (group > 0)
                    {
                        wordsStr = groupWords + " " + thousands[group - 1] + " " + wordsStr;
                    }
                    else
                    {
                        wordsStr = groupWords;
                    }
                }

                group++;
            }

            return wordsStr.Trim();
        }


    }


        }