/** 
 *  based on geesp0t, Doc0ctopuss spanking plugins; i believe original original credits goes to AcidBubbles
 * 
 */

using System;
using UnityEngine;
using SPQR;

namespace customevent
{
    public class EventTypeAlive
    {   // using enums crashes vam
        public const byte NONE = 0;
        public const byte ENTERED = 1;
        public const byte HIT = 2;
        public const byte EXITED = 3;
        public const byte STAY = 4;
    }

    public class TriggerEventArgsAlive : EventArgs
    {
        public Atom parentAtom = null;
        public string bodyPart = "";
        public Collision collision { get; set; }
        public Collider collider { get; set; }
        public Collider collider2 { get; set; }
        public byte evtType { get; set; }
        public bool insideTrigger { get; set; }
    }

    public class TriggerCollideAlive : MonoBehaviour
    {

        TriggerEventArgsAlive lastEvent;
        bool clear = true;
        bool inside = false;

        public static float minTimeBetweenCollisions = 0.25f;
        public static float minTimeBetweenEnters = 0.0001f;
        float lastCollisionTime = 0;
        float lastEnterTime = 0;

        float lastScriptCheck = 0f;
        float deltaScriptCheck = 5f;

        public event EventHandler<TriggerEventArgsAlive> OnCollideAlive;

  
        void Awake()
        {
            lastEvent = new TriggerEventArgsAlive
            {
                evtType = EventTypeAlive.NONE,
                collider = null,
                collision = null,
                insideTrigger = false,
                collider2 = null
            };
        }

        public void OnCollideAliveStop(bool stop){
            clear = stop;
         //   SuperController.LogMessage("Stopped!");
        }

        private void OnTriggerEnter(Collider other)
        {
            //if (clear) return;
            //other.isTrigger = false;
            inside = true;
            DoCollideEvent(EventTypeAlive.ENTERED, other, null);
        }

        private void OnTriggerExit(Collider other)
        {
            inside = false;
            lastEvent.evtType = EventTypeAlive.EXITED;
            DoCollideEvent(EventTypeAlive.EXITED, other, null);
        }

        protected virtual void OnCollideEvent(TriggerEventArgsAlive e)
        {
            //if (clear) return;
            //SuperController.LogMessage("sending event: " + e.collider.name + ", " + e.insideTrigger);
            EventHandler<TriggerEventArgsAlive> handler = OnCollideAlive;
            handler?.Invoke(this, e);
        }

        protected virtual void OnCollisionEnter(Collision collision)
        {
            DoCollideEvent(EventTypeAlive.HIT, collision.collider, collision);
        }

        protected virtual void OnCollisionExit(Collision collision)
        {
            lastEvent.evtType = EventTypeAlive.EXITED;
        }
        
        private void DoCollideEvent(byte evtType, Collider col, Collision c)
        {
            //SuperController.LogMessage("OnCollideEvent");
            //SuperController.LogMessage("sending event");
            //   if (scriptkey_p67 != GlobalVariables.Instance.mainScriptUid_p67) return;
            //   if (!GlobalVariables.Instance.mainScriptOn_p67) return;
            
            //if (clear) return;
            

            if (Time.timeSinceLevelLoad - lastScriptCheck > deltaScriptCheck)
            {
                lastScriptCheck = Time.timeSinceLevelLoad;
            //    var id = SPQRUtils.getAtomStorableString_p67("AliveGlobalData-"+suffix, "Text", "text");
            //    if (id.val != scriptkey)
            //    {
            //        Clear();
            //    }
                return;
            }


            bool allow = false;
            if (evtType == EventTypeAlive.HIT && Time.timeSinceLevelLoad - lastCollisionTime > minTimeBetweenCollisions) allow = true;
            if (evtType == EventTypeAlive.ENTERED && Time.timeSinceLevelLoad - lastEnterTime > minTimeBetweenEnters) allow = true;
            if (allow)
            {
                if (evtType == lastEvent.evtType || (evtType == EventTypeAlive.HIT && c == null))
                {
                    return;
                }
                else
                {


                    //if (SPQRUtils.checkChance_p67(5f))
                    //{
                    //    SuperController.LogMessage("collide " + scriptkey_p67 + " vs : " + col.name + "time: " + Time.timeSinceLevelLoad);
                    //}

                    if(evtType == EventTypeAlive.HIT)     lastCollisionTime = Time.timeSinceLevelLoad;
                    if(evtType == EventTypeAlive.ENTERED) lastEnterTime = Time.timeSinceLevelLoad;

                    Collider currentColl = GetComponent<Collider>();
                    if(currentColl == null) currentColl = GetComponentInChildren<Collider>();
                    if (currentColl == null) currentColl = gameObject.transform.parent.GetComponentInChildren<Collider>();
                    if (currentColl == null) return;

                 

                    TriggerEventArgsAlive tempEvent = new TriggerEventArgsAlive
                    {
                        evtType = evtType,
                        collider =currentColl,
                        collision = c,
                        insideTrigger = inside,
                        collider2 = col
                        
                    };
                    OnCollideEvent(tempEvent);
                    lastEvent = tempEvent;
                }
            }
        }

    }


}
