﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class SmartObjects : MVRScript {

		Dictionary<string, JSONStorableBool> bools_p67 = new Dictionary<string, JSONStorableBool>();
		Dictionary<string, JSONStorableString> strings_p67 = new Dictionary<string, JSONStorableString>();
		Dictionary<string, UIDynamicButton> buttons_p67 = new Dictionary<string, UIDynamicButton>();
		Dictionary<string, JSONStorableFloat> floats_p67 = new Dictionary<string, JSONStorableFloat>();
		Dictionary<string, JSONStorableString> titles = new Dictionary<string, JSONStorableString>();


		bool sceneLoaded = false;
		public override void Init() {

			InvokeRepeating("UpdateSecond", 1f, 1f);
			InvokeRepeating("UpdateConstant", 1f, 1f / 30f);
			InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);
			SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;

			InitUI_p67();
		}

	
		void Start() {
		
		}

	
		void Update() {
		
		}

	
		void FixedUpdate() {
		
		}
		void UpdateSecond()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant5()
		{
			if (IsDisabled()) return;

		}
		void OnDestroy()
		{
			CancelInvoke();
			SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
		}

		void OnSceneLoaded()
		{
			sceneLoaded = true;
		}
		bool IsDisabled()
        {
			if (!enabledJSON.val)
			{
				return true;
			}
			return false;
		}


		void AddToggle_p67(string s, bool val = false, bool right = false)
        {
			bools_p67.Add(s, new JSONStorableBool(s, val));
			CreateToggle(bools_p67[s], right);
		}
		void AddSlider_p67(string s, float val, float min, float max, bool right = false)
		{
			floats_p67.Add(s, new JSONStorableFloat(s,val, min, max, true));
			var slider = CreateSlider(floats_p67[s], right);
			slider.rangeAdjustEnabled = false;
			slider.defaultButtonEnabled = false;
			slider.quickButtonsEnabled = false;
		}

		void AddOption_p67(string s)
        {
			AddToggle_p67("Can "+s);
			AddSlider_p67("Priority "+s, 1f, 1f, 10f);
		}

		void InitUI_p67()
        {

			CreateTitle_p67("titlepluginname", "SmartObjects", 40, false);
			CreateTitle_p67("titlepluginname2", "", 40, true);

			AddOption_p67("watch");
			AddOption_p67("sit");
			AddOption_p67("stand");
			AddOption_p67("sleep");
			AddOption_p67("dance");


			AddToggle_p67("Is occupied", false, true);

			//AddToggle_p67("Can take",false,true);
			//AddSlider_p67("Weight" , 1f, 0.1f, 10f, true);



			if (strings_p67.Count > 0)
			{
				foreach (var s in strings_p67)
				{
					strings_p67[s.Key].storeType = JSONStorableParam.StoreType.Full;
					RegisterString(strings_p67[s.Key]);
				}
			}
			if (bools_p67.Count > 0)
			{
				foreach (var b in bools_p67)
				{
					bools_p67[b.Key].storeType = JSONStorableParam.StoreType.Full;
					RegisterBool(bools_p67[b.Key]);
				}
			}
			if (floats_p67.Count > 0)
			{
				foreach (var f in floats_p67)
				{
					floats_p67[f.Key].storeType = JSONStorableParam.StoreType.Full;
					RegisterFloat(floats_p67[f.Key]);
				}
			}

		}


		void CreateTitle_p67(string id, string text, int fontsize, bool right, int spacing)
		{
			CreateTitle_p67(id, text, fontsize, right);
			CreateSpacer_p67(this, spacing, right);
		}


		UIDynamic CreateSpacer_p67(MVRScript X, float height, bool rightSide)
		{
			UIDynamic spacer = X.CreateSpacer(rightSide);
			spacer.height = height;
			return spacer;
		}

		void CreateTitle_p67(string id, string text, int fontsize, bool right)
		{
			if (!titles.ContainsKey(id))
				titles.Add(id, new JSONStorableString("title " + id, "\n<size=" + fontsize + "><b>" + text + "</b></size>"));
			UIDynamicTextField title1text = CreateTextField(titles[id], right);
			title1text.UItext.supportRichText = true;
			title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
			title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
			title1text.height = 100f;
			title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
		}

	}
}