$ = jQuery;

$(document).ready(function(){
    $("body").on("mousedown",".aeurl",function(e){
        aeurl_click($(this));
        if($(this).hasClass("aelivebool")){
            var val = isSelectedCheck($(this));
            aelivebool_mutual($(this));
            aelivebool_set($(this), !val);
            setTimeout(function(){update_all_aealiveslider_values();}, 100);
            
        }
    });
    
    $("body").on("mousedown",".aequery",function(e){ 
        var context = $(this).attr('data-context');
        var query = $(this).attr('data-query');
        var event = {action:"query", context:context, query:query};
        if($(this).hasClass("toggle")){
            event.value =  $(this).is(":checked") ? "false" : "true";
        }
        if($(this).attr("data-query2") !== undefined){
            event.query2 = $(this).attr("data-query2");
        }
        
        
        $.each($(this)[0].attributes, function() {
        if(this.specified) {
            if(this.name.startsWith("data-query-")){
                var s = this.name.replace("data-query-","");
                event[s] = this.value;
            }
        }
    });
        
        
        
        aevent(event);
    });
    
//    $("body").on("change"," .language_select", function(){
//        var val = $(".language_select").val();
//        Language.setLanguage(val);
//    });
});

function aephemeral_key(event){

    return  event.context + "_"+event.query + (event.context2 ? "_"+event.context2 : "") ;
}

function aephemeral_callback(event){  
    var ctx = aephemeral_key(event);
    if(event.action === "query"){
        if(!event.callback) return;
        var fn = event.callback;
        if(!isVam()) window[fn](ctx, EPHEMERAL.queries[ctx]);
    }
    event.ctx = ctx;
    return event;
}

function aelivebool_mutual(o){
    var p = $(o).parents(".aelivebool-mutual");
    if(p.length < 1) return;
    p.find('.aelivebool').each(function(){
        aelivebool_set($(this), false);
    });
}

function aelivebool_set(o, val){
    EPHEMERAL.characters[character_get_selected()]['enabled'][$(o).attr("data-aelivebool")] = val;
}

$(window).on('hashchange', function() {
  var hash = location.hash.replace("#","");
  var hashdata = hash.split(":");
  if(hashdata[0]!=="v") return;
  if(hashdata[1]==="a"){
      var requid = hashdata[2];
      var partial = hashdata[3];
      apireq_response(requid,partial);
  }
  
});


function replaceAll(msg, search, replace) {
    var ite = 0;
    while(msg.indexOf(search) >= 0){
        msg = msg.replace(search, replace);
        if(ite++ > 100) break;
    }
    return msg;
}


function base64_url_encode($input) {
 return btoa(unescape(encodeURIComponent($input))).replace(/\ +/g,'.').replace(/\//g,'_').replace(/=/g,'-');
}

function base64_url_decode($input) {
 return atob($input.replace(/\./g,'+').replace(/_/g,'/').replace(/-/g,'='));
}


function get_fragment(){
    if (location.href.indexOf("#") != -1) {
        return location.href.substr(location.href.indexOf("#")).replace("#","");
    }
    return "";
}

function getRedGreenColor(percent) {
  // Calculate the value between 0 and 255 based on the input percentage
  var value = Math.round((percent / 100) * 255);

  // Generate the red component of the color
  var red = 0xff - value;

  // Generate the green component of the color
  var green = value;

  // Combine the red and green components into a hex color string
  var hex = '#' + ('0' + red.toString(16)).slice(-2) + ('0' + green.toString(16)).slice(-2) + '33';

  return hex;
}

function aemessage(msg){
     $.confirm({
        theme: 'material',
        columnClass: 'large',
        backgroundDismiss: true,
        title: '',
        draggable: false,
        content: msg,
        buttons: {
            ok: function () {
            },
        }
    });
}

function aerror(msg){
     $.confirm({
        theme: 'material',
        columnClass: 'large',
        backgroundDismiss: true,
        title: '',
        draggable: false,
        content: msg,
        buttons: {
            ok: function () {
            },
        }
    });
}

function aelocation(location, room){
    if(location === "homeroom"){
        var locations = page_homescreen_get_locations();
        if(typeof locations[room] === "undefined") return;
        aevent({action: "playerMove", position: locations[room].position, rotation: locations[room].rotation });
    }
}

function aevent(options){
    if(typeof options === "string"){
        options =  {action:options};
    }
    set_url_from_options(options);
}

function callback_get_people(){    
    var people =[Object.keys(EPHEMERAL.characters)];
    aevent({action:"activePeople", people: people});
}

function set_url_from_options(options){
    options.t = getTimestamp();
    if(typeof(options.person) === "undefined"){
        options.person = character_get_selected();
    }
    if(typeof(options.android) === "undefined"){
        options.android = android_get_selected();
    }
    
    var logged = JSON.parse(JSON.stringify(options));
    delete logged["t"];
    if(logged.action === "uiLoaded"){
        loading_add("event: ui");
    } else {
        loading_add("event: "+ JSON.stringify(logged));
    }
    
    if(DEBUGMODE){
        console.log("seturl", options);
    }
    
    ae_log_triggers(options);
    
    ae_direct_send_data(options);
//    var hash = get_js_hash(options);
//    location.hash = hash;
//    if(Mirror.isMirror()){
//        Mirror.sendMirrorUrl(hash);
//    }
}

function ae_log_triggers(options){
   Triggers.addEvent(options);
}

function ae_direct_send_data(data){
    if(typeof AeMainmenuCallback === "undefined"){
//        console.log("AeMainmenuCallback not registered");
        return;
    }
    AeMainmenuCallback("AeMainmenuCallback",JSON.stringify(data));
}

function get_js_hash(o){
    var s=  JSON.stringify(o);
    console.log("get_js_hash:",s);
    return "#j:"+base64_url_encode(s);
}

function aeurl_click(o){
    let options = {};
    $.each(o[0].attributes, function() {
        if(this.specified) {
            if(this.name.startsWith("data-aeurl-")){
                var s = this.name.replace("data-aeurl-","");
                options[s] = this.value;
            }
            if(this.name === "data-aecallback"){
//                console.log("callback:"+this.value);
                if(typeof(window[this.value]) === "function" ){
                    window[this.value](o);
                }
            }
        }
    });
    //console.log("aeurl_clickww", options);
    set_url_from_options(options);
}



function ae_generic_text_popup(msg){
    $.dialog({
            backgroundDismiss: true,
            title: '',
            columnClass: 'col-md-12',
            content: '<div class="generic_text_popup">'+msg+'</div>'
        });
}var UI_COLOR = "#9c23bb";
var VERSION = "v71";
var EPHEMERAL = {};
var DATA = {};
EPHEMERAL.vamdata = {};
EPHEMERAL.vamscene = {};
EPHEMERAL.aesettings = {};
EPHEMERAL.characters = {};
EPHEMERAL.queries = {};
EPHEMERAL.tempdata = {effects: {}, };

var RIVE = null;
var RIVEARTIFICIAL = null;
var RIVESCRIPTS = [];
var RIVESCRIPTSARTIFICIAL = [];

var USE_EPEHEMERAL = false;
var ISVR = false;
var ISHOME = false;
var TPL = {};
var META = {};
var ERR = false;
var TIMESTAMPS = {};
var DEBUGMODE = false;
var _PERSON_LIMIT = 4;
var INIT_PARAMS = {};
var LASTEXECUTIONTIME = {};
var settings_initialized= false;
var INIT_APP = "home";
//var INIT_APP = "vamdiffusion";



//  window.onerror = function(error, url, line) {
//        var msg = '<div class="alert alert-danger" role="alert">'+error+ ' @ ' +line+'</div>';
//    };


window.onerror = function (msg, url, lineNo, columnNo, error) {
    var m = msg + ' ' + url + ': ' + error + ' @ ' + lineNo + ' ' + columnNo;
    ERR = m;
    return false;
};

var eventMethod = window.addEventListener ? "addEventListener" : "attachEvent";
var eventer = window[eventMethod];
var messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";

// Listen to message from child window
eventer(messageEvent, function (e) {
    var key = e.message ? "message" : "data";
    var data = e[key];
//    console.log("post", data);
    if (typeof data === "object") {
        if (typeof data.vamdata !== "undefined") {
            fraemework_process_vamdata(data.vamdata);
        }
        if (typeof data.vamscene !== "undefined") {
            fraemework_process_vamscene(data.vamscene);
        }
        if (typeof data.aesettings !== "undefined") {
            fraemework_process_aesettings(data.aesettings);
        }
        if (typeof data.customeph !== "undefined") {
            fraemework_process_customeph(data.customeph);
        }
    }
}, false);


$(document).ready(function () {
    aeternum_start();
});



function aeternum_start() {
    page_fraemework_init_vrmode();
    page_fraemework_init_apps();
    loading_add("ALIVE " + VERSION + " started!");
    aeternum_check_uiload();
    if(!isVam()) {
        DEBUGMODE = true;
        $('body').addClass("debugmode");
    }

}

function aeternum_check_uiload() {
    init_document_load();
    setTimeout(aeternum_check_uiload, 1000);
}



function aeternum_ready() {
    page_fraemework_init();
    apps_init_clicks();
    page_cron_5seconds();
    page_cron_second();
    page_cron_halfsecond();
    page_cron_quartersecond();
    
    aeternum_send_language();
    
    //temp 
//    Language.setLanguage("zh");
}

function aeternum_send_language(){
    aevent({action:"receiveTranslations", language: Language.getMap()});
}
function throttled(name, throttle = 1000) {
    var now = Date.now();
    if (now - (LASTEXECUTIONTIME[name] || 0) >= throttle) {
        LASTEXECUTIONTIME[name] = now;
        return false;
    }
    return true;
}

function update_selected_person_name(){
    if(isEmpty(SELECTED_PERSON)) return;
    var p = new Person(SELECTED_PERSON);
    $('.selected-person-name').html(p.getString("personName"));
}

function page_scroll_disabled() {
    if (isSelectOpen())
        return true;
    return false;
}

function page_scroll_down(s) {
    //if(page_scroll_disabled()) return true;
    var val = parseFloat(s);
    $(".scrollbar1").each(function () {
        this.scrollBy(0, 20 * val)
    });
}
function page_scroll_up(s) {
    //if(page_scroll_disabled()) return true;
    var val = parseFloat(s);
    $(".scrollbar1").each(function () {
        this.scrollBy(0, -20 * val)
    });
}

function testzf(s) {
//    $("body").html("ok! "+s);
//    $("body").css({"font-size":"20px", "color":"#fff" });
    var ret = {};
    ret.callback = "AeCallbackTest";
    ret.data = s;
    return JSON.stringify(ret);
}

function testzf2(s) {
    $("body").html("ok! " + s);
    $("body").css({"font-size": "20px", "color": "#fff"});
}
function page_cron_5seconds() {
    cron_tooltips();
    setTimeout(page_cron_5seconds, 5000);
}

function init_tooltips() {

}

function cron_tooltips() {

    if($(".aetooltip:not(.aetooltip-initiated)").length < 1) return;
    $(".aetooltip:visible").each(function () {
        var tooltipTriggerEl = this;
        if ($(tooltipTriggerEl).hasClass('aetooltip-initiated'))
            return;
        if ($(tooltipTriggerEl).height() < 1)
            return;
        $(tooltipTriggerEl).addClass("aetooltip-initiated");
        
        var title = $(tooltipTriggerEl).attr('data-title');
        title = Language.getTranslated(title);
        $(tooltipTriggerEl).attr('title',title);

        return new bootstrap.Tooltip(tooltipTriggerEl);
    });


}
var uiLoaded = false;
var uiLoadedCount = 0;

function init_document_load() {
    if (uiLoadedCount > 30 ) {
        if (uiLoadedCount === 30) {
            loading_add("event: ui no response");

        }
        return;
    }
    if (!uiLoaded) {
        aevent("uiLoaded");
        uiLoadedCount++;
    }
}

function uiLoadedConfirm() {
//    console.log("loadedconfirm");
    loading_add("event: uiLoadedConfirm!");
    uiLoaded = true;
    aeternum_ready();
}

function page_cron_second() {
    setTimeout(page_cron_second, 1000);
//    fraemework_load_frame($("#vamscene-holder"));
    try {

        scene_populate_atoms();
        app_music_update_second();
//        cron_characters_cleanup();
        cron_characters_hide_apps();
        bottom_characters_menu_cron();

        cron_main_menu();
    } catch (e) {
        console.log("page_cron_second", e);
    }

    var fn = "app_" + App.GetCurrentAppName() + "_cron_second";
    if (typeof window[fn] === "function")
        window[fn]();


}
function page_cron_halfsecond() {
    app_loading_check_cron();
//   fraemework_load_frame($("#vamscene-holder"));
    var fn = "app_" + App.GetCurrentAppName() + "_cron_halfsecond";
    if (typeof window[fn] === "function")
        window[fn]();
    setTimeout(page_cron_halfsecond, 500);
}
function page_cron_quartersecond() {
    
//    cron_character_update();
    var fn = "app_" + App.GetCurrentAppName() + "_cron_quartersecond";
    if (typeof window[fn] === "function")
        window[fn]();
    setTimeout(page_cron_quartersecond, 250);
}

function ae_error(m, m2 = "") {
    $("#mainapp").append('<div class="alert alert-danger" role="alert">1' + m + " " + m2 + '</div>');
}

function cron_main_menu() {
//    if (isTrue(EPHEMERAL.vamscene.atommarker)) {
//        if (!$("#app").hasClass("atommarker-selected"))
//            $("#app").addClass("atommarker-selected");
//    } else {
//        if ($("#app").hasClass("atommarker-selected"))
//            $("#app").removeClass("atommarker-selected");
//    }
}

function page_fraemework_init() {
    page_fraemework_init_mode();
    page_fraemework_init_selectables();
    page_fraemework_init_tab_content();
    page_fraemework_init_documentready_vamdata();
    page_fraemework_init_documentready_aesttings();
    page_framework_init_alive();
    page_fraemework_init_vr_adjustments();
    page_fraemework_init_ephemeral();
    page_fraemework_init_search();
    page_fraemework_init_clicks();
    page_fraemework_init_range();
    page_fraemework_init_colorchange();
}

function page_fraemework_init_colorchange() {

    $("body").on("change", ".colorpicker", function () {
        let key = $(this).attr('id');
        if (TIMESTAMPS[key] === undefined)
            TIMESTAMPS[key] = 0;
        if (getTimestampFull() - TIMESTAMPS[key] > 0.05) {

            var fn = $(this).attr('data-colorpicker-live');
            if ($(".ui-colorpicker-hex-input").length < 1)
                return;
            var value = "#" + $(".ui-colorpicker-hex-input").val();
            if (typeof (window[fn]) !== 'function')
                return;
            window[fn](value);
            TIMESTAMPS[key] = getTimestampFull();

            setTimeout(function () {
                if ($(".ui-colorpicker-hex-input").length < 1)
                    return;
                var value = "#" + $(".ui-colorpicker-hex-input").val();
                if (typeof (window[fn]) !== 'function')
                    return;
                window[fn](value);
            }, 100);
        }
    });
}

function formatValue(value) {
    return parseFloat(value.toFixed(5)).toString();
}

function page_fraemework_init_range() {
//    $(document).on('input', 'input[type="range"]', function () {
//        var $this = $(this);
//        if($this.hasClass("nolive")) return;
//        var $display = $this.next('.current-value');
//
//        if (!$display.length) {
//            $display = $('<span>', {
//                class: 'current-value',
//                text: $this.val()
//            }).insertAfter($this);
//        }
//
//        $display.text($this.val()).fadeIn();
//    }).on('mouseup', 'input[type="range"]', function () {
//        if($(this).hasClass("nolive")) return;
//        var $this = $(this);
//        var $display = $this.next('.current-value');
//
//        if ($display.length) {
//            $display.fadeOut(function () {
//                $(this).remove();
//            });
//        }
//    });

    $("body").on("change input", ".form-range", function () {
        var preview = aesetting_range_get_preview($(this));
        if (preview === null || preview.length < 1)
            return;
        var val = $(this).val();
        preview.val(val);
    });

    $("body").on("mousedown", ".aelocation", function () {
        aelocation($(this).attr("data-location"), $(this).attr("data-room"));
    });

    $("body").on("change", ".form-range-preview", function () {
        var o = $(this).parent().find(".form-range");
        var currentval = parseFloat($(this).val());
        $(o).val(currentval);
        var val = $(o).val();
        //   val = parseFloat(val).toFixed(5);

        //console.log("parse float "+($(this).val()) +" - "+currentval +" _ " + val);
        $(this).val(val);
        $(o).trigger("change");
//        aevent({action:"aelivesliderUpdate", key: key, val: val});
    });

    $("body").on("change", ".aealiveslider-range", function () {
        var val = $(this).val();
        var key = $(this).attr("data-aealiveslider");
        aevent({action: "aelivesliderUpdate", key: key, val: val});
    });

}


function update_all_aealiveslider_values() {
    var person = Person.getSelectedPerson();
    if (person === null) return;
    $(".aealiveslider-range").each(function () {
        var key = $(this).attr("data-aealiveslider");
        var val = person.getSliderVal(key);
        if (val !== null) {
            $(this).val(val);
        }
    });

    $("#app .aelivebool").each(function () {
        var isOn = false;
        if ($(this).attr("data-aelivebool") === undefined)
            isOn = true;
        else if (isTrue(EPHEMERAL.characters[character_get_selected()]['enabled'][$(this).attr("data-aelivebool")]))
            isOn = true;
        if ($(this).attr("data-aelivebool-excludeall") !== undefined) {
            var vals = $(this).attr("data-aelivebool-excludeall").split(",");
            for (var val of vals) {
                if (isTrue(EPHEMERAL.characters[character_get_selected()]['enabled'][val]))
                    isOn = false;
            }
        }
        if (isOn) {
            if (!$(this).hasClass('selected'))
                $(this).addClass("selected");
        } else {
            if ($(this).hasClass('selected'))
                $(this).removeClass("selected");
        }
    });
    
    
     $("#app .aeliveeffect").each(function () {
        if(isEmpty(SELECTED_PERSON)) return;
        person = Person.getSelectedPerson();
        var isOn = false;
        if ($(this).attr("data-aeliveeffect") !== undefined){
            var effect = person.getEffect($(this).attr("data-aeliveeffect"));
            if(effect !== null){
                 if ($(this).attr("data-aeliveeffect-enabled") !== undefined){
                     isOn = false;
                     if(isTrue($(this).attr("data-aeliveeffect-enabled")) && effect.isEnabled()) isOn = true;
                     if(!isTrue($(this).attr("data-aeliveeffect-enabled")) && !effect.isEnabled()) isOn = true;
                 } else {
                     isOn = effect.isEnabled();
                 }
                if ($(this).attr("data-aeliveeffect-param") !== undefined){
                    isOn = effect.isEnabled() && $(this).attr("data-aeliveeffect-param") === effect.getParam();
                }
            } else {
                 if ($(this).attr("data-aeliveeffect-enabled") !== undefined){
                     if(!isTrue($(this).attr("data-aeliveeffect-enabled"))) isOn = true;
                 }
            }
         }
         
        if (isOn) {
            if (!$(this).hasClass('selected')) $(this).addClass("selected");
        } else {
            if ($(this).hasClass('selected')) $(this).removeClass("selected");
        }
    });
    
    
    

}

function page_fraemework_init_clicks() {
    $("body").on("mousedown", ".refresh-aeternum", function () {

        $.confirm({
            theme: 'material',
            title: 'Reload Aeternum UI?',
            content: '',
            buttons: {
                cancel: function () {

                },
                confirm: function () {
                    aevent({action: "refreshAeternum"});
                },
            }
        });
    });

    $("#app").on("mousedown", ".menu-more", function () {

        $.dialog({
            backgroundDismiss: true,
            title: '',
            content: $(".menu-more-content").html()
        });
    });


    $("body").on("mousedown", ".quit-vam", function () {

        $.confirm({
            theme: 'material',
            title: 'Close Virt-A-Mate?',
            content: 'Any unsaved changes to your scene or models will be lost.',
            buttons: {
                cancel: function () {

                },
                confirm: function () {
                    aevent({action: "quitVam"});
                },
            }
        });
    });

    $("body").on("mousedown", ".alive-auto-active", function () {
        var person = Person.getSelectedPerson();
        alive_person_enabled_toggle(person.id);

    });


}


function alive_person_enabled_toggle(person) {
    var p = $(".person-select-item[data-person='" + person + "']");
    if (p.length < 1)
        return;
    var on = $("#bottom-menu .alive-auto-active").hasClass('active');
    if (on) {
        alive_person_enabled_off(person);
        aevent({action: "query", context: "alive", query: "aliveDisable"});
    } else {
        alive_person_enabled_on(person);
        aevent({action: "query", context: "alive", query: "aliveEnable"});
    }
}

function alive_person_enabled_on(person) {
    $("#bottom-menu .alive-auto-active").addClass("active");

}
function alive_person_enabled_off(person) {
    $("#bottom-menu .alive-auto-active").removeClass("active");
}

function page_fraemework_init_search() {
    $('#app').on("keyup", ".aesearchfilter", function () {
        var val = $(this).val();
        var v = val.toLowerCase();
        var destination = $($(this).attr("data-aesearch"));
        destination.find(".filteredout").removeClass("filteredout");
        destination.find(".aesearchitem").each(function (k, val) {
            if ($(val).find(".aesearchtext").text().toLowerCase().indexOf(v) === -1) {
                $(val).addClass("filteredout");
            }
        });
    });
}


function page_fraemework_init_ephemeral() {
    if (USE_EPEHEMERAL)
        $("#vamdata-ephemeral").attr('src', $("#vamdata-ephemeral").attr('data-src'));
}

function page_fraemework_init_vr_adjustments() {
    $('#app').on('mousedown', ".app-tabs .nav-link", function (e) {
        var tab = $(this).attr('data-bs-target');
        var a = App.GetCurrent();
        a.SetTab(tab);
        $(this).trigger("click");

    });
}

function page_fraemework_init_documentready_vamdata() {
    set_url_from_options({action: "documentReadyVamdata", data: "documentReady"});
    set_url_from_options({action: "getscenedata", data: "documentReady"});
//    if (typeof EPHEMERAL.vamdata.time === "undefined") {
//        setTimeout(page_fraemework_init_documentready_vamdata, 1000 +randomIntFromInterval(0,500));
//    }
}
function page_fraemework_init_documentready_aesttings() {
    set_url_from_options({action: "documentReadyAesettings", data: "documentReady"});
//    if (typeof EPHEMERAL.aesettings.defaultTime === "undefined") {
//        setTimeout(page_fraemework_init_documentready_aesttings, 1000 + randomIntFromInterval(0,500));
//    }
}

var initiatedAlive = false;
function page_framework_init_alive() {
    aevent({actionAll: "aliveGetData"});
//    if (typeof EPHEMERAL.aesettings.defaultTime === "undefined") {
//        setTimeout(page_framework_init_alive, 1000 + randomIntFromInterval(0,500));
//    }
}


function page_fraemework_ephemeral_debug() {
}



function aesetting_range_get_preview(o) {
    var preview = $(o).parent().find(".form-range-preview");
    return preview;
}

function aesetting_trigger(o) {
    if (!o.hasClass("aesetting-initiated"))
        return;
    var fn = o.attr('data-aesetting-callback');
    var setting = o.attr('data-aesetting');
    var value = "";
    if (o.hasClass("aesetting-select"))
        value = o.find("option:selected").attr("value");
    if (o.hasClass("aesetting-text") || o.hasClass("aesetting-range")) {
        value = o.val();
    }
    if (o.hasClass("aesetting-toggle"))
        value = o.is(":checked") ? "true" : "false";
    if (o.hasClass("aesetting-color")){
        value = o.attr('data-value');
    }

    if (fn !== undefined) {
        if (window[fn] !== undefined)
            window[fn](value);
    }

    EPHEMERAL.aesettings[setting] = value;
    
   

    let options = {};
    options.action = "setsetting";
    options.setting = setting;
    options.value = value;
    set_url_from_options(options);
    if (!o.hasClass("aesetting-toggle")) {
        o.addClass("changed");
        setTimeout(function () {
            o.removeClass("changed");
            fraemework_load_frame($("#vamsettings-holder"));

        }, 1000);
    }
    page_fraemework_aesettings_ifs();
     on_trigger("on_aesetting_change",{setting: setting, value: value});
}

function on_trigger(trigger,param){
    for(var k in META){
        var fn = "app_"+k+"_"+trigger;
        if(typeof window[fn] === "function"){
            window[fn](param);
        }
    }
}

function page_fraemework_init_tab_content() {

    $('.colorpicker').each(function () {
        var o = $(this);
        if (o.hasClass("colorpicker-initiated"))
            return;
        o.addClass("colorpicker-initiated");

        var fn = o.attr('data-colorpicker-callback');
        var value = o.attr('data-value');
        var colorpickerOptions = {
            parts: ['map', 'bar', 'hex', 'rgb', 'preview', 'footer'],
            altProperties: 'background-color',
            altField: '#' + o.attr("id"),
            showOn: "click",
            color: value,
            close: function (event, color) {
                var color_in_hex_format = "#" + color.formatted;
                $(this).attr('data-value', color_in_hex_format);
                
                aesetting_trigger(o);
                if (fn === undefined)
                    return;
                if (typeof (window[fn]) !== 'function')
                    return;
                window[fn](color_in_hex_format);

            }

            , inline: false
        };
        $(o).colorpicker(colorpickerOptions);
    });


    $('.aesetting-select, .aesetting-text, .aesetting-range, .aesetting-toggle, .aesetting-color').each(function () {

        var o = $(this);
//        aesetting_trigger(o);

        if (o.hasClass("aesetting-initiated"))
            return;

        var fn = o.attr('data-aesettings-callback');
        var setting = o.attr('data-aesetting');

        if (!o.hasClass("setting-change-initiated")) {
            o.on("change", function () {
                if (o.hasClass("aesetting-color"))
                    return;
                aesetting_trigger(o);
            });
            o.addClass("setting-change-initiated");
        }

        if (typeof (EPHEMERAL.aesettings[setting]) !== "undefined") {
            var value = EPHEMERAL.aesettings[setting];
            if (o.hasClass("aesetting-select"))
                o.find('option[value="' + value + '"]').attr('selected', 'selected');
            if (o.hasClass("aesetting-text"))
                o.val(value);
            if (o.hasClass("aesetting-range")) {
                var preview = o.parent().find(".form-range-preview");
                o.val(value);
                if (!isEmpty(preview))
                    preview.val(value);
            }
            if (o.hasClass("aesetting-toggle"))
                o.prop("checked", value === "true" ? true : false);
            if (o.hasClass("aesetting-color")) {
                o.attr("data-value", value);
                o.css("background-color", value);
            }
        }
        o.addClass("aesetting-initiated");
    });

    page_fraemework_aesettings_ifs();
}

function page_fraemework_aesettings_ifs() {
    page_fraemework_aesettings_ifs_true();
}

function page_fraemework_aesettings_ifs_true() {
    if ($(".aesetting-if-true").length > 0) {
        $(".aesetting-if-true").each(function () {
            var setting = $(this).attr('data-aesetting');
            if (isTrue(EPHEMERAL.aesettings[setting])) {
                $(this).removeClass("aesetting-hidden");
            } else {
                $(this).addClass("aesetting-hidden");
            }
        });
    }
}



function page_fraemework_init_selectables() {
    $("#app").on("mousedown", ".selectable-toggle", function (e) {
        var parent = $(this).parents(".selectables");
        var selectable = $(this).parents(".selectable");
        var same = selectable.hasClass('selected');
        parent.find('.selectable.selected').removeClass("selected");
        if (!same) {
            setTimeout(function () {
                selectable.addClass('selected');
            }, 100);
        }
    });
}

function page_fraemework_init_screensize() {
//    $("#app").on("click",".select-fullscreen",function(e){
//        e.preventDefault();
//        fraemework_change_menu_mode_val("full");
//        return false;
//    });
//    $("#app").on("click",".select-fullscreenexit",function(e){
//        e.preventDefault();
//        fraemework_change_menu_mode_val("side");
//        return false;
//    });
}
function page_fraemework_init_apps() {
    var a = new App("loading");
//    var a = new App("haircuts");
    a.Load();
}
function page_fraemework_init_mode() {

    $("body").on("mousedown", ".changemenu_full", function () {
        fraemework_change_menu_mode_val("full");
    });
    $("body").on("mousedown", ".changemenu_sidebar", function () {
        fraemework_change_menu_mode_val("side");
    });

    var hash = window.location.hash.replace("#", "");
    if (hash.length === 0)
        return;
    hash = hash.split("&");
    for (var h of hash) {
        let pair = h.split("=");
        if (!pair)
            continue;
        if (pair[0] === "mode")
            fraemework_change_menu_mode_val(pair[1]);
        if (pair[0] === "vr" && isTrue(pair[1])) {
            ISVR = true;
            page_fraemework_init_vrmode();
        }
        if (pair[0] === "ephemeral")
            USE_EPEHEMERAL = true;
        INIT_PARAMS[pair[0]] = pair[1];
    }
}
function page_fraemework_init_vrmode() {
    if (ISVR)
        $("body").addClass("vrmode");
    else
        $("body").removeClass("vrmode");
}
//function page_fraemework_init_time() {
//    setInterval(page_fraemework_init_time_second, 1000);
//}


function fraemework_change_menu_mode(o) {
    var mode = o.attr("data-mode");
    fraemework_change_menu_mode_val(mode);
}
function fraemework_change_menu_mode_val(mode) {
    $("body").removeClass("mode_mini").removeClass("mode_side").removeClass("mode_full");
    $("body").addClass("mode_" + mode);
    $("body").attr("data-mode", mode);
}
function fraemework_process_vamdata(data) {
//    console.log('fraemework_process_vamdata',data);
    if (typeof data === "string") {
        try {
            data = JSON.parse(data);
        } catch (e) {
            console.log("err", e);
            console.log("vamdatabad json", data);
            return;
        }
    }
    EPHEMERAL.vamdata = data;
//    console.log('vamdata updated', EPHEMERAL.vamdata);
    if ($('body').hasClass("initiated")) {
        $('body').removeClass('initiated');
        //initial_load();
    }
}

function fraemework_process_aesettings(data) {
    if (typeof data === "string") {
        try {
            data = JSON.parse(data);
        } catch (e) {
            console.log("aesettings bad json", data);
            return;
        }
    }
    EPHEMERAL.aesettings = data;
    //console.log('aesettings updated', EPHEMERAL.aesettings);
    fraemework_aesettings_update_elements();
    app_settings_update_gameplay_values();
    fraemework_redraw_settings();
    if(!settings_initialized){
        on_settings_initialized();
    }

}

function on_settings_initialized(){
    settings_initialized = true;
    Language.setLanguage(Settings.getString("sttlanguage"));
}
function fraemework_redraw_settings() {
    $(".aesetting-initiated").removeClass('aesetting-initiated');
    page_fraemework_init_tab_content();
    $("body").addClass("ui-desktop-" + EPHEMERAL.aesettings.stUiDesktop.toLowerCase());
}

function fraemework_aesettings_update_elements() {
    $(".aesettingselect").each(function () {
        var settingKey = $(this).attr('data-aesettingselect');
        var settingVal = $(this).attr('data-aesettingselect-val');
        if (Settings.getString(settingKey) === "" + settingVal) {
            $(this).addClass('selected');
        } else {
            $(this).removeClass('selected');
        }
    });
    
    set_ui_color(Settings.getString("sttUiColor"));
}

function initial_load() {
    if (!isEmpty(INIT_PARAMS["app"])) {
        INIT_APP = INIT_PARAMS["app"];
    }
    App.LoadApp(INIT_APP);
}

function fraemework_process_customeph(data) {
    if (!isVam() && typeof (data) !== "") {
        Debug.setSnapshot(unescape(data));
        initial_load();
        uiLoadedConfirm();
    }
}
function fraemework_process_vamscene(data) {
    loading_add("fraemework_process_vamscene");
    if (typeof data === "string") {
        try {
            data = JSON.parse(data);
        } catch (e) {
            loading_add("error: " + data);
            console.log("vamscene bad json", data);
            return;
        }
    }
    EPHEMERAL.vamscene = data;
    //   console.log('vamscene updated', vamscene);

    DEBUGMODE = isTrue(EPHEMERAL.vamscene.debugmode);
}

function fraemework_load_frame(o) {
    o.attr('src', o.attr("data-src") + "?t=" + getTimestamp());
}

function roundToDecimalPlaces(num, decimalPlaces) {
    num = parseFloat(num);
    return +(Math.round(num + "e+" + decimalPlaces) + "e-" + decimalPlaces);
}

var confirmedProcessAlive = {};
function fraemework_process_alive(data) {
    loading_add("fraemework_process_alive");
    initiatedAlive = true;
    if (typeof data === "string") {
        try {
            data = JSON.parse(data);
        } catch (e) {
            loading_add("error: " + data);
            return;
        }
    }

    EPHEMERAL.characters[data.id] = data;

//    if(isTrue(data.isAliveEnabled)){
//        alive_person_enabled_on(data.id);
//    } else {
//        alive_person_enabled_off(data.id);
//    }

    if (typeof (confirmedProcessAlive[data.id]) === "undefined") {
        confirmedProcessAlive[data.id] = getTimestamp();
        aevent({action: "uiConfirmPersonAdded", id: data.id});
    }
    update_all_aealiveslider_values();
}

function isVam() {
    if (navigator.appVersion.indexOf("ZFBrowser") > -1)
        return true;
    return false;
}


function cron_characters_cleanup() {
    var expires = 10;
    if (EPHEMERAL == null)
        return;
    var keys = Object.keys(EPHEMERAL.characters);
    for (var i in keys) {
        var key = keys[i];
        if (getTimestamp() - parseInt(EPHEMERAL.characters[key].time) > expires) {
            if (!Debug.isFrozen()) {
                delete EPHEMERAL.characters[key];
                continue;
            }
        }

    }
}

function cron_characters_hide_apps() {
    if (character_is_selected() && !$("body").hasClass("selected-character"))
        $("body").addClass("selected-character");
    if (!character_is_selected() && $("body").hasClass("selected-character")){
        $("body").removeClass("selected-character");
        $("body").removeClass("character-is-android");
    }
}

function toggle_selected(o) {
    if (o.hasClass("selected")) {
        o.removeClass("selected");
    } else {
        o.addClass('selected');
    }
}

function app_reload_character_app(){
    var app = App.GetCurrent();
    if(isTrue((app.Meta("isCharacterApp")))){
        App.TabRefresh();
    }
    if(isTrue((app.Meta("isPersonApp")))){
        App.TabRefresh();
    }
}


function app_init_topmenu() {
    var current = App.GetCurrentAppName();
    $(".select-app.selected").removeClass("selected");

    if ($(".select-app[data-app='" + current + "']").length > 0) {
        $(".select-app[data-app='" + current + "']").addClass('selected');
    }
}

function app_init_topmenu_characters_cleanup() {


    var current = App.GetCurrentAppName();
    var tab = App.GetCurrentAppTabName();
    if (!isEmpty(SELECTED_PERSON)) {
        var person = Person.getSelectedPerson();
        var android = person.getAndroid();
        var param = App.GetCurrent().GetParam();
        
        if(!isEmpty(android)){
            
            if (current === "android" && tab === 'tab-inbox-chat' && param === android.id) {
                $(".select-app.selected").removeClass("selected");
                $("#bottom-menu .select-app-person-chat").addClass('selected');
                return;
            }
            
            if (current === "android" && param === android.id) {
                $(".select-app.selected").removeClass("selected");
                $("#bottom-menu .select-app-person-profile").addClass('selected');
                return;
            }

            
        }
    }
}
function modals_close_all() {
    if (jconfirm !== null && jconfirm.instances.length > 0) {
        for (var k of jconfirm.instances)
            k.close();
    }

}
function apps_init_clicks() {
    $("#app").on("mousedown", ".home-app", function () {
        var a = new App($(this).attr('data-app'));
        a.Load();
    });

    $("body").on("mousedown", ".select-app", function () {
        var app = $(this).attr('data-app');
        if(isEmpty(app)) return;
        var tab = $(this).attr('data-tab');
        if (App.GetCurrentAppName() !== app) {
            var a = new App(app);
            a.Load();
            if (tab !== undefined)
                a.SetTab(tab);
        }
    });


    $("#app").on("mousedown", ".app-title-button-close", function () {
        App.LoadApp(INIT_APP);
    });
    $("#app").on("mousedown", ".app-title-button-refresh", function () {

        App.ClearApp();
        setTimeout(function () {
            App.LoadApp(App.GetCurrentAppName());
            App.ShowApp();
        }, 500);
    });
//    $("#app").on("mouseenter", ".person-avatar-container .person-avatar", function(){
//        var person = $(this).parents(".person-select-item").attr("data-person");
//        aevent({action:"personHover", person: person});
//    });
//    
    $("#app").on("mousedown", ".ae-api-check-button", function () {
        var o = $(this).parents(".ae-api-check");
        o.find(".api-status").html("Checking...");
        var q = o.attr("data-api");
        aevent({action: "query", context: "aeapi", query: q});
    });
    
    
    $("#app").on("mousedown",".subtabs .subtab", subtab_select);
    
//    $("body").on("mousedown", ".aeexternallink", function(){
//        aevent({action: "externalLink", link: $(this).attr("data-link")});
//    });
}

CLICKCATCHER_ENABLED = false;
function clickcatcher_show(){
    if(CLICKCATCHER_ENABLED) return;
    CLICKCATCHER_ENABLED = true;
    $("#clickcatcher").addClass("show");
}
function clickcatcher_hide(){
    if(!CLICKCATCHER_ENABLED) return;
    CLICKCATCHER_ENABLED = false;
    $("#clickcatcher").removeClass("show");
}
function clickcatcher_hide_delayed(){
    setTimeout(clickcatcher_hide, 100);
}

function subtab_select(event){
    var o = event.currentTarget;
    var val = $(o).attr("data-subtab");
    var subtabs = $(o).parents(".subtabs");
    subtabs.find(".subtab.selected").removeClass("selected");
    subtabs.find(".subtab").each(function(k,v){
        var tab = $(v).attr("data-subtab");
        $("#mainapp .app").removeClass(tab);
    });
    
    $(o).addClass("selected");
    $("#mainapp .app").addClass(val);
}


function app_init_keyboards() {
    if (!ISVR) return;
    if ($('.keyboard').length === 0) return;
    
    $.extend($.keyboard.keyaction, {
        enter : function(kb) {
          // accept the content and close the keyboard
          kb.accept();
        }
    });
    
    
    
    $('.keyboard').keyboard({
        visible: function (e, keyboard, el) {
            $("#app").addClass('keyboard-visible');
        },
        hidden: function (event, keyboard, el) {
            $("#app").removeClass('keyboard-visible');
        },
        position: {
            // null = attach to input/textarea;
            // use $(sel) to attach elsewhere
            of: $("body"),
            my: 'center bottom',
            at: 'center bottom',
            // used when "usePreview" is false
            at2: 'center bottom'
        },
        autoAccept: true,
        enterNavigation : true,
        layout: 'custom',
        customLayout: {
            'normal': [
                '` 1 2 3 4 5 6 7 8 9 0 - = {bksp}',
                '{tab} q w e r t y u i o p [ ] \\',
                'a s d f g h j k l ; \' {enter}',
                '{shift} z x c v b n m , . / {shift}',
                '{space} {left} {right} {accept}'
            ],
            'shift': [
                '~ ! @ # $ % ^ & * ( ) _ + {del}',
                '{tab} Q W E R T Y U I O P { } |',
                'A S D F G H J K L : " {enter}',
                '{shift} Z X C V B N M < > ? {shift}',
                '{space} {left} {right} {accept} '
            ]
        },
        display: {
            bksp: "⌫",
            accept: 'Done',
        },
        change: function (event, keyboard, el) {

            $(event.target).val(keyboard.$preview.val());
            $(event.target).trigger("keyup");
        },
        
        accepted: function (event, keyboard, el) {
            //autosubmit keyboard
            if($(el).attr('id') === "chat-textbox") app_android_submit_chat();
        },
    });
}


function set_ui_color(col){
    if(!isColor(col)) col ="#9c23bb";
    UI_COLOR = col;
    $("body .style-ui-color").remove();
    $("body").append('<style class="style-ui-color">:root{--bs-primary: '+col+';}</style>')
}$(document).ready(function(){
        
});


var config = {};

config.folders = {
	"looks": {
		
	},
	"haircuts": {
		
	},
	"wardrobe": {
		
	}
};



class VamFile{
	
	constructor(type, path, hasImage){
		this.type = type;
		this.path = path;
		this.hasImage = hasImage;
		if(this.path == ""){
                    this.hasImage = false;
                    return;
                }
                
		var split = path.split(".");
		this.extension  = split.pop();
		this.imagePath = split.join(".")+".jpg";
		
		var split2 = path.split("/");
		this.fileName = split2.pop();
		split2 = this.fileName.split(".");
		split2.pop();
		this.fileName = split2.join(".");
                this.fileNameSimple = this.fileName.replace("Preset_","");
	}
	
	fullPath(s){
		return "../../../../../"+s;
	}
	
	 getImageSrc(){
		if(this.hasImage){
			return this.fullPath(this.imagePath);
		} else {
			return "resources/character.jpg";
		}
	}
}function isTrue(val) {
    if (typeof val === "boolean")
        return val;
    if (typeof val === "string")
        return val.toLowerCase() === "true";
}
function isEmpty(v) {
    if (v === null)
        return true;
    if (typeof v === "object" && Object.keys(v).length < 1)
        return true;
    if (v === undefined)
        return true;
    if (v === "")
        return true;
    return false;
}
function isColor(color) {
    const hexColorRegex = /^#([0-9a-fA-F]{6})$/;
    return hexColorRegex.test(color);
}
function removeItemAll(arr, value) {
    var i = 0;
    while (i < arr.length) {
        if (arr[i] === value) {
            arr.splice(i, 1);
        } else {
            ++i;
        }
    }
    return arr;
}

function randomIntFromInterval(min, max) {
    return Math.floor(Math.random() * (max - min + 1) + min)
}

function setCookie(cname, cvalue, exdays) {
    const d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    let expires = "expires=" + d.toUTCString();
    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}


function getCookie(cname) {
    let name = cname + "=";
    let decodedCookie = decodeURIComponent(document.cookie);
    let ca = decodedCookie.split(';');
    for (let i = 0; i < ca.length; i++) {
        let c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}

function getTimestamp() {
    return Math.floor(Date.now() / 1000)
}

function getTimestampFull() {
    return Date.now() / 1000;
}

function escapeHtml(string) {

    var entityMap = {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#39;',
        '/': '&#x2F;',
        '`': '&#x60;',
        '=': '&#x3D;'
    };

    return String(string).replace(/[&<>"'`=\/]/g, function (s) {
        return entityMap[s];
    });
}



function isUrl(url) {
    // Check if the URL is valid
    if (/^(ftp|http|https):\/\/[^ "]+$/.test(url)) {
        return true;
    }

    // Check if the URL is a local host or IP address
    if (/^(localhost|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})(:\d+)?(\/.*)?$/i.test(url)) {
        return true;
    }

    return false;
}

function getDistributed2(inputValue) {
  const midValue = 50;
  const range = 49;
  const distance = Math.abs(inputValue - midValue);
  const normalizedDistance = distance / range;
  const biasedValue = 1 - Math.log(normalizedDistance + 1) / Math.log(2);
  const scaledValue = Math.round(biasedValue * 9);
  return Math.abs(scaledValue);
}

function getDistributed3(inputValue) {
  const midValue = 500;
  const range = 499;
  const distance = Math.abs(inputValue - midValue);
  const normalizedDistance = distance / range;
  const biasedValue = 1 - Math.log(normalizedDistance + 1) / Math.log(2);
  const scaledValue = Math.round(biasedValue * 99);
  return Math.abs(scaledValue);
}

function generateBellValue(param) {
  const u = param / 1000;
  const v = (param + 500) % 1000 / 1000;
  
  const z = Math.sqrt(-2.0 * Math.log(u)) * Math.cos(2.0 * Math.PI * v);
  const mean = 50;
  const stddev = 16.67;
  const value = Math.round(z * stddev + mean);
  
  var val =  Math.max(0, Math.min(99, value));
  if(val === 0) val = 1;
  return val;
}

function generateBellValueHalf(param) {
  var val = Math.abs(generateBellValue(param) - 50)*2;
  return val;
}

function isSelectedCheck(o){
    return (o).hasClass("selected");
}

function toggle(o){
    if(o.hasClass("selected")){
        o.removeClass("selected");
        return true;
    }
    o.addClass("selected");
    return false;
}
// Ripple 

//document.onclick = () => applyCursorRippleEffect(event);

function applyCursorRippleEffect(e) {
    if (typeof e === "undefined")
        return;
    if (typeof e.clientX === "undefined")
        return;
    const ripple = document.createElement("div");

    ripple.className = "ripple";
    if (document.body === undefined)
        return;
    document.body.appendChild(ripple);

    ripple.style.left = `${e.clientX}px`;
    ripple.style.top = `${e.clientY}px`;
    ripple.style.animation = `ripple-effect .3s  linear`;
    setTimeout(function () {
        document.body.removeChild(ripple);
    }, 300);

}




function md5cycle(x, k) {
    var a = x[0], b = x[1], c = x[2], d = x[3];

    a = ff(a, b, c, d, k[0], 7, -680876936);
    d = ff(d, a, b, c, k[1], 12, -389564586);
    c = ff(c, d, a, b, k[2], 17, 606105819);
    b = ff(b, c, d, a, k[3], 22, -1044525330);
    a = ff(a, b, c, d, k[4], 7, -176418897);
    d = ff(d, a, b, c, k[5], 12, 1200080426);
    c = ff(c, d, a, b, k[6], 17, -1473231341);
    b = ff(b, c, d, a, k[7], 22, -45705983);
    a = ff(a, b, c, d, k[8], 7, 1770035416);
    d = ff(d, a, b, c, k[9], 12, -1958414417);
    c = ff(c, d, a, b, k[10], 17, -42063);
    b = ff(b, c, d, a, k[11], 22, -1990404162);
    a = ff(a, b, c, d, k[12], 7, 1804603682);
    d = ff(d, a, b, c, k[13], 12, -40341101);
    c = ff(c, d, a, b, k[14], 17, -1502002290);
    b = ff(b, c, d, a, k[15], 22, 1236535329);

    a = gg(a, b, c, d, k[1], 5, -165796510);
    d = gg(d, a, b, c, k[6], 9, -1069501632);
    c = gg(c, d, a, b, k[11], 14, 643717713);
    b = gg(b, c, d, a, k[0], 20, -373897302);
    a = gg(a, b, c, d, k[5], 5, -701558691);
    d = gg(d, a, b, c, k[10], 9, 38016083);
    c = gg(c, d, a, b, k[15], 14, -660478335);
    b = gg(b, c, d, a, k[4], 20, -405537848);
    a = gg(a, b, c, d, k[9], 5, 568446438);
    d = gg(d, a, b, c, k[14], 9, -1019803690);
    c = gg(c, d, a, b, k[3], 14, -187363961);
    b = gg(b, c, d, a, k[8], 20, 1163531501);
    a = gg(a, b, c, d, k[13], 5, -1444681467);
    d = gg(d, a, b, c, k[2], 9, -51403784);
    c = gg(c, d, a, b, k[7], 14, 1735328473);
    b = gg(b, c, d, a, k[12], 20, -1926607734);

    a = hh(a, b, c, d, k[5], 4, -378558);
    d = hh(d, a, b, c, k[8], 11, -2022574463);
    c = hh(c, d, a, b, k[11], 16, 1839030562);
    b = hh(b, c, d, a, k[14], 23, -35309556);
    a = hh(a, b, c, d, k[1], 4, -1530992060);
    d = hh(d, a, b, c, k[4], 11, 1272893353);
    c = hh(c, d, a, b, k[7], 16, -155497632);
    b = hh(b, c, d, a, k[10], 23, -1094730640);
    a = hh(a, b, c, d, k[13], 4, 681279174);
    d = hh(d, a, b, c, k[0], 11, -358537222);
    c = hh(c, d, a, b, k[3], 16, -722521979);
    b = hh(b, c, d, a, k[6], 23, 76029189);
    a = hh(a, b, c, d, k[9], 4, -640364487);
    d = hh(d, a, b, c, k[12], 11, -421815835);
    c = hh(c, d, a, b, k[15], 16, 530742520);
    b = hh(b, c, d, a, k[2], 23, -995338651);

    a = ii(a, b, c, d, k[0], 6, -198630844);
    d = ii(d, a, b, c, k[7], 10, 1126891415);
    c = ii(c, d, a, b, k[14], 15, -1416354905);
    b = ii(b, c, d, a, k[5], 21, -57434055);
    a = ii(a, b, c, d, k[12], 6, 1700485571);
    d = ii(d, a, b, c, k[3], 10, -1894986606);
    c = ii(c, d, a, b, k[10], 15, -1051523);
    b = ii(b, c, d, a, k[1], 21, -2054922799);
    a = ii(a, b, c, d, k[8], 6, 1873313359);
    d = ii(d, a, b, c, k[15], 10, -30611744);
    c = ii(c, d, a, b, k[6], 15, -1560198380);
    b = ii(b, c, d, a, k[13], 21, 1309151649);
    a = ii(a, b, c, d, k[4], 6, -145523070);
    d = ii(d, a, b, c, k[11], 10, -1120210379);
    c = ii(c, d, a, b, k[2], 15, 718787259);
    b = ii(b, c, d, a, k[9], 21, -343485551);

    x[0] = add32(a, x[0]);
    x[1] = add32(b, x[1]);
    x[2] = add32(c, x[2]);
    x[3] = add32(d, x[3]);

}

function cmn(q, a, b, x, s, t) {
    a = add32(add32(a, q), add32(x, t));
    return add32((a << s) | (a >>> (32 - s)), b);
}

function ff(a, b, c, d, x, s, t) {
    return cmn((b & c) | ((~b) & d), a, b, x, s, t);
}

function gg(a, b, c, d, x, s, t) {
    return cmn((b & d) | (c & (~d)), a, b, x, s, t);
}

function hh(a, b, c, d, x, s, t) {
    return cmn(b ^ c ^ d, a, b, x, s, t);
}

function ii(a, b, c, d, x, s, t) {
    return cmn(c ^ (b | (~d)), a, b, x, s, t);
}

function md51(s) {
    txt = '';
    var n = s.length,
            state = [1732584193, -271733879, -1732584194, 271733878], i;
    for (i = 64; i <= s.length; i += 64) {
        md5cycle(state, md5blk(s.substring(i - 64, i)));
    }
    s = s.substring(i - 64);
    var tail = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    for (i = 0; i < s.length; i++)
        tail[i >> 2] |= s.charCodeAt(i) << ((i % 4) << 3);
    tail[i >> 2] |= 0x80 << ((i % 4) << 3);
    if (i > 55) {
        md5cycle(state, tail);
        for (i = 0; i < 16; i++)
            tail[i] = 0;
    }
    tail[14] = n * 8;
    md5cycle(state, tail);
    return state;
}

function md5blk(s) {
    var md5blks = [], i;
    for (i = 0; i < 64; i += 4) {
        md5blks[i >> 2] = s.charCodeAt(i)
                + (s.charCodeAt(i + 1) << 8)
                + (s.charCodeAt(i + 2) << 16)
                + (s.charCodeAt(i + 3) << 24);
    }
    return md5blks;
}

var hex_chr = '0123456789abcdef'.split('');

function rhex(n)
{
    var s = '', j = 0;
    for (; j < 4; j++)
        s += hex_chr[(n >> (j * 8 + 4)) & 0x0F]
                + hex_chr[(n >> (j * 8)) & 0x0F];
    return s;
}

function hex(x) {
    for (var i = 0; i < x.length; i++)
        x[i] = rhex(x[i]);
    return x.join('');
}

function md5(s) {
    return hex(md51(s));
}
function add32(a, b) {
    return (a + b) & 0xFFFFFFFF;
}



///browser info

navigator.browserinfo = (function () {
    var ua = navigator.userAgent;
    var tem;
    var M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    if (/trident/i.test(M[1])) {
        tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
        return 'IE ' + (tem[1] || '');
    }
    if (M[1] === 'Chrome') {
        tem = ua.match(/\b(OPR|Edge)\/(\d+)/);
        if (tem != null)
            return tem.slice(1).join(' ').replace('OPR', 'Opera');
    }
    M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
    if ((tem = ua.match(/version\/(\d+)/i)) != null)
        M.splice(1, 1, tem[1]);
    return M.join(' ');
})();



var makeCRCTable = function () {
    var c;
    var crcTable = [];
    for (var n = 0; n < 256; n++) {
        c = n;
        for (var k = 0; k < 8; k++) {
            c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
        }
        crcTable[n] = c;
    }
    return crcTable;
}

var crc32 = function (str) {
    var crcTable = window.crcTable || (window.crcTable = makeCRCTable());
    var crc = 0 ^ (-1);

    for (var i = 0; i < str.length; i++) {
        crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xFF];
    }

    var num = (crc ^ (-1)) >>> 0;
    var str = num.toString();
    var paddedStr = str.padStart(10, '0');
    return paddedStr;
};


function escapeHtml(string) {
  const map = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#039;'
  };

  return string.replace(/[&<>"']/g, (m) => map[m]);
}




function convertToPercentSentiment(value) {
    var shiftedValue = value + 1;
    var scaledValue = shiftedValue * 50;
    return scaledValue;
}

function formatTimestamp(timestamp) {
  // Convert the timestamp to milliseconds
  var milliseconds = timestamp * 1000;
  
  // Create a new Date object
  var date = new Date(milliseconds);
  
  // Get the month, day, and year
  var month = date.toLocaleString('en-US', { month: 'long' });
  var day = date.getDate();
  var year = date.getFullYear();
  
  // Format the date string
  var formattedDate = month + ' ' + day + ', ' + year;
  
  return formattedDate;
}


function set_progressbar(o, val){
    if(val < 0) val = 0;
    if(val > 100) val = 100;
    $(o).attr('data-val', val);
    $(o).find('span').css('width',val+"%");
}

function get_percent_on_range(val, min, max){
    var range = max - min;
    var normalizedValue = val - min;
    var percent = (normalizedValue / range) * 100;
    if(percent < 0 ) percent = 0;
    if(percent > 100) percent = 100;
    return percent;
}

function isSelectOpen() {
  var isOpen = $('select').is(':focus');
  return isOpen;
}


function copyTextToClipboard(text) {

    var focusedElement = document.activeElement; // Store the currently focused element
    
    var tempInput = document.createElement("textarea");
    tempInput.style = "position: absolute; left: -1000px; top: -1000px";
    tempInput.value = text;
    document.body.appendChild(tempInput);
    tempInput.select();
    
    try {
        document.execCommand("copy");
    // console.log("Text copied to clipboard");
    } catch (err) {
      //  console.error("Failed to copy text to clipboard:", err);
    }
    
    document.body.removeChild(tempInput);
    
    // Restore focus to the previously focused element
    focusedElement.focus();
}


function formatTimestampGetTime(timestamp) {
  const date = new Date(timestamp * 1000);
  const hours = String(date.getHours()).padStart(2, '0');
  const minutes = String(date.getMinutes()).padStart(2, '0');
  return `${hours}:${minutes}`;
}


function formatTimestampDay(timestamp) {
  const months = [
    'January', 'February', 'March', 'April', 'May', 'June',
    'July', 'August', 'September', 'October', 'November', 'December'
  ];

  const date = new Date(timestamp * 1000);
  const month = months[date.getMonth()];
  const day = date.getDate();
  const daySuffix = getDaySuffix(day);

  return `${month} ${day}${daySuffix}`;
}

function getDaySuffix(day) {
  if (day >= 11 && day <= 13) {
    return 'th';
  }
  switch (day % 10) {
    case 1:
      return 'st';
    case 2:
      return 'nd';
    case 3:
      return 'rd';
    default:
      return 'th';
  }
}

function formatTimestampFullDay(timestamp) {
  const date = new Date(timestamp * 1000);
  const month = String(date.getMonth() + 1).padStart(2, '0');
  const day = String(date.getDate()).padStart(2, '0');
  const year = date.getFullYear();
  return `${month}/${day}/${year}`;
}


function stringToFloat(s){
    return isTrue(s);
}

function stringToInt(s){
    return parseInt(s);
}
function stringToFloat(s){
    return parseFloat(s);
}


function imageToBase64(img, callback) {
    // Create a new canvas element
    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');

    // Set canvas dimensions to the image dimensions
    canvas.width = img.width;
    canvas.height = img.height;

    // Draw the image onto the canvas
    ctx.drawImage(img, 0, 0);

    // Get the base64 data from the canvas
    var base64Data = canvas.toDataURL('image/png');

    // Execute the callback with the base64 data
    callback(base64Data);
}


function floatToHexAlpha(floatValue) {
    // Ensure the input is within the valid range
    if (floatValue < 0 || floatValue > 1) {
        console.error('Input value must be between 0 and 1.');
        return null;
    }

    // Convert the float value to an 8-bit integer (0-255)
    var intValue = Math.round(floatValue * 255);

    // Convert the integer value to a hexadecimal string
    var hexString = intValue.toString(16).toUpperCase().padStart(2, '0');

    return hexString;
}

function hexToRgb(hex) {
    // Remove the hash (#) if present
    hex = hex.replace(/^#/, '');

    // Parse the hexadecimal string to an integer
    var bigint = parseInt(hex, 16);

    // Extract the red, green, and blue components
    var r = (bigint >> 16) & 255;
    var g = (bigint >> 8) & 255;
    var b = bigint & 255;

    return {
        r: r,
        g: g,
        b: b
    };
}
/*jslint devel: true, bitwise: true, regexp: true, browser: true, confusion: true, unparam: true, eqeq: true, white: true, nomen: true, plusplus: true, maxerr: 50, indent: 4 */
/*globals jQuery,Color,define */

/*!
 * ColorPicker
 *
 * Copyright (c) 2011-2017 Martijn W. van der Lee
 * Licensed under the MIT.
 */
/* Full-featured colorpicker for jQueryUI with full theming support.
 * Most images from jPicker by Christopher T. Tillman.
 * Sourcecode created from scratch by Martijn W. van der Lee.
 */
(function( factory ) {
  if ( typeof define === 'function' && define.amd ) {

    // AMD. Register as an anonymous module.
    define([
      'jquery'
    ], factory );
  } else {

    // Browser globals
    factory( jQuery );
  }
} (function ($) {
  'use strict';

  var _colorpicker_index = 0,

    _container_popup = '<div class="ui-colorpicker ui-colorpicker-dialog ui-dialog ui-widget ui-widget-content ui-corner-all" style="display: none;"></div>',
    _container_inlineFrame = '<div class="ui-colorpicker ui-colorpicker-inline ui-dialog ui-widget ui-widget-content ui-corner-all"></div>',
    _container_inline = '<div class="ui-colorpicker ui-colorpicker-inline"></div>',

    _intToHex = function (dec) {
      var result = Math.round(dec).toString(16);
      if (result.length === 1) {
        result = ('0' + result);
      }
      return result.toLowerCase();
    },

    _keycode = {
      isPrint: function(keycode) {
        return keycode == 32 // spacebar
          || (keycode >= 48 && keycode <= 57) // number keys
          || (keycode >= 65 && keycode <= 90) // letter keys
          || (keycode >= 96 && keycode <= 111) // numpad keys
          || (keycode >= 186 && keycode < 192) // ;=,-./` (in order)
          || (keycode >= 219 && keycode < 222); // [\]' (in order)
      },
      isHex: function(keycode) {
        return (keycode >= 48 && keycode <= 57) // number keys
          || (keycode >= 96 && keycode <= 105) // numpad keys
          || (keycode >= 65 && keycode <= 70); // a-f
      }
    },

    _layoutTable = function(layout, callback) {
      var bitmap,
        x, y,
        width, height,
        columns, rows,
        index,
        cell,
        html,
        w, h,
        colspan,
        walked;

      layout.sort(function(a, b) {
        if (a.pos[1] === b.pos[1]) {
          return a.pos[0] - b.pos[0];
        }
        return a.pos[1] - b.pos[1];
      });

      // Determine dimensions of the table
      width = 0;
      height = 0;
      $.each (layout, function(index, part) {
        width = Math.max(width, part.pos[0] + part.pos[2]);
        height = Math.max(height, part.pos[1] + part.pos[3]);
      });

      // Initialize bitmap
      bitmap = [];
      for (x = 0; x < width; ++x) {
        bitmap.push([]);
      }

      // Mark rows and columns which have layout assigned
      rows = [];
      columns = [];
      $.each(layout, function(index, part) {
        // mark columns
        for (x = 0; x < part.pos[2]; x += 1) {
          columns[part.pos[0] + x] = true;
        }
        for (y = 0; y < part.pos[3]; y += 1) {
          rows[part.pos[1] + y] = true;
        }
      });

      // Generate the table
      html = '';
      cell = layout[index = 0];
      for (y = 0; y < height; ++y) {
        html += '<tr>';
        x = 0;
        while (x < width) {
          if (typeof cell !== 'undefined' && x === cell.pos[0] && y === cell.pos[1]) {
            // Create a "real" cell
            html += callback(cell, x, y);

            for (h = 0; h < cell.pos[3]; h +=1) {
              for (w = 0; w < cell.pos[2]; w +=1) {
                bitmap[x + w][y + h] = true;
              }
            }

            x += cell.pos[2];
            cell = layout[++index];
          } else {
            // Fill in the gaps
            colspan = 0;
            walked = false;

            while (x < width && bitmap[x][y] === undefined && (cell === undefined || y < cell.pos[1] || (y === cell.pos[1] && x < cell.pos[0]))) {
              if (columns[x] === true) {
                colspan += 1;
              }
              walked = true;
              x += 1;
            }

            if (colspan > 0) {
              html += '<td colspan="'+colspan+'"></td>';
            } else if (!walked) {
              x += 1;
            }
          }
        }
        html += '</tr>';
      }

      return '<table cellspacing="0" cellpadding="0" border="0"><tbody>' + html + '</tbody></table>';
    };

  $.colorpicker = new function() {
    this.regional = {
      '': {
        ok:       'OK',
        cancel:     'Cancel',
        none:     'None',
        button:     'Color',
        title:      'Pick a color',
        transparent:  'Transparent',
        hsvH:     'H',
        hsvS:     'S',
        hsvV:     'V',
        rgbR:     'R',
        rgbG:     'G',
        rgbB:     'B',
        labL:     'L',
        labA:     'a',
        labB:     'b',
        hslH:     'H',
        hslS:     'S',
        hslL:     'L',
        cmykC:      'C',
        cmykM:      'M',
        cmykY:      'Y',
        cmykK:      'K',
        alphaA:     'A'
      }
    };

    this.swatchesNames = {
      'html':   'HTML'
    };

    this.swatches = {
      'html': [
        {name: 'black',         r: 0, g: 0, b: 0},
        {name: 'dimgray',       r: 0.4117647058823529, g: 0.4117647058823529, b: 0.4117647058823529},
        {name: 'gray',          r: 0.5019607843137255, g: 0.5019607843137255, b: 0.5019607843137255},
        {name: 'darkgray',        r: 0.6627450980392157, g: 0.6627450980392157, b: 0.6627450980392157},
        {name: 'silver',        r: 0.7529411764705882, g: 0.7529411764705882, b: 0.7529411764705882},
        {name: 'lightgrey',       r: 0.8274509803921568, g: 0.8274509803921568, b: 0.8274509803921568},
        {name: 'gainsboro',       r: 0.8627450980392157, g: 0.8627450980392157, b: 0.8627450980392157},
        {name: 'whitesmoke',      r: 0.9607843137254902, g: 0.9607843137254902, b: 0.9607843137254902},
        {name: 'white',         r: 1, g: 1, b: 1},
        {name: 'rosybrown',       r: 0.7372549019607844, g: 0.5607843137254902, b: 0.5607843137254902},
        {name: 'indianred',       r: 0.803921568627451, g: 0.3607843137254902, b: 0.3607843137254902},
        {name: 'brown',         r: 0.6470588235294118, g: 0.16470588235294117, b: 0.16470588235294117},
        {name: 'firebrick',       r: 0.6980392156862745, g: 0.13333333333333333, b: 0.13333333333333333},
        {name: 'lightcoral',      r: 0.9411764705882353, g: 0.5019607843137255, b: 0.5019607843137255},
        {name: 'maroon',        r: 0.5019607843137255, g: 0, b: 0},
        {name: 'darkred',       r: 0.5450980392156862, g: 0, b: 0},
        {name: 'red',         r: 1, g: 0, b: 0},
        {name: 'snow',          r: 1, g: 0.9803921568627451, b: 0.9803921568627451},
        {name: 'salmon',        r: 0.9803921568627451, g: 0.5019607843137255, b: 0.4470588235294118},
        {name: 'mistyrose',       r: 1, g: 0.8941176470588236, b: 0.8823529411764706},
        {name: 'tomato',        r: 1, g: 0.38823529411764707, b: 0.2784313725490196},
        {name: 'darksalmon',      r: 0.9137254901960784, g: 0.5882352941176471, b: 0.47843137254901963},
        {name: 'orangered',       r: 1, g: 0.27058823529411763, b: 0},
        {name: 'coral',         r: 1, g: 0.4980392156862745, b: 0.3137254901960784},
        {name: 'lightsalmon',     r: 1, g: 0.6274509803921569, b: 0.47843137254901963},
        {name: 'sienna',        r: 0.6274509803921569, g: 0.3215686274509804, b: 0.17647058823529413},
        {name: 'seashell',        r: 1, g: 0.9607843137254902, b: 0.9333333333333333},
        {name: 'chocolate',       r: 0.8235294117647058, g: 0.4117647058823529, b: 0.11764705882352941},
        {name: 'saddlebrown',     r: 0.5450980392156862, g: 0.27058823529411763, b: 0.07450980392156863},
        {name: 'sandybrown',      r: 0.9568627450980393, g: 0.6431372549019608, b: 0.3764705882352941},
        {name: 'peachpuff',       r: 1, g: 0.8549019607843137, b: 0.7254901960784313},
        {name: 'peru',          r: 0.803921568627451, g: 0.5215686274509804, b: 0.24705882352941178},
        {name: 'linen',         r: 0.9803921568627451, g: 0.9411764705882353, b: 0.9019607843137255},
        {name: 'darkorange',      r: 1, g: 0.5490196078431373, b: 0},
        {name: 'bisque',        r: 1, g: 0.8941176470588236, b: 0.7686274509803922},
        {name: 'burlywood',       r: 0.8705882352941177, g: 0.7215686274509804, b: 0.5294117647058824},
        {name: 'tan',         r: 0.8235294117647058, g: 0.7058823529411765, b: 0.5490196078431373},
        {name: 'antiquewhite',      r: 0.9803921568627451, g: 0.9215686274509803, b: 0.8431372549019608},
        {name: 'navajowhite',     r: 1, g: 0.8705882352941177, b: 0.6784313725490196},
        {name: 'blanchedalmond',    r: 1, g: 0.9215686274509803, b: 0.803921568627451},
        {name: 'papayawhip',      r: 1, g: 0.9372549019607843, b: 0.8352941176470589},
        {name: 'orange',        r: 1, g: 0.6470588235294118, b: 0},
        {name: 'moccasin',        r: 1, g: 0.8941176470588236, b: 0.7098039215686275},
        {name: 'wheat',         r: 0.9607843137254902, g: 0.8705882352941177, b: 0.7019607843137254},
        {name: 'oldlace',       r: 0.9921568627450981, g: 0.9607843137254902, b: 0.9019607843137255},
        {name: 'floralwhite',     r: 1, g: 0.9803921568627451, b: 0.9411764705882353},
        {name: 'goldenrod',       r: 0.8549019607843137, g: 0.6470588235294118, b: 0.12549019607843137},
        {name: 'darkgoldenrod',     r: 0.7215686274509804, g: 0.5254901960784314, b: 0.043137254901960784},
        {name: 'cornsilk',        r: 1, g: 0.9725490196078431, b: 0.8627450980392157},
        {name: 'gold',          r: 1, g: 0.8431372549019608, b: 0},
        {name: 'palegoldenrod',     r: 0.9333333333333333, g: 0.9098039215686274, b: 0.6666666666666666},
        {name: 'khaki',         r: 0.9411764705882353, g: 0.9019607843137255, b: 0.5490196078431373},
        {name: 'lemonchiffon',      r: 1, g: 0.9803921568627451, b: 0.803921568627451},
        {name: 'darkkhaki',       r: 0.7411764705882353, g: 0.7176470588235294, b: 0.4196078431372549},
        {name: 'beige',         r: 0.9607843137254902, g: 0.9607843137254902, b: 0.8627450980392157},
        {name: 'lightgoldenrodyellow',  r: 0.9803921568627451, g: 0.9803921568627451, b: 0.8235294117647058},
        {name: 'olive',         r: 0.5019607843137255, g: 0.5019607843137255, b: 0},
        {name: 'yellow',        r: 1, g: 1, b: 0},
        {name: 'lightyellow',     r: 1, g: 1, b: 0.8784313725490196},
        {name: 'ivory',         r: 1, g: 1, b: 0.9411764705882353},
        {name: 'olivedrab',       r: 0.4196078431372549, g: 0.5568627450980392, b: 0.13725490196078433},
        {name: 'yellowgreen',     r: 0.6039215686274509, g: 0.803921568627451, b: 0.19607843137254902},
        {name: 'darkolivegreen',    r: 0.3333333333333333, g: 0.4196078431372549, b: 0.1843137254901961},
        {name: 'greenyellow',     r: 0.6784313725490196, g: 1, b: 0.1843137254901961},
        {name: 'lawngreen',       r: 0.48627450980392156, g: 0.9882352941176471, b: 0},
        {name: 'chartreuse',      r: 0.4980392156862745, g: 1, b: 0},
        {name: 'darkseagreen',      r: 0.5607843137254902, g: 0.7372549019607844, b: 0.5607843137254902},
        {name: 'forestgreen',     r: 0.13333333333333333, g: 0.5450980392156862, b: 0.13333333333333333},
        {name: 'limegreen',       r: 0.19607843137254902, g: 0.803921568627451, b: 0.19607843137254902},
        {name: 'lightgreen',      r: 0.5647058823529412, g: 0.9333333333333333, b: 0.5647058823529412},
        {name: 'palegreen',       r: 0.596078431372549, g: 0.984313725490196, b: 0.596078431372549},
        {name: 'darkgreen',       r: 0, g: 0.39215686274509803, b: 0},
        {name: 'green',         r: 0, g: 0.5019607843137255, b: 0},
        {name: 'lime',          r: 0, g: 1, b: 0},
        {name: 'honeydew',        r: 0.9411764705882353, g: 1, b: 0.9411764705882353},
        {name: 'mediumseagreen',    r: 0.23529411764705882, g: 0.7019607843137254, b: 0.44313725490196076},
        {name: 'seagreen',        r: 0.1803921568627451, g: 0.5450980392156862, b: 0.3411764705882353},
        {name: 'springgreen',     r: 0, g: 1, b: 0.4980392156862745},
        {name: 'mintcream',       r: 0.9607843137254902, g: 1, b: 0.9803921568627451},
        {name: 'mediumspringgreen',   r: 0, g: 0.9803921568627451, b: 0.6039215686274509},
        {name: 'mediumaquamarine',    r: 0.4, g: 0.803921568627451, b: 0.6666666666666666},
        {name: 'aquamarine',      r: 0.4980392156862745, g: 1, b: 0.8313725490196079},
        {name: 'turquoise',       r: 0.25098039215686274, g: 0.8784313725490196, b: 0.8156862745098039},
        {name: 'lightseagreen',     r: 0.12549019607843137, g: 0.6980392156862745, b: 0.6666666666666666},
        {name: 'mediumturquoise',   r: 0.2823529411764706, g: 0.8196078431372549, b: 0.8},
        {name: 'darkslategray',     r: 0.1843137254901961, g: 0.30980392156862746, b: 0.30980392156862746},
        {name: 'paleturquoise',     r: 0.6862745098039216, g: 0.9333333333333333, b: 0.9333333333333333},
        {name: 'teal',          r: 0, g: 0.5019607843137255, b: 0.5019607843137255},
        {name: 'darkcyan',        r: 0, g: 0.5450980392156862, b: 0.5450980392156862},
        {name: 'darkturquoise',     r: 0, g: 0.807843137254902, b: 0.8196078431372549},
        {name: 'aqua',          r: 0, g: 1, b: 1},
        {name: 'cyan',          r: 0, g: 1, b: 1},
        {name: 'lightcyan',       r: 0.8784313725490196, g: 1, b: 1},
        {name: 'azure',         r: 0.9411764705882353, g: 1, b: 1},
        {name: 'cadetblue',       r: 0.37254901960784315, g: 0.6196078431372549, b: 0.6274509803921569},
        {name: 'powderblue',      r: 0.6901960784313725, g: 0.8784313725490196, b: 0.9019607843137255},
        {name: 'lightblue',       r: 0.6784313725490196, g: 0.8470588235294118, b: 0.9019607843137255},
        {name: 'deepskyblue',     r: 0, g: 0.7490196078431373, b: 1},
        {name: 'skyblue',       r: 0.5294117647058824, g: 0.807843137254902, b: 0.9215686274509803},
        {name: 'lightskyblue',      r: 0.5294117647058824, g: 0.807843137254902, b: 0.9803921568627451},
        {name: 'steelblue',       r: 0.27450980392156865, g: 0.5098039215686274, b: 0.7058823529411765},
        {name: 'aliceblue',       r: 0.9411764705882353, g: 0.9725490196078431, b: 1},
        {name: 'dodgerblue',      r: 0.11764705882352941, g: 0.5647058823529412, b: 1},
        {name: 'slategray',       r: 0.4392156862745098, g: 0.5019607843137255, b: 0.5647058823529412},
        {name: 'lightslategray',    r: 0.4666666666666667, g: 0.5333333333333333, b: 0.6},
        {name: 'lightsteelblue',    r: 0.6901960784313725, g: 0.7686274509803922, b: 0.8705882352941177},
        {name: 'cornflowerblue',    r: 0.39215686274509803, g: 0.5843137254901961, b: 0.9294117647058824},
        {name: 'royalblue',       r: 0.2549019607843137, g: 0.4117647058823529, b: 0.8823529411764706},
        {name: 'midnightblue',      r: 0.09803921568627451, g: 0.09803921568627451, b: 0.4392156862745098},
        {name: 'lavender',        r: 0.9019607843137255, g: 0.9019607843137255, b: 0.9803921568627451},
        {name: 'navy',          r: 0, g: 0, b: 0.5019607843137255},
        {name: 'darkblue',        r: 0, g: 0, b: 0.5450980392156862},
        {name: 'mediumblue',      r: 0, g: 0, b: 0.803921568627451},
        {name: 'blue',          r: 0, g: 0, b: 1},
        {name: 'ghostwhite',      r: 0.9725490196078431, g: 0.9725490196078431, b: 1},
        {name: 'darkslateblue',     r: 0.2823529411764706, g: 0.23921568627450981, b: 0.5450980392156862},
        {name: 'slateblue',       r: 0.41568627450980394, g: 0.35294117647058826, b: 0.803921568627451},
        {name: 'mediumslateblue',   r: 0.4823529411764706, g: 0.40784313725490196, b: 0.9333333333333333},
        {name: 'mediumpurple',      r: 0.5764705882352941, g: 0.4392156862745098, b: 0.8588235294117647},
        {name: 'blueviolet',      r: 0.5411764705882353, g: 0.16862745098039217, b: 0.8862745098039215},
        {name: 'indigo',        r: 0.29411764705882354, g: 0, b: 0.5098039215686274},
        {name: 'darkorchid',      r: 0.6, g: 0.19607843137254902, b: 0.8},
        {name: 'darkviolet',      r: 0.5803921568627451, g: 0, b: 0.8274509803921568},
        {name: 'mediumorchid',      r: 0.7294117647058823, g: 0.3333333333333333, b: 0.8274509803921568},
        {name: 'thistle',       r: 0.8470588235294118, g: 0.7490196078431373, b: 0.8470588235294118},
        {name: 'plum',          r: 0.8666666666666667, g: 0.6274509803921569, b: 0.8666666666666667},
        {name: 'violet',        r: 0.9333333333333333, g: 0.5098039215686274, b: 0.9333333333333333},
        {name: 'purple',        r: 0.5019607843137255, g: 0, b: 0.5019607843137255},
        {name: 'darkmagenta',     r: 0.5450980392156862, g: 0, b: 0.5450980392156862},
        {name: 'magenta',       r: 1, g: 0, b: 1},
        {name: 'fuchsia',       r: 1, g: 0, b: 1},
        {name: 'orchid',        r: 0.8549019607843137, g: 0.4392156862745098, b: 0.8392156862745098},
        {name: 'mediumvioletred',   r: 0.7803921568627451, g: 0.08235294117647059, b: 0.5215686274509804},
        {name: 'deeppink',        r: 1, g: 0.0784313725490196, b: 0.5764705882352941},
        {name: 'hotpink',       r: 1, g: 0.4117647058823529, b: 0.7058823529411765},
        {name: 'palevioletred',     r: 0.8588235294117647, g: 0.4392156862745098, b: 0.5764705882352941},
        {name: 'lavenderblush',     r: 1, g: 0.9411764705882353, b: 0.9607843137254902},
        {name: 'crimson',       r: 0.8627450980392157, g: 0.0784313725490196, b: 0.23529411764705882},
        {name: 'pink',          r: 1, g: 0.7529411764705882, b: 0.796078431372549},
        {name: 'lightpink',       r: 1, g: 0.7137254901960784, b: 0.7568627450980392}
      ]
    };

    this.writers = {
      '#HEX':   function(color, that) {
        return that._formatColor('#rxgxbx', color);
      }
      , '#HEX3':  function(color, that) {
        var hex3 = $.colorpicker.writers.HEX3(color);
        return hex3 === false? false : '#'+hex3;
      }
      , 'HEX':    function(color, that) {
        return that._formatColor('rxgxbx', color);
      }
      , 'HEX3':   function(color, that) {
        var rgb = color.getRGB(),
          r = Math.round(rgb.r * 255),
          g = Math.round(rgb.g * 255),
          b = Math.round(rgb.b * 255);

        if (((r >>> 4) === (r &= 0xf))
               && ((g >>> 4) === (g &= 0xf))
               && ((b >>> 4) === (b &= 0xf))) {
          return r.toString(16)+g.toString(16)+b.toString(16);
        }
        return false;
      }
      , '#HEXA':  function(color, that) {
        return that._formatColor('#rxgxbxax', color);
      }
      , '#HEXA4': function(color, that) {
        var hexa4 = $.colorpicker.writers.HEXA4(color, that);
        return hexa4 === false? false : '#'+hexa4;
      }
      , 'HEXA': function(color, that) {
        return that._formatColor('rxgxbxax', color);
      }
      , 'HEXA4':    function(color, that) {
        var a = Math.round(color.getAlpha() * 255);

        if ((a >>> 4) === (a &= 0xf)) {
          return $.colorpicker.writers.HEX3(color, that)+a.toString(16);
        }
        return false;
      }
      , 'RGB':    function(color, that) {
        return color.getAlpha() >= 1
          ? that._formatColor('rgb(rd,gd,bd)', color)
          : false;
      }
      , 'RGBA':   function(color, that) {
        return that._formatColor('rgba(rd,gd,bd,af)', color);
      }
      , 'RGB%':   function(color, that) {
        return color.getAlpha() >= 1
          ? that._formatColor('rgb(rp%,gp%,bp%)', color)
          : false;
      }
      , 'RGBA%':  function(color, that) {
        return that._formatColor('rgba(rp%,gp%,bp%,af)', color);
      }
      , 'HSL':    function(color, that) {
        return color.getAlpha() >= 1
          ? that._formatColor('hsl(hd,sd,vd)', color)
          : false;
      }
      , 'HSLA':   function(color, that) {
        return that._formatColor('hsla(hd,sd,vd,af)', color);
      }
      , 'HSL%':   function(color, that) {
        return color.getAlpha() >= 1
          ? that._formatColor('hsl(hp%,sp%,vp%)', color)
          : false;
      }
      , 'HSLA%':  function(color, that) {
        return that._formatColor('hsla(hp%,sp%,vp%,af)', color);
      }
      , 'NAME':   function(color, that) {
        return that._closestName(color);
      }
      , 'EXACT':  function(color, that) {
        return that._exactName(color);
      }
    };

    this.parsers = {
      '':     function(color) {
        if (color === '') {
          return new $.colorpicker.Color();
        }
      }
      , 'NAME':   function(color, that) {
        var c = that._getSwatch($.trim(color));
        if (c) {
          return new $.colorpicker.Color(c.r, c.g, c.b);
        }
      }
      , 'RGBA':   function(color) {
        var m = /^rgba?\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*(?:,\s*(\d+(?:\.\d+)?)\s*)?\)$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            m[1] / 255,
            m[2] / 255,
            m[3] / 255,
            parseFloat(m[4])
          );
        }
      }
      , 'RGBA%':  function(color) {
        var m = /^rgba?\(\s*(\d+(?:\.\d+)?)\%\s*,\s*(\d+(?:\.\d+)?)\%\s*,\s*(\d+(?:\.\d+)?)\%\s*(?:,\s*(\d+(?:\.\d+)?)\s*)?\)$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            m[1] / 100,
            m[2] / 100,
            m[3] / 100,
            m[4] / 100
          );
        }
      }
      , 'HSLA': function(color) {
        var m = /^hsla?\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*(?:,\s*(\d+(?:\.\d+)?)\s*)?\)$/.exec(color);
        if (m) {
          return (new $.colorpicker.Color()).setHSL(
            m[1] / 255,
            m[2] / 255,
            m[3] / 255).setAlpha(parseFloat(m[4]));
        }
      }
      , 'HSLA%': function(color) {
        var m = /^hsla?\(\s*(\d+(?:\.\d+)?)\%\s*,\s*(\d+(?:\.\d+)?)\%\s*,\s*(\d+(?:\.\d+)?)\%\s*(?:,\s*(\d+(?:\.\d+)?)\s*)?\)$/.exec(color);
        if (m) {
          return (new $.colorpicker.Color()).setHSL(
            m[1] / 100,
            m[2] / 100,
            m[3] / 100).setAlpha(m[4] / 100);
        }
      }
      , '#HEX': function(color) {
        var m = /^#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(m[1], 16) / 255,
            parseInt(m[2], 16) / 255,
            parseInt(m[3], 16) / 255
          );
        }
      }
      , '#HEX3': function(color) {
        var m = /^#([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(String(m[1]) + m[1], 16) / 255,
            parseInt(String(m[2]) + m[2], 16) / 255,
            parseInt(String(m[3]) + m[3], 16) / 255
          );
        }
      }
      , 'HEX': function(color) {
        var m = /^([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(m[1], 16) / 255,
            parseInt(m[2], 16) / 255,
            parseInt(m[3], 16) / 255
          );
        }
      }
      , 'HEX3': function(color) {
        var m = /^([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(String(m[1]) + m[1], 16) / 255,
            parseInt(String(m[2]) + m[2], 16) / 255,
            parseInt(String(m[3]) + m[3], 16) / 255
          );
        }
      }
      , '#HEXA': function(color) {
        var m = /^#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(m[1], 16) / 255,
            parseInt(m[2], 16) / 255,
            parseInt(m[3], 16) / 255,
            parseInt(m[4], 16) / 255
          );
        }
      }
      , '#HEXA4': function(color) {
        var m = /^#([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(String(m[1]) + m[1], 16) / 255,
            parseInt(String(m[2]) + m[2], 16) / 255,
            parseInt(String(m[3]) + m[3], 16) / 255,
            parseInt(String(m[4]) + m[4], 16) / 255
          );
        }
      }
      , 'HEXA': function(color) {
        var m = /^([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(m[1], 16) / 255,
            parseInt(m[2], 16) / 255,
            parseInt(m[3], 16) / 255,
            parseInt(m[4], 16) / 255
          );
        }
      }
      , 'HEXA4': function(color) {
        var m = /^([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])$/.exec(color);
        if (m) {
          return new $.colorpicker.Color(
            parseInt(String(m[1]) + m[1], 16) / 255,
            parseInt(String(m[2]) + m[2], 16) / 255,
            parseInt(String(m[3]) + m[3], 16) / 255,
            parseInt(String(m[4]) + m[4], 16) / 255
          );
        }
      }
    };

    this.partslists = {
      'full': ['header', 'map', 'bar', 'hex', 'hsv', 'rgb', 'alpha', 'lab', 'cmyk', 'preview', 'swatches', 'footer'],
      'popup': ['map', 'bar', 'hex', 'hsv', 'rgb', 'alpha', 'preview', 'footer'],
      'draggable': ['header', 'map', 'bar', 'hex', 'hsv', 'rgb', 'alpha', 'preview', 'footer'],
      'inline': ['map', 'bar', 'hex', 'hsv', 'rgb', 'alpha', 'preview']
    };

    this.limits = {
      'websafe': function(color) {
        color.limit(6);
      },
      'nibble': function(color) {
        color.limit(16);
      },
      'binary': function(color) {
        color.limit(2);
      },
      'name': function(color, that) {
        var swatch = that._getSwatch(that._closestName(color));
        color.setRGB(swatch.r, swatch.g, swatch.b);
      }
    };

    this.parts = {
      header: function (inst) {
        var that = this,
          part = null,
          _html  = function() {
            var title = inst.options.title || inst._getRegional('title'),
              html = '<span class="ui-dialog-title">' + title + '</span>';

            if (!inst.inline && inst.options.showCloseButton) {
              html += '<a href="#" class="ui-dialog-titlebar-close ui-corner-all" role="button">'
                + '<span class="ui-icon ui-icon-closethick">close</span></a>';
            }

            return '<div class="ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix">' + html + '</div>';
          },
          _onclick = function(event) {
            event.preventDefault();
            inst.close(inst.options.revert);
          };

        this.init = function() {
          part = $(_html()).prependTo(inst.dialog);

          var close = $('.ui-dialog-titlebar-close', part);
          inst._hoverable(close);
          inst._focusable(close);
          close.on('click', _onclick);

          if (!inst.inline && inst.options.draggable) {
            var draggableOptions = {
              handle: part,
            };
            if (inst.options.containment) {
              draggableOptions.containment = inst.options.containment;
            }
            inst.dialog.draggable(draggableOptions);
          }
        };

        this.disable = function (disable) {
          $('.ui-dialog-titlebar-close', part)[disable ? 'off' : 'on']('click', _onclick);
        };
      },

      map: function (inst) {
        var that = this,
          part = null,
          pointer, width, height, layers = {},
          _mousedown, _mouseup, _mousemove, _keydown, _html;

        _mousedown = function (event) {
          if (!inst.opened) {
            return;
          }

          var offset = layers.p.offset(),
            x = event.pageX - offset.left,
            y = event.pageY - offset.top;

          if (x >= 0 && x < width && y >= 0 && y < height) {
            event.stopImmediatePropagation();
            event.preventDefault();
            part.off('mousedown', _mousedown).focus();
            $(document).on('mouseup', _mouseup);
            $(document).on('mousemove', _mousemove);
            _mousemove(event);
          }
        };

        _mouseup = function (event) {
          event.stopImmediatePropagation();
          event.preventDefault();
          $(document).off('mouseup', _mouseup);
          $(document).off('mousemove', _mousemove);
          part.on('mousedown', _mousedown);

          inst._callback('stop');
        };

        _mousemove = function (event) {
          event.stopImmediatePropagation();
          event.preventDefault();

          if (event.pageX === that.x && event.pageY === that.y) {
            return;
          }
          that.x = event.pageX;
          that.y = event.pageY;

          var offset = layers.p.offset(),
            x = event.pageX - offset.left,
            y = event.pageY - offset.top;

          x = Math.max(0, Math.min(x / width, 1));
          y = Math.max(0, Math.min(y / height, 1));

          // interpret values
          switch (inst.mode) {
          case 'h':
            inst.color.setHSV(null, x, 1 - y);
            break;

          case 's':
          case 'a':
            inst.color.setHSV(x, null, 1 - y);
            break;

          case 'v':
            inst.color.setHSV(x, 1 - y, null);
            break;

          case 'r':
            inst.color.setRGB(null, 1 - y, x);
            break;

          case 'g':
            inst.color.setRGB(1 - y, null, x);
            break;

          case 'b':
            inst.color.setRGB(x, 1 - y, null);
            break;
          }

          inst._change(false);
        };

        _keydown = function(event) {
          var x_channel_map = {
              'h': 's',
              's': 'h',
              'v': 'h',
              'r': 'b',
              'g': 'b',
              'b': 'r',
              'a': 'h'
            },
            x_change = {
              37: -1,
              39: 1,
            },
            y_channel_map = {
              'h': 'v',
              's': 'v',
              'v': 's',
              'r': 'g',
              'g': 'r',
              'b': 'g',
              'a': 'v'
            },
            y_change = {
              38: 1,
              40: -1
            },
            set = {
              35: 0,
              36: 1
            },
            change, value;

          if (typeof x_change[event.which] !== 'undefined') {
            value = inst.color.getChannel(x_channel_map[inst.mode]) * width;
            change = x_change[event.which];
            if (event.shiftKey) {
              change *= 10;
            } else if (event.ctrlKey || event.metaKey) {
              change *= width;
            }
            inst.color.setChannel(x_channel_map[inst.mode], (value + change) / width);
            inst._change(false);
          } else if (typeof y_change[event.which] !== 'undefined') {
            value = inst.color.getChannel(y_channel_map[inst.mode]) * height;
            change = y_change[event.which];
            if (event.shiftKey) {
              change *= 10;
            } else if (event.ctrlKey || event.metaKey) {
              change *= height;
            }
            inst.color.setChannel(y_channel_map[inst.mode], (value + change) / height);
            inst._change(false);
          } else if (typeof set[event.which] !== 'undefined') {
            inst.color.setChannel(x_channel_map[inst.mode], 1 - set[event.which]);
            inst.color.setChannel(y_channel_map[inst.mode], set[event.which]);
            inst._change(false);
          }
        };

        _html = function () {
          var html = '<div class="ui-colorpicker-map ui-colorpicker-map-'+(inst.options.part.map.size || 256)+' ui-colorpicker-border" taonex="0">'
            + '<span class="ui-colorpicker-map-layer-1">&nbsp;</span>'
            + '<span class="ui-colorpicker-map-layer-2">&nbsp;</span>'
            + (inst.options.alpha ? '<span class="ui-colorpicker-map-layer-alpha">&nbsp;</span>' : '')
            + '<span class="ui-colorpicker-map-layer-pointer"><span class="ui-colorpicker-map-pointer"></span></span></div>';
          return html;
        };

        this.init = function () {
          part = $(_html()).appendTo($('.ui-colorpicker-map-container', inst.dialog));

          part.on('mousedown', _mousedown);
          part.on('keydown', _keydown);

          // cache
          layers[1] = $('.ui-colorpicker-map-layer-1', part);
          layers[2] = $('.ui-colorpicker-map-layer-2', part);
          layers.a = $('.ui-colorpicker-map-layer-alpha', part);
          layers.p = $('.ui-colorpicker-map-layer-pointer', part);
          width = layers.p.width();
          height = layers.p.height();

          pointer = $('.ui-colorpicker-map-pointer', part);
        };

        this.update = function () {
          var step = ((inst.options.part.map.size || 256) * 65 / 64);

          switch (inst.mode) {
          case 'h':
            layers[1].css({'background-position': '0 0', 'opacity': ''}).show();
            layers[2].hide();
            break;

          case 's':
          case 'a':
            layers[1].css({'background-position': '0 ' + (-step) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 2) + 'px', 'opacity': ''}).show();
            break;

          case 'v':
            part.css('background-color', 'black');
            layers[1].css({'background-position': '0 ' + (-step * 3) + 'px', 'opacity': ''}).show();
            layers[2].hide();
            break;

          case 'r':
            layers[1].css({'background-position': '0 ' + (-step * 4) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 5) + 'px', 'opacity': ''}).show();
            break;

          case 'g':
            layers[1].css({'background-position': '0 ' + (-step * 6) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 7) + 'px', 'opacity': ''}).show();
            break;

          case 'b':
            layers[1].css({'background-position': '0 ' + (-step * 8) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 9) + 'px', 'opacity': ''}).show();
            break;
          }

          that.repaint();
        };

        this.repaint = function () {
          var x = 0,
            y = 0;

          switch (inst.mode) {
          case 'h':
            var hsv = inst.color.getHSV();
            x = hsv.s * width;
            y = (1 - hsv.v) * width;
            part.css('background-color', inst.color.copy().setHSV(null, 1, 1).toCSS());
            break;

          case 's':
          case 'a':
            var hsv = inst.color.getHSV();
            x = hsv.h * width;
            y = (1 - hsv.v) * width;
            layers[2].css('opacity', 1 - hsv.s);
            break;

          case 'v':
            var hsv = inst.color.getHSV();
            x = hsv.h * width;
            y = (1 - hsv.s) * width;
            layers[1].css('opacity', hsv.v);
            break;

          case 'r':
            var rgb = inst.color.getRGB();
            x = rgb.b * width;
            y = (1 - rgb.g) * width;
            layers[2].css('opacity', rgb.r);
            break;

          case 'g':
            var rgb = inst.color.getRGB();
            x = rgb.b * width;
            y = (1 - rgb.r) * width;
            layers[2].css('opacity', rgb.g);
            break;

          case 'b':
            var rgb = inst.color.getRGB();
            x = rgb.r * width;
            y = (1 - rgb.g) * width;
            layers[2].css('opacity', rgb.b);
            break;
          }

          if (inst.options.alpha) {
            layers.a.css('opacity', 1 - inst.color.getAlpha());
          }

          pointer.css({
            'left': x - 7,
            'top': y - 7
          });
        };

        this.disable = function (disable) {
          part[disable ? 'off' : 'on']('mousedown', _mousedown);
          part[disable ? 'off' : 'on']('keydown', _keydown);
        };
      },

      bar: function (inst) {
        var that = this,
          part = null,
          pointer, width, height, layers = {},
          _mousedown, _mouseup, _mousemove, _keydown, _html;

        _mousedown = function (event) {
          if (!inst.opened) {
            return;
          }

          var offset = layers.p.offset(),
            x = event.pageX - offset.left,
            y = event.pageY - offset.top;

          if (x >= 0 && x < width && y >= 0 && y < height) {
            event.stopImmediatePropagation();
            event.preventDefault();
            part.off('mousedown', _mousedown).focus();
            $(document).on('mouseup', _mouseup);
            $(document).on('mousemove', _mousemove);
            _mousemove(event);
          }
        };

        _mouseup = function (event) {
          event.stopImmediatePropagation();
          event.preventDefault();
          $(document).off('mouseup', _mouseup);
          $(document).off('mousemove', _mousemove);
          part.on('mousedown', _mousedown);

          inst._callback('stop');
        };

        _mousemove = function (event) {
          event.stopImmediatePropagation();
          event.preventDefault();

          if (event.pageY === that.y) {
            return;
          }
          that.y = event.pageY;

          var offset  = layers.p.offset(),
            y = event.pageY - offset.top;

          y = Math.max(0, Math.min(y / height, 1));

          // interpret values
          switch (inst.mode) {
          case 'h':
            inst.color.setHSV(1 - y, null, null);
            break;

          case 's':
            inst.color.setHSV(null, 1 - y, null);
            break;

          case 'v':
            inst.color.setHSV(null, null, 1 - y);
            break;

          case 'r':
            inst.color.setRGB(1 - y, null, null);
            break;

          case 'g':
            inst.color.setRGB(null, 1 - y, null);
            break;

          case 'b':
            inst.color.setRGB(null, null, 1 - y);
            break;

          case 'a':
            inst.color.setAlpha(1 - y);
            break;
          }

          inst._change(false);
        };

        _keydown = function(event) {
          var change = {
              38: 1,
              40: -1,
              33: 10,
              34: -10
            },
            set = {
              35: 0,
              36: 1
            },
            change, value;

          if (typeof change[event.which] !== 'undefined') {
            value = inst.color.getChannel(inst.mode) * height;
            change = change[event.which];
            if (event.shiftKey) {
              change *= 10;
            } else if (event.ctrlKey || event.metaKey) {
              change *= height;
            }
            inst.color.setChannel(inst.mode, (value + change) / height);
            inst._change(false);
          } else if (typeof set[event.which] !== 'undefined') {
            inst.color.setChannel(inst.mode, set[event.which]);
            inst._change(false);
          }
        };

        _html = function () {
          var html = '<div class="ui-colorpicker-bar ui-colorpicker-bar-'+(inst.options.part.bar.size || 256)+'  ui-colorpicker-border" taonex="0">'
            + '<span class="ui-colorpicker-bar-layer-1">&nbsp;</span>'
            + '<span class="ui-colorpicker-bar-layer-2">&nbsp;</span>'
            + '<span class="ui-colorpicker-bar-layer-3">&nbsp;</span>'
            + '<span class="ui-colorpicker-bar-layer-4">&nbsp;</span>';

          if (inst.options.alpha) {
            html += '<span class="ui-colorpicker-bar-layer-alpha">&nbsp;</span>'
              + '<span class="ui-colorpicker-bar-layer-alphabar">&nbsp;</span>';
          }

          html += '<span class="ui-colorpicker-bar-layer-pointer"><span class="ui-colorpicker-bar-pointer"></span></span></div>';

          return html;
        };

        this.init = function () {
          part = $(_html()).appendTo($('.ui-colorpicker-bar-container', inst.dialog));

          part.on('mousedown', _mousedown);
          part.on('keydown', _keydown);

          // cache
          layers[1] = $('.ui-colorpicker-bar-layer-1', part);
          layers[2] = $('.ui-colorpicker-bar-layer-2', part);
          layers[3] = $('.ui-colorpicker-bar-layer-3', part);
          layers[4] = $('.ui-colorpicker-bar-layer-4', part);
          layers.a = $('.ui-colorpicker-bar-layer-alpha', part);
          layers.ab = $('.ui-colorpicker-bar-layer-alphabar', part);
          layers.p = $('.ui-colorpicker-bar-layer-pointer', part);
          width = layers.p.width();
          height = layers.p.height();

          pointer = $('.ui-colorpicker-bar-pointer', part);
        };

        this.update = function () {
          var step = ((inst.options.part.bar.size || 256) * 65 / 64);

          switch (inst.mode) {
          case 'h':
          case 's':
          case 'v':
          case 'r':
          case 'g':
          case 'b':
            layers.a.show();
            layers.ab.hide();
            break;

          case 'a':
            layers.a.hide();
            layers.ab.show();
            break;
          }

          switch (inst.mode) {
          case 'h':
            layers[1].css({'background-position': '0 0', 'opacity': ''}).show();
            layers[2].hide();
            layers[3].hide();
            layers[4].hide();
            break;

          case 's':
            layers[1].css({'background-position': '0 ' + (-step) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 2) + 'px', 'opacity': ''}).show();
            layers[3].hide();
            layers[4].hide();
            break;

          case 'v':
            layers[1].css({'background-position': '0 ' + (-step * 2) + 'px', 'opacity': ''}).show();
            layers[2].hide();
            layers[3].hide();
            layers[4].hide();
            break;

          case 'r':
            layers[1].css({'background-position': '0 ' + (-step * 6) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 5) + 'px', 'opacity': ''}).show();
            layers[3].css({'background-position': '0 ' + (-step * 3) + 'px', 'opacity': ''}).show();
            layers[4].css({'background-position': '0 ' + (-step * 4) + 'px', 'opacity': ''}).show();
            break;

          case 'g':
            layers[1].css({'background-position': '0 ' + (-step * 10) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 9) + 'px', 'opacity': ''}).show();
            layers[3].css({'background-position': '0 ' + (-step * 7) + 'px', 'opacity': ''}).show();
            layers[4].css({'background-position': '0 ' + (-step * 8) + 'px', 'opacity': ''}).show();
            break;

          case 'b':
            layers[1].css({'background-position': '0 ' + (-step * 14) + 'px', 'opacity': ''}).show();
            layers[2].css({'background-position': '0 ' + (-step * 13) + 'px', 'opacity': ''}).show();
            layers[3].css({'background-position': '0 ' + (-step * 11) + 'px', 'opacity': ''}).show();
            layers[4].css({'background-position': '0 ' + (-step * 12) + 'px', 'opacity': ''}).show();
            break;

          case 'a':
            layers[1].hide();
            layers[2].hide();
            layers[3].hide();
            layers[4].hide();
            break;
          }

          that.repaint();
        };

        this.repaint = function () {
          var y = 0;

          switch (inst.mode) {
          case 'h':
            y = (1 - inst.color.getHSV().h) * height;
            break;

          case 's':
            var hsv = inst.color.getHSV();
            y = (1 - hsv.s) * height;
            layers[2].css('opacity', 1 - hsv.v);
            part.css('background-color', inst.color.copy().setHSV(null, 1, null).toCSS());
            break;

          case 'v':
            y = (1 - inst.color.getHSV().v) * height;
            part.css('background-color', inst.color.copy().setHSV(null, null, 1).toCSS());
            break;

          case 'r':
            var rgb = inst.color.getRGB();
            y = (1 - rgb.r) * height;
            layers[2].css('opacity', Math.max(0, (rgb.b - rgb.g)));
            layers[3].css('opacity', Math.max(0, (rgb.g - rgb.b)));
            layers[4].css('opacity', Math.min(rgb.b, rgb.g));
            break;

          case 'g':
            var rgb = inst.color.getRGB();
            y = (1 - rgb.g) * height;
            layers[2].css('opacity', Math.max(0, (rgb.b - rgb.r)));
            layers[3].css('opacity', Math.max(0, (rgb.r - rgb.b)));
            layers[4].css('opacity', Math.min(rgb.r, rgb.b));
            break;

          case 'b':
            var rgb = inst.color.getRGB();
            y = (1 - rgb.b) * height;
            layers[2].css('opacity', Math.max(0, (rgb.r - rgb.g)));
            layers[3].css('opacity', Math.max(0, (rgb.g - rgb.r)));
            layers[4].css('opacity', Math.min(rgb.r, rgb.g));
            break;

          case 'a':
            y = (1 - inst.color.getAlpha()) * height;
            part.css('background-color', inst.color.copy().toCSS());
            break;
          }

          if (inst.mode !== 'a') {
            layers.a.css('opacity', 1 - inst.color.getAlpha());
          }

          pointer.css('top', y - 3);
        };

        this.disable = function (disable) {
          part[disable ? 'off' : 'on']('mousedown', _mousedown);
          part[disable ? 'off' : 'on']('keydown', _keydown);
        };
      },

      preview: function (inst) {
        var that = this,
          part = null,
          both,
          initial, initial_alpha,
          current, current_alpha,
          _html,
          onclick = function () {
            inst.color = inst.currentColor.copy();
            inst._change();
          };

        _html = function () {
          return '<div class="ui-colorpicker-preview ui-colorpicker-border">'
            + '<div class="ui-colorpicker-preview-initial"><div class="ui-colorpicker-preview-initial-alpha"></div></div>'
            + '<div class="ui-colorpicker-preview-current"><div class="ui-colorpicker-preview-current-alpha"></div></div>'
            + '</div>';
        };

        this.init = function () {
          part = $(_html()).appendTo($('.ui-colorpicker-preview-container', inst.dialog));

          $('.ui-colorpicker-preview-initial', part).on('click', onclick);

          // cache
          initial = $('.ui-colorpicker-preview-initial', part);
          initial_alpha = $('.ui-colorpicker-preview-initial-alpha', part);
          current  = $('.ui-colorpicker-preview-current', part);
          current_alpha = $('.ui-colorpicker-preview-current-alpha', part);
          both = $('.ui-colorpicker-preview-initial-alpha, .ui-colorpicker-preview-current-alpha', part);
        };

        this.update = function () {
          both[inst.options.alpha ? 'show' : 'hide']();

          this.repaint();
        };

        this.repaint = function () {
          initial.css('background-color', inst.currentColor.set ? inst.currentColor.toCSS() : '').attr('title', inst.currentColor.set ? inst.currentColor.toCSS() : '');
          initial_alpha.css('opacity', 1 - inst.currentColor.getAlpha());
          current.css('background-color', inst.color.set ? inst.color.toCSS() : '').attr('title', inst.color.set ? inst.color.toCSS() : '');
          current_alpha.css('opacity', 1 - inst.color.getAlpha());
        };

        this.disable = function (disable) {
          $('.ui-colorpicker-preview-initial', part)[disable ? 'off' : 'on']('click', onclick);
        };
      },

      hsv: function (inst) {
        var that = this,
          part = null,
          inputs = {},
          _html;

        _html = function () {
          var html = '';

          if (inst.options.hsv) {
            html += '<div class="ui-colorpicker-hsv-h"><input class="ui-colorpicker-mode" type="radio" value="h"/><label>'
              + inst._getRegional('hsvH')
              + '</label><input class="ui-colorpicker-number" type="number" min="0" max="360" size="10"/><span class="ui-colorpicker-unit">&deg;</span></div>'
              + '<div class="ui-colorpicker-hsv-s"><input class="ui-colorpicker-mode" type="radio" value="s"/><label>'
              + inst._getRegional('hsvS')
              + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100" size="10"/><span class="ui-colorpicker-unit">%</span></div>'
              + '<div class="ui-colorpicker-hsv-v"><input class="ui-colorpicker-mode" type="radio" value="v"/><label>'
              + inst._getRegional('hsvV')
              + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100" size="10"/><span class="ui-colorpicker-unit">%</span></div>';
          }

          return '<div class="ui-colorpicker-hsv">' + html + '</div>';
        };

        this.init = function () {
          part = $(_html()).appendTo($('.ui-colorpicker-hsv-container', inst.dialog));

          $('.ui-colorpicker-mode', part).click(function () {
            inst.mode = $(this).val();
            inst._updateAllParts();
          });

          inputs.h = $('.ui-colorpicker-hsv-h .ui-colorpicker-number', part);
          inputs.s = $('.ui-colorpicker-hsv-s .ui-colorpicker-number', part);
          inputs.v = $('.ui-colorpicker-hsv-v .ui-colorpicker-number', part);

          $('.ui-colorpicker-number', part).on('input change keyup', function () {
            inst.color.setHSV(
              inputs.h.val() / 360,
              inputs.s.val() / 100,
              inputs.v.val() / 100
            );
            inst._change();
          });
        };

        this.repaint = function () {
          var hsv = inst.color.getHSV();
          inputs.h.val(Math.round(hsv.h * 360));
          inputs.s.val(Math.round(hsv.s * 100));
          inputs.v.val(Math.round(hsv.v * 100));
        };

        this.update = function () {
          $('.ui-colorpicker-mode', part).each(function () {
            var $this = $(this);
            $this.prop('checked', $this.val() === inst.mode);
          });
          this.repaint();
        };

        this.disable = function (disable) {
          $(':input', part).prop('disabled', disable);
        };
      },

      rgb: function (inst) {
        var that = this,
          part = null,
          inputs = {},
          _html;

        _html = function () {
          var html = '';

          if (inst.options.rgb) {
            html += '<div class="ui-colorpicker-rgb-r"><input class="ui-colorpicker-mode" type="radio" value="r"/><label>' + inst._getRegional('rgbR') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="255"/></div>'
              + '<div class="ui-colorpicker-rgb-g"><input class="ui-colorpicker-mode" type="radio" value="g"/><label>' + inst._getRegional('rgbG') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="255"/></div>'
              + '<div class="ui-colorpicker-rgb-b"><input class="ui-colorpicker-mode" type="radio" value="b"/><label>' + inst._getRegional('rgbB') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="255"/></div>';
          }

          return '<div class="ui-colorpicker-rgb">' + html + '</div>';
        };

        this.init = function () {
          part = $(_html()).appendTo($('.ui-colorpicker-rgb-container', inst.dialog));

          $('.ui-colorpicker-mode', part).click(function () {
            inst.mode = $(this).val();
            inst._updateAllParts();
          });

          inputs.r = $('.ui-colorpicker-rgb-r .ui-colorpicker-number', part);
          inputs.g = $('.ui-colorpicker-rgb-g .ui-colorpicker-number', part);
          inputs.b = $('.ui-colorpicker-rgb-b .ui-colorpicker-number', part);

          $('.ui-colorpicker-number', part).on('input change keyup', function () {
            var r = $('.ui-colorpicker-rgb-r .ui-colorpicker-number', part).val();
            inst.color.setRGB(
              inputs.r.val() / 255,
              inputs.g.val() / 255,
              inputs.b.val() / 255
            );

            inst._change();
          });
        };

        this.repaint = function () {
          var rgb = inst.color.getRGB();
          inputs.r.val(Math.round(rgb.r * 255));
          inputs.g.val(Math.round(rgb.g * 255));
          inputs.b.val(Math.round(rgb.b * 255));
        };

        this.update = function () {
          $('.ui-colorpicker-mode', part).each(function () {
            var $this = $(this);
            $this.prop('checked', $this.val() === inst.mode);
          });
          this.repaint();
        };

        this.disable = function (disable) {
          $(':input', part).prop('disabled', disable);
        };
      },

      lab: function (inst) {
        var that = this,
          part = null,
          inputs = {},
          html = function () {
            var html = '';

            if (inst.options.hsv) {
              html += '<div class="ui-colorpicker-lab-l"><label>' + inst._getRegional('labL') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100"/></div>'
                + '<div class="ui-colorpicker-lab-a"><label>' + inst._getRegional('labA') + '</label><input class="ui-colorpicker-number" type="number" min="-128" max="127"/></div>'
                + '<div class="ui-colorpicker-lab-b"><label>' + inst._getRegional('labB') + '</label><input class="ui-colorpicker-number" type="number" min="-128" max="127"/></div>';
            }

            return '<div class="ui-colorpicker-lab">' + html + '</div>';
          };

        this.init = function () {
          var data = 0;

          part = $(html()).appendTo($('.ui-colorpicker-lab-container', inst.dialog));

          inputs.l = $('.ui-colorpicker-lab-l .ui-colorpicker-number', part);
          inputs.a = $('.ui-colorpicker-lab-a .ui-colorpicker-number', part);
          inputs.b = $('.ui-colorpicker-lab-b .ui-colorpicker-number', part);

          $('.ui-colorpicker-number', part).on('input change keyup', function (event) {
            inst.color.setLAB(
              parseInt(inputs.l.val(), 10) / 100,
              (parseInt(inputs.a.val(), 10) + 128) / 255,
              (parseInt(inputs.b.val(), 10) + 128) / 255
            );
            inst._change();
          });
        };

        this.repaint = function () {
          var lab = inst.color.getLAB();
          inputs.l.val(Math.round(lab.l * 100));
          inputs.a.val(Math.round(lab.a * 255) - 128);
          inputs.b.val(Math.round(lab.b * 255) - 128);
        };

        this.update = this.repaint;

        this.disable = function (disable) {
          $(':input', part).prop('disabled', disable);
        };
      },

      cmyk: function (inst) {
        var that = this,
          part = null,
          inputs = {},
          html = function () {
            var html = '';

            if (inst.options.hsv) {
              html += '<div class="ui-colorpicker-cmyk-c"><label>' + inst._getRegional('cmykC') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100"/><span class="ui-colorpicker-unit">%</span></div>'
                + '<div class="ui-colorpicker-cmyk-m"><label>' + inst._getRegional('cmykM') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100"/><span class="ui-colorpicker-unit">%</span></div>'
                + '<div class="ui-colorpicker-cmyk-y"><label>' + inst._getRegional('cmykY') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100"/><span class="ui-colorpicker-unit">%</span></div>'
                + '<div class="ui-colorpicker-cmyk-k"><label>' + inst._getRegional('cmykK') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100"/><span class="ui-colorpicker-unit">%</span></div>';
            }

            return '<div class="ui-colorpicker-cmyk">' + html + '</div>';
          };

        this.init = function () {
          part = $(html()).appendTo($('.ui-colorpicker-cmyk-container', inst.dialog));

          inputs.c = $('.ui-colorpicker-cmyk-c .ui-colorpicker-number', part);
          inputs.m = $('.ui-colorpicker-cmyk-m .ui-colorpicker-number', part);
          inputs.y = $('.ui-colorpicker-cmyk-y .ui-colorpicker-number', part);
          inputs.k = $('.ui-colorpicker-cmyk-k .ui-colorpicker-number', part);

          $('.ui-colorpicker-number', part).on('input change keyup', function (event) {
            inst.color.setCMYK(
              parseInt(inputs.c.val(), 10) / 100,
              parseInt(inputs.m.val(), 10) / 100,
              parseInt(inputs.y.val(), 10) / 100,
              parseInt(inputs.k.val(), 10) / 100
            );
            inst._change();
          });
        };

        this.repaint = function () {
          var cmyk = inst.color.getCMYK();
          inputs.c.val(Math.round(cmyk.c * 100));
          inputs.m.val(Math.round(cmyk.m * 100));
          inputs.y.val(Math.round(cmyk.y * 100));
          inputs.k.val(Math.round(cmyk.k * 100));
        };

        this.update = this.repaint;

        this.disable = function (disable) {
          $(':input', part).prop('disabled', disable);
        };
      },

      alpha: function (inst) {
        var that = this,
          part = null,
          input,
          html = function () {
            var html = '';

            if (inst.options.alpha) {
              html += '<div class="ui-colorpicker-a"><input class="ui-colorpicker-mode" name="mode" type="radio" value="a"/><label>' + inst._getRegional('alphaA') + '</label><input class="ui-colorpicker-number" type="number" min="0" max="100"/><span class="ui-colorpicker-unit">%</span></div>';
            }

            return '<div class="ui-colorpicker-alpha">' + html + '</div>';
          };

        this.init = function () {
          part = $(html()).appendTo($('.ui-colorpicker-alpha-container', inst.dialog));

          $('.ui-colorpicker-mode', part).click(function () {
            inst.mode = $(this).val();
            inst._updateAllParts();
          });

          input = $('.ui-colorpicker-a .ui-colorpicker-number', part);

          $('.ui-colorpicker-number', part).on('input change keyup', function () {
            inst.color.setAlpha(input.val() / 100);
            inst._change();
          });
        };

        this.update = function () {
          $('.ui-colorpicker-mode', part).each(function () {
            $(this).prop('checked', $(this).val() === inst.mode);
          });
          this.repaint();
        };

        this.repaint = function () {
          input.val(Math.round(inst.color.getAlpha() * 100));
        };

        this.disable = function (disable) {
          $(':input', part).prop('disabled', disable);
        };
      },

      hex: function (inst) {
        var that = this,
          part = null,
          inputs = {},
          parseHex = function(color) {
            var c,
              m;

            // {#}rgb
            m = /^#?([a-fA-F0-9]{1,3})$/.exec(color);
            if (m) {
              c = parseInt(m[1], 16);
              return new $.colorpicker.Color(
                ((c >> 8) & 0xF) / 15,
                ((c >> 4) & 0xF) / 15,
                (c & 0xF) / 15
              );
            }

            // {#}rrggbb
            m = /^#?([a-fA-F0-9]{1,6})$/.exec(color);
            if (m) {
              c = parseInt(m[1], 16);
              return new $.colorpicker.Color(
                ((c >> 16) & 0xFF) / 255,
                ((c >>  8) & 0xFF) / 255,
                (c & 0xFF) / 255
              );
            }

            return new $.colorpicker.Color();
          },
          html = function () {
            var html = '';

            if (inst.options.alpha) {
              html += '<input class="ui-colorpicker-hex-alpha" type="text" maxlength="2" size="2"/>';
            }

            html += '<input class="ui-colorpicker-hex-input" type="text" maxlength="6" size="6"/>';

            return '<div class="ui-colorpicker-hex"><label>#</label>' + html + '</div>';
          };

        this.init = function () {
          part = $(html()).appendTo($('.ui-colorpicker-hex-container', inst.dialog));

          inputs.color = $('.ui-colorpicker-hex-input', part);
          inputs.alpha = $('.ui-colorpicker-hex-alpha', part);

          inputs.color.on('keydown keyup', function(e) {
            return e.ctrlKey || e.metaKey || _keycode.isHex(e.which) || !_keycode.isPrint(e.which);
          });

          // repeat here makes the invalid input disappear faster
          inputs.color.on('change', function () {
            if (/[^a-fA-F0-9]/.test(inputs.color.val())) {
              inputs.color.val(inputs.color.val().replace(/[^a-fA-F0-9]/g, ''));
            }
          });

          inputs.color.on('change keyup', function () {
            // repeat here makes sure that the invalid input doesn't get parsed
            inst.color = parseHex(inputs.color.val()).setAlpha(inst.color.getAlpha());
            inst._change();
          });

          inputs.alpha.on('keydown keyup', function(e) {
            return e.ctrlKey || e.metaKey || _keycode.isHex(e.which) || !_keycode.isPrint(e.which);
          });

          inputs.alpha.on('change', function () {
            if (/[^a-fA-F0-9]/.test(inputs.alpha)) {
              inputs.alpha.val(inputs.alpha.val().replace(/[^a-fA-F0-9]/g, ''));
            }
          });

          inputs.alpha.on('change keyup', function () {
            inst.color.setAlpha(parseInt(inputs.alpha.val(), 16) / 255);
            inst._change();
          });
        };

        this.repaint = function () {
          if (!inputs.color.is(':focus')) {
            inputs.color.val(inst.color.toHex(true));
          }

          if (!inputs.alpha.is(':focus')) {
            inputs.alpha.val(_intToHex(inst.color.getAlpha() * 255));
          }
        };

        this.update = this.repaint;

        this.disable = function (disable) {
          $(':input', part).prop('disabled', disable);
        };
      },

      swatches: function (inst) {
        var that = this,
          part = null,
          html = function () {
            var html = '';

            inst._eachSwatch(function (name, color) {
              var c = new $.colorpicker.Color(color.r, color.g, color.b),
                css = c.toCSS();
              html += '<div class="ui-colorpicker-swatch" style="background-color:' + css + '" title="' + name + '"></div>';
            });

            return '<div class="ui-colorpicker-swatches ui-colorpicker-border" style="width:' + inst.options.swatchesWidth + 'px">' + html + '</div>';
          },
          onclick = function () {
            inst.color	= inst._parseColor($(this).css('background-color')) || new $.colorpicker.Color();
            inst._change();
          };

        this.init = function () {
          part = $(html());
          $('.ui-colorpicker-swatches-container', inst.dialog).html(part);
          $('.ui-colorpicker-swatch', part).on('click', onclick);
        };

        this.disable = function (disable) {
          $('.ui-colorpicker-swatch', part)[disable ? 'off' : 'on']('click', onclick);
        };
      },

      footer: function (inst) {
        var that = this,
          part = null,
          id_transparent = 'ui-colorpicker-special-transparent-' + inst.colorpicker_index,
          id_none = 'ui-colorpicker-special-none-' + inst.colorpicker_index,
          html = function () {
            var html = '';

            if (inst.options.alpha || (!inst.inline && inst.options.showNoneButton)) {
              html += '<div class="ui-colorpicker-buttonset">';

              if (inst.options.alpha) {
                html += '<input type="radio" name="ui-colorpicker-special" id="'+id_transparent+'" class="ui-colorpicker-special-transparent"/><label for="'+id_transparent+'">' + inst._getRegional('transparent') + '</label>';
              }
              if (!inst.inline && inst.options.showNoneButton) {
                html += '<input type="radio" name="ui-colorpicker-special" id="'+id_none+'" class="ui-colorpicker-special-none"><label for="'+id_none+'">' + inst._getRegional('none') + '</label>';
              }
              html += '</div>';
            }

            if (!inst.inline) {
              html += '<div class="ui-dialog-buttonset">';
              if (inst.options.showCancelButton) {
                html += '<button class="ui-colorpicker-cancel">' + inst._getRegional('cancel') + '</button>';
              }
              html += '<button class="ui-colorpicker-ok">' + inst._getRegional('ok') + '</button>';
              html += '</div>';
            }

            return '<div class="ui-dialog-buttonpane ui-widget-content">' + html + '</div>';
          };

        this.init = function () {
          part = $(html()).appendTo(inst.dialog);

          $('.ui-colorpicker-ok', part).button().click(function () {
            inst.close();
          });

          $('.ui-colorpicker-cancel', part).button().click(function () {
            inst.close(true);   //cancel
          });

          $('.ui-colorpicker-buttonset', part)[$.fn.controlgroup ? 'controlgroup' : 'buttonset']();

          $('.ui-colorpicker-special-color', part).click(function () {
            inst._change();
          });

          $('#'+id_none, part).click(function () {
            inst.color.set = false;
            inst._change();
          });

          $('#'+id_transparent, part).click(function () {
            inst.color.setAlpha(0);
            inst._change();
          });
        };

        this.repaint = function () {
          $('.ui-colorpicker-special-none', part).prop('checked', !inst.color.set).button('refresh');
          $('.ui-colorpicker-special-transparent', part).prop('checked', inst.color.set && inst.color.getAlpha() === 0).button('refresh');
          $('.ui-colorpicker-ok', part).button(inst.changed ? 'enable' : 'disable');
        };

        this.update = function () {};

        this.disable = function (disabled) {
          $(':input, :button', part).button(disabled ? 'disable' : 'enable');
          if (!disabled) {
            $('.ui-colorpicker-ok', part).button(inst.changed ? 'enable' : 'disable');
          }
        };
      }
    };

    this.Color = function () {
      var spaces = {	rgb:	{r: 0, g: 0, b: 0},
          hsv:	{h: 0, s: 0, v: 0},
          hsl:	{h: 0, s: 0, l: 0},
          lab:	{l: 0, a: 0, b: 0},
          cmyk:	{c: 0, m: 0, y: 0, k: 1}
        },
        a = 1,
        illuminant = [0.9504285, 1, 1.0889],	// CIE-L*ab D65/2' 1931
        args = arguments,
        _clip = function(v) {
          if (isNaN(v) || v === null) {
            return 0;
          }
          if (typeof v == 'string') {
            v = parseInt(v, 10);
          }
          return Math.max(0, Math.min(v, 1));
        },
        _hexify = function (number) {
          var number = Math.round(number),
            digits = '0123456789abcdef',
            lsd = number % 16,
            msd = (number - lsd) / 16,
            hexified = digits.charAt(msd) + digits.charAt(lsd);
          return hexified;
        },
        _rgb_to_xyz = function(rgb) {
          var r = (rgb.r > 0.04045) ? Math.pow((rgb.r + 0.055) / 1.055, 2.4) : rgb.r / 12.92,
            g = (rgb.g > 0.04045) ? Math.pow((rgb.g + 0.055) / 1.055, 2.4) : rgb.g / 12.92,
            b = (rgb.b > 0.04045) ? Math.pow((rgb.b + 0.055) / 1.055, 2.4) : rgb.b / 12.92;

          return {
            x: r * 0.4124 + g * 0.3576 + b * 0.1805,
            y: r * 0.2126 + g * 0.7152 + b * 0.0722,
            z: r * 0.0193 + g * 0.1192 + b * 0.9505
          };
        },
        _xyz_to_rgb = function(xyz) {
          var rgb = {
            r: xyz.x *  3.2406 + xyz.y * -1.5372 + xyz.z * -0.4986,
            g: xyz.x * -0.9689 + xyz.y *  1.8758 + xyz.z *  0.0415,
            b: xyz.x *  0.0557 + xyz.y * -0.2040 + xyz.z *  1.0570
          };

          rgb.r = (rgb.r > 0.0031308) ? 1.055 * Math.pow(rgb.r, (1 / 2.4)) - 0.055 : 12.92 * rgb.r;
          rgb.g = (rgb.g > 0.0031308) ? 1.055 * Math.pow(rgb.g, (1 / 2.4)) - 0.055 : 12.92 * rgb.g;
          rgb.b = (rgb.b > 0.0031308) ? 1.055 * Math.pow(rgb.b, (1 / 2.4)) - 0.055 : 12.92 * rgb.b;

          return rgb;
        },
        _rgb_to_hsv = function(rgb) {
          var minVal = Math.min(rgb.r, rgb.g, rgb.b),
            maxVal = Math.max(rgb.r, rgb.g, rgb.b),
            delta = maxVal - minVal,
            del_R, del_G, del_B,
            hsv = {
              h: 0,
              s: 0,
              v: maxVal
            };

          if (delta === 0) {
            hsv.h = 0;
            hsv.s = 0;
          } else {
            hsv.s = delta / maxVal;

            del_R = (((maxVal - rgb.r) / 6) + (delta / 2)) / delta;
            del_G = (((maxVal - rgb.g) / 6) + (delta / 2)) / delta;
            del_B = (((maxVal - rgb.b) / 6) + (delta / 2)) / delta;

            if (rgb.r === maxVal) {
              hsv.h = del_B - del_G;
            } else if (rgb.g === maxVal) {
              hsv.h = (1 / 3) + del_R - del_B;
            } else if (rgb.b === maxVal) {
              hsv.h = (2 / 3) + del_G - del_R;
            }

            if (hsv.h < 0) {
              hsv.h += 1;
            } else if (hsv.h > 1) {
              hsv.h -= 1;
            }
          }

          return hsv;
        },
        _hsv_to_rgb = function(hsv) {
          var rgb = {
              r: 0,
              g: 0,
              b: 0
            },
            var_h,
            var_i,
            var_1,
            var_2,
            var_3;

          if (hsv.s === 0) {
            rgb.r = rgb.g = rgb.b = hsv.v;
          } else {
            var_h = hsv.h === 1 ? 0 : hsv.h * 6;
            var_i = Math.floor(var_h);
            var_1 = hsv.v * (1 - hsv.s);
            var_2 = hsv.v * (1 - hsv.s * (var_h - var_i));
            var_3 = hsv.v * (1 - hsv.s * (1 - (var_h - var_i)));

            if (var_i === 0) {
              rgb.r = hsv.v;
              rgb.g = var_3;
              rgb.b = var_1;
            } else if (var_i === 1) {
              rgb.r = var_2;
              rgb.g = hsv.v;
              rgb.b = var_1;
            } else if (var_i === 2) {
              rgb.r = var_1;
              rgb.g = hsv.v;
              rgb.b = var_3;
            } else if (var_i === 3) {
              rgb.r = var_1;
              rgb.g = var_2;
              rgb.b = hsv.v;
            } else if (var_i === 4) {
              rgb.r = var_3;
              rgb.g = var_1;
              rgb.b = hsv.v;
            } else {
              rgb.r = hsv.v;
              rgb.g = var_1;
              rgb.b = var_2;
            }
          }

          return rgb;
        },
        _rgb_to_hsl = function(rgb) {
          var minVal = Math.min(rgb.r, rgb.g, rgb.b),
            maxVal = Math.max(rgb.r, rgb.g, rgb.b),
            delta = maxVal - minVal,
            del_R, del_G, del_B,
            hsl = {
              h: 0,
              s: 0,
              l: (maxVal + minVal) / 2
            };

          if (delta === 0) {
            hsl.h = 0;
            hsl.s = 0;
          } else {
            hsl.s = hsl.l < 0.5 ? delta / (maxVal + minVal) : delta / (2 - maxVal - minVal);

            del_R = (((maxVal - rgb.r) / 6) + (delta / 2)) / delta;
            del_G = (((maxVal - rgb.g) / 6) + (delta / 2)) / delta;
            del_B = (((maxVal - rgb.b) / 6) + (delta / 2)) / delta;

            if (rgb.r === maxVal) {
              hsl.h = del_B - del_G;
            } else if (rgb.g === maxVal) {
              hsl.h = (1 / 3) + del_R - del_B;
            } else if (rgb.b === maxVal) {
              hsl.h = (2 / 3) + del_G - del_R;
            }

            if (hsl.h < 0) {
              hsl.h += 1;
            } else if (hsl.h > 1) {
              hsl.h -= 1;
            }
          }

          return hsl;
        },
        _hsl_to_rgb = function(hsl) {
          var var_1,
            var_2,
            hue_to_rgb	= function(v1, v2, vH) {
              if (vH < 0) {
                vH += 1;
              }
              if (vH > 1) {
                vH -= 1;
              }
              if ((6 * vH) < 1) {
                return v1 + (v2 - v1) * 6 * vH;
              }
              if ((2 * vH) < 1) {
                return v2;
              }
              if ((3 * vH) < 2) {
                return v1 + (v2 - v1) * ((2 / 3) - vH) * 6;
              }
              return v1;
            };

          if (hsl.s === 0) {
            return {
              r: hsl.l,
              g: hsl.l,
              b: hsl.l
            };
          }

          var_2 = (hsl.l < 0.5) ? hsl.l * (1 + hsl.s) : (hsl.l + hsl.s) - (hsl.s * hsl.l);
          var_1 = 2 * hsl.l - var_2;

          return {
            r: hue_to_rgb(var_1, var_2, hsl.h + (1 / 3)),
            g: hue_to_rgb(var_1, var_2, hsl.h),
            b: hue_to_rgb(var_1, var_2, hsl.h - (1 / 3))
          };
        },
        _xyz_to_lab = function(xyz) {
          var x = xyz.x / illuminant[0],
            y = xyz.y / illuminant[1],
            z = xyz.z / illuminant[2];

          x = (x > 0.008856) ? Math.pow(x, (1/3)) : (7.787 * x) + (16/116);
          y = (y > 0.008856) ? Math.pow(y, (1/3)) : (7.787 * y) + (16/116);
          z = (z > 0.008856) ? Math.pow(z, (1/3)) : (7.787 * z) + (16/116);

          return {
            l: ((116 * y) - 16) / 100,	// [0,100]
            a: ((500 * (x - y)) + 128) / 255,	// [-128,127]
            b: ((200 * (y - z))	+ 128) / 255	// [-128,127]
          };
        },
        _lab_to_xyz = function(lab) {
          var lab2 = {
              l: lab.l * 100,
              a: (lab.a * 255) - 128,
              b: (lab.b * 255) - 128
            },
            xyz = {
              x: 0,
              y: (lab2.l + 16) / 116,
              z: 0
            };

          xyz.x = lab2.a / 500 + xyz.y;
          xyz.z = xyz.y - lab2.b / 200;

          xyz.x = (Math.pow(xyz.x, 3) > 0.008856) ? Math.pow(xyz.x, 3) : (xyz.x - 16 / 116) / 7.787;
          xyz.y = (Math.pow(xyz.y, 3) > 0.008856) ? Math.pow(xyz.y, 3) : (xyz.y - 16 / 116) / 7.787;
          xyz.z = (Math.pow(xyz.z, 3) > 0.008856) ? Math.pow(xyz.z, 3) : (xyz.z - 16 / 116) / 7.787;

          xyz.x *= illuminant[0];
          xyz.y *= illuminant[1];
          xyz.z *= illuminant[2];

          return xyz;
        },
        _rgb_to_cmy = function(rgb) {
          return {
            c: 1 - (rgb.r),
            m: 1 - (rgb.g),
            y: 1 - (rgb.b)
          };
        },
        _cmy_to_rgb = function(cmy) {
          return {
            r: 1 - (cmy.c),
            g: 1 - (cmy.m),
            b: 1 - (cmy.y)
          };
        },
        _cmy_to_cmyk = function(cmy) {
          var K = 1;

          if (cmy.c < K) {
            K = cmy.c;
          }
          if (cmy.m < K) {
            K = cmy.m;
          }
          if (cmy.y < K) {
            K = cmy.y;
          }

          if (K === 1) {
            return {
              c: 0,
              m: 0,
              y: 0,
              k: 1
            };
          }

          return {
            c: (cmy.c - K) / (1 - K),
            m: (cmy.m - K) / (1 - K),
            y: (cmy.y - K) / (1 - K),
            k: K
          };
        },
        _cmyk_to_cmy = function(cmyk) {
          return {
            c: cmyk.c * (1 - cmyk.k) + cmyk.k,
            m: cmyk.m * (1 - cmyk.k) + cmyk.k,
            y: cmyk.y * (1 - cmyk.k) + cmyk.k
          };
        };

      this.set = false;

      this.setAlpha = function(_a) {
        if (_a !== null) {
          a = _clip(_a);
        }
        this.set = true;

        return this;
      };

      this.getAlpha = function() {
        return a;
      };

      this.setRGB = function(r, g, b) {
        spaces = { rgb: this.getRGB() };
        if (r !== null) {
          spaces.rgb.r = _clip(r);
        }
        if (g !== null) {
          spaces.rgb.g = _clip(g);
        }
        if (b !== null) {
          spaces.rgb.b = _clip(b);
        }
        this.set = true;

        return this;
      };

      this.getChannel = function(channel) {
        switch (channel) {
        case 'h':
        case 's':
        case 'v':
          return this.getHSV()[channel];

        case 'r':
        case 'g':
        case 'b':
          return this.getRGB()[channel];

        case 'a':
          return this.getAlpha();
        }

        return null;
      };

      this.setChannel = function(channel, value) {
        switch (channel) {
        case 'h':
          return this.setHSV(value, null, null);

        case 's':
          return this.setHSV(null, value, null);

        case 'v':
          return this.setHSV(null, null, value);

        case 'r':
          return this.setRGB(value, null, null);

        case 'g':
          return this.setRGB(null, value, null);

        case 'b':
          return this.setRGB(null, null, value);

        case 'a':
          return this.setAlpha(value);
        }

        return this;
      };

      this.setHSV = function(h, s, v) {
        spaces = {hsv: this.getHSV()};
        if (h !== null) {
          spaces.hsv.h = _clip(h);
        }
        if (s !== null)	{
          spaces.hsv.s = _clip(s);
        }
        if (v !== null)	{
          spaces.hsv.v = _clip(v);
        }
        this.set = true;

        return this;
      };

      this.setHSL = function(h, s, l) {
        spaces = {hsl: this.getHSL()};
        if (h !== null)	{
          spaces.hsl.h = _clip(h);
        }
        if (s !== null) {
          spaces.hsl.s = _clip(s);
        }
        if (l !== null) {
          spaces.hsl.l = _clip(l);
        }
        this.set = true;

        return this;
      };

      this.setLAB = function(l, a, b) {
        spaces = {lab: this.getLAB()};
        if (l !== null) {
          spaces.lab.l = _clip(l);
        }
        if (a !== null) {
          spaces.lab.a = _clip(a);
        }
        if (b !== null) {
          spaces.lab.b = _clip(b);
        }
        this.set = true;

        return this;
      };

      this.setCMYK = function(c, m, y, k) {
        spaces = {cmyk: this.getCMYK()};
        if (c !== null) {
          spaces.cmyk.c = _clip(c);
        }
        if (m !== null) {
          spaces.cmyk.m = _clip(m);
        }
        if (y !== null) {
          spaces.cmyk.y = _clip(y);
        }
        if (k !== null) {
          spaces.cmyk.k = _clip(k);
        }
        this.set = true;

        return this;
      };

      this.getRGB = function() {
        if (!spaces.rgb) {
          spaces.rgb	= spaces.lab ?	_xyz_to_rgb(_lab_to_xyz(spaces.lab))
            : spaces.hsv ?	_hsv_to_rgb(spaces.hsv)
              : spaces.hsl ?	_hsl_to_rgb(spaces.hsl)
                : spaces.cmyk ?	_cmy_to_rgb(_cmyk_to_cmy(spaces.cmyk))
                  : {r: 0, g: 0, b: 0};
          spaces.rgb.r = _clip(spaces.rgb.r);
          spaces.rgb.g = _clip(spaces.rgb.g);
          spaces.rgb.b = _clip(spaces.rgb.b);
        }
        return $.extend({}, spaces.rgb);
      };

      this.getHSV = function() {
        if (!spaces.hsv) {
          spaces.hsv	= spaces.lab ? _rgb_to_hsv(this.getRGB())
            : spaces.rgb ?	_rgb_to_hsv(spaces.rgb)
              : spaces.hsl ?	_rgb_to_hsv(this.getRGB())
                : spaces.cmyk ?	_rgb_to_hsv(this.getRGB())
                  : {h: 0, s: 0, v: 0};
          spaces.hsv.h = _clip(spaces.hsv.h);
          spaces.hsv.s = _clip(spaces.hsv.s);
          spaces.hsv.v = _clip(spaces.hsv.v);
        }
        return $.extend({}, spaces.hsv);
      };

      this.getHSL = function() {
        if (!spaces.hsl) {
          spaces.hsl	= spaces.rgb ?	_rgb_to_hsl(spaces.rgb)
            : spaces.hsv ?	_rgb_to_hsl(this.getRGB())
              : spaces.cmyk ?	_rgb_to_hsl(this.getRGB())
                : spaces.hsv ?	_rgb_to_hsl(this.getRGB())
                  : {h: 0, s: 0, l: 0};
          spaces.hsl.h = _clip(spaces.hsl.h);
          spaces.hsl.s = _clip(spaces.hsl.s);
          spaces.hsl.l = _clip(spaces.hsl.l);
        }
        return $.extend({}, spaces.hsl);
      };

      this.getCMYK = function() {
        if (!spaces.cmyk) {
          spaces.cmyk	= spaces.rgb ?	_cmy_to_cmyk(_rgb_to_cmy(spaces.rgb))
            : spaces.hsv ?	_cmy_to_cmyk(_rgb_to_cmy(this.getRGB()))
              : spaces.hsl ?	_cmy_to_cmyk(_rgb_to_cmy(this.getRGB()))
                : spaces.lab ?	_cmy_to_cmyk(_rgb_to_cmy(this.getRGB()))
                  : {c: 0, m: 0, y: 0, k: 1};
          spaces.cmyk.c = _clip(spaces.cmyk.c);
          spaces.cmyk.m = _clip(spaces.cmyk.m);
          spaces.cmyk.y = _clip(spaces.cmyk.y);
          spaces.cmyk.k = _clip(spaces.cmyk.k);
        }
        return $.extend({}, spaces.cmyk);
      };

      this.getLAB = function() {
        if (!spaces.lab) {
          spaces.lab  = spaces.rgb ?  _xyz_to_lab(_rgb_to_xyz(spaces.rgb))
            : spaces.hsv ?  _xyz_to_lab(_rgb_to_xyz(this.getRGB()))
              : spaces.hsl ?  _xyz_to_lab(_rgb_to_xyz(this.getRGB()))
                : spaces.cmyk ? _xyz_to_lab(_rgb_to_xyz(this.getRGB()))
                  : {l: 0, a: 0, b: 0};
          spaces.lab.l = _clip(spaces.lab.l);
          spaces.lab.a = _clip(spaces.lab.a);
          spaces.lab.b = _clip(spaces.lab.b);
        }
        return $.extend({}, spaces.lab);
      };

      this.getChannels = function() {
        return {
          r: this.getRGB().r,
          g: this.getRGB().g,
          b: this.getRGB().b,
          a: this.getAlpha(),
          h: this.getHSV().h,
          s: this.getHSV().s,
          v: this.getHSV().v,
          c: this.getCMYK().c,
          m: this.getCMYK().m,
          y: this.getCMYK().y,
          k: this.getCMYK().k,
          L: this.getLAB().l,
          A: this.getLAB().a,
          B: this.getLAB().b
        };
      };

      this.getSpaces = function() {
        return $.extend(true, {}, spaces);
      };

      this.distance = function(color) {
        var space = 'lab',
          getter  = 'get'+space.toUpperCase(),
          a = this[getter](),
          b = color[getter](),
          distance = 0,
          channel;

        for (channel in a) {
          distance += Math.pow(a[channel] - b[channel], 2);
        }

        return distance;
      };

      this.equals = function(color) {
        if (color) {
          var a = this.getRGB(),
            b = color.getRGB();

          return this.set === color.set
            && this.getAlpha() === color.getAlpha()
            && a.r === b.r
            && a.g === b.g
            && a.b === b.b;
        }
        return false;
      };

      this.limit = function(steps) {
        steps -= 1;
        var rgb = this.getRGB();
        this.setRGB(
          Math.round(rgb.r * steps) / steps,
          Math.round(rgb.g * steps) / steps,
          Math.round(rgb.b * steps) / steps
        );
      };

      this.toHex = function() {
        var rgb = this.getRGB();
        return _hexify(rgb.r * 255) + _hexify(rgb.g * 255) + _hexify(rgb.b * 255);
      };

      this.toCSS = function() {
        return '#' + this.toHex();
      };

      this.copy = function() {
        var color = new $.colorpicker.Color(this.getSpaces(), this.getAlpha());
        color.set = this.set;
        return color;
      };

      // Construct
      if (args.length === 2) {
        spaces = args[0];
        this.setAlpha(args[1] === 0 ? 0 : args[1] || 1);
        this.set = true;
      }
      if (args.length > 2) {
        this.setRGB(args[0], args[1], args[2]);
        this.setAlpha(args[3] === 0 ? 0 : args[3] || 1);
        this.set = true;
      }
    };
  }();

  $.widget('vanderlee.colorpicker', {
    options: {
      alpha:        false,    // Show alpha controls and mode
      altAlpha:     true,   // change opacity of altField as well?
      altField:     '',     // selector for DOM elements which change background color on change.
      altOnChange:    true,   // true to update on each change, false to update only on close.
      altProperties:    'background-color', // comma separated list of any of 'background-color', 'color', 'border-color', 'outline-color'
      autoOpen:     false,    // Open dialog automatically upon creation
      buttonClass:    null,   // If set, the button will get this/these classname(s).
      buttonColorize:   false,
      buttonImage:    'images/ui-colorpicker.png',
      buttonImageOnly:  false,
      buttonText:     null,   // Text on the button and/or title of button image.
      cancelOnExit:     false, // Should we revert to original value if user clicks outside?
      closeOnEscape:    true,   // Close the dialog when the escape key is pressed.
      closeOnOutside:   true,   // Close the dialog when clicking outside the dialog (not for inline)
      color:        '#00FF00',  // Initial color (for inline only)
      colorFormat:    'HEX',    // Format string for output color format
      disabled:     false,    // Disable or enable the colorpicker initially
      draggable:      true,   // Make popup dialog draggable if header is visible.
      containment:    null,   // Constrains dragging to within the bounds of the specified element or region.
      duration:     'fast',
      hideOn:       'button', // 'focus', 'click', 'button', 'alt', 'all'
      hsv:        true,   // Show HSV controls and modes
      inline:       true,   // Show any divs as inline by default
      inlineFrame:    true,   // Show a border and background when inline.
      layout: {
        map:    [0, 0, 1, 5], // Left, Top, Width, Height (in table cells).
        bar:    [1, 0, 1, 5],
        preview:  [2, 0, 1, 1],
        hsv:    [2, 1, 1, 1],
        rgb:    [2, 2, 1, 1],
        alpha:    [2, 3, 1, 1],
        hex:    [2, 4, 1, 1],
        lab:    [3, 1, 1, 1],
        cmyk:   [3, 2, 1, 2],
        swatches: [4, 0, 1, 5]
      },
      limit:        '',     // Limit color "resolution": '', 'websafe', 'nibble', 'binary', 'name'
      modal:        false,    // Modal dialog?
      mode:       'h',    // Initial editing mode, h, s, v, r, g, b or a
      okOnEnter:      false,    // Close (with OK) when pressing the enter key
      parts:        '',     // leave empty for automatic selection
      part: {
        map:    { size: 256 },
        bar:    { size: 256 }
      },      // options per part
      position:     null,
      regional:     '',
      revert:       false,    // Revert color upon non
      rgb:        true,   // Show RGB controls and modes
      showAnim:     'fadeIn',
      showCancelButton: true,
      showNoneButton:   false,
      showCloseButton:  true,
      showOn:       'focus click alt',    // 'focus', 'click', 'button', 'alt', 'all'
      showOptions:    {},
      swatches:     null,   // null for default or kv-object or names swatches set
      swatchesWidth:    84,     // width (in number of pixels) of swatches box.
      title:        null,

      cancel:             null,
      close:              null,
      init:       null,
      ok:                 null,
      open:               null,
      select:             null,
      stop:       null,
      ready:    null
    },

    _create: function () {
      var that = this,
        text;

      that.colorpicker_index = _colorpicker_index++;

      that.widgetEventPrefix = 'colorpicker';

      that.opened   = false;
      that.generated  = false;
      that.inline   = false;
      that.changed  = false;

      that.dialog   = null;
      that.button   = null;
      that.image    = null;
      that.overlay  = null;

      that.events = {
        window_resize:      null,
        document_keydown:   null,
        document_click_html:  null
      };

      that.mode   = that.options.mode;

      if (that.element.is('input') || that.options.inline === false) {
        // Initial color
        that._setColor(that.element.is('input') ? that.element.val() : that.options.color);
        that._callback('init');

        // showOn focus
        if (/\bfocus|all|both\b/.test(that.options.showOn)) {
          that.element.on('focus', function () {
            that.open();
          });
        }
        if (/\bfocus|all|both\b/.test(that.options.hideOn)) {
          that.element.on('focusout', function (e) {
            that.close();
          });
        }

        // showOn click
        if (/\bclick|all|both\b/.test(that.options.showOn)) {
          that.element.on('click', function (e) {
            if (that.opened && /\bclick|all|both\b/.test(that.options.hideOn)) {
              that.close();
            } else {
              that.open();
            }
          });
        }

        // showOn button
        if (/\bbutton|all|both\b/.test(that.options.showOn)) {
          if (that.options.buttonImage !== '') {
            text = that.options.buttonText || that._getRegional('button');

            that.image = $('<img/>').attr({
              'src': that.options.buttonImage,
              'alt': text,
              'title': text
            });
            if (that.options.buttonClass) {
              that.image.attr('class', that.options.buttonClass);
            }

            that._setImageBackground();
          }

          if (that.options.buttonImageOnly && that.image) {
            that.button = that.image;
          } else {
            that.button = $('<button type="button"></button>').html(that.image || that.options.buttonText).button();
            that.image = that.image ? $('img', that.button).first() : null;
          }
          that.button.insertAfter(that.element).click(function () {
            if (!that.options.disabled) {
              if (that.opened && /\bbutton|all|both\b/.test(that.options.hideOn)) {
                that.close();
              } else {
                that.open();
              }
            }
          });
        }

        // showOn alt
        if (/\balt|all|both\b/.test(that.options.showOn)) {
          $(that.options.altField).on('click', function () {
            if (that.opened && /\balt|all|both\b/.test(that.options.hideOn)) {
              that.close();
            } else {
              that.open();
            }
          });
        }

        if (that.options.autoOpen) {
          that.open();
        }

      } else {
        that.inline = true;

        that._generate();
        that.opened = true;
      }

      // Disable Widget-style
      (that.element.is(':disabled') || that.options.disabled) && that.disable();

      // Set callback just before creation ending
      that._callback('ready');

      return this;
    },

    _setOption: function(key, value) {
      switch (key) {
      case 'disabled':
        this[value ? 'disable' : 'enable']();
        break;

      case 'swatches':
        this.options.swatches = value;
        this.parts.swatches.init();
        break;
      }

      $.Widget.prototype._setOption.apply(this, arguments);
    },

    enable: function () {
      //$.Widget.prototype.enable.call(this);
      this.element && this.element.prop('disabled', false);
      this.button && this.button.prop('disabled', false);
      this.dialog && this.dialog.removeClass('ui-colorpicker-disabled');
      this.options.disabled = false;

      this.parts && $.each(this.parts, function (index, part) {
        part.disable && part.disable(false);
      });
    },

    disable: function () {
      //$.Widget.prototype.disable.call(this);
      this.element && this.element.prop('disabled', true);
      this.button && this.button.prop('disabled', true);
      this.dialog && this.dialog.addClass('ui-colorpicker-disabled');
      this.options.disabled = true;

      this.parts && $.each(this.parts, function (index, part) {
        part.disable && part.disable(true);
      });
    },

    _setImageBackground: function() {
      if (this.image && this.options.buttonColorize) {
        this.image.css('background-color', this.color.set? this._formatColor('RGBA', this.color) : '');
      }
    },

    /**
     * If an alternate field is specified, set it according to the current color.
     */
    _setAltField: function () {
      if (this.options.altOnChange && this.options.altField && this.options.altProperties) {
        var index,
          property,
          properties = this.options.altProperties.split(',');

        for (index = 0; index <= properties.length; ++index) {
          property = $.trim(properties[index]);
          switch (property) {
          case 'color':
          case 'fill':
          case 'stroke':
          case 'background-color':
          case 'backgroundColor':
          case 'outline-color':
          case 'border-color':
            $(this.options.altField).css(property, this.color.set? this.color.toCSS() : '');
            break;
          }
        }

        this.options.altAlpha &&
          $(this.options.altField).css('opacity', this.color.set? this.color.getAlpha() : '');
      }
    },

    _setColor: function(text) {
      this.color = this._parseColor(text) || new $.colorpicker.Color();
      this.currentColor = this.color.copy();

      this._setImageBackground();
      this._setAltField();
    },

    setColor: function(text) {
      this._setColor(text);
      this._change();
    },

    getColor: function(format) {
      return this._formatColor(format || this.options.colorFormat, this.color);
    },

    _generateInline: function() {
      var that = this;

      $(that.element).html(that.options.inlineFrame ? _container_inlineFrame : _container_inline);

      that.dialog = $('.ui-colorpicker', that.element);
    },

    _generatePopup: function() {
      var that = this;

      that.dialog = $(_container_popup).appendTo('body');

      // Close on clicking outside window and controls
      if (that.events.document_click_html === null) {
        $(document).on('touchstart click', 'html', that.events.document_click_html = function (event) {
          if (!that.opened || event.target === that.element[0] || that.overlay) {
            return;
          }

          // Check if clicked on any part of dialog
          if (that.dialog.is(event.target) || that.dialog.has(event.target).length > 0) {
            that.element.blur();	// inside window!
            return;
          }

          // Check if clicked on known external elements
          var p,
            parents = $(event.target).parents();
          // add the event.target in case of buttonImageOnly and closeOnOutside both are set to true
          parents.push(event.target);
          for (p = 0; p <= parents.length; ++p) {
            // button
            if (that.button !== null && parents[p] === that.button[0]) {
              return;
            }
            // showOn alt
            if (/\balt|all|both\b/.test(that.options.showOn) && $(that.options.altField).is(parents[p])) {
              return;
            }
          }

          // no closeOnOutside
          if (!that.options.closeOnOutside) {
            return;
          }

          // bring back the previous color if cancelOnExit is set to true
          if (that.options.cancelOnExit) {
            that.color = that.currentColor.copy();
            that._change();
          }

          that.close(that.options.revert);
        });
      }

      if (that.events.document_keydown === null) {
        $(document).on('keydown', that.events.document_keydown = function (event) {
          // close on ESC key
          if (that.opened && event.keyCode === 27 && that.options.closeOnEscape) {
            that.close(that.options.revert);
          }

          // OK on Enter key
          if (that.opened && event.keyCode === 13 && that.options.okOnEnter) {
            that.close();
          }
        });
      }

      // Close (with OK) on tab key in element
      that.element.keydown(function (event) {
        if (event.keyCode === 9) {
          that.close();
        }
      }).keyup(function (event) {
        var color = that._parseColor(that.element.val());
        if (color && !that.color.equals(color)) {
          that.color = color;
          that._change();
        }
      });
    },

    _generate: function () {
      var that = this,
        index,
        part,
        parts_list,
        layout_parts,
        table,
        classes;

      that._setColor(that.inline || !that.element.is('input') ? that.options.color : that.element.val());

      that[that.inline ? '_generateInline' : '_generatePopup']();

      // Determine the parts to include in this colorpicker
      if (typeof that.options.parts === 'string') {
        if ($.colorpicker.partslists[that.options.parts]) {
          parts_list = $.colorpicker.partslists[that.options.parts];
        } else {
          // automatic
          parts_list = $.colorpicker.partslists[that.inline ? 'inline' : 'popup'];
        }
      } else {
        parts_list = that.options.parts;
      }

      // Add any parts to the internal parts list
      that.parts = {};
      $.each(parts_list, function(index, part) {
        if ($.colorpicker.parts[part]) {
          that.parts[part] = new $.colorpicker.parts[part](that);
        }
      });

      if (!that.generated) {
        layout_parts = [];

        $.each(that.options.layout, function(part, pos) {
          if (that.parts[part]) {
            layout_parts.push({
              'part': part,
              'pos':  pos
            });
          }
        });

        table = $(_layoutTable(layout_parts, function(cell, x, y) {
          classes = ['ui-colorpicker-' + cell.part + '-container'];

          if (x > 0) {
            classes.push('ui-colorpicker-padding-left');
          }

          if (y > 0) {
            classes.push('ui-colorpicker-padding-top');
          }

          return '<td  class="' + classes.join(' ') + '"'
            + (cell.pos[2] > 1 ? ' colspan="' + cell.pos[2] + '"' : '')
            + (cell.pos[3] > 1 ? ' rowspan="' + cell.pos[3] + '"' : '')
            + ' valign="top"></td>';
        })).appendTo(that.dialog);
        if (that.options.inlineFrame) {
          table.addClass('ui-dialog-content ui-widget-content');
        }

        that._initAllParts();
        that._updateAllParts();
        that.generated = true;
      }
    },

    _effectGeneric: function (element, show, slide, fade, callback) {
      var that = this;

      if ($.effects && $.effects[that.options.showAnim]) {
        element[show](that.options.showAnim, that.options.showOptions, that.options.duration, callback);
      } else {
        element[(that.options.showAnim === 'slideDown' ?
          slide
          :	(that.options.showAnim === 'fadeIn' ?
            fade
            :	show))]((that.options.showAnim ? that.options.duration : null), callback);
        if ($.isFunction(callback) && (!that.options.showAnim || !that.options.duration)) {
          callback();
        }
      }
    },

    _effectShow: function(element, callback) {
      this._effectGeneric(element, 'show', 'slideDown', 'fadeIn', callback);
    },

    _effectHide: function(element, callback) {
      this._effectGeneric(element, 'hide', 'slideUp', 'fadeOut', callback);
    },

    open: function() {
      var that = this,
        offset,
        bottom, right,
        height, width,
        x, y,
        zIndex,
        element,
        position;

      if (!that.opened) {
        that._generate();

        if (that.element.is(':hidden')) {
          element = $('<div/>').insertBefore(that.element);
        } else {
          element = that.element;
        }

        if (that.element.is(':hidden')) {
          element.remove();
        }

        // Automatically find highest z-index.
        zIndex = 0;
        $(that.element[0]).parents().each(function() {
          var z = $(this).css('z-index');
          if ((typeof(z) === 'number' || typeof(z) === 'string') && z !== '' && !isNaN(z)) {
            if (z > zIndex) {
              zIndex = parseInt(z, 10);
              return false;
            }
          }
          else {
            $(this).siblings().each(function() {
              var z = $(this).css('z-index');
              if ((typeof(z) === 'number' || typeof(z) === 'string') && z !== '' && !isNaN(z)) {
                if (z > zIndex) {
                  zIndex = parseInt(z, 10);
                }
              }
            });
          }
        });

        zIndex += 2;
        that.dialog.css('z-index', zIndex);

        if (that.options.modal) {
          that.overlay = $('<div class="ui-widget-overlay"></div>').appendTo('body').css('z-index', zIndex - 1);

          if (that.events.window_resize !== null) {
            $(window).off('resize', that.events.window_resize);
          }

          that.events.window_resize = function() {
            if (that.overlay) {
              that.overlay.width($(document).width());
              that.overlay.height($(document).height());
            }
          },

          $(window).on('resize', that.events.window_resize);
          that.events.window_resize();
        }

        that._effectShow(this.dialog);

        if (that.options.position) {
          position = $.extend({}, that.options.position);
          if (position.of === 'element') {
            position.of = element;
          }
        } else {
          position = {
            my: 'left top',
            at: 'left bottom',
            of: element,
            collision:  'flip'
          };
        }
        that.dialog.position(position);

        that.opened = true;
        that._callback('open');

        // Without waiting for domready the width of the map is 0 and we
        // wind up with the cursor stuck in the upper left corner
        $(function() {
          that._repaintAllParts();
        });
      }
    },

    close: function (cancel) {
      var that = this;

      if (!that.opened) {
        return;
      }

      if (cancel) {
        that.color = that.currentColor.copy();
        that._change();
        that._callback('cancel');
      } else {
        that.currentColor	= that.color.copy();
        that._callback('ok');
      }
      that.changed		= false;

      if (that.overlay) {
        $(window).off('resize', that.events.window_resize);
        that.overlay.remove();
      }

      // tear down the interface
      that._effectHide(that.dialog, function () {
        that.dialog.remove();
        that.dialog		= null;
        that.generated	= false;

        that.opened		= false;
        that._callback('close');
      });
    },

    destroy: function() {
      var that = this;
      if (that.events.document_click_html !== null) {
        $(document).off('touchstart click', 'html', that.events.document_click_html);
      }

      if (that.events.document_keydown !== null) {
        $(document).off('keydown', that.events.document_keydown);
      }

      if (that.events.window_resize !== null) {
        $(window).off('resize', that.events.window_resize);
      }

      this.element.off();

      if (this.overlay) {
        this.overlay.remove();
      }

      if (this.dialog !== null) {
        this.dialog.remove();
      }

      if (this.image !== null) {
        this.image.remove();
      }

      if (this.button !== null) {
        this.button.remove();
      }
    },

    _callback: function (callback) {
      var that = this,
        data,
        lab;

      if (that.color.set) {
        data = {
          formatted: that._formatColor(that.options.colorFormat, that.color),
          colorPicker: that
        };

        data.hex  = that.color.toHex();
        data.css  = that.color.toCSS();
        data.a    = that.color.getAlpha();
        data.rgb  = that.color.getRGB();
        data.hsv  = that.color.getHSV();
        data.cmyk = that.color.getCMYK();
        data.hsl  = that.color.getHSL();

        lab = that.color.getLAB();
        lab.a = (lab.a * 2) - 1;
        lab.b = (lab.b * 2) - 1;
        data.lab  = lab;

        return that._trigger(callback, null, data);
      } else {
        return that._trigger(callback, null, {
          formatted: '',
          colorPicker: that
        });
      }
    },

    _initAllParts: function () {
      $.each(this.parts, function (index, part) {
        if (part.init) {
          part.init();
        }
      });
    },

    _updateAllParts: function () {
      $.each(this.parts, function (index, part) {
        if (part.update) {
          part.update();
        }
      });
    },

    _repaintAllParts: function () {
      $.each(this.parts, function (index, part) {
        if (part.repaint) {
          part.repaint();
        }
      });
    },

    _change: function (stoppedChanging /* = true */) {
      // Limit color palette
      if (this.color.set && this.options.limit && $.colorpicker.limits[this.options.limit]) {
        $.colorpicker.limits[this.options.limit](this.color, this);
      }

      // Set changed if different from starting color
      this.changed = !this.color.equals(this.currentColor);

      // update input element content
      if (!this.inline) {
        if (!this.color.set) {
          if (this.element.val() !== '') {
            this.element.val('').change();
          }
        } else if (!this.color.equals(this._parseColor(this.element.val()))) {
          this.element.val(this._formatColor(this.options.colorFormat, this.color)).change();
        }

        this._setImageBackground();
      }

      // Set the alt field
      this._setAltField();

      // update color option
      this.options.color = this.color.set ? this.color.toCSS() : '';

      if (this.opened) {
        this._repaintAllParts();
      }

      // callbacks
      this._callback('select');

      if (typeof stoppedChanging === 'undefined' ? true : !!stoppedChanging) {
        this._callback('stop');
      }
    },

    // This will be deprecated by jQueryUI 1.9 widget
    _hoverable: function (e) {
      e.hover(function () {
        e.addClass('ui-state-hover');
      }, function () {
        e.removeClass('ui-state-hover');
      });
    },

    // This will be deprecated by jQueryUI 1.9 widget
    _focusable: function (e) {
      e.focus(function () {
        e.addClass('ui-state-focus');
      }).blur(function () {
        e.removeClass('ui-state-focus');
      });
    },

    _getRegional: function(name) {
      return $.colorpicker.regional[this.options.regional][name] !== undefined ?
        $.colorpicker.regional[this.options.regional][name] : $.colorpicker.regional[''][name];
    },

    _getSwatches: function() {
      if (typeof(this.options.swatches) === 'string') {
        return $.colorpicker.swatches[this.options.swatches];
      }

      if ($.isPlainObject(this.options.swatches)) {
        return this.options.swatches;
      }

      return $.colorpicker.swatches.html;
    },

    _eachSwatch: function (callback) {
      var currentSwatches = this._getSwatches(),
        name;
      $.each(currentSwatches, function (nameOrIndex, swatch) {
        name = $.isArray(currentSwatches) ? swatch.name : nameOrIndex;
        return callback(name, swatch);
      });
    },

    _getSwatch: function(name) {
      var swatch = false;

      this._eachSwatch(function(swatchName, current) {
        if (swatchName.toLowerCase() == name.toLowerCase()) {
          swatch = current;
          return false;
        }
      });

      return swatch;
    },

    _parseFormat: function(format, text) {
      var that = this,
        typeRegexps = {
          x:  function() {return '([0-9a-fA-F]{2})';}
          , d:  function() {return '([12]?[0-9]{1,2})';}
          , f:  function() {return '([0-9]*\\.?[0-9]*)';}
          , p:  function() {return '([0-9]*\\.?[0-9]*)';}
        },
        typeConverters = {
          x:  function(v) {return parseInt(v, 16) / 255.;}
          , d:  function(v) {return v / 255.;}
          , f:  function(v) {return v;}
          , p:  function(v) {return v * 0.01;}
        },
        setters = {
          r:  'setRGB'
          , g:  'setRGB'
          , b:  'setRGB'
          , h:  'setHSV'
          , s:  'setHSV'
          , v:  'setHSV'
          , c:  'setCMYK'
          , m:  'setCMYK'
          , y:  'setCMYK'
          , k:  'setCMYK'
          , L:  'setLAB'
          , A:  'setLAB'
          , B:  'setLAB'
        },
        setterChannels = {
          setRGB:   [ 'r', 'g', 'b']
          , setHSV:   [ 'h', 's', 'v' ]
          , setCMYK:  [ 'c', 'm', 'y', 'k' ]
          , setLAB:   [ 'L', 'A', 'B' ]
        },
        channels = [],
        converters = [],
        setter = null,
        color,
        pattern;

      // Construct pattern
      pattern = format.replace(/[()\\^$.|?*+[\]]/g, function(m) {
        return '\\'+m;
      });


      pattern = pattern.replace(/\\?[argbhsvcmykLAB][xdfp]/g, function(variable) {
        if (variable.match(/^\\/)) {
          return variable.slice(1);
        }

        var channel = variable.charAt(0),
          type = variable.charAt(1);

        channels.push(channel);
        converters.push(typeConverters[type]);
        if (setters[channel]) {
          setter = setters[channel];
        }

        return typeRegexps[type]();
      });

      if (setter) {
        var values = text.match(new RegExp(pattern));
        if (values) {
          var args = [],
            channelIndex;

          values.shift();

          $.each(setterChannels[setter], function(index, channel) {
            channelIndex = $.inArray(channel, channels);
            args[index] = converters[channelIndex](values[channelIndex]);
          });

          color = new $.colorpicker.Color();
          color[setter].apply(color, args);
        }
      }

      return color;
    },

    _parseColor: function(text) {
      var that = this,
        color;

      var formats = $.isArray(that.options.colorFormat)
        ? that.options.colorFormat
        : [ that.options.colorFormat ];

      $.each(formats, function(index, format) {
        if ($.colorpicker.parsers[format]) {
          color = $.colorpicker.parsers[format](text, that);
        } else {
          color = that._parseFormat(format, text);
        }

        if (color) {
          return false;
        }
      });

      if (!color) {
        // fallback; check all registered parsers
        $.each($.colorpicker.parsers, function(name, parser) {
          color = parser(text, that);
          if (color) {
            return false;
          }
        });
      }

      if (color) {
        return color;
      }

      return false;
    },

    _exactName: function(color) {
      var name = false;

      this._eachSwatch(function(n, swatch) {
        if (color.equals(new $.colorpicker.Color(swatch.r, swatch.g, swatch.b))) {
          name = n;
          return false;
        }
      });

      return name;
    },

    _closestName: function(color) {
      var rgb     = color.getRGB(),
        distance  = null,
        name    = false,
        d;

      this._eachSwatch(function(n, swatch) {
        d = color.distance(new $.colorpicker.Color(swatch.r, swatch.g, swatch.b));
        if (d < distance || distance === null) {
          name = n;
          if (d <= 1e-20) { // effectively 0 by maximum rounding error
            return false; // can't get much closer than 0
          }
          distance = d; // safety net
        }
      });

      return name;
    },

    _formatColor: function (formats, color) {
      var that = this,
        text = null,
        types = { 'x':  function(v) {return _intToHex(v * 255);}
          ,'d':function(v) {return Math.round(v * 255);}
          ,'f':function(v) {return v;}
          ,'p':function(v) {return v * 100.;}
        },
        channels  = color.getChannels();

      if (!$.isArray(formats)) {
        formats = [formats];
      }

      $.each(formats, function(index, format) {
        if ($.colorpicker.writers[format]) {
          text = $.colorpicker.writers[format](color, that);
          return (text === false);
        } else {
          text = format.replace(/\\?[argbhsvcmykLAB][xdfp]/g, function(m) {
            if (m.match(/^\\/)) {
              return m.slice(1);
            }
            return types[m.charAt(1)](channels[m.charAt(0)]);
          });
          return false;
        }
      });

      return text;
    }
  });

  return $.vanderlee.colorpicker;
}));
class Module{
  
}class Android extends Module {
    age; chat; description; firstmessage; chargender; pronouns;  firstName; lastName;  title; genome; gender; 
    
    happiness; love; health; 
    
    energy; sexdrive;
    
    id; initialbody; intelligence;
    
    

    
   
    constructor(id = null, gender = 0) {
        var usedGenes = [6,14,43,56,57,64,77,78,81,95,98,115,119,142,144,151,152,154,155,157,222,223,321,322,359];
        super();
        
        this.gender = gender;
        this.constructorId(id, gender);
        if(typeof id === "object" && id !== null){
            this.constructorData(id, gender);
        }
        
        this.postConstructor();
    }
    
    constructorData(data, gender){
        var keys = Object.keys(data);
        for(var k of keys){
            this[k] = data[k];
        }
    }
    constructorId(id, gender = 0){
         if (isEmpty(id)){
            id = Android._getRandomId();
        }
        this.id = id;
       
        this.genome = Android._getGenome(this.id, gender);
        this.firstName = this._getFirstName();
        this.lastName = this._getLastName();
        this.title = "Stranger";
//        this.manufacturer = this.getGene(43);
        this.initialbody = 0;
        this.intelligence  = generateBellValue(this.getGene3(56,77,321));
        this.age = parseFloat((18 + generateBellValueHalf(this.getGene3(57,78,322))/2).toFixed(2));
        
        this.happiness = this.getGene2(151,222);
        this.love = parseInt((9*50 + this.getGene2(152,223))/10);
        this.health = this.getGene2(142,144);
        
        this.energy = this.getGene2(155,157);
        this.sexdrive = this.getGene2(115,119);
        
        
        this.job = "";
        this.chat = "";
        this.description = this.getRandomIntroduction();
        this.firstmessage = "";
        this.chargender = "";
        this.pronouns = "";
        
        this.voiceElevenlabs = "";
        this.voiceLocal = "";
        
    }
    
    isInScene(){
        if( Object.keys(EPHEMERAL.characters).length < 1) return false;
        for (var pid of Object.keys(EPHEMERAL.characters)) {
            if(EPHEMERAL.characters[pid]["androidId"].toString() !== this.id.toString()) continue;
            return isTrue(EPHEMERAL.characters[pid]["isAndroid"]);
        }
        return false;
    }
   
    RefreshImage(url){
        $("img").each(function(){
            var src = $(this).attr('src');
            var parts = src.split('?');
            src = parts[0];
            if(src === url || src.indexOf("url") > -1){
                $(this).attr('src', url+"?t="+getTimestamp());
            }
        });
    }
    
    getImageProfile(){
        return "../../../../../Saves/PluginData/Aeternum/Androids/"+this.id+"/avatar.jpg";
    }
     getImageProfileTimestamp(){
        return "../../../../../Saves/PluginData/Aeternum/Androids/"+this.id+"/avatar.jpg?t="+getTimestamp();
    }
    
    static getSerializableFields(){
        return ["age","chat","description","firstmessage", "chargender", "pronouns","firstName","genome","id","intelligence","initialbody","lastName", "voiceElevenlabs", "voiceLocal"];
    }
    
    serialize(){
        var serializable = Android.getSerializableFields();
        var o = {};
        for(var k of Object.keys(this)){
            if(serializable.indexOf(k) === -1) continue;
            o[k] = this[k];
        }
        return o;
    }
    
    unserialize(o){
        for(var k of Object.keys(o)){
            this[k] = o[k];
        }
        this.postConstruct();
    }
    
    postConstructor(){
//        this.corp = new Corp(this.manufacturer);
        this.favColor = this.getFavColor(this.getGene(81));
        this.archetype = this.getArchetype(this.getGene(95));
        this.archetypeEmoji = this.getArchetypeEmoji(this.getGene(95));
        this.personality = this.getPersonality(this.getGene(98));
        this.personalityEmoji = this.getPersonalityEmoji(this.getGene(98));
        this.trait = this.getTrait(this.getGene(154));
        this.traitEmoji = this.getTraitEmoji(this.getGene(154));
        this.ageType = this.getAgeType();
        
        this.score = this.getScore();
    }
    
    getName(){
        return this.firstName +" "+this.lastName;
    }
    
    getJobMap(){
        map = {};
        
        map.relax = {
            key: 'relax',
            name: "Relax",
        };
        return map;
    }
    
    static getAndroidIdFromObject(o){
        if($(o).attr("data-androidid") !== undefined) return $(o).attr("data-androidid");
        var p = $(o).parents(".android");
        if(p.length < 1) return null;
        return p.attr("data-androidid");
    }
    
    getRandomIntroduction(){
         var  introductionPhrases = [
            "Grew up in a bustling urban neighborhood",
            "Raised in a close-knit suburban community",
            "Hails from a small town with a tight community",
            "Overcame a challenging upbringing in a low-income area",
            "Experienced life as a child of immigrant parents",
            "Attended a prestigious university and excelled academically",
            "Traveled extensively and gained a multicultural perspective",
            "Served in the military and learned valuable skills",
            "Worked their way up from an entry-level job to a successful career",
            "Became a passionate advocate for social justice",
            "Built a successful business from scratch",
            "Survived a life-threatening illness and gained a new perspective",
            "Devoted themselves to environmental conservation",
            "Overcame personal adversity and became a motivational speaker",
            "Worked as a dedicated first responder, saving lives",
            "Developed a groundbreaking technology or invention",
            "Found their passion as an influential social media influencer",
            "Experienced the challenges of being a single parent",
            "Dedicated their life to philanthropy and charitable causes",
            "Became an accomplished athlete and competed at a high level",
            "Thrived in the fast-paced world of finance and investment",
            "Championed education and established a scholarship fund",
            "Overcame addiction and now helps others on the same journey",
            "Worked as a journalist, uncovering important truths",
            "Survived a natural disaster and became an advocate for preparedness",
            "Embarked on a transformative spiritual journey",
            "Advocated for animal rights and worked at a rescue shelter",
            "Found their calling as a successful artist or musician",
            "Became a dedicated teacher, inspiring future generations",
            "Mastered the craft of gourmet cooking and opened a popular restaurant",
          ];
          introductionPhrases.sort(() => Math.random() - 0.5);
          return introductionPhrases[0]+". "+introductionPhrases[1]+".";
    }
    
    checkIsNew(){
        if(!EPHEMERAL.queries.androids_list) return true;
        if(!EPHEMERAL.queries.androids_list.androids) return true ;
        if(Object.keys(EPHEMERAL.queries.androids_list.androids).length < 1) return true;
        var keys = Object.keys(EPHEMERAL.queries.androids_list.androids);
        for(var k of keys){
            if(EPHEMERAL.queries.androids_list.androids[k]["id"] === this.id) return false;
        }
        return true;
    }
    
    getLiveIntelligence(){
        return this.intelligence;
    }
    
    getLiveHealth(){
        var i =  parseFloat(this.health);
        if(i < 0) i = 0;
        if(i > 99) i = 99;
        return i;
    }
    
    getAdjectiveHealth(){
       var i = this.getLiveHealth();
        const healthStates = [
            "Very Sick",
            "Very Sick",
            "Sick",
            "Sick",
            "Sick",
            "Healthy",
            "Healthy",
            "Healthy",
            "Very Healthy",
            "Very Healthy"
        ];
        return healthStates[Math.floor(i/10)];
    }
    
    getLiveHappiness(){
        var i =  parseFloat(this.happiness);
        if(i < 0) i = 0;
        if(i > 99) i = 99;
        return i;
    }
    
    getAdjectiveHappiness(){
       var i = this.getLiveHappiness();
        var states = [
            "Very Sad",
            "Very Sad",
            "Sad",
            "Sad",
            "Sad",
            "Happy",
            "Happy",
            "Happy",
            "Very Happy",
            "Very Happy"
        ];
        return states[Math.floor(i/10)];
    }
    
     getLiveLove(){
        var i =  parseFloat(this.love);
        if(i < 0) i = 0;
        if(i > 99) i = 99;
        return i;
    }
    
    getAdjectiveLove(){
       var i = this.getLiveLove();
        const states = [
            "Very Hateful",
            "Very Hateful",
            "Hateful",
            "Hateful",
            "Hateful",
            "Loving",
            "Loving",
            "Loving",
            "Very Loving",
            "Very Loving"
        ];
        return states[Math.floor(i/10)];
    }
    
    
    getScore(){
        var sum = 3*this.getLiveIntelligence() + this.getLiveEnergy() + this.getLiveHealth() + this.getLiveSexdrive() + (118-this.age);
        var avg = Math.ceil(sum/7);
        return avg;
    }
    
    getRating(){
        var n = Math.round(this.score/10);
        return n;
    }
    
    getRatingStars(){
        var f = Math.round(this.getRating()/2);
        return f;
    }
    
    getHtmlRatingStars(){
        var html = "";
        var f = this.getRatingStars();
        for(var i=1;i<=f;i++){
            html+='<span class="star material-symbols-outlined">star</span>';
        }
        return html;
    }
    
    getLiveEnergy(){
        var i =  parseFloat(this.energy);
        if(i < 0) i = 0;
        if(i > 99) i = 99;
        return i;
    }
    
    getAdjectiveEnergy(){
       var i = this.getLiveEnergy();
        const states = [
            "Drained",
            "Exhausted",
            "Fatigued",
            "Weak",
            "Low",
            "Moderate",
            "Lively",
            "Charged",
            "Vibrant",
            "Euphoric"
        ];
        return states[Math.floor(i/10)];
    }
    
     getLiveSexdrive(){
        var i =  parseFloat(this.sexdrive);
        if(i < 0) i = 0;
        if(i > 99) i = 99;
        return i;
    }
    
    getAdjectiveSexdrive(){
       var i = this.getLiveSexdrive();
        const states = [
            "None",
            "Adverse",
            "Dormant",
            "Low",
            "Active",
            "Moderate",
            "Intense",
            "Fiery",
            "Fervent",
            "Raging"
            
        ];
        return states[Math.floor(i/10)];
    }
    
    getAgeType(){
        if(this.age <= 22) return "Young";
        if(this.age <= 29) return "Twenties";
        if(this.age <= 39) return "Thirties";
        if(this.age <= 49) return "MILF";
        else return "Granny";
    }
    
    getFavColor(i){
        const coolColors = [
            "teal",
            "orchid",
            "slateblue",
            "crimson",
            "turquoise",
            "fuchsia",
            "steelblue",
            "salmon",
            "seagreen",
            "indigo"
        ];
        return coolColors[i];
    }
    
    getTrait(i){
        const archetypes = [
            "Brave",
            "Humble",
            "Trusting",
            "Ambitious",
            "Lazy",
            "Stubborn",
            "Shy",
            "Deceitful",
            "Arrogant",
            "Sadistic"
        ];
        return archetypes[i];
    }
    getTraitEmoji(i){
        const archetypeEmojis = [
            "🦁", // Brave
            "🙏", // Humble
            "🤝", // Trusting
            "💪", // Ambitious
            "😴", // Lazy
            "😠", // Stubborn
            "😳", // Shy
            "😈", // Deceitful
            "😏", // Arrogant
            "🔪"  // Sadistic
        ];
        return archetypeEmojis[i];
    }
    
    getArchetype(i){
        const archetypes = [
            "Leader",
            "Thinker",
            "Dreamer",
            "Innovator",
            "Adventurer",
            "Nurturer",
            "Entertainer",
            "Outlaw",
            "Lover",
            "Jester",
        ];
        return archetypes[i];
    }
    getArchetypeEmoji(i){
        const archetypeEmojis = [
            "👑", // Leader
            "💭", // Thought Bubble
            "✨", // Dreamer (Stars)
            "🔧", // Innovator
            "⛰️", // Adventurer
            "🌼", // Nurturer
            "🎭", // Entertainer
            "🔥", // Outlaw (Fire)
            "💕", // Lover
            "🤡"  // Jester
        ];
        return archetypeEmojis[i];
    }
    
    getPersonality(i){
        const personalities = [
            "Introvert",
            "Extrovert",
            "Melancholic",
            "Analytical",
            "Creative",
            "Pessimistic",
            "Empathetic",
            "Assertive",
            "Logical",
            "Optimistic"
        ];
        return personalities[i];
    }
    getPersonalityEmoji(i){
        const personalityEmojis = [
            "🔒", // Introvert
            "🎉", // Extrovert
            "💙", // Melancholic
            "🔬", // Analytical
            "🎨", // Creative
            "🌧️", // Pessimistic
            "🌍", // Empathetic
            "⛰️", // Assertive (Mountain)
            "🎯", // Logical
            "🌞"  // Optimistic
        ];
        return personalityEmojis[i];
    }
    
    
  
    
    getPurchasePrice(){
        var price = 100;
//        price*= this.corp.price;
        var intelligence_delta = Math.max(1, Math.max(0,this.intelligence)/20);
        intelligence_delta*= intelligence_delta;
        price*= intelligence_delta;
        var age_delta = 1;
        if(this.age > 19) age_delta-=0.1;if(this.age > 24) age_delta-=0.1;if(this.age > 29) age_delta-=0.1;if(this.age > 35) age_delta-=0.1;if(this.age > 40) age_delta-=0.1;if(this.age > 45) age_delta-=0.1;if(this.age > 55) age_delta-=0.1;if(this.age > 65) age_delta-=0.1;if(this.age > 75) age_delta-=0.1; 
        price*= age_delta;
        
        var rating = this.getRating();
        price+= rating*rating*rating*rating/3;
        
        return parseInt(price);
    }
    
    getGene(i){
        return parseInt(this.genome[parseInt(i)]);
    }
    getGene2(i1,i2){
        return parseInt("" + this.genome[parseInt(i1)] + this.genome[parseInt(i2)]);
    }
    getGene3(i1,i2,i3){
        return parseInt("" + this.genome[parseInt(i1)] + this.genome[parseInt(i2)] + this.genome[parseInt(i3)]);
    }
        
    _getFirstName(){
        const femaleNames = [
            "Emma", "Olivia", "Ava", "Isabella", "Sophia", "Mia", "Charlotte", "Amelia", "Harper", "Evelyn",
            "Abigail", "Emily", "Elizabeth", "Mila", "Ella", "Avery", "Sofia", "Camila", "Aria", "Scarlett",
            "Victoria", "Madison", "Luna", "Grace", "Chloe", "Penelope", "Layla", "Riley", "Zoey", "Nora",
            "Lily", "Eleanor", "Hannah", "Lillian", "Addison", "Aubrey", "Ellie", "Stella", "Natalie", "Zoe",
            "Leah", "Hazel", "Violet", "Aurora", "Savannah", "Audrey", "Brooklyn", "Bella", "Claire", "Skylar",
            "Lucy", "Paisley", "Everly", "Anna", "Caroline", "Nova", "Genesis", "Emilia", "Kennedy", "Samantha",
            "Maya", "Willow", "Kinsley", "Naomi", "Aaliyah", "Elena", "Sarah", "Ariana", "Allison", "Gabriella",
            "Alice", "Madelyn", "Cora", "Ruby", "Eva", "Serenity", "Autumn", "Adeline", "Hailey", "Gianna",
            "Valentina", "Isla", "Eliana", "Quinn", "Nevaeh", "Ivy", "Sadie", "Piper", "Lydia", "Alexa",
            "Josephine", "Emery", "Julia", "Delilah", "Arianna", "Vivian", "Kaylee", "Sophie", "Brielle", "Madeline"
        ];
        
        var index = parseInt(this.getGene2(6,359));
        return femaleNames[index];
    }
    _getLastName(){
       const familyNames = [
            "Smith", "Johnson", "Williams", "Brown", "Jones", "Miller", "Davis", "Garcia", "Rodriguez", "Wilson",
            "Martinez", "Anderson", "Taylor", "Thomas", "Hernandez", "Moore", "Martin", "Jackson", "Thompson", "White",
            "Lopez", "Lee", "Gonzalez", "Harris", "Clark", "Lewis", "Robinson", "Walker", "Perez", "Hall",
            "Young", "Allen", "Sanchez", "Wright", "King", "Scott", "Green", "Baker", "Adams", "Nelson",
            "Hill", "Ramirez", "Campbell", "Mitchell", "Roberts", "Carter", "Phillips", "Evans", "Turner", "Torres",
            "Parker", "Collins", "Edwards", "Stewart", "Flores", "Morris", "Nguyen", "Murphy", "Rivera", "Cook",
            "Rogers", "Morgan", "Peterson", "Cooper", "Reed", "Bailey", "Bell", "Gomez", "Kelly", "Howard",
            "Ward", "Cox", "Diaz", "Richardson", "Wood", "Watson", "Brooks", "Bennett", "Gray", "James",
            "Reyes", "Cruz", "Hughes", "Price", "Myers", "Long", "Foster", "Sanders", "Ross", "Morales",
            "Powell", "Sullivan", "Russell", "Ortiz", "Jenkins", "Gutierrez", "Perry", "Butler", "Barnes", "Fisher"
        ];
        var index = parseInt(this.getGene2(14,64));
        return familyNames[index];
    }

    
    static _getGenome(str, gender){
        var s = "";
        for(var i=1;i<=50;i++){
            s+=crc32("genome-"+i+"-"+str);
        }
        let stringArray = s.split("");
        stringArray[1] = gender;
        return stringArray.join("");
    }
    static _getRandomId(){
        var id =  ""+randomIntFromInterval(1000000,9999999);
        if(Object.keys(EPHEMERAL.queries.androids_list.androids).length >  0){
            var keys = Object.keys(EPHEMERAL.queries.androids_list.androids);
            for(var k of keys){
                if(EPHEMERAL.queries.androids_list.androids[k]["id"] === ""+id){
                    return Android._getRandomId();
                }
            }
        }
        return id;
    }
    
    static getFromEphemeral(id){
        if(!EPHEMERAL.queries.androids_list) return;
        if(!EPHEMERAL.queries.androids_list.androids) return;
        if(Object.keys(EPHEMERAL.queries.androids_list.androids).length < 1) return;
        for(var a of EPHEMERAL.queries.androids_list.androids){
            if(a.id === id){
                return new Android(a);
            }
        }
    }
  
}var APPHISTORY_TABS = {};
var APPHISTORY_PARAMS = {};


function app_refresh_tab(){
    App.TabRefresh();
}

class App {

    
    constructor(name, settings = {}) {
        this.name = name;
        this.settings = settings;
        this.param = this.GetLastParam();
    }
    
    GetParam(){
        return this.param;
    }
    SetParam(val){
        this.param = val;
        APPHISTORY_PARAMS[this.name] = val;
    }
    
    
    SetTab(s){
        $(".nav-tabs.app-tabs .nav-link[data-bs-target='" + s + "']").tab("show");
        var tab = s.replace("#","");
        tab = replaceAll(tab,"-","_");
       
        if(isEmpty(tab)) return;
        var fn1 = "tab_load_"+this.name;
        var fn2 = "tab_load_"+this.name+"_"+tab;
        aevent({action: "setAppTab", param: App.GetCurrentParam(), app: this.name, tab: tab, fn2: fn2});
        App.setLoading(false);
        if(typeof window[fn1] === "function") window[fn1]();
        if(typeof window[fn2] === "function") window[fn2]();
        APPHISTORY_TABS[this.name] = s;
        update_all_aealiveslider_values();
        App.setVersion();
        app_init_topmenu();
        app_init_topmenu_characters_cleanup();
        
    }
    
    static GetCurrentParam(){
        var app = App.GetCurrent();
        var id = app.GetParam(id);
        return id;
    }
    static TabRefresh(){
        var app = App.GetCurrentAppName();
        var tab = App.GetCurrentAppTabName();
        App.LoadApp(app, function(){
            App.changeTab(tab);
        });
    }
    
    static setVersion(){
        $(".aeversion").html(VERSION);
    }
    
    static reverseName(s){
        var tab = replaceAll(s,"_","-");
        return "#"+tab;
    }
    
    GetLastParam(){
        if(typeof(APPHISTORY_PARAMS[this.name]) !== "undefined")
            return APPHISTORY_PARAMS[this.name];
        return "";
    }
    GetLastTab(){
        if(typeof(APPHISTORY_TABS[this.name]) !== "undefined")
            return APPHISTORY_TABS[this.name];
        return null;
    }
    
    static setLoading(b){
        if(b){
            $("#mainapp").addClass("app-loaded");
        } else {
            $("#mainapp").removeClass("app-loaded");
        }
    }

    static GetCurrent() {
        return new App(App.GetCurrentAppName());
    }

    static GetCurrentAppTab() {
        if ($(".nav-tabs .nav-link.active").length < 1)
            return '';
        return $(".nav-tabs .nav-link.active").attr("data-bs-target");
    }
     static GetCurrentAppTabName() {
        var tab = App.GetCurrentAppTab();
        return tab.replace("#","");
    }

    static GetCurrentAppName() {
        return $("#mainapp").attr('data-app');
    }
    static ShowApp() {
        $("#mainapp").fadeIn(300);
    }
    static ClearApp() {
        $("#mainapp").fadeOut(300);
    }

    static LoadApp(s,f ) {
        (new App(s)).Load(f);
    }

    IsCharacter() {
        if (this.Meta("icon") === "person")
            return true;
        return false;
    }

    Meta(s) {
        return META[this.name][s];
    }

    Load(f) {
        var oldapp = App.GetCurrent().name || "";
        var oldtab = $(".app-tabs .nav-link.active").attr("data-bs-target")|| "";
        $("#mainapp").html("LOAD " + this.name);

        if (isTrue(this.Meta("fullscreen"))) {
            $("#app").addClass('full-screen-app');
        } else {
            $("#app").removeClass('full-screen-app');
        }

        var html = $(TPL[this.name]);
        html.addClass(("cpl"));


//        if (!this.Meta("hideTitle")) {
//            var title = '<div class="app-title ' + /*this.GetTitleClass()+*/'">'
//                    + '<div class="app-title-text">'
//                    + this.Meta("title")
//                    + '</div>'
//                    + '<div class="app-title-buttons">';
//            if (typeof (this.Meta("titleButtons")) !== "undefined") {
//                if (this.Meta("titleButtons").includes("refresh"))
//                    title += '<span class="app-title-button-refresh material-symbols-outlined">refresh</span>';
//                if (this.Meta("titleButtons").includes("close"))
//                    title += '<span class="app-title-button-close  material-symbols-outlined">close</span>';
//            }
//            title += '</div>'
//                    + '</div>';
//            html.prepend(title);
//        }

        this.Prepare(html);
        html = App.prepareFormRange(html);
        $("#mainapp").html("");
        $("#mainapp").append(html);
        $("#mainapp").attr('data-app', this.name);
        app_init_topmenu();
        app_apphistory_add_app(this.name);
        aevent({action: "setApp", app: this.name, oldapp: oldapp, oldtab: oldtab});
        app_init_keyboards();
        app_android_add_character_bar();        
        this.PostPrepare();
        if(typeof f === "function") f();
        this.autoselectFirstTab();
        page_fraemework_init_tab_content();
        fraemework_aesettings_update_elements();
        update_all_aealiveslider_values();
        app_settings_update_gameplay_values();
        modals_close_all();
        app_init_topmenu_characters_cleanup();
        App.setVersion();
        Language.translateAll();
        update_selected_person_name();
    }
    
    static changeTab(t){
        var app = $("#mainapp").attr('data-app');
        if(t=== null){
            $(".app-tabs .nav-link").first().trigger("mousedown");
            return;
        }
        if($(".app-tabs .nav-link[data-bs-target='#"+t+"']").length > 0 ){
            $(".app-tabs .nav-link[data-bs-target='#"+t+"']").first().trigger("mousedown");
            return;
        }
        if($(".app-tabs .nav-link[data-bs-target='#tab-"+app+"-"+t+"']").length > 0 ){
            $(".app-tabs .nav-link[data-bs-target='#tab-"+app+"-"+t+"']").first().trigger("mousedown");
            return;
        }
    }
    
    autoselectFirstTab(){
        var tab = "";
        if($(".app-tabs .nav-link").length < 1) return;
        if($(".app-tabs .nav-link").length > 0){
            if($(".app-tabs .nav-link.active").length < 1){
                tab = $(".app-tabs .nav-link").first().attr('data-bs-target');
                    if(!isEmpty(APPHISTORY_TABS[this.name])) tab = APPHISTORY_TABS[this.name];
            }
        }
        this.SetTab(tab);
    }

    static prepareFormRange(html) {
        $(html).find(".form-range").each(function (k, v) {
            if($(this).hasClass("form-range-full")) return;
            var val = $(this).val();
            var el = $('<input type="text" class="form-range-preview keyboard" value="'+val+'" />');
            $(v).parent().append(el);
        });
        return html;

    }

    static UnselectedPerson() {
        var current = App.GetCurrent();
        if (isTrue(current.Meta("isPerson"))) {
            App.LoadApp("home");
        }
    }

    GetIconSrc() {
        return "apps/" + this.name + "/" + this.name + ".png";
    }
    GetIconClass() {
        var s = "appicon";
        if (this.Meta("icon") !== undefined) {
            s += " " + this.Meta("icon");
        }
        return s;
    }
    GetTitleClass() {
        var s = "apptitleicon";
        if (this.Meta("icon") !== undefined) {
            s += " " + this.Meta("icon");
        }
        return s;
    }

    Prepare(html) {
        var fn = "app_" + this.name + "_prepare";
        if (typeof (window[fn]) !== "function")
            return;
        html = window[fn](html);
    }

    PostPrepare() {
        var fn = "app_" + this.name + "_postprepare";
        if (typeof (window[fn]) !== "function")
            return;
        window[fn]();
    }

}


function setAppConfirm(app){
    if(App.GetCurrentAppName() !== app){
        App.LoadApp(app);
    }
}
function setTabConfirm(tab){
    var tab2 = App.reverseName(tab);
    var app = App.GetCurrent();
    if(App.GetCurrentAppTab() !== tab2 && !isEmpty(tab2)){
        app.SetTab(tab2);
    }
}class Character extends Module{

    constructor(id) {
        super();
        if (id === "auto" || id === undefined)
            id = character_get_selected();
        this.id = id;
        if (isEmpty(id))
            return;
        if (!this.isGood())
            return;

    }
    isGood() {
        if (isEmpty(this.id))
            return false;
        if (typeof EPHEMERAL.characters[this.id] === null)
            return false;
        return true;
    }
    getData() {
        if (isEmpty(EPHEMERAL.characters[this.id]))
            return null;
        return EPHEMERAL.characters[this.id];
    }
    getSlider(k) {
        return this.getDataFloat(k);
    }
    getDataFloat(k) {
        if (isEmpty(EPHEMERAL.characters[this.id]["sliders"][k]))
            return null;
        return parseFloat(EPHEMERAL.characters[this.id]["sliders"][k]);
    }
    getEnabled(k) {
        if (isEmpty(EPHEMERAL.characters[this.id]["enabled"][k]))
            return null;
        return EPHEMERAL.characters[this.id]["enabled"][k] === "True";
    }

    getBreathingRatePercent() {
        var val = this.getSlider("breathing_rate");
        return get_percent_on_range(val, 0, 30);
    }
    getHeartRatePercent() {
        var val = this.getSlider("heartrate_rate");
        return get_percent_on_range(val, 0, 145);
    }
    getTiredRatePercent() {
        var val = this.getSlider("tired_rate");
        return get_percent_on_range(val, 0, 100);
    }

}

class Compiler extends Module{
    
    static apps = [
        "actions",
        "addons",
        "android",
        "androids",
        "apphistory",
        "atom",
        "business",
        "characters",
        "clothing",
        "debug",
        "demo", 
        "hair", 
        "help",
        "home", 
        "homescreen",
        "interaction",
        "loading",
        "makeup",
        "music",
        "posing",
        "scene",
        "settings",
        "settingsinfo",
        "soundpad",
        "speech",
        "status",
        "tvremote",
        "virtualdoll",
        "vrgolf"
    ];
        
    static Compile(){
        var c = new Compiler();
        var html = "";
        var html_clone = $("html").clone();
        html_clone.find(".cpl").remove();
        html_clone.find('.aetooltip-initiated').removeClass("aetooltip-initiated");
        html_clone.find(".initiated").removeClass('initiated');
        Compiler.AddApps(html_clone);
        var h = '<!doctype html><html>'+html_clone.html()+'</html>';
        $("html").html('<textarea style="width:100%;min-height:60vh;"><!doctype html><html>'+html_clone.html()+'</html></textarea>');
        console.log(h);
    }
    
    static AddApps(html){
        for(var a of this.apps){
            html.find("head").append('<script  class="cpl" src="apps/'+a+'/'+a+'.js"></script>');
            html.find("head").append('<script  class="cpl" src="apps/'+a+'/'+a+'.tpl.html"></script>');
            html.find("head").append('<script  class="cpl" src="apps/'+a+'/'+a+'.meta.js"></script>');
            html.find("head").append('<link class="cpl" rel="stylesheet" href="apps/'+a+'/'+a+'.css">');
        }
    }
}class Corp extends Module {
    id;name;price;quality;intelligence;

    constructor(id = null) {
        super();
        this.id = id;
        var data = Corp._getMap()[id];
        for(var k of Object.keys(data)){
            this[k] = data[k];
        }
    }

    static _getMap() {
        const data = [
            {
                id: 0,
                name: "Minisoft Corp",
                price: 1.2,
                quality: 1.1,
                intelligence: 0.9
            },
            {
                id: 1,
                name: "PinnacleCorp",
                price: 1.5,
                quality: 1.4,
                intelligence: 1.2
            },
            {
                id: 2,
                name: "NILE Services",
                price: 1.25,
                quality: 1.2,
                intelligence: 1.1
            },
            {
                id: 3,
                name: "Googlue Inc.",
                price: 1.4,
                quality: 1.2,
                intelligence: 1.3
            },
            {
                id: 4,
                name: "Metabook",
                price: 1,
                quality: 1,
                intelligence: 1.0
            },
            {
                id: 5,
                name: "ReactiVision",
                price: 0.85,
                quality: 0.8,
                intelligence: 0.8
            },
            {
                id: 6,
                name: "UnrealDoll",
                price: 1.3,
                quality: 1.4,
                intelligence: 0.9
            },
            {
                id: 7,
                name: "Mercy-Blendz",
                price: 1.6,
                quality: 1.1,
                intelligence: 1.15
            },
            {
                id: 8,
                name: "NikolaX",
                price: 1.4,
                quality: 1.2,
                intelligence: 1.25
            },
            {
                id: 9,
                name: "Wallmark",
                price: 0.7,
                quality: 0.8,
                intelligence: 0.75
            }
        ];


        return data;
    }
    _getName() {

    }

}class Debug extends Module{
    
    static frozen = false;
    
    static getSnapshot(){
        return Debug.escapeString(JSON.stringify(EPHEMERAL));
    }
    
    static isFrozen(){
        return Debug.frozen;
    }
    
    static escapeString(s){
        return escape(s);
    }

    static setSnapshot(s){
        Debug.frozen = true;
        EPHEMERAL = JSON.parse(s);
        fraemework_process_aesettings(EPHEMERAL.aesettings);
    }
}$(document).ready(function(){
    $("body").on('mousedown',".menu-effects-container .effect-cancel",function(){
        var name = $(this).parents(".menu-effects-container").attr("data-effect");
        if(isEmpty((name))) return;
        var effect = new Effect({name:name});
        effect.cancel();
        modals_close_all();
    });
     $("body").on('mousedown',".menu-effects-container .effect-cancel-all",function(){
        Effect.cancelAll();
        modals_close_all();
    });
    $("body").on('mousedown','#bottom-menu .person-effect', function(){
        var name = $(this).attr('data-effect');
        var effect = new Effect(EPHEMERAL.tempdata.effects[SELECTED_PERSON][name]);
        effect.showPopup();
        
    });
});


function effects_populate() {
    var destination = $("#bottom-menu .person-effects");
    destination.find('.person-effect.new').remove();
    if (EPHEMERAL.tempdata.effects[SELECTED_PERSON] === undefined)
        return;
  
    
    
    var demo = destination.find(".person-effect.demoitem");
    $.each(EPHEMERAL.tempdata.effects[SELECTED_PERSON], function (k, v) {
        var effect = new Effect(v);
        if (!effect.isEnabled()) return;
        var item = demo.clone();
        item.addClass("new");
        if(effect.isAuto()) item.addClass("is-auto");
        item.removeClass("demoitem");
        item.addClass("effect-" + effect.name).attr("data-effect", effect.name).attr('data-title',effect.title);
        item.find(".aeicon").addClass(effect.getIconClass());
        item.find(".title").html(effect.title);
        destination.append(item);
    });
}


function effects_person_changed(data){
    data = JSON.parse(data);
    var info = data.info;
    delete data.info;
    EPHEMERAL.tempdata.effects[info.person] = data;
    if(info.person === SELECTED_PERSON){
        effects_populate();
    }
    update_all_aealiveslider_values();
}

class Effect {

    
    constructor(o) {
        this.name = o.name;
        this.title = o.title;
        this.count = o.count;
        this.enabled = o.enabled;
        this.param = o.param;
        this.auto = o.isAuto;
    }
    
    
    cancel(){
        aevent({action: "query", context:"effects", query:"cancel", effect:this.name});        
    }
    hasParam(){
        return !isEmpty(this.param);
    }
    isEnabled(){
        return isTrue(this.enabled);
    }
    isAuto(){
        return isTrue(this.auto);
    }
    getIconClass(){
        return 'icon-'+this.name;
    }
    static cancelAll(){
        aevent({action: "query", context:"effects", query:"cancelAll"});
    }
    
    getParam(){
        return ""+this.param;
    }
    
    showPopup(){
        var title = this.title;
        if(this.hasParam()) title+=": "+this.param;
        if(this.isAuto()) title+=" (AI)";
        
        $(".menu-effects-container").attr("data-effect", this.name);
        $(".menu-effects-container .effect-name").html(title);
        var icon = $(".menu-effects-container .aeicon");
        icon.removeClass();
        icon.addClass("aeicon "+this.getIconClass());
         $.dialog({
            backgroundDismiss: true,
            title: '',
            columnClass: 'col-md-12',
            content: $(".menu-effects").html()
        });
    }
    
}class Kobold extends Module{
    
    enabled = false;
    uri = "";
    
    constructor(id = null){
        super();
        this.uri = Settings.getString("sttServicesKoboldApi");
        this.uri = this._fixUrl(this.uri);
        this.enabled = Settings.getBool("sttServicesTextAI");
        if(isEmpty(this.uri)) this.enabled = false;
    }
    
    _fixUrl(string){
        if (string.slice(-1) !== '/') {
            string = string + '/';
        }
        if (string.slice(-5) !== '/api/') {
            string = string.replace(/\/+$/, '') + '/api/';
        }
        
        if(!isUrl(string)) return "";
        return string;
    }
    
    
    getStatus(){
        this.get("v1/info/version",console.log);
    }
    
    
    
    get(api, data, success, error){
        if(!this.enabled) return;
        $.ajax({
            url: this.uri+api,
            type: "GET",
            dataType: "json",
            success: function(data){if(typeof success == "function") sucess(data);},
            error: function(jqXHR, textStatus, errorThrown) {if(typeof error == "function") error(jqXHR, textStatus, errorThrown);}
        });
    }
    
    
    post(api, data, success, error){
        
    }
   
}var SELECTED_PERSON = "";
class Person extends Module {
    constructor(id = null) {
        super();
        if (isEmpty(id))
            return;
        this.id = id;
        if (typeof (EPHEMERAL.characters[id]) === "undefined")
            return;
    }
    getData() {
        return EPHEMERAL.characters[this.id];
    }
    getFloat(k) {
        return parseFloat(this.getData()[k]) || 0;
    }
    getString(k) {
        return this.getData()[k] || "";
    }
    getBool(k) {
        return isTrue(this.getData()[k]);
    }
    isAndroid(){
        return isTrue(this.getBool("isAndroid"));
    }
    getAndroidId() {
        if(this.isEmpty() || isEmpty(this.getData())) return;
        var id = this.getString("androidId");
        return id;
    }

    getAndroid() {
        if(this.isEmpty() || isEmpty(this.getData())) return;
        var id = this.getString("androidId");
        return Android.getFromEphemeral(id);
    }
    
    static getPersonByAndroidId(android_id){
        if(Object.keys(EPHEMERAL.characters).length < 1) return null;
        for (var pid of Object.keys(EPHEMERAL.characters)) {
            if(isTrue(EPHEMERAL.characters[pid].isAndroid)){
                if(""+EPHEMERAL.characters[pid].androidId === ""+android_id){
                    return new Person(pid);
                }
            }
        }
        
    }
    
    static getCurrentAndroidId(){
        var person = new Person(character_get_selected()); 
        if(isEmpty(person)) return;
        var android_id = person.getAndroidId();
        return android_id;
    }

    static getCurrentPerson() {
        if (!isEmpty(character_get_selected()))
            return;
        return new Person(character_get_selected());
    }
    static getClothingItems() {
        if (this.isFemale()) {
            return EPHEMERAL.vamdata.options.femaleClothes;
        } else {
            return EPHEMERAL.vamdata.options.maleClothes;
        }
    }

    static getThumbEmpty() {
        return "resources/characterempty.jpg";
    }

    getAvatarButton() {
        return $("#bottom-menu .person-select-item[data-person='" + this.id + "']");
    }
    getThumb() {
        if (isEmpty(this.getData()))
            return "";
        if (isEmpty(this.getData().strings.gSelectedPreset))
            return "";
        var file = new VamFile("looks", this.getData().strings.gSelectedPreset, true);
        return file.getImageSrc();
    }

    isMale() {
        return !isTrue(this.getData().isFemale);
    }
    isFemale() {
        return isTrue(this.getData().isFemale);
    }

    removePerson() {
        aevent({action: "personDismiss"});
        Person.unselectAll();
        App.UnselectedPerson();
        var o = $("#bottom-menu .person-select-item[data-person='" + this.id + "']");
        o.remove();
        delete EPHEMERAL.characters[this.id];
    }

    static removeSelected() {
        var o = $("#bottom-menu .person-select-item.selected");
        if (o.length < 1)
            return;
        var id = o.attr('data-person');
        o.remove();
        Person.unselectAll();
        delete EPHEMERAL.characters[id];
    }
    static unselectAll() {
        app_init_topmenu();
        app_init_topmenu_characters_cleanup();
        $("body").removeClass("selected-character");
        $("body").removeClass("selected-character-female").removeClass("selected-character-male");
        $("body").removeClass("character-is-android");
        for (var pid of Object.keys(EPHEMERAL.characters)) {
            var character = EPHEMERAL.characters[pid];
            EPHEMERAL.characters[pid].strings["gIsSelected"] = false;
            $("#bottom-menu .person-select-item.selected").removeClass("selected");
        }
        SELECTED_PERSON = "";
        $("body").removeClass("selected-character");
        $("body").removeClass("selected-character-female").removeClass("selected-character-male");
        $("body").removeClass("character-is-android");
        aevent({actionAll: "aliveUnselectPerson", action: "aliveUnselectPerson"});

    }

    getCharacterData() {
        if (typeof EPHEMERAL.characters[this.id] === 'undefined')
            return null;
        var character = EPHEMERAL.characters[this.id];
        return character;
    }

    getImageAvatar() {
        var avatar = "resources/character.jpg";
        var character = this.getCharacterData();
        if (isEmpty(character))
            return avatar;
        if (isTrue(character.isAndroid)) {
            var android = new Android(character.androidId);
            avatar = android.getImageProfileTimestamp();
        }
        return avatar;
    }
    
    getEffect(key){
         if (EPHEMERAL.tempdata.effects[this.id] === undefined) return null;
         if (EPHEMERAL.tempdata.effects[this.id][key] === undefined) return null;
         return new Effect(EPHEMERAL.tempdata.effects[this.id][key]);
    }

    selectPerson() {
        Person.unselectAll();
        $("#bottom-menu .person-select-item.selected").removeClass("selected");
        var character = EPHEMERAL.characters[this.id];
        var el = $("#bottom-menu .person-select-item[data-person='" + this.id + "']");
        EPHEMERAL.characters[this.id].strings["gIsSelected"] = true;
        el.addClass("selected");
        if (this.getBool("isAndroid")) {
            $("body").addClass("character-is-android");
            $("#bottom-menu").addClass("android").attr("data-androidid",this.getAndroidId())
        } else {
            $("body").removeClass("character-is-android");
            $("#bottom-menu").removeClass("android").attr("data-androidid",null);
        }



        if (isTrue(character.isAliveEnabled)) {
            alive_person_enabled_on(character.id);
        } else {
            alive_person_enabled_off(character.id);
        }

        $(".person-bottom-main-avatar-img IMG").attr("src", this.getImageAvatar());
        SELECTED_PERSON = this.id;
        $("body").addClass("selected-character");
        
        if(isTrue(character.isFemale))
            $("body").addClass("selected-character-female");
        else 
            $("body").addClass("selected-character-male");

        aevent({action: "aliveSelectPerson", person: this.id, actionAll: "aliveUnselectPerson"});
        effects_populate();
        character_info_populate(SELECTED_PERSON);
        app_init_topmenu();
        app_init_topmenu_characters_cleanup();
        app_reload_character_app();
        
        
        
        
    }
    isSelected() {
        return isTrue(this.getData().strings["gIsSelected"]);
    }
    isEmpty() {
        return isEmpty(this.id);

    }

    getSliderVal(key) {
        if (isEmpty(this.getData()))
            return null;
        if (isEmpty(this.getData().sliders))
            return null;
        if (isEmpty(this.getData().sliders[key]))
            return null;
        return parseFloat(this.getData().sliders[key]);
    }

    static getSelectedPerson() {
        return new Person(SELECTED_PERSON);
    }

}$(document).ready(function () {
    RIVE = new Rive();
    RIVEARTIFICIAL = new Rive(true);
});

function RIVE_chat(answer,payload) {
    return RIVE.chat(answer,payload);
}

function RIVEARTIFICIAL_chat(answer,payload) {
    return RIVEARTIFICIAL.chat(answer,payload);
}
//RIVE.bot.reply("user", "Hello").then((reply) => {console.log("got reply", reply)});
class Rive extends Module {
    bot = null;
    jsCache = "";
    isArtifical = false;

    constructor(isArtifical = false) {
        super();
        this.isArtifical = isArtifical;
        this.bot = new RiveScript({
            utf8: true,
        });

        var collection = isArtifical ? RIVESCRIPTSARTIFICIAL : RIVESCRIPTS;
        var ite = 0;
        for (var data of collection) {
            this.bot.parse("rivescript " + (++ite), data);
        }
        this.bot.sortReplies();
    }

    reply(msg) {
        this.jsCache = "";
        var originalMessage = msg;
        msg = this.sanitize(msg);
        this.bot.reply("user", msg).then((reply) => {

            var answer = reply;
            if (answer.indexOf("{js}") !== -1) {
                this.jsCache = answer;
                var regex = /\{js\}.*?\{\/js\}/g;
                var matches = answer.match(regex);
                for (var match of matches) {
                    var payload = {};
                    payload.message = originalMessage;
                    payload.replacing = "" + match;
                    match = match.replace(");", ",payload);");
                    match = match.replace("{js}", "");
                    match = match.replace("{/js}", "");
//                    console.log("js eval", payload, match);
                    eval(match);
                }


            } else {
                var payload = {};
                payload.message = originalMessage;
                this.chat(answer, payload);
            }

        });
    }

    isError(msg) {
        return (msg.indexOf("ERR:") === 0);
    }

    sanitize(msg, reverse = false) {
        var replace = {
//            "*": " ",
//            "(": "open parenthesis ",
//            ")": "close parenthesis ",
            "+": " plus ",
            "-": " ",
            "/": " "
        }
        for (var key in replace) {
            if (reverse) {
                msg = replaceAll(msg, replace[key], key);
            } else {
                msg = replaceAll(msg, key, replace[key]);
            }

        }

        return msg;
    }

    jsCachePending() {
        return this.jsCache.indexOf("{js}") >= 0;
    }
    jsCacheReplace(answer, payload) {
        this.jsCache = this.jsCache.replace(payload.replacing, answer);
//        console.log(["replacing", payload.replacing, answer, RIVE.jsCache]);
        if (!this.jsCachePending()) {
//            console.log("chat finished");
            this.chat(this.jsCache, payload);
            this.jsCache = "";
        }
    }

    chat(answer, payload) {
        if (typeof this === "undefined") return RIVE.chat(answer, payload); //improv fix for older rules some people added
            
        if (this.isArtifical) {
            if (!this.isError(answer)) {
                aevent({action: "interactionUserChatFromAi", answer: answer, message: " ", isArtificial: true});
            }
        } else {

            if (this.jsCachePending()) {
                this.jsCacheReplace(answer, payload);
            } else {


                if (this.isError(answer)) {
                    //submit payload.message to AI if enabled else show error
                    aevent({action: "interactionUserChat", message: payload.message});
                } else {
                    aevent({action: "interactionUserChatFromAi", answer: answer, message: payload.message});
                }

            }
        }
    }
}class Settings{
    static exists(k){
        if(isEmpty(EPHEMERAL.aesettings)) return false;
        if(isEmpty(EPHEMERAL.aesettings[k])) return false;
        return true;
    }
    static getFloat(k){
        var def = 0;
        if(isEmpty(EPHEMERAL.aesettings)) return def;
        if(isEmpty(EPHEMERAL.aesettings[k])) return def;
        return parseFloat((EPHEMERAL.aesettings[k]));
    }
    
    static getInt(k){
        var def = 0;
        if(isEmpty(EPHEMERAL.aesettings)) return def;
        if(isEmpty(EPHEMERAL.aesettings[k])) return def;
        return parseInt((EPHEMERAL.aesettings[k]));
    }
    static getString(k){
        var def = "";
        if(isEmpty(EPHEMERAL.aesettings)) return def;
        if(isEmpty(EPHEMERAL.aesettings[k])) return def;
        return (EPHEMERAL.aesettings[k]);
    }
    
     static getBool(k){
        var def = false;
        if(isEmpty(EPHEMERAL.aesettings)) return def;
        if(isEmpty(EPHEMERAL.aesettings[k])) return def;
        return isTrue(EPHEMERAL.aesettings[k]);
    }
  
}class Triggers extends Module {
    static log = {};
    static logLimit = 50;
    static logId = 0;
    
    
    
    static addEvent(data){
        if(Triggers.skipEvent(data)) return;
        data = JSON.parse(JSON.stringify(data));
        data = Triggers.cleanEvent(data);
        Triggers.log[Triggers.logId] = data;
        Triggers.logId++;
        Triggers.cleanOlderEvents();
    }
    
    static skipEvent(data){
        if(data.action === "setAppTab" || data.action === "setApp"){
            if(data.app=== "triggers") return true;
        }
        return false;
    }
 
    static cleanOlderEvents(){
        for (var i = Triggers.logId - 1 - Triggers.logLimit; i >= 0; i--){
            if(typeof Triggers.log[i] === "undefined") break;
            delete Triggers.log[i];
        }
    }
    
    static cleanEvent(data){
        if(typeof data.t !== 'undefined') delete data.t;
        if(typeof data.person !== 'undefined') delete data.person;
        if(typeof data.android !== 'undefined' && ""+data.android === "0") delete data.android;
        return data;
    }

    static getTitle(data){
        var title = data.action;
        if(title === "query"){
            title = data.action+":"+data.context+":"+data.query;
        }
        return title;
    }

}class Language extends Module {
   static activeLanguage = "en";
   
   static setLanguage(code){
       if(code === "" || code === null || code == undefined){
           code = "en";
       }
       Language.activeLanguage = code;
       Language.translateAll();
       $(".aetooltip-initiated").removeClass("aetooltip-initiated");
       cron_tooltips();
   }
   
   
   static translateAll(){
       $('.t').each(function(){
           var s = $(this).text();
           if(typeof($(this).attr("data-t")) !== "undefined"){
               s = $(this).attr("data-t");
           }
           var t = Language.getTranslated(s);
           $(this).html(t);
           $(this).attr("data-t", s);
       });
   }
   
   static getTranslated(s){
       if(Language.activeLanguage === "en") return s;
       if(typeof(LANG[s]) !== "undefined"){
           return LANG[s][Language.activeLanguage];
       }
       return s;
   }
   
   static getMap(){
       return JSON.stringify(LANG);
   }
   
}
RIVESCRIPTS.push(`

+ reset pose [please]
- Resetting pose!{js}brain_alive_reset_pose(RIVE_chat);{/js}

+ (move to me|come to me|come here) [please]
- {js}brain_alive_person_come_here(RIVE_chat);{/js}

+ (move to center|go to center|recenter)
- Going to center!{js}brain_alive_person_move_recenter(RIVE_chat);{/js}

+ (move to flag/go to center)
- Moving to flag!{js}brain_alive_person_move_flag(RIVE_chat);{/js}

+ (come to me|Komm zu mir|Ven a mí|Viens à moi|Vieni da me|こっちに来て|내게 와|Venha até mim|过来|Подойди ко мне)
- {ai}{js}brain_alive_person_come_here(RIVE_chat);{/js}

+ (turn around|Dich umdrehen|Girar|Tourne-toi|Girati|回れ|돌아서다|Gire-se|转身|Повернись)
- {ai}{js}brain_alive_person_turn_around(RIVE_chat);{/js}

+ turn left [please]
- Ok, I'm turning to my left.{js}brain_alive_person_turn_left(RIVE_chat);{/js}

+ turn right [please]
- Ok, I'm turning to my right.{js}brain_alive_person_turn_right(RIVE_chat);{/js}

+ smile [please]
- {js}brain_alive_person_expression(RIVE_chat,'smile','medium');{/js}

+ frown [please]
- {js}brain_alive_person_expression(RIVE_chat,'frown','medium');{/js}

+ move (up|further|further away|away) (*m|#|* meter|* meters) [please]
- Ok, I'm moving away: {js}brain_alive_person_move(RIVE_chat,"w", "<star2>");{/js}

+ move (up|further|further away|away)[please]
- Ok, I'm moving away: {js}brain_alive_person_move(RIVE_chat,"w", "<star2>");{/js}

+ move (down|closer) (*m|#|* meter|* meters) [please]
- Ok, I'm moving closer: {js}brain_alive_person_move(RIVE_chat,"s","<star2>");{/js}

+ move (down|closer) [please]
- Ok, I'm moving closer: {js}brain_alive_person_move(RIVE_chat,"s","<star2>");{/js}

+ move (left) (*m|#|* meter|* meters) [please]
- Ok, I'm moving left: {js}brain_alive_person_move(RIVE_chat,"a","<star2>");{/js}

+ move (left) [please]
- Ok, I'm moving left: {js}brain_alive_person_move(RIVE_chat,"a","<star2>");{/js}

+ move (right) (*m|#|* meter|* meters) [please]
- Ok, I'm moving right: {js}brain_alive_person_move(RIVE_chat,"d","<star2>");{/js}

+ move (right) [please]
- Ok, I'm moving right: {js}brain_alive_person_move(RIVE_chat,"d","<star2>");{/js}

+ echo *
- {js}brain_debug_echo(RIVE_chat,"<star>");{/js}

+ do (standing|sitting|lying|crouching) pose (#|random)
- Changing pose to <star1> <star2> {js}brain_alive_person_pose(RIVE_chat,"<star1>","<star2>");{/js}

+ change pose (standing|sitting|lying|crouching) (#|random)
- Changing pose to <star1>:  {js}brain_alive_person_pose(RIVE_chat,"<star1>","<star2>");{/js}

+ change pose (standing|sitting|lying|crouching)
- Picking a random <star1> pose: {js}brain_alive_person_pose(RIVE_chat,"<star1>","random");{/js}

+ (trigger|auslösen|activar|déclencher|attivare|トリガー|트리거|acionar|触发|запуск) *
- {js}brain_vam_trigger(RIVE_chat,"<star2>");{/js}

+ (show me what you see|you see *|you are seeing|you are seeing *)
- {js}brain_vam_show_sight(RIVE_chat);{/js}

+ (react|What do you see?|Was siehst du?|¿Qué ves?|Que vois-tu ?|Cosa vedi?|何を見ているの？|何が見えますか？|무엇을 보고 있나요?|O que você vê?|你看到了什么？|Что ты видишь?)
- {js}brain_vam_show_sight(RIVE_chat);{/js}

+ (loreipsum|loremipsum)
- "The quick brown fox jumps over the lazy dog" is an English-language pangram – a sentence that contains all the letters of the alphabet. The phrase is commonly used for touch-typing practice, testing typewriters and computer keyboards, displaying examples of fonts, and other applications.

+ poeme 1
- Oui. Je comprends qu'on aille aux fêtes.

+ poeme 2
- Oui. Je comprends qu'on aille aux fêtes. Qu'on soit foule, qu'on brille aux yeux. Qu'on fasse, amis, ce que vous faites. Et qu'on trouve cela joyeux ; Mais vivre seul sous les étoiles, Aller et venir sous les voiles. Du désert où nous oublions, Respirer l'immense atmosphère ; C'est âpre et triste, et je préfère... Cette habitude des lions.



`);




function brain_alive_reset_pose(callback, payload) {
    aevent({action: "aliveResetPose"});
    callback("", payload);
}

function brain_alive_person_come_here(callback, payload) {
    aevent({action: "personComeHere"});
    callback("", payload);
}
function brain_alive_person_move_recenter(callback, payload) {
    aevent({action: "aliveRecenterPerson"});
    callback("", payload);
}
function brain_alive_person_move_flag(callback, payload) {
    aevent({action: "personMoveToFlag"});
    callback("", payload);
}

function brain_alive_person_turn_around(callback, payload) {
    aevent({action: 'poseRotationAdd', value: 180, direct: true});
    callback("", payload);
}

function brain_alive_person_turn_left(callback, payload) {
    aevent({action: 'poseRotationAdd', value: 90, direct: true});
    callback("", payload);
}

function brain_alive_person_turn_right(callback, payload) {
    aevent({action: 'poseRotationAdd', value: -90, direct: true});
    callback("", payload);
}

function brain_alive_person_expression(callback, expression, duration, payload) {
    aevent({action: 'setExpression', expression: expression, duration: duration});
    callback("", payload);
}

function brain_alive_person_move(callback, direction, distance, payload) {
    var val = 0.5;
    if (distance !== null && distance != "") {
        distance = distance.replace(" meters");
        distance = distance.replace("m");
        distance = parseFloat(distance);
        if (distance > 0)
            val = distance;
    }
    aevent({action: "poseMove", value: val, direction: direction});
    callback(distance + " meters.", payload);
}

function brain_debug_echo(callback, text, payload) {
    msg = payload.message.replace("echo ", "");
    callback(msg , payload);
}

function brain_alive_person_pose(callback, pose, number, payload) {
    var poses = JSON.parse(EPHEMERAL.vamdata.poses);
    var keys = Object.keys(poses).reverse();
    if (keys.length > 1) {
        for (var key of keys) {
            if (key.toLowerCase() === "aes-" + pose) {
                var posesCount = parseInt(poses[key]);
                if (posesCount !== null) {
                    if (number === "random") {
                        number = randomIntFromInterval(1, posesCount);
                    } else {
                        number = parseInt(number);
                    }
                    if (number < 0 ) number = 0;
                    if(number > posesCount) number = posesCount;
                    var poseid = number.toString().padStart(3, '0');
                    aevent({action: 'changePose', posefolder: key, poseid: poseid});
                    break;
                }
            }
        }
    }

    callback(number, payload);
}

function brain_vam_trigger(callback,trigger,payload){
    trigger = trigger.replace(/[^a-z0-9]/gi, "");
    aevent({action:"vamTriggerButton",id:trigger});
    callback(trigger, payload);
}

function brain_vam_show_sight(callback, payload) {
    var msg = "";
    aevent({ action: "query", context: "android", query: "showSight" });
    callback(msg, payload);
}RIVESCRIPTS.push(`

// Arrays

// Set arrays
! array malenoun   = male guy boy dude boi man men gentleman gentlemen
! array femalenoun = female girl chick woman women lady babe
! array mennoun    = males guys boys dudes bois men gentlemen
! array womennoun  = females girls chicks women ladies babes
! array lol        = lol lmao rofl rotfl haha hahaha
! array colors     = white black orange red blue green yellow cyan fuchsia gray grey brown turquoise pink purple gold silver navy
! array height     = tall long wide thick
! array yes        = yes|yeah|yep|yup|ya|yea
! array no         = no nah nope nay


`);
RIVESCRIPTS.push(`

// Substitutions
! sub pls       = please
! sub plz       = please
! sub &quot;    = "
! sub &apos;    = '
! sub &amp;     = &
! sub &lt;      = <
! sub &gt;      = >
! sub +         = plus
! sub -         = minus
! sub /         = divided
! sub *         = times
! sub i'm       = i am
! sub i'd       = i would
! sub i've      = i have
! sub i'll      = i will
! sub don't     = do not
! sub isn't     = is not
! sub you'd     = you would
! sub you're    = you are
! sub you've    = you have
! sub you'll    = you will
! sub he'd      = he would
! sub he's      = he is
! sub he'll     = he will
! sub she'd     = she would
! sub she's     = she is
! sub she'll    = she will
! sub they'd    = they would
! sub they're   = they are
! sub they've   = they have
! sub they'll   = they will
! sub we'd      = we would
! sub we're     = we are
! sub we've     = we have
! sub we'll     = we will
! sub whats     = what is
! sub what's    = what is
! sub what're   = what are
! sub what've   = what have
! sub what'll   = what will
! sub can't     = can not
! sub whos      = who is
! sub who's     = who is
! sub who'd     = who would
! sub who'll    = who will
! sub don't     = do not
! sub didn't    = did not
! sub it's      = it is
! sub could've  = could have
! sub couldn't  = could not
! sub should've = should have
! sub shouldn't = should not
! sub would've  = would have
! sub wouldn't  = would not
! sub when's    = when is
! sub when're   = when are
! sub when'd    = when did
! sub im        = i am
! sub wat       = what
! sub wats      = what is
! sub ohh       = oh
! sub becuse    = because
! sub becasue   = because
! sub becuase   = because
! sub practise  = practice
! sub its a     = it is a
! sub fav       = favorite
! sub fave      = favorite
! sub yesi      = yes i
! sub yetit     = yet it
! sub iam       = i am
! sub welli     = well i
! sub wellit    = well it
! sub amfine    = am fine
! sub aman      = am an
! sub amon      = am on
! sub amnot     = am not
! sub realy     = really
! sub iamusing  = i am using
! sub amleaving = am leaving
! sub yuo       = you
! sub youre     = you are
! sub didnt     = did not
! sub ain't     = is not
! sub aint      = is not
! sub wanna     = want to
! sub brb       = be right back
! sub bbl       = be back later
! sub gtg       = got to go
! sub g2g       = got to go
! sub lyl       = love you lots
! sub gf        = girlfriend
! sub g/f       = girlfriend
! sub bf        = boyfriend
! sub b/f       = boyfriend
! sub b/f/f     = best friend forever
! sub :-)       = smile
! sub :)        = smile
! sub :d        = grin
! sub :-d       = grin
! sub :-p       = tongue
! sub :p        = tongue
! sub ;-)       = wink
! sub ;)        = wink
! sub :-(       = sad
! sub :(        = sad
! sub :'(       = cry
! sub :-[       = shy
! sub :-\       = uncertain
! sub :-/       = uncertain
! sub :-s       = uncertain
! sub 8-)       = cool
! sub :-*       = kissyface
! sub :-!       = foot
! sub o:-)      = angel
! sub >:o       = angry
! sub :@        = angry
! sub 8o|       = angry
! sub :$        = blush
! sub :-$       = blush
! sub :-[       = blush
! sub :[        = bat
! sub (a)       = angel
! sub (h)       = cool
! sub 8-|       = nerdy
! sub |-)       = tired
! sub +o(       = ill
! sub *-)       = uncertain
! sub ^o)       = raised eyebrow


// Person substitutions
! person i am    = you are
! person you are = I am
! person i'm     = you're
! person you're  = I'm
! person my      = your
! person your    = my
! person you     = I
! person i       = you



`);
/* 
 * 
 * .rive.js brain files get loaded by the live assistant when aeternum UI loads. When chatting, the assistant will first look for local rules that match that message and if it finds one it will answer with that, otherwise will proceed with sending the message to the oobabooga AI if it's active
 * 
 *
 * 
 * between `` add normal rivescript rules https://www.rivescript.com/docs/tutorial  https://www.rivescript.com/try, lots of examples there!
 * 
 * At the end you can also add javascript function that get called if the answer has then like {js}function_name(RIVE_chat){/js}.
 * That javascript part gets then replaced with what the function returns.
 * If the input pattern has * or (variant1|variant2), the pattern found will be in variables <star1>,<star2>,..,<starN> where the number is the occurance number, 1st, 2nd, etc.
 * Those can be sent to to javascript.
 * 
 * IMPORTANT! for js function copy paste the structure: inside the {js}{/js} the function has to have RIVE_chat as the first parameter, and to end with );.
 *  Don't stack up js inside {js}{/js}, call a single function there. Then when declaring the function make sure there's a payload argument as well. RIVE_chat & payload are necessary, and in between you can add extra parameters that you want. When done the function must do callback(answer, payload), answer can be an empty string. Calling that will replace the "{js}..{/js}" part with the answer
 * 
 */


RIVESCRIPTS.push(`

+ demo say something random
- This {random}message|sentence{/random} has a random word.
- No. 
- something random



+ demo time
- {js}brain_debug_time(RIVE_chat);{/js}



+ demo calculate * [please]
- {random}It's|It is|That's|Easy.{/random} {js}brain_math_calculate(RIVE_chat,"<star1>");{/js}{random}.|!{/random}



+ demo async * * *
- Delayed chat responses {js}brain_debug_async(RIVE_chat,1, <star1>);{/js}, {js}brain_debug_async(RIVE_chat,2, <star2>);{/js} , {js}brain_debug_async(RIVE_chat,3, <star3>);{/js}


+ demo こんにちは
- こんにちは！



`);


// adds current time in the answer
function brain_debug_time(callback, payload){
    var d = new Date();
    var answer = d.toLocaleTimeString();  
    callback(answer, payload);
}



// calculate formula example
function brain_math_calculate(callback,formula, payload){
    var answer = "";
    formula= RIVE.sanitize(formula,true);
    try{
        answer = eval(formula);
    } catch(error){
        answer = "I don't know." + formula
    };
    callback(answer, payload)
}

// async call example: when finished just call callback(answer, payload);, if there are multiple items waiting, the response should wait for all to finish
// In the example  the command receives 3 numbers, like "demo async 1 2 3" and for each of the numbers it pauses for that number of seconds, so the response in this example comes after 3 seconds (the biggest delay)
function brain_debug_async(callback, id, delay, payload){
    var answer = parseInt(delay)*1000;
    setTimeout(function(){
        callback(answer+" ms", payload);
    }, answer);
}

RIVESCRIPTSARTIFICIAL.push(`



+ [*] coloris * vae [*]
- {js}brain_artificial_magic_coloriscaelum(RIVEARTIFICIAL_chat, "<star>");{/js}

+ [*] musica vae [*] 
- {js}brain_artificial_magic_musica(RIVEARTIFICIAL_chat);{/js}

+ [*] musicstop vae [*] 
- {js}brain_artificial_magic_musicanul(RIVEARTIFICIAL_chat);{/js}

+ [*] boo * vae [*] 
- {js}brain_artificial_magic_boo(RIVEARTIFICIAL_chat, "<star>");{/js}


`);

function brain_artificial_magic_coloriscaelum(callback, color, payload) {
    var response = "";
    if(color.length === 6) color+= color[5];
    if(!isColor(color)) return;
    aevent({"action":"setVamColorMain","value":color});
    callback(response, payload);
}

function brain_artificial_magic_musica(callback,  payload) {
    var response = "";
    aevent({"action":"musicSelectPlaylist","playlist":"Demo"});
    callback(response, payload);
}

function brain_artificial_magic_musicanul(callback, payload) {
    var response = "";
    aevent({"action":"musicStop"});
    callback(response, payload);
}

function brain_artificial_magic_boo(callback, trigger, payload) {
    var response = "";
    trigger = trigger.replace(/[^a-z0-9]/gi, "");
    aevent({action:"vamTriggerButton",id:trigger});
    callback(response, payload);
}


RIVESCRIPTSARTIFICIAL.push(`

+ *virtamate*
- {js}brain_artificial_mention_virtamate(RIVEARTIFICIAL_chat);{/js}

`);


function brain_artificial_mention_virtamate(callback, payload) {    
    var msg = "Virtamate mentioned by AI! ";
    callback(msg, payload);
}


$(document).ready(function () {
    $("#app").on("mousedown",".load-autosave", app_autosaves_load_save)
});

function app_autosaves_prepare(html){
    
}

function app_autosaves_postprepare(){
    
}

function app_autosaves_cron_second(){
    
}

function tab_load_autosaves(){
    
}
function tab_load_autosaves_tab_autosaves_1(){
    aevent({action: "query", context: "filemanagement", query: "refreshSceneAutosaves", callback: "app_autosaves_update_list"});
}

function app_autosaves_on_home_append(element){
    //element.addClass("app-with-effect");
    return element;
}

function app_autosaves_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}

function app_autosaves_update_list(data){
     var dest = $("#autosaves-list");
    var demo = dest.find(".demo");
    dest.find(".new").remove();
    if (typeof data === "string") data = JSON.parse(data);
    if (isEmpty(data)) return;
    
    for (var k of Object.keys(data)) {
        var item = data[k];
        var o = demo.clone();
        o.removeClass("demo").addClass("new");
        var shortname = item.split("/");
        shortname = shortname[shortname.length-1].split("\\");
        shortname = shortname[shortname.length-1].replace(".json","");
        o.find(".name").html(shortname);
        o.find(".name").attr('data-name', shortname);
        dest.append(o);
    }
}

function app_autosaves_load_save(event){
    var o = $(event.currentTarget);
    var el = o.parents(".autosave-entry");
    var scene = el.find('.name').attr('data-name');
    
    var $cancel = Language.getTranslated("cancel");
    var $confirm = Language.getTranslated("confirm");
     $.confirm({
        theme: 'material',
        title: Language.getTranslated('Load scene?'),
        content: Language.getTranslated("The current scene will be lost and ALIVE will load the selected autosave. Continue?"),
        columnClass: 'col-md-12',
        buttons: {
            [$cancel]: function () {

            },
            [$confirm]: function () {
                aevent({action: "query", context: "filemanagement", query: "loadAutosave", save: scene});
            },
        }
    });
    
    
}TPL["autosaves"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-autosaves-1" >Autosaves</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-autosaves-settings" >Settings</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-autosaves-1">
                <div class="container py-3" id="autosaves-list">
                    <div class="row autosave-entry demo">
                        <div class="col-9 name"></div>
                        <div class="col-3"><div class="btn btn-secondary btn-sm load-autosave t w-100">Load</div></div>
                    </div>
                </div>
            </div>
            <div class="tab-pane fade" id="tab-autosaves-settings">


                <div class="container ">
                    <div class="row my-3">
                        <div class="col-12"><h4 class="t section-title">Settings</h4></div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Enable autosaves:</label>
                        </div>
                        <div class="col-6 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stAutosavesEnabled" />
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">When enabled, Alive will autosave the current scene in Saves/PluginData/Aeternum/Autosaves. By default this is Enabled (<b>1</b>).</div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Number of saves:</label>
                        </div>
                        <div class="col-6">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stAutosavesCount" min="3" max="100" step="1">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">The number of autosaves to keep on disk. Default is <b>10</b>.</div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Save interval (minutes):</label>
                        </div>
                        <div class="col-6">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stAutosavesInterval" min="1" max="60" step="1">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">The number of minutes between saves. Default is <b>15</b>.</div>
                    </div>

                </div>

            </div>
            <div class="tab-pane fade" id="tab-autosaves-2">


            </div>
            <div class="tab-pane fade" id="tab-autosaves-3">


            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["autosaves"] = {
    title: "Autosaves",
    titleButtons: ["close"],
    icon: "vam",
};$(document).ready(function () {

});
function app_credits_prepare(html) {

}

function app_credits_postprepare() {

}

function app_credits_cron_second() {

}

function tab_load_credits() {

}
function tab_load_credits_tab_credits_1() {

}
function tab_load_credits_tab_credits_3() {
    aevent({action: "query", context: "dependencies", query: "refreshSceneDependencies", callback: "app_credits_update_scene_dependencies"});
}

function app_credits_on_home_append(element) {
    //element.addClass("app-with-effect");
    return element;
}

function app_credits_on_aesetting_change(params) {
    switch (params.setting) {
        case "settingname":

            break;
    }
}

function get_license_class(s){
    s = s.toLowerCase();
    s = replaceAll(s," ","");
    s = replaceAll(s,"-","");
    return "license-"+s;
}
function app_credits_update_scene_dependencies(data) {

    var dest = $("#credits-addons-list");
    var destquickcredits = $("#credits-quickcredits");
    var quickcredits= "";
    var demo = dest.find(".demo");
    dest.find(".new").remove();
    if (typeof data === "string") data = JSON.parse(data);
    destquickcredits.val("");

    if (isEmpty(data))
        return;
    

    for (var k of Object.keys(data)) {
        var item = data[k];
        var o = demo.clone();
        var deps = Object.keys(item.dependencies).length || 0;
        o.removeClass("demo").addClass("new");
        o.find('.author').html(item.creatorName);
        o.find('.name').html(item.name);
        o.find('.dependencies').html(deps).addClass(deps>0 ? "has-deps" :"no-deps");
        o.find('.license').html(item.licenseType).addClass(get_license_class(item.licenseType));
        dest.append(o);
        
        quickcredits+="* "+item.packageName +" by "+item.creatorName+" ("+item.name+") licensed as "+item.licenseType+". "+ item.promotionalLink+"\n";
    }

    destquickcredits.val(quickcredits);

}
TPL["credits"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-credits-1" >Alive</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-credits-2" >Home</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-credits-3" >This Scene</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-credits-1">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <table class="aetable w-100">
                                <tr>
                                    <th class="t">Author</th>
                                    <th class="t">Asset</th>
                                    <th class="t">Link (click to copy)</th>
                                </tr>
                                <tr>
                                    <td>AcidBubbles</td>
                                    <td>TriggerHandler logic in geesp0t's Spanking Plugin</td>
                                    <td class="copy-clipboard">patreon.com/acidbubbles</td>
                                </tr>
                                <tr>
                                    <td>Ascorad</td>
                                    <td>ascorad.asco_Expressions.12</td>
                                    <td class="copy-clipboard">patreon.com/ascorad</td>
                                </tr>
                                <tr>
                                    <td>AshAuryn</td>
                                    <td>AshAuryn.Expressions.2 <br/> AshAuryn.Pose_Tools.2 <br/> AshAuryn.Sexpressions.2 <br/>AshAuryn.AshAuryn's_Female_Genitalia_Collection.2 <br/> AshAuryn.AshAuryn's_Assorted_Expression_Pack_with_75_Morphs.7 <br/> AshAuryn.AshAuryn's_Tears_and_Pain_Pack.3 <br/> AshAuryn.AshAuryn_Sexpressions_2_Point_0.4<br/> AshAuryn.Expressions.5<br/> AshAuryn.Pose_Tools.4</td>
                                    <td class="copy-clipboard">patreon.com/ashauryn</td>
                                </tr>
                                <tr>
                                    <td>geesp0t</td>
                                    <td>Spankings Plugin Mod v3.6</td>
                                    <td class="copy-clipboard">https://www.reddit.com/r/VAMscenes/comments/ferdd8/spankings_plugin_mod_and_physics_sounds_v35/</td>
                                </tr>
                                <tr>
                                    <td>Jackaroo</td>
                                    <td>Jackaroo.JarModularExpressions.2</td>
                                    <td class="copy-clipboard">patreon.com/Jackaroo</td>
                                </tr>
                                <tr>
                                    <td>kemenate</td>
                                    <td>kemenate.Morphs.10</td>
                                    <td class="copy-clipboard">patreon.com/kemenate</td>
                                </tr>
                                <tr>
                                    <td>klphgz</td>
                                    <td>Crouching, Standing, Lying & Prone, Sitting poses packs</td>
                                    <td class="copy-clipboard">patreon.com/klphgz</td>
                                </tr>
                                <tr>
                                    <td>VamX</td>
                                    <td>vamX.VAMasutra.1</td>
                                    <td class="copy-clipboard">patreon.com/vamx</td>
                                </tr>
                                <tr>
                                    <td>VamDeluxe</td>
                                    <td>vamX.VAMasutra.1</td>
                                    <td class="copy-clipboard"></td>
                                </tr>
                                <tr>
                                    <td>VRAdultFun</td>
                                    <td>BVHPlayer v1.1.3</td>
                                    <td class="copy-clipboard">patreon.com/vradultfun</td>
                                </tr>
                                <tr>
                                    <td>ElkVR</td>
                                    <td>BVHPlayer v1.1.3</td>
                                    <td class="copy-clipboard"></td>
                                </tr>
                                
                                <tr>
                                    <td>DasBoot</td>
                                    <td>Eyeshadow_and_Eyeliner.4</td>
                                    <td class="copy-clipboard"></td>
                                </tr>
                                <tr>
                                    <td>Tomynator</td>
                                    <td>2024_makeup.2, 2023_tattoo_pack_Makeup.3 </td>
                                    <td class="copy-clipboard">patreon.com/Tomynator</td>
                                </tr>
                                <tr>
                                    <td>oomphy</td>
                                    <td>make_up_pack.1</td>
                                    <td class="copy-clipboard">patreon.com/oomphy</td>
                                </tr>
                                <tr>
                                    <td>Jackaroo</td>
                                    <td>VAM Textures</td>
                                    <td class="copy-clipboard">patreon.com/Jackaroo</td>
                                </tr>

                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div class="tab-pane fade" id="tab-credits-2">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <h3>Old Alive Home CC-BY assets from sketchfab.com</h3>
                            <textarea class="w-100" style="height:300px">
"Minimalistic Modern Bedroom" (https://skfb.ly/oCnNx) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Modern Office" (https://skfb.ly/oDPCS) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Small Modern Kitchen" (https://skfb.ly/oERJX) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Modern Dining Room" (https://skfb.ly/oz7w6) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"White Modern Living Room" (https://skfb.ly/oCoML) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Modern Bathroom" (https://skfb.ly/oDJBG) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Dome Showcase" (https://skfb.ly/oEyKs) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Floors and ceiling (Modular Construction Pack)" (https://skfb.ly/6X7XY) by BlackMonolith is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Seaside Balcony" (https://skfb.ly/oytL8) by dylanheyes is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"elevator" (https://skfb.ly/o8UXW) by 1-3D.com is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Low Poly Small Film Studio" (https://skfb.ly/6XsT6) by AnshiNoWara is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Home Theater" (https://skfb.ly/6ZBoV) by tojiro is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Curtains" (https://skfb.ly/6D7TY) by daedaljs is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Futuristic Chair" (https://skfb.ly/oxTsV) by 3D_for_everyone is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Speaker" (https://skfb.ly/66KzR) by Andulil is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Estatua / Statue" (https://skfb.ly/D7Eq) by Huargenn is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Statue" (https://skfb.ly/opuMP) by DJMaesen is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Griffon statue" (https://skfb.ly/osBoT) by Feivelyn is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Statue" (https://skfb.ly/oqJKy) by Dávid Ludvig is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Dusty Old Bookshelf (FREE)" (https://skfb.ly/6pXG6) by Brandon Westlake is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).


"Desktop PC" (https://skfb.ly/oxnww) by AFX/CGMotion 3DModel Maker is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Clock" (https://skfb.ly/6uzQt) by oscarherry3d is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"AC - Air Conditioner" (https://skfb.ly/6BWVG) by Auspicious Art and Graphics (AAG) is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Roomba" (https://skfb.ly/6UX8x) by Macwithav is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Cardboard box set 2 Low poly" (https://skfb.ly/ovALG) by Watanuki_San is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Night Sky Visible Spectrum Monochromatic" (https://skfb.ly/osLuS) by commonfactory is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Door" (https://skfb.ly/opVZ9) by Arnau Rocher Alcayde is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Post soviet lowpoly buildings" (https://skfb.ly/or6FL) by Mince is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Low Poly People Free Sample Pack" (https://skfb.ly/o7Hw9) by Denys Almaral is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Toilet" (https://skfb.ly/6S9CM) by HippoStance is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"toilet paper dispenser" (https://skfb.ly/6QYys) by tobei is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Henrik Wool Rug 160x230cm, Mustard and Grey" (https://skfb.ly/6ywBR) by MADE.COM is licensed under Creative Commons Attribution-NonCommercial (http://creativecommons.org/licenses/by-nc/4.0/).

"Simple chair" (https://skfb.ly/6VVNA) by MrFreeman is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Simple Grass Ground (Free Low Model)" (https://skfb.ly/oywq8) by Shun Koizumi is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Hand Painted Grasses" (https://skfb.ly/XG78) by PiyalakNuchim is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Lowpoly rock - 07" (https://skfb.ly/6AJWW) by Loïc Norgeot is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Simple Star (Lowpoly)" (https://skfb.ly/6WZJZ) by Fernando is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Diamond" (https://skfb.ly/6uSHL) by DarkPixel Studios is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Lowpoly Car - Saab 900" (https://skfb.ly/SUCU) by Albn is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Camping bonfire grill" (https://skfb.ly/o8Nzr) by Blarb is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Ship Deck balcony" (https://skfb.ly/otVsI) by Nofil.Khan is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Ladder, Railing and Flood Light Kit" (https://skfb.ly/6UuUW) by DudleyLong is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Ladder, Railing and Flood Light Kit" (https://skfb.ly/6UuUW) by DudleyLong is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Lowpoly lantern" (https://skfb.ly/oH9wE) by r1c05h37 is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Bed 06" (https://skfb.ly/6TQrD) by Doaa Sheha is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Plush Unicorn" (https://skfb.ly/6WZCC) by C.U.V is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Fairy Lights" (https://skfb.ly/ooA7Z) by SunsetScorpion is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Stylized Low Poly Wooden Wardrobe" (https://skfb.ly/opyuR) by Alvin Suen is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Gamer Chair Cosmetic" (https://skfb.ly/6XnOL) by Oliver is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"Corner Computer Desk" (https://skfb.ly/6GxLM) by timtoo is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).

"LAPTOP" (https://skfb.ly/6WPwC) by VISIONNEW is licensed under Creative Commons Attribution (http://creativecommons.org/licenses/by/4.0/).
                            </textarea>



                            <h3>Old Alive versions CC-BY songs used from soundcloud.com</h3>
                            <textarea class="w-100" style="height:300px">
Arnyd - Abyss
https://soundcloud.com/arnydmusic/abyss

Arnyd - Axiom
https://soundcloud.com/arnydmusic/axiom

Arnyd - Beginning
https://soundcloud.com/arnydmusic/beginning

Arnyd - Decadence
https://soundcloud.com/arnydmusic/decadence

Arnyd - End
https://soundcloud.com/arnydmusic/end

Arnyd - Hypernova
https://soundcloud.com/arnydmusic/hypernova

Arnyd - Mesmerized
https://soundcloud.com/arnydmusic/mesmerized

Arnyd - Memento Mori
https://soundcloud.com/arnydmusic/memento-mori

Arnyd - Neon Lights
https://soundcloud.com/arnydmusic/neon-lights

Arnyd - Paradox
https://soundcloud.com/arnydmusic/paradox

Arnyd - Principle
https://soundcloud.com/arnydmusic/principle

Arnyd - Polaris
https://soundcloud.com/arnydmusic/polaris

Arnyd - Rays
https://soundcloud.com/arnydmusic/rays

Arnyd - Subversive
https://soundcloud.com/arnydmusic/subversive

Arnyd - Truth
https://soundcloud.com/arnydmusic/truth

Arnyd - Trust
https://soundcloud.com/arnydmusic/trust

Arnyd - Vestige
https://soundcloud.com/arnydmusic/vestige

Arnyd - Walpurgisnacht
https://soundcloud.com/arnydmusic/walpurgisnacht

Arnyd - Way
https://soundcloud.com/arnydmusic/way
                            </textarea>
                        </div>
                    </div>
                </div>
            </div>

            <div class="tab-pane fade" id="tab-credits-3">
                <div class="container">
                    <div class="row py-3">
                        <div class="col-12">
                            <h4 class="t section-title">Addons used in this scene</h4>
                        </div>
                    </div>
                    <div id="credits-addons-list">
                        <div class="row headerinfo " >
                            <div class="col-8">Addon</div>
                            <div class="col-2">Dependencies</div>
                            <div class="col-2">License</div>
                        </div>
                        <div class="row demo" class="credits-addons-list-item">
                            <div class="col-8">
                                <div class="author"></div>
                                <div class="name"></div>
                                <div class="promotional url"></div>
                            </div>
                            <div class="col-2 dependencies"></div>
                            <div class="col-2 license"></div>
                        </div>
                    </div>
                    
                    <div class="row py-3">
                        <div class="col-12">
                            <h4 class="t section-title">Quick credits</h4>
                        </div>
                        <div class="col-12">
                            <textarea id="credits-quickcredits" class="w-100" style="min-height:150px;" ></textarea>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["credits"] = {
    title: "Credits",
    titleButtons: ["close"],
    icon: "vam",
};$(document).ready(function () {
    $("#app").on("mousedown", ".ambience-item .aelist-thumb", app_ambience_item_toggle);
    $("#app").on("change", ".ambience-item .ambience-volume", app_ambience_item_volume);
    $("#app").on("mousedown", ".ambience-stop-all", app_ambience_stop_all);
    $("#app").on("change", ".ambience-volume-master", app_ambience_refresh_volume_all);
});
function app_ambience_prepare(html) {
}

function app_ambience_postprepare() {

}

function app_ambience_cron_second() {

}

function tab_load_ambience() {

}
function tab_load_ambience_tab_ambience_1() {
    app_ambience_refresh_selection();

}



function app_ambience_on_home_append(element){
    if(app_ambience_is_playing()) element.addClass("app-with-sound");
    return element;
}
function app_ambience_on_aesetting_change(params) {
    switch (params.setting) {
        case "stAmbienceLoopCutoff":
            app_ambience_stop_all();
            break;
    }
}
function app_ambience_get_master_volume(){
    return $(".ambience-volume-master").val();
}
function app_ambience_get_global_audio(src) {
    var o = $("#globalaudio").find("audio[data-src='" + src + "']");
    if (o.length < 1) {
        $("#globalaudio").append('<audio class="ambience-sound" loop  src="' + src + '" data-src="' + src + '"></audio>');
        o = $("#globalaudio").find("audio[data-src='" + src + "']");
        fix_audio_loop(o[0]);
    }
    return o;
}
function app_ambience_item_volume(event) {
    var o = $(event.currentTarget).parents(".ambience-item");
    var volume = o.find('.ambience-volume').val() * app_ambience_get_master_volume();
    var src = o.attr('data-src');
    var audio = app_ambience_get_global_audio(src);
    audio[0].volume = volume;
}
function app_ambience_item_toggle(event) {
    var o = $(event.currentTarget).parents(".ambience-item");
    var sound = o.attr('data-value');
    var isPlaying = o.hasClass('selected');
    if (isPlaying) {
        app_ambience_stop(o);
    } else {
        app_ambience_play(o);
    }
}
function app_ambience_stop_all() {
    $("#globalaudio audio.ambience-sound").each(function (k, audio) {
        if (!audio.paused)
            audio.pause();
        $(audio).remove();
    });
    app_ambience_refresh_selection();
}

function app_ambience_refresh_volume_all() {
    $(".ambience-item.selected").each(function (k, el) {
        var src = $(el).attr('data-src');
        var global_audio = $("#globalaudio").find("audio[data-src='" + src + "']");
        if (global_audio.length > 0) {
            var audio = global_audio[0];
            if (typeof (audio) !== "undefined") {
                audio.volume = $(el).find('.ambience-volume').val() * app_ambience_get_master_volume();
            }
        }
    });
}
function app_ambience_play(o) {
    o.addClass("selected");
    var audio = app_ambience_get_global_audio(o.attr("data-src"));
    var volume = o.find('.ambience-volume').val()* app_ambience_get_master_volume();
    if (isEmpty(audio))
        return;
    audio[0].play();
    audio[0].volume = volume;
}


function app_ambience_stop(o) {
    o.removeClass("selected");
    var audio = app_ambience_get_global_audio(o.attr("data-src"));
    if (isEmpty(audio))
        return;
    audio[0].pause();
}

function app_ambience_refresh_selection() {
    $(".ambience-item.selected").removeClass('selected');
    $(".ambience-item").each(function (k, el) {
        var src = $(el).attr('data-src');
        var global_audio = $("#globalaudio").find("audio[data-src='" + src + "']");
        if (global_audio.length > 0) {
            var audio = global_audio[0];
            if (typeof (audio) !== "undefined") {
                if (!audio.paused)
                    $(el).addClass("selected");
            }
        }
    });
}


function fix_audio_loop(audio_file) {
    audio_file.addEventListener('timeupdate', function () {
        var buffer = Settings.getFloat("stAmbienceLoopCutoff") || 0.17;
        if (this.currentTime > this.duration - buffer) {
            this.currentTime = 0;
            this.play();
        }
    });
}

function app_ambience_is_playing() {
    var isPlaying = false;
    $("#globalaudio audio.ambience-sound").each(function (k, audio) {
        if (!audio.paused)
            isPlaying = true;
    });
    return isPlaying;
}TPL["ambience"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-ambience-1" >Ambience</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-ambience-settings" >Settings</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-ambience-1">

                <div class="container py-3">
                    <div class="row g-2">

                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/airtone.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-3 sprite-y-1"></div>
                                <div class="aelist-title t">Air tone</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>

                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/birds.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-2 sprite-y-1"></div>
                                <div class="aelist-title t">Birds</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>


                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/dark.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-4 sprite-y-1"></div>
                                <div class="aelist-title t">Dark</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>

                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/industrial.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-6 sprite-y-1"></div>
                                <div class="aelist-title t">Industrial</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        
                          <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/laundry.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-7 sprite-y-1"></div>
                                <div class="aelist-title t">Laundry</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>

                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/lofi.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-8 sprite-y-1"></div>
                                <div class="aelist-title t">LoFi</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>

                      
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/night.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-9 sprite-y-1"></div>
                                <div class="aelist-title t">Night</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>

                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/noir.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-6 sprite-y-2"></div>
                                <div class="aelist-title t">Noir</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>

                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/rain.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-10 sprite-y-1"></div>
                                <div class="aelist-title t">Rain</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>

                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/rainindoor.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-1 sprite-y-2"></div>
                                <div class="aelist-title t">Rain indoor</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>


                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/restaurant1.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-5 sprite-y-1"></div>
                                <div class="aelist-title t">Restaurant 1</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>


                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/restaurant2.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-2 sprite-y-2"></div>
                                <div class="aelist-title t">Restaurant 2</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>


                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/retroscifi.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-3 sprite-y-2"></div>
                                <div class="aelist-title t">Retro Scifi</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>


                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/suburban.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-4 sprite-y-2"></div>
                                <div class="aelist-title t">Suburban</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>


                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/wind.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-5 sprite-y-2"></div>
                                <div class="aelist-title t">Wind</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/train.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-7 sprite-y-2"></div>
                                <div class="aelist-title t">Train</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/drumandbells.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-8 sprite-y-2"></div>
                                <div class="aelist-title t">Drum and bells</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        
                        
                        
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/park.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-9 sprite-y-2"></div>
                                <div class="aelist-title t">Park</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>                       
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/beach.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-10 sprite-y-2"></div>
                                <div class="aelist-title t">Beach</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/adrift.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-1 sprite-y-3"></div>
                                <div class="aelist-title t">Adrift</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/Alpha Centauri.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-2 sprite-y-3"></div>
                                <div class="aelist-title t">Alpha Centauri</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/cybercity.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-3 sprite-y-3"></div>
                                <div class="aelist-title t">Cyber City</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/cave.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-4 sprite-y-3"></div>
                                <div class="aelist-title t">Cave</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/forest.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-5 sprite-y-3"></div>
                                <div class="aelist-title t">Forest</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/farm.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-6 sprite-y-3"></div>
                                <div class="aelist-title t">Farm</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/jail.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-7 sprite-y-3"></div>
                                <div class="aelist-title t">Jail</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/gong.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-8 sprite-y-3"></div>
                                <div class="aelist-title t">Gong</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/nuclear.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-10 sprite-y-3"></div>
                                <div class="aelist-title t">Nuclear</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/nightclub.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-1 sprite-y-4"></div>
                                <div class="aelist-title t">Nightclub</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/mall.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-2 sprite-y-4"></div>
                                <div class="aelist-title t">Mall</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/stadium.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-3 sprite-y-4"></div>
                                <div class="aelist-title t">Stadium</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/office.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-4 sprite-y-4"></div>
                                <div class="aelist-title t">Office</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/tibetanbowl.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-9 sprite-y-3"></div>
                                <div class="aelist-title t">Tibetan bowl</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/traffic.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-5 sprite-y-4"></div>
                                <div class="aelist-title t">Traffic</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/waves.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-6 sprite-y-4"></div>
                                <div class="aelist-title t">Waves</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        <div class="col-4 col-md-3 ambience-item aelist-item hover-bright" data-src="resources/sound/underwater.ogg">
                            <div class="aelist-item-element"><div class="aelist-thumb hundred-sprite sprite-x-7 sprite-y-4"></div>
                                <div class="aelist-title t">Underwater</div>
                                <div class="ambience-volume-holder"><input class="ambience-volume form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="0.5" /></div>
                            </div>
                        </div>
                        


                    </div>
                    <div class="row py-4">
                        <div class="col-4 py-2 text-end" >
                            <span class="t">Volume:</span>
                        </div>
                        <div class="col-4 py-2"  style="background:#333">
                            <div class="ambience-volume-holder"><input class="ambience-volume-master form-range form-range-full w-100" type="range" min="0" max="1" step="0.01" value="1" /></div>
                        </div>
                        <div class="col-4">
                            <div class="btn btn-sm btn-secondary ambience-stop-all t">Stop all sounds</div>
                        </div>
                    </div>
                </div>
            </div>
            
            
            <div class="tab-pane fade" id="tab-ambience-settings">

                <div class="container py-3">
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Loop cut-off:</label>
                        </div>
                        <div class="col-6">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stAmbienceLoopCutoff" min="0" max="0.5" step="0.001">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Change this if you get very noticeable gaps between sound loops. The default is <b>0.20</b>.</div>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["ambience"] = {
    title: "Ambience",
    titleButtons: ["close"],
    icon: "fun",
    devOnly: false
};$(document).ready(function () {

});
var _VFX_CURRENT = "none";
function app_vfx_prepare(html){
    
}

function app_vfx_postprepare(){
    
}

function app_vfx_cron_second(){
    
}

function tab_load_vfx(){
    
}
function tab_load_vfx_tab_vfx_1(){
    aevent({action:"query",context:"vfx",query:"getCurrent"});
}


function app_vfx_on_home_append(element){
    if(app_vfx_is_playing()) element.addClass("app-with-effect");
    return element;
}
function app_vfx_is_playing(){
    return _VFX_CURRENT !== "none";
}
function app_vfx_set_current(s){
    _VFX_CURRENT = s;
    $(".vfx-item.selected").removeClass("selected");
    $(".vfx-item[data-value='"+s+"']").addClass("selected");
}
function app_vfx_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}

TPL["vfx"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-vfx-1" >Visual Effects</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-vfx-1">
                <div class="container py-3">
                    <div class="row g-2">
                        <div class="col-4 vfx-item aelist-item hover-bright selected aequery" data-context="vfx" data-query="selectNone" data-value="none">
                            <div class="aelist-item-element">
                                <div class="aelist-thumb"><img src="resources/vfx/none.jpg" /></div>
                                <div class="aelist-title t">None</div>
                            </div>
                        </div>

                        <div class="col-4 vfx-item aelist-item hover-bright aequery" data-context="vfx" data-query="selectRain"  data-value="raineffect">
                            <div class="aelist-item-element">
                                <div class="aelist-thumb"><img src="resources/vfx/rain.jpg" /></div>
                                <div class="aelist-title t">Rain</div>
                            </div>
                        </div>

                        <div class="col-4 vfx-item aelist-item hover-bright aequery" data-context="vfx" data-query="selectSnow"  data-value="snoweffect">
                            <div class="aelist-item-element">
                                <div class="aelist-thumb"><img src="resources/vfx/snow.jpg" /></div>
                                <div class="aelist-title t">Snow</div>
                            </div>
                        </div>

                        <div class="col-4 vfx-item aelist-item hover-bright aequery" data-context="vfx" data-query="selectFireflies"  data-value="fireflyeffect">
                            <div class="aelist-item-element">
                                <div class="aelist-thumb"><img src="resources/vfx/fireflies.jpg" /></div>
                                <div class="aelist-title t">Fireflies</div>
                            </div>
                        </div>

                        <div class="col-4 vfx-item aelist-item hover-bright aequery" data-context="vfx" data-query="selectConfetti"  data-value="confettieffect">
                            <div class="aelist-item-element">
                                <div class="aelist-thumb"><img src="resources/vfx/confetti.jpg" /></div>
                                <div class="aelist-title t">Confetti</div>
                            </div>
                        </div>

                        <div class="col-4 vfx-item aelist-item hover-bright aequery" data-context="vfx" data-query="selectLeafs"  data-value="leafseffect">
                            <div class="aelist-item-element">
                                <div class="aelist-thumb"><img src="resources/vfx/leafs.jpg" /></div>
                                <div class="aelist-title t">Leaves</div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["vfx"] = {
    title: "Visual Effects",
    titleButtons: ["close"],
    icon: "fun",
    devOnly: false
};$(document).ready(function () {

});

function app_lookgenerator_prepare(html){
    
}

function app_lookgenerator_postprepare(){
    
}

function app_lookgenerator_cron_second(){
    
}

function tab_load_lookgenerator(){
    
}
function tab_load_lookgenerator_tab_lookgenerator_1(){
    
}

function app_lookgenerator_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}

TPL["lookgenerator"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-lookgenerator-1">Look Generator</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-lookgenerator-morphology">Morphology</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-lookgenerator-1">
                <div class="container py-3 ">
                    <div class="row on-character-notselected">
                        <div class="col-12 ">
                            <div class="t">No person is selected.</div>
                        </div>
                    </div>
                    <div class="on-character-selected">

                        
                        <div class="row settings-row ">
                            <div class="col-12 py-2 setting-info t">Look generator allows generating random VAM looks. Add variation to an existing look, or use the Generate look button to create a new look.</div>
                            <div class="col-6 pb-2"><div class="btn btn-secondary btn-sm w-100 aequery t" data-context="lookgenerator" data-query="resetMorphs">Reset morphs</div></div>
                        </div>
                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Settings</h4></div></div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Morph chance:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stLookgeneratorMorphchance" min="0" max="10" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Percentage chance for each of the preset morphs to be changed. The default is <b>5</b>.</div>
                        </div>
                        
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Morph min:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stLookgeneratorMorphmin" min="-0.15" max="0.15" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The minimum value for a morph to change. The default is <b>0.05</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Morph max:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stLookgeneratorMorphmax" min="-0.5" max="0.5" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The maximum value for a morph to change. The default is <b>0.33</b>.</div>
                        </div>
                        
<!--                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Custom head morphs:</label>
                            </div>
                            <div class="col-6">
                                <textarea id="setting-diffPrompt" type="text" class="form-textarea mt-0 aesetting aesetting-text keyboard" data-aesetting="stLookgeneratorMorphsHead" maxlength="2"></textarea>
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Extra morphs to be added to the head. List separated with ",". Press copy UID for the morph in vam's UI. The default is <b>Spacedog.Import_Reloaded_Lite.2:/Custom/Atom/Person/Morphs/female/Head_Reloaded-Lite/Achiko.vmi, Spacedog.Import_Reloaded_Lite.2:/Custom/Atom/Person/Morphs/female/Head_Reloaded-Lite/angelina.vmi</b>.</div>
                        </div>
                        
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Custom body morphs:</label>
                            </div>
                            <div class="col-6">
                                <textarea id="setting-diffPrompt" type="text" class="form-textarea mt-0 aesetting aesetting-text keyboard" data-aesetting="stLookgeneratorMorphsBody"></textarea>
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Extra morphs to be added to the body. List separated with ",". Press copy UID for the morph in vam's UI. The default is <b>Spacedog.Import_Reloaded_Lite.2:/Custom/Atom/Person/Morphs/female/Actor_Reloaded-Lite/Athletic.vmi, Spacedog.Import_Reloaded_Lite.2:/Custom/Atom/Person/Morphs/female/Actor_Reloaded-Lite/Chubby.vmi</b>.</div>
                        </div>-->
                        
                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Modify existing look</h4></div></div>
                        <div class="row py-3">
                            <div class="col-6"><div class="btn btn-secondary btn-sm w-100 aequery t" data-context="lookgenerator" data-query="addHead">Head</div></div>
                            <div class="col-6"><div class="btn btn-secondary btn-sm w-100 aequery t" data-context="lookgenerator" data-query="addBody">Body</div></div>
                            <div class="col-12 pt-1"><div class="btn btn-secondary btn-sm w-100 aequery t" data-context="lookgenerator" data-query="addFull">Full look</div></div>
                            <!--<div class="col-4"><div class="btn btn-primary w-100 aequery t" data-context="lookgenerator" data-query="addFull">Full</div></div>-->
                        </div>
                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Generate new look</h4></div></div>
                        <div class="col-12"><div class="btn btn-primary w-100 aequery t" data-context="lookgenerator" data-query="generateFull">Generate</div></div>
                    </div>
                </div>
            </div>
            
            
            <div class="tab-pane fade" id="tab-lookgenerator-morphology">
                <div class="container py-3 ">
                    <div class="row on-character-notselected">
                        <div class="col-12 ">
                            <div class="t">No person is selected.</div>
                        </div>
                    </div>
                    <div class="on-character-selected">
                        
                        <div class="row settings-row ">
                            <div class="col-12 py-2 setting-info t">Use this function to increase or decrease all the active morphs of the person, at the same time.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Morphology change %:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range morphology-change" value="100" min="0" max="200" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Set the percentage level for the morphology changes. If you set it to 50%, all morphs will change to be 50% or half of their current values. If you change to 200%, all morphs will change to be 200% or twice of their current values.</div>
                        </div>
                       
                        <div class="col-12 pt-3"><div class="btn btn-primary w-100 t morphology-change-update">Update all morphs</div></div>
                        
                        
                    </div>
                </div>
            </div>

        </div>
    </div>
</div>
</div>
`;$(document).ready(function () {

});

META["lookgenerator"] = {
    title: "Look Generator",
    titleButtons: ["close"],
    icon: "fun",
    devOnly: false
};$(document).ready(function () {
    $("#app").on('mousedown',".sexposes-item",app_sexposes_select);
});

function app_sexpose_prepare(html){
    
}

function app_sexpose_postprepare(){
    
}

function app_sexpose_cron_second(){
    
}

function tab_load_sexpose(){
    
}
function tab_load_sexpose_tab_sexpose_1(){
    app_sexposes_populate_list();
}

function app_sexpose_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}


function app_sexposes_populate_list(){
    var destination = $("#seposes-list");
    var demo = destination.find(".demo");
    destination.find('.new').remove();
    var i = 0;
    for(var sexpose of DATA.sexposes){
        var o = demo.clone();
        o.removeClass("demo").addClass("new");
        o.attr('data-name', sexpose.name);
        o.find(".sexposes-item-name").html(sexpose.name);
        var cssx = (i%10) * 100/(10-1); 
        var cssy = parseInt(i/10) * (100/(Math.ceil(DATA.sexposes.length/10)-1)); 
        o.find(".sprite-image").css("background-position-x", cssx+"%");
        o.find(".sprite-image").css("background-position-y", cssy+"%");
        i++;
        destination.append(o);
    }
}

function app_sexposes_select(event){
    var o = $(event.currentTarget);
    var pose = o.attr('data-name');
    aevent({action:"query",context:"sexposes",query:"changePose", pose:pose});
    
}TPL["sexpose"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-sexpose-1" >Poses</a>
        </li>
       <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-sexpose-2" >Position</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-sexpose-1">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <div id="seposes-list">
                                <div class="sexposes-item demo hover-bright">
                                    <div class="sexposes-item-thumb sprite-image"><img src="resources/square.jpg" /></div>
                                    <div class="sexposes-item-name"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>


            <div class="tab-pane fade" id="tab-sexpose-2">
                <div class="container">
                     <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Pose controller</h4></div></div>
                    <div class="row">
                        <div class="col-6">
                            <div class="btn btn-primary w-100 t aequery" data-context="sexposes" data-query="showController">Show</div>
                        </div>
                        <div class="col-6">
                            <div class="btn btn-primary w-100 t aequery" data-context="sexposes" data-query="hideController">Hide</div>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
    
</div>
`;$(document).ready(function () {

});

META["sexpose"] = {
    title: "Couple Poses",
    titleButtons: ["close"],
    icon: "aeternum",
    devOnly: false
};var AESTHETICS_MAP = {
    "global": [
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
        "Saves/PluginData/Aeternum/Ae/Html/resources/aesthetics/templates/global/\\alive.png",
    ]
};
$(document).ready(function () {
    $("#app").on("mousedown", ".aeditor-action-apply", app_aesthetics_apply);
    $("#app").on("mousedown", ".aeditor-action-save", app_aesthetics_save);
    $("#app").on("mousedown", ".aeditor-action-clear", app_aesthetics_clear);
    $("#app").on("mousedown", ".aeditor-action-undo", app_aesthetics_undo);
    $("#app").on("mousedown", ".aeditor-action-redo", app_aesthetics_redo);
    $("#app").on("mousedown", ".editor-layer-action-add", app_aesthetics_add_layer);
    $("#app").on("mousedown", ".editor-layer-action-reset", app_aesthetics_reset);
    $("#app").on("mousedown", ".editor-layer-action-add-debugimage", app_aesthetics_add_debugimage);
    $("#app").on("mousedown", ".editor-layer-action-movebefore", app_aesthetics_layer_moveleft);
    $("#app").on("mousedown", ".editor-layer-action-moveafter", app_aesthetics_layer_moveright);
    $("#app").on("mousedown", ".editor-layer-action-delete", app_aesthetics_layer_delete);
    $("#app").on("change", ".editor-layer-action-opacity", app_aesthetics_layer_opacity);
    $("#app").on("change", ".editor-layer-action-hue", app_aesthetics_layer_hue);
    $("#app").on("change", ".editor-layer-action-brightness", app_aesthetics_layer_brightness);
    $("#app").on("change", ".editor-layer-action-contrast", app_aesthetics_layer_contrast);
    $("#app").on("change", ".editor-layer-action-blur", app_aesthetics_layer_blur);
    $("#app").on("change", ".editor-layer-action-x", app_aesthetics_layer_x);
    $("#app").on("change", ".editor-layer-action-y", app_aesthetics_layer_y);
    $("#app").on("change", ".editor-layer-action-angle", app_aesthetics_layer_angle);
    $("#app").on("change", ".editor-layer-action-scale", app_aesthetics_layer_scale);
    $("#app").on("change", ".editor-layer-action-saturation", app_aesthetics_layer_saturation);
    $("#app").on("mousedown", "#editor-layers .editor-layer", app_aesthetics_select_layer);
    $("#app").on("mousedown", "#tab-aesthetics-face .subtab", app_aesthetics_tab_change);
    $("#app").on("mousedown", ".morphology-change-update", app_aesthetics_update_morphology);
    $("#app").on("mousedown", ".editor-layer-mode", function () {
        app_aesthetics_set_mode($(this).attr('data-mode'))
    });
    $("#app").on('change', ".editor-layer-action-drawing-width", app_aesthetics_on_draw_settings_change);
    $("#app").on('change', ".editor-layer-action-drawing-opacity", app_aesthetics_on_draw_settings_change);
    $("#app").on('change', ".editor-layer-action-eraser-width", app_aesthetics_on_eraser_settings_change);
    $("#app").on("mousedown", ".editor-template-thumb", app_aesthetics_select_template);
    window.addEventListener('mousemove', app_aesthetics_on_move_cursor)
});
var aecanvas;
var aesthetics_canvas_size = 2048;
var _aesthetics_prev_selected_layer;
function app_aesthetics_on_move_cursor() {


}

function app_aesthetics_prepare(html) {

}

function app_aesthetics_postprepare() {
    app_aesthetics_popuplate_templates();
}

function app_aesthetics_cron_second() {

}

function app_aesthetics_is_autoset() {
    return Settings.getBool("sedAutoRefresh");
}
function tab_load_aesthetics() {

}
function tab_load_aesthetics_tab_aesthetics_settings() {
    $("#tab-aesthetics-face").hide();
}

function tab_load_aesthetics_tab_aesthetics_head() {
    $("#tab-aesthetics-face").show();
    $("#tab-aesthetics-face").attr("data-editor", "head");
    app_aesthetics_init_editor();
    aesthetics_set_tab("head");
}
function tab_load_aesthetics_tab_aesthetics_body() {
    $("#tab-aesthetics-face").show();
    $("#tab-aesthetics-face").attr("data-editor", "body");
    app_aesthetics_init_editor();
    aesthetics_set_tab("body");
}
function tab_load_aesthetics_tab_aesthetics_limbs() {
    $("#tab-aesthetics-face").show();
    $("#tab-aesthetics-face").attr("data-editor", "limbs");
    app_aesthetics_init_editor();
    aesthetics_set_tab("limbs");
}
function tab_load_aesthetics_tab_aesthetics_hip() {
    $("#tab-aesthetics-face").show();
    $("#tab-aesthetics-face").attr("data-editor", "hip");
    app_aesthetics_init_editor();
    aesthetics_set_tab("hip");
}

function aesthetics_set_tab(s) {
    $(".app").removeClass("subtab_body");
    $(".app").removeClass("subtab_head");
    $(".app").removeClass("subtab_limbs");
    $(".app").removeClass("subtab_hip");
    $(".app").addClass("subtab_" + s);
    aevent({action: "query", context: "filemanagement", query: "aestheticsLoadDecal", query2: s, callback: "on_app_aesthetics_image_loaded"})
}

function app_aesthetics_on_aesetting_change(params) {
    switch (params.setting) {
        case "settingname":

            break;
    }
}


function app_aesthetics_merge_layers(canvas, layer1Index, layer2Index) {
    if (layer1Index < 0 || layer2Index < 0 || layer1Index >= canvas.getObjects().length || layer2Index >= canvas.getObjects().length) {
        console.error('Invalid layer indices.');
        return;
    }

    var layer1 = canvas.item(layer1Index);
    var layer2 = canvas.item(layer2Index);
    if (!layer1 || !layer2) {
        return;
    }

    var layer2Clone = fabric.util.object.clone(layer2);
    layer2Clone.set({
        left: layer1.left,
        top: layer1.top
    });
    layer1.addWithUpdate(layer2Clone);
    canvas.remove(layer2);
    canvas.requestRenderAll();
    updateCanvasState();
}


function app_aesthetics_get_mode() {
    return $('#tab-aesthetics-face').attr('data-mode');
}

function app_aesthetics_set_mode(m) {
    $('#tab-aesthetics-face').attr('data-mode', m);
    $('#tab-aesthetics-face').removeClass("mode-move");
    $('#tab-aesthetics-face').removeClass("mode-eraser");
    $('#tab-aesthetics-face').removeClass("mode-draw");
    $('#tab-aesthetics-face').addClass("mode-" + m);
    //do move ops
    if (m === "move") {
        app_aesthetics_unset_drawing_mode();
        app_aesthetics_on_draw_settings_change();
    }
//do eraser ops
    if (m === "eraser") {
        app_aesthetics_set_eraser_mode();
        app_aesthetics_on_eraser_settings_change();
    }

//do drawing ops
    if (m === "draw") {
        app_aesthetics_set_drawing_mode();
        app_aesthetics_on_draw_settings_change();
    }
}

function app_aesthetics_init_editor() {
    app_aesthetics_clear_history();
    app_aesthetics_set_mode("move");
    app_aesthetics_clear_layers();
    $("#aesthetic-editor").attr("width", aesthetics_canvas_size);
    $("#aesthetic-editor").attr("height", aesthetics_canvas_size);
    $(".aesthetic-editor-container").css("max-width", aesthetics_canvas_size + "px");
    $(".aesthetic-editor-container").css("max-height", aesthetics_canvas_size + "px");
    $(".aesthetic-editor-container-background").css("width", aesthetics_canvas_size + "px");
    $(".aesthetic-editor-container-background").css("height", aesthetics_canvas_size + "px");
    if (typeof aecanvas !== "undefined")
        aecanvas.dispose();
    if (fabric.isWebglSupported()) {
//fabric.textureSize = fabric.maxTextureSize;
    }
    aecanvas = new fabric.Canvas('aesthetic-editor',
            {
                preserveObjectStacking: true,
                selection: false,
                controlsAboveOverlay: true

            }
    );
    aecanvas.on('mouse:move', function (e) {
        if (!app_aesthetics_is_drawing_mode()) {

        } else {

            var width = aecanvas.freeDrawingBrush.width / aesthetics_canvas_size * 100;
            var o = $("#canvas-cursor");
            o.css("width", width + "%");
            o.css("height", width + "%");
            o.css("left", (e.pointer.x / aesthetics_canvas_size * 100 - width / 2) + "%");
            o.css("top", (e.pointer.y / aesthetics_canvas_size * 100 - width / 2) + "%");
        }
    });
    aecanvas.on('object:modified', function (options) {
        if (app_aesthetics_is_drawing_mode())
            return;
        on_app_aesthetics_object_modify(options.target);
        updateCanvasState();
    });
    aecanvas.on('object:added', function (options) {
        updateCanvasState();
    });
   
    aecanvas.on('selection:updated', function (options) {
        if (app_aesthetics_is_drawing_mode())
            return;
        on_app_aesthetics_object_selected(options.selected[0]);
    });
    aecanvas.on('selection:created', function (options) {
        if (app_aesthetics_is_drawing_mode())
            return;
        on_app_aesthetics_object_selected(options.selected[0]);
    });
    aecanvas.on("path:created", function (event) {
        var path = event.path;
        if (app_aesthetics_get_mode() !== "draw")
            return;
        var dataUrl = path.toDataURL();
        // Create a new fabric.Image object using the data URL
        fabric.Image.fromURL(dataUrl, function (img) {
            // Set additional properties if needed
            img.set({
                left: path.left,
                top: path.top,
                hasControls: true,
                cornerSize: 30,
                cornerStyle: 'circle',
                cornerColor: UI_COLOR,
                transparentCorners: false,
                id: app_aesthetics_get_unique_id()

            });
            aecanvas.remove(path);
            aecanvas.add(img);
            aecanvas.requestRenderAll();
            app_aesthetics_update_layers();
        });
    });
    aecanvas.on('selection:cleared', function () {
        if (app_aesthetics_is_drawing_mode())
            return;
        app_aesthetics_select_layer_clear();
    });
//    var rect = new fabric.Rect({
//        left: 100,
//        top: 100,
//        fill: 'red',
//        width: 200,
//        height: 200,
//        id: app_aesthetics_get_unique_id(),
//        hasControls: false
//    });
//    aecanvas.add(rect);
//    app_aesthetics_update_layers();
}

function app_aesthetics_get_current_editor() {
    return $("#tab-aesthetics-face").attr("data-editor");
    return o;
}

function app_aesthetics_clear() {
    aecanvas.clear();
    app_aesthetics_update_layers();
    var dataURL = aecanvas.toDataURL({format: 'png', });
    app_aesthetics_update_image_preview(dataURL);
    aevent({action: "query", context: "aesthetics", query: "clearDecal", query2: app_aesthetics_get_current_editor(), callback: "on_app_aesthetics_clear"});
}


function app_aesthetics_save() {
    var dataURL = aecanvas.toDataURL({format: 'png', });
    app_aesthetics_update_image_preview(dataURL);
    aevent({action: "query", context: "aesthetics", query: "saveImage", query2: app_aesthetics_get_current_editor(), image: dataURL, callback: "on_app_aesthetics_save"});
}

function app_aesthetics_apply() {
    var dataURL = aecanvas.toDataURL({format: 'png', });
    app_aesthetics_update_image_preview(dataURL);
    aevent({action: "query", context: "aesthetics", query: "applyImage", query2: app_aesthetics_get_current_editor(), image: dataURL, callback: "on_app_aesthetics_apply"});
}

function on_app_aesthetics_save() {

}
function on_app_aesthetics_apply() {

}
function on_app_aesthetics_clear() {

}

function app_aesthetics_update_image_preview(src) {
    if ($("#editor-preview").length < 1)
        return;
    $("#editor-preview").attr('src', src);
}

function app_aesthetics_get_unique_id() {
    return getTimestampFull() + "_" + randomIntFromInterval(1000000, 9999999);
}

function app_aesthetics_clear_layers() {
    
    $("#editor-layers .editor-layer.new").remove();
    $(".on-layer-selected").removeClass("on-layer-selected");
//    app_aesthetics_unset_drawing_mode();
}

function app_aesthetics_update_layers(select_last = false) {
    _aesthetics_prev_selected_layer = app_aesthetics_get_selected_layer_id();
    var scaleFactor = 60 / aesthetics_canvas_size;
    app_aesthetics_clear_layers();
    var destination = $("#editor-layers");
    var demo = destination.find(".editor-layer.demo");
    var objects = aecanvas.getObjects();
    if (objects.length < 1)
        return;
    var layer_id = 0;
    var last_layer = null;
    for (var obj of objects) {


        var o = demo.clone();
        o.removeClass("demo").addClass("new");
        var thumbnailDataURL = obj.toDataURL({format: 'png'});
        o.find(".editor-layer-thumb IMG").attr("src", thumbnailDataURL);
        o.attr('data-layer', layer_id);
        o.attr('data-layerid', obj.id);
        last_layer = o;
        if (!isEmpty(_aesthetics_prev_selected_layer) && _aesthetics_prev_selected_layer === obj.id) {
            o.addClass("selected");
            $("#app-aesthetics").addClass("on-layer-selected");
            app_aesthetics_set_settings();
        }
        destination.append(o);
        layer_id++;
        //        obj.clone(function (layer) {
        //            var o = demo.clone();
        //            o.removeClass("demo").addClass("new");
        //            var tempCanvas = new fabric.StaticCanvas("static-canvas-layer", {width: aecanvas.width * scaleFactor, height: aecanvas.height * scaleFactor});
        //            
        //            layer.scaleX = layer.scaleY = layer.scaleY * scaleFactor;
        //            layer.left = layer.left * scaleFactor;
        //            layer.top = layer.top * scaleFactor;
        ////            console.log('cloned', layer);
        //            tempCanvas.add(layer);
        //            var thumbnailDataURL = tempCanvas.toDataURL({format: 'png'});
        //            o.find(".editor-layer-thumb IMG").attr("src", thumbnailDataURL);
        //            o.attr('data-layer', layer_id);
        //            o.attr('data-layerid', layer.id); 
        //            
        //            if (!isEmpty(_aesthetics_prev_selected_layer) && _aesthetics_prev_selected_layer === layer.id) {
        //                o.addClass("selected");
        //                $("#app-aesthetics").addClass("on-layer-selected");
        //               
        //                app_aesthetics_set_settings();
        //            }
        //            destination.append(o);
        //            layer_id++;
        //        }, ["id"]);



    }
    setTimeout(function(){
        if (app_aesthetics_is_autoset()) {
            app_aesthetics_apply();
        }
    },500);
    if (select_last && last_layer !== null) {
        app_aesthetics_select_layer({currentTarget: last_layer});
}
}

function app_aesthetics_reset() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    layer.scaleX = layer.scaleY = 1;
    layer.left = 0;
    layer.top = 0;
    layer.angle = 0;
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_add_layer() {
    aevent({action: "query", context: "filemanagement", query: "openvamimage", callback: "on_app_aesthetics_image_loaded"});
}



function on_app_aesthetics_fromurl_finished(img) {

    aecanvas.add(img);
    img.set({
        left: 0,
        top: 0,
    });
    var canvasWidth = aecanvas.width;
    var canvasHeight = aecanvas.height;
    var imageAspectRatio = img.width / img.height;
    if (canvasWidth / canvasHeight > imageAspectRatio) {
        img.scaleToWidth(canvasWidth);
    } else {
        img.scaleToHeight(canvasHeight);
    }

    img.center();
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers(true);
}

function on_app_aesthetics_image_loaded(base64img) {
    app_aesthetics_hide_load();
    if (isEmpty(base64img))
        return;
    resizeImage(base64img, aesthetics_canvas_size, aesthetics_canvas_size, on_app_aesthetics_image_loaded_finished);
}

function on_app_aesthetics_image_loaded_finished(base64img) {
//    console.log("on_app_aesthetics_image_loaded_finished", base64img);
    fabric.Image.fromURL(base64img, on_app_aesthetics_fromurl_finished,
            {
                id: app_aesthetics_get_unique_id(),
                hasControls: true,
                cornerSize: 30,
                cornerStyle: 'circle',
                cornerColor: UI_COLOR,
                transparentCorners: false
            }
    );
}

function app_aesthetics_is_drawing_mode() {
    if (isEmpty(aecanvas))
        return false;
    return aecanvas.isDrawingMode === true;
}
function app_aesthetics_set_drawing_mode() {
    if (isEmpty(aecanvas))
        return;
    aecanvas.isDrawingMode = true;
    aecanvas.freeDrawingBrush = new fabric.PencilBrush(aecanvas);
//    aecanvas.freeDrawingCursor = "url('resources/circle.svg') 0 50, auto";
}
function app_aesthetics_unset_drawing_mode() {
    if (isEmpty(aecanvas))
        return;
    aecanvas.isDrawingMode = false;
//    if(app_aesthetics_get_mode() === "draw") app_aesthetics_set_mode("move");
}
function app_aesthetics_select_layer_clear() {
    $("#editor-layers .editor-layer.new.selected").removeClass('selected');
    app_aesthetics_clear_settings();
    $("#app-aesthetics").removeClass("on-layer-selected");
}


function app_aesthetics_set_eraser_mode() {
    if (isEmpty(aecanvas))
        return;
    aecanvas.freeDrawingBrush = new fabric.EraserBrush(aecanvas);
    aecanvas.isDrawingMode = true;
}
function app_aesthetics_unset_eraser_mode() {
    if (isEmpty(aecanvas))
        return;
    aecanvas.isDrawingMode = false;
    if (app_aesthetics_get_mode() === "draw")
        app_aesthetics_set_mode("move");
}



function app_aesthetics_select_layer(event) {
    var o = $(event.currentTarget);
    var isSelected = o.hasClass("selected");
    $("#editor-layers .editor-layer.new.selected").removeClass('selected');
    if (isSelected) {
        app_aesthetics_select_layer_clear();
        return;
    }
    $(o).addClass("selected");
    $("#app-aesthetics").addClass("on-layer-selected");
    app_aesthetics_set_settings();
}
function app_aesthetics_set_settings() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
//    console.log("set active", layer);
    aecanvas.setActiveObject(layer);
    aecanvas.renderAll();
    $(".editor-layer-action-x").val(layer.left / aecanvas.width * 100);
    $(".editor-layer-action-x").parent().find(".form-range-preview").val(layer.left / aecanvas.width * 100);
    $(".editor-layer-action-y").val(layer.top / aecanvas.height * 100);
    $(".editor-layer-action-y").parent().find(".form-range-preview").val(layer.top / aecanvas.height * 100);
    $(".editor-layer-action-angle").val(layer.angle);
    $(".editor-layer-action-angle").parent().find(".form-range-preview").val(layer.angle);
    $(".editor-layer-action-scale").val(layer.scaleX || 1);
    $(".editor-layer-action-scale").parent().find(".form-range-preview").val(layer.scaleX || 1);
    var currentContrast = getFilterValue(layer, "contrast", "contrast");
    $(".editor-layer-action-contrast").val(currentContrast);
    $(".editor-layer-action-contrast").parent().find(".form-range-preview").val(currentContrast);
    var currentBlur = getFilterValue(layer, "blur", "blur");
    $(".editor-layer-action-blur").val(currentBlur);
    $(".editor-layer-action-blur").parent().find(".form-range-preview").val(currentBlur);
    var currentSaturation = getFilterValue(layer, "saturation", "saturation");
    $(".editor-layer-action-saturation").val(currentSaturation);
    $(".editor-layer-action-saturation").parent().find(".form-range-preview").val(currentSaturation);
    var currentBrightness = getFilterValue(layer, "brightness", "brightness");
    $(".editor-layer-action-brightness").val(currentHue);
    $(".editor-layer-action-brightness").parent().find(".form-range-preview").val(currentBrightness);
    var currentHue = getFilterValue(layer, "hueRotation", "rotation");
    $(".editor-layer-action-hue").val(currentHue);
    $(".editor-layer-action-hue").parent().find(".form-range-preview").val(currentHue);
    $(".editor-layer-action-opacity").val(layer.opacity * 100);
    $(".editor-layer-action-opacity").parent().find(".form-range-preview").val(layer.opacity * 100);
}

function app_aesthetics_clear_settings() {

    $(".editor-layer-action-x").val(0);
    $(".editor-layer-action-x").parent().find(".form-range-preview").val(0);
    $(".editor-layer-action-y").val(0);
    $(".editor-layer-action-y").parent().find(".form-range-preview").val(0);
    $(".editor-layer-action-angle").val(0);
    $(".editor-layer-action-angle").parent().find(".form-range-preview").val(0);
    $(".editor-layer-action-scale").val(1);
    $(".editor-layer-action-scale").parent().find(".form-range-preview").val(1);
    var currentContrast = 0;
    $(".editor-layer-action-contrast").val(currentContrast);
    $(".editor-layer-action-contrast").parent().find(".form-range-preview").val(currentContrast);
    var currentBlur = 0;
    $(".editor-layer-action-blur").val(currentBlur);
    $(".editor-layer-action-blur").parent().find(".form-range-preview").val(currentBlur);
    var currentSaturation = 0;
    $(".editor-layer-action-saturation").val(currentSaturation);
    $(".editor-layer-action-saturation").parent().find(".form-range-preview").val(currentSaturation);
    $(".editor-layer-action-brightness").val(0);
    $(".editor-layer-action-brightness").parent().find(".form-range-preview").val(0);
    $(".editor-layer-action-hue").val(0);
    $(".editor-layer-action-hue").parent().find(".form-range-preview").val(0);
    $(".editor-layer-action-opacity").val("");
    $(".editor-layer-action-opacity").parent().find(".form-range-preview").val("");
}

function on_app_aesthetics_object_modify(obj) {
    app_aesthetics_update_layers();
}

function app_aesthetics_get_selected_layer() {
    return $("#editor-layers .editor-layer.new.selected");
}
function app_aesthetics_get_selected_layer_id() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 0)
        return;
    var layerId = o.attr('data-layerid');
    return layerId;
}
function app_aesthetics_layer_moveleft(isRight = false) {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var objects = aecanvas.getObjects();
    var countObjects = objects.length;
    var layerIndex = parseInt(o.attr('data-layer'));
    var moveTo = isRight === true ? layerIndex + 1 : layerIndex - 1;
    if (moveTo < 0)
        return;
    if (moveTo > countObjects - 1)
        return;
    var layer = aecanvas.item(layerIndex);
    aecanvas.moveTo(layer, moveTo);
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_moveright() {
    app_aesthetics_layer_moveleft(true);
}

function app_aesthetics_layer_delete() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    aecanvas.remove(layer);
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
    setTimeout(app_aesthetics_apply, 1500);
}

function app_aesthetics_layer_opacity() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var opacity = $(".editor-layer-action-opacity").val();
    layer.opacity = opacity / 100;
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_hue() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-hue").val();
    var newfilter = new fabric.Image.filters.HueRotation({
        name: "hueRotation",
        rotation: current
    });
    if (typeof layer.filters === "undefined")
        layer.filters = [];
    layer.filters = layer.filters.filter(function (filter) {
        return filter.name !== 'hueRotation';
    });
    layer.filters.push(newfilter);
    layer.applyFilters();
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_contrast() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-contrast").val();
    var newfilter = new fabric.Image.filters.Contrast({
        name: "contrast",
        contrast: current
    });
    if (typeof layer.filters === "undefined")
        layer.filters = [];
    layer.filters = layer.filters.filter(function (filter) {
        return filter.name !== 'contrast';
    });
    layer.filters.push(newfilter);
    layer.applyFilters();
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_x() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-x").val();
    layer.left = current / 100 * aecanvas.width;
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_y() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-y").val();
    layer.top = current / 100 * aecanvas.height;
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_angle() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-angle").val();
    var originalCenter = {left: layer.left + layer.width / 2, top: layer.top + layer.height / 2};
    //layer.set({ originX: 'center', originY: 'center' });
    layer.rotate(current);
//    var newCenter = { left: layer.left + layer.width / 2, top: layer.top + layer.height / 2 };
//    layer.set({
//        left: layer.left + (originalCenter.left - newCenter.left),
//        top: layer.top + (originalCenter.top - newCenter.top)
//      });
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_scale() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-scale").val();
    layer.scaleX = current;
    layer.scaleY = current;
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_blur() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-blur").val();
    var newfilter = new fabric.Image.filters.Blur({
        name: "blur",
        blur: current
    });
    if (typeof layer.filters === "undefined")
        layer.filters = [];
    layer.filters = layer.filters.filter(function (filter) {
        return filter.name !== 'blur';
    });
    layer.filters.push(newfilter);
    layer.applyFilters();
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}
function app_aesthetics_layer_saturation() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-saturation").val();
    var newfilter = new fabric.Image.filters.Saturation({
        name: "saturation",
        saturation: current
    });
    if (typeof layer.filters === "undefined")
        layer.filters = [];
    layer.filters = layer.filters.filter(function (filter) {
        return filter.name !== 'saturation';
    });
    layer.filters.push(newfilter);
    layer.applyFilters();
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}

function app_aesthetics_layer_brightness() {
    var o = app_aesthetics_get_selected_layer();
    if (o.length < 1)
        return;
    var layerIndex = parseInt(o.attr('data-layer'));
    var layer = aecanvas.item(layerIndex);
    var current = $(".editor-layer-action-brightness").val();
    var newfilter = new fabric.Image.filters.Brightness({
        name: "brightness",
        brightness: current
    });
    if (typeof layer.filters === "undefined")
        layer.filters = [];
    layer.filters = layer.filters.filter(function (filter) {
        return filter.name !== 'brightness';
    });
    layer.filters.push(newfilter);
    layer.applyFilters();
    aecanvas.renderAll();
    updateCanvasState();
    app_aesthetics_update_layers();
}


function getFilterValue(object, filterName, filterKey) {
    if (typeof object.filters === "undefined")
        return 0;
    var filterval = object.filters.find(function (filter) {
        return filter.name === filterName;
    });
    if (filterval) {
        return filterval[filterKey];
    } else {
        return 0;
    }
}

function app_aesthetics_add_emptylayer() {

    fabric.Image.fromURL(
            "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII=",
            on_app_aesthetics_fromurl_finished,
            {
                crossOrigin: 'anonymous',
                id: app_aesthetics_get_unique_id(),
                hasControls: false,
                lockMovementX: true,
                lockMovementY: true,
                lockRotation: true,
                selectable: false
            }
    );
}

function app_aesthetics_add_debugimage() {
    app_aesthetics_hide_load();
    fabric.Image.fromURL(
//            "https://placehold.co/2048x2048/FF9999/FFF",
            "data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIGhlaWdodD0nMjA0OCcgd2lkdGg9JzIwNDgnPjxyZWN0IHdpZHRoPScyMDQ4JyBoZWlnaHQ9JzIwNDgnIHN0eWxlPSdmaWxsOnJnYigyNTUsMCwwKTsnPjwvcmVjdD48L3N2Zz4=",
            on_app_aesthetics_fromurl_finished,
            {
                crossOrigin: 'anonymous',
                id: app_aesthetics_get_unique_id(),
                hasControls: true,
                cornerSize: 30,
                cornerStyle: 'circle',
                cornerColor: UI_COLOR,
                transparentCorners: false
            }
    );
}

function app_aesthetics_load_image(url, callback) {
    aevent({action: "query", context: "filemanagement", query: "getImage", query2: url, callback: callback});
}

function on_app_aesthetics_object_selected(obj) {
    if (app_aesthetics_get_selected_layer_id() !== obj.id) {
        var target = $("#editor-layers .editor-layer.new[data-layerid='" + obj.id + "']").first();
        if (target.length > 0) {
            app_aesthetics_select_layer({currentTarget: target});
        }
    }
}


function resizeImage(base64Image, maxWidth, maxHeight, callback) {
// Create an image element
    var imgElement = new Image();
    // Set the source of the image element
    imgElement.src = base64Image;
    // Wait for the image to load
    imgElement.onload = function () {
        // Create a temporary canvas element
        var canvas = document.createElement('canvas');
        $(canvas).css("opacity", 0.001);
        var context = canvas.getContext('2d');
        // Calculate the aspect ratio
        var aspectRatio = imgElement.width / imgElement.height;
        // Calculate new dimensions to fit within maxWidth x maxHeight
        var newWidth = Math.min(imgElement.width, maxWidth);
        var newHeight = Math.min(imgElement.height, maxHeight);
        if (newWidth / newHeight > aspectRatio) {
            // Fit based on height
            newWidth = newHeight * aspectRatio;
        } else {
            // Fit based on width
            newHeight = newWidth / aspectRatio;
        }

        // Set the canvas size to the new dimensions
        canvas.width = newWidth;
        canvas.height = newHeight;
        // Draw the image onto the canvas with the new dimensions
        context.drawImage(imgElement, 0, 0, newWidth, newHeight);
        // Convert the canvas content to a base64 URL
        var resizedBase64 = canvas.toDataURL();
        // Call the callback with the resized image base64
        callback(resizedBase64);
    };
}


function app_aesthetics_update_morphology() {
    var value = $(".morphology-change").val();
    aevent({action: "query", context: "lookgenerator", query: "updateMorphology", query2: value});
    $(".morphology-change").val(100).trigger("change");
}

function app_aesthetics_tab_change(event) {
    var o = event.currentTarget;
    app_aesthetics_init_editor();
}

function app_aesthetics_on_draw_settings_change() {
    if (aecanvas == null)
        return;
    var width = parseInt($(".editor-layer-action-drawing-width").val());
    var opacity = parseFloat($(".editor-layer-action-drawing-opacity").val());
    var color = $("#editor-layer-action-drawing-color").attr("data-value");
    var rgb = hexToRgb(color);
    aecanvas.freeDrawingBrush.color = 'rgba(' + rgb.r + ',' + rgb.g + ', ' + rgb.b + ', ' + opacity + ')';
    aecanvas.freeDrawingBrush.width = width;
}
function app_aesthetics_on_eraser_settings_change() {
    if (aecanvas == null)
        return;
    var width = parseInt($(".editor-layer-action-eraser-width").val());
    aecanvas.freeDrawingBrush.width = width;
}


function app_aesthetics_receive_map(data) {
    if (typeof data === "string")
        data = JSON.parse(data);
//    console.log('app_aesthetics_receive_map', data);
    AESTHETICS_MAP = data;
}

function app_aesthetics_popuplate_templates() {
    if (Object.keys(AESTHETICS_MAP).length < 1)
        return;
    
    for (var key of Object.keys(AESTHETICS_MAP)) {
        var dest = $("#editor-templates-" + key + " .list");
        dest.find(".new").remove();
        var demo = dest.find(".demo");
        var ite = 0;
        for (var src of AESTHETICS_MAP[key]) {
            if(AESTHETICS_MAP[key].length < 9) ite=0; //1row too few items
            var prettypath = "../../../../../" + src;
            var o = demo.clone();
            o.removeClass("demo").addClass("new");
            o.find("img").attr("src", prettypath);
            o.attr("data-img", src);
            let name = src.split("\\");
            name = name[name.length - 1];
            name = name.split("/");
            name = name[name.length - 1];
            name = name.split(".");
            name.pop();
            name = name.join(".");
            o.find(".editor-template-name").html(name);
            dest.find(".r"+(ite%3)).append(o);
            ite++;
        }
        
    }

}

function app_aesthetics_select_template(event) {
    var o = $(event.currentTarget).parents(".editor-template");
    var src = o.attr('data-img');
    aevent({action: "query", context: "filemanagement", query: "getDirectImage", query2: src, callback: "on_app_aesthetics_image_loaded"});
}

function app_aesthetics_hide_load() {
    $(".aesthetic-editor-loading").hide();
}

var _config = {
    canvasState: [],
    currentStateIndex: -1,
    undoStatus: false,
    redoStatus: false,
    undoFinishedStatus: 1,
    redoFinishedStatus: 1,
};
//        function app_aesthetics_undo(){
//
//        }
//function app_aesthetics_redo(){
//
//}


function app_aesthetics_clear_history() {
    _config.canvasState = [];
}

function updateCanvasState() {
    if ((_config.undoStatus == false && _config.redoStatus == false)) {
        var jsonData = aecanvas.toJSON(['id']);
        var canvasAsJson = JSON.stringify(jsonData);
        if (_config.currentStateIndex < _config.canvasState.length - 1) {
            var indexToBeInserted = _config.currentStateIndex + 1;
            _config.canvasState[indexToBeInserted] = canvasAsJson;
            var numberOfElementsToRetain = indexToBeInserted + 1;
            _config.canvasState = _config.canvasState.splice(0, numberOfElementsToRetain);
        } else {
            _config.canvasState.push(canvasAsJson);
        }
        _config.currentStateIndex = _config.canvasState.length - 1;
        if ((_config.currentStateIndex == _config.canvasState.length - 1) && _config.currentStateIndex != -1) {
//    _config.redoButton.disabled = "disabled";
        }
    }
}
function app_aesthetics_undo() {
    if (_config.undoFinishedStatus) {
        if (_config.currentStateIndex == -1) {
            _config.undoStatus = false;
        } else {
            if (_config.canvasState.length >= 1) {
                _config.undoFinishedStatus = 0;
                if (_config.currentStateIndex != 0) {
                    _config.undoStatus = true;
                    aecanvas.loadFromJSON(_config.canvasState[_config.currentStateIndex - 1], function () {
                        var jsonData = JSON.parse(_config.canvasState[_config.currentStateIndex - 1]);
                        aecanvas.renderAll();
                        _config.undoStatus = false;
                        _config.currentStateIndex -= 1;
//                                                            _config.undoButton.removeAttribute("disabled");
//                                                            if(_config.currentStateIndex !== _config.canvasState.length-1){
//                                                                    _config.redoButton.removeAttribute('disabled');
//                                                            }
                        _config.undoFinishedStatus = 1;
                    });
                } else if (_config.currentStateIndex == 0) {
                    aecanvas.clear();
                    _config.undoFinishedStatus = 1;
//                                            _config.undoButton.disabled= "disabled";
//                                            _config.redoButton.removeAttribute('disabled');
                    _config.currentStateIndex -= 1;
                }
            }
        }
    }
    setTimeout(app_aesthetics_update_layers, 1000);
    
}

function app_aesthetics_redo() {
    if (_config.redoFinishedStatus) {
        if ((_config.currentStateIndex == _config.canvasState.length - 1) && _config.currentStateIndex != -1) {
//                            _config.redoButton.disabled= "disabled";
        } else {
            if (_config.canvasState.length > _config.currentStateIndex && _config.canvasState.length != 0) {
                _config.redoFinishedStatus = 0;
                _config.redoStatus = true;
                aecanvas.loadFromJSON(_config.canvasState[_config.currentStateIndex + 1], function () {
                    var jsonData = JSON.parse(_config.canvasState[_config.currentStateIndex + 1]);
                    aecanvas.renderAll();
                    _config.redoStatus = false;
                    _config.currentStateIndex += 1;
//                                                    if(_config.currentStateIndex != -1){
//                                                            _config.undoButton.removeAttribute('disabled');
//                                                    }
                    _config.redoFinishedStatus = 1;
//        if((_config.currentStateIndex == _config.canvasState.length-1) && _config.currentStateIndex != -1){
//          _config.redoButton.disabled= "disabled";
//        }
                });
            }
        }
    }
    setTimeout(app_aesthetics_update_layers, 1000);
}



TPL["aesthetics"] = `
<div class="app subtab_head" id="app-aesthetics">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-aesthetics-settings" >Aesthetics</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-aesthetics-head" >Head</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-aesthetics-body" >Body</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-aesthetics-limbs" >Limbs</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-aesthetics-hip" >Hip</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade " id="tab-aesthetics-settings" >
                <div class="container my-3">
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Auto refresh:</label>
                        </div>
                        <div class="col-7 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sedAutoRefresh">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Controls if the editor auto-refreshes the texture in vam when it changes. For best performance this should be off. But turning it on makes designing textures easier as you can see the results directly on the model without having to press Apply. By default this is Disabled (<b>0</b>).</div>
                    </div>
                </div>
            </div>
            
            <div class="tab-pane fade " id="tab-aesthetics-head" >

            </div>


            <div id="tab-aesthetics-face" class="mode-move" data-editor="face" data-mode="move">
                <div class="on-character-notselected">
                    <div class="container"><div class="row mt-4">
                            <div class="col-12 t">No person is selected.</div>
                        </div></div>
                </div>
                <div class="on-character-selected container-full">



                    <div class="container g-0">
                        <div class="row my-1 position-relative g-1">
                            <div class="col-2">
                                <div class="btn btn-sm btn-secondary aeditor-action-clear w-100 btn-danger"><span class="material-symbols-outlined">cancel</span></div>
                            </div>
                            <div class="col-2">
                                <div class="btn btn-sm btn-secondary  aeditor-action-undo w-100"><span class="material-symbols-outlined">undo</span></div>
                            </div>
                            <div class="col-2">
                                <div class="btn btn-sm btn-secondary  aeditor-action-redo w-100"><span class="material-symbols-outlined">redo</span></div>
                            </div>
                            
                           
                            <div class="col-2">
                                <div class="btn btn-sm btn-secondary  aeditor-action-save w-100"><span class="material-symbols-outlined">save</span></div>
                            </div>
                            <div class="col-4 text-end">
                                <div class="btn btn-sm btn-primary aeditor-action-apply w-100"><span class="material-symbols-outlined">done</span></div>
                            </div>
                        </div>
                    </div>


                    <div id="aesthetics-left">
                        <div class="container-full text-center">
                            <div class="row">
                                <div class="col-12">
                                    <div class="aesthetic-editor-container position-relative">
                                        <div class="aesthetics-background on-character-selected-female">
                                            <img class="aesthetic-editor-container-background on_subtab_head" src="resources/aesthetics/backgroundFace.jpg" />
                                            <img class="aesthetic-editor-container-background on_subtab_body" src="resources/aesthetics/backgroundBody.jpg" />
                                            <img class="aesthetic-editor-container-background on_subtab_limbs" src="resources/aesthetics/backgroundLimbs.jpg" />
                                            <img class="aesthetic-editor-container-background on_subtab_hip" src="resources/aesthetics/backgroundHip.jpg" />
                                        </div>
                                        <div class="aesthetics-background on-character-selected-male">
                                            <img class="aesthetic-editor-container-background on_subtab_head" src="resources/aesthetics/backgroundFaceM.jpg" />
                                            <img class="aesthetic-editor-container-background on_subtab_body" src="resources/aesthetics/backgroundBodyM.jpg" />
                                            <img class="aesthetic-editor-container-background on_subtab_limbs" src="resources/aesthetics/backgroundLimbsM.jpg" />
                                            <img class="aesthetic-editor-container-background on_subtab_hip" src="resources/aesthetics/backgroundHipM.jpg" />
                                        </div>
                                        <div id="canvas-cursor-holder">
                                            <div id="canvas-cursor"></div>
                                        </div>
                                        <canvas id="aesthetic-editor"  />
                                    </div>
                                    <div class="aesthetic-editor-loading">
                                        <div class="lds-roller"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="aesthetics-right">

                        <div class="container g-0" >
                            <div class="row my-1 " id="editor-layers-actions">


                                <div class="col-6" >

                                    <div class="on-mode-move-selected btn btn-secondary btn-sm btn-primary editor-layer-action editor-layer-mode editor-layer-mode-move" data-mode="move"><span class="material-symbols-outlined">open_with</span></div>
                                    <div class="on-mode-draw-selected btn btn-secondary btn-sm btn-primary editor-layer-action editor-layer-mode editor-layer-mode-draw" data-mode="draw"><span class="material-symbols-outlined">stylus_note</span></div>
                                    <div class="on-mode-eraser-selected btn btn-secondary btn-sm btn-primary editor-layer-action editor-layer-mode editor-layer-mode-eraser" data-mode="eraser"><span class="material-symbols-outlined">ink_eraser</span></div>

                                </div>
                                <div class="col-6 text-end" >
                                    <div class="btn btn-secondary btn-sm btn-primary editor-layer-action editor-layer-action-add"><span class="material-symbols-outlined">add_circle</span></div>
                                    <div class="btn btn-secondary btn-sm btn-primary editor-layer-action editor-layer-action-add-debugimage"><span class="material-symbols-outlined">dialogs</span></div>


                                </div>
                                <!-- <div class="col-12">
                                    <img id="editor-preview" class="w-100" />
                                </div>-->
                            </div>
                        </div>
                        <div class="container" id="editor-layers">
                            <div class="row">
                                <div class="col-4 "><h4 class="t">Layers</h4></div>
                                <div class="col-8 text-end">
                                    <div class="on-layer-selected-show btn btn-secondary btn-sm editor-layer-action  editor-layer-action-small editor-layer-action-movebefore"><span class="material-symbols-outlined">arrow_back</span></div>
                                    <div class="on-layer-selected-show btn btn-secondary btn-sm editor-layer-action  editor-layer-action-small editor-layer-action-moveafter"><span class="material-symbols-outlined">arrow_forward</span></div>
                                    <div class="on-layer-selected-show btn btn-secondary btn-sm editor-layer-action  editor-layer-action-small editor-layer-action-reset"><span class="material-symbols-outlined">open_in_full</span></div>
                                    <div class="on-layer-selected-show btn btn-danger btn-sm editor-layer-action  editor-layer-action-small editor-layer-action-delete"><span class="material-symbols-outlined">delete_forever</span></div>
                                </div>
                                <div class="col-12" >
                                    <div class="editor-layer demo">
                                        <div class="editor-layer-thumb"><img src=""/></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="container" id="editor-layer-drawing">
                            <div class="row settings-row" >
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Pencil width:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-drawing-width" min="0" max="100" value="5" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the drawing pencil width.</div>
                            </div>
                            <div class="row settings-row" >
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Pencil opacity:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-drawing-opacity" min="0" max="1" value="1" step="0.01">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the drawing pencil opacity.</div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Pencil color:</label>
                                </div>
                                <div class="col-6">
                                    <div id="editor-layer-action-drawing-color" class="colorpicker"  data-value="#000000" data-colorpicker-callback="app_aesthetics_on_draw_settings_change"></div>
                                </div>
                                <div class="col-1 col-helper">
                                    <span class="settings-info-icon material-symbols-outlined">help</span>
                                </div>
                                <div class="col-12 settings-info">Changes the color of the drawing pencil.</div>
                            </div>
                        </div>
                        <div class="container" id="editor-layer-eraser">
                            <div class="row settings-row" >
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Eraser width:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-eraser-width" min="0" max="100" value="5" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the drawing pencil width.</div>
                            </div>

                        </div>
                        <div class="container" id="editor-layer-operations">

                            <div class="row settings-row" >
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Opacity:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-opacity" min="0" max="100" step="0.1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the transparency of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Color:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-hue" min="-1" max="1" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the color of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Brightness:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-brightness" min="-1" max="1" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the brightness of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Contrast:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-contrast" min="-1" max="1" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the contrast of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Blur:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-blur" min="0" max="1" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the blur of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Saturation:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-saturation" min="-1" max="1" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the saturation of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Move x:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-x" min="-100" max="100" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the position of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Move y:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-y" min="-100" max="100" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the position of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Angle:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-angle" min="-180" max="180" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the rotation  of the selected layer.</div>
                            </div>

                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Scale:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range editor-layer-action-scale" min="0.01" max="3" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls the scale of the selected layer.</div>
                            </div>
                        </div>

                    </div>

                    <div id="aesthetics-left">

                        <div class="container editor-templates on_subtab_head" id="editor-templates-head">
                            <div class="row">
                                <div class="col-12 "><h4 class="t">Templates Head</h4></div>
                                <div class="editor-templates-list list scrollbar1" >
                                    <div class="editor-template demo">
                                        <div class="editor-template-thumb"><img src="" /></div>
                                        <div class="editor-template-name"></div>
                                    </div>
                                    <div class="templates-row r0"></div>
                                    <div class="templates-row r1"></div>
                                    <div class="templates-row r2"></div>
                                </div>
                            </div>
                        </div>
                        <div class="container editor-templates on_subtab_body" id="editor-templates-body">
                            <div class="row">
                                <div class="col-12 "><h4 class="t">Templates Body</h4></div>
                                <div class="editor-templates-list list scrollbar1" >
                                    <div class="editor-template demo">
                                        <div class="editor-template-thumb"><img src="" /></div>
                                        <div class="editor-template-name"></div>
                                    </div>
                                    <div class="templates-row r0"></div>
                                    <div class="templates-row r1"></div>
                                    <div class="templates-row r2"></div>
                                </div>
                            </div>
                        </div>
                        <div class="container editor-templates on_subtab_limbs" id="editor-templates-limbs">
                            <div class="row">
                                <div class="col-12 "><h4 class="t">Templates Limbs</h4></div>
                                <div class="editor-templates-list list scrollbar1" >
                                    <div class="editor-template demo">
                                        <div class="editor-template-thumb"><img src="" /></div>
                                        <div class="editor-template-name"></div>
                                    </div>
                                    <div class="templates-row r0"></div>
                                    <div class="templates-row r1"></div>
                                    <div class="templates-row r2"></div>
                                </div>
                            </div>
                        </div>
                        <div class="container editor-templates on_subtab_hip" id="editor-templates-hip">
                            <div class="row">
                                <div class="col-12 "><h4 class="t">Templates Hip</h4></div>
                                <div class="editor-templates-list list scrollbar1" >
                                    <div class="editor-template demo">
                                        <div class="editor-template-thumb"><img src="" /></div>
                                        <div class="editor-template-name"></div>
                                    </div>
                                    <div class="templates-row r0"></div>
                                    <div class="templates-row r1"></div>
                                    <div class="templates-row r2"></div>
                                </div>
                            </div>
                        </div>
                        <div class="container editor-templates" id="editor-templates-global">
                            <div class="row">
                                <div class="col-12 "><h4 class="t">Templates General</h4></div>
                                <div class="editor-templates-list list scrollbar1" >
                                    <div class="editor-template demo">
                                        <div class="editor-template-thumb"><img src="" /></div>
                                        <div class="editor-template-name"></div>
                                    </div>
                                    <div class="templates-row r0"></div>
                                    <div class="templates-row r1"></div>
                                    <div class="templates-row r2"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["aesthetics"] = {
    title: "Aesthetics",
    titleButtons: ["close"],
    icon: "aeternum",
    devOnly: false,
    isPersonApp: true
};$(document).ready(function () {
    $("#app").on("mousedown", "#app-scenebuttons .buttons-list .btn", function(){
        var id = $(this).attr("data-button-id");
        aevent({action:"vamTriggerButtonByInstanceId", id: id});
    });
});

function app_scenebuttons_prepare(html){
    
}

function app_scenebuttons_postprepare(){
    
}

function app_scenebuttons_cron_second(){
    
}

function tab_load_scenebuttons(){
    
}

function tab_load_scenebuttons_tab_scenebuttons_1(){
    app_scenebuttons_populate_send(1);
}
function tab_load_scenebuttons_tab_scenebuttons_2(){
    app_scenebuttons_populate_send(2);
}
function tab_load_scenebuttons_tab_scenebuttons_3(){
    app_scenebuttons_populate_send(3);
}
function tab_load_scenebuttons_tab_scenebuttons_4(){
    app_scenebuttons_populate_send(4);
}
function tab_load_scenebuttons_tab_scenebuttons_5(){
    app_scenebuttons_populate_send(5);
}

function app_scenebuttons_populate_send(page){
    aevent({action:"query",context:"scenebuttons",query:"loadbuttons", page: page, callback: 'app_scenebuttons_populate_received'});
}

function app_scenebuttons_populate_received(page, data){
    data = JSON.parse(data);
    app_scenebuttons_clear(page);
    var destination = $("#tab-scenebuttons-"+page+" .buttons-list");
    var demo = destination.find(".demo");
    if(Object.keys(data).length < 1) return;
    
    for(var key of Object.keys(data)){
        var entry = data[key];
        console.log("data", key, entry);
        console.log("data2", destination, demo);
        var item = demo.clone();
        item.removeClass("demo");
        item.addClass("new");
        item.html(entry.name);
        item.attr('data-button-id', entry.id);
        item.attr('style', entry.style);
        destination.append(item);
    }
   
}

function app_scenebuttons_clear(page){
    $("#app-scenebuttons .buttons-list .new").remove();
}TPL["scenebuttons"] = `
<div class="app" id="app-scenebuttons">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-scenebuttons-1" >Buttons</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-scenebuttons-2" >2</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-scenebuttons-3" >3</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-scenebuttons-4" >4</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-scenebuttons-5" >5</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-scenebuttons-help" >help</a>
        </li>
        

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            
            <div class="tab-pane fade" id="tab-scenebuttons-1">
                <div class="container mt-3">
                    <div class="row">
                        <div class="buttons-list col-12">
                            <div class="t btn btn-primary btn-sm demo">Button</div>
                        </div>
                    </div>
                </div>
            </div>
            
             <div class="tab-pane fade" id="tab-scenebuttons-2">
                <div class="container mt-3">
                    <div class="row">
                        <div class="buttons-list col-12">
                            <div class="t btn btn-primary btn-sm demo">Button</div>
                        </div>
                    </div>
                </div>
            </div>
            
             <div class="tab-pane fade" id="tab-scenebuttons-3">
                <div class="container mt-3">
                    <div class="row">
                        <div class="buttons-list col-12">
                            <div class="t btn btn-primary btn-sm demo">Button</div>
                        </div>
                    </div>
                </div>
            </div>
            
             <div class="tab-pane fade" id="tab-scenebuttons-4">
                <div class="container mt-3">
                    <div class="row">
                        <div class="buttons-list col-12">
                            <div class="t btn btn-primary btn-sm demo">Button</div>
                        </div>
                    </div>
                </div>
            </div>
            
             <div class="tab-pane fade" id="tab-scenebuttons-5">
                <div class="container mt-3">
                    <div class="row">
                        <div class="buttons-list col-12">
                            <div class="t btn btn-primary btn-sm demo">Button</div>
                        </div>
                    </div>
                </div>
            </div>
            
            <div class="tab-pane fade" id="tab-scenebuttons-help">
               <div class="container">
                    <div class="col-12 py-3">
                        <p class="t">This app grabs all the UIButtons atoms in the scene that have the plugin <b>AliveButtons</b> (AliveButtons.cslist is in the Plugins folder in the var) and adds them to the UI for easier & quicker access.</p>
                        <br />
                        <p class="t">In the style field of that plugin UI you can add CSS code to format how the button appears in the UI.</p>
                        <br />
                        <p><span class="t">Guide video on YouTube</span>: "ALIVE: Your custom buttons inside the UI"</p>
                    </div>
                </div>
            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["scenebuttons"] = {
    title: "Scene Buttons",
    titleButtons: ["close"],
    icon: "fun",
};$(document).ready(function () {
    $("#mainapp").on("mousedown", ".android-chat-clearall", android_chat_clearall);
    $("#mainapp").on("mousedown", ".android-chat-clearold", android_chat_clearold);
    $("#mainapp").on("mousedown", ".android-chat-react", android_chat_react);
    $("#mainapp").on("mousedown", ".android-chat-continue", android_chat_continue);
    $("#app").on("mousedown", "#chat-player-actions .player-action", chat_player_action_selected)
    
    $("#app").on("mousedown", ".chat-emotion", chat_player_emotion);
    $("#app").on("mousedown", ".quickmessage-item", chat_player_quickmessage);
    
//    $("body").on("mousedown",".person-bottom-main-avatar", function(){if(!$("body").hasClass("character-is-android")) return; app_android_form_more($(this))});
    
    $("#app").on("mousedown", "#chat-textbox-submit", function () {
        app_android_submit_chat();
    });
    $("#app").on("keypress", "#chat-textbox", function (event) {
        if (event.keyCode === 13) {
            event.preventDefault();
            app_android_submit_chat();
        }
    });

    $("#app").on("mousedown", "#chat-textbox-record", function () {
        app_android_start_recording();
    });
    
      $("#app").on("mousedown", ".android-profile-chat", function(){
        var a = app_android_get_current_android();
        character_load_chat(a.id);
    });
    
});

function app_chat_prepare(html){
    
}

function app_chat_postprepare(){
    var android_id = Person.getCurrentAndroidId();
    var app = App.GetCurrent();
    app.SetParam(android_id);
}

function app_chat_cron_second(){
    
}

function tab_load_chat(){
    
}
function tab_load_chat_tab_inbox_chat(){
    var app = App.GetCurrent();

    var person = new Person(character_get_selected()); 
    var android_id = person.getAndroidId();
    
    if(!isEmpty(android_id) && person.isAndroid()){
        var a = Android.getFromEphemeral(android_id);
        $("#tab-inbox-chat.android").attr("data-androidid",android_id);
        app_android_update_android_position($("#tab-inbox-chat.android"), a);

        $('#tab-inbox-chat .android-avatar IMG').attr("src", a.getImageProfileTimestamp());
        $('#tab-inbox-chat .android-name').html(a.getName());

        var event = {action:"query",context:"android",context2:a.id,query:"getChatHistory",callback:"callback_receive_chat_history"};
        event = aephemeral_callback(event);
        aevent(event);
    } else {
        App.LoadApp("home");
    }
    
  
}

function app_chat_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}




function app_android_submit_chat() {
    var message = $("#chat-textbox").val();
    $("#chat-textbox").val("");
    app_android_submit_chat_val(message);
}

function app_android_submit_chat_val(message) {
    app_android_add_chat_item({isAi: "false", message: message});

//    if (!isTrue(EPHEMERAL.aesettings.sttServicesLocalAssist)) {   
//        var app = App.GetCurrent();
//        var android_id = app.GetParam();
//        var data = {action: "interactionUserChat", message: message};
//
//        aevent(data);
//    } else {
//        RIVE.reply(message);
//    }
     RIVE.reply(message);
}


function app_android_submit_chat_val_android(message){
    aevent({action: "interactionUserChatFromAi", answer: message, message: " ", isArtificial: true});
}

function callback_receive_chat_history(ctx, data){
    if(isEmpty(data)) return;
    if(typeof data === "string") data = JSON.parse((data));
    EPHEMERAL.queries[ctx] = data; 
   app_android_populate_chat();
}


function app_android_process_actions(msg, isMe = false) {
    if(isEmpty(msg)) return "";
  const regex = /[\*(]([^*]+)[\*)]/g;
  const result = msg.replace(regex, '');
  const fragments = msg.match(regex);
      
  const cleanedFragments = fragments ? fragments.map(fragment => fragment.replace(/[\*()]/g, '')) : [];
  if(cleanedFragments.length > 0){
      for(var fragment of cleanedFragments) app_android_process_action(fragment, isMe);
  }
}


function app_android_clear_actions(msg) {
  if(isEmpty(msg)) return "";
  const regex = /[\*(]([^*]+)[\*)]/g;
  const result = msg.replace(regex, '');
  return result;
}



function app_android_process_action(msg,isMe = false){
    var action = $('<div class="chat-action">'+msg+'</div>');
    if(isMe){
        action.addClass("chat-action-me");
    }
    $("#chat-items-holder").append(action);
}



function app_android_populate_chat(){
    var android_id = App.GetCurrentParam();
    var data = EPHEMERAL.queries["android_getChatHistory_"+android_id];
//    if(isEmpty(data["info"])) return;
//    var info = data.info;
//    delete data.info;
    app_android_clear_chat();
    var keys = Object.keys(data);
    if(keys.length<1){
        android_load_first_message();
        return;
    }
    var lastDay = "";
    for(var key of keys){
        if(key === "info") continue;
        var msg = data[key];
      
        var day = formatTimestampDay(msg.time);
        if(day !== lastDay){
            app_android_add_day_separator(day);
            lastDay = day;
        }
        app_android_add_chat_item(msg, true);
    }
    
}

function app_android_add_day_separator(day){
    var destination = $("#chat-log #chat-items-holder");   
    var separator = $('<div class="day-separator">'+day+'</div>')
    destination.append(separator);
}

function app_android_clear_chat(){
    var destination = $("#chat-log");
    destination.find(".chat-item").each(function(){
        if($(this).hasClass("demo")) return;
        $(this).remove();
    });
}



function app_android_chat_bottom() {
    $("#chat-log").scrollTop($("#chat-log")[0].scrollHeight);
}
function app_tab_refresh(){
    App.TabRefresh();
}
function android_chat_refresh(){
    App.TabRefresh();
}
function android_chat_clearall(){
    aevent({action:"query",context:"android",query:"chatclearall"});
    setTimeout(android_load_first_message, 1000);
}

function android_load_first_message(){
    var app = App.GetCurrent();
    var android_id = app.GetParam();
    var android = Android.getFromEphemeral(android_id);
    var first_message = android.firstmessage || "";
    first_message = first_message.trim();
    if(first_message.length === 0) return;
    app_android_submit_chat_val_android(first_message);
   
}
function android_chat_clearold(){
    aevent({action:"query",context:"android",query:"chatclearold"});
}

function android_chat_react(){
    var msg = Language.getTranslated("What do you see?");
    app_android_submit_chat_val(msg);
}
function android_chat_continue(){
    var msg = "";
    app_android_submit_chat_val(msg);
}



function app_android_add_chat_item_stt(data) {
    if (typeof data === "string") {
        data = JSON.parse(data);
    }
    app_android_add_chat_item(data);
    RIVE.reply(data.message);


}
function app_android_clear_chat(){
    var destination = $("#chat-log");
    destination.find(".day-separator").remove();
     destination.find(".chat-action").remove();
    destination.find(".chat-item").each(function(){
        if($(this).hasClass("demo")) return;
        $(this).remove();
    });
}

function add_chat_ai_image(img){
    if($("#chat-log").length === 0) return;
    app_android_add_chat_item({isAi: "true", message: '<img class="cimg" src="data:image/jpg;base64, '+img+'" />'});
}


function app_android_add_chat_item_from_ai(data){
    app_android_add_chat_item(data);
//    aevent({action:"query", context:"android", query:"showNotification"})
}
function app_android_add_chat_item(data, isPopulate = false) {
    var app = App.GetCurrent();
    if (typeof data === "string") {
        data = JSON.parse(data);
    }

    if(typeof data.time === "undefined") data.time = getTimestamp();
    
    var android_id = app.GetParam();
    var android = Android.getFromEphemeral(android_id);
    
    //console.log("app_android_add_chat_item", data);
    var destination = $("#chat-items-holder");
    var isAi = isTrue(data.isAi);
    if (typeof data.ai !== "undefined")
        isAi = isTrue(data.ai);
    var msg = data.message;
    if (typeof data.msg !== "undefined")
        msg = data.msg;
    
    
   
    //@todo split multiple messages?
    if(isTrue(data.temporary)){
        app_android_process_actions(msg, !isAi);
        return;
    }

    var cleanedmsg =  app_android_clear_actions(msg);

    var name = isAi ? android.getName() : PERSON_NAME;
    var item = $(".chat-item.demo").clone();
    item.removeClass("demo");
    item.find(".user-name").html(name);
    item.find(".user-message").html(cleanedmsg);
    item.find(".message-time").html(formatTimestampGetTime(data.time));

    if (isAi) {
        item.removeClass("chat-me");
        if (typeof data.sentiment !== "undefined") {
            var sentiment = convertToPercentSentiment(parseFloat(data.sentiment));
            var color = getRedGreenColor(sentiment);
            item.find(".user-sentiment-value").css("width", sentiment + "%").css("background-color", color);
        } else {
            item.find(".user-sentiment-value").hide();
        }
    }
    app_android_process_actions(msg,  !isAi);
    
    if(!isEmpty(cleanedmsg.trim())){
        destination.append(item);
    }
    
    app_android_chat_bottom();
    setTimeout(app_android_chat_bottom,600);
    
     if (isTrue(data.isAiGenerated)){
         setTimeout(function(){RIVEARTIFICIAL.reply(msg, true);}, 3000);
     }
     
     if(!isPopulate && isAi){
         aevent({action:"speechBubbleChat", message: cleanedmsg});
     }
     
     if(isTrue(data.forceNext)){
         setTimeout(android_chat_continue,1500);  
     }
    
}



function app_android_chat_writing_animation(enable = "true"){
    var destination = $("#chat-items-holder");
    if(isTrue(enable)){ 
        if( destination.find(".chat-bubble.new").length > 0) return;
        var el = $(".chat-bubble.demo").clone();
        el.removeClass("demo").addClass("new").css("display","none");
        destination.append(el);
        setTimeout(function(){
            $(".chat-bubble.new").css('display',"inline-block");
        }, 500);
        
    } else {
        var el = destination.find(".chat-bubble.new");
        if(el.length > 0){
            $(el).remove();
        }
    }
}

function app_android_action_player(action){
    app_android_submit_chat_val(action);
}


function app_android_get_user(user) {
    var o = {
        name: user,
        avatar: ""
    };
    return o;
}
function chat_player_quickmessage(){
    var msg = $(this).text();
    app_android_submit_chat_val(msg);
    chat_player_action_unselect();
}
function chat_player_emotion(o){
    var emotion = "*"+$(this).text().toLowerCase()+"*";
    app_android_submit_chat_val(emotion);
    chat_player_action_unselect();
}

function chat_player_action_unselect(){
    $("#chat-player-actions .player-action.selected").removeClass('selected');
    $("#chat-player-actions .chat-player-action-panel.selected").removeClass('selected');
}
function chat_player_action_selected(event){;
    var o = event.currentTarget;
    var isSelected = $(o).hasClass("selected");
    chat_player_action_unselect();
    if(isSelected) return;
    
    $(o).addClass("selected");
    var panel = $(o).attr('data-panel');
    if(isEmpty(panel)){
        chat_player_action_unselect();
        return;
    }
    $('#'+panel).addClass('selected');
}


function ai_inquiry_option(prefix,list,suffix, callback){
    aevent({action:"query",context:"android",query:"aiInquiryOption", prefix:prefix,list:list,suffix ,callback:callback});
}

function test_inquiry(){
    ai_inquiry_option
}TPL["chat"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-inbox-chat">Chat</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade android" id="tab-inbox-chat">
                <div class="on-character-notandroid">
                    <div class="row my-3">
                        <div class="col col-12">
                            <h5 class="t">No character is selected.</h5>
                        </div>
                    </div>
                </div>
                <div class="on-character-android">
                    <div class="row">
                        <div class="col-12">


                            <div class="row" id="chat-container" style="">

                                <div id="chat-log" class="col-12 scrollbar1" >
                                    <!--                                <div id="chat-buttons" class="row">
                                                                        <div class="col"><div class="t btn btn-primary btn-sm android-chat-clearall">Clear chat</div></div>
                                                                        <div class="col"><div class="t btn btn-primary btn-sm android-chat-clearold">Clear old</div></div>
                                                                    </div>-->

                                    <div class="chat-bubble demo"><div class="dot-pulse"></div></div>

                                    <div class="chat-item chat-me demo">
                                        <div class="item-chat-avatar">
                                            <img src="" class="mr-3 user-avatar">
                                        </div>
                                       
                                        <div class="item-chat-body">
                                            <h5 class="mt-0 user-name">User 1</h5>
                                            <span class="user-message">Hello there!</span>
                                            <div class="message-time"></div>
                                            <div class="user-sentiment"><div class="user-sentiment-value"><span></span></div></div>
                                        </div>
                                    </div>
                                     <div id="chat-items-holder">
                                            
                                        </div>
                                    <div id="chat-player-actions">
                                        <div class="player-action player-action-quickmessage" data-panel="player-action-quickmessage-panel">
                                            <span class="material-symbols-outlined">speaker_notes</span><span class="t">Text</span>
                                        </div>
                                        <div class="player-action player-action-commands" data-panel="player-action-commands-panel">
                                            <span class="material-symbols-outlined">priority_high</span><span class="t">Command</span>
                                        </div>
                                        <div class="player-action player-action-reaction" data-panel="player-action-reaction-panel">
                                            <span class="material-symbols-outlined">add_reaction</span><span class="t">React</span>
                                        </div>
                                        <div class="player-action player-action-reaction android-chat-react">
                                            <span class="material-symbols-outlined">visibility</span><span class="t">Sight</span>
                                        </div>
                                        <div class="player-action  player-action-more android-chat-continue">
                                            <span class="material-symbols-outlined">more_horiz</span><span class="t">Continue</span>
                                        </div>
                                        <div id="chat-placyer-action-panels">
                                            
                                            <div id="player-action-commands-panel" class="chat-player-action-panel">
                                                <div class="text-center">
                                                    <div class="quickmessage-item hover-bright t">Turn around</div>
                                                    <div class="quickmessage-item hover-bright t">Come to me</div>
                                                    <hr />
                                                </div>
                                            </div>
                                            
                                            <div id="player-action-quickmessage-panel" class="chat-player-action-panel">
                                                <div class="text-center">
                                                    <div class="quickmessage-item hover-bright t">Yes.</div>
                                                    <div class="quickmessage-item hover-bright t">No.</div>
                                                    <div class="quickmessage-item hover-bright t">Hmm...</div>
                                                    <div class="quickmessage-item hover-bright t">Maybe.</div>
                                                    <div class="quickmessage-item hover-bright t">Please!</div>
                                                    <div class="quickmessage-item hover-bright t">Stop!</div>
                                                    <div class="quickmessage-item hover-bright t">Continue!</div>
                                                    <div class="quickmessage-item hover-bright t">I don't know.</div>
                                                    <div class="quickmessage-item hover-bright t">I can't say.</div>
                                                    <div class="quickmessage-item hover-bright t">Tell me more.</div>
                                                    <hr />
                                                    <div class="quickmessage-item hover-bright t">Why?</div>
                                                    <div class="quickmessage-item hover-bright t">How?</div>
                                                    <div class="quickmessage-item hover-bright t">What?</div>
                                                    <div class="quickmessage-item hover-bright t">When?</div>
                                                    <hr />
                                                    <div class="quickmessage-item hover-bright t">I love it!</div>
                                                    <div class="quickmessage-item hover-bright t">I hate it!</div>
                                                    <div class="quickmessage-item hover-bright t">It's ok.</div>
                                                    <div class="quickmessage-item hover-bright t">I need your help.</div>
                                                    <hr />
                                                    <div class="quickmessage-item hover-bright t">Hello!</div>
                                                    <div class="quickmessage-item hover-bright t">Hi.</div>
                                                    <div class="quickmessage-item hover-bright t">Good morning.</div>
                                                    <div class="quickmessage-item hover-bright t">Goodbye.</div>
                                                    <hr />
                                                    <div class="quickmessage-item hover-bright t">How are you?</div>
                                                    <div class="quickmessage-item hover-bright t">How was it?</div>
                                                    <div class="quickmessage-item hover-bright t">How was your day?</div>
                                                    <div class="quickmessage-item hover-bright t">How do you feel?</div>
                                                    <div class="quickmessage-item hover-bright t">What do you want to do?</div>
                                                    <div class="quickmessage-item hover-bright t">What do you want?</div>
                                                    <div class="quickmessage-item hover-bright t">What's the matter?</div>
                                                    <div class="quickmessage-item hover-bright t">Do you like it?</div>
                                                    <div class="quickmessage-item hover-bright t">Did you like it?</div>
                                                    <div class="quickmessage-item hover-bright t">What would you like?</div>
                                                    
                                                    
                                                </div>
                                            </div>
                                            
                                            <div id="player-action-reaction-panel" class="chat-player-action-panel">

                                                <div class="text-center">
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*smiles*"><div class="icon">🙂</div><div class="title t">Smile</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*laugh out loud*"><div class="icon">🤣</div><div class="title t">Laugh</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*wink*"><div class="icon">😉</div><div class="title t">Wink</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*embarrased laugh*"><div class="icon">😅</div><div class="title t">Embarrassed</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*loving it*"><div class="icon">🥰</div><div class="title t">Loving it</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*kisses*"><div class="icon">😘</div><div class="title t">Kiss</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*cheeky reaction*"><div class="icon">😛</div><div class="title t">Cheeky</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*mocking reaction*"><div class="icon">🤪</div><div class="title t">Mocking</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*thinks of money*"><div class="icon">🤑</div><div class="title t">Money</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*gives hug*"><div class="icon">🤗</div><div class="title t">Hug</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*chuckle*"><div class="icon">🤭</div><div class="title t">Chuckle</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*shushes*"><div class="icon">🤫</div><div class="title t">Shush</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*thinking*"><div class="icon">🤔</div><div class="title t">Thinking</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*suspicious*"><div class="icon">🤨</div><div class="title t">Suspicious</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*no comment*"><div class="icon">😐</div><div class="title t">No comment</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*smirking*"><div class="icon">😏</div><div class="title t">Smirking</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*rolls eyes*"><div class="icon">🙄</div><div class="title t">Roll eyes</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*unamused*"><div class="icon">😒</div><div class="title t">Unamused</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*grimacing*"><div class="icon">😬</div><div class="title t">Grimacing</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*drooling*"><div class="icon">🤤</div><div class="title t">Drooling</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*relieved*"><div class="icon">😌</div><div class="title t">Relieved</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*sleepy*"><div class="icon">😴</div><div class="title t">Sleepy</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*hurt*"><div class="icon">🤕</div><div class="title t">Hurt</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*sick*"><div class="icon">🤢</div><div class="title t">Sick</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*puking*"><div class="icon">🤮</div><div class="title t">Puke</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*sweating*"><div class="icon">🥵</div><div class="title t">Sweating</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*shivering*"><div class="icon">🥶</div><div class="title t">Shivering</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*confused*"><div class="icon">🥴</div><div class="title t">Confused</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*amazed*"><div class="icon">🤯</div><div class="title t">Amazed</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*celebrating*"><div class="icon">🥳</div><div class="title t">Celebrating</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*acts cool*"><div class="icon">😎</div><div class="title t">Cool</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*nerdy*"><div class="icon">🤓</div><div class="title t">Nerdy</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*worried*"><div class="icon">😟</div><div class="title t">Worried</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*sad*"><div class="icon">🙁</div><div class="title t">Sad</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*frowning*"><div class="icon">☹</div><div class="title t">Frown</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*surprised*"><div class="icon">😮</div><div class="title t">Surprised</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*shocked*"><div class="icon">😲</div><div class="title t">Shocked</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*blushing*"><div class="icon">😳</div><div class="title t">Blushing</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*pleading*"><div class="icon">🥺</div><div class="title t">Pleading</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*fearful*"><div class="icon">😨</div><div class="title t">Fearful</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*cries*"><div class="icon">😢</div><div class="title t">Tearing up</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*cries loudly*"><div class="icon">😭</div><div class="title t">Crying</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*screams*"><div class="icon">😱</div><div class="title t">Scream</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*disappointed*"><div class="icon">😞</div><div class="title t">Disappointed</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*yawns*"><div class="icon">🥱</div><div class="title t">Yawn</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*tired*"><div class="icon">😫</div><div class="title t">Tired</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*angry*"><div class="icon">😡</div><div class="title t">Angry</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*curses*"><div class="icon">🤬</div><div class="title t">Curse</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*naughty smile*"><div class="icon">😈</div><div class="title t">Naughty</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*waves hand*"><div class="icon">👋</div><div class="title t">Wave hand</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*shows OK sign*"><div class="icon">👌</div><div class="title t">OK</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*shows peace sign*"><div class="icon">✌</div><div class="title t">Peace</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*crosses fingers*"><div class="icon">🤞</div><div class="title t">Fingers crossed</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*shows middle finger*"><div class="icon">🖕</div><div class="title t">Middle finger</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*thumbs up*"><div class="icon">👍</div><div class="title t">Thumbs up</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*thumbs down*"><div class="icon">👎</div><div class="title t">Thumbs down</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*claps*"><div class="icon">👏</div><div class="title t">Clap</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*handshakes*"><div class="icon">🤝</div><div class="title t">Handshake</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*praying*"><div class="icon">🙏</div><div class="title t">Pray</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*writes it down*"><div class="icon">✍</div><div class="title t">Write it</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*flexes muscles*"><div class="icon">💪</div><div class="title t">Flex</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*watching*"><div class="icon">👀</div><div class="title t">Watching</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*sticks tongue out*"><div class="icon">👅</div><div class="title t">Tongue out</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*facepalms*"><div class="icon">🤦‍♀️</div><div class="title t">Facepalm</div></div>
                                                    <div class="chat-emotion hover-bright chat-emotion-emoji"  data-val="*shrugs*"><div class="icon">🤷‍♀️</div><div class="title t">Shrug</div></div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>


                    <div id="chat-input" class="row" >
                        <div class="col-12" >
                            <form>
                                <div  class="input-group2">
                                    <button class="t btn btn-sm btn-secondary android-chat-clearold" id="chat-textbox-trim" type="button" >Trim</button>
                                    <button class="t btn btn-sm btn-secondary android-chat-clearall" id="chat-textbox-clear" type="button" >Clear</button>
                                    <!--<button class="t btn btn-sm btn-primary android-chat-react" id="chat-textbox-react" type="button" >React</button>-->
                                    <!--<button class="t btn btn-sm btn-primary android-chat-continue" type="button" >Continue</button>-->
                                </div>
                                <div  class="input-group">
                                    <button class="btn btn-secondary" id="chat-textbox-record" type="button" ><span class="material-symbols-outlined">mic</span></button>
                                    <textarea id="chat-textbox" class="form-control keyboard" style="resize:none" placeholder="..." ></textarea>
                                    <button class="t btn btn-primary" id="chat-textbox-submit" type="button" >Send</button>
                                </div>

                            </form>
                        </div>
                    </div>
                </div>

            </div>

            
        </div>
    </div>
</div>
`;


$(document).ready(function () {

});

META["chat"] = {
    title: "Chat",
    titleButtons: ["close"],
    icon: "aeternum",
    isCharacterApp: true,
    skipHome: true
//    classes: "on-character-android"
};$(document).ready(function () {
    
    
   
    
    $("#app").on("mousedown","#contacts-list-characters .contact",function(){
        var id = $(this).attr('data-id');
        character_load_chat(id);
    });
    
    
    
});


function app_messages_prepare(html){
    
}

function app_messages_postprepare(){
    
}

function app_messages_cron_second(){
    
}

function tab_load_messages(){
    
}

function tab_load_messages_tab_inbox_contacts(){
    app_messages_populate_contacts();
}


function app_messages_populate_contacts(){
    var destination = $("#contacts-list-characters");
    destination.find('.new').remove();
    var demo = destination.find(".demo");
    if(!EPHEMERAL.queries.androids_list) return;
    if(!EPHEMERAL.queries.androids_list.androids) return;
    if(Object.keys(EPHEMERAL.queries.androids_list.androids).length < 1) return;
    for(var a of EPHEMERAL.queries.androids_list.androids){
        var android = new Android(a);
        var el = demo.clone();
        el.removeClass("demo").addClass("new");
        el.find('.contact-avatar').attr("src", android.getImageProfileTimestamp());
        el.find('.contact-name').html(android.getName());
        el.attr('data-id', android.id);
        destination.append(el);
    }
    
}



TPL["messages"] = `
<div class="app" id="app-messages">
    <ul class="nav nav-tabs app-tabs" >
        <!--        <li class="nav-item">
                    <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-inbox" >Inbox</a>
                </li>-->
        <!--        <li class="nav-item">
                    <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-inbox-contacts">Contacts</a>
                </li>-->
        

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-inbox">

                <div class="container py-3">
                    <!--                    <div class="row  inbox-panel show" id="tab-inbox-messages-list">
                                            <div class="col-12 tab-inbox-tools">
                                                <div class="tab-inbox-tool" data-action="refresh"><span class="material-symbols-outlined">refresh</span></div>
                                            </div>
                                        </div>
                                        <div class="row inbox-panel" id="tab-inbox-messages-message">
                                            <div class="col-12 tab-inbox-tools">
                                                <div class="tab-inbox-tool" data-action="back"><span class="material-symbols-outlined">arrow_back</span></div>
                                                <div class="tab-inbox-tool" data-action="delete"><span class="material-symbols-outlined">delete</span></div>
                                            </div>
                                        </div>-->
                    TBD
                </div>

            </div>

            <div class="tab-pane fade" id="tab-inbox-contacts">
                <div class="container mt-3" id="contacts-list-search">
                    <div class="row mb-1">
                        <div class="col-12">
                            <input id="settings-search-settings-general" data-aesearch="#contacts-list" class="keyboard aesearchfilter search-filter keyboard" type="text" />
                        </div>
                    </div>
                </div>
                <div class="container" id="contacts-list">
                    <div class="row">
                        <div class="col-12">
                            <h4 class="t section-title">Characters</h4>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12" id="contacts-list-characters">
                            <div class="contact demo aesearchitem">
                                <img src="" class="contact-avatar"/>
                                <h5 class="contact-name aesearchtext"></h5>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            

        </div>
    </div>




</div>
`;$(document).ready(function () {

});

META["messages"] = {
    title: "Messages",
    titleButtons: ["close"],
    icon: "fun",
    skipHome: true
};$(document).ready(function () {

});

function app_dependencies_prepare(html){
    
}

function app_dependencies_postprepare(){
    
}

function app_dependencies_cron_second(){
    
}

function tab_load_dependencies(){
    
}
function tab_load_dependencies_tab_1(){
    app_dependencies_check_packs();
}

function app_dependencies_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}


function app_dependencies_check_packs(){
    let list = [];
    
    $("#app-dependencies .item").each(function(k,v){
        if($(v).attr("data-dependency") === undefined) return;
        list.push($(this).attr("data-dependency"));
    });
    
    aevent({action:"query", context: "dependencies", query:"getStatus", list: list, callback: "app_dependencies_receive"});
}
function app_dependencies_receive(data){
    if (typeof data === "string") {
        data = JSON.parse(data);
    }
    $("#app-dependencies .item.selected").removeClass("selected");
    if(isEmpty(data)) return;
    
    $("#app-dependencies .item").each(function(k,v){
         if($(this).attr("data-dependency") === undefined) return;
         let package = $(this).attr("data-dependency");
         if(typeof data[package] === "undefined") return; 
         if(isTrue(data[package])){
             $(v).addClass("selected");
         }
     })
   
}

TPL["dependencies"] = `
<div class="app" id="app-dependencies">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-1" >Dependencies</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-1"> 
                <div class="container">
                    <div class="alert uialert  alert-secondary t my-3" role="alert">Please add these VARs directly in the AddonPackages folder (not in subfolders) to avoid problems. ALIVE works without these packages too, but for best quality and more features it's recommended to install them too.</div>
                   <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Morph packs</h4></div></div>
                    <div class="row"><div class="col-12"><h6 class="t">Add these addon packages to get more variation to face expressions.</h6></div></div>
                    <div class="row">
                        <div class="col-12">
                            <div class="item" data-dependency="ascorad.asco_Expressions.12">
                                <div class="td-package">asco_Expressions</div>
                                <div class="td-author">ascorad</div>
                                <div class="td-file">ascorad.asco_Expressions.12.var</div>
                                <div class="td-installed">12</div>
                            </div>
                            <div class="item" data-dependency="AshAuryn.AshAuryn_Sexpressions_2_Point_0.4">
                                <div class="td-package">AshAuryn_Sexpressions_2_Point_0</div>
                                <div class="td-author">AshAuryn</div>
                                <div class="td-file">AshAuryn.AshAuryn_Sexpressions_2_Point_0.4.var</div>
                                <div class="td-installed">4</div>
                            </div>
                            <div class="item" data-dependency="AshAuryn.Expressions.5">
                                <div class="td-package">Expressions</div>
                                <div class="td-author">AshAuryn</div>
                                <div class="td-file">AshAuryn.Expressions.5.var</div>
                                <div class="td-installed">5</div>
                            </div>
                            <div class="item" data-dependency="AshAuryn.Pose_Tools.4">
                                <div class="td-package">Pose_Tools</div>
                                <div class="td-author">AshAuryn</div>
                                <div class="td-file">AshAuryn.Pose_Tools.4.var</div>
                                <div class="td-installed">4</div>
                            </div>
                            <div class="item" data-dependency="Jackaroo.JarModularExpressions.2">
                                <div class="td-package">JarModularExpressions</div>
                                <div class="td-author">Jackaroo</div>
                                <div class="td-file">Jackaroo.JarModularExpressions.2.var</div>
                                <div class="td-installed">2</div>
                            </div>
<!--                            <div class="item" data-dependency="kemenate.Morphs.10">
                                <div class="td-package">Morphs</div>
                                <div class="td-author">kemenate</div>
                                <div class="td-file">kemenate.Morphs.10.var</div>
                                <div class="td-installed">10</div>
                            </div>-->
<!--                            <div class="item" data-dependency="Spacedog.Import_Reloaded_Lite.2">
                                <div class="td-package">Import_Reloaded_Lite</div>
                                <div class="td-author">Spacedog</div>
                                <div class="td-file">Spacedog.Import_Reloaded_Lite.2.var</div>
                                <div class="td-installed">2</div>
                            </div>-->
                        </div>
                    </div>
                    

                    


                   
                    

                    <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Animation</h4></div></div>
                    <div class="row"><div class="col-12"><h6 class="t">Add these addon packages to get more animations.</h6></div></div>
                    <div class="row">
                        <div class="col-12">


                            <div class="item" data-dependency="SPQR.AnimationsPack.latest">
                                <div class="td-package">AnimationsPack</div>
                                <div class="td-author">SPQR</div>
                                <div class="td-file">SPQR.AnimationsPack.1.var</div>
                                <div class="td-installed">1</div>
                            </div>
                        </div>
                    </div>

                    
                    <div class="row mt-3"><div class="col-12"><h4 class="t section-title">ALIVE Extras</h4></div></div>
                    <div class="row"><div class="col-12"><h6 class="t">Add these addon packages to get more ALIVE extras, like Alive Home and Aesthetics textures.</h6></div></div>
                    <div class="row">
                        <div class="col-12">
                            <div class="item" data-dependency="SPQR.AliveExtrasOptional.2">
                                <div class="td-package">AliveExtrasOptional</div>
                                <div class="td-author">SPQR</div>
                                <div class="td-file">SPQR.AliveExtrasOptional.2.var</div>
                                <div class="td-installed">2</div>
                            </div>
                        </div>
<!--                        <div class="col-12">
                            <div class="item" data-dependency="SPQR.AliveTextures.1">
                                <div class="td-package">AliveTextures</div>
                                <div class="td-author">SPQR</div>
                                <div class="td-file">SPQR.AliveTextures.1.var</div>
                                <div class="td-installed">1</div>
                            </div>
                        </div>-->
                    </div>

                    

                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["dependencies"] = {
    title: "Dependencies",
    titleButtons: ["close"],
    icon: "vam"
};$(document).ready(function () {
    $("#app").on("mousedown", ".aecinematic", function(e){
        var query = $(this).attr("data-query");
        var query2 = $(this).attr("data-query2");
        aevent({action:"query", context:"cinematic", query:query, query2: query2});
    });
});

function app_cinematic_prepare(html){
    
}

function app_cinematic_postprepare(){
    
}

function app_cinematic_cron_second(){
    
}

function tab_load_cinematic(){
    
}
function tab_load_cinematic_tab_cinematic_1(){
    
}

function app_cinematic_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}

TPL["cinematic"] = `
<div class="app" id="app-cinematic">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-cinematic-1" >Cinematic</a>
        </li>
       
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-cinematic-1">
                <div class="container">
                    <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Cinematic shot</h4></div></div>
                    <div class="row my-3">
                        <div class="col-12">
                            <div class="btn btn-sm btn-primary aecinematic t" data-query="stop">Stop</div>
                            <div class="btn btn-sm btn-primary aecinematic t" data-query="reset">Reset</div>
                        </div>
                        
                        <div class="col-12">
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Cinematic duration:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="cinematicDuration" min="0" max="100" step="0.1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info t">The time duration of the cinematic effect in seconds. The default is <b>3</b>.</div>
                            </div>
                        </div>
                         <div class="col-12">
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Cinematic speed:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="cinematicSpeed" min="0" max="100" step="0.001">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info t">The speed at which the cinematic movement happens. The default is <b>0.25</b>.</div>
                            </div>
                        </div>
                        
                    </div>
                    <div class="row my-3">
                        <div class="col-12">
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="zoomout">Zoom out</div>
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="zoomin">Zoom in</div>
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="slideforward">Slide forward</div>
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="slidebackward">Slide backward</div>
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="slideleft">Slide left</div>
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="slideright">Slide right</div>
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="slideup">Slide up</div>
                            <div class="btn btn-sm btn-primary t aecinematic" data-query="start" data-query2="slidedown">Slide down</div>
                        </div>
                    </div>
                    
                    <div class="row my-3"><div class="col-12"><h4 class="t section-title">Shaky Cam</h4></div></div>
                    
                    <div class="row settings-row aesearchitem">
                       <div class="col-4">
                           <label class="t form-check-label aesearchtext">Enable:</label>
                       </div>
                       <div class="col-7 form-check form-switch">
                           <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="shakyCamEnable">
                       </div>
                       <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                       <div class="col-12 settings-info">Controls if the shaky cam is enabled. Resets when Alive reloads. By default this is Disable (<b>0</b>).</div>
                   </div>
                   
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Shake force:</label>
                        </div>
                        <div class="col-6">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="shakycamForce" min="0" max="5" step="0.001">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Controls how much the camera shakes. The default value is <b>1</b>.</div>
                    </div>
                    
                    
                    
                </div>
            </div>
            <div class="tab-pane fade" id="tab-cinematic-2">testt2</div>
            <div class="tab-pane fade" id="tab-cinematic-3">testt3</div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["cinematic"] = {
    title: "Cinematic",
    titleButtons: ["close"],
    icon: "fun",
};$(document).ready(function () {
    $("body").on("mousedown",".aeanimation",function(){
        var anim = $(this).attr("data-animation");
        aevent({action:"query",context:"animation",query:"play", query2: anim});
    });
    $("body").on("mousedown",".aeanimation-action",function(){
        var anim = $(this).attr("data-animation-action");
        aevent({action:"query",context:"animation",query:anim});
    });
    
    $("#app").on("mousedown","#animations-list .play", function(){
         var anim = $(this).parents(".item").attr("data-animation");
         aevent({action:"query",context:"animation",query:"play", query2: anim});
    });
    
    $("#app").on("mousedown",".animation-seach-set", function(){
         var anim = $(this).attr("data-search");
         $("#settings-search-settings-general").val(anim).trigger("keyup");
    });
});

function app_animation_prepare(html){
    
}

function app_animation_postprepare(){
    
}

function app_animation_cron_second(){
    
}

function tab_load_animation(){
    
}
function tab_load_animation_tab_1(){
    app_animation_populate();
}

function app_animation_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}

function animation_get_file(animation){
    var file = animation.file;
    file = file.replace("@","AddonPackages\\SPQR.AnimationsPack.1.var:\\Custom\\BVH\\BVH Animations ",file);
    return file;
}

function app_animation_populate(){
    var destination = $("#animations-list");
    var demo = destination.find(".demo");
    destination.find(".new").remove();
    
    for(var animation of DATA["animations"]){
        var el = demo.clone();
        el.removeClass("demo").addClass("new");
        el.attr('data-animation', animation_get_file(animation));
        el.find(".title").html( !isEmpty(animation.title) ? animation.title : replaceAll(animation.name,"_"," "));
        destination.append(el);
    }
    
    
//    destination.find( ".new .slider-range-time" ).slider({
//      range: true,
//      min: 0,
//      max: 100,
//      values: [ 0, 100 ],
//      slide: function( event, ui ) {
////        $( "#amount" ).val( "$" + ui.values[ 0 ] + " - $" + ui.values[ 1 ] );
//      }
//    });
    
    
    $("#settings-search-settings-general").trigger("keyup");
}


TPL["animation"] = `
<div class="app" id="animation">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-1" >Animation</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-2" >Settings</a>
        </li>
      
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-1"> 
                <div class="container on-character-notselected">
                    <div class="row mt-4">
                        <div class="col-12 t">No person is selected.</div>
                    </div>
                </div>
                <div class="container on-character-selected">
                   
                    <div class="row  animation-top-bar">
                        <div class="col-5">
                            <div class="btn btn-primary btn-sm aeanimation-action" data-animation-action="stop"><span class="material-symbols-outlined">pause</span></div>
                            <div class="btn btn-primary btn-sm person-menu-button-reset-pose" ><span class="material-symbols-outlined">accessibility</span></div>
                        </div>
                        <div class="col-7">
                            <input id="settings-search-settings-general" data-aesearch="#animations-list" class="keyboard aesearchfilter search-filter keyboard" type="text" />
                        </div>
                    </div>
                    <div class="row animation-content scrollbar1">
                         <div class="col-12 pb-2">
                            <div class="btn btn-sm btn-secondary animation-seach-set t" data-search="dance">Dance</div>
                        </div>
                        <div class="col-12" id="animations-list">
                            <div class="demo item animation-item aesearchitem" data-animation="">
                                <div class="title aesearchtext"></div>
<!--                                
                                <div class="slider-range-time-container">
                                    <input class="slider-range-time1 form-range w-70" type="range" min="0" max="100" step="0.1" value="0" />
                                </div>
                                <div class="slider-range-time-container">
                                    <input class="slider-range-time2 form-range w-70" type="range" min="0" max="100" step="0.1" value="100" />
                                </div>
                                -->
                                
                                <div class="btn btn-sm btn-primary play"><span class="material-symbols-outlined">play_arrow</span> <span class="t">PLAY</span></div>
<!--                                <div class="btn btn-sm btn-secondary animation-addsequence"><span class="material-symbols-outlined">movie</span> <span class="t">Add</span></div>
                                <div class="btn btn-sm btn-secondary animation-addsequence"><span class="material-symbols-outlined">movie</span> <span class="t">Fav</span></div>-->
                            </div>
                            
                        </div>
                    </div>
                    
                    
                </div>
            </div>
            <div class="tab-pane fade" id="tab-2"> 
                <div class="container">
                    
                     
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Animation speed:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="animSpeed" min="0" max="2" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the playback speed of animations. Default is <b>1</b>.</div>
                        </div>
                    
                        <div class="row settings-row aesearchitem">
                            <div class="col-4">
                                <label class="t form-check-label aesearchtext">Animation loop:</label>
                            </div>
                            <div class="col-7 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="animLoop">
                            </div>
                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the animations will play in a loop. By default this is Disabled (<b>0</b>).</div>
                        </div>
                    
                    
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Head angle offset:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="animHeadAngleOffset" min="-40" max="40" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the offset of the head angle (head inclined up or down). Default is <b>17</b>.</div>
                        </div>
                    
                        <div class="row settings-row aesearchitem">
                            <div class="col-4">
                                <label class="t form-check-label aesearchtext">Smoother animation:</label>
                            </div>
                            <div class="col-7 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="animSmooth">
                            </div>
                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, Alive will limit how much body parts can move when animated to prevent abrupt large movements. By default this is Enabled (<b>1</b>).</div>
                        </div>
                    
                    
                    
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Smoothness limit:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="animSmoothLevel" min="0.01" max="20" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When Smoother animation is enabled, this controls how much elements are allowed to be moved between animation frames. Default is <b>15</b>.</div>
                        </div>
                    
                    
                    
                    
<!--                       <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Distance limitation:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="animMaxDistance" min="0" max="20" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the model is allowed to move. Smaller value will make the model move around body parts on smaller distance length. Default is <b>10</b>.</div>
                        </div>
                    
                     <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Rotation limitation:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="animMaxDistanceRotation" min="0" max="30" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the model is allowed to rotate body parts. Smaller value will make body parts rotate less. Default is <b>20</b>.</div>
                    </div>
                    
                     <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Joints Distance Ratio:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="animMaxDistanceJoints" min="0" max="1" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the knees and elbows are allowed to move. The value is the percent of the general Distance Limitation. Default is <b>0.75</b>.</div>
                    </div>
                    -->
                    
                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["animation"] = {
    title: "Animation",
    titleButtons: ["close"],
    icon: "aeternum",
};$(document).ready(function () {

    $("#app").on("mousedown",".trigger-entry-copy",function(){
        var text = $(this).parents(".entry").find(".trigger-entry-value").val();
        copyTextToClipboard(text);
    });
    
     $("#app").on("mousedown",".copy-clipboard",function(){
        var text = $(this).text();
        copyTextToClipboard(text);
    });
    
    $("#app").on("mousedown",".textarea-copy textarea", function(){
        var p = $(this).parents(".textarea-copy");
        var text = $(this).val();
        copyTextToClipboard(text);
        $(p).addClass('copied');
        setTimeout(function(){$(p).removeClass('copied')}, 1000);
    });
});

function app_triggers_prepare(html){
    
}

function app_triggers_postprepare(){
    
}

function app_triggers_cron_second(){
    
}

function tab_load_triggers(){
    
}
function tab_load_triggers_tab_triggers_1(){
    app_triggers_populate();
}

function app_triggers_populate(){
    var destination = $(".triggers-list");
    destination.find(".entry.new").remove();
    var demo = destination.find(".demo");
    var keys =  Object.keys(Triggers.log);
    for(var k of keys){
        var entry = demo.clone();
        entry.removeClass("demo");
        entry.addClass("new");
        entry.find(".trigger-entry-value").val(JSON.stringify(Triggers.log[k]));
        entry.find(".textarea-title").html(Triggers.getTitle(Triggers.log[k]));
        destination.prepend(entry);
    }
}





TPL["triggers"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-triggers-1" >Triggers</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-triggers-custom" >Custom</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-triggers-help" >Help</a>
        </li>
        <!--        <li class="nav-item">
                    <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Filters</a>
                </li>-->

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-triggers-1">

                <div class="container mt-3">

                    <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Recent UI events</h4></div></div>
                    <div class="triggers-list">
                        <div class="row demo entry">
                            <div class="col-5 textarea-title fs-8"></div>
                            <div class="col-7 textarea-copy">
                                <textarea class="trigger-entry-value"></textarea>
                            </div>
                        </div>
                    </div>



                </div>

            </div>
            
             <div class="tab-pane fade" id="tab-triggers-custom">
                <div class="container mt-3">
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">TTS Person:</label>
                        </div>
                        <div class="col-7 textarea-copy ">
                            <textarea class="w-100">{"action": "apiSpeak","value": "Put your text here."}</textarea>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Plays text as audio. Requires for an Alive TTS option to be enabled in the Services app.</div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">TTS Narrator:</label>
                        </div>
                        <div class="col-7 textarea-copy ">
                            <textarea class="w-100">{"action": "apiSpeakNarrator","value": "Put your text here."}</textarea>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Plays text as audio. Requires for an Alive TTS option to be enabled in the Services app.</div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Effect Toggle:</label>
                        </div>
                        <div class="col-7 textarea-copy ">
                            <textarea class="w-100">{"action":"query","context":"effects","query":"toggle","effect":"EmoHappy"}</textarea>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Toggles on and off an effect on the person. query must be set to <u>toggle</u></div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Effect Start:</label>
                        </div>
                        <div class="col-7 textarea-copy ">
                            <textarea class="w-100">{"action":"query","context":"effects","query":"start","effect":"EmoHappy"}</textarea>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Start an effect on the person. query must be set to <u>start</u></div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Effect Stop:</label>
                        </div>
                        <div class="col-7 textarea-copy ">
                            <textarea class="w-100">{"action":"query","context":"effects","query":"stop","effect":"EmoHappy"}</textarea>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Stops an effect on the person. query must be set to <u>start</u></div>
                    </div>
                </div>
             </div>

            <div class="tab-pane fade" id="tab-triggers-help">
                <div class="container mt-3">
                    <div class="row mt-3">
                     
                        <div class="row mt-3"><div class="col-12"><h3 class="t section-title">WARNING: experimental</h3></div></div>
                        
                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Alive triggers</h4></div></div>
                        <div class="col-12">
                            <p class="t"> Triggers in vam can be used to add more advanced logic to your scenes and connect vam features and plugins in specific ways. If you want to use Alive triggers you have to add this plugin to any atom: Plugins/AliveEvents.cslist. Then you can trigger things by doing a normal vam trigger call to Atom > plugin#_SPQR.AliveEvents > AliveData and putting an Alive Event in the Text To Send vam field.  <br /> <br />
                                
                                I'll try to add more documentation about available triggers, but there are so many and in constant change these days and DIY stuff tools like this are very low priority so for now the best way to use it is by copying UI functionality. If you want to do something that the Alive UI can do, you can do it first through the UI and then come back to this app and copy the event and then paste it in the vam trigger in the AliveData field. Events that are specific to an atom (changing a person setting, or moving an atom, etc) must be sent to an AliveEvents plugin on that specific atom. Then the <%id%> part will get replaced with the id of the atom that gets the event. </<p class="t">
                            <p class="t"></p>
                        </div>
                       
                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Finding events to use</h4></div></div>
                        <div class="col-12">
                            <p class="t">
                                This app logs the latest events, formats them to work with triggers and lets you copy them when you click on them. So if you want to find how to do something that the UI does, do it first in the UI and then come back to the UI and you should see it in the recent events lists, from where you can copy and paste it in a VAM trigger. There will be other extra triggers created specifically for vam triggers that will be listed separately in this app in the Custom tab.
                            </p>
                        </div>
                         <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Atom specific triggers</h4></div></div>
                        <div class="col-12">
                            <p class="t">
                                For events that are specific to a particular person or other atom, the trigger must be sent to an instance of the AliveEvents.cslist plugin that is on that atom. The <%id%> part that appears in some events will be replaced with the internal ID of the atom that has the plugin to which the event is sent. So if you want to do person triggers, the person must have the AliveEvents plugin, similar a bit with how the old person-specific Alive plugin worked.
                            </p>
                        </div>
                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Events format</h4></div></div>
                        <div class="col-12">
                            <p class="t">
                                Alive Events are formatted as JSON strings, same as VAM's save files (looks, scenes, etc). They're basically a list inside {} like {"a":"value for A", "b":"value for B"}. The only thing you really need to be careful about are texts that include ". It's better to just avoid " and use ' instead. If you google "json formatter online" there are also plenty of tools to validate or help build such strings if you want to do something more complex.
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["triggers"] = {
    title: "Triggers",
    titleButtons: ["close"],
    icon: "vam"
};$(document).ready(function () {

});

function app_alivehome_prepare(html){
    
}

function app_alivehome_postprepare(){
    
}

function app_alivehome_cron_second(){
    
}

function tab_load_alivehome(){
    
}
function tab_load_alivehome_tab_1(){
    
}

function app_alivehome_on_initialized(){
    ISHOME = true;
    $("body").addClass("is-home");
}TPL["alivehome"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-1">Alive Home Settings</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-1"> 
                <div class="container my-3">
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">City Cars:</label>
                        </div>
                        <div class="col-6">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="ahIntTrafficCars" min="0" max="20" step="1">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Number of cars moving around Aeternum City. Default is <b>20</b>.</div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["alivehome"] = {
    title: "Home Settings",
    titleButtons: ["close"],
    isAliveHome: true,
    icon: "devel"
};$(document).ready(function () {

});

function app_actions_prepare(html){
    
}

function app_actions_postprepare(){
    
}

function app_actions_cron_second(){
    if($("#app-actions").length < 1) return;
}

function tab_load_actions_tab_actions_personality(){
    $("#tab-actions-personality .toggle.personality").each(function(){
        $(this).prop("checked", isTrue( EPHEMERAL.characters[character_get_selected()]['enabled']["personality_trait_"+$(this).attr("data-query2")]));
    });
}
TPL["actions"] = `
<div class="app" id="app-actions">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-actions-3" >Head</a>
        </li>
<!--        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-actions-personality">Emotions</a>
        </li>-->

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">




            <div class="tab-pane fade pb-5" id="tab-actions-3">
                <div class="container mt-3">
                    <div class="row aelivebool-mutual">
                        <div class="col col-12">
                            <h5 class="t">Head focus</h5>
                        </div>
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="stop" data-query-effect="LookAt" data-query-param="" data-aeliveeffect="LookAt" data-aeliveeffect-enabled="false">
                                <div class="card-body p-0 t">Auto</div>
                            </div>
                        </div>
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="start" data-query-effect="LookAt" data-query-param="me" data-aeliveeffect="LookAt" data-aeliveeffect-param="me">
                                <div class="card-body p-0 t">Me</div>
                            </div>
                        </div>
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="start" data-query-effect="LookAt" data-query-param="away" data-aeliveeffect="LookAt"  data-aeliveeffect-param="away">
                                <div class="card-body p-0 t">Away</div>
                            </div>
                        </div>
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="start" data-query-effect="LookAt" data-query-param="front" data-aeliveeffect="LookAt"  data-aeliveeffect-param="front">
                                <div class="card-body p-0 t">Front</div>
                            </div>
                        </div>
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="start" data-query-effect="LookAt" data-query-param="people" data-aeliveeffect="LookAt"  data-aeliveeffect-param="people">
                                <div class="card-body p-0 t">People</div>
                            </div>
                        </div>
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="start" data-query-effect="LookAt" data-query-param="objects" data-aeliveeffect="LookAt" data-aeliveeffect-param="objects">
                                <div class="card-body p-0 t">Objects</div>
                            </div>
                        </div>
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="start" data-query-effect="LookAt" data-query-param="target"  data-aeliveeffect="LookAt"  data-aeliveeffect-param="target">
                                <div class="card-body p-0 t">Target</div>
                            </div>
                        </div>

                    </div>

                    <div class="row mt-3">
                        <div class="col col-12">
                            <h5 class="t">Mouth</h5>
                        </div>
                        <div class="col-6 col-md-3">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="TongueOut" data-aeliveeffect="TongueOut" data-aeliveeffect-enabled="true">
                                <div class="card-body p-0 t">Tongue out</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MouthOpen" data-aeliveeffect="MouthOpen"  data-aeliveeffect-enabled="true">
                                <div class="card-body p-0 t">Mouth open</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="LipsPucker"  data-aeliveeffect="LipsPucker" data-aeliveeffect-enabled="true">
                                <div class="card-body p-0 t">Lips pucker</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MouthSmile" data-aeliveeffect="MouthSmile" data-aeliveeffect-enabled="true">
                                <div class="card-body p-0 t">Mouth smile</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="ChewingGum" data-aeliveeffect="ChewingGum" data-aeliveeffect-enabled="true">
                                <div class="card-body p-0 t">Chewing gum</div>
                            </div>
                        </div>

                    </div>

                    <div class="row mt-3">
                        <div class="col col-12">
                            <h5 class="t">Face</h5>
                        </div>
                        <div class="col-6 col-md-3">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EyesClosed" data-aeliveeffect="EyesClosed" data-aeliveeffect-enabled="true">
                                <div class="card-body p-0 t">Eyes closed</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="FaceKiss" data-aeliveeffect="FaceKiss" data-aeliveeffect-enabled="true">
                                <div class="card-body p-0 t">Kiss</div>
                            </div>
                        </div>
                        <!--                        <div class="col-6 col-md-3">
                                                    <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="FacePhotoEpressions" data-aeliveeffect="FacePhotoEpressions" data-aeliveeffect-enabled="true">
                                                        <div class="card-body p-0 t">
                                                            Photo expressions
                                                        </div>
                                                    </div>
                                                </div>-->
                    </div>
                    
                    <div class="row mt-3">
                        <div class="col col-12">
                            <h5 class="t">Emotions</h5>
                        </div>
                    </div>
                    <div class="row settings-row aesearchitem">

                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoHappy"  data-aeliveeffect="EmoHappy" >
                                <div class="card-body p-0 t">Happy</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoSad"  data-aeliveeffect="EmoSad" >
                                <div class="card-body p-0 t">Sad</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoShy"  data-aeliveeffect="EmoShy" >
                                <div class="card-body p-0 t">Shy</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoSeductive"  data-aeliveeffect="EmoSeductive" >
                                <div class="card-body p-0 t">Seductive</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoExpressive"  data-aeliveeffect="EmoExpressive" >
                                <div class="card-body p-0 t">Expressive</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoAngry"  data-aeliveeffect="EmoAngry" >
                                <div class="card-body p-0 t">Angry</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoCute"  data-aeliveeffect="EmoCute" >
                                <div class="card-body p-0 t">Cute</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoAnnoyed"  data-aeliveeffect="EmoAnnoyed" >
                                <div class="card-body p-0 t">Annoyed</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoScared"  data-aeliveeffect="EmoScared" >
                                <div class="card-body p-0 t">Scared</div>
                            </div>
                        </div>
                        <div class="col-6 col-md-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="EmoSatisfied"  data-aeliveeffect="EmoSatisfied" >
                                <div class="card-body p-0 t">Satisfied</div>
                            </div>
                        </div>
                    </div>      
                    

                </div>

            </div>


            <div class="tab-pane fade py-4" id="tab-actions-personality">
                <div class="container">
                    

                    <!--                    
                                        
                                        
                                         <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Happy:</label>
                                            </div>
                                            <div class="col-7 form-check form-switch ">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Happy" />
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Sad:</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Sad" />
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Shy:</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Shy"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Seductive:</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Seductive"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Expressive:</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Expressive"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Angry:</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Angry"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Cute</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Cute"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Annoyed</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Annoyed"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                         <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Scared</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Scared"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                  
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Satisfied</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Satisfied"/>
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                          
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Confused</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Confused">
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>
                                        
                                       
                                        
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Curious</label>
                                            </div>
                                            <div class="col-7 form-check form-switch">
                                                <input class="form-check-input aequery toggle personality" type="checkbox" role="switch" data-context="android" data-query="personality" data-query2="Curious">
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">Toggles personality trait.</div>
                                        </div>-->


                </div>
            </div>



        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["actions"] = {
    title: "Actions",
    titleButtons: ["close"],
    icon: "person",
    isPerson: true,
    skipHome: true,
};var app_vamdiffusion_last_image  = null;
$(document).ready(function () {
    $("#mainapp").on("mousedown",".vamdiffusion-capture", app_vamdiffusion_capture);
    $("#mainapp").on("mousedown",".vamdiffusion-capture-quick", app_vamdiffusion_capture_quick);
    $("#mainapp").on("mousedown",".vamdiffusion-preview", app_vamdiffusion_preview);
});

function app_vamdiffusion_prepare(html){
    
}

function app_vamdiffusion_postprepare(){
    
}

function app_vamdiffusion_cron_second(){
    
}

function tab_load_vamdiffusion(){
    
}
function tab_load_vamdiffusion_tab_vamdiffusion_1(){
    
}

function tab_load_vamdiffusion_tab_vamdiffusion_cam(){
    aevent({action:"query", context:"vamdiffusion", query:"loadCameraApp"});
    if(app_vamdiffusion_last_image === null) return;
    app_vamdiffusion_load_image_final(app_vamdiffusion_last_image);
}

function tab_load_vamdiffusion_tab_vamdiffusion_settings(){
    aevent({action:"query", context:"vamdiffusion", query:"refreshControlnetModels"});
    aevent({action:"query", context:"vamdiffusion", query:"refreshSamplers"});
}

function app_vamdiffusion_reset_settings(){
//    console.log("app_vamdiffusion_reset_settings");
    App.Load(App.GetCurrentAppName());
}

function app_vamdiffusion_load_image_final(src){
    app_vamdiffusion_last_image  = src;
    app_vamdiffusion_load_image_src(src);
    app_vamdiffusion_remove_loading();
}
function app_vamdiffusion_load_image_temp(src){
    app_vamdiffusion_load_image_src(src);
    app_vamdiffusion_add_loading();
}


function app_vamdiffusion_load_image_path(path){
    var url = "../../../../../Saves/PluginData/Aeternum/Diffusion/"+path;
    $("#vamdiffusion-result").attr("src", url);
}
function app_vamdiffusion_remove_loading(){
    $(".vamdiffusion-cam-live").removeClass("loading");
}

function app_vamdiffusion_add_loading(){
    $(".vamdiffusion-cam-live").addClass("loading");
}
function app_vamdiffusion_load_image_src(src){
    var img = "data:image/jpg;base64,"+src;
    $("#vamdiffusion-result").attr("src", img);
}

function app_vamdiffusion_capture(){
    aevent({action:"query", context:"vamdiffusion", query:"capture"});
}
function app_vamdiffusion_capture_quick(){
    aevent({action:"query", context:"vamdiffusion", query:"captureQuick"});
}
function app_vamdiffusion_preview(){
    aevent({action:"query", context:"vamdiffusion", query:"preview"});
}

function app_vamdiffusion_callback_controlnetmodels(data){
    if(typeof data === "string") data = JSON.parse(data);
    if(data.length < 0 ) return;
    
    var o = $(".form-select[data-aesetting='diffControlnetModelUpdated']");
    if(o.length < 1) return;
    o.find("option").remove();
    for(var v of data){
        var selected = Settings.getString("diffControlnetModelUpdated") === v ? ' selected="selected" ': "";
        o.append('<option value="'+v+'" '+selected+'>'+v+'</option');
    }
}

function app_vamdiffusion_callback_samplers(data){
//    console.log("app_vamdiffusion_callback_samplers", data);
    if(typeof data === "string") data = JSON.parse(data);
    if(data.data.length < 0 ) return;
    
    var o = $(".form-select[data-aesetting='diffSampler']");
    if(o.length < 1) return;
    o.find("option").remove();
    for(var v of data.data){
        var name = v.name;
        var selected = Settings.getString("diffSampler") === name ? ' selected="selected" ': "";
        o.append('<option value="'+name+'" '+selected+'>'+name+'</option');
    }
}TPL["vamdiffusion"] = `
<div class="app" id="app-vamdiffusion">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-vamdiffusion-cam" >Cam</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-vamdiffusion-prompt" >AI Prompt</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-vamdiffusion-settings" >Settings</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-vamdiffusion-lora" >LoRA</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-vamdiffusion-help" >Help</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1 py-4">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-vamdiffusion-cam">
                <div class="container">
                    <div class="vamdiffusion-cam-live">
                        <img id="vamdiffusion-result" />
                        <div class="vamdiffusion-loading"><div class="lds-default"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div></div>
                    </div>
                    <div class="vamdiffusion-cam-buttons row g-1">
                        <div class="col-10"><div class="btn btn-primary w-100 vamdiffusion-capture"><span class="material-symbols-outlined">photo_camera</span></div></div>
                        <div class="col-2"><div class="btn btn-primary w-100 vamdiffusion-capture-quick"><span class="material-symbols-outlined">acute</span></div></div>
                        <!--<div class="col-3"><div class="t btn btn-primary w-100 px-0 vamdiffusion-preview">Preview</div></div>-->
                    </div>
                </div>
            </div>
            <div class="tab-pane fade text-start" id="tab-vamdiffusion-prompt">

                <div class="container py-3">




                    <div class="row settings-row aesearchitem">
                        <div class="col-11">
                            <label class="t form-check-label aesearchtext">Prompt:</label>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Positive terms to describe what the image should contain. </div>
                        <div class="col-12">
                            <textarea id="setting-diffPrompt" type="text" class="form-textarea mt-0 aesetting aesetting-text keyboard" data-aesetting="diffPrompt">
                            </textarea>
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-11">
                            <label class="t form-check-label aesearchtext">Negative:</label>
                        </div>

                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Negative terms to describe what the image should not contain. </div>
                        <div class="col-12">
                            <textarea id="setting-diffNprompt" type="text" class="form-textarea mt-0 aesetting aesetting-text keyboard" data-aesetting="diffNprompt">
                            </textarea>
                        </div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Steps:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffSteps" min="1" max="100" step="1">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">This is the sampling steps from A1111. It's the number of iterations the AI will go over the image. With more steps the AI will add more details to the image, but this it will take more time to finish. Default value is <b>17</b>. The default value in A1111 is 20. People usually use values between 15-30.</div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">CFG (Text strictness):</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffCfg" min="0" max="30" step="0.1">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">CFG value from A1111. Controls how big of an impact the prompt should have. Lower value lets the AI be more creative and follow what 'it knows', images will look a bit more hazy and desaturated and more realistic. Higher values will force the AI to try to satisfy the prompts more; images will look a bit more saturated and forced. Default value is <b>7</b>.</div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Denoise (image creativity):</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffDenoise" min="0" max="1" step="0.01">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Denoise value from A1111. Controls how closely the AI will follow the input (the screenshot from vam). On higher creativity values, the AI will ignore more the image, while on lower values it will try to follow it more closely. Default value is <b>0.4</b>.</div>
                    </div>





                </div>
            </div>

            <div class="tab-pane fade text-start py-3" id="tab-vamdiffusion-settings">
                <div class="container">
                    <div class="row settings-row">
                        <div class="col-12">
                            <h5 class="t section-title">General</h5>
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Image type:</label>
                        </div>
                        <div class="col-7">
                            <select class="form-select aesetting aesetting-select" data-aesetting="diffMode">
                                <option value="vam">VAM Only</option>
                                <option value="normal">AI</option>
                                <option value="controltxt">AI ControlNet</option>
                                <option value="controlimg">AI ControlNet+img2img</option>
                            </select>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">ControlNet mode uses extra algorithms when generating the image, calculating things like outlines,depth and poses from the input vam image and uses them as reference for the output generated image. This makes the resulting images better keep the position and layout of the original vam image. This is at the cost of speed though. For best performance use the default value: <b>normal</b>.</div>
                    </div>





                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Width:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffSizeX" min="256" max="2048" step="16">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Width of the generated image. </div>
                    </div>



                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Height:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffSizeY" min="256" max="2048" step="16">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Height of the generated image.</div>
                    </div>


                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Photos location:</label>
                        </div>
                        <div class="col-7">
                            <input type="text" class="form-text w-100" disabled="disabled" value="Saves/screenshots/Diffusion Cam" />

                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">This is the path where the cam photos will be saved. It can't be changed. </div>
                    </div>

                    <div class="row settings-row pt-3">
                        <div class="col-12">
                            <h5 class="t section-title">AI Settings</h5>
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Better faces:</label>
                        </div>
                        <div class="col-7 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="diffFaces">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">When enabled A1111 will run an extra step to improve the faces in the image. The quality will be much better but it will take longer to finish the image. Works best for photos with normal faces. If the face is covered this might cause weird results. By default this is <b>off</b>.</div>
                    </div>



                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Sampler:</label>
                        </div>
                        <div class="col-7">
                            <select class="form-select aesetting aesetting-select" data-aesetting="diffSampler" onfocus='this.size = 10;'  onblur='this.size = 1;'  onchange='this.size = 1; this.blur();'>
                                <option value="Euler a">Euler a</option>
                                <option value="Euler">Euler</option>
                                <option value="LMS">LMS</option>
                                <option value="Heun">Heun</option>
                                <option value="DPM2">DPM2</option>
                                <option value="DPM2 a">DPM2 a</option>
                                <option value="DPM++ 2S a">DPM++ 2S a</option>
                                <option value="DPM++ 2M">DPM++ 2M</option>
                                <option value="DPM++ SDE">DPM++ SDE</option>
                                <option value="DPM fast">DPM fast</option>
                                <option value="DPM adaptive">DPM adaptive</option>
                                <option value="LMS Karras">LMS Karras</option>
                                <option value="DPM2 Karras">DPM2 Karras</option>
                                <option value="DPM2 a Karras">DPM2 a Karras</option>
                                <option value="DPM++ 2S a Karras">DPM++ 2S a Karras</option>
                                <option value="DPM++ 2M Karras">DPM++ 2M Karras</option>
                                <option value="DPM++ SDE Karras">DPM++ SDE Karras</option>
                                <option value="DDIM">DDIM</option>
                                <option value="PLMS">PLMS</option>
                                <option value="UniPC">UniPC</option>
                            </select>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">The algorithm used by the AI when moving from step to step. Some focus on more continuity, others on reaching  a good result faster. Explaining each is too complicated, google "stable diffusion sampling examples" for examples, it will make more sense. The default value is <b>Euler a</b></div>
                    </div>


                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Random seed:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffSeed" min="0" max="9999999999999" step="1">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">When set to 0, the generated images will always be random even if everything sent to the AI is identical. If you set a value bigger than 0, the AI will always do that particular randomization, keeping things constant if you send the same thing. You can use this to test prompt words or settings to see how they influence the generated image. Default value is <b>0</b> (images will be random every time).</div>
                    </div>


                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Save Vam Previews:</label>
                        </div>
                        <div class="col-7 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="diffSaveVam">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info"> When enabled, Alive will save in the diffusion screenshot folder also the preview from VAM. By default this is <b>on</b>.</div>
                    </div>



                    <div class="row settings-row  pt-3">
                        <div class="col-11">
                            <h5 class="t section-title">ControlNet</h5>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">ControlNet is a method that allows forcing the generated images to look in specific way, for example people to have very specific poses and the photos to be taken from specific angles. There are two main steps, a preprocessor and the model itself. Preprocessor 'translates' input image to a controlnet friendly format. For some method that means it just finds the edges and you get kind of a black and white sketch of the input image (canny for example). For others it tries to detect actual people it generates a pose image which is like a stickman representing the person pose (openpose for examples). After it does this, the pose image is sent along to the normal image AI model and the controlnet model takes care of steering the AI in that direction. For vam purposes you need to match the preprocessor and processor, canny-canny, openpose-openpose, otherwise you'll get more abstract results.</div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Preprocessor:</label>
                        </div>
                        <div class="col-7">
                            <select class="form-select aesetting aesetting-select" data-aesetting="diffControlnetPreprocessorUpdated" onfocus='this.size = 10;'  onblur='this.size = 1;'  onchange='this.size = 1; this.blur();'>
                                <option value="canny">canny</option>
                                <option value="depth_leres">depth_leres</option>
                                <option value="depth_leres++">depth_leres++</option>
                                <option value="depth_midas">depth_midas</option>
                                <option value="depth_zoe">depth_zoe</option>
                                <option value="inpaint_global_harmonious">inpaint_global_harmonious</option>
                                <option value="inpaint_only">inpaint_only</option>
                                <option value="inpaint_only+lama">inpaint_only+lama</option>
                                <option value="lineart_anime">lineart_anime</option>
                                <option value="lineart_anime_denoise">lineart_anime_denoise</option>
                                <option value="lineart_coarse">lineart_coarse</option>
                                <option value="lineart_realistic">lineart_realistic</option>
                                <option value="lineart_standard (from white bg &amp; black line)">lineart_standard (from white bg &amp; black line)</option>
                                <option value="mediapipe_face">mediapipe_face</option>
                                <option value="mlsd">mlsd</option>
                                <option value="normal_bae">normal_bae</option>
                                <option value="normal_midas">normal_midas</option>
                                <option value="openpose">openpose</option>
                                <option value="openpose_face">openpose_face</option>
                                <option value="openpose_faceonly">openpose_faceonly</option>
                                <option value="openpose_full">openpose_full</option>
                                <option value="openpose_hand">openpose_hand</option>
                                <option value="reference_adain">reference_adain</option>
                                <option value="reference_adain+attn">reference_adain+attn</option>
                                <option value="reference_only">reference_only</option>
                                <option value="scribble_hed">scribble_hed</option>
                                <option value="scribble_pidinet">scribble_pidinet</option>
                                <option value="scribble_xdog">scribble_xdog</option>
                                <option value="seg_ofade20k">seg_ofade20k</option>
                                <option value="seg_ofcoco">seg_ofcoco</option>
                                <option value="seg_ufade20k">seg_ufade20k</option>
                                <option value="shuffle">shuffle</option>
                                <option value="softedge_hed">softedge_hed</option>
                                <option value="softedge_hedsafe">softedge_hedsafe</option>
                                <option value="softedge_pidinet">softedge_pidinet</option>
                                <option value="softedge_pidisafe">softedge_pidisafe</option>
                                <option value="t2ia_color_grid">t2ia_color_grid</option>
                                <option value="t2ia_sketch_pidi">t2ia_sketch_pidi</option>
                                <option value="t2ia_style_clipvision">t2ia_style_clipvision</option>
                                <option value="threshold">threshold</option>
                                <option value="tile_colorfix">tile_colorfix</option>
                                <option value="tile_colorfix+sharp">tile_colorfix+sharp</option>
                                <option value="tile_resample">tile_resample</option>

                            </select>

                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">This is the main ControlNet module used.These need to be installed inside A111, they're not enabled by default iirc. To install them google "controlnet automatic1111 install". Default value is <b>canny</b>. </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Model:</label>
                        </div>
                        <div class="col-7">
                            <select class="form-select aesetting aesetting-select" data-aesetting="diffControlnetModelUpdated"  onfocus='this.size = 10;'  onblur='this.size = 1;'  onchange='this.size = 1; this.blur();'>
                            </select>

                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-11 text-end"><div class="t btn btn-sm btn-primary aequery" data-context="vamdiffusion" data-query="refreshControlnetModels" style="font-size:12px;">Refresh</div></div><div class="col-1"></div>
                        <div class="col-12 settings-info">This is the ControlNet model used when generating the image. Must match a value available in your Automatic1111 ControlNet settings in the controlnet model dropdown. Use the custom model field below in case you want to use a model that is not in the list. Default value is <b>control_v11p_sd15_canny [d14c016b]</b>. </div>
                    </div>


                    <!--                    
                                        <div class="row settings-row aesearchitem">
                                            <div class="col-4">
                                                <label class="t form-check-label aesearchtext">Custom Model:</label>
                                            </div>
                                            <div class="col-7">
                                                <input type="text" class="form-text mt-0 aesetting aesetting-text keyboard" data-aesetting="diffControlnetModelCustom" max-length="50" />
                                                
                                            </div>
                                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                            <div class="col-12 settings-info">This field allows setting a custom controlnet model that might be different than the ones predefined and listed above. If it's not empty, the value here will be used, otherwise the value from the dropdown above will be used. Default value is <b>empty</b>. </div>
                                        </div>
                                        
                                        
                    -->


                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Weight:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffControlnetWeight" min="0" max="2" step="0.01">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">This represent the weight of the ControlNet processing. Lower value will give the AI more freedom while higher values will force the AI to keep closer to the input image. Default value is <b>1</b>.</div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Low Threshold:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffControlnetLowTreshold" min="1" max="255" step="1">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info"> ControlNet preprocessor low threshold value for models that support it like canny. Default value is <b>64</b>.</div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">High Threshold:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffControlnetHighTreshold" min="1" max="255" step="1">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info"> ControlNet preprocessor high threshold value for models that support it like canny. Default value is <b>64</b>.</div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Preprocessor resolution:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="diffControlnetResolution" min="64" max="2048" step="1">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info"> ControlNet preprocessor resolution when processing the image.Higher will make the result follow the input image closer. Default value is <b>200</b>.</div>
                    </div>



                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Low VRAM:</label>
                        </div>
                        <div class="col-7 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="diffControlnetLowvram">
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">When checked, controlnet will run in lowvram mode. This reduces the cost of GPU used and prevents running out of VRAM on larger images, but it increases the time it takes to generate the image. By default this is <b>checked</b>.</div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-4">
                            <label class="t form-check-label aesearchtext">Control Mode:</label>
                        </div>
                        <div class="col-7 form-check form-switch">
                            <select class="form-select aesetting aesetting-select" data-aesetting="diffControlMode">
                                <option value="Balanced">Balanced</option>
                                <option value="My prompt is more important">Text prompt focus</option>
                                <option value="ControlNet is more important">ControlNet focus</option>
                            </select>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info"> Changes what has more impact, the text prompt or the controlnet guidance when generating the image. Default is <b>Balanced</b>.</div>
                    </div>



                    <div class="row settings-row pt-3">
                        <div class="col-11">
                            <h5 class="t section-title">Reset settings</h5>
                        </div>
                        <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Press this to reset all AI Cam settings to default values.</div>
                        <div class="col-12"><div class="t btn btn-primary btn-sm aequery" data-context="vamdiffusion" data-query="resetAiCameraSettings">Reset to defaults</div></div>
                    </div>



                </div>
            </div>


            <div class="tab-pane fade text-start py-3" id="tab-vamdiffusion-lora">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <h5 class="t section-title">LoRAs</h5>
                        </div>
                    </div>
                    <div id="cam_loras_list" class="row">
                        <div class="col-12">
                            
                        </div>
                    </div>
                </div>
            </div>

            <div class="tab-pane fade text-start" id="tab-vamdiffusion-help">
                <div class="container">
                    <div class="col-12 py-3">
                        <p class="t">To generate images using the AI modes of the Cam app you need to have Automatic1111 installed & running.</p>
                        <br />
                        <p><span class="t">Guide video on YouTube</span>: "ALIVE: Photorealistic screenshots with StableDiffusion"</p>
                    </div>
                </div>
            </div>


        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["vamdiffusion"] = {
    title: "Cam",
    titleButtons: ["close"],
    icon: "fun"
};$(document).ready(function () {

});TPL["addons"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t active" data-bs-toggle="tab" data-bs-target="#tab-demo-1" >Info</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >List</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-3" >Link</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade show active" id="tab-demo-1"> Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br> </div>
            <div class="tab-pane fade" id="tab-demo-2">testt2</div>
            <div class="tab-pane fade" id="tab-demo-3">testt3</div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["addons"] = {
    title: "Addons",
    titleButtons: ["close"],
    icon: "system",
    skipHome: true,
};var APPHISTORY = [];

$(document).ready(function () {
    app_apphistory_init_delete();
    
    $("#app").on("mousedown",".apphistory_switch",app_apphistory_switch);
    $("#app").on("mousedown", ".menu-historyapp", function(e){e.preventDefault; app_apphistory_toggle(); return false;});
});


function app_apphistory_toggle(){
    var isSelected = isSelectedCheck($('.menu-historyapp'));
    if(!isSelected){
        App.LoadApp("apphistory");
    } else {
        app_apphistory_switch();
    }
}

function app_apphistory_init_delete(){
    $("#app").on("mousedown", "#app-apphistory .close",function(e){
        var o = $(this).parents(".item");
        var appname = o.attr("data-app");
        app_apphistory_remove_app(appname);
        if(!isEmpty(APPHISTORY_PARAMS[appname])) delete APPHISTORY_PARAMS[appname];
        if(!isEmpty(APPHISTORY_TABS[appname])) delete APPHISTORY_TABS[appname];
        (new App("apphistory")).Load();
    });
}

function app_apphistory_add_app(s){
    if(META[s].skipRecentApps) return;
    app_apphistory_remove_app(s);
    APPHISTORY.push(s);
}
function app_apphistory_remove_app(s){
    if(APPHISTORY.indexOf(s) > -1){
        APPHISTORY = removeItemAll(APPHISTORY, s);
    }
//    console.log("app_apphistory_remove_app ", s);
  
    
}

function app_apphistory_prepare(html){
       var destination = html.find(".list");
       if(APPHISTORY.length === 0){
           destination.append("<h3>No recent apps.</h3>");
           return;
       }
        for(var k of APPHISTORY){
            var app = new App(k);
            var demo = html.find(".item.demo").clone();
            demo.removeClass("demo");
            demo.attr('data-app', k);
            demo.find(".select-app").attr('data-app', k);
            demo.find(".title").html( Language.getTranslated(META[k].title));
            demo.find("IMG.icon").attr("src",app.GetIconSrc()).addClass(app.GetIconClass());
            destination.prepend(demo);
        }
        return html;
}

function app_apphistory_switch(){
    if(APPHISTORY === null) return;
    if(APPHISTORY.length < 2) return;
    var previous = APPHISTORY[APPHISTORY.length - 2];
    App.LoadApp(previous);
}TPL["apphistory"] = `
<div id="app-apphistory" class="app">
    <div class ="app-content scrollbar1">
        <div class="list container px-5" >
            <div class="item demo row">
                <div class="col-3 select-app"><img src="" class="icon" /></div>
                <div class="col-8 select-app">
                    <div class="title"></div>
                </div>
                <div class="col-1 close"><span class="material-symbols-outlined">close</span></div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["apphistory"] = {
    title: "Recent Apps",
    titleButtons: ["close"],
    skipRecentApps: true,
    skipHome: true,
    hideTitle: true,
    icon: "devel"
};$(document).ready(function () {
    app_atom_init_clicks();
});

function app_atom_init_clicks() {
    $("#app").on("mousedown", "#addobject-list .element", app_atom_select_atom);
    $("#app").on("mousedown", "#objects-list-container .item .item-container", app_atom_select_existing_atom);
    $("#app").on("mousedown", "#object-list-actions .item-action", app_atom_click_action);
    $("#app").on("mousedown", ".atom-addobject-categories .card", app_addobject_select_category_action);
    $("#app").on("mousedown", ".lighting-performance-links", function(e){e.preventDefault(); App.LoadApp("settings", function(){App.changeTab("tab-settings-performance")});return false;});
}

function app_addobject_select_category_action(){
    var o = $(this);
    var category = o.find("span").attr("data-category");
    var parent = o.parents(".atom-addobject-categories");
    parent.find(".card.selected").removeClass("selected");
    o.addClass('selected');
    $(".atom-addobject-categories .aesearchitem").each(function(){
        var item_category = $(this).attr('data-category');
        if(category === item_category || category === "all"){
            $(this).removeClass("hiddenForCategory");
        } else {
            $(this).addClass("hiddenForCategory");   
        }
    });
    
}

function app_atom_click_action() {
    var action = $(this).attr("data-action");
    var atom_id = $("#objects-list .item.selected").attr("data-uid");
    aevent({action: "sceneAtomAction", action2: action, atom: atom_id});
}

function app_atom_select_existing_atom() {
    var el = $(this).parents(".item").first();
    var id = el.attr('data-uid');
    aevent({action: "sceneSelectAtom", atom_uid: id});
}

function app_atom_select_atom() {
    if (throttled("app_atom_select_atom", 1500))
        return;
    var name = $(this).attr('data-element');
    aevent({action: 'sceneAddAtom', element: name});
}

function app_atom_prepare(html) {

}

function app_atom_postprepare() {
    app_atom_prepare_addobject();
    app_atom_prepare_current_atoms();
}

function app_atom_cron_second() {
    if (App.GetCurrentAppName() !== "atom")
        return;
    if (App.GetCurrentAppTab() !== "#tab-atom-objects")
        return;
    aevent({action: "getSceneAtoms"});
}

function app_atom_prepare_addobject() {
    var destination = $("#addobject-list");
    if (isEmpty(EPHEMERAL.vamdata))
        return;
    if (isEmpty(EPHEMERAL.vamdata.atoms))
        return;
    
    var map = app_atom_get_map();

    var keys = Object.keys(EPHEMERAL.vamdata.atoms);
    for (var key of keys) {
        var file = new VamFile("atom", key, Image);
        var objtype = "";
        if(typeof map[file.fileName] !== "undefined") objtype=map[file.fileName].category;
        if(file.fileNameSimple === "AliveMan") continue;
        if(file.fileNameSimple === "AliveWoman") continue;
        
        var element = destination.find(".demo").clone();
        element.removeClass('demo').addClass("new").attr("data-category",objtype);
        element.attr('data-element', file.fileName);
        element.find('.element-image img').attr("src", file.getImageSrc());
        element.find('.element-title').html(file.fileNameSimple);

        destination.append(element);
    }


}

function app_atom_format_name(s) {
    var ns = s.split("/");
    return ns[ns.length - 1];
}

function app_atom_prepare_current_atoms() {
    app_atom_prepare_current_atoms_cleanup();
    if (isEmpty(EPHEMERAL.sceneatoms))
        return;
    if (isEmpty(EPHEMERAL.sceneatoms.atoms))
        return;

    var destination = $("#objects-list");
    var keys = Object.keys(EPHEMERAL.sceneatoms.atoms);
    for (var key of keys) {
        if (app_atom_is_skipped(EPHEMERAL.sceneatoms.atoms[key]["name"]))
            continue;
        app_atom_prepare_current_atoms_atom(key);

    }
}

function app_atom_prepare_current_atoms_cleanup() {
    $("#objects-list .item.new").each(function () {
        var uid = $(this).attr('data-uid');
        if (!app_atom_current_atoms_exists(uid))
            $(this).remove();
    });
}
function app_atom_current_atoms_exists(key) {
    if (isEmpty(EPHEMERAL.sceneatoms))
        return false;
    if (isEmpty(EPHEMERAL.sceneatoms.atoms))
        return false;
    if (isEmpty(EPHEMERAL.sceneatoms.atoms[key]))
        return false;
    return true;
}
function app_atom_is_skipped(uid) {
    if (uid.startsWith("Alive"))
        return true;
    if (uid.startsWith("AEMain"))
        return true;
    if (uid.startsWith("SPQRFPS"))
        return true;
    if (uid === "PlayerNavigationPanel")
        return true;
    return false;
}
function app_atom_prepare_current_atoms_atom(key) {
    var atom = EPHEMERAL.sceneatoms.atoms[key];
    var destination = $("#objects-list");
    var element = destination.find(".demo.item").clone();
    var element_exists = false;
    if (destination.find('.item[data-uid="' + atom.uid + '"]').length > 0) {
        element_exists = true;
        element = destination.find('.item[data-uid="' + atom.uid + '"]');
    }
    if (atom.parent !== "") {
        if (destination.find('.item[data-uid="' + atom.parent + '"]').length < 1) {
            app_atom_prepare_current_atoms_atom(atom.parent);
        }
        destination = destination.find('.item[data-uid="' + atom.parent + '"] > .item-subcontainer');
    }

    
  // Store the current values of the attributes and classes
var currentDataUid = element.attr('data-uid');
var currentAtomType = element.attr('data-atom-type');
var currentClassName = element.attr('class');

// Check if the attributes need to be changed
if (currentDataUid !== atom.uid) {
  element.attr('data-uid', atom.uid);
}

if (currentAtomType !== atom.type) {
  element.attr('data-atom-type', atom.type);
}

// Check if the class "demo" needs to be changed to "new"
if (!element.hasClass("new")) {
  element.removeClass("demo").addClass("new");
}

    // Check if ".item-name" needs to be updated
    var currentItemName = element.find(".item-name").html();
    var newFormattedName = app_atom_format_name(atom.name);
    if (currentItemName !== newFormattedName) {
      element.find(".item-name").html(newFormattedName);
    }

    // Check if ".item-type" needs to be updated
    var currentItemType = element.find(".item-type").html();
    if (currentItemType !== atom.type) {
      element.find(".item-type").html(atom.type);
    }

    // Check if the class related to atom type needs to be changed
    var currentAtomClass = "atom_" + app_atom_get_class(atom.type);
    if (!element.hasClass(currentAtomClass)) {
      // Remove any existing atom class before adding the new one
      element.removeClass(function(index, className) {
        return (className.match(/\batom_\S+/g) || []).join(' ');
      });
      element.addClass(currentAtomClass);
    }

    // Check if the "selected" class needs to be changed
    if (isTrue(atom.selected) && !element.hasClass("selected")) {
      element.addClass("selected");
    } else if (!isTrue(atom.selected) && element.hasClass("selected")) {
      element.removeClass("selected");
    }
    
    if(isTrue(atom.on)){
        if(!element.hasClass("on_on")) element.addClass("on_on");
        if(element.hasClass("on_off")) element.removeClass("on_off");
    } else {
        if(!element.hasClass("on_off")) element.addClass("on_off");
        if(element.hasClass("on_on")) element.removeClass("on_on");
    }
    
    
    
    if (!element_exists) {
        destination.append(element);
    }

}

function app_atom_get_class(s) {
    s = s.toLowerCase();
    return s;
}

function app_atom_process_current_atoms(data) {
    data = JSON.parse(data);

    EPHEMERAL.sceneatoms = data;
    app_atom_prepare_current_atoms();
}



function app_atom_get_categories(){
    var categories = ["person", "items", "furniture", "floor", "tech", "bedroom", "bathroom", "kitchen", "living", "office", "plants", "outdoor", "decorations", "shapes","sextoys", "light", "audio", "construction", "vam", "vamui", "background"];
    return categories;
}
function app_atom_get_map() {
    var map = {
        "AnimationPattern": {category: "vam"},
        "AptBook01": {category: "items"},
        "AptBook02": {category: "items"},
        "AptBookShelf": {category: "furniture"},
        "AptChair": {category: "living"},
        "AptCoffeeTable": {category: "furniture"},
        "AptJacuzziProp": {category: "outdoor"},
        "AptJacuzziRailing": {category: "outdoor"},
        "AptLamp": {category: "light"},
        "AptOutdoorLight": {category: "light"},
        "AptPatioChair": {category: "outdoor"},
        "AptPicture01": {category: "decorations"},
        "AptPicture02": {category: "decorations"},
        "AptPlant": {category: "plants"},
        "AptPlanter": {category: "plants"},
        "AptRug": {category: "floor"},
        "AptSmartTV": {category: "tech"},
        "AptSmartWebTV": {category: "tech"},
        "AptSofa": {category: "living"},
        "AptSpeaker": {category: "audio"},
        "AptTVStand": {category: "furniture"},
        "AudioSource": {category: "audio"},
        "BathroomShower": {category: "bathroom"},
        "BathroomSink": {category: "bathroom"},
        "BathroomToilet": {category: "bathroom"},
        "BathroomToilet2": {category: "bathroom"},
        "BathroomToiletpaper": {category: "bathroom"},
        "BathroomToiletpaperPile": {category: "bathroom"},
        "BathroomTowel": {category: "bathroom"},
        "BathroomWashingMachine": {category: "bathroom"},
        "Bathtub": {category: "bathroom"},
        "BedBunk": {category: "bedroom"},
        "BedKing": {category: "bedroom"},
        "BedSingle": {category: "bedroom"},
        "Bookshelf": {category: "furniture"},
        "Button": {category: "vam"},
        "Carpet1": {category: "floor"},
        "Carpet2": {category: "floor"},
        "CarpetRound": {category: "floor"},
        "CensorCube": {category: "vam"},
        "CensorPanel": {category: "vam"},
        "Chair1": {category: "furniture"},
        "Chair2": {category: "furniture"},
        "Chair3": {category: "furniture"},
        "Chair4": {category: "furniture"},
        "ClothGrabSphere": {category: "vam"},
        "CollisionTrigger": {category: "vam"},
        "ColumnRound": {category: "outdoor"},
        "ColumnRound2": {category: "outdoor"},
        "ColumnRound3": {category: "outdoor"},
        "ColumnSquareBig": {category: "outdoor"},
        "ColumnSquareSmall": {category: "outdoor"},
        "Couch": {category: "living"},
        "CouchLarge": {category: "living"},
        "CouchLarge2": {category: "living"},
        "CouchLarge3": {category: "living"},
        "CouchMedium1": {category: "living"},
        "CouchMedium2": {category: "living"},
        "CouchSmall1": {category: "living"},
        "CouchSmall2": {category: "living"},
        "CourtainsDouble": {category: "decorations"},
        "CurtainSingle": {category: "decorations"},
        "Cube": {category: "shapes"},
        "CustomUnityAsset": {category: "vam"},
        "CyberpunkBed": {category: "bedroom"},
        "CyberpunkBedPillow01": {category: "decoration"},
        "CyberpunkBedPillow02": {category: "decoration"},
        "CyberpunkBedPillow03": {category: "decoration"},
        "CyberpunkChair": {category: "office"},
        "CyberpunkCoffeeTable": {category: "furniture"},
        "CyberpunkComputer": {category: "tech"},
        "CyberpunkComputerChair": {category: "office"},
        "CyberpunkControlScreen": {category: "tech"},
        "CyberpunkDresser01": {category: "furniture"},
        "CyberpunkDresser02": {category: "furniture"},
        "CyberpunkKeyboard": {category: "tech"},
        "CyberpunkLaptop": {category: "tech"},
        "CyberpunkLight": {category: "light"},
        "CyberpunkMouse": {category: "tech"},
        "CyberpunkMousepad": {category: "tech"},
        "CyberpunkRemote": {category: "tech"},
        "CyberpunkSofa": {category: "living"},
        "CyberpunkSofaCushion01": {category: "decoration"},
        "CyberpunkSofaCushion02": {category: "decoration"},
        "CyberpunkTable": {category: "office"},
        "CyberpunkTablet": {category: "tech"},
        "CyberpunkWallLight01": {category: "light"},
        "CyberpunkWallLight02": {category: "light"},
        "CycleForce": {category: "vam"},
        "DecoDowntimeChair": {category: "furniture"},
        "DecoDowntimeCoffeeTable": {category: "furniture"},
        "DecoDowntimeSideTable": {category: "furniture"},
        "DecoDowntimeStand": {category: "furniture"},
        "Dildo": {category: "sextoys"},
        "Dildo2": {category: "sextoys"},
        "Door": {category: "construction"},
        "Door10": {category: "construction"},
        "Door2": {category: "construction"},
        "Door3": {category: "construction"},
        "Door4": {category: "construction"},
        "Door5": {category: "construction"},
        "Door6": {category: "construction"},
        "Door7": {category: "construction"},
        "Door8": {category: "construction"},
        "Door9": {category: "construction"},
        "Drawer": {category: "furniture"},
        "Drawer2": {category: "furniture"},
        "Drawer3": {category: "furniture"},
        "Drawer4": {category: "furniture"},
        "Drawer5": {category: "furniture"},
        "DreamHomeTV": {category: "tech"},
        "DreamHomeWebTV": {category: "tech"},
        "DSBR_2TierTable": {category: "furniture"},
        "DSBR_Bed": {category: "bedroom"},
        "DSBR_BedPillow": {category: "decoration"},
        "DSBR_Bench": {category: "furniture"},

    };
    map["DSBR_Chair"] = {category: "furniture"};
    map["DSBR_DecorativePillow"] = {category: "decorations"};
    map["DSBR_Ottoman"] = {category: "furniture"};
    map["DSBR_ThrowPillow"] = {category: "decorations"};
    map["Empty"] = {category: "vam"};
    map["FencePost"] = {category: "outdoor"};
    map["FenceSection"] = {category: "outdoor"};
    map["Fireplace"] = {category: "furniture"};
    map["Fork"] = {category: "kitchen"};
    map["Glass-Stained"] = {category: "construction"};
    map["Glass"] = {category: "construction"};
    map["GrabPoint"] = {category: "vam"};
    map["HousePlant1"] = {category: "plants"};
    map["HousePlant2"] = {category: "plants"};
    map["HousePlant3"] = {category: "plants"};
    map["HousePlant4"] = {category: "plants"};
    map["HousePlant5"] = {category: "plants"};
    map["HousePlant6"] = {category: "plants"};
    map["HousePlant7"] = {category: "plants"};
    map["HousePlant8"] = {category: "plants"};
    map["ImagePanel"] = {category: "vam"};
    map["ImagePanelEmissive"] = {category: "vam"};
    map["ImagePanelTransparent"] = {category: "vam"};
    map["ImagePanelTransparentEmissive"] = {category: "vam"};
    map["ImagePanelTransparentEmissiveOverlay"] = {category: "vam"};
    map["InvisibleLight"] = {category: "light"};
    map["InvisiblePanel"] = {category: "vam"};
    map["ISCapsule"] = {category: "shapes"};
    map["ISCone"] = {category: "shapes"};
    map["ISCylinder"] = {category: "shapes"};
    map["IslBench"] = {category: "furniture"};
    map["IslPatioChair"] = {category: "outdoor"};
    map["IslPlantWFlowers"] = {category: "plants"};
    map["IslPotA"] = {category: "plants"};
    map["IslPotB"] = {category: "plants"};
    map["IslPotSmall"] = {category: "plants"};
    map["IslStool"] = {category: "furniture"};
    map["IslTopiary"] = {category: "plants"};
    map["IslTree"] = {category: "plants"};
    map["IslTreePlanter"] = {category: "plants"};
    map["ISSphere"] = {category: "shapes"};
    map["ISTube"] = {category: "shapes"};
    map["KitchenCabinet1"] = {category: "kitchen"};
    map["KitchenCabinet2"] = {category: "kitchen"};
    map["KitchenCabinetSmall"] = {category: "kitchen"};
    map["KitchenDrawers1"] = {category: "kitchen"};
    map["KitchenDrawers2"] = {category: "kitchen"};
    map["KitchenDrawers3"] = {category: "kitchen"};
    map["KitchenFridge"] = {category: "kitchen"};
    map["KitchenOven"] = {category: "kitchen"};
    map["KitchenOven2"] = {category: "kitchen"};
    map["KitchenSink"] = {category: "kitchen"};
    map["Knife"] = {category: "kitchen"};
    map["LightArt"] = {category: "decorations"};
    map["LightArt2"] = {category: "decorations"};
    map["LightCeiling"] = {category: "light"};
    map["LightCeiling2"] = {category: "light"};
    map["LightCeiling3"] = {category: "light"};
    map["LightCeiling4"] = {category: "light"};
    map["LightCeiling5"] = {category: "light"};
    map["LightCeiling6"] = {category: "light"};
    map["LightChandelier"] = {category: "light"};
    map["LightCube"] = {category: "light"};
    map["LightCube2"] = {category: "light"};
    map["LightDeskLamp"] = {category: "light"};
    map["LightFloor"] = {category: "light"};
    map["LightFloor2"] = {category: "light"};
    map["LightFloor3"] = {category: "light"};
    map["LightFloor4"] = {category: "light"};
    map["LightSmall"] = {category: "light"};
    map["LightStand"] = {category: "light"};
    map["LookAtTrigger"] = {category: "vam"};
    map["LoungeChair"] = {category: "furniture"};
    map["Man"] = {category: "person"};
    map["Mirror1"] = {category: "decorations"};
    map["Mirror2"] = {category: "decorations"};
    map["ModernRoomBed"] = {category: "bedroom"};
    map["ModernRoomLargeLamp"] = {category: "light"};
    map["NightStand"] = {category: "furniture"};
    map["NightStand2"] = {category: "furniture"};
    map["NightStand3"] = {category: "furniture"};
    map["OldStyleBed"] = {category: "bedroom"};
    map["OldStyleChair"] = {category: "furniture"};
    map["OldStylePillow01"] = {category: "decorations"};
    map["OldStylePillow02"] = {category: "decorations"};
    map["OldStylePillow03"] = {category: "decorations"};
    map["OldStyleSideTable"] = {category: "furniture"};
    map["OldStyleVanityStool"] = {category: "furniture"};
    map["Paddle"] = {category: "sextoys"};
    map["Plate"] = {category: "kitchen"};
    map["Plate2"] = {category: "kitchen"};
    map["Plate3"] = {category: "kitchen"};
    map["RailingGlass"] = {category: "construction"};
    map["ReflectiveSlate"] = {category: "floor"};
    map["ReflectiveWoodPanel"] = {category: "floor"};
    map["RhythmAudioSource"] = {category: "audio"};
    map["RhythmForce"] = {category: "vam"};
    map["Shelf"] = {category: "furniture"};
    map["Shelf1"] = {category: "furniture"};
    map["Shelf2"] = {category: "furniture"};
    map["ShelfLarge"] = {category: "furniture"};
    map["ShelfSmall"] = {category: "furniture"};
    map["ShelfSmall2"] = {category: "furniture"};
    map["ShelfSmall3"] = {category: "furniture"};
    map["Shelves"] = {category: "furniture"};
    map["SkullQueenSword"] = {category: "items"};
    map["Slate"] = {category: "floor"};
    map["SpaceBox"] = {category: "background"};
    map["Sphere"] = {category: "shapes"};
    map["Spoon"] = {category: "kitchen"};
    map["Stool"] = {category: "furniture"};
    map["SubScene"] = {category: "vam"};
    map["SyncForce"] = {category: "vam"};
    map["TableRoundLarge"] = {category: "furniture"};
    map["TableRoundSmall"] = {category: "furniture"};
    map["TableRoundSmall2"] = {category: "furniture"};
    map["TechnoDancePole"] = {category: "construction"};
    map["TechnoGirder"] = {category: "construction"};
    map["TechnoLight"] = {category: "light"};
    map["TechnoLightBar"] = {category: "light"};
    map["TechnoLightBarLight"] = {category: "light"};
    map["TechnoNeonCircle"] = {category: "light"};
    map["TechnoNeonCircleLight"] = {category: "light"};
    map["TechnoNeonHeart"] = {category: "light"};
    map["TechnoNeonHeartLight"] = {category: "light"};
    map["TechnoNeonSquare"] = {category: "light"};
    map["TechnoNeonSquareLight"] = {category: "light"};
    map["TechnoNeonTriangle"] = {category: "light"};
    map["TechnoNeonTriangleLight"] = {category: "light"};
    map["TechnoPillar"] = {category: "construction"};
    map["TechnoRingLight"] = {category: "light"};
    map["TechnoRingLightLight"] = {category: "light"};
    map["TechnoRoundCage"] = {category: "construction"};
    map["TechnoRoundPlatform"] = {category: "construction"};
    map["TechnoSquareCage"] = {category: "construction"};
    map["TechnoThrone"] = {category: "furniture"};
    map["Torch"] = {category: "light"};
    map["ToyAH"] = {category: "sextoys"};
    map["ToyBP"] = {category: "sextoys"};
    map["Trashcan"] = {category: "items"};
    map["TrashcanGreen"] = {category: "items"};
    map["TrashcanLarge"] = {category: "items"};
    map["UIButton"] = {category: "vamui"};
    map["UIButtonImage"] = {category: "vamui"};
    map["UiImage"] = {category: "vamui"};
    map["UISlider"] = {category: "vamui"};
    map["UIText"] = {category: "vamui"};
    map["UIToggle"] = {category: "vamui"};
    map["VaMLogo"] = {category: "decoration"};
    map["VaMSign"] = {category: "decoration"};
    map["VariableTrigger"] = {category: "vam"};
    map["Wall"] = {category: "construction"};
    map["WallPost"] = {category: "construction"};
    map["WallSection"] = {category: "construction"};
    map["WebBrowser"] = {category: "vam"};
    map["WebPanel"] = {category: "vam"};
    map["WebPanelEmissive"] = {category: "vam"};
    map["WindowLarge"] = {category: "construction"};
    map["WindowRound"] = {category: "construction"};
    map["WindowRound2"] = {category: "construction"};
    map["WindowRound3"] = {category: "construction"};
    map["WindowSmall1"] = {category: "construction"};
    map["WindowSmall2"] = {category: "construction"};
    map["WindowSmall3"] = {category: "construction"};
    map["Woman"] = {category: "person"};
    map["WoodSlate"] = {category: "floor"};
    
    return map;
}TPL["atom"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
<!--        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-atom-objects" >Scene</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-atom-addobject" >Add</a>
        </li>-->
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-atom-lights" >Lights</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1 no-bottom-padding">
        <div class="tab-content">
<!--            <div class="tab-pane fade" id="tab-atom-objects">

                <div class="container" id="object-list-actions">
                    <div class="row">
                        <div class="col item-action" data-action="visible">
                            <span class="material-symbols-outlined">visibility</span>
                            <div class="item-action-title">Visibility</div>
                        </div>

                        <div class="col item-action" data-action="rotate_left">
                            <span class="material-symbols-outlined">rotate_left</span>
                            <div class="item-action-title">Rot.Left</div>
                        </div>
                        <div class="col item-action" data-action="rotate_right">
                            <span class="material-symbols-outlined">rotate_right</span>
                            <div class="item-action-title">Rot.Right</div>
                        </div>
                        <div class="col item-action" data-action="rotate_reset">
                            <span class="material-symbols-outlined">360</span>
                            <div class="item-action-title">Rot.Reset</div>
                        </div>
                        <div class="col item-action" data-action="movetoflag">
                            <span class="material-symbols-outlined">flag</span>
                            <div class="item-action-title">Move to flag</div>
                        </div>
                        <div class="col item-action" data-action="physics">
                            <span class="material-symbols-outlined">offline_bolt</span>
                            <div class="item-action-title">Physics</div>
                        </div>
                        <div class="col item-action" data-action="collision">
                            <span class="material-symbols-outlined">touch_app</span>
                            <div class="item-action-title">Collision</div>
                        </div>
                        <div class="col item-action" data-action="recenter">
                            <span class="material-symbols-outlined">filter_center_focus</span>
                            <div class="item-action-title">Recenter</div>
                        </div>

                        <div class="col item-action" data-action="clone">
                            <span class="material-symbols-outlined">content_copy</span>
                            <div class="item-action-title">Clone</div>
                        </div>
                        <div class="col item-action" data-action="delete">
                            <span class="material-symbols-outlined">delete</span>
                            <div class="item-action-title">Delete</div>
                        </div>
                    </div>
                </div>

                <div class="container">
                    <div class="row pt-1 pb-1" id="objects-list-search">
                        <div class="col-3">
                            <label class="t form-check-label t" >Filter:</label>
                        </div>
                        <div class="col-9">
                            <input data-aesearch="#objects-list-container" class="keyboard aesearchfilter search-filter keyboard" type="text" />
                        </div>
                    </div>
                </div>
                <div class="container scrollbar1" id="objects-list-container">
                    <div class="row" id="objects-list">
                        <div class="col col-12 demo item aesearchitem">
                            <div class="item-container">
                                <div class="item-name aesearchtext"></div>
                                <div class="item-type aesearchtext"></div>
                            </div>
                            <div class="item-subcontainer">

                            </div>
                        </div>
                    </div>
                </div>

            </div>
            <div class="tab-pane fade" id="tab-atom-addobject">
                <div class="container atom-addobject-categories">
                    
                     <div class="row mt-3">
                        <div class="col-4 col-md-2">
                            <div class="card aecard selected">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="all">more_horiz</span> All
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="bathroom">bathtub</span> Bathroom
                                </div>
                            </div>
                        </div>
                        <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="audio">volume_up</span> Audio
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="background">background_replace</span> Background
                                </div>
                            </div>
                        </div>
                        <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="bedroom">bed</span> Bedroom
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="construction">door_open</span> Construction
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="decorations">wallpaper</span> Decorations
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="floor">grid_view</span> Floor
                                </div>
                            </div>
                        </div>
                          <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="furniture">shelves</span> Furniture
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="items">book</span> Items
                                </div>
                            </div>
                        </div>
                         
                        <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="kitchen">restaurant</span> Kitchen
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="light">floor_lamp</span> Light
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="living">chair</span> Living
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="office">apartment</span> Office
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="outdoor">nature_people</span> Outdoor
                                </div>
                            </div>
                        </div>
                        <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="person">directions_run</span> Person
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="plants">potted_plant</span>  Plants
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="sextoys">favorite</span> Sex toys
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="shapes">view_in_ar</span> Shapes
                                </div>
                            </div>
                        </div>
                        <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="tech">desktop_windows</span> Tech
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined" data-category="vam">bolt</span> VAM
                                </div>
                            </div>
                        </div>
                         <div class="col-4 col-md-2">
                            <div class="card aecard">
                                <div class="card-body p-0 t">
                                    <span class="material-symbols-outlined"  data-category="vamui">check_box</span> VAM UI
                                </div>
                            </div>
                        </div>
                         
                        
                        
                          
                        
                         
                        
                        
                        
                         
                       
                        
                        
                    </div>
                    
                    <div class="row mt-2 mb-2" id="objects-list-search">
                        <div class="col-3">
                            <label class="t form-check-label t" >Filter:</label>
                        </div>
                        <div class="col-9">
                            <input data-aesearch="#addobject-list" class="keyboard aesearchfilter search-filter" type="text" />
                        </div>
                    </div>
                    
                    <div class="row" id="addobject-list">
                        <div class="col col-6 col-md-3 col-lg-2 element demo text-center mb-3 aesearchitem">
                            <div class="element-image">
                                <img src="" class="img-fluid" />
                            </div>
                            <div class="element-title aesearchtext">

                            </div>
                        </div>
                    </div>
                </div>
            </div>-->

            <div class="tab-pane fade" id="tab-atom-lights">
                <div class="container mt-3">
                    <div class="row settings-row">
                            <div class="col-9">
                                <h5 class="t">Head Lights</h5>
                            </div>
                            <div class="col-3 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="headlightsEnabled">
                            </div>
                        </div>
                    
                    <div class="row" id="atom-headlights">

                         


                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="None" data-aesettingselect="lightsPreset" data-aesettingselect-val="None">
                                <div class="card-body" style="background-image:url('resources/lights/light (None).jpg')">0</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset1" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset1">
                                <div class="card-body" style="background-image:url('resources/lights/light (1).jpg')">1</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset2" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset2">
                                <div class="card-body" style="background-image:url('resources/lights/light (2).jpg')">2</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset3" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset3">
                                <div class="card-body" style="background-image:url('resources/lights/light (3).jpg')">3</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset4" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset4">
                                <div class="card-body" style="background-image:url('resources/lights/light (4).jpg')">4</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset5" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset5">
                                <div class="card-body" style="background-image:url('resources/lights/light (5).jpg')">5</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset6" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset6">
                                <div class="card-body" style="background-image:url('resources/lights/light (6).jpg')">6</div>
                            </div>
                        </div>


                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset7" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset7">
                                <div class="card-body" style="background-image:url('resources/lights/light (7).jpg')">7</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset8" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset8">
                                <div class="card-body" style="background-image:url('resources/lights/light (8).jpg')">8</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset9" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset9">
                                <div class="card-body" style="background-image:url('resources/lights/light (9).jpg')">9</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset10" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset10">
                                <div class="card-body" style="background-image:url('resources/lights/light (10).jpg')">10</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset11" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset11">
                                <div class="card-body" style="background-image:url('resources/lights/light (11).jpg')">11</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset12" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset12">
                                <div class="card-body" style="background-image:url('resources/lights/light (12).jpg')">12</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset13" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset13">
                                <div class="card-body" style="background-image:url('resources/lights/light (13).jpg')">13</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset14" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset14">
                                <div class="card-body" style="background-image:url('resources/lights/light (14).jpg')">14</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset15" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset15">
                                <div class="card-body" style="background-image:url('resources/lights/light (15).jpg')">15</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset16" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset16">
                                <div class="card-body" style="background-image:url('resources/lights/light (16).jpg')">16</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset17" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset17">
                                <div class="card-body" style="background-image:url('resources/lights/light (17).jpg')">17</div>
                            </div>
                        </div>


                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset18" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset18">
                                <div class="card-body" style="background-image:url('resources/lights/light (18).jpg')">18</div>
                            </div>
                        </div>

                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset19" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset19">
                                <div class="card-body" style="background-image:url('resources/lights/light (19).jpg')">19</div>
                            </div>
                        </div>
                        
                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset20" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset20">
                                <div class="card-body" style="background-image:url('resources/lights/light (20).jpg')">20</div>
                            </div>
                        </div>
                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset21" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset21">
                                <div class="card-body" style="background-image:url('resources/lights/light (21).jpg')">21</div>
                            </div>
                        </div>
                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset22" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset22">
                                <div class="card-body" style="background-image:url('resources/lights/light (22).jpg')">22</div>
                            </div>
                        </div>
                        <div class="col col-3 text-center">
                            <div class="aecard card aeurl aesettingselect" data-aeurl-action="changeLight" data-aeurl-action2="Preset23" data-aesettingselect="lightsPreset" data-aesettingselect-val="Preset23">
                                <div class="card-body" style="background-image:url('resources/lights/light (23).jpg')">23</div>
                            </div>
                        </div>

                    </div>

                    <div class="row mt-3">
                        <div class="col col-12">
                            <h4 class="t section-title">LIGHT ACTIONS</h4>
                        </div>
                    </div>

                    

                    <div class="row settings-row">
                        <div class="col-6">
                            <label class="t form-check-label t">Headlights range:</label>
                        </div>
                        <div class="col-5">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stgHeadlightRange" min="0" max="25" step="0.1">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">This slider allows controlling the distance the lights are allowed to travel. Higher values means objects further away will get lit too.</div>
                    </div>
                    
                    <div class="row settings-row">
                        <div class="col-6">
                            <label class="t form-check-label t">Headlights angle:</label>
                        </div>
                        <div class="col-5">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stgHeadlightAngle" min="30" max="179" step="0.1">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">This slider controls the spot angle for headlights that are spotlights. Higher values are recommend for VR to prevent flashlight effect. Default value is <b>140</b>.</div>
                    </div>



                    <div class="row mt-3 settings-row">
                        <div class="col col-6 t">Turn off other lights:</div>
                        <div class="col col-5"><button class="t btn btn-primary aeurl" data-aeurl-action="turnOffAllLights">Turn off</button></div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">This action will turn off all other lights active in the scene right now. To have this automatically be done everytime you can enable the Headlights Only option from above.</div>
                    </div>
                    
                    
                     <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Headlights Performance</h4></div></div>

                    <div class="row settings-row">
                        <div class="col-8">
                            <label class="t form-check-label t">Headlights only (Recommended):</label>
                        </div>
                        <div class="col-3 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stgHeadlightsForced" />
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">When enabled, Alive will try to close all other lights in vam scenes and keep only the head lights on. This is not recommended for people that want to play other vam scenes as their creators intended it, with their lighting setup. But when enabled it provides a constant lighting experience across vam, and is better for performance as it prevents lots of lights stacking up in a scene which will make vam struggle.  Default is Disabled (<b>0</b>).</div>
                    </div>

                    <div class="row settings-row">
                        <div class="col-8">
                            <label class="t form-check-label t">One headlight only:</label>
                        </div>
                        <div class="col-3 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stgHeadlightsForceOne" />
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">When enabled, the headlights will use a single light instead of 2 or 3. This will improve performance but the light will look a bit worse. Having multiple lights active affects performance considerably so it's recommended to enable it if you get low fps in vam.  Default is Disabled (<b>0</b>). </div>
                    </div>

                    <div class="row settings-row">
                        <div class="col-8">
                            <label class="t form-check-label t">Headlights shadows:</label>
                        </div>
                        <div class="col-3 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stgEnableHeadlightShadows" />
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">When enabled the lights will do shadows on objects, making things look better but at the cost of performance. Turning this off should improve performance.   Default is Disabled (<b>0</b>).</div>
                    </div>
                    
                    
                </div>
            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["atom"] = {
    title: "Lights",
    titleButtons: ["close"],
    hideTitle: true,
    icon: "system",
    skipHome: true,
};$(document).ready(function () {
//    characters_init_click_image();
    characters_init_bottommenu_character();
    characters_init_buttons();
});


function bottom_characters_menu_cron() {
    characters_populate_bottom();
//    characters_update_selected();
}

function characters_update_selected() {
    var person = Person.getSelectedPerson();
    if (isEmpty(person))
        return;
    var arousal = person.getSliderVal("arouse_level");
    $("#bottom-menu .person-stat.person-stat-arousal .range span").css("height", (arousal) + "%");
    var pain = person.getSliderVal("pain_level");
    $("#bottom-menu .person-stat.person-stat-pain .range span").css("height", (pain) + "%");

//    
//    var bpm = person.getSliderVal("heartrate_rate");
//    var duration = 60 / bpm;
//    
//    $('#bottom-menu .person-stat-arousal .icon.pulse').css('animation-duration', duration + 's');
}

function characters_populate_bottom() {
    var destination = $("#person-select-list");



    for (var pid of Object.keys(EPHEMERAL.characters)) {


        if ($('#person-select-list .item[data-person="' + pid + '"]').length < 1) {
            var character = EPHEMERAL.characters[pid];
            var android = null;
            var demo = destination.find(".demo").clone();
            demo.removeClass("demo").addClass('new cpl');
            demo.attr('data-person', pid);
            demo.addClass(isTrue(character.isFemale) ? "gender-female" : "gender-male");
            demo.find(".character-recenter").attr('data-aeurl-atom', pid);
            
            var avatar = "resources/character.jpg";
            if (isTrue(character.isAndroid)) {
                android = new Android(character.androidId);
                avatar = android.getImageProfileTimestamp();
                demo.addClass("is-android");
            }
            

            
            demo.find(".person-avatar").attr("src", avatar);
            
            
            destination.prepend(demo);
        }

    }

}



var character_select_doubleclick_time = 0;
var character_select_doubleclick_treshold = .400;
var character_select_doubleclick_last = "";

function characters_init_buttons() {
//    $("#app").on("mousedown", ".btn-character-replace", characters_on_character_replace_button);
    $("#app").on("mousedown", "#tab-characters-looks .character-look", characters_on_character_replace_person);
    $("#app").on("mousedown", ".character-add", characters_switch_add_character);
//    $("#app").on("mousedown",".person-menu-button-dismiss", character_dismiss);
    $("#app").on("mousedown", ".person-select-unselect", character_unselect);
    
    $("body").on("mousedown", ".person-menu-button-reset-pose", character_reset_pose);
    $("body").on("mousedown", ".person-menu-button-quick-move", character_quick_move);
    $("body").on("mousedown", ".person-menu-button-remove", character_remove);

    $("#app").on("mousedown", "#bottom-menu .person-avatar", function (e) {
        var parent = $(this).parents(".person-select-item");
        var personid = parent.attr('data-person');
        var person = new Person(personid);

        var currenttime = getTimestampFull();

        if (currenttime - character_select_doubleclick_time <= character_select_doubleclick_treshold) {
            aevent({action: "personVamSelect"});
        } else {
            person.selectPerson();
        }
        character_select_doubleclick_last = personid;
        character_select_doubleclick_time = currenttime;

    });

    $("#app").on("mousedown", ".person-dismiss-item", app_characters_remove_callback);
    
    $("#app").on("mousedown",".select-app-person-chat", function(){
        var person = Person.getSelectedPerson();
        var android = person.getAndroid();
        character_load_chat(android.id);
    });
    
    $("#app").on("mousedown",".select-app-person-profile", function(){
        var person = Person.getSelectedPerson();
        var android = person.getAndroid();
        character_load_profile(android.id);
    });
}
//
//function character_dismiss(){
//    $.confirm({
//        theme: 'material',
//        title: 'Delete this model from the scene?',
//        content: '',
//        buttons: {
//            cancel: function () {
//                
//            },
//            confirm: function () {
//                aevent({action:"personDismiss"});
//            },
//            
//        }
//    });
//    
//}




function character_load_profile(android_id){
    App.LoadApp("android", function(){
        app_android_select_android(android_id);
        App.changeTab("tab-android-profile");
    });
}


function character_load_chat(android_id){
    App.LoadApp("android",function(){
        var app = App.GetCurrent();
        app.SetParam(android_id);
        App.changeTab("tab-inbox-chat");
    });
}
//
//
//function characters_on_character_replace_button() {
//    var a = new App("characters");
//    a.Load();
//    var el = $(this).parents(".character");
//    var id = el.attr('data-id');
//    $("#tab-characters-looks").attr('data-id', id);
//    $(".tab-characters-looks-link").html("Replace");
//    a.SetTab("#tab-characters-looks");
//    app_init_topmenu_characters_cleanup();
//
//}

function characters_init_bottommenu_character() {
    $("#app").on(" mousedown", ".character-avatar-container", function () {
        if (App.GetCurrentAppName() == "characters") {
            App.LoadApp("home");
        } else {
            App.LoadApp("characters");
        }
    });
}

function characters_switch_add_character() {
    var a = new App("characters");
    a.Load();
    $("#tab-characters-looks").attr('data-id', "add");
    $(".tab-characters-looks-link").html("Add");
    a.SetTab("#tab-characters-looks");
//    app_init_topmenu_characters_cleanup();
}
//
//function characters_init_click_image(){
//    $("#app").on("mousedown", "#tab-characters-active .img_holder", function(e){
//        var o = $(this).parents(".character");
//        var personid = o.attr("data-id");
//        if(o.hasClass("selected")){
//            character_unselect();
//        }
//        else{
//         //   $("#tab-characters-active .character[data-id='"+personid+"']").addClass("selected");
//            character_select(personid);
//        }
//    });
//}
//

function characters_on_character_replace_person() {
    var el = $(this);
    var val = el.attr('data-value');
    var person_id = $("#tab-characters-looks").attr('data-id');
    set_url_from_options({action: "changelook", value: val, person: person_id});
    Person.removeSelected();
    App.LoadApp("home");
}


CHARACTER_PERSON_AVATAR_ID = "PersonAvatar";

function character_select(personid) {
    var p = new Person(personid);
    if (isEmpty(p.id))
        return;
    p.selectPerson();
//    set_url_from_options({action:"aliveSelectPerson",person:personid, actionAll:"aliveUnselectPerson"});
}

function character_reset_pose(){
    aevent({action: "aliveResetPoseStill"});
}
function character_remove(){
    var $cancel = Language.getTranslated("cancel");
    var $confirm = Language.getTranslated("confirm");
     $.confirm({
        theme: 'material',
        title: Language.getTranslated('Remove this person?'),
        content:"",
        columnClass: 'col-md-12',
        buttons: {
            [$cancel]: function () {

            },
            [$confirm]: function () {
                aevent({action: "personDismiss"});
            },
        }
    });
    
    
}
function character_quick_move(){
    aevent({action: "personComeHere"});
}

function character_unselect() {
    aevent({action: "personSelectNone"});
    Person.unselectAll();
    App.UnselectedPerson();
}


function character_is_selected() {
    return character_get_selected() !== "";
}

function character_get_selected() {
    return SELECTED_PERSON;
}
function android_get_selected() {
    var current = App.GetCurrent();
    if (current.name === "android" || current.name === "messages" || current.name === "chat") {
        return current.GetParam();
    }
    
    return 0;
}

function app_characters_postprepare() {

}
//

function app_character_refresh_bottom(id) {
    $("#person-select-list .person-select-item").each(function () {
        if ($(this).attr("data-person") === id) {
            $(this).remove();
        };
    });
}
function app_character_remove(id) {
    $("#person-select-list .person-select-item").each(function () {
        if ($(this).attr("data-person") === id) {
            var selected = $(this).hasClass('selected');
            $(this).remove();
            delete EPHEMERAL.characters[id];
            if (selected) {
                Person.unselectAll()
                App.UnselectedPerson();
            }
        }
    });
//        
}

function app_characters_remove_callback(o) {
    var person = Person.getSelectedPerson();
    if (!isEmpty(person.id))
        person.removePerson();

}

function app_characters_prepare_active() {
    var destination = $("#tab-characters-active .list");

    //Remove if no longer active
    if (destination.find(".item.new").length > 0) {
        destination.find(".item.new").each(function () {
            var id = $(this).attr('data-id');
            if (typeof (EPHEMERAL.characters[id]) === "undefined")
                $(this).remove();
        });
    }
    //Add if missing
    for (var pid of Object.keys(EPHEMERAL.characters)) {
        if (destination.find(".item.new[data-id='" + pid + "']").length > 0)
            continue; //skip if exists
        var character = EPHEMERAL.characters[pid];
        var demo = destination.find(".item.demo").clone();
        demo.removeClass("demo").addClass("new cpl");
        demo.find(".name").html(character.id);

        demo.attr("data-id", character.id);
//        demo.attr('data-timestamp', character.time);
        destination.append(demo);
    }
}






function character_info_populate(personid) {
    var person = new Person(personid);
    var android = person.getAndroid();
    var destination = $("#bottom-menu .person-info .person-name");
    var name = person.getString("personName");


    var personType = Language.getTranslated("VAM Generic Look");
    if (person.getBool("isAndroid")) {
        personType = Language.getTranslated("Character");
        name = android.firstName + " " + android.lastName;
    }
    
    
    
    
    destination.html(name);
    $("#bottom-menu .person-info .person-type").html(personType);


}TPL["characters"] = `
<div id="app-characters" class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t nav-link-hidden"  data-bs-toggle="tab" data-bs-target="#tab-characters-1" >Characters</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-characters-1">
            </div>
        </div>
    </div>


</div>
`;$(document).ready(function () {

});

META["characters"] = {
    title: "Characters",
    titleButtons: ["close"],
    icon: "vam",
};$(document).ready(function () {

});


function app_clothing_get_list_event_obj(){
    var event = {action:"query",context:"assets", query:"getList", context2:"wardrobe", callback:"app_clothing_on_received_clothing"};
    event.ctx = aephemeral_key(event);
    return event;
}

function app_clothing_get_list_event(){
    var event_obj = app_clothing_get_list_event_obj();
    var event = aephemeral_callback(event_obj);
    return event;
}

function tab_load_clothing_tab_wardrobe_templates(){
    aevent(app_clothing_get_list_event());    
}
function app_clothing_on_received_clothing(ctx, data){
    if(isEmpty(data)) return;
    if(typeof data === "string") data = JSON.parse((data));
    EPHEMERAL.queries[ctx] = data;
    app_clothing_populate_clothing();
    
}

function app_clothing_populate_clothing(){
    var destination = $("#tab-wardrobe-templates .list");
    destination.find(".added").remove();
    var ctx = app_clothing_get_list_event_obj().ctx;
    if(isEmpty(EPHEMERAL.queries[ctx])) return;
    for(var k of Object.keys(EPHEMERAL.queries[ctx])){
        var file = new VamFile("wardrobe",k, parseInt(EPHEMERAL.queries[ctx][k])===1);
        var demo = $("#tab-wardrobe-templates .item.demo").clone();
        demo.removeClass("demo").addClass("added");
        demo.find(".title").html( file.fileNameSimple);
        demo.find(".icon IMG").attr("src",file.getImageSrc());
        
        demo.addClass("aeurl")
            .attr("data-aeurl-action","changewardrobe")
            .attr("data-aeurl-value",file.path)
            .attr("data-aeurl-preset",file.fileNameSimple);
        
        destination.append(demo);
    }


}TPL["clothing"] = `
<div id="app-wardrobe" class="app">

    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-wardrobe-templates" >Clothes</a>
        </li>
         <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-wardrobe-actions">Actions</a>
        </li>
<!--        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-wardrobe-items" >Items</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-wardrobe-color" >Color</a>
        </li>-->
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            
            <div class="tab-pane fade list-default" id="tab-wardrobe-templates">
                <div class="list text-center">
                    <div class="item demo">
                        <div class="icon"><img class="selectable-toggle" src=""  /></div>
                        <div class="title">Title</div>
                    </div>
                </div>
            </div>
            
            <div class="tab-pane fade" id="tab-wardrobe-actions">
                <div class="container">
                    <div class="row ">
                        
                    </div>
                </div>
            </div>
            
            <div class="tab-pane fade" id="tab-wardrobe-color">
                
                <div class="row settings-row">
                    <div class="col-5">
                        <label class="t form-check-label t">Main color:</label>
                    </div>
                    <div class="col-7">
                        <div id="hair-main-color" class="colorpicker" data-value="#ff1a1a" data-colorpicker-callback="hair_color_main_callback"></div>
                    </div>
                </div>
                
                <div class="row settings-row">
                    <div class="col-5">
                        <label class="t form-check-label t">Accent color:</label>
                    </div>
                    <div class="col-7">
                        <div id="hair-accent-color" class="colorpicker" data-value="#ff1a1a" data-colorpicker-callback="hair_color_accent_callback"></div>
                    </div>
                </div>
                
                <div class="row settings-row">
                    <div class="col-5">
                        <label class="t form-check-label t">Accent color:</label>
                    </div>
                    <div class="col-7">
                        <div id="hair-accent-color" class="colorpicker" data-value="#ff1a1a" data-colorpicker-callback="hair_color_accent_callback"></div>
                    </div>
                </div>
                
            </div>
            
        </div>
    </div>


</div>
`;$(document).ready(function () {

});

META["clothing"] = {
    title: "Clothes",
    titleButtons: ["close"],
    icon: "person",
    isPerson: true,
    skipHome: true,
};$(document).ready(function () {
    app_debug_init();
});

function app_debug_init(){
    $("#app").on('click', "#settings-info-get-button", function(e){
        var destination = $("#settings-info-get");
        var s = Debug.getSnapshot();
//         set_url_from_options({action:"ephemeralSet", data:s});
         
        destination.val(s);
    });
    
    $("#app").on('click', "#settings-info-set-button", function(e){
        var s = $("#settings-info-set").val();
        Debug.setSnapshot(unescape(s));
    });
}
TPL["debug"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item "><a class="nav-link t active" data-bs-toggle="tab" data-bs-target="#tab-demo-snapshot" >Snapshot</a></li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content pt-3">

            <div class="tab-pane fade show active" id="tab-demo-snapshot"> 
                <div id="settingsinfo-debug" class="container">
                    <div class="col col-12">
                        <div class="alert alert-dark d-flex align-items-center" role="alert">
                            <span class="material-symbols-outlined me-3">info</span>
                            <div>Dev tool for exporting the UI data to allow setting it as a snapshot and develop quicker in a normal browser.</div>
                        </div>
                    </div>
                    <div class="row pb-4">
                        <div class="col col-12"><textarea id="settings-info-get" style="width:100%; min-height:10vh;"></textarea></div>
                        <div class="col col-6"></div>
                        <div class="col col-6"><input type="button" class="t btn btn-primary" id="settings-info-get-button" value="Get" style="width:100%;"  /></div>
                    </div>
                    <!--                    <div class="row pb-4">
                                            <div class="col col-12"><textarea id="settings-info-set"  style="width:100%; min-height:10vh;"></textarea></div>
                                            <div class="col col-6">Set:</div>
                                            <div class="col col-6"><input type="button" class="t btn btn-primary" id="settings-info-set-button" value="Set" style="width:100%;" /></div>
                                        </div>-->
                </div>
            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["debug"] = {
    title: "Debug",
    titleButtons: ["close"],
    icon: "devel",
    skipHome: true,
};$(document).ready(function () {

});

function app_demo_prepare(html){
    
}

function app_demo_postprepare(){
    
}

function app_demo_cron_second(){
    
}

function tab_load_demo(){
    
}
function tab_load_demo_tab_demo_1(){
    
}

function app_demo_on_home_append(element){
    //element.addClass("app-with-effect");
    return element;
}

function app_demo_on_aesetting_change(params){
     switch(params.setting){
        case "settingname":
            
            break;
    }
}

TPL["demo"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-demo-1" >Active</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-3" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t disabled">Disabled</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-demo-1"> Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br> </div>
            <div class="tab-pane fade" id="tab-demo-2">testt2</div>
            <div class="tab-pane fade" id="tab-demo-3">testt3</div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["demo"] = {
    title: "Demo",
    titleButtons: ["close"],
    icon: "devel",
    devOnly: true
};$(document).ready(function () {
    $("body").on("change","#hair-main-color, #hair-accent-color, #hair-specular-color",function(){
        let key = $(this).attr('id');
        if(TIMESTAMPS[key] === undefined) TIMESTAMPS[key] = 0;
        if(getTimestampFull()-TIMESTAMPS[key] > 0.05){  
            
            var fn = $(this).attr('data-colorpicker-callback');
            var value = "#"+$(".ui-colorpicker-hex-input").val();
            window[fn](value);
            TIMESTAMPS[key] = getTimestampFull();
            
            setTimeout(function(){
                let value = "#"+$(".ui-colorpicker-hex-input").val();
                window[fn](value);
            },100);
        }
    });
    
    $("body").on("input", ".hair-field", function(){
        if (throttled("app_hair_hair-field", 5)) return;
        var key = $(this).attr('data-val');
        var val = $(this).val();
        aevent({action:"query", context:"hair", query:"setHairField", key:key, val:val});
    });
    $("body").on("change", ".hair-field", function(){
        var key = $(this).attr('data-val');
        var val = $(this).val();
        aevent({action:"query", context:"hair", query:"setHairField", key:key, val:val});
    });
});


function hair_color_main_callback(color){
    let options = {};
    options.action = "setHairColorMain";
    options.value = color;
    set_url_from_options(options);
}

function hair_color_accent_callback(color){
    let options = {};
    options.action = "setHairColorAccent";
    options.value = color;
    set_url_from_options(options);
}

function hair_color_specular_callback(color){
    let options = {};
    options.action = "setHairColorSpecular";
    options.value = color;
    set_url_from_options(options);
}


function app_hair_get_list_event_obj(){
  var event = {action:"query",context:"assets", query:"getList", context2:"haircuts", callback:"app_hair_on_received_hair"};
  event.ctx = aephemeral_key(event);
  return event;
}
function app_hair_get_list_event(){
    var eventdata = app_hair_get_list_event_obj();
    var event = aephemeral_callback(eventdata);
    return event;
}

function tab_load_hair_tab_haircuts_templates(){
    aevent(app_hair_get_list_event());    
}
function app_hair_on_received_hair(ctx, data){
    if(isEmpty(data)) return;
    if(typeof data === "string") data = JSON.parse((data));
    EPHEMERAL.queries[ctx] = data;
    app_hair_populate_hair();
    
}

function app_hair_populate_hair(){
    var destination = $("#tab-haircuts-templates .list");
    destination.find(".added").remove();
    var ctx = app_hair_get_list_event_obj().ctx;
    if(isEmpty(EPHEMERAL.queries[ctx])) return;
    for(var k of Object.keys(EPHEMERAL.queries[ctx])){
        var file = new VamFile("haircuts",k, parseInt(EPHEMERAL.queries[ctx][k])===1);
        var demo = $("#tab-haircuts-templates .item.demo").clone();
        demo.removeClass("demo").addClass("added");
        demo.find(".title").html( file.fileNameSimple);
        demo.find(".icon IMG").attr("src",file.getImageSrc());
        
        demo.addClass("aeurl")
            .attr("data-aeurl-action","changehaircut")
            .attr("data-aeurl-value",file.path)
            .attr("data-aeurl-preset",file.fileNameSimple);
        
        destination.append(demo);
    }


}TPL["hair"] = `
<div id="app-haircuts" class="app list-default">

    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-haircuts-templates" >Hairstyle</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-haircuts-2" >Color</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">

            <div class="tab-pane fade" id="tab-haircuts-templates">
                <div class="list text-center">
                    <div class="item  demo">
                        <div class="icon"><img class="selectable-toggle" src=""  /></div>
                        <div class="title">Title</div>
                    </div>
                </div>
            </div>

            <div class="tab-pane fade" id="tab-haircuts-2">
                <div class="container">
                    <div class="row settings-row">
                        <div class="col-5">
                            <label class="t form-check-label t">Main color:</label>
                        </div>
                        <div class="col-7">
                            <div id="hair-main-color" class="colorpicker" data-value="#ff1a1a" data-colorpicker-callback="hair_color_main_callback"></div>
                        </div>
                    </div>

                    <div class="row settings-row">
                        <div class="col-5">
                            <label class="t form-check-label t">Accent color:</label>
                        </div>
                        <div class="col-7">
                            <div id="hair-accent-color" class="colorpicker" data-value="#ff1a1a" data-colorpicker-callback="hair_color_accent_callback"></div>
                        </div>
                    </div>

                    <div class="row settings-row">
                        <div class="col-5">
                            <label class="t form-check-label t">Specular color:</label>
                        </div>
                        <div class="col-7">
                            <div id="hair-specular-color" class="colorpicker" data-value="#ff1a1a" data-colorpicker-callback="hair_color_specular_callback"></div>
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Primary Specular Gloss:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="primarySpecularSharpness" min="0" max="256" step="0.01">
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Secondary Specular Gloss:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="secondarySpecularSharpness" min="0" max="256" step="0.01">
                        </div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Secondary Specular Shift:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="specularShift" min="0" max="1" step="0.01">
                        </div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Random Color Power:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="randomColorPower" min="0" max="10" step="0.01">
                        </div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Random Color Offset:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="randomColorOffset" min="0" max="1" step="0.01">
                        </div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Fresnel Power:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="fresnelPower" min="0" max="10" step="0.01">
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Fresnel Attenuation:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="fresnelAttenuation" min="0" max="1" step="0.01">
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Global Illumination Factor:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="IBLFactor" min="0" max="1" step="0.01">
                        </div>
                    </div>
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Normal Randomize:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="normalRandomize" min="0" max="1" step="0.01">
                        </div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Root-Tip Color Roll-off:</label>
                        </div>
                        <div class="col-7">
                            <input type="range" class="form-range hair-field" data-val="colorRolloff" min="0" max="5" step="0.01">
                        </div>
                    </div>



                </div>

            </div>

        </div>
    </div>


</div>
`;$(document).ready(function () {

});

META["hair"] = {
    title: "Hair",
    titleButtons: ["close"],
    icon: "person",
    isPerson: true,
    skipHome: true,
};$(document).ready(function () {
    app_help_init_clicks();
});

function app_help_prepare(html){
    
}

function app_help_postprepare(){
    
}

function app_help_cron_second(){
    
}

function app_help_init_clicks(){
    $("#app").on("mousedown","#app-help .help-category h3", app_help_click_title);
    $("#app").on("mousedown","#app-help .help-category h4", app_help_click_article);
}

function app_help_click_title(){
    var el = $(this).parents(".help-category");
    toggle_selected(el);
}

function app_help_click_article(){
    var article = $(this).attr("data-article");
    $("#app-help .help-category h4.selected").removeClass('selected');
    $(this).addClass("selected");
    $(".help-articles-list .article.selected").removeClass('selected');
    $(".help-articles-list .article[data-article='"+article+"']").addClass("selected");
    var title = $(this).html();
    $(".help-articles-title h2").html(title);
}TPL["help"] = `
<div class="app" id="app-help">

    <div class="app-content  scrollbar1">
        <div class="tab-content">
            <div class="tab-pane active show fade" id="tab-help-general">

                <div class="container-fluid" id="help-categories">
                    <div class="row">
                        <div class="col col-md-3 col-12 scrollbar1" id="help-categories-tree">
                            <div class="row">
                                <div class="col col-12 help-category">
                                    <br />
                                    <h3><span class="material-symbols-outlined add">add</span><span class="material-symbols-outlined remove">remove</span><span class="t">General</span></h3>
                                    <div class="help-category-subcategories">
                                        <h4 class="t" data-article="article-defaultplugin">Set as default plugin</h4>
                                        <h4 class="t" data-article="article-keys">Controls</h4>
                                    </div>
                                </div>
<!--                                <div class="col col-12 help-category">
                                    <h3><span class="material-symbols-outlined add">add</span><span class="material-symbols-outlined remove">remove</span>Plugins</h3>
                                    <div class="help-category-subcategories">
                                        <h4 data-article="plugins-alive">Alive</h4>
                                        <h4 data-article="plugins-aeternum">Aeternum</h4>

                                    </div>
                                </div>-->
                            </div>
                        </div>
                        <div class="col col-md-9 col-12 help-articles-list">
                            <br />
                            <div class="help-articles-list-separator d-inline-block d-md-none"></div>
                            <div class="help-articles-title"><h2></h2></div>

                             <div class="article" data-article="article-defaultplugin">
                                <h5 class="t">Setting Alive as a default plugin</h5>
                                
                                If you want Alive to automatically be loaded in VAM you can do the following:<br /><br/>
                                <ul>
                                    <li style="list-style: none">1. In vam's menu select the <b>Session Plugin Presets</b> tab and hit the "Load defaults" button</li> <br/>
                                    <li  style="list-style: none">2. Go to <b>Session Plugins</b> tab and add Alive </li><br/>
                                    <li  style="list-style: none">3. Go back to <b>Session Plugin Presets</b> and press Change User Defaults > Set current as User Defaults</li><br/>
                                </ul>
                                
                                Doing that will save the currently loaded session plugins as default plugins, so that they'll get loaded automatically next time when loading VAM.
                                
                             </div>
                            <div class="article" data-article="article-keys">
                                <h5 class="t">VR</h5>
                                <ul>
                                    <li><b>Trigger+A or Trigger+X</b> = when pressed it toggles the Alive UI; on hold it moves the Alive UI</li>
                                    <li><b>Trigger (next to headset)</b> = if VR voice button is enabled it will trigger the voice microphone if the current app screen has that feature (like on the chat screen for example)</li>
                                </ul>
                                
                                
                                <h5 class="t">General</h5>
                                <ul>
                                    <li><b>H</b> = bring active model in front of camera</li>
                                    <li><b>Q or E </b> = rotate VAM's screenshot camera left and right</li>
                                    <li><b>Delete</b> = removes the currently selected atom</li>
                                    <li><b>Insert</b> = duplicates the currently selected atom</li>
                                </ul>
                                
                                <h5 class="t">Desktop touches</h5>
                                You can simulate the VR touches on desktop too by right clicking on a character with Alive.<br/>
                                <ul>
                                    <li><b>Right Mouse Button</b> = tease </li>
                                    <li><b>Shift+RMB</b> = caress</li>
                                    <li><b>Ctrl+RMB</b> = spank</li>
                                </ul>
                                
                                <h5 class="t">Desktop first person mode</h5>
                                The desktop 1st person mode replaces vam floating mode when pressing TAB.
                                <ul>
                                    <li><b>Tab</b> = Toggle first person mode</li>
                                    <li><b>WASD</b> = move up down left right</li>
                                    <li><b>Space</b> = jump</li>
                                    <li><b>C</b> = crouch</li>
                                    <li><b>Left Shift</b> = sprint</li>
                                    <li><b>1</b> = default crosshair</li>
                                    <li><b>2</b> = toy  dildo</li>
                                    <li><b>3</b> = toy paddle</li>
                                    <li><b>0</b> = no toy and no crosshair</li>
                                    <li><b>Up Down Left Right arrows</b> = move toy around</li>
                                    <li><b>Mouse scroll</b> = move toy forward and back</li>
                                    <li><b>L</b> = Turn headlights on/off</li>
                                </ul>
                                
                            </div>



                            <div class="article" data-article="plugins-alive">
                                "Alive (Session Plugin).cslist" is a plugin that must be added to <b>Person atoms</b>. Once added the person will automatically have expressions, idle body movement and will react to interaction.
                            </div>
                            <div class="article" data-article="plugins-aeternum">
                                "Alive (Session Plugin).cslist" is a plugin that must be added as a <b>Session plugin</b>. On desktop it will show the new UI on the right side of the screen, on desktop it will add the UI to one of the hands.
                            </div>



                        </div>
                    </div>
                </div>



            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["help"] = {
    title: "Help",
    titleButtons: ["close"],
    hideTitle: false,
    icon: "vam"
};$(document).ready(function () {
    app_home_init_search();
});

function app_home_init_search(){
    $("#app").on("keyup","#app-home-search-input",function(){
        var val = $("#app-home-search-input").val();
        app_home_filter_list(val);
    });
}
function app_home_filter_list(v){
    v = v.toLowerCase();
    var destination = $("#app-home-apps .list");
    destination.find(".filteredout").removeClass("filteredout");
    destination.find(".home-app").each(function(k,val){
        if($(val).find(".title").text().toLowerCase().indexOf(v) === -1){
            $(val).addClass("filteredout");
        }
    });
}
//
//function app_home_cron_second() {
//    page_home_cron_time_second();
//    page_home_cron_elapse();
//}
//
//function page_home_cron_time_second() {
//    var d = new Date();
//    var s = d.getSeconds();
//    var m = d.getMinutes();
//    var h = d.getHours();
//    if (DEBUGMODE) {
//        h = 0;
//    }
//    //var text = ("0" + h).substr(-2) + ":" + ("0" + m).substr(-2) + ":" + ("0" + s).substr(-2); 
//    var text = ("0" + h).substr(-2) + ":" + ("0" + m).substr(-2);
//    $("#mainmenu_time span").html(text);
//}
//
//function page_home_cron_elapse() {
//    var destination = $("#mainmenu_time_elapsed");
//    destination.html(EPHEMERAL.vamscene.timeelapsed);
//}

function app_home_prepare(html){
    var destination = html.find("#app-home-apps .list");
    
    var sortedApps = {};
    for(var k in META){
        sortedApps[META[k].title] = META[k];
        sortedApps[META[k].title].key = k;
    }
    
    app_home_append_apps(sortedApps, html, destination, "aeternum");
    destination.append("<hr />");
//    app_home_append_apps(sortedApps, html, destination, "game");
//    destination.append("<hr />");
    app_home_append_apps(sortedApps, html, destination, "fun");
   
//    destination.append("<hr />");
//    app_home_append_apps(sortedApps, html, destination, "devel");
//    
     destination.append("<hr />");
     app_home_append_apps(sortedApps, html, destination, "vam");
    
    return html;
}


function app_home_append_apps(sortedApps, html, destination, category){
    var keys = Object.keys(sortedApps);
    keys = keys.sort();
    for(var key of keys){
        var k = sortedApps[key].key;
        var app = new App(k);
        if(app.Meta("skipHome")) continue;
        if(app.Meta("devOnly") /*&& !DEBUGMODE*/) continue;
        if(app.Meta("icon") !== category) continue;
        var classes = app.Meta("classes") || "";
        
        var demo = html.find(".home-app.demo").clone();
        demo.removeClass("demo");
        demo.addClass("new "+classes);
        if(app.Meta("isAliveHome")) demo.addClass("alive-home-only");
        demo.attr('data-app', k);
        demo.find(".title").html( META[k].title);
        demo.find(".icon IMG").attr("src",app.GetIconSrc()).addClass(app.GetIconClass());
        if(app.IsCharacter()){
            demo.addClass("character-app");
        }
        
        
        
        var fn = "app_" + k + "_on_home_append";
        if (typeof (window[fn]) === "function"){
            demo = window[fn](demo);
        }
        
        
        destination.append(demo);
    }
}TPL["home"] = `
<div id="app-home" class="app">
    <!--    
            <div class="row">
                <div class="col-6">
                    <div class="card text-white bg-black text-center">
                        <div class="card-header p-1">Clock</div>
                        <div class="card-body p-1">
                            <div id="mainmenu_time"><span></span></div>
                        </div>
                    </div>
                </div>
                <div class="col-6">
                    <div class="card text-white bg-black text-center">
                        <div class="card-header p-1">Elapsed</div>
                        <div class="card-body p-1">
                            <div id="mainmenu_time_elapsed"><span></span></div>
                        </div>
                    </div>
                </div>
            </div>
    -->
    <div class="app-content  scrollbar1">
        <div id="app-home-search" class="search-filter-container ">
            <input id="app-home-search-input" class="keyboard search-filter" type="text" />
        </div>
        <div id="app-home-apps">
            <div class="list">
                <div class="home-app demo">
                    <div class="icon"><img src=""  />
                    <div class="app-extra-icons">
                        <div class="app-extra-icon app-extra-icon-sound"><span class="material-symbols-outlined">volume_up</span></div>
                        <div class="app-extra-icon app-extra-icon-effect"><span class="material-symbols-outlined">play_circle</span></div>
                    </div>
                    </div>
                    <div class="title t">Title</div>
                    
                </div>
            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["home"] = {
    title: "Home",
    hideTitle: true,
    skipRecentApps: true,
    skipHome: true,
    icon: "system"
};$(document).ready(function () {
    page_homescreen_daytime_slider_init();
});


function app_homescreen_prepare(html) {

}

function app_homescreen_postprepare() {
    page_homescreen_populate_locations();
}



function page_homescreen_populate_locations(){
    var destination = $(".list-player-locations");
    var demo = destination.find(".demo");
    var locations = page_homescreen_get_locations();
    
    for(var key of Object.keys(locations)){
        var location = locations[key];
        var item = demo.clone();
        item.removeClass("demo").addClass("location-"+key);
        item.find(".item-link").attr('data-aeurl-position',location.position).attr('data-aeurl-rotation',location.rotation);
        item.find(".item-link .title").html(location.name);
        item.find(".item-link .img").html('<img src="resources/locations/'+key+'.jpg" />');
        destination.append(item);
    }
}
function page_homescreen_alivehome_notloaded(o){
     $.confirm({
            theme: 'material',
            title: 'Leave scene and go to Alive Home?',
            content: "Warning! Changes in the current scene will be lost if you didn't save them and you proceed.",
            buttons: {
                cancel: function () {

                },
                confirm: function () {
                    aevent({action: "gotoAliveHome"});
                },
            }
        });
}
function page_homescreen_get_locations(){
    var o = {};
    
    o["balcony"] = {
        name: "Balcony",
        position: "3.65,0,1.66",
        rotation: "0,120,0"
    };
    
    o["dining"] = {
        name: "Dining",
        position: "2.953,0,6.372",
        rotation: "0,99,0"
    };
    
    o["kitchen"] = {
        name: "Kitchen",
        position: "4.173,0,13.523",
        rotation: "0,99.646,0"
    };
    
    o["office"] = {
        name: "Office",
        position: "1.269,0,20.438",
        rotation: "0,181.405,0"
    };
    
    o["panicroom"] = {
        name: "Safe",
        position: "5.03,0,20.346",
        rotation: "0,181.405,0"
    };
    
    o["hallway"] = {
        name: "Hallway",
        position: "-4.096,0,12.414",
        rotation: "0,181.405,0"
    };
    
    o["dome"] = {
        name: "Dome",
        position: "-13.321,0,19.956",
        rotation: "0,271.41,0"
    };
    o["entrance"] = {
        name: "Entrance",
        position: "-8.7,0,19.63",
        rotation: "0,175.623,0"
    };
    o["bedroom"] = {
        name: "Bedroom",
        position: "-6.423,0,-2.316",
        rotation: "0,175.623,0"
    };
    o["studio"] = {
        name: "Studio",
        position: "-10.268,0,-2.905",
        rotation: "0,241.962,0"
    };
    o["room1"] = {
        name: "Camshow",
        position: "-12.34,0,0.98",
        rotation: "0,274.584,0"
    };
    o["room2"] = {
        name: "Hallway 2",
        position: "-11.85,0,7.07",
        rotation: "0,274.584,0"
    };
    o["room3"] = {
        name: "BDSM Room",
        position: "-11.94,0,13.77",
        rotation: "0,274.584,0"
    };
    
    o["stage"] = {
        name: "Stage",
        position: "-3.37,0,3.573",
        rotation: "0,181.405,0"
    };
    o["living"] = {
        name: "Living",
        position: "0.989,0,-1.602",
        rotation: "0,247.433,0"
    };
    o["bathroom"] = {
        name: "Bathroom",
        position: "-2.741,0,16.85",
        rotation: "0,351.796,0"
    };
    o["elevator"] = {
        name: "Elevator",
        position: "-8.097,0,25.369",
        rotation: "0,180,0"
    };
    o["interviewroom"] = {
        name: "Interview",
        position: "-20.368,0,3.775",
        rotation: "0,125.984,0"
    };
    
    return o;
}

function page_homescreen_daytime_slider_init() {


    function updateTime() {
        var $slider = $('#time-slider');
        var $circles = $('#day-time-slider .slider-circle');
        var $time = $('#day-time-slider .slider-time');
        var circleCount = $circles.length;
        var range = $slider.attr('max') - $slider.attr('min');
        var circleStep = range / (circleCount - 1);

        var value = parseFloat($slider.val());
        var hours = Math.floor(value);
        var minutes = Math.round((value - hours) * 60);
        var ampm = hours < 12 ? 'AM' : 'PM';
        hours = hours % 12;
        hours = hours ? hours : 12;
        var timeString = hours + ':' + (minutes < 10 ? '0' + minutes : minutes) + ' ' + ampm;
        $time.text(timeString);
    }

    $("#app").on('input', "#time-slider", function () {
        var $slider = $('#time-slider');
        var $circles = $('#day-time-slider .slider-circle');
        var $time = $('#day-time-slider .slider-time');
        var circleCount = $circles.length;
        var range = $slider.attr('max') - $slider.attr('min');
        var circleStep = range / (circleCount - 1);
        
        var value = parseFloat($slider.val());
        var percentage = (value - $slider.attr('min')) / range;
        var circleIndex = Math.round(percentage * (circleCount - 1));
        $circles.removeClass('active');
        $circles.eq(circleIndex).addClass('active');
        updateTime();
    });

    updateTime();



}TPL["homescreen"] = `

<div id="app-homescreen" class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#homescreen-locations" >Locations</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade pb-5 mb-5" id="homescreen-locations">
                <div class="container mt-4" style="min-height:100vh;">
                    <div class="row">
                       <div class="col-12">
                           <div class="list list-player-locations row">
                               <div class="item demo player-location col-4 col-md-2">
                                    <div class="item-link aeurl" data-aeurl-action="playerMove" data-aeurl-position="0,0,0" data-aeurl-rotation="0,0,0">
                                        <div class="img"></div>
                                        <div class="title"></div>
                                    </div>
                               </div>
                           </div>
                       </div>
                   </div>
               </div>
            </div>

        </div>
    </div>
</div>

<!--<div id="app-homescreen" class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t active" data-bs-toggle="tab" data-bs-target="#homescreen-locations" >Locations</a>
        </li>
       
    </ul>
    <div class="app-content tabbed scrollbar1">
        
        
        <div class="app-content tabbed">
        <div class="tab-content">
            <div class="tab-pane fade show active" id="homescreen-locations">
                <div class="container mt-4">
                    <div class="row">
                       <div class="col-12">
                           <div class="list list-player-locations row">
                               <div class="item demo player-location col-4 col-md-2">
                                   <div class="item-link aeurl" data-aeurl-action="playerMove" data-aeurl-position="0,0,0" data-aeurl-rotation="0,0,0">
                                       <div class="img"></div>
                                       <div class="title"></div>
                                   </div>
                               </div>
                           </div>
                       </div>
                   </div>
               </div>
            </div>
        </div>
    </div>
    </div>
</div>-->
`;$(document).ready(function () {

});

META["homescreen"] = {
    title: "Locations",
    hideTitle: true,
    isAliveHome: true,
    icon: "fun"
};$(document).ready(function () {

});

function app_interaction_prepare(html){
    
}

function app_interaction_postprepare(){
    
}

function app_interaction_cron_second(){
    
}

function tab_load_interaction(){
    app_interaction_loop_get_levels();
}
function tab_load_interaction_tab_interaction_effects(){
   
}
var timeout_app_interaction_loop_get_levels;
function app_interaction_loop_get_levels(){
    if(App.GetCurrentAppName() !== "interaction") return;
    aevent({action:"aliveGetData"});
    
    app_interaction_populate_effects();
    clearTimeout(timeout_app_interaction_loop_get_levels);
    timeout_app_interaction_loop_get_levels = setTimeout(app_interaction_loop_get_levels, 1000);
}

function app_interaction_populate_effects(){
    if(App.GetCurrentAppTab() !== "#tab-interaction-effects") return;
    var character = new Character();
    if(!character.isGood()) return;
    set_progressbar($(".ae-level-interaction-tease"), character.getSlider("tease_level"));
    set_progressbar($(".ae-level-interaction-arouse"), character.getSlider("arouse_level"));
    set_progressbar($(".ae-level-interaction-pain"), character.getSlider("pain_level"));
    
    set_progressbar($(".ae-level-interaction-breathing"), character.getBreathingRatePercent());
    set_progressbar($(".ae-level-interaction-heartrate"), character.getHeartRatePercent());
    set_progressbar($(".ae-level-interaction-tired"), character.getTiredRatePercent());
    
    
}

TPL["interaction"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-interaction-effects" >Actions</a>
        </li>
<!--        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-interaction-casual" >Casual</a>
        </li>-->
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-interaction-xxx" >XXX</a>
        </li>
<!--        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-interaction-actions" >Actions</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-interaction-context" >Context</a>
        </li>-->

    </ul>
    
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-interaction-effects">
                <div class="container mt-3">
                    <h4 class="t section-title">Levels</h4>
                    
                     <div class="row settings-row p-0">
                        <div class="col-1 p-0  text-center">
                            <label class=" form-check-label aesearchtext "><span class="material-symbols-outlined ae-level-interaction-arouse-icon">favorite</span></label>
                        </div>
                        <div class="col-10">
                            <div class="ae-level ae-level-interaction-arouse"><span></span></div>
                        </div>
                        <div class="col-1 p-0 text-center">
                            <span class="settings-info-icon material-symbols-outlined">help</span>
                        </div>
                      
                  
                        <div class="col-1 p-0 text-center">
                            <label class="form-check-label aesearchtext"><span class="material-symbols-outlined ae-level-interaction-tease-icon">sentiment_content</span></label>
                        </div>
                        <div class="col-5">
                            <div class="ae-level ae-level-interaction-tease"><span></span></div>
                        </div>
                      
                        
                        <div class="col-5">
                            <div class="ae-level ae-level-interaction-pain"><span></span></div>
                        </div>
                        <div class="col-1 p-0 text-center">
                            <label class=" form-check-label aesearchtext float-end" style="margin-right:8px;"><span class="material-symbols-outlined  ae-level-interaction-pain-icon">sentiment_stressed</span></label>
                        </div>
                       
                        <div class="col-12 settings-info">The current levels of the character based on touches: arouse, tease and discomfort.</div>
                         
                    </div>
                    
                    
                    <div class="row settings-row p-0">
                        <div class="col-1 p-0  text-center">
                            <label class="form-check-label aesearchtext "><span class="material-symbols-outlined ae-level-interaction-breathing-icon">oxygen_saturation</span></label>
                        </div>
                        <div class="col-10">
                            <div class="ae-level ae-level-interaction-breathing"><span></span></div>
                        </div>
                        <div class="col-1 p-0 text-center">
                            <span class="settings-info-icon material-symbols-outlined">help</span>
                        </div>
                        <div class="col-12 settings-info">Breathing rate level. Breathing rate controls the breathing sounds and increases in intensity when interacting a lot with the character or when the character moves around or based on other factors.</div>
                    </div>
                    
                    <div class="row settings-row  p-0">
                        <div class="col-1 p-0  text-center">
                            <label class=" form-check-label aesearchtext "><span class="material-symbols-outlined ae-level-interaction-heartrate-icon">ecg_heart</span></label>
                        </div>
                        <div class="col-10">
                            <div class="ae-level ae-level-interaction-heartrate"><span></span></div>
                        </div>
                        <div class="col-1 p-0 text-center">
                            <span class="settings-info-icon material-symbols-outlined">help</span>
                        </div>
                        <div class="col-12 settings-info">Heart rate level. Heart rate increases when the character moves around considerably in the scene or based on other factors.</div>
                    </div>
                    
                    <div class="row settings-row p-0">
                        <div class="col-1 p-0  text-center">
                            <label class=" form-check-label aesearchtext "><span class="material-symbols-outlined ae-level-interaction-tired-icon">sprint</span></label>
                        </div>
                        <div class="col-10">
                            <div class="ae-level ae-level-interaction-tired"><span></span></div>
                        </div>
                        <div class="col-1 p-0 text-center">
                            <span class="settings-info-icon material-symbols-outlined">help</span>
                        </div>
                        <div class="col-12 settings-info">Tired level. When tired level is up, the character eyes will be a bit more closed.</div>
                    </div>
                    
                    
                    
                    
                  
                </div>
            </div>
<!--           <div class="tab-pane fade" id="tab-interaction-casual">
               <div class="container mt-3">
                   
                   <div class="row">
                        <div class="col-7">
                            <label class="t form-check-label aesearchtext">Give chewing gum</label>
                        </div>
                        <div class="col-4">
                            <button class="t btn btn-primary btn-sm aequery " data-context="effects" data-query="start" data-query-effect="ChewingGum">Give</button>
                        </div>
                        <div class="col-1 col-helper">
                            <span class="settings-info-icon material-symbols-outlined">help</span>
                        </div>
                        <div class="col-12 settings-info">Gives the character some ASMR chewing gum.</div>
                    </div>
                   
               </div>
           </div>-->
            
            <div class="tab-pane fade" id="tab-interaction-xxx">
                <div class="container mt-3">
                    
                       
                     <div class="row">
                        <div class="col-7">
                            <label class="t form-check-label aesearchtext">Forced orgasm</label>
                        </div>
                        <div class="col-4">
                            <button class="t btn btn-primary btn-sm aeurl " data-aeurl-action="personForceOrgasm">Orgasm</button>
                        </div>
                        <div class="col-1 col-helper">
                            <span class="settings-info-icon material-symbols-outlined">help</span>
                        </div>
                        <div class="col-12 settings-info">Forces the character to have an orgasm if Alive is enabled for it.</div>
                    </div>
                    
                    
                </div>
            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["interaction"] = {
    title: "Interaction",
    titleButtons: ["close"],
    icon: "person",
    isPerson: true,
    skipHome: true,
//    devOnly: true
};$(document).ready(function () {
    $("body").on("mousedown", "#app-loading .loading-widget, #app-loading .loading-alive", function(){
        $("#app-loading").addClass("show-loading-steps");
    });
});

function app_loading_prepare(html){
    
}
var loadingLoaded = false;
function app_loading_check_cron(){
    if(App.GetCurrentAppName() !== "loading") return;
    var ok = 0;
    var asettings = "N", vamscene="N", vamdata="N";
    if(app_loading_check_item("aesettings")){
        ok++;
        asettings = "Y";
    }
    //if(app_loading_check_item("characters")) ok++;
    if(app_loading_check_item("vamscene")){
        ok++;
        vamscene = "Y";
    }
    if(app_loading_check_item("vamdata")) {
        ok++;
        vamdata = "Y";
    }
   
    if(ok === 3){
        if(!loadingLoaded){
            loading_add("c: "+ asettings+vamscene+vamdata);
           loadingLoaded = true;
           initial_load();
       }
    } else {
         loading_add("c: "+ asettings+vamscene+vamdata);
    }
    
}

function app_loading_check_item(s){
    var destination = $(".loading-steps .step_"+s);
    if(destination.hasClass("finished")) return true;
    if(Object.keys(EPHEMERAL[s]).length > 0){
        destination.addClass("finished");
    }
    return false;
        
}



function loading_add(s){
    if($("#loading-debug textarea").length < 1) return;
    $("#loading-debug textarea").val($("#loading-debug textarea").val()+getTimestamp()+": "+s+" | ");
}

TPL["loading"] = `
<div class="app" id="app-loading">
    <div class="loading-widget">
        <div class="aeversion loading-version"></div>
        <div class="lds-roller"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
    </div>
    <div class="loading-alive">
        <img src="resources/aelogo.png" />
    </div>
    <div class="loading-steps container">
        <div class="row step step_aesettings">
            <div class="col col-10 title">AESETTINGS</div>
            <div class="col col-2 status"></div>
            <div class="col col-12 info"></div>
        </div>
        <div class="row step step_characters">
            <div class="col col-10 title">CHARACTERS</div>
            <div class="col col-2 status"></div>
            <div class="col col-12 info"></div>
        </div>
        <div class="row step step_vamscene">
            <div class="col col-10 title">VAMSCENE</div>
            <div class="col col-2 status"></div>
            <div class="col col-12 info"></div>
        </div>
        <div class="row step step_vamdata">
            <div class="col col-10 title">VAMDATA</div>
            <div class="col col-2 status"></div>
            <div class="col col-12 info"></div>
        </div>
        
        <div id="loading-debug" class="textarea-copy"><textarea></textarea></div>
    </div>
</div>
`;$(document).ready(function () {

});

META["loading"] = {
    title: "Loading",
    hideTitle: true,
    fullscreen: true,
    skipHome: true,
    skipRecentApps: true,
    icon: "devel"
};$(document).ready(function () {

});TPL["makeup"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-demo-1" >Active</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-3" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t disabled">Disabled</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-demo-1"> Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br>Demo <br> </div>
            <div class="tab-pane fade" id="tab-demo-2">testt2</div>
            <div class="tab-pane fade" id="tab-demo-3">testt3</div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["makeup"] = {
    title: "Makeup",
    titleButtons: ["close"],
    icon: "person",
    isPerson: true,
    devOnly: true
};PERSON_NAME = 'Player';
AI_NAME = "AI";


$(document).ready(function () {
    app_android_init();
});

function app_android_init(){
    $("#mainapp").on("mousedown",".android_action",android_action);
    $("#mainapp").on("mousedown", ".android-btn-save", function(){app_android_form_save()});
    $("#mainapp").on("mousedown", ".android-btn-save-direct", function(){app_android_form_save(true)});
    $("body").on("mousedown", ".android-btn-delete", function(){app_android_form_delete($(this));});
    $("body").on("mousedown", ".android-scene-load", function(){app_android_add($(this))});
    $("body").on("mousedown", ".android-scene-remove", function(){app_android_scene_remove($(this))});
    $("body").on("mousedown", ".android-load-in-person", function(){app_android_load_in_person($(this));});
    $("body").on("mousedown", ".android-swap", function(){app_android_swap($(this));});
    $("body").on("mousedown", ".android-unload-in-person", function(){app_android_unload_in_person($(this));});
    $("body").on("mousedown", ".android-replace-in-person", function(){app_android_replace_in_person($(this));});
    $("body").on("mousedown", ".android-body-save", function(){app_android_body_save($(this));});
    $("#mainapp").on("mousedown", ".android-body-photo", app_android_body_photo);
    $('body').on("mousedown",".android-profile-link", function(){app_android_goto_profile($(this))});
    $('body').on('mousedown','.load-character-card', app_android_load_character_card);
  
    
    $("#app").on("mousedown", ".android-profile-more", function(){app_android_form_more($(this))});
    
}

function app_android_prepare(html){
    
}

function app_android_postprepare(){
    
}

function app_demo_cron_second(){
    
}

function app_android_update_android_position(o, android){
    o.removeClass("location-away").removeClass("location-present");
    if(android.isInScene()){
        o.addClass("location-present");
    } else {
        o.addClass("location-away");
    }
}

function app_android_update_android_current_position(androidid, isPresent){
    var o;
    if(!isPresent){
        o = $('.location-present[data-androidid="'+androidid+'"]');
        if(o.length > 0){
            o.removeClass("location-present").addClass("location-away");
        }
    }
    else{
        o = $('.location-away[data-androidid="'+androidid+'"]');
        if(o.length > 0){
            o.removeClass("location-away").addClass("location-present");
        }
    }
    
    
}

function tab_load_android(){
    var a = app_android_get_current_android();
   if(a === null) return;
//   console.log("tab_load_android",$("#app-android").length);

   $("#app-android.android").attr("data-androidid", a.id);
   app_android_update_android_position($("#app-android.android"), a);
   $("#app-android .android-name").html(a.getName());
   $("#app-android .android-id-subtitle").html(a.id);
   $("#app-android .android-avatar IMG").attr("src", a.getImageProfileTimestamp());
   $("#app-android .android-traits").html(
        a.archetypeEmoji + a.archetype +", "+
        a.personalityEmoji + a.personality +", "+
        a.traitEmoji + a.trait
    );
}
function tab_load_android_tab_android_androids(){
    App.LoadApp("androids");
}

function tab_load_android_tab_android_edit(){
    app_android_form_populate();
    
}





function android_action(){
    var action = $(this).attr('data-action');
    var app = App.GetCurrent();
    var id = app.GetParam(id);
    var android = Android.getFromEphemeral(id);
    if(android === null) return;
    var fn = "android_action_"+action;
//    console.log("fn "+fn);
    if(typeof window[fn] === "function") window[fn](android);
}

function app_android_get_current_android(o){
    var app = App.GetCurrent();
    var id = app.GetParam(id);
    if(!isEmpty(o)){
        id = Android.getAndroidIdFromObject(o);
    }
    var a = Android.getFromEphemeral(id);
    return a;
}



function app_android_select_android(id){
   var a = Android.getFromEphemeral(id);
   if(a === null) return;
   var app = App.GetCurrent();
   app.SetParam(id);
   var app = new App("android");
   app.SetParam(id);
   
}







function app_androids_form_fields(){
    return ["age","chat","description","firstmessage","chargender","pronouns","firstName","id","lastName", "voiceElevenlabs", "voiceLocal"];
}



function app_android_form_field_get(k){
    var o = $(".android-form .android-data[data-android-field='"+k+"']");
    return o;
}
function app_android_form_field_get_val(k){
    var o = app_android_form_field_get(k);
    if(o.hasClass("form-select")){
        return (o.find("option:selected").attr("value"));
    }
    return o.val();
}
function app_androids_form_set_field(k, v){
    var o = app_android_form_field_get(k);
    if(o.length < 1) return;
    o.val(v);
    o.trigger("change");
}

function app_android_collect_data(){
    var A = app_android_get_current_android();
    var androidFields = app_androids_form_fields();
    for(var k of androidFields){
        A[k] = app_android_form_field_get_val(k);
    }
    A.postConstructor();
    return A;
}

function app_android_form_populate(){
    var A = app_android_get_current_android();
    if(A.isInScene()){
        $(".app").addClass("is-present").removeClass("is-away");
        var androidFields = app_androids_form_fields();
        for(var k of androidFields){
            app_androids_form_set_field(k, A[k]);
        }
    } else {
        $(".app").removeClass("is-present").addClass("is-away");
    }
    
    
}

function app_android_goto_profile(o){
    var android_id = Android.getAndroidIdFromObject(o);
    character_load_profile(android_id);
    modals_close_all();
}

function app_android_body_save(o){
    var android_id = Android.getAndroidIdFromObject(o);
    var A = Android.getFromEphemeral(android_id);
    aevent({action:"query", context:"android", query:"saveBody", android:A.id, callback: 'app_android_body_save_finished' });
    modals_close_all();
}
function app_android_body_photo(){
    var A = app_android_get_current_android();
    aevent({action:"query", context:"android", query:"saveBodyPhoto", android:A.id, callback: 'app_android_body_photo_finished'});
}

function app_android_body_save_finished(){
    aemessage(Language.getTranslated("Character saved!"));
}

function app_android_body_photo_finished(){
    
    var A = app_android_get_current_android();
    A.RefreshImage(A.getImageProfile());
}

function app_android_scene_load(o){
    var android_id = Android.getAndroidIdFromObject(o);
    var A = Android.getFromEphemeral(android_id);
    aevent({action:"query", context:"android", query:"loadToScene", android:A.id});
    modals_close_all();
    app_android_update_android_current_position(android_id, true);
}

function app_android_load_in_person(o){
    if(isEmpty(SELECTED_PERSON)){
        aemessage(Language.getTranslated("No Person atom is selected to be replaced!"));   
        return;
    }
    var android_id = Android.getAndroidIdFromObject(o);
    var A = Android.getFromEphemeral(android_id);
    aevent({action:"query", context:"android", query:"loadInPerson", android:A.id});
    modals_close_all();
    app_android_update_android_current_position(android_id, true);
}


function app_android_add(o){
    var $cancel = Language.getTranslated("cancel");
    var $confirm = Language.getTranslated("confirm");
     $.confirm({
        theme: 'material',
        title: Language.getTranslated('Add model?'),
        content: Language.getTranslated("The character will be added as a new model in this scene. Continue?"),
        columnClass: 'col-md-12',
        buttons: {
            [$cancel]: function () {

            },
            [$confirm]: function () {
                app_android_scene_load(o);
            },
        }
    });
    
    
}

function app_android_swap(o){
    var $cancel = Language.getTranslated("cancel");
    var $confirm = Language.getTranslated("confirm");
     $.confirm({
        theme: 'material',
        title: Language.getTranslated('Swap model?'),
        content: Language.getTranslated("The selected model in the scene will be replaced with this character. Continue?"),
        columnClass: 'col-md-12',
        buttons: {
            [$cancel]: function () {

            },
            [$confirm]: function () {
                app_android_replace_in_person(o);
            },
        }
    });
    
    
}
function app_android_unload_in_person(o){
    var android_id = Android.getAndroidIdFromObject(o);
    var A = Android.getFromEphemeral(android_id);
    aevent({action:"query", context:"android", query:"unloadInPerson", android:A.id});
    modals_close_all();
}
function app_android_replace_in_person(o){
    if(isEmpty(SELECTED_PERSON)){
        aemessage(Language.getTranslated("No Person atom is selected to be replaced!"));   
        return;
    }
    var android_id = Android.getAndroidIdFromObject(o);
    var A = Android.getFromEphemeral(android_id);
    
    aevent({action:"query", context:"android", query:"replaceInPerson", android:A.id});
    character_unselect();
    modals_close_all();
    app_android_update_android_current_position(android_id, true);
}


function app_android_scene_remove(o){
    var android_id = Android.getAndroidIdFromObject(o);
    var p = Person.getPersonByAndroidId(android_id);
    if(isEmpty(p)) return;
    modals_close_all();
    aevent({action:"sceneAtomAction", action2:"delete", atom:p.id});
    app_android_update_android_current_position(android_id, false);
}

function app_android_form_save(isDirect = false){
    var A = app_android_collect_data();
    aevent({action:"androidSave",direct: isDirect, android:A.serialize()});
    modals_close_all();
    aemessage(Language.getTranslated("Character saved!"));
}

function app_android_form_delete(o){
    var android_id = Android.getAndroidIdFromObject(o);
    modals_close_all();
    
    var $cancel = Language.getTranslated("cancel");
    var $confirm = Language.getTranslated("confirm");
    
    $.confirm({
        theme: 'material',
        title: Language.getTranslated('Delete this character?'),
        content: Language.getTranslated("Warning! This is will delete the character and its settings and info from disk. This action is irreversible!"),
        columnClass: 'col-md-12',
        buttons: {
            [$cancel]: function () {

            },
            [$confirm]: function () {
                app_android_form_delete_yes(android_id);
            },
        }
    });
    
}
function app_android_form_delete_yes(android_id){
    //aevent({action:"sceneAtomAction", action2:"delete", atom:android_id});
    aevent({action:"androidDelete", androidId:android_id, callback: "app_android_form_delete_confirm"});
}

function app_android_form_delete_confirm(){
    App.LoadApp("androids", function(){App.changeTab("tab_androids_list")});
}

function app_android_form_more(o){
    var android_id = Android.getAndroidIdFromObject(o);
    character_load_profile(android_id);
    
//    
//    var A = Android.getFromEphemeral(android_id);
//    
//    $(".android-actions.android .android-avatar IMG").attr('src',A.getImageProfileTimestamp());
//    $(".android-actions.android .android-name").html(A.getName());
//    $(".android-actions.android").attr("data-androidid", A.id);
//    app_android_update_android_position($(".android-actions.android"), A);
//    update_selected_person_name();
//    $.dialog({
//        backgroundDismiss: true,
//        title: '',
//        columnClass: 'col-md-12',
//        content: $(".popup-android-actions").html()
//    });
    
    
}


function app_android_add_character_bar(){
    var el = $(".character-bar-container-demo").html();
    $(".character-bar-placeholder").html(el);
}













var timeout_app_android_start_recording;
function app_android_start_recording() {
    if ($("#app").hasClass("recording"))
        return;
    $("#app").addClass("recording");
    clearTimeout(timeout_app_android_start_recording);
    timeout_app_android_start_recording = setTimeout(app_android_stop_recording, 16 * 1000);
    aevent({action: "interactionRecord"});
}

function app_android_stop_recording() {
    $("#app").removeClass("recording");
}

function app_android_load_character_card(){
    var A = app_android_get_current_android();
    aevent({action:"query", context:"android", query:"loadCharacterCard", android:A.id, callback: 'app_android_receive_character_card' });
}

function app_android_receive_character_card(data){
    if(typeof data === "string"){
        data = JSON.parse(data);
    }
    if(isEmpty(data)) return;
    
    $("#character-personality").val("");
    if(typeof data.description !== "undefined"){
        $("#character-personality").val(data.description);
    }
    $("#character-chat").val("");
    if(typeof data.mes_example !== "undefined"){
        $("#character-chat").val(data.mes_example);
    }
    
    $("#character-first-message").val("");
    if(typeof data.first_mes !== "undefined"){
        $("#character-first-message").val(data.first_mes);
    }
    
    $("#character-first-name").val("");
    $("#character-last-name").val("");
    if(typeof data.name !== "undefined"){
        var splitname = data.name.split(" ");
        var first_name = splitname.shift();
        var last_name = splitname.length > 0 ? splitname.join(" ") : "";
        $("#character-first-name").val(first_name);
        $("#character-last-name").val(last_name);
    }
    
    console.log("app_android_receive_character_card", data);
}TPL["android"] = `
<div class="app android" id="app-android">
    <ul class="nav nav-tabs app-tabs" >

        <li class="nav-item">
            <a class="nav-link t tab-character-bar" data-bs-toggle="tab" data-bs-target="#tab-android-profile" >Profile</a>
        </li>

        <li class="nav-item">
            <a class="nav-link t tab-character-bar" href="#" data-bs-toggle="tab" data-bs-target="#tab-android-edit">Edit</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t tab-character-bar" href="#" data-bs-toggle="tab" data-bs-target="#tab-android-advanced">Advanced</a>
        </li>



    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">

            <div class="tab-pane fade" id="tab-android-profile">
                <div class="container-fluid profile-backtop">
                    <div class="container">
                        <!--                    <div class="row">
                                                <div class="col-6"></div>
                                                <div class="col-6 text-end">
                                                    <a class="select-app" data-app="androids" href="">< Back to all characters</a>
                                                </div>
                                            </div>-->
                        <div class="row">
                            <div class="col-4">
                                <div class="android-avatar android-custom-photo android-body-photo"><img class="w-100" src="" /></div>
                            </div>
                            <div class="col-8">
                                <h4 class="android-name"></h4>
                                <div class="android-id-subtitle"></div>
                                <div class="on-location-present">
                                    <div class="location-status location-present t">In scene</div>
                                </div>
                                <!--<h5 class="android-traits-container">Main traits: <span class="android-traits"></span></h5>-->
                            </div>
                        </div>

                        <div class="android-profile-main-buttons">
                            <div class="row on-location-away g-2">
                                <div class="col-6"><div class="btn btn-sm btn-primary android-scene-load w-100"><span class="material-symbols-outlined">add</span><span class="t">Add</span></div></div>
                                <div class="col-6"><div class="on-character-selected w-100"><div class="btn btn-sm btn-secondary android-swap w-100"><span class="material-symbols-outlined">sync</span><span class="t">Replace</span></div></div> </div>
                            </div>



                            <!--                        <div class="col-4">
                                                        <div class="t btn btn-primary android-body-photo">Take photo</div>
                                                    </div>
                                                    <div class="col-4">
                                                        <div class="t btn btn-primary android-body-save">Save</div>
                                                    </div>-->
                        </div>

                        <div class="row android-action">

                        </div>
                    </div>
                </div>
            </div>






            <div class="tab-pane fade character-bar-tab" id="tab-android-edit">
                <div class="character-bar-placeholder"></div>
                <div class="android-present">
                    <div class="container">
                        <div class="android-form">


                            <div class="row settings-row aesearchitem"  style="display: none">
                                <div class="col-5">
                                    <label class=" aesearchtext">Character ID:</label>
                                </div>
                                <div class="col-6 ">
                                    <input  class="android-data form-text w-100" data-android-field="id" type="text" disabled="disabled"/>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The character ID is the unique identifier of each character.</div>
                            </div>

                            <div class="row">
                                <div class="col-12">
                                    <h4 class="t section-title">Info</h4>
                                </div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class=" aesearchtext t ">First name:</label>
                                </div>
                                <div class="col-6 ">
                                    <input id="character-first-name"  class="android-data form-text keyboard w-100" data-android-field="firstName" type="text" maxlength="16"/>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The first name of the character.</div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class=" aesearchtext t">Last name:</label>
                                </div>
                                <div class="col-6 ">
                                    <input id="character-last-name"  class="android-data form-text keyboard w-100" data-android-field="lastName" type="text" maxlength="16"/>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The last name of the character.</div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class=" aesearchtext t">Age:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="ae-range form-range android-data" data-android-field="age" min="18" max="99" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The age of the character.</div>
                            </div>
                            
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class=" aesearchtext t">Role:</label>
                                </div>
                                <div class="col-6 ">
                                    <input  class="android-data form-text keyboard w-100" data-android-field="role" type="text" maxlength="20"/>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The role or job or title of the character.</div>
                            </div>
                            
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class=" aesearchtext t">Gender:</label>
                                </div>
                                <div class="col-6 ">
                                    <input  class="android-data form-text keyboard w-100" data-android-field="chargender" type="text" maxlength="20"/>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The gender of the character.</div>
                            </div>
                            
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class=" aesearchtext t">Pronouns:</label>
                                </div>
                                <div class="col-6 ">
                                    <input  class="android-data form-text keyboard w-100" data-android-field="pronouns" type="text" maxlength="20"/>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The pronouns of the character.</div>
                            </div>

                            <div class="row"><div class="col-12"><hr /></div></div>
                            <div class="row">
                                <div class="col-12">
                                    <h4 class="t section-title">Personality</h4>
                                </div>
                            </div>


                            <div class="row settings-row aesearchitem">
                                <div class="col-11">
                                    <label class=" aesearchtext t">Description:</label>
                                </div>

                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Description of this character. Use <b>&lt;AI&gt;</b> or <b>{{char}}</b> for the character name. Use <b>&lt;You&gt;</b> or <b>{{user}}</b> for your name.</div>
                                <div class="col-12">
                                    <textarea id="character-personality" class="android-data form-textarea keyboard w-100" data-android-field="description" maxlength="4096" style="height:150px;"></textarea>
                                </div>
                                <div class="col-12">
                                    <div class="btn btn-sm btn-secondary t load-character-card">Load from PNG character card</div>
                                </div>
                            </div>


                            <div class="row settings-row aesearchitem">
                                <div class="col-11">
                                    <label class=" aesearchtext t">Chat example:</label>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">An example chat sequence that helps direct the AI of the android when chatting with you. </div>
                                <div class="col-12 ">
                                    <textarea id="character-chat"  class="android-data form-textarea keyboard w-100" data-android-field="chat" maxlength="1024" style="height:100px;"></textarea>
                                </div>
                            </div>
                            
                             <div class="row settings-row aesearchitem">
                                <div class="col-11">
                                    <label class=" aesearchtext t">First message:</label>
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">The first message of the character when reloading the discussion. </div>
                                <div class="col-12 ">
                                    <textarea id="character-first-message"  class="android-data form-textarea keyboard w-100" data-android-field="firstmessage" maxlength="512" style="height:100px;"></textarea>
                                </div>
                            </div>



                            <div class="row"><div class="col-12"><hr /></div></div>
                            <div class="row">
                                <div class="col-12">
                                    <h4 class="t section-title">Voice</h4>
                                </div>
                            </div>



                            <div class="row settings-row" >
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">ElevenLabs Voice:</label>
                                </div>
                                <div class="col-7">
                                    <input type="text" id="elevenlabsselectedvoice" class="form-text mt-0 keyboard android-data" data-android-field="voiceElevenlabs" />
                                </div>
                                <div class="col-12">
                                    <a id="elevenlabsvoicesget" class="t">List voices</a>
                                    <a id="elevenlabsvoicestest" class="t">Test</a>
                                </div>
                                <div class="col-12" id="elevenlabsvoices">
                                    <div class="elevenlabsvoice hover-bright demo"></div>
                                </div>
                            </div>


                            <div class="row settings-row">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Local voice:</label>
                                </div>
                                <div class="col-7">
                                    <input type="text" id="localselectedvoice" class="form-text mt-0 keyboard android-data" data-android-field="voiceLocal"   />
                                </div>
                                <div class="col-12">

                                    <a id="localvoicesget" class="t">List voices</a>
                                    <a id="localvoicestest" class="t">Test</a>
                                </div>
                                <div class="col-12" id="localvoices">
                                    <div class="localvoice hover-bright demo"></div>
                                </div>
                            </div>



                        </div>
                    </div>
                    <div class="container-fluid  container-header ae-form-submit py-4 mt-5">
                        <hr />
                        <div class="container">
                            <div class="row">
                                <div class="col-12 setting-info mb-1 t">When saving, the character will be updated with the current personality settings and the current look.</div>
                                <div class="col-12 setting-info mb-3 t">Use the quick save button to skip taking the profile photo.</div>
                            </div>
                            <div class="row">
                                <div class="col-6">
                                    <div class="t btn btn-secondary btn-sm android-btn-save-direct">Quick save</div>
                                </div>
                                <div class="col-6 text-end">
                                    <div class="t btn btn-primary android-btn-save">Save</div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="android-away">
                    <div class="container">
                        <div class="row my-3">
                            <div class="col col-12">
                                <h5 class="t">Can't edit because this character is not in the scene.</h5>
                            </div>
                        </div>
                    </div>
                </div>
            </div>



            <div class="tab-pane fade character-bar-tab" id="tab-android-advanced">
                <div >
                    <div class="character-bar-placeholder"></div>
                    <div class="container ">

                        <div class="row ">
                            <div class="col-12 py-2">
                                <div class="t btn btn-sm btn-danger android-btn-delete">Delete character</div>
                            </div>
                            
                            <div class="col-12  py-2">
                                <div class="on-character-selected ">
                                    <div class="t btn btn-sm btn-primary android-load-in-person">Load character in selected body</div>
                                </div>
                            </div>
                            <div class="col-12 py-2">
                                <div class="on-character-selected ">
                                    <div class="t btn btn-sm btn-primary android-swap">Force reload</div>
                                </div>
                            </div>
                        </div>

                    </div>

                </div>

            </div>




        </div>
    </div>

</div>
`;$(document).ready(function () {

});

META["android"] = {
    title: "Character",
    titleButtons: ["close"],
    icon: "aeternum",
    skipHome: true
};$(document).ready(function () {
    app_androids_init();
});

function app_androids_init() {
   
//    $("#app").on("mousedown", ".android-btn-next", app_androids_next_android);
//    $("#app").on("mousedown", ".android-btn-buy", app_androids_buy_android);
    //$("#app").on("change",".android-form input, .android-form select",app_android_form_refresh );
    $("#app").on("mousedown",".androids-list .android-item",function(){character_load_profile($(this).attr("data-android-id"))});
    $("#app").on("mousedown",".aeandroid-select",function(){
        var android_id = $(this).hasClass("aeandroid") ? $(this).attr("data-android") : $(this).parents(".aeandroid").attr("data-android");
        if(android_id === undefined )return;
        character_load_profile(android_id);
    });
    
    $("#app").on("mousedown",".androids-create", function(){
        if(EPHEMERAL.queries.androids_list.androids.length >= EPHEMERAL.vamdata.VAR_MAX_ALLOWED_CHARACTERS ){
            aemessage(Language.getTranslated("All character slots are already used."))
            return;
        }
        var gender = $(this).attr('data-gender');
        app_androids_create(gender);
    });
    
  
}


function app_androids_create(gender){
    var A = new Android("", gender);
    aevent({action:"androidCreate", android:A.serialize(), callback: "app_android_create_finished"});
   
}
function app_android_create_finished(id){
    character_load_profile(id);
    aemessage(Language.getTranslated("Character created!"));    
}

function app_androids_prepare(html) {
}

function app_androids_postprepare() {
//    app_androids_init_manufacturers();
}

function app_androids_cron_second() {
}


function tab_load_androids(){
}
function tab_load_androids_tab_androids_list(){
    var event = {action:"query",context:"androids", query:"list", callback:"callback_androids_list"};
    event = aephemeral_callback(event);
    aevent(event);
    
    
}


function tab_load_androids_tab_androids_buy(){
 
}

function callback_androids_list(ctx, data){
    if(isEmpty(data)) return;
    if(typeof data === 'string') data = JSON.parse(data);
    EPHEMERAL.queries[ctx] = data;
    app_androids_load_list();
}
function app_androids_load_list(){
    var $table = $('#androids-list-table');
    var data = [];
    
    App.setLoading(true);    
    if(!EPHEMERAL.queries.androids_list) return;
    if(!EPHEMERAL.queries.androids_list.androids) return;
    if(Object.keys(EPHEMERAL.queries.androids_list.androids).length < 1) return;
    for(var a of EPHEMERAL.queries.androids_list.androids){
        var android = new Android(a);
        data.push({
            id: android.id,
            avatar: '<img class="avatar '+(android.isInScene() ? "location-present" : "location-away")+'" style="max-height:120px;max-width:20vw;" src="'+android.getImageProfileTimestamp()+'" />',
            name: '<span class="name-first">'+android.firstName +'</span><span class="name-last">'+android.lastName+'</span>',
//            title: android.title,
            mainstats: android.isInScene() ? '<div class="location-status location-present t">'+Language.getTranslated("In scene")+'</div>' : '<div class="location-status location-away t">'+Language.getTranslated("Away")+'</div>' ,
        });
    }
    
    $table.bootstrapTable({data: data});
    $(".search-input").addClass("keyboard");
    app_init_keyboards();
}

function formatAdjectiveStat(s,n){
    var col = parseInt(n/10);
    return '<div class="adjective-stat adjective-col-'+col+'"><span>'+s+'</span><div class="bckg-holder"><div class="bckg" style="width:'+n+'%;"></div></div></div>';
}
function androids_list_table_rowstyle(row,index){
    return {classes: "aeandroid"};
}
function androids_list_table_rowattributes(row, index){
    return {
      'data-android': row.id,
    };
}

TPL["androids"] = `
<div class="app" id="app-androids">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-androids-list" >Characters</a>
        </li>
        <!--        <li class="nav-item">
                    <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-androids-2" >Link</a>
                </li>-->
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-androids-create" >Create</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content ">
            <div class="tab-pane fade  pb-5 mb-5" id="tab-androids-list">
                <div class="container g-0">
                    <div class="app-loading">
                        <div class="lds-default"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
                    </div>
                    <div class="app-notloading container">

                        <div class="row">
                            <div class="col-12 p-3">
                                <table id="androids-list-table" class="aetable" data-row-attributes="androids_list_table_rowattributes" data-row-style="androids_list_table_rowstyle"   >
                                    <thead>
                                        <tr>
                                            <th data-field="avatar" data-class="aeandroid-select" ></th>
                                            <th data-field="name" data-sortable="true"  data-class="aeandroid-select" data-searchable="true" ><span class="t">Name</span></th>
                                            <th data-field="role" data-sortable="true" ><span class="t">Role</span></th>
                                            <th data-field="mainstats" data-sortable="false"><span class="material-symbols-outlined bck-icon">place</span></th>
                                        </tr>
                                    </thead>
                                </table>
                            </div>
                        </div>



                    </div>
                </div>
            </div>

            <div class="tab-pane fade  pb-5 mb-5" id="tab-androids-create">
                <div class="container">
                    <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Create a new character</h4></div></div>
                    <div class="on-character-selected">
                        <div class="row">
                            <div class="col-12 setting-info t">Creates a new ALIVE character from the selected model.</div>
                        </div>
                        <div class="row settings-row ">
                            <div class="col-12 ">
                                <div class="t btn btn-sm btn-primary androids-create" data-gender="0">Create new character</div>
                            </div>
                        </div>
                    </div>
                    <div>
                        <div class="on-character-notselected">
                            <div class="row">
                                <div class="col-12 setting-info t">Select a VAM person in the scene to transform to a new ALIVE character.</div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["androids"] = {
    title: "Characters",
    titleButtons: ["close"],
    icon: "aeternum",
    devOnly: false
};$(document).ready(function () {
    music_app_init();
});

function music_app_init(){
    $("#app").on("mousedown","#music-playlists .entry", function(e){
        var name = $(this).attr('data-name');
        $("#music-playlists .entry.selected").removeClass("selected");
        music_select_playlist(name);
    });
    
    $("#app").on("mousedown","#app-music .play-button-previous", function(e){
        music_previous();
    });    
    $("#app").on("mousedown","#app-music .play-button-next", function(e){
        music_next();
    });    
    $("#app").on("mousedown","#app-music .play-button-play", function(e){
        music_play();
    });
    $("#app").on("mousedown","#app-music .play-button-pause", function(e){
        music_pause();
    });
    $("#app").on("mousedown","#app-music .play-button-stop", function(e){
        music_stop();
    });
    
//    $("#app").on("mousedown", "#music-tab-menu-playlist",function(e){
//        music_populate_playlist();
//    });
    
    $("#app").on("change", "#music-progress", function(e){
        var val = $(this).val();
        music_change_seek(val);
        $("#music-progress").addClass("manual-changed").attr('data-manual', 3);
    });
     $("#app").on("change", "#app-music .music-volume", function(e){
        var val = $(this).val();
        music_change_volume(val);
    });
    $("#app").on("mousedown","#music-playlist .entry",function(e){
        var song = $(this).attr("data-id");
        music_select_song(song);
    });
    $("#app").on("mousedown","#app-music .play-modes", function(e){
        var o = $("#app-music  .play-mode.selected");
       var max = 3;
       var k = parseInt($(o).attr('data-k'));
       var next = ++k % max + 1;
       $("#app-music  .play-mode.selected").removeClass('selected');
       var n = $("#app-music .play-mode[data-k='"+next+"']");
       n.addClass('selected');
       music_change_play_mode(n.attr("data-mode"));
    });
    
    
}


function tab_load_music_music_tab_2(){
    music_populate_playlist();
}


function app_music_postprepare(){
    music_prepare_playlists();
}

function app_music_update_second(){
    if($("#app-music").length < 1) return;
    set_url_from_options({action: "getscenedata", data: "documentReady"});
    $("#app-music .music-controls .time-current.minutes").html(Math.floor(EPHEMERAL.vamscene.music.currentTime/60))
    var s = Math.floor(EPHEMERAL.vamscene.music.currentTime%60);
    if(s < 10) s= "0"+s;
    $("#app-music .music-controls .time-current.seconds").html(s);
    
    $("#app-music .music-controls .time-total.minutes").html(Math.floor(EPHEMERAL.vamscene.music.totalTime/60))
    var s = Math.floor(EPHEMERAL.vamscene.music.totalTime%60);
    if(s < 10) s= "0"+s;
    $("#app-music .music-controls .time-total.seconds").html(s);
    
    var song = music_get_clean_song_title(EPHEMERAL.vamscene.music.song);
    if(song === "") song = "---";
    $("#app-music .song-title").html(song);
    
    var volume = parseFloat(EPHEMERAL.vamscene.music.volume);
    $("#app-music .music-volume").val(volume);
    
    
    if($("#music-progress").hasClass("manual-changed")){
        var m = parseInt($("#music-progress").attr('data-manual'))-1;
        $("#music-progress").attr("data-manual",m);
        if(m <= 0) $("#music-progress").removeClass("manual-changed")
    } else {
        var percent = (EPHEMERAL.vamscene.music.currentTime/EPHEMERAL.vamscene.music.totalTime) * 100;
        if(EPHEMERAL.vamscene.music.enabled.toLowerCase()!="true") percent = 0;
        $("#music-progress").val(percent);
    }
    
    if(isTrue(EPHEMERAL.vamscene.music.enabled)){
        if(!$("#app-music").hasClass("playing")) $("#app-music").addClass("playing");
    } else {
        if($("#app-music").hasClass("playing")) $("#app-music").removeClass("playing");
    }
    
    if(!$("#app-music .entry[data-name='"+EPHEMERAL.vamscene.music.playlist+"']").hasClass("selected")){
        $("#app-music .entry.selected").removeClass('selected');
        $("#app-music .entry[data-name='"+EPHEMERAL.vamscene.music.playlist+"']").addClass('selected');
        
        
    }
    
    
    if($("#app-music-background").attr('data-playlist')!=EPHEMERAL.vamscene.music.playlist){
        $("#app-music-background").attr('data-playlist', EPHEMERAL.vamscene.music.playlist);
        var imgurl = $("#music-playlists .entry[data-name='"+EPHEMERAL.vamscene.music.playlist+"'] .cover").attr("src");
        $("#app-music-background").css("background-image","url('"+imgurl+"')");
    }
    if(!$("#app-music .play-mode[data-mode='"+EPHEMERAL.vamscene.music.playmode+"']").hasClass("selected")){
        $("#app-music .play-mode.selected").removeClass('selected');
        $("#app-music .play-mode[data-mode='"+EPHEMERAL.vamscene.music.playmode+"']").addClass('selected');
    }
    
    if(!$("#music-playlist .entry[data-id='"+EPHEMERAL.vamscene.music.currentSongId+"']").hasClass("selected")){
        $("#music-playlist .entry.selected").removeClass("selected");
        $("#music-playlist .entry[data-id='"+EPHEMERAL.vamscene.music.currentSongId+"']").addClass("selected");
    }
    
        if(!Settings.getBool("sttMusicAnimation")){
            if($("#app-music").hasClass("music-animation")) $("#app-music").removeClass("music-animation");
            if(!$("#app-music").hasClass("music-noanimation")) $("#app-music").addClass("music-noanimation");
        } else {
            if(!$("#app-music").hasClass("music-animation")) $("#app-music").addClass("music-animation");
            if($("#app-music").hasClass("music-noanimation")) $("#app-music").removeClass("music-noanimation");
        }
    
}


function app_music_on_home_append(element){
    if(isTrue(EPHEMERAL.vamscene.music.enabled)) element.addClass("app-with-sound");
    return element;
}

function music_get_clean_song_title(name){
    var song = name.replace(".mp3.optimized.mp3","");
    song = song.replace(".mp3","");
    return song;
}
function music_prepare_playlists(){
    var destination = $("#music-playlists");
    var el = destination.find(".demo");
   
    $.each(EPHEMERAL.vamdata.music,function(name,playlist){
        var o = el.clone();
        o.removeClass("demo");
        o.attr('data-name', name)
        o.find(".cover").attr('src', music_playlist_get_cover(playlist));
        o.find('.title').html(playlist.name);
        o.find('.songscount span').html(playlist.songsCount);
        if(destination.find(".entry.selected").length < 1) o.addClass("selected");
        destination.append(o);
        
    });
    
}


function music_populate_playlist(){
    var destination = $("#music-playlist");
    var el = destination.find(".demo");
    
    destination.find(".entry").each(function(){
        if($(this).hasClass("demo")) return;
        $(this).remove();
    });
    if(isEmpty(EPHEMERAL.vamdata.music)) return;
    $.each(EPHEMERAL.vamdata.music[EPHEMERAL.vamscene.music.playlist].songs,function(id,song){
        var o = el.clone();
        o.removeClass("demo");
        o.attr('data-name', song["name"])
        o.attr('data-id', id)
        o.find(".number").html(id+".");
        o.find(".title").html(music_get_clean_song_title(song["name"]));
        destination.append(o);
    });
}

function music_playlist_get_cover(playlist){
    return "../../../../AEMusic/"+playlist.name+"/artwork/icon.jpg";
}

function music_clean_song(){
    $("#app-music .song-title").html("---");
    $("#app-music .music-controls .time-current.minutes").html("-");
    $("#app-music .music-controls .time-current.seconds").html("-");
    $("#music-progress").val(0);
}

function music_change_seek(val){
    set_url_from_options({action:"musicSeek", seek:val});
}
function music_change_volume(val){
    set_url_from_options({action:"musicVolume", volume:val});
}
function music_change_play_mode(mode){
    set_url_from_options({action:"musicPlayMode", mode:mode});
}
function music_stop(){
    set_url_from_options({action:"musicStop"});
}
function music_pause(){
    set_url_from_options({action:"musicPause"});
}
function music_play(){
    set_url_from_options({action:"musicPlay"});
    music_clean_song();
}
function music_select_song(song){
    set_url_from_options({action:"musicSong", song:song});
    music_clean_song();
}
function music_previous(){
    set_url_from_options({action:"musicPrevious"});
    music_clean_song();
}
function music_next(){
    set_url_from_options({action:"musicNext"});
    music_clean_song();
}
function music_select_playlist(name){
    music_clean_song();
    var o = $("#music-playlists .entry[data-name='"+name+"']");
    o.addClass("selected");
    set_url_from_options({action:"musicSelectPlaylist", playlist:name});
}TPL["music"] = `
<div id="app-music" class="app">
    
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#music-tab-1" >Playlists</a>
        </li>
        <li class="nav-item">
            <a id="music-tab-menu-playlist" class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#music-tab-2" >Songs</a>
        </li>
    
<!--        <li class="nav-item">
            <a id="music-tab-settings" class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#music-tab-3" >Settings</a>
        </li>-->
        
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div id="app-music-background"></div>
        <div class="music-controls container">
            <div class="row">
                <div class="col-1"></div>
                <div class="col-2 play-button play-button-previous"><span class="material-symbols-outlined">skip_previous</span></div>
                <div class="col-2 play-button play-button-play"><span class="material-symbols-outlined">play_arrow</span></div>
                <div class="col-2 play-button play-button-stop"><span class="material-symbols-outlined">stop</span></div>
                <div class="col-2 play-button play-button-next"><span class="material-symbols-outlined">skip_next</span></div>
                <div class="col-2 play-button play-modes">
                    <span class="play-mode material-symbols-outlined selected" data-mode="shuffle" data-k="1">shuffle</span>
                    <span class="play-mode material-symbols-outlined" data-mode="order" data-k="2">arrow_right_alt</span>
                    <span class="play-mode material-symbols-outlined" data-mode="loop" data-k="3">loop</span>
                </div>
            </div>
            <div class="row">
                <div class="col-12 song-title">-</div>
            </div>
            <div class="row">
                <div class="col-3 text-end p-0">
                    <span class="minutes time-current"></span>:<span class="seconds time-current "></span> /
                    <span class="minutes time-total"></span>:<span class="seconds time-total"></span></div>
                <div class="col-6"><input type="range" class="form-range form-range-full" min="0" max="100" step="0.5" id="music-progress" value="0"></div>
                <div class="col-3 text-start"><input type="range" class="form-range form-range-full music-volume" min="0" max="1" step="0.05"></div>
            </div>
            
        </div>
        <div class="tab-content">
            <div class="tab-pane fade" id="music-tab-1">
                <div class="container">
                    <div id="music-playlists" class="list row">
                        <div class="col-6 col-md-3 entry demo">
                            <div class="row"><div class="col-12"><img src="" class="cover" /></div></div>
                            <div class="row"><div class="col-12"><div class="title"></div></div></div>
                            <div class="row"><div class="col-12"><div class="songscount"><span></span> songs</div></div></div>
                        </div>
                    </div>
                </div>
            </div>
            
            <div class="tab-pane fade" id="music-tab-2">                
                <div id="music-playlist" class="list container">
                    <div class="entry row demo">
                        <div class="col-1 number"></div>
                        <div class="col-11 title"></div>
                    </div>
                </div>
            </div>
            
           
            
            <div class="tab-pane fade" id="music-tab-3">                
                <div id="music-settings" class="list container">
                    <div class="row settings-row">
                        <div class="col-5">
                            <label class="t form-check-label t">Animations:</label>
                        </div>
                        <div class="col-7 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttMusicAnimation" />
                        </div>
                    </div>
                </div>
            </div>
            
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["music"] = {
    title: "Music",
    titleButtons: ["close"],
    icon: "fun"
};$(document).ready(function () {
    app_posing_init_click();
    app_posing_init_actions();
    app_posing_init_handpose_click();
});

function app_posing_init_handpose_click(){
    $("#app").on("mousedown",".posing-hands-list-item",function(){
        var pose = $(this).attr("data-pose");
        var hand = $(this).attr("data-hand");
        aevent({action: "changeHandPoseCustom", pose: pose, hand: hand});
    });
}
function app_posing_get_vals() {
    return [0, 50, 100];
}
function app_posing_init_hands() {
    var destination = $("#posing-hands-list");
    var demo = destination.find('.posing-hands-list-item');
    var items = app_posing_hand_get_categories();
    for (var k of items) {
        var left = demo.clone();
        var right = demo.clone();
        left.removeClass("demo");
        right.removeClass("demo");
        left.addClass("left");
        right.addClass("right");
        var img = "resources/handposes/full/" + k + ".jpg";
        left.find("IMG").attr("src", img);
        right.find("IMG").attr("src", img);
        left.attr("data-pose",k).attr("data-hand","left");
        right.attr("data-pose",k).attr("data-hand","right");

        destination.append(right);
        destination.append(left);
    }
}


function app_posing_hand_get_categories() {
    return ["open", "fist", "hj", "thumbup", "scratch", "middlefinger", "rock", "insert", "point", "point2", "relaxed", "relaxed2", "palm", "hj2", "hold","v"];
}

function app_posing_init_actions() {
    $("#app").on("input", "#person-pose-rotation", function (e) {
        if (throttled("app_posing_init_actions", 50))
            return;
        app_posing_action_changed_rotation($(this).val());
    });
    $("#app").on("change", "#person-pose-rotation", function (e) {
        app_posing_action_changed_rotation($(this).val());
    });
    $("#app").on("mousedown", "#person-pose-rotation-angles .btn", function (e) {
        var val = parseFloat($(this).attr("data-val"));
        var angle = (parseFloat($("#person-pose-rotation").val()) + val) % 360;
        if(angle < 0) angle+=360;
        if ($(this).hasClass("direct"))
            angle = val;
        $("#person-pose-rotation").val(angle);
        app_posing_action_changed_rotation(angle, true);
    });

    $("#app").on("mousedown", "#person-pose-move-actions .btn", function (e) {
        var val = $("#person-pose-distance").val();
        var direction = $(this).attr('data-val');
        app_posing_action_changed_position(direction, val)
    });
    
    $("#app").on("mousedown",".modelling-action", function(e){
        var action = $(this).attr('data-action');
        aevent({action:"query", context:"modelling", query: "setModellingAction",value:action});
    });
    
    $("#app").on("change", ".modelling-setting-on", app_posing_modelling_autochanged);
}
function app_posing_action_changed_rotation(angle, direct) {
    aevent({action: "poseRotation", value: angle, direct: direct});
}
function app_posing_action_changed_position(direction, val) {
    aevent({action: "poseMove", value: val, direction: direction});
}
function app_posing_populate_categories() {
    var destination = $("#poses-categories");
    var demo = destination.find(".poses-category-item.demo");
    var poses = JSON.parse(EPHEMERAL.vamdata.poses);
    var keys = Object.keys(poses).reverse();
    if (keys.length < 1)
        return;
    for (var key of keys) {
        var o = demo.clone();
        o.attr("data-posefolder", key);
        o.removeClass("demo");
        o.html(app_posing_get_pose_name(key));
        destination.append(o);
    }

}


function tab_load_posing_tab_posing_body(){
    aevent({action:"aliveGetData" });
}

function tab_load_posing_tab_posing_modelling(){
    app_posing_modelling_loading(true);
}
function app_posing_modelling_autochanged(){
    aevent({
        action:"query", 
        context:"modelling", 
        query: "setModellingAuto",
        valueOn: $(".modelling-setting-on").is(':checked')
    });
    
}
function app_posing_modelling_loading(){
    App.setLoading(false);    
    var event = aephemeral_callback({action:"query", context:"modelling", context2:character_get_selected(), query: "getModellingStatus", callback: "app_posing_modelling_loaded" });
    aevent(event);
}

function app_posing_modelling_loaded(ctx, data){
    if(typeof data === "string") data = JSON.parse(data);
    EPHEMERAL.queries[ctx] = data; 
    App.setLoading(true);
    var on = isTrue(data.on);
    $(".modelling-setting-on").attr('checked', on ? "checked" : null);
    
}

function app_posing_get_pose_name(s) {
    switch (s) {
        case "AES-Crouching":
            s="Crouching";
            break;
        case "AES-Lying":
            s= "Lying";
            break;
        case "AES-Sitting":
            s = "Sitting";
            break;
        case "AES-Standing":
            s = "Standing";
            break;
    }
    return Language.getTranslated(s);
}

function app_posing_populate_poses() {
    var destination = $("#posing-poses-list");
    var demo = destination.find(".posing-pose-item.demo");
    var poses = JSON.parse(EPHEMERAL.vamdata.poses);
    var keys = Object.keys(poses).reverse();
    if (keys.length < 1)
        return;
    for (var key of keys) {
        var posesCount = parseInt(poses[key]);
        for (var i = 1; i <= posesCount; i++) {
            var poseid = i.toString().padStart(3, '0');
            var o = demo.clone();
            o.removeClass("demo");
            o.attr("data-posefolder", key);
            o.attr("data-poseid", poseid);
            o.find(".pose-label").html( poseid);
            o.find(".img").css('background-image', "url('resources/poses/" + key + "/sprite.jpg'");
            var x = (i-1)%10;
            var y = Math.floor((i-1)/10);
            var deltay = Math.ceil(posesCount/10);
            deltay = 100 / (deltay-1);
            o.find(".img").css("background-position-x",(x*11.111111)+"%").css("background-position-y",(y*deltay)+"%");
            destination.append(o);
        }
    }
    $(".poses-category-item[data-posefolder='AES-Standing']").first().trigger("mousedown");
}


function app_posing_init_click() {
    $("#app").on("mousedown", "#tab-posing-hands .finger-button", function (e) {
        var finger = parseInt($(this).attr('data-button'));
        var newhand = $(this).parents('.hand').attr('data-hand');
        var vals = app_posing_get_vals();
        var person = new Person(character_get_selected());
        if (person.isEmpty())
            return;
        var current = parseInt(person.getData().hands[newhand][finger]);
        var index = vals.indexOf(current) + 1;
        if (index >= vals.length)
            index = 0;
        var newval = vals[index];
        var data = {action: "setFingers"};
        for (var hand of ["left", "right"]) {
            var o = $("#tab-posing-hands .hand-" + hand);
            for (var i = 1; i <= 5; i++) {
                var val = parseInt(o.attr('data-finger' + i)) || 0;
                if (i === finger && hand === newhand)
                    val = newval;
                data[hand + "-f" + i] = val;
            }
        }

        aevent(data);
    });


    $("#app").on("mousedown", ".poses-category-item", function (e) {
        var folder = $(this).attr('data-posefolder');
        var isAll = folder === "All";
        $(".poses-category-item.selected").removeClass("selected");
        $(this).addClass("selected");

        $("#posing-poses-list .posing-pose-item").each(function () {
            if ($(this).hasClass("demo"))
                return;
            if (isAll) {
                $(this).show();
            } else {
                if ($(this).attr('data-posefolder') === folder) {
                    $(this).show();
                } else {
                    $(this).hide();
                }
            }
        });

    });

    $("#app").on("mousedown", ".posing-pose-item", function (e) {
        var posefolder = $(this).attr("data-posefolder");
        var poseid = $(this).attr("data-poseid");
        aevent({action: "changePose", posefolder: posefolder, poseid: poseid});
    });

}

function app_posing_cron_second() {
    var vals = app_posing_get_vals();
    var person = new Person(character_get_selected());
    if (person.isEmpty())
        return;
    if (isEmpty(person.getData()))
        return;
    for (var hand of ["left", "right"]) {
        var o = $("#tab-posing-hands .hand-" + hand);
        for (var i = 1; i <= 5; i++) {
            var cls = "f" + i + "-" + person.getData().hands[hand][i];
            if (!o.hasClass(cls)) {
                for (var oldcls of vals)
                    o.removeClass("f" + i + "-" + oldcls);
                o.addClass(cls);
                o.attr('data-finger' + i, person.getData().hands[hand][i]);
            }
        }
    }

}

function app_posing_postprepare() {
    set_url_from_options({action: "appReadyPosing"});
    app_posing_populate_objects();
    app_posing_populate_categories();
    app_posing_populate_poses();
    app_posing_init_hands();
    app_posing_init_position();
}

function app_posing_init_position(){
    $("#person-pose-rotation").val(Person.getSelectedPerson().getFloat("rot_y"));
}
function app_posing_prepare(html) {

}


function app_posing_objects_received_js(datastring) {
    EPHEMERAL.posing_objects = JSON.parse(datastring);
    app_posing_populate_objects();
}

function app_posing_object_actions() {
    return ["sit", "sleep", "stand"];
}


function sortObjectsByDistance(inputObject) {
    const sortedObjects = [];
    const objectKeys = Object.keys(inputObject).sort();

    objectKeys.forEach(key => {
        const currentObject = inputObject[key];
        const currentObjectDistance = parseFloat(currentObject.distance);
        currentObject.distance = currentObjectDistance;
        currentObject.key = key;
        sortedObjects.push(currentObject);
    });

    sortedObjects.sort((a, b) => a.distance - b.distance);

    return sortedObjects;
}

function app_posing_populate_objects() {
    if (isEmpty(EPHEMERAL.posing_objects))
        return;
    if ($("#tab-posing-objects").length < 1)
        return;
    var destination = $("#posing-objects-list");
    destination.find(".item.new").remove();
    var object_actions = app_posing_object_actions();

    var sorted = sortObjectsByDistance(EPHEMERAL.posing_objects.objects);

    for (var obj of sorted) {
        var obj = EPHEMERAL.posing_objects['objects'][obj.key];
        var el = destination.find(".item.demo").clone();
        el.removeClass("demo");
        el.attr('data-atomid', obj.key);
//        el.find(".distance").html(roundToDecimalPlaces(obj.distance,1)+"m");
        el.find('.name').html(obj.parent + " (" + obj.key + ")");
        el.addClass("new");

        for (var object_action of object_actions) {
            if (isTrue(obj[object_action])) {
                var el_btn = el.find(".actions .btn.demo").clone();
                el_btn.attr('data-action', object_action);
                el_btn.removeClass("demo");
                el_btn.html(object_action);
                el.find(".actions").append(el_btn);
            }
        }
        destination.append(el);
    }



}

TPL["posing"] = `
<div class="app" id="app-posing">
    <ul class="nav nav-tabs app-tabs" >
        <!--         <li class="nav-item">
                    <a class="nav-link t active" data-bs-toggle="tab" data-bs-target="#tab-posing-objects" >Quick posing</a>
                </li>-->
        <li class="nav-item">
            <a class="nav-link t " data-bs-toggle="tab" data-bs-target="#tab-posing-body" >Body</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t " data-bs-toggle="tab" data-bs-target="#tab-posing-poses" >Pose</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t " data-bs-toggle="tab" data-bs-target="#tab-posing-modelling">Modeling</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t " data-bs-toggle="tab" data-bs-target="#tab-posing-general">Position</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-posing-hands" >Hands</a>
        </li>
        <!--        <li class="nav-item">
                    <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Link</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-3" >Link</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link t disabled">Disabled</a>
                </li>-->
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">


            <div class="tab-pane fade actions-button pb-5" id="tab-posing-body">

                <div class="container mt-3">
                    <div class="row text-center">
                        <div class="col col-4">
                            <h5 class="t">Action</h5>
                        </div>
                        <div class="col col-4">
                            <h5 class="t">Speed</h5>
                        </div>
                        <div class="col col-4">
                            <h5 class="t">Power</h5>
                        </div>
                    </div>
                    <div class="row">

                        <div class="col col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionBJ" data-aeliveeffect="MotionBJ">
                                <div class="card-body p-0 t">BJ</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdBjSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdBjPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">

                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionRideGentle" data-aeliveeffect="MotionRideGentle">
                                <div class="card-body p-0 t">Ride</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRideGentleSpeed" min="0.1" max="3" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRideGentlePower" min="0.1" max="3" step="0.01">
                        </div>
                    </div>

                    <div class="row">

                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionThrust" data-aeliveeffect="MotionThrust">
                                <div class="card-body p-0 t">Thrust</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdThrustSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdThrustPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>
                    <div class="row">

                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionHipside" data-aeliveeffect="MotionHipside">
                                <div class="card-body p-0 t">Hip side</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdHipsideSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdHipsidePower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>


                    <div class="row">

                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionTwerk" data-aeliveeffect="MotionTwerk">
                                <div class="card-body p-0 t">Twerk</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdTwerkSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdTwerkPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>


                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionHeadbop" data-aeliveeffect="MotionHeadbop">
                                <div class="card-body p-0 t">Head bop</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdHeadbopSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdHeadbopPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionVibe" data-aeliveeffect="MotionVibe">
                                <div class="card-body p-0 t">Vibe</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdVibe2Speed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdVibe2Power" min="0.1" max="2" step="0.01">
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-4 subitem">Vibe: head</div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdVibe2Speed2" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdVibe2Power2" min="0.1" max="2" step="0.01">
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-4 subitem">Vibe: chest</div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdVibe2Speed3" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdVibe2Power3" min="0.1" max="2" step="0.01">
                        </div>
                    </div>


                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionChesttwister" data-aeliveeffect="MotionChesttwister">
                                <div class="card-body p-0 t">Breasts</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdChesttwisterSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdChesttwisterPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionChestgrind" data-aeliveeffect="MotionChestgrind">
                                <div class="card-body p-0 t">Chest Grind</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdChestgrindSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdChestgrindPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionBootygrind" data-aeliveeffect="MotionBootygrind">
                                <div class="card-body p-0 t">Booty</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdBootygrindSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdBootygrindPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionLefthandjob" data-aeliveeffect="MotionLefthandjob">
                                <div class="card-body p-0 t">Lhand job</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLefthandjobSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLefthandjobPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionRighthandjob" data-aeliveeffect="MotionRighthandjob">
                                <div class="card-body p-0 t">Rhand job</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRighthandjobSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRighthandjobPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionLefthandrub" data-aeliveeffect="MotionLefthandrub">
                                <div class="card-body p-0 t">Lhand rub</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLefthandrubSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLefthandrubPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                                <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionRighthandrub" data-aeliveeffect="MotionRighthandrub">
                                <div class="card-body p-0 t">Rhand rub</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRighthandrubSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRighthandrubPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>


                    <div class="row">
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionLefthandslap" data-aeliveeffect="MotionLefthandslap">
                                <div class="card-body p-0 t">Lhand slap</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLefthandslapSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLefthandslapPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionRighthandslap" data-aeliveeffect="MotionRighthandslap">
                                <div class="card-body p-0 t">Rhand slap</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRighthandslapSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRighthandslapPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionFeetjob" data-aeliveeffect="MotionFeetjob">
                                <div class="card-body p-0 t">Feet job</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLeftfootjobSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLeftfootjobPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

 

                    <div class="row">
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionLeftfootrub" data-aeliveeffect="MotionLeftfootrub">
                                <div class="card-body p-0 t">Lfoot rub</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLeftfootrubSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdLeftfootrubPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-4">
                            <div class="card aecard aeliveeffect aequery" data-context="effects" data-query="toggle" data-query-effect="MotionRightfootrub" data-aeliveeffect="MotionRightfootrub">
                                <div class="card-body p-0 t">Rfoot rub</div>
                            </div>
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRightfootrubSpeed" min="0.1" max="2" step="0.01">
                        </div>
                        <div class="col col-4">
                            <input type="range" class="form-range aealiveslider aealiveslider-range" data-aealiveslider="tmpCmdRightfootrubPower" min="0.1" max="2" step="0.01">
                        </div>
                    </div>



                    <div class="row">
                        <div class="col-12 action-buttons-container">
                            <button class="t btn btn-primary aeurl" data-aeurl-action="turnOffAllMotions">Stop all</button>
                        </div>
                    </div>

                </div>


            </div>


            <div class="tab-pane fade pb-5" id="tab-posing-modelling">
                <div class="container mt-3">

                    <div class="app-loading">
                        <div class="lds-default"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
                    </div>
                    <div class="app-notloading">

                       
                        <div class="row">
                            <div class="col-md-3 col-6 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Upper body">Upper body</div>
                            </div>


                            <div class="col-md-3 col-6 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Lower body">Lower body</div>
                            </div>


                            <div class="col-md-2 col-3 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Head">Head</div>
                            </div>



                            <div class="col-md-2 col-3 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Arms">Hands</div>
                            </div>
                            <div class="col-md-2 col-3 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Left arm">L.Arm</div>
                            </div>
                            <div class="col-md-2 col-3 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Right arm">R.Arm</div>
                            </div>

                            <div class="col-md-2 col-3 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Legs">Legs</div>
                            </div>
                            <div class="col-md-2 col-3 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Left leg">L.Leg</div>
                            </div>
                            <div class="col-md-2 col-3 mb-2">
                                <div class="t btn btn-sm btn-primary w-100 modelling-action" data-action="Right leg">R.Leg</div>
                            </div>
                        </div>


                        <div class="">
                            <div class="row settings-row">
                                <div class="col col-7">
                                    <h3>Auto Modelling</h3>
                                </div>
                                <div class="col-5 form-check form-switch text-end">
                                    <input class="form-check-input  modelling-setting-on float-end" type="checkbox" role="switch" data-aesetting="" />
                                </div>
                            </div>



                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Min Duration:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeDuration"  min="1" max="60" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls how many seconds before switching to a new modelling pose. A random value is picked between min and max.</div>
                            </div>
                            
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Max Duration:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeDurationMax"  min="1" max="60" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls how many seconds before switching to a new modelling pose. A random value is picked between min and max.</div>
                            </div>
                            
                            
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Min Transition:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeSpeedMin"  min="0.1" max="120" step="0.01">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls how fast the transition from one pose to another happens. For each body part a value is selected between the min and max values.</div>
                            </div>
                            
                            <div class="row settings-row aesearchitem">
                                <div class="col-5">
                                    <label class="t form-check-label aesearchtext">Max Transition:</label>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeSpeedMax"  min="0.1" max="120" step="0.01">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls how fast the transition from one pose to another happens. For each body part a value is selected between the min and max values.</div>
                            </div>


                            <div class="row settings-row aesearchitem">
                                <div class="col-3">
                                    <label class="t form-check-label aesearchtext">Head:</label>
                                </div>
                                <div class="col-2">
                                    <div class="form-check form-switch">
                                    <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAutoposeHead">
                                    </div>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeHeadChance"  min="1" max="100" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls if the model will modify the head pose when auto posing. The slider controls the percent chance for this body part to change.</div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-3">
                                    <label class="t form-check-label aesearchtext">Chest:</label>
                                </div>
                                <div class="col-2">
                                    <div class="form-check form-switch">
                                        <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAutoposeChest">
                                    </div>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeChestChance"  min="1" max="100" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls if the model will modify the chest pose when auto posing. The slider controls the percent chance for this body part to change.</div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-3">
                                    <label class="t form-check-label aesearchtext">Hands:</label>
                                </div>
                                <div class="col-2">
                                    <div class="form-check form-switch">
                                    <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAutoposeHands">
                                    </div>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeHandsChance"  min="1" max="100" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls if the model will modify the hands poses when auto posing. The slider controls the percent chance for this body part to change.</div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-3">
                                    <label class="t form-check-label aesearchtext">Hip:</label>
                                </div>
                                <div class="col-2">
                                    <div class="form-check form-switch">
                                    <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAutoposeHip">
                                    </div>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeHipChance"  min="1" max="100" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls if the model will modify the hip pose when auto posing. The slider controls the percent chance for this body part to change.</div>
                            </div>

                            <div class="row settings-row aesearchitem">
                                <div class="col-3">
                                    <label class="t form-check-label aesearchtext">Legs:</label>
                                </div>
                                <div class="col-2">
                                    <div class="form-check form-switch">
                                    <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAutoposeLegs">
                                    </div>
                                </div>
                                <div class="col-6">
                                    <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staAutoposeLegsChance"  min="1" max="100" step="1">
                                </div>
                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                <div class="col-12 settings-info">Controls if the model will modify the legs poses when auto posing. The slider controls the percent chance for this body part to change.</div>
                            </div>
                        </div>

                    </div>
                </div>
            </div>

            <div class="tab-pane fade pb-5" id="tab-posing-general">
                <div class="container">
                    <div class="row">
                        <div class="row mt-3">
                            <div class="col-12"><h4 class="t section-title">ROTATE CHARACTER</h4></div>
                        </div>
                        <div class="row">
                            <div class="col-3">
                                <label class="t form-check-label t" >Angle:</label>
                            </div>
                            <div class="col-9">
                                <input type="range" class="form-range" id="person-pose-rotation" value="0"  min="0" max="360" step="1">
                            </div>
                        </div>
                        <div class="row" id="person-pose-rotation-angles">

                            <div class="col-2 p-0">
                                <div class="t btn btn-primary w-100" data-val="-90">-90</div>
                            </div>
                            <div class="col-2 p-0">
                                <div class="t btn btn-primary w-100" data-val="-45">-45</div>
                            </div>
                            <div class="col-2 p-0">
                                <div class="t btn btn-primary w-100" data-val="-22">-22</div>
                            </div>
                            <div class="col-2 p-0">
                                <div class="t btn btn-primary w-100" data-val="22">+22</div>
                            </div>
                            <div class="col-2 p-0">
                                <div class="t btn btn-primary w-100" data-val="45">+45</div>
                            </div>
                            <div class="col-2 p-0">
                                <div class="t btn btn-primary w-100" data-val="90">+90</div>
                            </div>
                            <div class="col-6 p-0 mt-3">
                                <div class="t btn btn-primary w-100 direct" data-val="0">0</div>
                            </div>
                            <div class="col-6 p-0 mt-3">
                                <div class="t btn btn-primary w-100" data-val="180">Turn around</div>
                            </div>
                        </div>

                        <div class="row mt-3">
                            <div class="col-12"><h4 class="t section-title">MOVE CHARACTER</h4></div>
                        </div>
                        <div class="row">
                            <div class="col-3">
                                <label class="t form-check-label t" >Distance:</label>
                            </div>
                            <div class="col-9">
                                <input type="range" class="form-range" id="person-pose-distance" value="0.5"  min="0.1" max="3" step="0.01">
                            </div>
                        </div>
                        <div class="row" id="person-pose-move-actions">
                            <div class="col-4 p-0 "></div>
                            <div class="col-4 p-0 ">
                                <div class=" btn btn-primary w-100" data-val="w"><span class="material-symbols-outlined">keyboard_arrow_up</span></div>
                            </div>
                            <div class="col-4 p-0 "></div>
                            <div class="col-4 p-0 ">
                                <div class=" btn btn-primary w-100" data-val="a"><span class="material-symbols-outlined">keyboard_arrow_left</span></div>
                            </div>
                            <div class="col-4 p-0 ">
                                <div class=" btn btn-primary w-100" data-val="s"><span class="material-symbols-outlined">keyboard_arrow_down</span></div>
                            </div>
                            <div class="col-4 p-0 ">
                                <div class=" btn btn-primary w-100" data-val="d"><span class="material-symbols-outlined">keyboard_arrow_right</span></div>
                            </div>

                        </div>

                        <div class="row mt-3">
                            <div class="col-12"><h4 class="t section-title">OTHER</h4></div>
                        </div>
                        <div class="row">
                            <div class="col-12 person-buttons-quick-actions">
                                <button class="t btn btn-primary aeurl " data-aeurl-action="aliveResetPose">Reset pose</button>
                                <button class="t btn btn-primary aeurl " data-aeurl-action="aliveRecenterPerson">Move to center</button>
                                <button class="t btn btn-primary aeurl " data-aeurl-action="personComeHere">Move to me</button>
                                <button class="t btn btn-primary aeurl " data-aeurl-action="personDropHands">Drop Hands</button>
                                <button class="t btn btn-primary aeurl " data-aeurl-action="personNodYes">Nod Yes</button>
                                <button class="t btn btn-primary aeurl " data-aeurl-action="personNodNo">Nod No</button>
                            </div>
                        </div>

                    </div>
                </div>
            </div>
            <div class="tab-pane fade  pb-5" id="tab-posing-poses">
                <div class="container">
                    <div class="row">
                        <div class="col" id="poses-side-left">
                            <div id="poses-categories">
                                <div class="poses-category-item demo"></div>
                            </div>
                        </div>
                        <div class="col" id="poses-side-right">
                            <div class="alert uialert alert-secondary t mt-2" role="alert">These are poses edited for procedural animation purposes and optimized for small file size. They will not look as good as the originals. For more accurate posing use VAM's posing system.</div>
                            <div class="row my-3">
                                <div class="col col-4">
                                    <div class="t btn btn-sm btn-primary aeurl" data-aeurl-action="aliveResetPoseStill">Reset</div>
                                </div>
                            </div>
                            <div id="posing-poses-list" class="row">
                                <div class="col col-6 col-md-3 posing-pose-item demo">
                                    <div class="img thumb hover-bright"></div>
                                    <img src="resources/square.jpg" />
                                    <div class="pose-label"></div>
                                </div>
                            </div>
                            <div class="klphgz-ad">
                                <img src="resources/poses/klphgz.jpg" />
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <div class="tab-pane fade pb-5 " id="tab-posing-hands">
                <div class="container">
                    <div class="row">
                        <div class="col-12" id="posing-hands-list">
                            <div class="posing-hands-list-item demo">
                                <img src="" />
                            </div>
                        </div>

                    </div>

                  
                </div>

            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["posing"] = {
    title: "Posing",
    titleButtons: ["close"],
    icon: "person",
    isPerson: true,
    skipHome: true,
};$(document).ready(function () {
    
});

function app_scene_postprepare(){
    scene_populate_atoms();
}

function scene_populate_atoms(){
    if($("#scene-atoms-list").length < 1) return;
    if($("#tab-scene-atoms.active").length < 1) return;
    scene_remove_unused_atoms();
    scene_add_new_atoms();
}

function scene_remove_unused_atoms(){
    $("#scene-atoms-list .entry").each(function(k,v){
        if($(v).hasClass("demo")) return;
        var name = $(v).attr("data-name");
        if(typeof EPHEMERAL.vamscene.atoms[name] === 'undefined'){
            $(v).remove();
        }
    });
}
function scene_add_new_atoms(){
    var last = null;
    
    for(var k in EPHEMERAL.vamscene.atoms){
        let atom = EPHEMERAL.vamscene.atoms[k];
        if($("#scene-atoms-list .entry[data-name='"+atom.name+"']").length <= 0){
            scene_add_new_atom(atom,last);
        } else {
            last = $("#scene-atoms-list .entry[data-name='"+atom.name+"']").first();
        }
    }
}

function scene_add_new_atom(atom,last){
    var dest = $("#scene-atoms-list");
    var o = $("#scene-atoms-list .demo").clone();
    
    o.removeClass("demo");
    o.find(".name").html(atom.name);
    o.find(".type").html(atom.type);
    if(last!= null) o.insertAfter(last);
    else dest.append(o);
    console.log('add '+ atom.name);
}TPL["scene"] = `
<div id="app-scene" class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-scene-atoms" >Atoms</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-3" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t disabled">Disabled</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-scene-atoms">
                <div id="scene-atoms-list" class="list container p-0">
                    <div class="row entry demo">
                        <div class="row top-row">
                            <div class="col-8 name"></div>
                            <div class="col-4 type"></div>
                        </div>
                        <div class="row bottom-row">
                        </div>
                    </div>
                </div>
                
                
            </div>
            <div class="tab-pane fade" id="tab-demo-2">testt2</div>
            <div class="tab-pane fade" id="tab-demo-3">testt3</div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["scene"] = {
    title: "Scene",
    titleButtons: ["close"],
    icon: "system",
    devOnly: true
};$(document).ready(function () {
    settings_init_field_changes();
    settings_init_clicks();
});

var settings_status_kobold = {ok: false};

function settings_init_clicks(){
    $("#app").on("mousedown", ".settings-info-icon", function(e){
        var parent = $(this).parents(".settings-row");
        if(parent.hasClass("info")){
            parent.removeClass("info");
        } else {
            parent.addClass("info");
            settings_add_default_button(parent);
        }
    });
//    
//    $("#app").on("mousedown", ".settings-row .form-check-label", function(e){
//        var parent = $(this).parents(".settings-row");
//        if(parent.hasClass("info")){
//            parent.removeClass("info");
//        } else {
//            parent.addClass("info");
//        }
//    });

    $("#app").on("mousedown",".settings-reset-defaults", app_settings_reset_defaults);
    
    $("#app").on("mousedown", ".setting-reset-default", function(e){
        var val = $(this).attr('data-val');
        var setting = $(this).parents(".row").first().find(".aesetting");
        if(setting === undefined) return;
        if(setting.hasClass("aesetting-color")){
            setting.attr("data-value", val);
            setting.css("background-color", val);
            var fn = $(setting).attr('data-colorpicker-live');
            if(typeof window[fn] === 'function') window[fn](val);
            aesetting_trigger(setting);
        } else if(setting.hasClass("aesetting-toggle")){
            if(val.toString() === "1"){
                setting.prop("checked", true);
            }  else {
                setting.prop("checked", false);
            }
            setting.trigger("change");
        } else {
            setting.val(val).trigger("change");
        }
    });
    
    $("#app").on("mousedown", "#elevenlabsvoicesget", function(e){
        aevent({
            action: "elevenlabsGetVoices"
        });
    });
    
    
    
       $("#app").on("mousedown", ".elevenlabsvoice", function(e){
        var voiceid = $(this).attr('data-voiceid');
        $("#elevenlabsselectedvoice").val(voiceid).trigger("change");
    });
    
    
     $("#app").on("mousedown", "#localvoicesget", function(e){
        aevent({
            action: "localGetVoices"
        });
    });
    
    
     $("#app").on("mousedown", "#localvoicestest", function(e){
        var parent = $(this).parents(".container");
        var android_id = Android.getAndroidIdFromObject($(this));
        aevent({
            action: "localTestVoices",
            voice: parent.find("#localselectedvoice").val(),
            target: android_id
        });
    });
    
     $("#app").on("mousedown", "#elevenlabsvoicestest", function(e){
         var android_id = Android.getAndroidIdFromObject($(this));
        var parent = $(this).parents(".container");
        aevent({
            action: "elevenlabsTestVoices",
            voice: parent.find("#elevenlabsselectedvoice").val(),
            target: android_id
        });
    });
    
    
    $("#app").on("mousedown", ".localvoice", function(e){
        var voiceid = $(this).attr('data-voiceid');
        $("#localselectedvoice").val(voiceid).trigger("change");
    });
    
    
 
}


function settings_add_default_button(o){
    var info = o.find(".settings-info");
    if(info.find(".setting-reset-default").length > 0) return;
    if(info.find("b").length !== 1) return;
    var defaultval= info.find("b").text();
    var el = $('<div class="t btn btn-sm btn-secondary setting-reset-default" data-val="'+defaultval+'">'+Language.getTranslated("Reset to default")+'</div>');
    info.append(el);
}

function app_settings_update_gameplay_values(){
    $(".gameplay-variable-html").each(function(){
        var settingKey = $(this).attr("data-gameplay-variable");
        var v = Settings.getString(settingKey);
        $(this).html(v);
    });
}

function settings_receive_local_voices(data){
    console.log('settings_receive_local_voices', data);
    var data = JSON.parse(data);
    
    if(isEmpty(data)) return;
    var keys = Object.keys(data);
    if(keys.length < 1) return;
    
    var destination = $("#localvoices");
    var demo = destination.find(".demo");
    destination.find(".localvoice").each(function(){
        if($(this).hasClass("demo")) return;
        $(this).remove();
    });
    
    for(var key of keys){
        var voice = data[key];
        var voiceid = data[key];
        var o = demo.clone();
        o.removeClass("demo");
        o.attr('data-voice',voice);
        o.attr('data-voiceid',voiceid);
        o.html(voice);
        destination.append(o);
    }
}


function settings_receive_elevenlabs_voices(data){
    //console.log('settings_receive_elevenlabs_voices', data);
    var data = JSON.parse(data);
    
    if(isEmpty(data)) return;
    if(isEmpty(data.voices)) return;
    var keys = Object.keys(data.voices);
    if(keys.length < 1) return;
    
    var destination = $("#elevenlabsvoices");
    var demo = destination.find(".demo");
    destination.find(".elevenlabsvoice").each(function(){
        if($(this).hasClass("demo")) return;
        $(this).remove();
    });
    
    for(var key of keys){
        var voice = data["voices"][key]["name"];
        var voiceid = data["voices"][key]["voice_id"];
        var o = demo.clone();
        o.removeClass("demo");
        o.attr('data-voice',voice);
        o.attr('data-voiceid',voiceid);
        o.html(voice);
        destination.append(o);
    }
}

function settings_init_field_changes(){
}

function settings_live_colorpicker_backgroundcolor(color){
    aevent({action: "setVamColorMain", value: color});
}
function settings_live_colorpicker_uicolor(color){
    set_ui_color(color);
}

function app_settings_on_aesetting_change(params){
     switch(params.setting){
        case "sttlanguage":
            Language.setLanguage(params.value);
            break;
        case "sttServicesElevenlabsTTS":
            console.log("sttServicesElevenlabsTTS changed");
            tab_load_settings_tab_settings_services();
            break;
    }
}


function app_settings_prepare(html){

    return html;
}

function app_settings_postprepare(){
    
}
function ae_popup_preview_ai_context(msg){
     $.dialog({
        backgroundDismiss: true,
        title: 'Tokens: '+Math.round((msg.length/4)),
        columnClass: 'col-md-12',
        content: '<pre class="generic_text_popup">'+msg+'</pre>'
    });
}





function tab_load_settings_tab_settings_services(){
    app_services_api_get_elevenlabs_models();
    app_services_api_get_elevenlabs_available();
}


function app_services_api_oobabooga(data){
    var ok = isTrue(data);
    var el = $('.ae-api-check[data-api="apiCheckOobabooga"] .api-status');
    app_services_api_add_class(el, ok);
}
function app_services_api_automatic1111(data){
    var ok = isTrue(data);
    var el = $('.ae-api-check[data-api="apiCheckAutomatic1111"] .api-status');
    app_services_api_add_class(el, ok);
}
function app_services_api_tat(data){
    var ok = isTrue(data);
    var el = $('.ae-api-check[data-api="apiCheckTAT"] .api-status');
    app_services_api_add_class(el, ok);
}


function app_services_api_add_class(el, ok){
    el.removeClass("api-on api-off");
    if(ok){
        el.addClass("api-on");
        el.html(Language.getTranslated("Connected"));
    } else {
        el.addClass("api-off");
        el.html(Language.getTranslated("Disconnected"));
    }
}


function app_services_api_get_elevenlabs_models(){
    aevent({action:"query", context:"aeapi", query: "apiGetElevenLabsModels"});
    
}
function app_services_api_get_elevenlabs_available(){
    aevent({action:"query", context:"aeapi", query: "apiGetElevenLabsAvailable"});
}

function app_services_elevenlabsmodels(data){
    var dest = $(".elevenlabsmodels-select");
    dest.find("option").remove();
    if(isEmpty(data)) return;
    if(typeof data === 'string') data = JSON.parse(data);
    if(isEmpty(data.data)) return;
    data = data.data;
    if(isEmpty(data)) return;
    if(Object.keys(data) < 1) return;
    var keys = Object.keys(data);
    
    var el = $('<option value="">Default</option>');
    dest.prepend(el);
    
    for(var key of keys){
       var o = data[key] ;
       if(typeof(o) !== "object") return;
       if(typeof(o.model_id) === "undefined") return;
       if(!isTrue(o.can_do_text_to_speech)) return;
       var selected = "";
       if(o.model_id === Settings.getString("sttServicesElevenlabsModel")) selected= ' selected="selected"';
       var el = $('<option value="'+o.model_id+'" '+selected+'>'+o.name+'</option>');
       dest.append(el);
    }
    
    
}

function app_services_elevenlabsuser(data){
    var o1 = $(".elevenlabs-wordscount-bar .bckg");
    var o2 = $(".elevenlabs-wordscount");
     if(isEmpty(data)) return;
    if(typeof data === 'string') data = JSON.parse(data);
    o1.css("width", "0%");
    o2.html("0/0");
    if(typeof (data.subscription) === "undefined") return;
    
    var total = parseInt(data.subscription.character_limit);
    var count = parseInt(data.subscription.character_count);
    count = (total - count);
    var perc = count/total * 100; 
    o1.css("width", perc+"%");
    o2.html(count+"/"+total);
}

function app_settings_reset_defaults(){
    var $cancel = Language.getTranslated("cancel");
    var $confirm = Language.getTranslated("confirm");
     $.confirm({
        theme: 'material',
        title: Language.getTranslated('Reset settings'),
        content: Language.getTranslated("All of the ALIVE settings will be reset to their default values. Continue?"),
        columnClass: 'col-md-12',
        buttons: {
            [$cancel]: function () {

            },
            [$confirm]: function () {
                aevent({action:"resetSettingsDefaults"});
            },
        }
    });
    
    

}TPL["settings"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <!--        <li class="nav-item">
                    <a class="nav-link t active" data-bs-toggle="tab" data-bs-target="#tab-settings-0" >General</a>
                </li>-->
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-settings-1">Settings</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-settings-alive" >Models</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-settings-chat" >AI</a>
        </li>
         <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-settings-services" >Services</a>
        </li>
      
    </ul>

    <div class="app-content tabbed scrollbar1">
        <!-- GENERAL -->
        <div class="tab-content">

            <!-- SETTINGS -->
            <div class="tab-pane fade  pb-5" id="tab-settings-1">
                <div class="container ">
                    <div class="container mt-3">
                        <div class="row mb-3">
                            <div class="col-1 "><span class="material-symbols-outlined  align-middle">search</span></div>
                            <div class="col-11">
                                <input id="settings-search-settings-general" data-aesearch="#settings-search-list-general" class="keyboard aesearchfilter search-filter keyboard" type="text" />
                            </div>
                        </div>
                    </div>

                    <div id="settings-search-list-general">
                        <div class="row mt-3">
                            <div class="col-12"><h4 class="t">Global settings</h4></div>
                        </div>

                        <div class="row settings-row aesearchitem ">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Language:</label>
                            </div>
                            <div class="col-6">
                                <select class="form-select aesetting aesetting-select language_select" data-aesetting="sttlanguage">
                                    <option value="en">English</option>
                                    <option value="de">Deutsch</option>
                                    <option value="es">Español</option>
                                    <option value="fr">Français</option>
                                    <option value="it">Italiano</option>
                                    <option value="ja">日本語</option>
                                    <option value="ko">한국어</option>
                                    <option value="pt">Português</option>
                                    <option value="ru">Русский</option>
                                    <option value="zh">普通话</option>
                                </select>
                            </div>
                            <div class="col-1 col-helper">
                                <span class="settings-info-icon material-symbols-outlined">help</span>
                            </div>
                            <div class="col-12 settings-info">Language used for the Alive UI. Default is English (<b>en</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Background color:</label>
                            </div>
                            <div class="col-6">
                                <div id="background-color" class="colorpicker aesetting aesetting-color"  data-aesetting="sttvambackgroundcolor" data-colorpicker-live="settings_live_colorpicker_backgroundcolor" data-value="#000000" data-colorpicker-callback=""></div>
                            </div>
                            <div class="col-1 col-helper">
                                <span class="settings-info-icon material-symbols-outlined">help</span>
                            </div>
                            <div class="col-12 settings-info">Changes the background color used in VAM. The default is black (<b>#000000</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">UI Color:</label>
                            </div>
                            <div class="col-6">
                                <div id="setting-ui-color" class="colorpicker aesetting aesetting-color"  data-aesetting="sttUiColor" data-colorpicker-live="settings_live_colorpicker_uicolor" data-value="#000000" data-colorpicker-callback=""></div>
                            </div>
                            <div class="col-1 col-helper">
                                <span class="settings-info-icon material-symbols-outlined">help</span>
                            </div>
                            <div class="col-12 settings-info">This setting changes the accent color of the Alive UI. The default color is purple (<b>#9c23bb</b>).</div>
                        </div>



                        <div class="row settings-row aesearchitem ">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Framerate limit:</label>
                            </div>
                            <div class="col-6">
                                <select class="form-select aesetting aesetting-select" data-aesetting="sttDisplayFPSLimit">
                                    <option value="-1" selected>Unlimited</option>
                                    <option value="20">20</option>
                                    <option value="24">24</option>
                                    <option value="30">30</option>
                                    <option value="45">45</option>
                                    <option value="60">60</option>
                                    <option value="75">75</option>
                                    <option value="90">90</option>
                                    <option value="100">100</option>
                                    <option value="120">120</option>
                                </select>
                            </div>
                            <div class="col-1 col-helper">
                                <span class="settings-info-icon material-symbols-outlined">help</span>
                            </div>
                            <div class="col-12 settings-info">Sets a frame-limit to prevent the GPU running high. For better control this can be done directly from Nvidia control panel. Recommended is 60fps. Default is Unlimited (<b>-1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Desktop FOV:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttvamfov" min="20" max="100" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The default FOV that VAM should use in desktop mode. The default is <b>40</b>.</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Draw Distance:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttvamworldscale" min="5" max="50000" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The maximum distance in meters from the camera allowed for objects to get rendered. If they are outside that range they will not be rendered and you'll see the background color instead. For Alive Home a high value like 50000 is needed for the sky & clouds to render. The vam default is <b>2000</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-4">
                                <label class="t form-check-label aesearchtext">Camera flash:</label>
                            </div>
                            <div class="col-7 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttvamcameraflash">
                            </div>
                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls if there is a flash when taking an a vam photo. By default this is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-4">
                                <label class="t form-check-label aesearchtext">Hide red loading icon:</label>
                            </div>
                            <div class="col-7 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttvamhideloadingicon">
                            </div>
                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Forcefully hides VAM's red loading icon that appears sometimes like when loading sounds. By default this is Enabled (<b>1</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-4">
                                <label class="t form-check-label aesearchtext">Prevent new person overlap:</label>
                            </div>
                            <div class="col-7 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttVamPersonalSpace">
                            </div>
                            <div class="col-1  col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled ALIVE checks for person atom overlap when new person atoms are added, and moves the new person to prevent physics problems. By default this is Enabled (<b>1</b>).</div>
                        </div>




                        <div class="row mt-3">
                            <div class="col-12"><h4 class="t">Desktop controls</h4></div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Enable 1st person (TAB):</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="fpsEnabled">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Alternative controls and logic for 1st person mode when pressing tab, to make it more like a game and less like floating around. The default is Enabled (<b>1</b>)</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Enable character cam (TAB):</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="3rdpersonEnabled">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, when pressing TAB and a caharacter is selected, the camera will go in 3rd person mode. The default is Enabled (<b>1</b>)</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">1st Person FOV:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="fpsFovNormal" min="20" max="100" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The Field of View for First Person mode (when pressing TAB on desktop). The default is <b>60</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">1st Person Height:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="fpsPlayerHeight" min="1" max="2.2" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The player height in meters for First Person mode (when pressing TAB on desktop). The default is <b>1.75</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">1st Person Mouse Sensitivity:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="fpsMouseSensitivity" min="0" max="10" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The mouse sensitivity in First Person mode (when pressing TAB on desktop). The default is <b>0.65</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">1st Person Speed:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="fpsWalkSpeed" min="1" max="10" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The walking speed for First Person mode (when pressing TAB on desktop). The default is <b>3</b>.</div>
                        </div>


                        <div class="row mt-3"><div class="col-12"><h4 class="t">UI</h4></div></div>



                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Desktop UI:</label>
                            </div>
                            <div class="col-6">
                                <select class="form-select aesetting aesetting-select" data-aesetting="stUiDesktop">
                                    <option value="Sidebar" selected>Sidebar</option>
                                    <option value="FloatingSidebar">Floating Sidebar</option>
                                </select>
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The Aeternum UI style for desktop. <b>Sidebar</b> is the default and recommended one.  Floating Sidebar is a mix of the two allowing a more customizable sidebar. Some of the settings for Floating Sidebar have to be done from the normal plugin UI to prevent moving the UI out of view and not being able to move it back.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Sidebar width:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttDesktopUIWidth" min="400" max="1000" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The width for the sidebar UI on desktop. Default is <b>400</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Floating scale:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFloatingScale" min="0.15" max="0.65" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The overall scale of the UI when in a Floating mode. Default is <b>0.5</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Floating width:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFloatingWidth" min="800" max="1600" step="10">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The width of the UI when in a Floating mode. Default is <b>800</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Floating height:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFloatingHeight" min="600" max="1200" step="10">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The height of the UI when in a Floating mode. Default is <b>600</b>.</div>
                        </div>


                        <div class="row mt-3"><div class="col-12"><h4 class="t">VR</h4></div></div>


<!--                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR UI Roomscale mode:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttVrRoomscale">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the VR UI will stay in place in the scene, instead of moving around with the player. Default is Disabled (<b>0</b>).</div>
                        </div>-->

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR UI scale:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFloatingScaleVR" min="0.15" max="0.65" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The overall scale of the UI when in a Floating mode. Default is <b>0.5</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR UI width:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFloatingWidthVR" min="800" max="1600" step="10">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The width of the UI when in a Floating mode. Default is <b>800</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR UI height:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFloatingHeightVR" min="600" max="1200" step="10">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The height of the UI when in a Floating mode. Default is <b>600</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">1st Person VR movement:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttFirstPersonVR">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">An alternative locomotion system in VR with snap turning,faster movement, up-down as crouch/stand. Default is Disabled (<b>0</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR player height:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFirstPersonVRheight" min="-2" max="2" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">VR 1st person player height offset. Default value is <b>0.5</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR movement snap-turn angle:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFirstPersonVRangle" min="1" max="180" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When 1st person VR movement is enabled, this slider controls how much the player snap turns. Default value is <b>30</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR movement speed:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttFirstPersonVRspeed" min="0.25" max="5" step="0.05">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When 1st person VR movement is enabled, this slider controls the speed of the movement. Default value is <b>1</b>.</div>
                        </div>



                        <div class="row settings-row aesearchitem">

                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR laser pointers:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttVRPointers">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Extra pointers that indicate the exact location where the VR hands are pointing.  Default is Disabled (<b>0</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">

                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR voice chat button:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttVRMicrophone">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, if pressing the main trigger on the controller next to your head and a microphone screen is available in the UI, recording will get triggered. Default is Enabled (<b>1</b>)</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VR voice button distance:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttVRMicrophoneKey" min="0.01" max="1" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The distance in meters that he hand must be from the head when pressing trigger for it to trigger voice chat. Default value is <b>0.18</b>.</div>
                        </div>

                        <div class="row mt-3">
                            <div class="col-12"><h4 class="t">VR Haptics</h4></div>
                        </div>

                        <div class="row settings-row aesearchitem">

                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Haptic force field:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttHapticForcefield">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Similiar to my old SPQRHaptics plugin that makes vr controllers vibrate on touch, but remade the feature in a way that simulates a force field for better feedback, rather than vibrate only on initial contact. Default value is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Vibration frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttHapticOccurance" min="0.001" max="1" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the vibration occurrence chance. Default value is <b>0.5</b>.</div>
                        </div>



                        <div class="row mt-3"><div class="col-12"><h4 class="t">Performance</h4></div></div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lower physics rate:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttOptimizePhysicsRate">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option similar to the SPQRPerformance plugin that when enabled turns down the physics rate to 30 physics frames per second to help performance. By default this is Disabled (<b>0</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Anisotropic Filtering:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttAnisotropicFiltering">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Quality setting that makes textures look better at certain angles. By default this is Enabled (<b>1</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Run in background:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttRunInBackground">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls if vam is allowed to run in the background, or if it pauses when minimized. This reduces VAM's GPU usage when the focus is not on the VAM window. By default this is Enabled (<b>1</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Force glutes physics off:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stgForceGlutesOff">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, Alive automatically disables glutes physics on person atoms to increase performance. By default this is disabled (<b>0</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Force breasts physics off:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stgForceBreastsOff">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, Alive automatically disables glutes physics on person atoms to increase performance. By default this is disabled (<b>0</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Auto tongue physics:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stgAutoTonguePhysics">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, Alive automatically disables tongue physics on person atoms to increase performance and activates it back only when tongue is sticking out (tongue length is bigger than 0). By default this is Enabled (<b>1</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Enable Alive LOD Morphs:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttOptimizeOutofviewAlive">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the level of detail of morph changes decreases with distance, improving performance. By default this is Enabed (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Stop Alive when not in view:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttOptimizeOutofviewAlive">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Stops Alive automatic behavior when the person is not in view, to improve performance. By default this is Enabed (<b>1</b>).</div>
                        </div>


                        <div class="row mt-3"><div class="col-12"><h4 class="t">Audio</h4></div></div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Sound volume:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttSoundVolume" min="0" max="1" step="0.05">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">General volume for vam sounds. Default is <b>1</b>.</div>

                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Alive audio:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAliveAudio" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to turn off all sounds produced by Alive person plugins. Default is Enabled (<b>1</b>).</div>

                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Spanking sounds:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAliveSpanking" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to turn off spanking sounds in Alive. Default is Enabled (<b>1</b>).</div>

                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Breathing sounds:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAliveBreathingSounds" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to turn off breathing sounds in Alive. Default is Enabled (<b>1</b>).</div>

                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Moaning sounds:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAliveMoaningSounds" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to turn off moaning sounds in Alive. Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Penetration sounds:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAlivePenetrationSounds" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to control penetration sounds. Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">BJ sounds:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAliveBlowjobSounds" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to control BJ sounds. Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Kissing sounds:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAliveKissingSounds" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to control auto-kissing sounds. Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">UI Sound Effects:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttEnableSFX" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to control Aeternum UI sound effects.  Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">UI SFX Volume:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttSoundFXVolume" min="0" max="1" step="0.05">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Volume for Aeternum UI sound effects.  Default is <b>0.5</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lipsync on:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staLipsyncForce" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to force lipsync to be enabled on characters automatically. Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lipsync volume multiplier:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staLipsyncVolume" min="0.1" max="10" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the default lipsync volume multiplier value for vam models. VAM's default is 5. Alive's default is <b>1</b>.</div>
                        </div>
                        
                        <div class="row mt-3"><div class="col-12"><h4 class="t">Reset settings</h4></div></div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-12">
                                <a class="btn btn-sm t btn-danger settings-reset-defaults">Reset settings to defaults</a>
                            </div>
                        </div>
                        
                    </div>
                </div>
            </div>


            <!-- ALIVE  -->
            <div class="tab-pane fade pb-5" id="tab-settings-alive">
                <div class="container mt-3">

                    <div class="container mt-3">
                        <div class="row mb-3">
                            <div class="col-1"><span class="material-symbols-outlined align-middle">search</span></div>
                            <div class="col-11">
                                <input id="settings-search-settings-alive" data-aesearch="#settings-search-list-alive" class="keyboard aesearchfilter search-filter keyboard" type="text" />
                            </div>
                        </div>
                    </div>

                    <div id="settings-search-list-alive">

                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Automatic behaviour</h4></div></div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Automatically start on all Person objects:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAutoAlive" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled it automatically starts Alive auto behavior on the models in the scene. When it's off, you'll have to manually enable it from the person bottom bar in the UI when you want it on. Default is Enabled (<b>1</b>). <br /><br /> 
                                You can also add AliveAlwaysOn.cslist and AliveAlwaysOff.cslist from the Plugins folder of the var to a Person atom to micromanage which model gets Alive autostarted and which not.</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Males expressions only:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAliveMalesExpressionsOnly" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, male atoms will have less automatic behavior. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Females expressions only:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAliveFemalesExpressionsOnly" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, female atoms will have less automatic behavior. Default is Disabled (<b>0</b>).</div>
                        </div>
                        
                         <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Interactive posing system:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttCompositePosing2" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Enable this for Alive's composite posing system which allows moving multiple body parts and adds feet snapping to the floor . Default is Disabled (<b>0</b>).</div>
                        </div>

                        <!--                        
                                                <div class="row settings-row aesearchitem">
                                                    <div class="col-5">
                                                        <label class="t form-check-label aesearchtext">Futas expressions only:</label>
                                                    </div>
                                                    <div class="col-6 form-check form-switch">
                                                        <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staAliveFutasExpressionsOnly" />
                                                    </div>
                                                    <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                                    <div class="col-12 settings-info">When enabled, futa atoms will have less automatic behavior. Default is Enabled (<b>1</b>).</div>
                                                </div>
                                                
                        -->


                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Automatic behavior settings</h4></div></div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Auto-kiss:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableKissing" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to control auto-kissing. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Enable tongue kissing:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableTongueKissing" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Option to control auto-kissing tongue. Default is Disabled (<b>0</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Kiss distance:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staEnableKissingDistance" min="0" max="1" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Distance at which the autokissing gets detected. Default is <b>0.33</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Automatic hand morphs:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staSmartHands" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that adds more automatic logic to hands and fingers. Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Drop hands:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttAutodropHands" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes the hands automatically drop if not touching anything, at certain angles ( hand much lower than the elbow). Default is Disabled(<b>0</b>).</div>
                        </div>

                        <!--                        <div class="row settings-row aesearchitem">
                                                    <div class="col-5">
                                                        <label class="t form-check-label aesearchtext">Auto drop hands:</label>
                                                    </div>
                                                    <div class="col-6 form-check form-switch">
                                                        <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAutoDropHands" />
                                                    </div>
                                                    <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                                    <div class="col-12 settings-info">When enabled, hands auto drop when they're not touching anything and if they're not above the elbow. Experimental. Default is Disabled (<b>0</b>).</div>
                                                </div>-->



                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Toes movement:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staToesMovement" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes the people with Alive move their toes. Default is Enabled (<b>1</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Mouth auto-open:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttMouthAutoOpen" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes the model open the mouth when touching a lot the chin. Default is Enabled (<b>1</b>).</div>
                        </div>


                        <!--<div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Body vibration:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staJittersEnable" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes characters with the Alive plugin have body vibration, jitters, shaking, for more realism.  Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Body vibration force:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staJittersStrength" min="0" max="5" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strong the body shaking is. The default is <b>1</b>.</div>
                        </div>-->



                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Idle movement:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableIdleBodyMovement" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes characters with the Alive plugin move around their bodies more.  Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Idle movement Extra:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableIdleBodyMovement2" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Extra movement to VAM controllers (green markers) to make the character feel more alive . Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Idle movement force:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staIdleBodyMovementForce" min="0" max="10" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strongly the auto idle body movements go. The default is <b>1</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Idle movement 2 force:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staIdleBodyMovement2Force" min="0" max="10" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strongly the auto idle body movements go. The default is <b>1</b>.</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Breathing chest:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableBreathingChest" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes characters with the Alive plugin have breathing animation on their chests. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Inhale strength:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staBreathingChestInhale" min="0" max="40" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strong the inhale animation is. The default is <b>3</b>. </div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Exhale strength:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staBreathingChestExhale" min="0" max="40" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strong the exhale animation is. The default is <b>6</b>.</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Touch reactions:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableTouchReactions" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled it allows the character to react more to touches.  Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Tease threshold:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staTouchTresholdTease" min="0" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The minimum intensity of touches to be considered Tease touches. For best results you should keep the values in order tease < caress < spank. Default value is <b>0.05</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Caress threshold:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staTouchTresholdCaress" min="0" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The minimum intensity of touches to be considered Caress touches. For best results you should keep the values in order tease < caress < spank. Default value is <b>0.20</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Spank threshold:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staTouchTresholdSpank" min="0" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The minimum intensity of touches to be considered Spank touches. For best results you should keep the values in order tease < caress < spank. Default value is <b>0.65</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Auto blowjob:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAutobj" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes characters with the Alive plugin automatically do blowjob movements when detecting something in their mouths.  Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Auto handjob:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAutohj" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes characters with the Alive plugin automatically do handjob movements when detecting a dildo or a penis in their hands.  Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Auto titjob:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAutotj" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes characters with the Alive plugin automatically do titjob movements when detecting a dildo or a penis next to their chest.  Default is Enabled (<b>1</b>).</div>
                        </div>



                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Auto ride:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAutoride" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes female characters with the Alive plugin automatically do riding movements when detecting deep penetration.  Default is Enabled (<b>1</b>).</div>
                        </div>




                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Enable sweat:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableSweat" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that allows characters with Alive to get their skin more shiny as arousal increases. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Male arouse:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableMaleArouse" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that allows arousal to work also for male/futa characters and drive their erection. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Nipple erection:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableNippleErection" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes nipples increase when arousal increases.  Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Female spread morph:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableLegsSpreadMorph" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes female genitals morphs change when legs are spreading. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Female arouse morph:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableVagArousal" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that changes the female genitals morphs as arousal increases.  Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Arousal speed:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staArouseFactor" min="0" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how fast models gets aroused. The default value is <b>1</b>.</div>
                        </div>

                        <!--                        <div class="row settings-row aesearchitem">
                                                    <div class="col-5">
                                                        <label class="t form-check-label aesearchtext">Sex Auto Align:</label>
                                                    </div>
                                                    <div class="col-6 form-check form-switch">
                                                        <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableSexAutoAlign" />
                                                    </div>
                                                    <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                                    <div class="col-12 settings-info">Controls if Alive tries to align hips & heads for easier sex animation. Experimental. The default value is Disabled (<b>0</b>).</div>
                                                </div>-->




                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Lively Expressions</h4></div></div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Eye movement rate:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staSaccadesRate" min="0" max="100" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the percent chance for eye saccades to happen. The default value is <b>75</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Macro eye movement rate:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staMacrosaccadesRate" min="0" max="100" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the percent chance for macro saccades to happen (depending on context, it's not a constant rate). Macro saccades drive the characters to divert attention around more. The default value is <b>35</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Blink Frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesBlinkChance" min="0.01" max="90" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how often the character will blink. Default value is <b>12</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Blink eyes close value:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesBlinkValue" min="0.01" max="1.2" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the eyes close when blinking. Default value is <b>0.7</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Blink speed min:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesBlinkMin" min="0.01" max="1" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the minimum speed of blinks. Default value is <b>0.25</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Blink speed max:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesBlinkMax" min="0.01" max="1" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the maximum speed of blinks. Default value is <b>0.65</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Eyelids auto-adjustment strength:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesEyelidsFactor" min="0" max="2" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the eyes and eyelids adjust based on the position of the target. Default value is <b>0.75</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Eyelids auto-adjustment offset:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesEyelidsoffset" min="-10" max="10" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the offset used when calculation eyelid auto adjustments for up-down direction. Default value is <b>-2</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Iris adjust on distance:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttlLivelyEyesAutoIrisDistance" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes the eye pupillary distance change based on the distance of the target the model is looking at at. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <!--                    <div class="row settings-row aesearchitem">
                                                <div class="col-5">
                                                    <label class="t form-check-label aesearchtext">Lively Facial Tics:</label>
                                                </div>
                                                <div class="col-6 form-check form-switch">
                                                    <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stlLivelyTics">
                                                </div>
                                                <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                                <div class="col-12 settings-info">Feature that adds more facial tics & procedural face movement. By default this is Enabled (<b>1</b>).</div>
                                            </div>-->
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Facial States:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stlLivelyFacialStates">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature to add more lively general procedural facial animation. By default this is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Facial Strength:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyFacialStrength" min="0.01" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the lively facial animation influences the face. Default value is <b>1</b>.</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Eyes:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stlLivelyEyesOn">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature to add more lively expressions to the eyes. By default this is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Eyes Frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesChance" min="0.01" max="90" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how often the character will change this type of morph. Default value is <b>1</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Eyes Strength:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyEyesFactor" min="0.01" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strongly the character will change this type of morph. Default value is <b>1</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Mouth:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stlLivelyMouthOn">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature to add more lively expressions to the mouth. By default this is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Mouth Frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyMouthChance" min="0.01" max="90" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how often the character will change this type of morph. Default value is <b>1</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Mouth Strength:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyMouthFactor" min="0.01" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strongly the character will change this type of morph. Default value is <b>1</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Brows:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stlLivelyBrowsOn">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature to add more lively expressions to the brows. By default this is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Brows Frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyBrowsChance" min="0.01" max="90" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how often the character will change this type of morph. Default value is <b>1</b>.</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lively Brows Strength:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stlLivelyBrowsFactor" min="0.01" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how strongly the character will change this type of morph. Default value is <b>1</b>.</div>
                        </div>



                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Vision</h4></div></div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Enable vision:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableGaze" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that allows characters with Alive to get their skin more shiny as arousal increases. By default this is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Upper body follow vision:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableGazeBody" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes the chest follow the target . By default this is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Lower body follow vision:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableGazeBodyLower" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes the hip follow the target . By default this is Disabled (<b>0</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Hands follow chest:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableGazeHands" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled the hands will rotate and move around with the chest. By default this is Disabled (<b>0</b>).</div>
                        </div>
                        
                        
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Body bending:</label>
                            </div>
                            <div class="col-6 ">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staBodyBending" min="0" max="3" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the body bends forward and backwards when the models look up and down. By default this is 1 (<b>1</b>).</div>
                        </div>


                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">VAM+</h4></div></div>

<!--                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Shake controllers:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableShakeControllers" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that allows you to toggle body parts of the models by shaking them. If you shake a hand for example it will go limp (Off), if you shake it again it go tense (On).  Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Shake threshold:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="staShakeTreshold" min="4" max="10" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">If controller shaking is enabled, this sliders allows controlling how hard you have to shake for the controller to toggle between on/off.  Default is <b>5</b>.</div>
                        </div>-->
<!--                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Keep feet above floor:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staKeepFeetAboveFloor" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that prevents the character with Alive to have their feet go below the 0 height.  Default is Dsiabled (<b>0</b>).</div>
                        </div>-->
                        <!--<div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Teleport flag:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableTeleport" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Features that allows quickly teleporting and rotating characters with Alive. When enabled there's an extra controller floating above the characters heads (with a hand icon). If you drag that, a flag will apear that you can also rotate (shift+drag on desktop). When you release the flag, the person will get teleported and rotated to that destination. Default is Enabled (<b>1</b>).</div>
                        </div>-->
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Auto tongue:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableAutoTongue" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that makes the tongue have collision disabled by default, and enabled only when mouth collision is detected. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Eye Sparkle:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="staEnableEyeReflection" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that adds a sparkle reflection to the eyes. Unlike normal vam reflections that are static, this reflection moves and varies in an attempt to make eyes more realistic. Default is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">T-pose correct:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="sttTposeAutoCorrect" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Feature that tries to detect when the reset pose happens and drops the hands of the model to a more natural position. Default is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Show ALIVE indicators:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stgAliveIndicator" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Alive indicators are animations in the form of a purple line showing in the scene when selecting characters or objects, to help indicate what was selected. Default is Enabled (<b>1</b>). </div>
                        </div>



                    </div>
                </div>
            </div>




            <!-- CHAT  -->
            <div class="tab-pane fade pb-5" id="tab-settings-chat">
                <div class="container">

                    <div class="container mt-3">
                        <div class="row mb-3">
                            <div class="col-1"><span class="material-symbols-outlined  align-middle">search</span></div>
                            <div class="col-11">
                                <input id="settings-search-settings-alive" data-aesearch="#settings-search-list-chat" class="keyboard aesearchfilter search-filter keyboard" type="text" />
                            </div>
                        </div>
                    </div>

                    <div id="settings-search-list-chat">
                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">AI knowledge</h4></div></div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-11">
                                <label class="t form-check-label aesearchtext">Custom intro:</label>
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 form-check">
                                <textarea class="form-check-input aesetting aesetting-text" type="text" data-aesetting="aiKnowCustom" maxlength="512" style="height:100px;"></textarea>
                            </div>

                            <div class="col-12 settings-info">Custom introduction instructions to send to the AI. Notice: this will be sent to ALL of the AI characters. By default this is empty <b></b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Chat mode:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="aiKnowChat" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the AI will receive instructions that its in a conversation and it should try to reply and keep the conversation going. By default this is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Time awareness:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="aiKnowTime" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the AI will know what day it is, as well as the time. By default this is Enabled (<b>1</b>).</div>
                        </div>

                        <!--                        <div class="row settings-row aesearchitem">
                                                    <div class="col-5">
                                                        <label class="t form-check-label aesearchtext">Clothing awareness:</label>
                                                    </div>
                                                    <div class="col-6 form-check form-switch">
                                                        <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="aiKnowClothing" />
                                                    </div>
                                                    <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                                                    <div class="col-12 settings-info">When enabled, the AI will know what its wearing in vam. By default this is Enabled (<b>1</b>).</div>
                                                </div>-->


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Kinky AI:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="aiKnowKinky" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the AI will receive instructions to be more open to adult themed chat. By default this is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Player info:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="aiKnowPlayer" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the AI will receive the player info. By default this is Enabled (<b>1</b>).</div>
                        </div>
                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Character info:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="aiKnowCharacter" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the AI will receive the character info from the character profile. By default this is Enabled (<b>1</b>).</div>
                        </div>
                         <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">VAM clothing:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="aiKnowCharacterClothing" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the AI will receive the names of the clothing items. By default this is Enabled (<b>1</b>).</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-12">
                                <div class="btn btn-sm btn-secondary t aequery" data-context="androids" data-query="previewAiKnowledge" data-query-callback="ae_popup_preview_ai_context">Preview</div>
                            </div>
                        </div>




                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Chat</h4></div></div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Messages cleanup:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stcMessagesCleanup" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled Alive will try to do cleanup on messages received from the AI, like preventing repetitive loops, incomplete sentences, bad punctuation and some sequences that cause malformed/junk answers. By default this is Enabled (<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">AI message character limit:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcMessagesAiLimit" min="30" max="300" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Target number of characters when generating messages. Default is <b>250</b>.</div>
                        </div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Show chat dialogue box:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stcEnableSpeechBubble" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled it will show the chat messages in a dialogue box next to the character. By default this is Disabled (<b>0</b>).</div>
                        </div>



                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">Automatic behavior</h4></div></div>



                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Touch detection percentage:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAiTouchPercentage" min="0" max="100" step="0.1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls the percentage change for touches to be detected by the AI. There are also some extra restrictions set in place to prevent spamming the AI, so even at 100% not all the touches will be sent to the AI, multiple touches of the same time in a short period of time will be ignored. Default value is <b>15</b>%.</div>
                        </div>



                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Short answer frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcMessagesAiShortFerquency" min="0" max="100" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Percentage chance that the AI is forced to answer with a shorter answer, to try to reduce the AI getting stuck in long messages loop. Default is <b>5</b>%.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Continue answer frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcMessagesContinueFrequency" min="0" max="50" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Percentage chance that the AI is forced to continue with another answer after answering already. Default is <b>5</b>%.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Continue short answer frequency:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcMessagesContinueShortFrequency" min="0" max="50" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Percentage chance that the AI is forced to continue with another answer if the previous answer was very short (25 characters or less). Default is <b>25</b>%.</div>
                        </div>


                        <div class="row mt-3"><div class="col-12"><h4 class="t">Player Info</h4></div></div>


                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Name:</label>
                            </div>
                            <div class="col-6 form-check">
                                <input class="form-check-input aesetting aesetting-text" type="text" data-aesetting="aplName" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">This is the player name used in chat. Default is <b>John</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Gender:</label>
                            </div>
                            <div class="col-6 form-check">
                                <input class="form-check-input aesetting aesetting-text" type="text" data-aesetting="aplGender" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Gender of the player used in chat, to help the AI customize dialogue. Default is <b>male</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Pronouns:</label>
                            </div>
                            <div class="col-6 form-check">
                                <input class="form-check-input aesetting aesetting-text" type="text" data-aesetting="aplPronouns" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Pronouns of the player used in chat, to help the AI customize dialogue. Default is <b>he/him</b>.</div>
                        </div>



                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class=" aesearchtext">Age:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="aplAge" min="18" max="99" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">The age of the player to send to the AI. Default is <b>99</b></div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-11">
                                <label class="t form-check-label aesearchtext">Description:</label>
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 form-check">
                                <textarea class="form-check-input aesetting aesetting-text" type="text" data-aesetting="aplDescription" maxlength="512" style="height:150px;"></textarea>
                            </div>

                            <div class="col-12 settings-info">Add here information you want the AI to always know about you. By default this is empty <b></b>.</div>
                        </div>



                        <div class="row mt-3"><div class="col-12"><h4 class="t section-title">AI LLM Settings</h4></div></div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">AI randomness (temperature):</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAiTemperature" min="0" max="5" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Controls how much the AI is allowed to do answers that are a bit more random. If dynamic temperature is enabled, this is ignored. Default value is <b>0.7</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Use dynamic temperature:</label>
                            </div>
                            <div class="col-6 form-check form-switch">
                                <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="stcEnableDynamicTemperature" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled, the AI temperature will change between the min and max values below to provide more variation to the behavior. By default this is Enabled(<b>1</b>).</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">AI temperature min:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAiTemperatureMin" min="0" max="5" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Minimum value for the dynamic temperature. Default value is <b>0.7</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">AI temperature max:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAiTemperatureMax" min="0" max="5" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Maximum value for the dynamic temperature. Default value is <b>0.9</b>.</div>
                        </div>





                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">LLM Repetition Penalty:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAirepetition_penalty" min="0" max="2" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">LLM repetition_penalty field. Default is <b>1.15</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">LLM Top K:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAitop_k" min="0" max="100" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">LLM top_k field. Default is <b>120</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">LLM Top P:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAitop_p" min="0" max="5" step="0.9">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">LLM top_p field. Default is <b>0.9</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">LLM Min Length:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAimin_length" min="0" max="100" step="1">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">LLM min_length field. Default is <b>10</b>.</div>
                        </div>

<!--                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">LLM Length Penalty:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAilength_penalty" min="0" max="5" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">LLM length_penalty field. Default is <b>1.05</b>.</div>
                        </div>-->

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">LLM Guidance Scale:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAiguidance_scale" min="0" max="5" step="0.01">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">LLM guidance_scale field. Default is <b>1</b>.</div>
                        </div>

                        <div class="row settings-row aesearchitem">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">LLM Truncation Length:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="stcAitruncation_length" min="512" max="32768" step="128">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">LLM truncation_length field. Default is <b>2048</b>.</div>
                        </div>


                    </div>
                </div>
            </div>




            <div class="tab-pane fade pb-5" id="tab-settings-services">
                <div class="container mt-3">

                    <div class="row mt-3">
                        <div class="col-12"><h4 class="t section-title">Text AI</h4></div>
                    </div>


                    <div class="row setting-background">

                        <div class="row settings-row">
                            <div class="col-9">
                                <h3 class="t">oobabooga Text Generation WebUI</h3>
                            </div>
                            <div class="col-3 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="sttServicesTextAI">
                            </div>
                            <div class="col-11 setting-info t">Works offline. Requires running oobabooga's Text generation web UI in the background.</div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">
                                OobaBooga's Text generation web UI needs to be running . Add "--api" to the CMD_FLAGS.txt file in the text generation webui folder to allow Alive to connect to it. Make sure to load a model in the webui, that's the model Alive will use. Default is Disabled (<b>0</b>).
                            </div>
                        </div>
                        <div class="row settings-row ae-api-check" data-api="apiCheckOobabooga" data-callback="app_services_api_oobabooga">
                            <div class="col-3 t">Status:</div>
                            <div class="col-5"><span class="api-status api-off t">Disconnected</span></div>
                            <div class="col-4 text-end"><div class="t btn btn-primary btn-sm ae-api-check-button">Recheck</div></div>
                        </div>
                        <div class="row settings-row aesearchitem aesetting-if-true" data-aesetting="sttServicesTextAI">
                            <div class="col-4">
                                <label class="t form-check-label aesearchtext">API URL:</label>
                            </div>
                            <div class="col-7">
                                <input id="setting-sttServicesOogaBoogaApi" type="text" class="form-text mt-0 aesetting aesetting-text keyboard" data-aesetting="sttServicesOogaBoogaApiUrlNew" />
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">
                                URL of the OobaBooga API. By default it's <b>http://127.0.0.1:5000/</b> which is oobabooga text-generation-webui running locally, on the same PC. But it can be changed to a different url if for example you want to run the AI on different pc on the network.
                            </div>
                        </div>
                        <div class="row settings-row aesearchitem aesetting-if-true" data-aesetting="sttServicesTextAI">
                            <div class="col-4">
                                <label class="t form-check-label aesearchtext">Legacy mode:</label>
                            </div>
                            <div class="col-7 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="sttServicesOogaBoogaLegacy">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">
                                Enable this if you're using an old version of oobabooga text-generation-webui that uses the old style of API (before November 2023). Recommended is to just update text-generation-webui. By default this is <
                            </div>
                        </div>
                    </div>


                    <div class="row mt-3">
                        <div class="col-12"><h4 class="t section-title">Image AI</h4></div>
                    </div>

                    <div class="row setting-background">
                        <div class="row settings-row ">
                            <div class="col-9">
                                <h3 class="t">AUTOMATIC1111</h3>
                            </div>
                            <div class="col-3 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="sttServicesAutomatic1111">
                            </div>
                            <div class="col-11 setting-info t">Works offline. Requires running AUTOMATIC1111 in the background.</div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">
                                <span class="t">Requires installing and running AUTOMATIC1111 in the background. Default is Disabled</span> (<b>0</b>).
                                <p><span class="t">Guide video on YouTube</span>: "ALIVE: Photorealistic screenshots with StableDiffusion"</p>
                            </div>
                        </div>
                        <div class="row settings-row ae-api-check" data-api="apiCheckAutomatic1111" data-callback="app_services_api_automatic1111">
                            <div class="col-3 t">Status:</div>
                            <div class="col-5"><span class="api-status api-off t">Disconnected</span></div>
                            <div class="col-4 text-end"><div class="t btn btn-primary btn-sm ae-api-check-button">Recheck</div></div>
                        </div>

                    </div>





                    <div class="row setting-background">
                        <div class="row settings-row">
                            <div class="col-9">
                                <h3 class="aesearchtext t">Enable AI Vision:</h3>
                            </div>
                            <div class="col-3 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="sttServiceImageaiVision">
                            </div>
                            <div class="col-11 setting-info t">Allows AI vision in chat. Models react to what they see when you press react.</div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">When enabled it allows the AI to react to what it sees. A capture is taken of what the model sees and this image gets analyzed with Automatic1111. Default is Disabled (<b>0</b>).</div>
                        </div>
                        <div class="row settings-row p-3 aesetting-if-true" data-aesetting="sttServiceImageaiVision">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Vision Quality:</label>
                            </div>
                            <div class="col-6">
                                <select class="form-select aesetting aesetting-select" data-aesetting="sttServiceImageaiVisionType">
                                    <option value="clip" selected>High Quality</option>
                                    <option value="deepdanbooru">Low Quality</option>
                                </select>
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">High Quality (CLIP) vision takes more time to analyze but is more accurate. Low Quality (DeepBoru) is fast but what the AI detect is less accurate. For faster speed for High Quality it's recommended in Automation1111 > Settings > Interrogate Options to do the following: <br />
                                <ul>
                                    <li>Lower "Interrogate: minimum description length". This is in how many words the AI describes to itself what it sees. The lower it is, the less the AI sees but the faster it gets. Recommended: 12 </li>
                                    <li>In "CLIP: skip inquire categories" check all toggles so that the AI prevents adding artistic styles words when describing what it sees</li>
                                    <li>Optionally, enable "Interrogate: keep models in VRAM" to increase the speed at the cost of VRAM</li>
                                </ul><br/>
                                Default is <b>clip</b>.
                            </div>


                        </div>


                    </div>







                    <div class="row mt-3">
                        <div class="col-12"><h4 class="t section-title">SPQR TextAudioTool</h4></div>
                        <div class="col-12 setting-info t">Works as an offline feature. Requires running TextAudioTool in the background.</div>
                        <div class="col-12 setting-info t">Needed for offline Text-to-speech and speech-to-text to work.</div>
                    </div>
                    <div class="row settings-row ae-api-check" data-api="apiCheckTAT">
                        <div class="col-3 t">Status:</div>
                        <div class="col-5"><span class="api-status api-off t">Disconnected</span></div>
                        <div class="col-4 text-end"><div class="t btn btn-primary btn-sm ae-api-check-button">Recheck</div></div>
                    </div>


                    <div class="row mt-3">
                        <div class="col-12"><h4 class="t section-title">Text to speech</h4></div>
                    </div>

                    <div class="row setting-background">
                        <div class="row settings-row">
                            <div class="col-9">
                                <h3 class="aesearchtext t">ElevenLabs AI Voices:</h3>
                            </div>
                            <div class="col-3 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="sttServicesElevenlabsTTS">
                            </div>
                            <div class="col-11 setting-info t">Works with an online service, requires an account on elevenlabs.io.</div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Requires an account on elevenlabs.io, works with free accounts too. The api key is unique for each user and appears in the user settings. It allows generating voice files based on that account settings & quota. Default is Disabled (<b>0</b>).</div>
                        </div>

                        <div class="row settings-row aesetting-if-true" data-aesetting="sttServicesElevenlabsTTS">
                            <div class="col-5 pb-3">
                                <label class="t form-check-label aesearchtext">Words available:</label>
                            </div>
                            <div class="col-4">
                                <div class="bckg-holder elevenlabs-wordscount-bar"><div class="bckg" style="background: var(--bs-primary); width:0%;"></div></div>
                            </div>
                            <div class="col-3">
                                <div class="elevenlabs-wordscount">0/0</div>
                            </div>

                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">ElevenLabs API key:</label>
                            </div>
                            <div class="col-6 pb-3">
                                <input type="text" class="form-text mt-0 aesetting aesetting-text keyboard censored" data-aesetting="sttServicesElevenlabsKey" />
                            </div>
                            <div class="col-1 col-helper"></div>
                            <div class="col-11">
                                <label class="t form-check-label aesearchtext">ElevenLabs Model:</label>
                            </div>

                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="row">
                                <div class="col-12 pb-3">
                                    <select class="form-select aesetting aesetting-select elevenlabsmodels-select" data-aesetting="sttServicesElevenlabsModel"  onfocus='this.size = 5;'  onblur='this.size = 1;'  onchange='this.size = 1; this.blur();'>
                                        <option value="">Default</option>
                                    </select>
                                </div>
                                <div class="col-12 settings-info">This is the elevenlabs AI model that will be used. By default Alive will use <b></b>eleven_monolingual_v1 (Eleven English v1).</div>
                            </div>
                        </div>
                        <div class="row settings-row  aesetting-if-true" data-aesetting="sttServicesElevenlabsTTS">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Voice stability:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttServicesElevenlabsStability" min="0" max="1" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Stability level of the elevenlabs AI voice. Default is <b>0.5</b>.</div>
                        </div>
                        <div class="row settings-row aesetting-if-true" data-aesetting="sttServicesElevenlabsTTS">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Voice similarity:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttServicesElevenlabsSimilarity" min="0" max="1" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Similarity boost level of the elevenlabs AI voice. Default is <b>0.5</b>.</div>
                        </div>
                        <div class="row settings-row  aesetting-if-true" data-aesetting="sttServicesElevenlabsTTS">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Voice style:</label>
                            </div>
                            <div class="col-6">
                                <input type="range" class="form-range aesetting aesetting-range" data-aesetting="sttServicesElevenlabsStyle" min="0" max="1" step="0.001">
                            </div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">Style level of the elevenlabs AI voice. Default is <b>0</b>.</div>
                        </div>
                        <div class="row  aesetting-if-true" data-aesetting="sttServicesElevenlabsTTS">
                            <div class="col-5 pb-3">
                                <label class="t form-check-label aesearchtext">ElevenLabs Voice ID:</label>
                            </div>
                            <div class="col-6">
                                <input type="text" id="elevenlabsselectedvoice" class="form-text mt-0 aesetting aesetting-text keyboard" data-aesetting="sttServicesElevenlabsVoice" />
                            </div>
                            <div class="col-1 col-helper"></div>
                            <div class="col-12">
                                <a id="elevenlabsvoicesget" class="t">List voices</a>
                                <a id="elevenlabsvoicestest" class="t">Test</a>
                            </div>
                            <div class="col-12" id="elevenlabsvoices">
                                <div class="elevenlabsvoice hover-bright demo"></div>
                            </div>


                        </div>
                    </div>

                    <div class="row setting-background">
                        <div class="row settings-row">
                            <div class="col-9">
                                <h3 class="t">Local text-to-speech:</h3>
                            </div>
                            <div class="col-3 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="sttServicesLocalTTS">
                            </div>
                            <div class="col-11 setting-info t">Works with offline Windows TTS voices (SAPI4, SAPI5). Requires running the SPQR TextAudioTool in the background.</div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">
                                Requires running the SPQR Text Audio tool for audio to generate. You can find some nice offline voices (IVONA) on deskshare or harposoftware. Default is Disabled (<b>0</b>).
                            </div>
                        </div>
                        <div class="row settings-row aesetting-if-true" data-aesetting="sttServicesLocalTTS">
                            <div class="col-5">
                                <label class="t form-check-label aesearchtext">Local voice:</label>
                            </div>
                            <div class="col-7">
                                <input type="text" id="localselectedvoice" class="form-text mt-0 aesetting aesetting-text keyboard" data-aesetting="sttServicesLocalVoice" />
                            </div>
                            <div class="col-12">

                                <a id="localvoicesget" class="t">List voices</a>
                                <a id="localvoicestest" class="t">Test</a>
                            </div>
                            <div class="col-12" id="localvoices">
                                <div class="localvoice hover-bright demo"></div>
                            </div>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-12"><h4 class="t section-title">Speech to text</h4></div>
                    </div>


                    <div class="row setting-background">
                        <div class="row settings-row">
                            <div class="col-9">
                                <h3 class="t">Local speech-to-text:</h3>
                            </div>
                            <div class="col-3 form-check form-switch text-end">
                                <input class="form-check-input aesetting aesetting-toggle float-end" type="checkbox" role="switch" data-aesetting="sttServicesLocalSpeechtotext">
                            </div>
                            <div class="col-11 setting-info t">Speech recognition that works offline. Requires running the SPQR TextAudioTool in the background.</div>
                            <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                            <div class="col-12 settings-info">
                                Requires running the SPQR Text Audio tool for speech recognition to work. When triggered (clicking on the microphone button) it will try to listen on them main microphone for a few seconds, if it doesn't detect anything it will time out. If the recording goes on for longer than 15s it will cut it there and stop to prevent messages that are too long or getting stuck in recording mode. Default is Disabled (<b>0</b>).
                            </div>
                        </div>
                    </div>

                </div>
            </div>





        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["settings"] = {
    title: "Settings",
    titleButtons: ["close"],
    hideTitle: true,
    skipHome: true,
    icon: "devel"
};


$(document).ready(function () {
    app_settingsinfo_init_search();
    app_settingsinfo_init_alive();
});


function app_settingsinfo_init_search(){
    $("#app").on("keyup","#settingsinfo-search",function(){
        var val = $("#settingsinfo-search").val();
        app_settingsinfo_filter_list(val);
    });
}
function app_settingsinfo_init_alive(){
    $("#app").on("mousedown","#settings-info-alive-submit",function(){
        var p = $("#settings-info-alive-person").val();
        set_url_from_options({action:"alivetest",person:p});
    });
}
function app_settingsinfo_init_api(){
    $("#app").on("mousedown","#settings-info-api-request-submit",function(){
        var p = $("#settings-info-api-request").val();
        apireq_request(p,app_settingsinfo_apireq_response);
        $("#settings-info-api-response").html("");
    });
}

function app_settingsinfo_apireq_response(request){
    $("#settings-info-api-response").html(JSON.stringify(request.response));
}
function app_settingsinfo_filter_list(v){
    v = v.toLowerCase();
    var destination = $("#settingsinfo-list");
    destination.find(".filteredout").removeClass("filteredout");
    destination.find(".item").each(function(k,val){
        if($(val).hasClass("demo")) return;
        var show = false;
        if($(val).find(".var-name").text().toLowerCase().indexOf(v) !== -1) show = true;
        if($(val).find(".var-value").val().toLowerCase().indexOf(v) !== -1) show = true;
        
        if(!show){
            $(val).addClass("filteredout");
        }
    });
}

function app_settingsinfo_prepare(html){
    var destination = html.find("#settingsinfo-list");
    
    for(var k of Object.keys(EPHEMERAL.aesettings)){
        var demo = html.find(".item.demo").clone();
        demo.removeClass("demo");
        demo.find(".var-name").html(k);
        demo.find(".var-value").val(EPHEMERAL.aesettings[k]);
        demo.find(".var-value").attr("data-aesetting",k);
        destination.append(demo);
    }

    return html;
}



function app_settingsinfo_debug(data){
    $("#settingsinfo-debug textarea").val(JSON.stringify(data));
}TPL["settingsinfo"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item"><a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-demo-1" >Settings Explorer</a></li>
        <li class="nav-item"><a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Debug</a></li>
        <!--<li class="nav-item"><a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-demo-3" >Alive test</a></li>-->
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            
            <div class="tab-pane fade" id="tab-demo-1"> 
                <div id="settingsinfo-list" class="container list">
                    <div class="row search-filter-container">
                            <input id="settingsinfo-search" class="search-filter" type="text" />
                    </div>
                    <div class="demo item row">
                        <div class="col-5 var-name fs-8"></div>
                        <div class="col-7"><input class="var-value aesetting aesetting-text" type="text" /></div>
                    </div>
                </div>
            </div>
            
             <div class="tab-pane fade" id="tab-demo-2"> 
                <div id="settingsinfo-debug" class="container">
                    <textarea class="w-100" style="height:60vh"></textarea>
                </div>
            </div>
            
             <div class="tab-pane fade" id="tab-demo-3"> 
                <div id="settingsinfo-debug" class="container">
                    <div class="row">
                        Person: <input type="text" value="Person" id="settings-info-alive-person" />
                    </div>
                    <div class="row">
                        <input type="button" class="t btn btn-primary" id="settings-info-alive-submit" value="Test"/>
                    </div>
                </div>
            </div>
            
            <div class="tab-pane fade" id="tab-demo-4"> 
                <div id="settingsinfo-debug" class="container">
                    <div class="row">
                        <div class="col col-12">
                        Request: <input type="text" value="" id="settings-info-api-request" />
                        </div>
                    </div>
                    <div class="row">
                        <div class="col col-12">
                            <input type="button" class="t btn btn-primary" id="settings-info-api-request-submit" value="Send" />
                        </div>
                    </div>
                    <div class="row">
                        <div class="col col-12">
                            <textarea id="settings-info-api-response" style="width:100%; min-height:60vh;"></textarea>
                        </div>
                    </div>
                </div>
            </div>
                       
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["settingsinfo"] = {
    title: "Settings Info",
    titleButtons: ["close"],
    icon: "devel",
    devOnly: true
};$(document).ready(function(){
    app_soundpad_init_soundselect();
});

function app_soundpad_prepare(html) {

}

function app_soundpad_postprepare() {
    app_soundpad_populate_sounds();
}

function app_soundpad_cron_second() {

}

function app_soundpad_init_soundselect(){
    $("#app").on("mousedown","#soundpad-list .item", function(){
        var voice = $("#soundpad-voice option:selected").text();
        var sound = $(this).attr('data-text');
        aevent({action:"soundpadPlay", voice:voice, sound:sound});
    });
}

function app_soundpad_populate_sounds(){
    var destination = $("#soundpad-list");
    
    var sounds = app_soundpad_get_sounds();
    for(var sound of sounds){
        var el = destination.find(".demo").clone();
        el.removeClass('demo').addClass("new");
        el.find(".text").html(sound);
        el.attr('data-text', sound);
        destination.append(el);
    }
}

function app_soundpad_get_sounds() {
    return [
        "Aeternum.",
        "Hey.",
        "Oh.",
        "No!",
        "Hello?",
        "Sorry.",
        "Yeah?",
        "Excuse me.",
        "Go!",
        "Oh, my God.",
        "Huh?",
        "Yes, sir.",
        "Hmm.",
        "Okay?",
        "Here.",
        "Ah!",
        "Wow.",
        "Stop!",
        "Well...",
        "Yes?",
    ];
}TPL["soundpad"] = `
<div class="app" id="app-soundpad">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-soundpad-1">Sounds</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-soundpad-1">
                <div class="container">
                    <div class="row mb-4 mt-4">
                        <div class="col-5">
                            <label class="t form-check-label t">Voice:</label>
                        </div>
                        <div class="col-7">
                            <select class="form-select" id="soundpad-voice">
                                <option value="">Female1</option>
                                <option value="">Female2</option>
                                <option value="">Female3</option>
                                <option value="">Male1</option>
                                <option value="">Male2</option>
                            </select>
                        </div>
                    </div>
                    <div class="row mb-3">
                         <div class="col-5">
                            <label class="t form-check-label t" >Search</label>:
                        </div>
                        <div class="col-7">
                            <input id="app-soundpad-search-input" data-aesearch="#soundpad-list" class="keyboard aesearchfilter search-filter" type="text" />
                        </div>
                    </div>
                    <div class="row " id="soundpad-list">
                        <div class="demo item col-6 aesearchitem">
                            <div class="text aesearchtext"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["soundpad"] = {
    title: "Soundpad",
    titleButtons: ["close"],
    isPerson: true,
    skipHome: true,
    icon: "person",
};$(document).ready(function () {
    speech_init_speak_button();
});

function speech_init_speak_button(){
    $("#app").on('change',"#speech-speak",function(e){
        var val = escapeHtml($("#speech-speak").val());
        $("#speech-speak-button").attr('data-aeurl-value',val);
    });
}TPL["speech"] = `
<div class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-demo-1" >Speak</a>
        </li>
       
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade " id="tab-demo-1">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <textarea class="w-100" id="speech-speak"></textarea>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <button id="speech-speak-button" type="button" class="t btn btn-primary aeurl" data-aeurl-action="speechSpeak" data-aeurl-value="">Speak</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["speech"] = {
    title: "Speech",
    titleButtons: ["close"],
    icon: "features",
    devOnly: true
};$(document).ready(function () {

    status_ping_second();
});


function status_ping_second(){
    
    status_update_values();
    setTimeout(status_ping_second, 1000);
}

function status_update_values(){
    if($('#app-status').length < 1) return;
    var person = new Character("auto");
    if(!person.isGood()) return;
    
    var dest = "#app-status ";
    $(dest+"#status-tease-level").html(person.getSlider("tease_level"));
    $(dest+"#status-arouse-level").html(person.getSlider("arouse_level"));
    $(dest+"#status-pain-level").html(person.getSlider("pain_level"));
    $(dest+"#status-breathingrate-level").html(person.getSlider("breathing_rate"));
    $(dest+"#status-heartrate-level").html(person.getSlider("heartrate_rate"));
    
}TPL["status"] = `
<div id="app-status" class="app">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-status-1" >Status</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-3" >Link</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t disabled">Disabled</a>
        </li>
    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-status-1">
                <div class="container">
                    <div class="row">
                        <div class="col-5">Tease</div>
                        <div class="col-7" id="status-tease-level"></div>
                    </div>
                    <div class="row">
                        <div class="col-5">Arousal</div>
                        <div class="col-7" id="status-arouse-level"></div>
                    </div>
                    <div class="row">
                        <div class="col-5">Discomfort</div>
                        <div class="col-7" id="status-pain-level"></div>
                    </div>
                    <div class="row">
                        <div class="col-5">Breathing rate</div>
                        <div class="col-7" id="status-breathingrate-level"></div>
                    </div>
                    <div class="row">
                        <div class="col-5">Heart rate</div>
                        <div class="col-7" id="status-heartrate-level"></div>
                    </div>
                </div>
                
            </div>
            <div class="tab-pane fade" id="tab-demo-2">testt2</div>
            <div class="tab-pane fade" id="tab-demo-3">testt3</div>
        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["status"] = {
    title: "Status",
    titleButtons: ["close"],
    icon: "features",
    devOnly: true
};$(document).ready(function () {
    app_vrgolf_init();
});

function app_vrgolf_init(){
    $("#app").on("mousedown", ".vrgolf-play",function(){
        var locs = page_homescreen_get_locations();
        aevent({action:"gamePlay", game:"MiniGolf", position:locs.dome.position, rotation: locs.dome.rotation});
    });
    $("#app").on("mousedown", ".vrgolf-stop",function(){
        aevent({action:"gameStop"});
    });
    $("#app").on("mousedown", ".vrgolf-courses .course-change",function(){
        var cid = $(this).text();
        aevent({action:"gameChangeLevel", game:"MiniGolf", level: cid});
    });
}

function app_vrgolf_prepare(html){
    
}

function app_vrgolf_postprepare(){
    
}

function app_vrgolf_cron_second(){
    
}TPL["vrgolf"] = `
<div class="app" id="app-golf">
    <ul class="nav nav-tabs app-tabs" >
        <li class="nav-item">
            <a class="nav-link t" data-bs-toggle="tab" data-bs-target="#tab-demo-1" >VR Golf</a>
        </li>
        <li class="nav-item">
            <a class="nav-link t" href="#" data-bs-toggle="tab" data-bs-target="#tab-demo-2" >Settings</a>
        </li>

    </ul>
    <div class="app-content tabbed scrollbar1">
        <div class="tab-content">
            <div class="tab-pane fade" id="tab-demo-1">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <h4 class="t section-title mt-3">VR GOLF</h4>
                            VR Golf allows playing mini golf in VR inside the <a class="aelocation" data-location="homeroom" data-room="dome">Alive Home scene Dome room</a>. While active, a golf club will appear in the selected hand. To stop playing, unselect VR Golf from the options on the right wall of the dome room, or use this app.
                        </div>
                        <div class="col-12"><hr /></div>
                        <div class="col-12">
                            <h4 class="t section-title mb-3">Actions</h4>
                        </div>
                        <div class="col-6">
                            <div class="t btn btn-primary w-100 vrgolf-play">Play</div>
                        </div>
                        <div class="col-6">
                            <div class="t btn btn-primary w-100 vrgolf-stop">Stop</div>
                        </div>
                        <div class="col-12"><hr /></div>
                    </div>
                    <div class="row vrgolf-courses">
                        <div class="col-12">
                            <h4 class="t section-title mb-3">Courses</h4>
                        </div>
                        <div class="col course-change btn btn-primary btn-sm">01</div>
                        <div class="col course-change btn btn-primary btn-sm">02</div>
                        <div class="col course-change btn btn-primary btn-sm">03</div>
                        <div class="col course-change btn btn-primary btn-sm">04</div>
                        <div class="col course-change btn btn-primary btn-sm">05</div>
                        <div class="col course-change btn btn-primary btn-sm">06</div>
                        <div class="col course-change btn btn-primary btn-sm">07</div>
                        <div class="col course-change btn btn-primary btn-sm">08</div>
                        <div class="col course-change btn btn-primary btn-sm">09</div>
                        <div class="col course-change btn btn-primary btn-sm">10</div>
                    </div>
                </div>

            </div>
            <div class="tab-pane fade" id="tab-demo-2">

                <div class="container">
                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Left-handed:</label>
                        </div>
                        <div class="col-6 form-check form-switch">
                            <input class="form-check-input aesetting aesetting-toggle" type="checkbox" role="switch" data-aesetting="gMinigolfLefthand" />
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Select this if you want the golf club to be held in the left hand.</div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Club distance:</label>
                        </div>
                        <div class="col-6">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="gMinigolfClubDistance" min="0" max="1.3" step="0.01">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Calibrate this to make the golf be closer to the hand or lower.</div>
                    </div>

                    <div class="row settings-row aesearchitem">
                        <div class="col-5">
                            <label class="t form-check-label aesearchtext">Club rotation: </label>
                        </div>
                        <div class="col-6">
                            <input type="range" class="form-range aesetting aesetting-range" data-aesetting="gMinigolfClubRotation" min="0" max="360" step="1">
                        </div>
                        <div class="col-1 col-helper"><span class="settings-info-icon material-symbols-outlined">help</span></div>
                        <div class="col-12 settings-info">Calibrate the angle at which the golf club is being held.</div>
                    </div>
                </div>


            </div>

        </div>
    </div>
</div>
`;$(document).ready(function () {

});

META["vrgolf"] = {
    title: "VR Golf",
    titleButtons: ["close"],
    icon: "fun",
    isAliveHome: true,
    devOnly: false
};DATA['animations']= [
{"file":"@4\\79 actor everyday activities\\79_39__sipping martinee.bvh","name":"79_39__sipping martinee"},    
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 1.bvh","name":"Female Dance 1"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 10.bvh","name":"Female Dance 10"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 11.bvh","name":"Female Dance 11"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 12.bvh","name":"Female Dance 12"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 13.bvh","name":"Female Dance 13"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 14.bvh","name":"Female Dance 14"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 15.bvh","name":"Female Dance 15"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 16.bvh","name":"Female Dance 16"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 17.bvh","name":"Female Dance 17"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 18.bvh","name":"Female Dance 18"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 19.bvh","name":"Female Dance 19"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 2.bvh","name":"Female Dance 2"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 20.bvh","name":"Female Dance 20"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 21.bvh","name":"Female Dance 21"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 22.bvh","name":"Female Dance 22"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 23.bvh","name":"Female Dance 23"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 24.bvh","name":"Female Dance 24"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 25.bvh","name":"Female Dance 25"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 26.bvh","name":"Female Dance 26"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 27.bvh","name":"Female Dance 27"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 28.bvh","name":"Female Dance 28"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 29.bvh","name":"Female Dance 29"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 3.bvh","name":"Female Dance 3"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 30.bvh","name":"Female Dance 30"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 31.bvh","name":"Female Dance 31"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 32.bvh","name":"Female Dance 32"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 33.bvh","name":"Female Dance 33"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 34.bvh","name":"Female Dance 34"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 35.bvh","name":"Female Dance 35"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 36.bvh","name":"Female Dance 36"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 37.bvh","name":"Female Dance 37"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 38.bvh","name":"Female Dance 38"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 39.bvh","name":"Female Dance 39"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 4.bvh","name":"Female Dance 4"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 40.bvh","name":"Female Dance 40"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 5.bvh","name":"Female Dance 5"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 6.bvh","name":"Female Dance 6"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 7.bvh","name":"Female Dance 7"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 8.bvh","name":"Female Dance 8"},
{"file":"@5\\110 Motion Capture Club Dances\\Female Dance 9.bvh","name":"Female Dance 9"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 1.bvh","name":"Male Dance 1"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 10.bvh","name":"Male Dance 10"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 11.bvh","name":"Male Dance 11"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 12.bvh","name":"Male Dance 12"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 13.bvh","name":"Male Dance 13"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 14.bvh","name":"Male Dance 14"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 15.bvh","name":"Male Dance 15"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 16.bvh","name":"Male Dance 16"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 17.bvh","name":"Male Dance 17"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 18.bvh","name":"Male Dance 18"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 19.bvh","name":"Male Dance 19"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 2.bvh","name":"Male Dance 2"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 20.bvh","name":"Male Dance 20"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 21.bvh","name":"Male Dance 21"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 22.bvh","name":"Male Dance 22"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 23.bvh","name":"Male Dance 23"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 24.bvh","name":"Male Dance 24"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 25.bvh","name":"Male Dance 25"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 3.bvh","name":"Male Dance 3"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 4.bvh","name":"Male Dance 4"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 5.bvh","name":"Male Dance 5"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 6.bvh","name":"Male Dance 6"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 7.bvh","name":"Male Dance 7"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 8.bvh","name":"Male Dance 8"},
{"file":"@5\\110 Motion Capture Club Dances\\Male Dance 9.bvh","name":"Male Dance 9"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 1.bvh","name":"Unisex Dance 1"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 10.bvh","name":"Unisex Dance 10"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 11.bvh","name":"Unisex Dance 11"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 12.bvh","name":"Unisex Dance 12"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 13.bvh","name":"Unisex Dance 13"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 14.bvh","name":"Unisex Dance 14"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 15.bvh","name":"Unisex Dance 15"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 16.bvh","name":"Unisex Dance 16"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 17.bvh","name":"Unisex Dance 17"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 18.bvh","name":"Unisex Dance 18"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 19.bvh","name":"Unisex Dance 19"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 2.bvh","name":"Unisex Dance 2"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 20.bvh","name":"Unisex Dance 20"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 21.bvh","name":"Unisex Dance 21"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 22.bvh","name":"Unisex Dance 22"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 23.bvh","name":"Unisex Dance 23"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 24.bvh","name":"Unisex Dance 24"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 25.bvh","name":"Unisex Dance 25"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 26.bvh","name":"Unisex Dance 26"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 27.bvh","name":"Unisex Dance 27"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 28.bvh","name":"Unisex Dance 28"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 29.bvh","name":"Unisex Dance 29"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 3.bvh","name":"Unisex Dance 3"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 30.bvh","name":"Unisex Dance 30"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 31.bvh","name":"Unisex Dance 31"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 32.bvh","name":"Unisex Dance 32"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 33.bvh","name":"Unisex Dance 33"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 34.bvh","name":"Unisex Dance 34"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 35.bvh","name":"Unisex Dance 35"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 36.bvh","name":"Unisex Dance 36"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 37.bvh","name":"Unisex Dance 37"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 38.bvh","name":"Unisex Dance 38"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 39.bvh","name":"Unisex Dance 39"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 4.bvh","name":"Unisex Dance 4"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 40.bvh","name":"Unisex Dance 40"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 41.bvh","name":"Unisex Dance 41"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 42.bvh","name":"Unisex Dance 42"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 43.bvh","name":"Unisex Dance 43"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 44.bvh","name":"Unisex Dance 44"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 45.bvh","name":"Unisex Dance 45"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 5.bvh","name":"Unisex Dance 5"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 6.bvh","name":"Unisex Dance 6"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 7.bvh","name":"Unisex Dance 7"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 8.bvh","name":"Unisex Dance 8"},
{"file":"@5\\110 Motion Capture Club Dances\\Unisex Dance 9.bvh","name":"Unisex Dance 9"},
{"file":"@2\\02 various expressions and human behaviors\\02_01__walk.bvh","name":"02_01__walk"},
{"file":"@2\\02 various expressions and human behaviors\\02_02__walk.bvh","name":"02_02__walk"},
{"file":"@2\\02 various expressions and human behaviors\\02_03__run or jog.bvh","name":"02_03__run or jog"},
{"file":"@2\\02 various expressions and human behaviors\\02_04__jump, balance.bvh","name":"02_04__jump, balance"},
{"file":"@2\\02 various expressions and human behaviors\\02_09__swordplay.bvh","name":"02_09__swordplay"},
{"file":"@2\\03 walk on uneven terrain\\03_01__walk on uneven terrain.bvh","name":"03_01__walk on uneven terrain"},
{"file":"@2\\03 walk on uneven terrain\\03_02__walk on uneven terrain.bvh","name":"03_02__walk on uneven terrain"},
{"file":"@2\\05 modern dance\\05_01__walk.bvh","name":"05_01__walk"},
{"file":"@2\\05 modern dance\\05_02__dance - expressive arms, pirouette.bvh","name":"05_02__dance - expressive arms, pirouette"},
{"file":"@2\\05 modern dance\\05_03__dance - sideways arabesque, turn step, folding arms.bvh","name":"05_03__dance - sideways arabesque, turn step, folding arms"},
{"file":"@2\\05 modern dance\\05_04__dance - sideways arabesque, folding arms, bending back.bvh","name":"05_04__dance - sideways arabesque, folding arms, bending back"},
{"file":"@2\\05 modern dance\\05_05__dance - quasi-cou-de-pied, raised leg above hip-height, jete en tourant.bvh","name":"05_05__dance - quasi-cou-de-pied, raised leg above hip-height, jete en tourant"},
{"file":"@2\\05 modern dance\\05_06__dance - cartwheel-like start, pirouettes, jete.bvh","name":"05_06__dance - cartwheel-like start, pirouettes, jete"},
{"file":"@2\\05 modern dance\\05_07__dance - small jetes, attitude or arabesque, shifted-axis pirouette, turn.bvh","name":"05_07__dance - small jetes, attitude or arabesque, shifted-axis pirouette, turn"},
{"file":"@2\\05 modern dance\\05_08__dance - rond de jambe in the air, jete, turn.bvh","name":"05_08__dance - rond de jambe in the air, jete, turn"},
{"file":"@2\\05 modern dance\\05_09__dance - glissade devant, glissade derriere, attitude or arabesque.bvh","name":"05_09__dance - glissade devant, glissade derriere, attitude or arabesque"},
{"file":"@2\\05 modern dance\\05_10__dance - glissade devant, glissade derriere, attitude or arabesque.bvh","name":"05_10__dance - glissade devant, glissade derriere, attitude or arabesque"},
{"file":"@2\\05 modern dance\\05_11__dance - sideways steps, pirouette.bvh","name":"05_11__dance - sideways steps, pirouette"},
{"file":"@2\\05 modern dance\\05_13__dance - small jetes, pirouette.bvh","name":"05_13__dance - small jetes, pirouette"},
{"file":"@2\\05 modern dance\\05_14__dance - retire derriere, attitude or arabesque.bvh","name":"05_14__dance - retire derriere, attitude or arabesque"},
{"file":"@2\\05 modern dance\\05_15__dance - retire derriere, attitude or arabesque.bvh","name":"05_15__dance - retire derriere, attitude or arabesque"},
{"file":"@2\\05 modern dance\\05_16__dance - coupe dessous, jete en tourant.bvh","name":"05_16__dance - coupe dessous, jete en tourant"},
{"file":"@2\\05 modern dance\\05_17__dance - coupe dessous, grand jete en tourant.bvh","name":"05_17__dance - coupe dessous, grand jete en tourant"},
{"file":"@2\\05 modern dance\\05_19__dance - attitude or arabesque, jete en tourant, bending back.bvh","name":"05_19__dance - attitude or arabesque, jete en tourant, bending back"},
{"file":"@2\\05 modern dance\\05_20__dance - attitude or arabesque, jete en tourant, bending back.bvh","name":"05_20__dance - attitude or arabesque, jete en tourant, bending back"},
{"file":"@2\\06 dribble, shoot basketball\\06_01__walk.bvh","name":"06_01__walk"},
{"file":"@2\\06 dribble, shoot basketball\\06_02__basketball - forward dribble.bvh","name":"06_02__basketball - forward dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_03__basketball - forward dribble.bvh","name":"06_03__basketball - forward dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_04__basketball - forward dribble.bvh","name":"06_04__basketball - forward dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_05__basketball - forward dribble.bvh","name":"06_05__basketball - forward dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_06__basketball - backward dribble.bvh","name":"06_06__basketball - backward dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_07__basketball - backward dribble.bvh","name":"06_07__basketball - backward dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_08__basketball - sideways dribble.bvh","name":"06_08__basketball - sideways dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_09__basketball - sideways dribble.bvh","name":"06_09__basketball - sideways dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_10__basketball - forward dribble, 90-degree left turns.bvh","name":"06_10__basketball - forward dribble, 90-degree left turns"},
{"file":"@2\\06 dribble, shoot basketball\\06_11__basketball - forward dribble, 90-degree right turns.bvh","name":"06_11__basketball - forward dribble, 90-degree right turns"},
{"file":"@2\\06 dribble, shoot basketball\\06_12__basketball - forward dribble, 90-degree right turns, crossover dribble.bvh","name":"06_12__basketball - forward dribble, 90-degree right turns, crossover dribble"},
{"file":"@2\\06 dribble, shoot basketball\\06_14__basketball - crossover dribble, shoot.bvh","name":"06_14__basketball - crossover dribble, shoot"},
{"file":"@2\\06 dribble, shoot basketball\\06_15__basketball - dribble, shoot.bvh","name":"06_15__basketball - dribble, shoot"},
{"file":"@2\\07 walk\\07_01__walk.bvh","name":"07_01__walk"},
{"file":"@2\\07 walk\\07_02__walk.bvh","name":"07_02__walk"},
{"file":"@2\\07 walk\\07_03__walk.bvh","name":"07_03__walk"},
{"file":"@2\\07 walk\\07_04__slow walk.bvh","name":"07_04__slow walk"},
{"file":"@2\\07 walk\\07_05__slow walk.bvh","name":"07_05__slow walk"},
{"file":"@2\\07 walk\\07_06__walk.bvh","name":"07_06__walk"},
{"file":"@2\\07 walk\\07_07__walk.bvh","name":"07_07__walk"},
{"file":"@2\\07 walk\\07_08__walk.bvh","name":"07_08__walk"},
{"file":"@2\\07 walk\\07_09__walk.bvh","name":"07_09__walk"},
{"file":"@2\\07 walk\\07_10__walk.bvh","name":"07_10__walk"},
{"file":"@2\\07 walk\\07_11__walk.bvh","name":"07_11__walk"},
{"file":"@2\\07 walk\\07_12__brisk walk.bvh","name":"07_12__brisk walk"},
{"file":"@2\\08 walk\\08_01__walk.bvh","name":"08_01__walk"},
{"file":"@2\\08 walk\\08_02__walk.bvh","name":"08_02__walk"},
{"file":"@2\\08 walk\\08_03__walk.bvh","name":"08_03__walk"},
{"file":"@2\\08 walk\\08_04__slow walk.bvh","name":"08_04__slow walk"},
{"file":"@2\\08 walk\\08_05__walk or stride.bvh","name":"08_05__walk or stride"},
{"file":"@2\\08 walk\\08_06__walk.bvh","name":"08_06__walk"},
{"file":"@2\\08 walk\\08_07__walk, exaggerated stride.bvh","name":"08_07__walk, exaggerated stride"},
{"file":"@2\\08 walk\\08_08__walk.bvh","name":"08_08__walk"},
{"file":"@2\\08 walk\\08_09__walk.bvh","name":"08_09__walk"},
{"file":"@2\\08 walk\\08_10__walk.bvh","name":"08_10__walk"},
{"file":"@2\\08 walk\\08_11__slow walk or stride.bvh","name":"08_11__slow walk or stride"},
{"file":"@2\\09 run\\09_01__run.bvh","name":"09_01__run"},
{"file":"@2\\09 run\\09_02__run.bvh","name":"09_02__run"},
{"file":"@2\\09 run\\09_03__run.bvh","name":"09_03__run"},
{"file":"@2\\09 run\\09_04__run.bvh","name":"09_04__run"},
{"file":"@2\\09 run\\09_05__run.bvh","name":"09_05__run"},
{"file":"@2\\09 run\\09_06__run.bvh","name":"09_06__run"},
{"file":"@2\\09 run\\09_07__run.bvh","name":"09_07__run"},
{"file":"@2\\09 run\\09_08__run.bvh","name":"09_08__run"},
{"file":"@2\\09 run\\09_09__run.bvh","name":"09_09__run"},
{"file":"@2\\09 run\\09_10__run.bvh","name":"09_10__run"},
{"file":"@2\\09 run\\09_11__run.bvh","name":"09_11__run"},
{"file":"@2\\10-11 kick soccer ball\\10_01__soccer - kick ball.bvh","name":"10_01__soccer - kick ball"},
{"file":"@2\\10-11 kick soccer ball\\10_02__soccer - kick ball.bvh","name":"10_02__soccer - kick ball"},
{"file":"@2\\10-11 kick soccer ball\\10_03__soccer - kick ball.bvh","name":"10_03__soccer - kick ball"},
{"file":"@2\\10-11 kick soccer ball\\10_04__walk.bvh","name":"10_04__walk"},
{"file":"@2\\10-11 kick soccer ball\\10_05__soccer - kick ball.bvh","name":"10_05__soccer - kick ball"},
{"file":"@2\\10-11 kick soccer ball\\10_06__soccer - kick ball.bvh","name":"10_06__soccer - kick ball"},
{"file":"@2\\10-11 kick soccer ball\\11_01__soccer - kick ball.bvh","name":"11_01__soccer - kick ball"},
{"file":"@2\\12 tai chi, walk\\12_01__walk.bvh","name":"12_01__walk"},
{"file":"@2\\12 tai chi, walk\\12_02__walk.bvh","name":"12_02__walk"},
{"file":"@2\\12 tai chi, walk\\12_03__walk.bvh","name":"12_03__walk"},
{"file":"@2\\13 various everyday behaviors\\13_09__drink soda.bvh","name":"13_09__drink soda"},
{"file":"@2\\13 various everyday behaviors\\13_11__forward jump.bvh","name":"13_11__forward jump"},
{"file":"@2\\13 various everyday behaviors\\13_13__forward jump.bvh","name":"13_13__forward jump"},
{"file":"@2\\13 various everyday behaviors\\13_19__forward jump.bvh","name":"13_19__forward jump"},
{"file":"@2\\13 various everyday behaviors\\13_32__forward jump.bvh","name":"13_32__forward jump"},
{"file":"@2\\13 various everyday behaviors\\13_35__climb 3 steps.bvh","name":"13_35__climb 3 steps"},
{"file":"@2\\13 various everyday behaviors\\13_39__jump.bvh","name":"13_39__jump"},
{"file":"@2\\13 various everyday behaviors\\13_40__jump.bvh","name":"13_40__jump"},
{"file":"@2\\13 various everyday behaviors\\13_41__jump.bvh","name":"13_41__jump"},
{"file":"@2\\13 various everyday behaviors\\13_42__jump.bvh","name":"13_42__jump"},
{"file":"@2\\14 various everyday behaviors\\14_04__drink soda, screw on bottlecap.bvh","name":"14_04__drink soda, screw on bottlecap"},
{"file":"@2\\14 various everyday behaviors\\14_05__unscrew bottlecap, drink soda.bvh","name":"14_05__unscrew bottlecap, drink soda"},
{"file":"@2\\14 various everyday behaviors\\14_21__climb 3 steps.bvh","name":"14_21__climb 3 steps"},
{"file":"@2\\14 various everyday behaviors\\14_22__climb 3 steps.bvh","name":"14_22__climb 3 steps"},
{"file":"@2\\14 various everyday behaviors\\14_37__drink soda.bvh","name":"14_37__drink soda"},
{"file":"@2\\16 run, jump, walk\\16_01__jump.bvh","name":"16_01__jump"},
{"file":"@2\\16 run, jump, walk\\16_02__jump.bvh","name":"16_02__jump"},
{"file":"@2\\16 run, jump, walk\\16_03__high jump.bvh","name":"16_03__high jump"},
{"file":"@2\\16 run, jump, walk\\16_04__high jump.bvh","name":"16_04__high jump"},
{"file":"@2\\16 run, jump, walk\\16_05__forward jump.bvh","name":"16_05__forward jump"},
{"file":"@2\\16 run, jump, walk\\16_06__forward jump.bvh","name":"16_06__forward jump"},
{"file":"@2\\16 run, jump, walk\\16_07__forward jump.bvh","name":"16_07__forward jump"},
{"file":"@2\\16 run, jump, walk\\16_08__run or jog, sudden stop.bvh","name":"16_08__run or jog, sudden stop"},
{"file":"@2\\16 run, jump, walk\\16_09__forward jump.bvh","name":"16_09__forward jump"},
{"file":"@2\\16 run, jump, walk\\16_10__forward jump.bvh","name":"16_10__forward jump"},
{"file":"@2\\16 run, jump, walk\\16_11__walk, veer left.bvh","name":"16_11__walk, veer left"},
{"file":"@2\\16 run, jump, walk\\16_12__walk, veer left.bvh","name":"16_12__walk, veer left"},
{"file":"@2\\16 run, jump, walk\\16_13__walk, veer right.bvh","name":"16_13__walk, veer right"},
{"file":"@2\\16 run, jump, walk\\16_14__walk, veer right.bvh","name":"16_14__walk, veer right"},
{"file":"@2\\16 run, jump, walk\\16_15__walk.bvh","name":"16_15__walk"},
{"file":"@2\\16 run, jump, walk\\16_16__walk.bvh","name":"16_16__walk"},
{"file":"@2\\16 run, jump, walk\\16_17__walk, 90-degree left turn.bvh","name":"16_17__walk, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_18__walk, 90-degree left turn.bvh","name":"16_18__walk, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_19__walk, 90-degree right turn.bvh","name":"16_19__walk, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_20__walk, 90-degree right turn.bvh","name":"16_20__walk, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_21__walk.bvh","name":"16_21__walk"},
{"file":"@2\\16 run, jump, walk\\16_22__walk.bvh","name":"16_22__walk"},
{"file":"@2\\16 run, jump, walk\\16_23__walk, veer left.bvh","name":"16_23__walk, veer left"},
{"file":"@2\\16 run, jump, walk\\16_24__walk, veer left.bvh","name":"16_24__walk, veer left"},
{"file":"@2\\16 run, jump, walk\\16_25__walk, veer right.bvh","name":"16_25__walk, veer right"},
{"file":"@2\\16 run, jump, walk\\16_26__walk, veer right.bvh","name":"16_26__walk, veer right"},
{"file":"@2\\16 run, jump, walk\\16_27__walk, 90-degree left turn.bvh","name":"16_27__walk, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_28__walk, 90-degree left turn.bvh","name":"16_28__walk, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_29__walk, 90-degree right turn.bvh","name":"16_29__walk, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_30__walk, 90-degree right turn.bvh","name":"16_30__walk, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_31__walk.bvh","name":"16_31__walk"},
{"file":"@2\\16 run, jump, walk\\16_32__walk.bvh","name":"16_32__walk"},
{"file":"@2\\16 run, jump, walk\\16_33__slow walk, stop.bvh","name":"16_33__slow walk, stop"},
{"file":"@2\\16 run, jump, walk\\16_34__slow walk, stop.bvh","name":"16_34__slow walk, stop"},
{"file":"@2\\16 run, jump, walk\\16_35__run or jog.bvh","name":"16_35__run or jog"},
{"file":"@2\\16 run, jump, walk\\16_36__run or jog.bvh","name":"16_36__run or jog"},
{"file":"@2\\16 run, jump, walk\\16_37__run or jog, veer left.bvh","name":"16_37__run or jog, veer left"},
{"file":"@2\\16 run, jump, walk\\16_38__run or jog, veer left.bvh","name":"16_38__run or jog, veer left"},
{"file":"@2\\16 run, jump, walk\\16_39__run or jog, veer right.bvh","name":"16_39__run or jog, veer right"},
{"file":"@2\\16 run, jump, walk\\16_40__run or jog, veer right.bvh","name":"16_40__run or jog, veer right"},
{"file":"@2\\16 run, jump, walk\\16_41__run or jog, 90-degree left turn.bvh","name":"16_41__run or jog, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_42__run or jog, 90-degree left turn.bvh","name":"16_42__run or jog, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_43__run or jog, 90-degree right turn.bvh","name":"16_43__run or jog, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_44__run or jog, 90-degree right turn.bvh","name":"16_44__run or jog, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_45__run or jog.bvh","name":"16_45__run or jog"},
{"file":"@2\\16 run, jump, walk\\16_46__run or jog.bvh","name":"16_46__run or jog"},
{"file":"@2\\16 run, jump, walk\\16_47__walk.bvh","name":"16_47__walk"},
{"file":"@2\\16 run, jump, walk\\16_48__run, veer left.bvh","name":"16_48__run, veer left"},
{"file":"@2\\16 run, jump, walk\\16_49__run, veer right.bvh","name":"16_49__run, veer right"},
{"file":"@2\\16 run, jump, walk\\16_50__run, veer right.bvh","name":"16_50__run, veer right"},
{"file":"@2\\16 run, jump, walk\\16_51__run, 90-degree left turn.bvh","name":"16_51__run, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_52__run, 90-degree left turn.bvh","name":"16_52__run, 90-degree left turn"},
{"file":"@2\\16 run, jump, walk\\16_53__run, 90-degree right turn.bvh","name":"16_53__run, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_54__run, 90-degree right turn.bvh","name":"16_54__run, 90-degree right turn"},
{"file":"@2\\16 run, jump, walk\\16_55__run.bvh","name":"16_55__run"},
{"file":"@2\\16 run, jump, walk\\16_56__run or jog.bvh","name":"16_56__run or jog"},
{"file":"@2\\16 run, jump, walk\\16_57__run or jog, sudden stop.bvh","name":"16_57__run or jog, sudden stop"},
{"file":"@2\\16 run, jump, walk\\16_58__walk.bvh","name":"16_58__walk"},
{"file":"@2\\18 human interaction and communication\\18_01__walk, shake hands (2 subjects - subject A).bvh","name":"18_01__walk, shake hands (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_02__walk, shake hands (2 subjects - subject A).bvh","name":"18_02__walk, shake hands (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_03__A pulls B, B resists (2 subjects - subject A).bvh","name":"18_03__A pulls B, B resists (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_04__A pulls B, B resists (2 subjects - subject A).bvh","name":"18_04__A pulls B, B resists (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_05__A pulls B by the elbow, B resists (2 subjects - subject A).bvh","name":"18_05__A pulls B by the elbow, B resists (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_06__A pulls B by the elbow, B resists (2 subjects - subject A).bvh","name":"18_06__A pulls B by the elbow, B resists (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_07__navigate busy sidewalk, A leads the way, takes B by the arm (2 subjects - subject A).bvh","name":"18_07__navigate busy sidewalk, A leads the way, takes B by the arm (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_09__conversation - explain with hand gestures, walk (2 subjects - subject A).bvh","name":"18_09__conversation - explain with hand gestures, walk (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_13__run, scramble for last seat (2 subjects - subject A).bvh","name":"18_13__run, scramble for last seat (2 subjects - subject A)"},
{"file":"@2\\18 human interaction and communication\\18_14__run, scramble for last seat (2 subjects - subject A).bvh","name":"18_14__run, scramble for last seat (2 subjects - subject A)"},
{"file":"@2\\19 human interaction and communication\\19_01__walk, shake hands (2 subjects - subject B).bvh","name":"19_01__walk, shake hands (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_02__walk, shake hands (2 subjects - subject B).bvh","name":"19_02__walk, shake hands (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_03__A pulls B, B resists (2 subjects - subject B).bvh","name":"19_03__A pulls B, B resists (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_04__A pulls B, B resists (2 subjects - subject B).bvh","name":"19_04__A pulls B, B resists (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_05__A pulls B by the elbow, B resists (2 subjects - subject B).bvh","name":"19_05__A pulls B by the elbow, B resists (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_06__A pulls B by the elbow, B resists (2 subjects - subject B).bvh","name":"19_06__A pulls B by the elbow, B resists (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_07__navigate busy sidewalk, A leads the way, takes B by the arm (2 subjects - subject B).bvh","name":"19_07__navigate busy sidewalk, A leads the way, takes B by the arm (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_09__conversation - explain with hand gestures, walk (2 subjects - subject B).bvh","name":"19_09__conversation - explain with hand gestures, walk (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_13__run, scramble for last seat (2 subjects - subject B).bvh","name":"19_13__run, scramble for last seat (2 subjects - subject B)"},
{"file":"@2\\19 human interaction and communication\\19_14__run, scramble for last seat (2 subjects - subject B).bvh","name":"19_14__run, scramble for last seat (2 subjects - subject B)"},
{"file":"@2\\20 human interaction - at play, formations\\20_02__link arms, walk (2 subjects - subject A).bvh","name":"20_02__link arms, walk (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_03__link arms, walk (2 subjects - subject A).bvh","name":"20_03__link arms, walk (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_04__synchronized walk (2 subjects - subject A).bvh","name":"20_04__synchronized walk (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_05__synchronized walk (2 subjects - subject A).bvh","name":"20_05__synchronized walk (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_06__soldiers march (2 subjects - subject A).bvh","name":"20_06__soldiers march (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_07__soldiers march (2 subjects - subject A).bvh","name":"20_07__soldiers march (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_08__zombie march (2 subjects - subject A).bvh","name":"20_08__zombie march (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_09__nursery rhyme - ring around the rosey (2 subjects - subject A).bvh","name":"20_09__nursery rhyme - ring around the rosey (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_10__360-degree two-person whip (2 subjects - subject A).bvh","name":"20_10__360-degree two-person whip (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_11__high-five, walk (2 subjects - subject A).bvh","name":"20_11__high-five, walk (2 subjects - subject A)"},
{"file":"@2\\20 human interaction - at play, formations\\20_12__low-five, walk (2 subjects - subject A).bvh","name":"20_12__low-five, walk (2 subjects - subject A)"},
{"file":"@3\\21 human interaction - at play, formations\\21_02__link arms, walk (2 subjects - subject B).bvh","name":"21_02__link arms, walk (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_03__link arms, walk (2 subjects - subject B).bvh","name":"21_03__link arms, walk (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_04__synchronized walk (2 subjects - subject B).bvh","name":"21_04__synchronized walk (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_05__synchronized walk (2 subjects - subject B).bvh","name":"21_05__synchronized walk (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_06__soldiers march (2 subjects - subject B).bvh","name":"21_06__soldiers march (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_07__soldiers march (2 subjects - subject B).bvh","name":"21_07__soldiers march (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_08__zombie march (2 subjects - subject B).bvh","name":"21_08__zombie march (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_09__nursery rhyme - ring around the rosey (2 subjects - subject B).bvh","name":"21_09__nursery rhyme - ring around the rosey (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_10__360-degree two-person whip (2 subjects - subject B).bvh","name":"21_10__360-degree two-person whip (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_11__high-five, walk (2 subjects - subject B).bvh","name":"21_11__high-five, walk (2 subjects - subject B)"},
{"file":"@3\\21 human interaction - at play, formations\\21_12__low-five, walk (2 subjects - subject B).bvh","name":"21_12__low-five, walk (2 subjects - subject B)"},
{"file":"@3\\22 human interaction\\22_01__B sits, A pulls up B (2 subjects - subject A).bvh","name":"22_01__B sits, A pulls up B (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_02__A sits, B pulls up A (2 subjects - subject A).bvh","name":"22_02__A sits, B pulls up A (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_03__A sits, holds face in hands, B kneels, comforts A (2 subjects - subject A).bvh","name":"22_03__A sits, holds face in hands, B kneels, comforts A (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_04__B comforts A, puts one hand on A's shoulder (2 subjects - subject A).bvh","name":"22_04__B comforts A, puts one hand on A's shoulder (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_05__A comforts B, puts both hands on B's shoulders (2 subjects - subject A).bvh","name":"22_05__A comforts B, puts both hands on B's shoulders (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_06__B comforts A, puts both hands on A's shoulders (2 subjects - subject A).bvh","name":"22_06__B comforts A, puts both hands on A's shoulders (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_07__A comforts B, puts one hand on B's shoulder (2 subjects - subject A).bvh","name":"22_07__A comforts B, puts one hand on B's shoulder (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_08__hold hands, swing arms, walk (2 subjects - subject A).bvh","name":"22_08__hold hands, swing arms, walk (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_09__A gives B a shoulder rub, B sits, A stands (2 subjects - subject A).bvh","name":"22_09__A gives B a shoulder rub, B sits, A stands (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_12__A stumbles into B (2 subjects - subject A).bvh","name":"22_12__A stumbles into B (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_13__A passes soda to B, both drink (2 subjects - subject A).bvh","name":"22_13__A passes soda to B, both drink (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_14__alternating squats (2 subjects - subject A).bvh","name":"22_14__alternating squats (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_15__alternating jumping jacks (2 subjects - subject A).bvh","name":"22_15__alternating jumping jacks (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_16__synchronized jumping jacks (2 subjects - subject A).bvh","name":"22_16__synchronized jumping jacks (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_17__rush up, arm wrestle (2 subjects - subject A).bvh","name":"22_17__rush up, arm wrestle (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_18__A stares down B, leans with hands on high stool (2 subjects - subject A).bvh","name":"22_18__A stares down B, leans with hands on high stool (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_19__B stares down A, leans with hands on high stool (2 subjects - subject A).bvh","name":"22_19__B stares down A, leans with hands on high stool (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_20__violence - A picks up high stool, threatens to strike B (2 subjects - subject A).bvh","name":"22_20__violence - A picks up high stool, threatens to strike B (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_21__conversation - B pounds high stool, points at A (2 subjects - subject A).bvh","name":"22_21__conversation - B pounds high stool, points at A (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_22__walk, B catches keys thrown by A (2 subjects - subject A).bvh","name":"22_22__walk, B catches keys thrown by A (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_23__walk, A catches keys thrown by B (2 subjects - subject A).bvh","name":"22_23__walk, A catches keys thrown by B (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_24__walk, B catches wallet thrown by A (2 subjects - subject A).bvh","name":"22_24__walk, B catches wallet thrown by A (2 subjects - subject A)"},
{"file":"@3\\22 human interaction\\22_25__walk, A catches wallet thrown by B (2 subjects - subject A).bvh","name":"22_25__walk, A catches wallet thrown by B (2 subjects - subject A)"},
{"file":"@3\\23 human interaction\\23_01__B sits, A pulls up B (subjects - subject B).bvh","name":"23_01__B sits, A pulls up B (subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_02__A sits, B pulls up A (subjects - subject B).bvh","name":"23_02__A sits, B pulls up A (subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_03__A sits, holds face in hands, B kneels, comforts A (2 subjects - subject B).bvh","name":"23_03__A sits, holds face in hands, B kneels, comforts A (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_04__B comforts A, puts one hand on A's shoulder (2 subjects - subject B).bvh","name":"23_04__B comforts A, puts one hand on A's shoulder (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_05__A comforts B, puts both hands on B's shoulders (2 subjects - subject B).bvh","name":"23_05__A comforts B, puts both hands on B's shoulders (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_06__B comforts A, puts both hands on A's shoulders (2 subjects - subject B).bvh","name":"23_06__B comforts A, puts both hands on A's shoulders (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_07__A comforts B, puts one hand on B's shoulder (2 subjects - subject B).bvh","name":"23_07__A comforts B, puts one hand on B's shoulder (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_08__hold hands, swing arms, walk (2 subjects - subject B).bvh","name":"23_08__hold hands, swing arms, walk (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_09__A gives B a shoulder rub, B sits, A stands (subjects - subject B).bvh","name":"23_09__A gives B a shoulder rub, B sits, A stands (subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_10__A shelters B, a younger child, from harm (2 subjects - subject B).bvh","name":"23_10__A shelters B, a younger child, from harm (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_11__B shelters A, a younger child, from harm (2 subjects - subject B).bvh","name":"23_11__B shelters A, a younger child, from harm (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_12__A stumbles into B (2 subjects - subject B).bvh","name":"23_12__A stumbles into B (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_13__A passes soda to B, both drink (2 subjects - subject B).bvh","name":"23_13__A passes soda to B, both drink (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_14__alternating squats (2 subjects - subject B).bvh","name":"23_14__alternating squats (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_15__alternating jumping jacks (2 subjects - subject B).bvh","name":"23_15__alternating jumping jacks (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_16__synchronized jumping jacks (2 subjects - subject B).bvh","name":"23_16__synchronized jumping jacks (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_17__rush up, arm wrestle (2 subjects - subject B).bvh","name":"23_17__rush up, arm wrestle (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_18__A stares down B, leans with hands on high stool (2 subjects - subject B).bvh","name":"23_18__A stares down B, leans with hands on high stool (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_19__B stares down A, leans with hands on high stool (2 subjects - subject B).bvh","name":"23_19__B stares down A, leans with hands on high stool (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_20__violence - A picks up high stool, threatens to strike B (2 subjects - subject B).bvh","name":"23_20__violence - A picks up high stool, threatens to strike B (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_21__conversation - B pounds high stool, points at A (2 subjects - subject B).bvh","name":"23_21__conversation - B pounds high stool, points at A (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_22__walk, B catches keys thrown by A (2 subjects - subject B).bvh","name":"23_22__walk, B catches keys thrown by A (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_23__walk, A catches keys thrown by B (2 subjects - subject B).bvh","name":"23_23__walk, A catches keys thrown by B (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_24__walk, B catches wallet thrown by A (2 subjects - subject B).bvh","name":"23_24__walk, B catches wallet thrown by A (2 subjects - subject B)"},
{"file":"@3\\23 human interaction\\23_25__walk, A catches wallet thrown by B (2 subjects - subject B).bvh","name":"23_25__walk, A catches wallet thrown by B (2 subjects - subject B)"},
{"file":"@3\\26 nursery rhymes, basketball, bending\\26_01__walk.bvh","name":"26_01__walk"},
{"file":"@3\\26 nursery rhymes, basketball, bending\\26_09__bend, pick up.bvh","name":"26_09__bend, pick up"},
{"file":"@3\\26 nursery rhymes, basketball, bending\\26_10__bend, lift.bvh","name":"26_10__bend, lift"},
{"file":"@3\\26 nursery rhymes, basketball, bending\\26_11__bend, lift.bvh","name":"26_11__bend, lift"},
{"file":"@3\\27 recreation, nursery rhymes\\27_01__walk.bvh","name":"27_01__walk"},
{"file":"@3\\35 walk, run\\35_01__walk.bvh","name":"35_01__walk"},
{"file":"@3\\35 walk, run\\35_02__walk.bvh","name":"35_02__walk"},
{"file":"@3\\35 walk, run\\35_03__walk.bvh","name":"35_03__walk"},
{"file":"@3\\35 walk, run\\35_04__walk.bvh","name":"35_04__walk"},
{"file":"@3\\35 walk, run\\35_05__walk.bvh","name":"35_05__walk"},
{"file":"@3\\35 walk, run\\35_06__walk.bvh","name":"35_06__walk"},
{"file":"@3\\35 walk, run\\35_07__walk.bvh","name":"35_07__walk"},
{"file":"@3\\35 walk, run\\35_08__walk.bvh","name":"35_08__walk"},
{"file":"@3\\35 walk, run\\35_09__walk.bvh","name":"35_09__walk"},
{"file":"@3\\35 walk, run\\35_10__walk.bvh","name":"35_10__walk"},
{"file":"@3\\35 walk, run\\35_11__walk.bvh","name":"35_11__walk"},
{"file":"@3\\35 walk, run\\35_12__walk.bvh","name":"35_12__walk"},
{"file":"@3\\35 walk, run\\35_13__walk.bvh","name":"35_13__walk"},
{"file":"@3\\35 walk, run\\35_14__walk.bvh","name":"35_14__walk"},
{"file":"@3\\35 walk, run\\35_15__walk.bvh","name":"35_15__walk"},
{"file":"@3\\35 walk, run\\35_16__walk.bvh","name":"35_16__walk"},
{"file":"@3\\35 walk, run\\35_17__run or jog.bvh","name":"35_17__run or jog"},
{"file":"@3\\35 walk, run\\35_18__run or jog.bvh","name":"35_18__run or jog"},
{"file":"@3\\35 walk, run\\35_19__run or jog.bvh","name":"35_19__run or jog"},
{"file":"@3\\35 walk, run\\35_20__run or jog.bvh","name":"35_20__run or jog"},
{"file":"@3\\35 walk, run\\35_21__run or jog.bvh","name":"35_21__run or jog"},
{"file":"@3\\35 walk, run\\35_22__run or jog.bvh","name":"35_22__run or jog"},
{"file":"@3\\35 walk, run\\35_23__run or jog.bvh","name":"35_23__run or jog"},
{"file":"@3\\35 walk, run\\35_24__run or jog.bvh","name":"35_24__run or jog"},
{"file":"@3\\35 walk, run\\35_25__run or jog.bvh","name":"35_25__run or jog"},
{"file":"@3\\35 walk, run\\35_26__run or jog.bvh","name":"35_26__run or jog"},
{"file":"@3\\35 walk, run\\35_28__walk.bvh","name":"35_28__walk"},
{"file":"@3\\35 walk, run\\35_29__walk.bvh","name":"35_29__walk"},
{"file":"@3\\35 walk, run\\35_30__walk.bvh","name":"35_30__walk"},
{"file":"@3\\35 walk, run\\35_31__walk.bvh","name":"35_31__walk"},
{"file":"@3\\35 walk, run\\35_32__walk.bvh","name":"35_32__walk"},
{"file":"@3\\35 walk, run\\35_33__walk.bvh","name":"35_33__walk"},
{"file":"@3\\35 walk, run\\35_34__walk.bvh","name":"35_34__walk"},
{"file":"@3\\37 walk\\37_01__slow walk.bvh","name":"37_01__slow walk"},
{"file":"@3\\38 walk, run\\38_01__walk.bvh","name":"38_01__walk"},
{"file":"@3\\38 walk, run\\38_02__walk.bvh","name":"38_02__walk"},
{"file":"@3\\38 walk, run\\38_03__run around in a circle.bvh","name":"38_03__run around in a circle"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_01__walk.bvh","name":"39_01__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_02__walk.bvh","name":"39_02__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_03__walk.bvh","name":"39_03__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_04__walk.bvh","name":"39_04__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_05__walk.bvh","name":"39_05__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_06__walk.bvh","name":"39_06__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_07__walk.bvh","name":"39_07__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_08__walk.bvh","name":"39_08__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_09__walk.bvh","name":"39_09__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_10__walk.bvh","name":"39_10__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_11__walk forward, turn around, walk back.bvh","name":"39_11__walk forward, turn around, walk back"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_12__walk.bvh","name":"39_12__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_13__walk.bvh","name":"39_13__walk"},
{"file":"@3\\39 climb, swing, hang on playground equipment\\39_14__walk.bvh","name":"39_14__walk"},
{"file":"@4\\42 stretch\\42_01__stretch - rotate head, shoulders, arms, legs.bvh","name":"42_01__stretch - rotate head, shoulders, arms, legs"},
{"file":"@4\\45-47 walk\\45_01__walk.bvh","name":"45_01__walk"},
{"file":"@4\\45-47 walk\\46_01__walk.bvh","name":"46_01__walk"},
{"file":"@4\\49 modern dance, gymnastics\\49_01__walk.bvh","name":"49_01__walk"},
{"file":"@4\\49 modern dance, gymnastics\\49_04__run, leap.bvh","name":"49_04__run, leap"},
{"file":"@4\\49 modern dance, gymnastics\\49_05__run, leap.bvh","name":"49_05__run, leap"},
{"file":"@4\\49 modern dance, gymnastics\\49_06__cartwheel.bvh","name":"49_06__cartwheel"},
{"file":"@4\\49 modern dance, gymnastics\\49_07__cartwheel.bvh","name":"49_07__cartwheel"},
{"file":"@4\\49 modern dance, gymnastics\\49_08__cartwheels.bvh","name":"49_08__cartwheels"},
{"file":"@4\\49 modern dance, gymnastics\\49_11__dance - fold in from side arabesque, curl inwards.bvh","name":"49_11__dance - fold in from side arabesque, curl inwards"},
{"file":"@4\\49 modern dance, gymnastics\\49_12__dance - lean forward, bring back leg forward, arching arms.bvh","name":"49_12__dance - lean forward, bring back leg forward, arching arms"},
{"file":"@4\\49 modern dance, gymnastics\\49_13__dance - fold in from side arabesque, curl inwards.bvh","name":"49_13__dance - fold in from side arabesque, curl inwards"},
{"file":"@4\\49 modern dance, gymnastics\\49_14__dance - lean forward, bring back leg forward, arching arms.bvh","name":"49_14__dance - lean forward, bring back leg forward, arching arms"},
{"file":"@4\\49 modern dance, gymnastics\\49_15__static dance pose - folded in, head lowered, leg bent.bvh","name":"49_15__static dance pose - folded in, head lowered, leg bent"},
{"file":"@4\\49 modern dance, gymnastics\\49_16__dance - fold in from side arabesque, curl inwards.bvh","name":"49_16__dance - fold in from side arabesque, curl inwards"},
{"file":"@4\\49 modern dance, gymnastics\\49_17__dance - lean forward, bring back leg forward, arching arms.bvh","name":"49_17__dance - lean forward, bring back leg forward, arching arms"},
{"file":"@4\\49 modern dance, gymnastics\\49_18__balance on one leg, outstretched arms.bvh","name":"49_18__balance on one leg, outstretched arms"},
{"file":"@4\\49 modern dance, gymnastics\\49_19__balance on one leg, outstretched arms.bvh","name":"49_19__balance on one leg, outstretched arms"},
{"file":"@4\\49 modern dance, gymnastics\\49_20__balance on one leg, outstretched arms.bvh","name":"49_20__balance on one leg, outstretched arms"},
{"file":"@4\\54 animal behaviors, pantomime\\54_05__pterosaur (human subject).bvh","name":"54_05__pterosaur (human subject)"},
{"file":"@4\\55 animal behaviors, pantomime\\55_04__walk.bvh","name":"55_04__walk"},
{"file":"@4\\60 salsa\\60_10__salsa dance.bvh","name":"60_10__salsa dance"},
{"file":"@4\\61 salsa\\61_10__salsa dance.bvh","name":"61_10__salsa dance"},
{"file":"@4\\69 walking\\69_01__walk forward.bvh","name":"69_01__walk forward"},
{"file":"@4\\69 walking\\69_02__walk forward.bvh","name":"69_02__walk forward"},
{"file":"@4\\69 walking\\69_03__walk forward.bvh","name":"69_03__walk forward"},
{"file":"@4\\69 walking\\69_04__walk forward.bvh","name":"69_04__walk forward"},
{"file":"@4\\69 walking\\69_05__walk forward.bvh","name":"69_05__walk forward"},
{"file":"@4\\69 walking\\69_20__walk forward 90 degree right turn.bvh","name":"69_20__walk forward 90 degree right turn"},
{"file":"@4\\69 walking\\69_21__walk forward 90 degree right turn.bvh","name":"69_21__walk forward 90 degree right turn"},
{"file":"@4\\69 walking\\69_22__walk forward 90 degree right turn.bvh","name":"69_22__walk forward 90 degree right turn"},
{"file":"@4\\69 walking\\69_23__walk forward 90 degree right turn.bvh","name":"69_23__walk forward 90 degree right turn"},
{"file":"@4\\69 walking\\69_24__walk forward 90 degree left turn.bvh","name":"69_24__walk forward 90 degree left turn"},
{"file":"@4\\69 walking\\69_25__walk forward 90 degree left turn.bvh","name":"69_25__walk forward 90 degree left turn"},
{"file":"@4\\69 walking\\69_26__walk forward 90 degree left turn.bvh","name":"69_26__walk forward 90 degree left turn"},
{"file":"@4\\69 walking\\69_27__walk forward 90 degree left turn.bvh","name":"69_27__walk forward 90 degree left turn"},
{"file":"@4\\69 walking\\69_28__walk forward 90 degree smooth right turn.bvh","name":"69_28__walk forward 90 degree smooth right turn"},
{"file":"@4\\69 walking\\69_29__walk forward 90 degree smooth right turn.bvh","name":"69_29__walk forward 90 degree smooth right turn"},
{"file":"@4\\69 walking\\69_30__walk forward 90 degree smooth right turn.bvh","name":"69_30__walk forward 90 degree smooth right turn"},
{"file":"@4\\69 walking\\69_31__walk forward 90 degree smooth left turn.bvh","name":"69_31__walk forward 90 degree smooth left turn"},
{"file":"@4\\69 walking\\69_32__walk forward 90 degree smooth left turn.bvh","name":"69_32__walk forward 90 degree smooth left turn"},
{"file":"@4\\69 walking\\69_33__walk forward 90 degree smooth left turn.bvh","name":"69_33__walk forward 90 degree smooth left turn"},
{"file":"@4\\69 walking\\69_50__walk sideways and backwards.bvh","name":"69_50__walk sideways and backwards"},
{"file":"@4\\69 walking\\69_51__walk backwards and turn.bvh","name":"69_51__walk backwards and turn"},
{"file":"@4\\69 walking\\69_52__walk backwards and turn.bvh","name":"69_52__walk backwards and turn"},
{"file":"@4\\69 walking\\69_53__walk backwards and turn.bvh","name":"69_53__walk backwards and turn"},
{"file":"@4\\69 walking\\69_54__walk backwards and turn.bvh","name":"69_54__walk backwards and turn"},
{"file":"@4\\69 walking\\69_55__walk backwards and turn.bvh","name":"69_55__walk backwards and turn"},
{"file":"@4\\69 walking\\69_57__walk sideways and turn (opposite direction).bvh","name":"69_57__walk sideways and turn (opposite direction)"},
{"file":"@4\\69 walking\\69_58__walk sideways and turn (opposite direction).bvh","name":"69_58__walk sideways and turn (opposite direction)"},
{"file":"@4\\69 walking\\69_59__walk sideways and turn.bvh","name":"69_59__walk sideways and turn"},
{"file":"@4\\69 walking\\69_60__walk sideways and turn.bvh","name":"69_60__walk sideways and turn"},
{"file":"@4\\69 walking\\69_61__walk sideways and turn.bvh","name":"69_61__walk sideways and turn"},
{"file":"@4\\69 walking\\69_62__walk sideways and turn (opposite direction).bvh","name":"69_62__walk sideways and turn (opposite direction)"},
{"file":"@4\\69 walking\\69_63__walk sideways and turn (opposite direction).bvh","name":"69_63__walk sideways and turn (opposite direction)"},
{"file":"@4\\69 walking\\69_64__walk sideways and turn (opposite direction).bvh","name":"69_64__walk sideways and turn (opposite direction)"},
{"file":"@4\\69 walking\\69_65__walk sideways and turn.bvh","name":"69_65__walk sideways and turn"},
{"file":"@4\\69 walking\\69_66__walk sideways and turn.bvh","name":"69_66__walk sideways and turn"},
{"file":"@4\\69 walking\\69_67__walk sideways and turn.bvh","name":"69_67__walk sideways and turn"},
{"file":"@4\\73\\73_01.bvh","name":"73_01"},
{"file":"@4\\73\\73_02.bvh","name":"73_02"},
{"file":"@4\\73\\73_05.bvh","name":"73_05"},
{"file":"@4\\73\\73_06.bvh","name":"73_06"},
{"file":"@4\\73\\73_08.bvh","name":"73_08"},
{"file":"@4\\73\\73_09.bvh","name":"73_09"},
{"file":"@4\\73\\73_10.bvh","name":"73_10"},
{"file":"@4\\73\\73_11.bvh","name":"73_11"},
{"file":"@4\\73\\73_12.bvh","name":"73_12"},
{"file":"@4\\73\\73_13.bvh","name":"73_13"},
{"file":"@4\\74 kicks and walking on slopes\\74_01__stiff walk.bvh","name":"74_01__stiff walk"},
{"file":"@4\\74 kicks and walking on slopes\\74_02__stiff walk.bvh","name":"74_02__stiff walk"},
{"file":"@4\\74 kicks and walking on slopes\\74_03__kick.bvh","name":"74_03__kick"},
{"file":"@4\\74 kicks and walking on slopes\\74_04__kick.bvh","name":"74_04__kick"},
{"file":"@4\\74 kicks and walking on slopes\\74_05__kick.bvh","name":"74_05__kick"},
{"file":"@4\\74 kicks and walking on slopes\\74_06__kick.bvh","name":"74_06__kick"},
{"file":"@4\\74 kicks and walking on slopes\\74_07__lifting up.bvh","name":"74_07__lifting up"},
{"file":"@4\\74 kicks and walking on slopes\\74_08__lifting up.bvh","name":"74_08__lifting up"},
{"file":"@4\\74 kicks and walking on slopes\\74_09__Unknown.bvh","name":"74_09__Unknown"},
{"file":"@4\\74 kicks and walking on slopes\\74_10__peeping.bvh","name":"74_10__peeping"},
{"file":"@4\\74 kicks and walking on slopes\\74_11__peeping.bvh","name":"74_11__peeping"},
{"file":"@4\\74 kicks and walking on slopes\\74_12__thinker.bvh","name":"74_12__thinker"},
{"file":"@4\\74 kicks and walking on slopes\\74_14__slope 1.bvh","name":"74_14__slope 1"},
{"file":"@4\\74 kicks and walking on slopes\\74_15__slope1.bvh","name":"74_15__slope1"},
{"file":"@4\\74 kicks and walking on slopes\\74_16__slope 2.bvh","name":"74_16__slope 2"},
{"file":"@4\\74 kicks and walking on slopes\\74_17__slope 2.bvh","name":"74_17__slope 2"},
{"file":"@4\\74 kicks and walking on slopes\\74_18__slope 3.bvh","name":"74_18__slope 3"},
{"file":"@4\\74 kicks and walking on slopes\\74_19__slope 3.bvh","name":"74_19__slope 3"},
{"file":"@4\\74 kicks and walking on slopes\\74_20__stiff walk.bvh","name":"74_20__stiff walk"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_01__run jump.bvh","name":"75_01__run jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_02__run jump.bvh","name":"75_02__run jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_03__run jump.bvh","name":"75_03__run jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_04__wide leg run.bvh","name":"75_04__wide leg run"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_05__cross leg run.bvh","name":"75_05__cross leg run"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_06__180 jump.bvh","name":"75_06__180 jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_07__angle jumps.bvh","name":"75_07__angle jumps"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_08__360 jumps.bvh","name":"75_08__360 jumps"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_09__360 jump.bvh","name":"75_09__360 jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_10__2 jump.bvh","name":"75_10__2 jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_11__2 jump.bvh","name":"75_11__2 jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_12__box jump.bvh","name":"75_12__box jump"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_13__hopscotch.bvh","name":"75_13__hopscotch"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_14__hopscotch.bvh","name":"75_14__hopscotch"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_16__jump kick.bvh","name":"75_16__jump kick"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_17__medium sit.bvh","name":"75_17__medium sit"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_18__high sit.bvh","name":"75_18__high sit"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_19__medium sit.bvh","name":"75_19__medium sit"},
{"file":"@4\\75 jumps, hopscotch, sits\\75_20__low sit.bvh","name":"75_20__low sit"},
{"file":"@4\\76 avoidance\\76_01__walk backwards then attack with a punch.bvh","name":"76_01__walk backwards then attack with a punch"},
{"file":"@4\\76 avoidance\\76_02__walk backwards, feign a few attacks, then attack.bvh","name":"76_02__walk backwards, feign a few attacks, then attack"},
{"file":"@4\\76 avoidance\\76_03__avoid attacker.bvh","name":"76_03__avoid attacker"},
{"file":"@4\\76 avoidance\\76_04__defensive guard pose.bvh","name":"76_04__defensive guard pose"},
{"file":"@4\\76 avoidance\\76_05__swatting at pesky bug.bvh","name":"76_05__swatting at pesky bug"},
{"file":"@4\\76 avoidance\\76_06__avoid stepping on something.bvh","name":"76_06__avoid stepping on something"},
{"file":"@4\\76 avoidance\\76_07__Unknown.bvh","name":"76_07__Unknown"},
{"file":"@4\\76 avoidance\\76_11__quick large steps backwards.bvh","name":"76_11__quick large steps backwards"},
{"file":"@4\\77 careful actions\\77_02__standing.bvh","name":"77_02__standing"},
{"file":"@4\\77 careful actions\\77_04__Looking around.bvh","name":"77_04__Looking around"},
{"file":"@4\\77 careful actions\\77_05__look around with flashlight.bvh","name":"77_05__look around with flashlight"},
{"file":"@4\\77 careful actions\\77_07__poking ground.bvh","name":"77_07__poking ground"},
{"file":"@4\\77 careful actions\\77_10__careful run.bvh","name":"77_10__careful run"},
{"file":"@4\\77 careful actions\\77_11__careful run.bvh","name":"77_11__careful run"},
{"file":"@4\\77 careful actions\\77_12__careful run in circle.bvh","name":"77_12__careful run in circle"},
{"file":"@4\\77 careful actions\\77_16__laying down, getting up, careful ready pose.bvh","name":"77_16__laying down, getting up, careful ready pose"},
{"file":"@4\\77 careful actions\\77_17__laying down, getting up, careful ready pose.bvh","name":"77_17__laying down, getting up, careful ready pose"},
{"file":"@4\\77 careful actions\\77_18__laying down on back, getting up, careful ready pose.bvh","name":"77_18__laying down on back, getting up, careful ready pose"},
{"file":"@4\\77 careful actions\\77_24__limping, hurt right leg.bvh","name":"77_24__limping, hurt right leg"},
{"file":"@4\\77 careful actions\\77_25__careful walk and search.bvh","name":"77_25__careful walk and search"},
{"file":"@4\\77 careful actions\\77_26__careful walk and search.bvh","name":"77_26__careful walk and search"},
{"file":"@4\\77 careful actions\\77_27__careful walk and search.bvh","name":"77_27__careful walk and search"},
{"file":"@4\\78 walking\\78_01__LeftTightTurn CleanedGRS.bvh","name":"78_01__LeftTightTurn CleanedGRS"},
{"file":"@4\\78 walking\\78_02__RightWideTurn CleanedGRS.bvh","name":"78_02__RightWideTurn CleanedGRS"},
{"file":"@4\\78 walking\\78_03__LeftWideTurn CleanedGRS.bvh","name":"78_03__LeftWideTurn CleanedGRS"},
{"file":"@4\\78 walking\\78_04__SuperTightLeft CleanedGRS.bvh","name":"78_04__SuperTightLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_05__SuperTightRight CleanedGRS.bvh","name":"78_05__SuperTightRight CleanedGRS"},
{"file":"@4\\78 walking\\78_06__RunningStraight CleanedGRS.bvh","name":"78_06__RunningStraight CleanedGRS"},
{"file":"@4\\78 walking\\78_07__RunningWideRight CleanedGRS.bvh","name":"78_07__RunningWideRight CleanedGRS"},
{"file":"@4\\78 walking\\78_08__RunningWideLeft CleanedGRS.bvh","name":"78_08__RunningWideLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_09__RunningTigherLeft CleanedGRS.bvh","name":"78_09__RunningTigherLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_10__RunningTighterRight CleanedGRS.bvh","name":"78_10__RunningTighterRight CleanedGRS"},
{"file":"@4\\78 walking\\78_11__calibration.bvh","name":"78_11__calibration"},
{"file":"@4\\78 walking\\78_12__RunningNoBall CleanedGRS.bvh","name":"78_12__RunningNoBall CleanedGRS"},
{"file":"@4\\78 walking\\78_13__OffensiveMoveSpinLeft CleanedGRS.bvh","name":"78_13__OffensiveMoveSpinLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_14__OffensiveMoveSpinLeft CleanedGRS.bvh","name":"78_14__OffensiveMoveSpinLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_15__OffensiveMoveGoRight CleanedGRS.bvh","name":"78_15__OffensiveMoveGoRight CleanedGRS"},
{"file":"@4\\78 walking\\78_16__OffensiveMoveGoLeft CleanedGRs.bvh","name":"78_16__OffensiveMoveGoLeft CleanedGRs"},
{"file":"@4\\78 walking\\78_17__OffensiveMoveSpinRight CleanedGRS.bvh","name":"78_17__OffensiveMoveSpinRight CleanedGRS"},
{"file":"@4\\78 walking\\78_18__WalkEvasiveLeft CleanedGRS.bvh","name":"78_18__WalkEvasiveLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_19__WalkEvasiveRight CleanedGRS.bvh","name":"78_19__WalkEvasiveRight CleanedGRS"},
{"file":"@4\\78 walking\\78_20__FeintLeftMoveRight CleanedGRS.bvh","name":"78_20__FeintLeftMoveRight CleanedGRS"},
{"file":"@4\\78 walking\\78_21__FeintRightMoveLeft CleanedGRS.bvh","name":"78_21__FeintRightMoveLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_22__FakeShotBreakRight CleanedGRs.bvh","name":"78_22__FakeShotBreakRight CleanedGRs"},
{"file":"@4\\78 walking\\78_23__FakeShotBreakLeft CleanedGRS.bvh","name":"78_23__FakeShotBreakLeft CleanedGRS"},
{"file":"@4\\78 walking\\78_24__DefensiveStraightNoStop CleanedGRS.bvh","name":"78_24__DefensiveStraightNoStop CleanedGRS"},
{"file":"@4\\78 walking\\78_25__DefensiveStraightWithStop CleanedGRS.bvh","name":"78_25__DefensiveStraightWithStop CleanedGRS"},
{"file":"@4\\78 walking\\78_26__DefensiveRightStopToStop CleanedGRS.bvh","name":"78_26__DefensiveRightStopToStop CleanedGRS"},
{"file":"@4\\78 walking\\78_27__DefensiveLeftStopToStop CleanedGRS.bvh","name":"78_27__DefensiveLeftStopToStop CleanedGRS"},
{"file":"@4\\78 walking\\78_28__DefensiveMoveZigZag CleanedGRS.bvh","name":"78_28__DefensiveMoveZigZag CleanedGRS"},
{"file":"@4\\78 walking\\78_29__DefensiveMoveSideToSide CleanedGRS.bvh","name":"78_29__DefensiveMoveSideToSide CleanedGRS"},
{"file":"@4\\78 walking\\78_30__DefensiveMoveSideToSide CleanedGRS.bvh","name":"78_30__DefensiveMoveSideToSide CleanedGRS"},
{"file":"@4\\78 walking\\78_31__Pivoting CleanedGRS.bvh","name":"78_31__Pivoting CleanedGRS"},
{"file":"@4\\78 walking\\78_32__SraightDriveFromStop Cleaned GRS.bvh","name":"78_32__SraightDriveFromStop Cleaned GRS"},
{"file":"@4\\78 walking\\78_33__RightDrive (left then right) Cleaned GRS.bvh","name":"78_33__RightDrive (left then right) Cleaned GRS"},
{"file":"@4\\78 walking\\78_34__LeftDrive (right then left) Cleaned GRS.bvh","name":"78_34__LeftDrive (right then left) Cleaned GRS"},
{"file":"@4\\78 walking\\78_35__RightTightTurn CleanedGRS.bvh","name":"78_35__RightTightTurn CleanedGRS"},
{"file":"@4\\79 actor everyday activities\\79_01__chopping wood.bvh","name":"79_01__chopping wood"},
{"file":"@4\\79 actor everyday activities\\79_02__swimming.bvh","name":"79_02__swimming"},
{"file":"@4\\79 actor everyday activities\\79_03__swimming.bvh","name":"79_03__swimming"},
{"file":"@4\\79 actor everyday activities\\79_04__digging.bvh","name":"79_04__digging"},
{"file":"@4\\79 actor everyday activities\\79_05__sewing.bvh","name":"79_05__sewing"},
{"file":"@4\\79 actor everyday activities\\79_06__hand shake.bvh","name":"79_06__hand shake"},
{"file":"@4\\79 actor everyday activities\\79_07__lost marker.bvh","name":"79_07__lost marker"},
{"file":"@4\\79 actor everyday activities\\79_08__boxing.bvh","name":"79_08__boxing"},
{"file":"@4\\79 actor everyday activities\\79_09__slicing bread.bvh","name":"79_09__slicing bread"},
{"file":"@4\\79 actor everyday activities\\79_10__chopping onions.bvh","name":"79_10__chopping onions"},
{"file":"@4\\79 actor everyday activities\\79_11__Subject calibration.bvh","name":"79_11__Subject calibration"},
{"file":"@4\\79 actor everyday activities\\79_12__eating dinner.bvh","name":"79_12__eating dinner"},
{"file":"@4\\79 actor everyday activities\\79_13__mixing batter.bvh","name":"79_13__mixing batter"},
{"file":"@4\\79 actor everyday activities\\79_14__making dough.bvh","name":"79_14__making dough"},
{"file":"@4\\79 actor everyday activities\\79_15__eating a sandwich.bvh","name":"79_15__eating a sandwich"},
{"file":"@4\\79 actor everyday activities\\79_16__buying something.bvh","name":"79_16__buying something"},
{"file":"@4\\79 actor everyday activities\\79_17__playing violin.bvh","name":"79_17__playing violin"},
{"file":"@4\\79 actor everyday activities\\79_18__playing drums.bvh","name":"79_18__playing drums"},
{"file":"@4\\79 actor everyday activities\\79_19__playing piano.bvh","name":"79_19__playing piano"},
{"file":"@4\\79 actor everyday activities\\79_20__hanging a picture.bvh","name":"79_20__hanging a picture"},
{"file":"@4\\79 actor everyday activities\\79_21__putting on a pull over.bvh","name":"79_21__putting on a pull over"},
{"file":"@4\\79 actor everyday activities\\79_22__range of motion.bvh","name":"79_22__range of motion"},
{"file":"@4\\79 actor everyday activities\\79_23__putting on a jacket.bvh","name":"79_23__putting on a jacket"},
{"file":"@4\\79 actor everyday activities\\79_24__putting on button up sweater.bvh","name":"79_24__putting on button up sweater"},
{"file":"@4\\79 actor everyday activities\\79_25__moving heavy box.bvh","name":"79_25__moving heavy box"},
{"file":"@4\\79 actor everyday activities\\79_26__planting a tree.bvh","name":"79_26__planting a tree"},
{"file":"@4\\79 actor everyday activities\\79_27__planting a plant.bvh","name":"79_27__planting a plant"},
{"file":"@4\\79 actor everyday activities\\79_28__putting on a ball cap.bvh","name":"79_28__putting on a ball cap"},
{"file":"@4\\79 actor everyday activities\\79_29__putting on a dress.bvh","name":"79_29__putting on a dress"},
{"file":"@4\\79 actor everyday activities\\79_30__pushing a swing.bvh","name":"79_30__pushing a swing"},
{"file":"@4\\79 actor everyday activities\\79_31__writing on a chalkboard.bvh","name":"79_31__writing on a chalkboard"},
{"file":"@4\\79 actor everyday activities\\79_32__writing on a chalkboard.bvh","name":"79_32__writing on a chalkboard"},
{"file":"@4\\79 actor everyday activities\\79_33__chug a beer.bvh","name":"79_33__chug a beer"},
{"file":"@4\\79 actor everyday activities\\79_34__fishing.bvh","name":"79_34__fishing"},
{"file":"@4\\79 actor everyday activities\\79_35__fishing.bvh","name":"79_35__fishing"},
{"file":"@4\\79 actor everyday activities\\79_36__answering the phone.bvh","name":"79_36__answering the phone"},
{"file":"@4\\79 actor everyday activities\\79_37__dialing phone.bvh","name":"79_37__dialing phone"},
{"file":"@4\\79 actor everyday activities\\79_38__drinking water.bvh","name":"79_38__drinking water"},
{"file":"@4\\79 actor everyday activities\\79_40__drinking a soda.bvh","name":"79_40__drinking a soda"},
{"file":"@4\\79 actor everyday activities\\79_41__sipping coffee.bvh","name":"79_41__sipping coffee"},
{"file":"@4\\79 actor everyday activities\\79_42__eating soup.bvh","name":"79_42__eating soup"},
{"file":"@4\\79 actor everyday activities\\79_43__painting.bvh","name":"79_43__painting"},
{"file":"@4\\79 actor everyday activities\\79_44__washing a window.bvh","name":"79_44__washing a window"},
{"file":"@4\\79 actor everyday activities\\79_45__bear.bvh","name":"79_45__bear"},
{"file":"@4\\79 actor everyday activities\\79_49__monkey.bvh","name":"79_49__monkey"},
{"file":"@4\\79 actor everyday activities\\79_50__mouse.bvh","name":"79_50__mouse"},
{"file":"@4\\79 actor everyday activities\\79_51__chipmunk.bvh","name":"79_51__chipmunk"},
{"file":"@4\\79 actor everyday activities\\79_52__prairie dog.bvh","name":"79_52__prairie dog"},
{"file":"@4\\79 actor everyday activities\\79_53__dog.bvh","name":"79_53__dog"},
{"file":"@4\\79 actor everyday activities\\79_54__snake.bvh","name":"79_54__snake"},
{"file":"@4\\79 actor everyday activities\\79_55__sweeping.bvh","name":"79_55__sweeping"},
{"file":"@4\\79 actor everyday activities\\79_56__T-rex.bvh","name":"79_56__T-rex"},
{"file":"@4\\79 actor everyday activities\\79_57__fish.bvh","name":"79_57__fish"},
{"file":"@4\\79 actor everyday activities\\79_58__bird.bvh","name":"79_58__bird"},
{"file":"@4\\79 actor everyday activities\\79_59__cat.bvh","name":"79_59__cat"},
{"file":"@4\\79 actor everyday activities\\79_60__chicken.bvh","name":"79_60__chicken"},
{"file":"@4\\79 actor everyday activities\\79_61__cow.bvh","name":"79_61__cow"},
{"file":"@4\\79 actor everyday activities\\79_62__chicken.bvh","name":"79_62__chicken"},
{"file":"@4\\79 actor everyday activities\\79_63__tiger.bvh","name":"79_63__tiger"},
{"file":"@4\\79 actor everyday activities\\79_64__penguin.bvh","name":"79_64__penguin"},
{"file":"@4\\79 actor everyday activities\\79_65__horse.bvh","name":"79_65__horse"},
{"file":"@4\\79 actor everyday activities\\79_66__movie and trial dont match.bvh","name":"79_66__movie and trial dont match"},
{"file":"@4\\79 actor everyday activities\\79_68__cold.bvh","name":"79_68__cold"},
{"file":"@4\\79 actor everyday activities\\79_69__very happy.bvh","name":"79_69__very happy"},
{"file":"@4\\79 actor everyday activities\\79_70__laughing.bvh","name":"79_70__laughing"},
{"file":"@4\\79 actor everyday activities\\79_71__sad.bvh","name":"79_71__sad"},
{"file":"@4\\79 actor everyday activities\\79_72__crying.bvh","name":"79_72__crying"},
{"file":"@4\\79 actor everyday activities\\79_73__scared.bvh","name":"79_73__scared"},
{"file":"@4\\79 actor everyday activities\\79_74__upset.bvh","name":"79_74__upset"},
{"file":"@4\\79 actor everyday activities\\79_77__vacuuming.bvh","name":"79_77__vacuuming"},
{"file":"@4\\79 actor everyday activities\\79_79__putting on headphones.bvh","name":"79_79__putting on headphones"},
{"file":"@4\\79 actor everyday activities\\79_80__using a palm pilot.bvh","name":"79_80__using a palm pilot"},
{"file":"@4\\79 actor everyday activities\\79_81__brushing teeth.bvh","name":"79_81__brushing teeth"},
{"file":"@4\\79 actor everyday activities\\79_82__putting on deoderant.bvh","name":"79_82__putting on deoderant"},
{"file":"@4\\79 actor everyday activities\\79_83__shaving.bvh","name":"79_83__shaving"},
{"file":"@4\\79 actor everyday activities\\79_84__combing hair.bvh","name":"79_84__combing hair"},
{"file":"@4\\79 actor everyday activities\\79_85__typing on a laptop.bvh","name":"79_85__typing on a laptop"},
{"file":"@4\\79 actor everyday activities\\79_86__shooting bow and arrow.bvh","name":"79_86__shooting bow and arrow"},
{"file":"@4\\79 actor everyday activities\\79_87__raking.bvh","name":"79_87__raking"},
{"file":"@4\\79 actor everyday activities\\79_88__swatting at a fly.bvh","name":"79_88__swatting at a fly"},
{"file":"@4\\79 actor everyday activities\\79_91__football.bvh","name":"79_91__football"},
{"file":"@4\\79 actor everyday activities\\79_92__frisbee.bvh","name":"79_92__frisbee"},
{"file":"@4\\79 actor everyday activities\\79_93__weight lifting.bvh","name":"79_93__weight lifting"},
{"file":"@4\\79 actor everyday activities\\79_94__flexing.bvh","name":"79_94__flexing"},
{"file":"@4\\79 actor everyday activities\\79_95__rowing.bvh","name":"79_95__rowing"},
{"file":"@4\\79 actor everyday activities\\79_96__shooting a gun.bvh","name":"79_96__shooting a gun"},
{"file":"@5\\102 Basketball\\102_01__RightWideTurn.bvh","name":"102_01__RightWideTurn"},
{"file":"@5\\102 Basketball\\102_02__LeftWideTurn.bvh","name":"102_02__LeftWideTurn"},
{"file":"@5\\102 Basketball\\102_03__SuperTightLeft.bvh","name":"102_03__SuperTightLeft"},
{"file":"@5\\102 Basketball\\102_04__SuperTightRight.bvh","name":"102_04__SuperTightRight"},
{"file":"@5\\102 Basketball\\102_05__RunningStraight.bvh","name":"102_05__RunningStraight"},
{"file":"@5\\102 Basketball\\102_06__RunningWideRight.bvh","name":"102_06__RunningWideRight"},
{"file":"@5\\102 Basketball\\102_07__RunningWideLeft.bvh","name":"102_07__RunningWideLeft"},
{"file":"@5\\102 Basketball\\102_08__RunningTighterRight.bvh","name":"102_08__RunningTighterRight"},
{"file":"@5\\102 Basketball\\102_09__calibration.bvh","name":"102_09__calibration"},
{"file":"@5\\102 Basketball\\102_10__RunningNoBall.bvh","name":"102_10__RunningNoBall"},
{"file":"@5\\102 Basketball\\102_11__OffensiveMoveSpinLeft.bvh","name":"102_11__OffensiveMoveSpinLeft"},
{"file":"@5\\102 Basketball\\102_12__OffensiveMoveSpinLeft.bvh","name":"102_12__OffensiveMoveSpinLeft"},
{"file":"@5\\102 Basketball\\102_13__OffensiveMoveGoRight.bvh","name":"102_13__OffensiveMoveGoRight"},
{"file":"@5\\102 Basketball\\102_14__OffensiveMoveGoLeft.bvh","name":"102_14__OffensiveMoveGoLeft"},
{"file":"@5\\102 Basketball\\102_15__OffensiveMoveSpinRight.bvh","name":"102_15__OffensiveMoveSpinRight"},
{"file":"@5\\102 Basketball\\102_16__WalkEvasiveLeft.bvh","name":"102_16__WalkEvasiveLeft"},
{"file":"@5\\102 Basketball\\102_17__WalkEvasiveRight.bvh","name":"102_17__WalkEvasiveRight"},
{"file":"@5\\102 Basketball\\102_18__FeintLeftMoveRight.bvh","name":"102_18__FeintLeftMoveRight"},
{"file":"@5\\102 Basketball\\102_19__FeintRightMoveLeft.bvh","name":"102_19__FeintRightMoveLeft"},
{"file":"@5\\102 Basketball\\102_20__FakeShotBreakRight.bvh","name":"102_20__FakeShotBreakRight"},
{"file":"@5\\102 Basketball\\102_21__FakeShotBreakLeft.bvh","name":"102_21__FakeShotBreakLeft"},
{"file":"@5\\102 Basketball\\102_22__DefensiveStraightNoStop.bvh","name":"102_22__DefensiveStraightNoStop"},
{"file":"@5\\102 Basketball\\102_23__DefensiveStraightWithStop.bvh","name":"102_23__DefensiveStraightWithStop"},
{"file":"@5\\102 Basketball\\102_24__DefensiveRightStopToStop.bvh","name":"102_24__DefensiveRightStopToStop"},
{"file":"@5\\102 Basketball\\102_25__DefensiveLeftStopToStop.bvh","name":"102_25__DefensiveLeftStopToStop"},
{"file":"@5\\102 Basketball\\102_26__DefensiveMoveZigZag.bvh","name":"102_26__DefensiveMoveZigZag"},
{"file":"@5\\102 Basketball\\102_27__DefensiveMoveSideToSide.bvh","name":"102_27__DefensiveMoveSideToSide"},
{"file":"@5\\102 Basketball\\102_28__DefensiveMoveSideToSide.bvh","name":"102_28__DefensiveMoveSideToSide"},
{"file":"@5\\102 Basketball\\102_29__Pivoting.bvh","name":"102_29__Pivoting"},
{"file":"@5\\102 Basketball\\102_30__SraightDriveFromStop.bvh","name":"102_30__SraightDriveFromStop"},
{"file":"@5\\102 Basketball\\102_31__RightDrive (left then right).bvh","name":"102_31__RightDrive (left then right)"},
{"file":"@5\\102 Basketball\\102_32__LeftDrive (right then left).bvh","name":"102_32__LeftDrive (right then left)"},
{"file":"@5\\102 Basketball\\102_33__RightTightTurn.bvh","name":"102_33__RightTightTurn"},
{"file":"@5\\103 Charelston Dancing\\103_01__Unknown.bvh","name":"103_01__Unknown"},
{"file":"@5\\103 Charelston Dancing\\103_03__charleston_01.bvh","name":"103_03__charleston_01"},
{"file":"@5\\103 Charelston Dancing\\103_04__charleston_side_by_side_female.bvh","name":"103_04__charleston_side_by_side_female"},
{"file":"@5\\103 Charelston Dancing\\103_05__charleston_side_by_side_male.bvh","name":"103_05__charleston_side_by_side_male"},
{"file":"@5\\103 Charelston Dancing\\103_06__lindyHop2.bvh","name":"103_06__lindyHop2"},
{"file":"@5\\103 Charelston Dancing\\103_07__Casual Walk.bvh","name":"103_07__Casual Walk"},
{"file":"@5\\103 Charelston Dancing\\103_08__xtra fancY charleston.bvh","name":"103_08__xtra fancY charleston"},
{"file":"@5\\104 motion\\104_01__JogThrough.bvh","name":"104_01__JogThrough"},
{"file":"@5\\104 motion\\104_02__neutral Male walk, exact footfalls.bvh","name":"104_02__neutral Male walk, exact footfalls"},
{"file":"@5\\104 motion\\104_04__JogThrough.bvh","name":"104_04__JogThrough"},
{"file":"@5\\104 motion\\104_05__Unknown.bvh","name":"104_05__Unknown"},
{"file":"@5\\104 motion\\104_06__StartJog.bvh","name":"104_06__StartJog"},
{"file":"@5\\104 motion\\104_08__StartJog.bvh","name":"104_08__StartJog"},
{"file":"@5\\104 motion\\104_09__JogStop.bvh","name":"104_09__JogStop"},
{"file":"@5\\104 motion\\104_10__JogStop.bvh","name":"104_10__JogStop"},
{"file":"@5\\104 motion\\104_11__HappyGoLuckWalk.bvh","name":"104_11__HappyGoLuckWalk"},
{"file":"@5\\104 motion\\104_12__ExcitedWalk.bvh","name":"104_12__ExcitedWalk"},
{"file":"@5\\104 motion\\104_13__StumbleWalk.bvh","name":"104_13__StumbleWalk"},
{"file":"@5\\104 motion\\104_14__HappyStartWalk.bvh","name":"104_14__HappyStartWalk"},
{"file":"@5\\104 motion\\104_15__Unknown.bvh","name":"104_15__Unknown"},
{"file":"@5\\104 motion\\104_16__SpasticWalk.bvh","name":"104_16__SpasticWalk"},
{"file":"@5\\104 motion\\104_17__SpasticStop.bvh","name":"104_17__SpasticStop"},
{"file":"@5\\104 motion\\104_18__SpasticStop.bvh","name":"104_18__SpasticStop"},
{"file":"@5\\104 motion\\104_19__CasualWalk.bvh","name":"104_19__CasualWalk"},
{"file":"@5\\104 motion\\104_20__Unknown.bvh","name":"104_20__Unknown"},
{"file":"@5\\104 motion\\104_21__Unknown.bvh","name":"104_21__Unknown"},
{"file":"@5\\104 motion\\104_26__Unknown.bvh","name":"104_26__Unknown"},
{"file":"@5\\104 motion\\104_28__SternWalk.bvh","name":"104_28__SternWalk"},
{"file":"@5\\104 motion\\104_29__SternWalk.bvh","name":"104_29__SternWalk"},
{"file":"@5\\104 motion\\104_34__Unknown.bvh","name":"104_34__Unknown"},
{"file":"@5\\104 motion\\104_35__SlowWalk.bvh","name":"104_35__SlowWalk"},
{"file":"@5\\104 motion\\104_37__RunThrough.bvh","name":"104_37__RunThrough"},
{"file":"@5\\104 motion\\104_44__AttitudeWalk.bvh","name":"104_44__AttitudeWalk"},
{"file":"@5\\104 motion\\104_48__RunThrough.bvh","name":"104_48__RunThrough"},
{"file":"@5\\104 motion\\104_53__StartRun.bvh","name":"104_53__StartRun"},
{"file":"@5\\104 motion\\104_54__StartRun.bvh","name":"104_54__StartRun"},
{"file":"@5\\104 motion\\104_55__StartRun.bvh","name":"104_55__StartRun"},
{"file":"@5\\104 motion\\104_56__RunStop.bvh","name":"104_56__RunStop"},
{"file":"@5\\104 motion\\104_57__RunStop.bvh","name":"104_57__RunStop"},
{"file":"@5\\105 motion\\105_06__MotorCyclePose.bvh","name":"105_06__MotorCyclePose"},
{"file":"@5\\105 motion\\105_36__WalkStraight.bvh","name":"105_36__WalkStraight"},
{"file":"@5\\105 motion\\105_37__Forward.bvh","name":"105_37__Forward"},
{"file":"@5\\105 motion\\105_38__SmallForward.bvh","name":"105_38__SmallForward"},
{"file":"@5\\105 motion\\105_39__JumpForward.bvh","name":"105_39__JumpForward"},
{"file":"@5\\105 motion\\105_40__JumpForward.bvh","name":"105_40__JumpForward"},
{"file":"@5\\105 motion\\105_41__JumpForward.bvh","name":"105_41__JumpForward"},
{"file":"@5\\105 motion\\105_42__JumpForward.bvh","name":"105_42__JumpForward"},
{"file":"@5\\105 motion\\105_43__JumpSmallForward.bvh","name":"105_43__JumpSmallForward"},
{"file":"@5\\105 motion\\105_44__JumpSmallForward.bvh","name":"105_44__JumpSmallForward"},
{"file":"@5\\105 motion\\105_45__JumpForward.bvh","name":"105_45__JumpForward"},
{"file":"@5\\105 motion\\105_46__Jump Turn.bvh","name":"105_46__Jump Turn"},
{"file":"@5\\105 motion\\105_47__Jump Turn.bvh","name":"105_47__Jump Turn"},
{"file":"@5\\105 motion\\105_48__JumpTurn.bvh","name":"105_48__JumpTurn"},
{"file":"@5\\105 motion\\105_49__Jump Turn.bvh","name":"105_49__Jump Turn"},
{"file":"@5\\105 motion\\105_50__JumpTurn.bvh","name":"105_50__JumpTurn"},
{"file":"@5\\105 motion\\105_51__FurtherJumpTurn.bvh","name":"105_51__FurtherJumpTurn"},
{"file":"@5\\105 motion\\105_52__SmallJumpTurn.bvh","name":"105_52__SmallJumpTurn"},
{"file":"@5\\105 motion\\105_53__180.bvh","name":"105_53__180"},
{"file":"@5\\105 motion\\105_54__180.bvh","name":"105_54__180"},
{"file":"@5\\105 motion\\105_55__180.bvh","name":"105_55__180"},
{"file":"@5\\105 motion\\105_56__90.bvh","name":"105_56__90"},
{"file":"@5\\105 motion\\105_57__WalkForward.bvh","name":"105_57__WalkForward"},
{"file":"@5\\105 motion\\105_58__270.bvh","name":"105_58__270"},
{"file":"@5\\105 motion\\105_59__360 smallStumble.bvh","name":"105_59__360 smallStumble"},
{"file":"@5\\105 motion\\105_60__360.bvh","name":"105_60__360"},
{"file":"@5\\105 motion\\105_61__360.bvh","name":"105_61__360"},
{"file":"@5\\106 Female General Subject\\106_01__clean.bvh","name":"106_01__clean"},
{"file":"@5\\106 Female General Subject\\106_02__clean.bvh","name":"106_02__clean"},
{"file":"@5\\106 Female General Subject\\106_03__clean.bvh","name":"106_03__clean"},
{"file":"@5\\106 Female General Subject\\106_04__clean.bvh","name":"106_04__clean"},
{"file":"@5\\106 Female General Subject\\106_05__clean.bvh","name":"106_05__clean"},
{"file":"@5\\106 Female General Subject\\106_06__clean.bvh","name":"106_06__clean"},
{"file":"@5\\106 Female General Subject\\106_07__clean.bvh","name":"106_07__clean"},
{"file":"@5\\106 Female General Subject\\106_08__clean.bvh","name":"106_08__clean"},
{"file":"@5\\106 Female General Subject\\106_09__clean.bvh","name":"106_09__clean"},
{"file":"@5\\106 Female General Subject\\106_10__clean.bvh","name":"106_10__clean"},
{"file":"@5\\106 Female General Subject\\106_11__clean.bvh","name":"106_11__clean"},
{"file":"@5\\106 Female General Subject\\106_12__clean.bvh","name":"106_12__clean"},
{"file":"@5\\106 Female General Subject\\106_13__clean.bvh","name":"106_13__clean"},
{"file":"@5\\106 Female General Subject\\106_14__clean.bvh","name":"106_14__clean"},
{"file":"@5\\106 Female General Subject\\106_15__106_15.amc.bvh","name":"106_15__106_15"},
{"file":"@5\\106 Female General Subject\\106_16__clean.bvh","name":"106_16__clean"},
{"file":"@5\\106 Female General Subject\\106_17__clean.bvh","name":"106_17__clean"},
{"file":"@5\\106 Female General Subject\\106_18__clean.bvh","name":"106_18__clean"},
{"file":"@5\\106 Female General Subject\\106_19__clean.bvh","name":"106_19__clean"},
{"file":"@5\\106 Female General Subject\\106_20__clean.bvh","name":"106_20__clean"},
{"file":"@5\\106 Female General Subject\\106_21__bad AMC.bvh","name":"106_21__bad AMC"},
{"file":"@5\\106 Female General Subject\\106_22__clean.bvh","name":"106_22__clean"},
{"file":"@5\\106 Female General Subject\\106_23__clean.bvh","name":"106_23__clean"},
{"file":"@5\\106 Female General Subject\\106_24__clean.bvh","name":"106_24__clean"},
{"file":"@5\\106 Female General Subject\\106_25__clean.bvh","name":"106_25__clean"},
{"file":"@5\\106 Female General Subject\\106_26__clean.bvh","name":"106_26__clean"},
{"file":"@5\\106 Female General Subject\\106_27__clean.bvh","name":"106_27__clean"},
{"file":"@5\\106 Female General Subject\\106_28__clean.bvh","name":"106_28__clean"},
{"file":"@5\\106 Female General Subject\\106_29__clean.bvh","name":"106_29__clean"},
{"file":"@5\\106 Female General Subject\\106_30__clean.bvh","name":"106_30__clean"},
{"file":"@5\\106 Female General Subject\\106_31__clean.bvh","name":"106_31__clean"},
{"file":"@5\\106 Female General Subject\\106_32__clean.bvh","name":"106_32__clean"},
{"file":"@5\\106 Female General Subject\\106_33__clean.bvh","name":"106_33__clean"},
{"file":"@5\\106 Female General Subject\\106_34__clean.bvh","name":"106_34__clean"},
{"file":"@5\\107 Walking with obstacles\\107_01__Unknown.bvh","name":"107_01__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_02__Unknown.bvh","name":"107_02__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_03__Unknown.bvh","name":"107_03__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_04__Unknown.bvh","name":"107_04__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_05__Unknown.bvh","name":"107_05__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_06__Unknown.bvh","name":"107_06__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_07__Unknown.bvh","name":"107_07__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_08__Unknown.bvh","name":"107_08__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_09__Unknown.bvh","name":"107_09__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_10__Unknown.bvh","name":"107_10__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_11__Unknown.bvh","name":"107_11__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_12__Unknown.bvh","name":"107_12__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_13__Unknown.bvh","name":"107_13__Unknown"},
{"file":"@5\\107 Walking with obstacles\\107_14__Unknown.bvh","name":"107_14__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_01__Unknown.bvh","name":"108_01__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_02__Unknown.bvh","name":"108_02__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_03__Unknown.bvh","name":"108_03__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_04__Unknown.bvh","name":"108_04__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_05__Unknown.bvh","name":"108_05__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_06__Unknown.bvh","name":"108_06__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_07__Unknown.bvh","name":"108_07__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_08__Unknown.bvh","name":"108_08__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_09__Unknown.bvh","name":"108_09__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_10__Unknown.bvh","name":"108_10__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_11__Unknown.bvh","name":"108_11__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_12__Unknown.bvh","name":"108_12__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_13__Unknown.bvh","name":"108_13__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_14__Unknown.bvh","name":"108_14__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_15__Unknown.bvh","name":"108_15__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_16__Unknown.bvh","name":"108_16__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_17__Unknown.bvh","name":"108_17__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_18__Unknown.bvh","name":"108_18__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_19__Unknown.bvh","name":"108_19__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_20__Unknown.bvh","name":"108_20__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_21__Unknown.bvh","name":"108_21__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_22__Unknown.bvh","name":"108_22__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_23__Unknown.bvh","name":"108_23__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_24__Unknown.bvh","name":"108_24__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_25__Unknown.bvh","name":"108_25__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_26__Unknown.bvh","name":"108_26__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_27__Unknown.bvh","name":"108_27__Unknown"},
{"file":"@5\\108 Walking with obstacles\\108_28__Unknown.bvh","name":"108_28__Unknown"},
{"file":"@5\\111 Pregnant Woman\\111_01__Walk backwards.bvh","name":"111_01__Walk backwards"},
{"file":"@5\\111 Pregnant Woman\\111_02__Bow.bvh","name":"111_02__Bow"},
{"file":"@5\\111 Pregnant Woman\\111_04__Curtsey.bvh","name":"111_04__Curtsey"},
{"file":"@5\\111 Pregnant Woman\\111_05__Dance.bvh","name":"111_05__Dance"},
{"file":"@5\\111 Pregnant Woman\\111_09__Get up from chair.bvh","name":"111_09__Get up from chair"},
{"file":"@5\\111 Pregnant Woman\\111_10__get up from chair.bvh","name":"111_10__get up from chair"},
{"file":"@5\\111 Pregnant Woman\\111_11__get up from chair.bvh","name":"111_11__get up from chair"},
{"file":"@5\\111 Pregnant Woman\\111_15__Motorcycle.bvh","name":"111_15__Motorcycle"},
{"file":"@5\\111 Pregnant Woman\\111_16__Peekaboo.bvh","name":"111_16__Peekaboo"},
{"file":"@5\\111 Pregnant Woman\\111_17__Pick up.bvh","name":"111_17__Pick up"},
{"file":"@5\\111 Pregnant Woman\\111_18__Pick up.bvh","name":"111_18__Pick up"},
{"file":"@5\\111 Pregnant Woman\\111_19__Punch Kick.bvh","name":"111_19__Punch Kick"},
{"file":"@5\\111 Pregnant Woman\\111_20__Ring around the rosie.bvh","name":"111_20__Ring around the rosie"},
{"file":"@5\\111 Pregnant Woman\\111_23__Run.bvh","name":"111_23__Run"},
{"file":"@5\\111 Pregnant Woman\\111_24__Run.bvh","name":"111_24__Run"},
{"file":"@5\\111 Pregnant Woman\\111_25__Shrug.bvh","name":"111_25__Shrug"},
{"file":"@5\\111 Pregnant Woman\\111_29__Stepping over.bvh","name":"111_29__Stepping over"},
{"file":"@5\\111 Pregnant Woman\\111_30__Stepping over.bvh","name":"111_30__Stepping over"},
{"file":"@5\\111 Pregnant Woman\\111_32__Stretch and yawn.bvh","name":"111_32__Stretch and yawn"},
{"file":"@5\\111 Pregnant Woman\\111_37__Wave.bvh","name":"111_37__Wave"},
{"file":"@5\\111 Pregnant Woman\\111_40__Yoga.bvh","name":"111_40__Yoga"},
{"file":"@5\\113 Post pregnant woman\\113_01__Walk backwards.bvh","name":"113_01__Walk backwards"},
{"file":"@5\\113 Post pregnant woman\\113_02__Bow.bvh","name":"113_02__Bow"},
{"file":"@5\\113 Post pregnant woman\\113_03__Curtsey.bvh","name":"113_03__Curtsey"},
{"file":"@5\\113 Post pregnant woman\\113_04__Dance.bvh","name":"113_04__Dance"},
{"file":"@5\\113 Post pregnant woman\\113_07__Run.bvh","name":"113_07__Run"},
{"file":"@5\\113 Post pregnant woman\\113_09__March.bvh","name":"113_09__March"},
{"file":"@5\\113 Post pregnant woman\\113_11__Motorcycle.bvh","name":"113_11__Motorcycle"},
{"file":"@5\\113 Post pregnant woman\\113_12__Peekaboo.bvh","name":"113_12__Peekaboo"},
{"file":"@5\\113 Post pregnant woman\\113_14__Ring around the rosie.bvh","name":"113_14__Ring around the rosie"},
{"file":"@5\\113 Post pregnant woman\\113_15__Sit in chair and get up.bvh","name":"113_15__Sit in chair and get up"},
{"file":"@5\\113 Post pregnant woman\\113_16__Shrug.bvh","name":"113_16__Shrug"},
{"file":"@5\\113 Post pregnant woman\\113_19__Walking up and down stairs.bvh","name":"113_19__Walking up and down stairs"},
{"file":"@5\\113 Post pregnant woman\\113_22__Step over.bvh","name":"113_22__Step over"},
{"file":"@5\\113 Post pregnant woman\\113_23__Stretch and yawn.bvh","name":"113_23__Stretch and yawn"},
{"file":"@5\\113 Post pregnant woman\\113_24__Throw.bvh","name":"113_24__Throw"},
{"file":"@5\\113 Post pregnant woman\\113_25__Walk.bvh","name":"113_25__Walk"},
{"file":"@5\\113 Post pregnant woman\\113_27__Wave.bvh","name":"113_27__Wave"},
{"file":"@5\\114 Pregnant Woman\\114_01__Motorcycle.bvh","name":"114_01__Motorcycle"},
{"file":"@5\\114 Pregnant Woman\\114_04__Getting up from chair.bvh","name":"114_04__Getting up from chair"},
{"file":"@5\\114 Pregnant Woman\\114_06__Getting up from chair.bvh","name":"114_06__Getting up from chair"},
{"file":"@5\\114 Pregnant Woman\\114_12__Stretching.bvh","name":"114_12__Stretching"},
{"file":"@5\\115 Bending over\\115_01__Pick up box, bend from waist.bvh","name":"115_01__Pick up box, bend from waist"},
{"file":"@5\\115 Bending over\\115_02__Pick box up, bend from waist.bvh","name":"115_02__Pick box up, bend from waist"},
{"file":"@5\\115 Bending over\\115_03__Pick box up, bend from waist.bvh","name":"115_03__Pick box up, bend from waist"},
{"file":"@5\\115 Bending over\\115_04__Pick box up, bend from waist.bvh","name":"115_04__Pick box up, bend from waist"},
{"file":"@5\\115 Bending over\\115_05__Pick box up, bend from waist.bvh","name":"115_05__Pick box up, bend from waist"},
{"file":"@5\\115 Bending over\\115_06__Picking box up, bending knees.bvh","name":"115_06__Picking box up, bending knees"},
{"file":"@5\\115 Bending over\\115_07__Picking box up, bending knees.bvh","name":"115_07__Picking box up, bending knees"},
{"file":"@5\\115 Bending over\\115_08__Picking box up, bending knees.bvh","name":"115_08__Picking box up, bending knees"},
{"file":"@5\\115 Bending over\\115_09__Picking box up, bending knees.bvh","name":"115_09__Picking box up, bending knees"},
{"file":"@5\\115 Bending over\\115_10__Pick box up, bend from waist.bvh","name":"115_10__Pick box up, bend from waist"},
{"file":"@5\\117\\117_01.bvh","name":"117_01"},
{"file":"@5\\117\\117_02.bvh","name":"117_02"},
{"file":"@5\\117\\117_06.bvh","name":"117_06"},
{"file":"@5\\117\\117_07.bvh","name":"117_07"},
{"file":"@5\\117\\117_08.bvh","name":"117_08"},
{"file":"@5\\117\\117_09.bvh","name":"117_09"},
{"file":"@5\\117\\117_10.bvh","name":"117_10"},
{"file":"@5\\118 Jumping\\118_01__Jump.bvh","name":"118_01__Jump"},
{"file":"@5\\118 Jumping\\118_02__Jump.bvh","name":"118_02__Jump"},
{"file":"@5\\118 Jumping\\118_03__Jump.bvh","name":"118_03__Jump"},
{"file":"@5\\118 Jumping\\118_04__Jump.bvh","name":"118_04__Jump"},
{"file":"@5\\118 Jumping\\118_05__Jump.bvh","name":"118_05__Jump"},
{"file":"@5\\118 Jumping\\118_06__Jump.bvh","name":"118_06__Jump"},
{"file":"@5\\118 Jumping\\118_07__Jump.bvh","name":"118_07__Jump"},
{"file":"@5\\118 Jumping\\118_08__Jump.bvh","name":"118_08__Jump"},
{"file":"@5\\118 Jumping\\118_09__Jump.bvh","name":"118_09__Jump"},
{"file":"@5\\118 Jumping\\118_10__Jump.bvh","name":"118_10__Jump"},
{"file":"@5\\118 Jumping\\118_11__Jump.bvh","name":"118_11__Jump"},
{"file":"@5\\118 Jumping\\118_12__Jump.bvh","name":"118_12__Jump"},
{"file":"@5\\118 Jumping\\118_13__Jump.bvh","name":"118_13__Jump"},
{"file":"@5\\118 Jumping\\118_14__Jump.bvh","name":"118_14__Jump"},
{"file":"@5\\118 Jumping\\118_15__Jump.bvh","name":"118_15__Jump"},
{"file":"@5\\118 Jumping\\118_16__Jump.bvh","name":"118_16__Jump"},
{"file":"@5\\118 Jumping\\118_17__Jump.bvh","name":"118_17__Jump"},
{"file":"@5\\118 Jumping\\118_18__Jump.bvh","name":"118_18__Jump"},
{"file":"@5\\118 Jumping\\118_19__Jump.bvh","name":"118_19__Jump"},
{"file":"@5\\118 Jumping\\118_20__Jump.bvh","name":"118_20__Jump"},
{"file":"@5\\118 Jumping\\118_21__Jump.bvh","name":"118_21__Jump"},
{"file":"@5\\118 Jumping\\118_22__Jump.bvh","name":"118_22__Jump"},
{"file":"@5\\118 Jumping\\118_23__Jump.bvh","name":"118_23__Jump"},
{"file":"@5\\118 Jumping\\118_24__Jump.bvh","name":"118_24__Jump"},
{"file":"@5\\118 Jumping\\118_25__Jump.bvh","name":"118_25__Jump"},
{"file":"@5\\118 Jumping\\118_26__Jump.bvh","name":"118_26__Jump"},
{"file":"@5\\118 Jumping\\118_27__Jump.bvh","name":"118_27__Jump"},
{"file":"@5\\118 Jumping\\118_28__Jump.bvh","name":"118_28__Jump"},
{"file":"@5\\118 Jumping\\118_29__Jump.bvh","name":"118_29__Jump"},
{"file":"@5\\118 Jumping\\118_30__Jump.bvh","name":"118_30__Jump"},
{"file":"@5\\118 Jumping\\118_31__Motorcycle.bvh","name":"118_31__Motorcycle"},
{"file":"@5\\120 Various Style Walks\\120_01__Alien Turn.bvh","name":"120_01__Alien Turn"},
{"file":"@5\\120 Various Style Walks\\120_07__Mickey Dance.bvh","name":"120_07__Mickey Dance"},
{"file":"@5\\120 Various Style Walks\\120_08__Mickey sneaky walk.bvh","name":"120_08__Mickey sneaky walk"},
{"file":"@5\\120 Various Style Walks\\120_10__Mickey sneaking walk.bvh","name":"120_10__Mickey sneaking walk"},
{"file":"@5\\120 Various Style Walks\\120_12__Mickey sneaking walk.bvh","name":"120_12__Mickey sneaking walk"},
{"file":"@5\\120 Various Style Walks\\120_13__Mickey sneaking walk.bvh","name":"120_13__Mickey sneaking walk"},
{"file":"@5\\120 Various Style Walks\\120_17__Mickey Walk.bvh","name":"120_17__Mickey Walk"},
{"file":"@5\\80 assorted motions\\80_01__shaking hands.bvh","name":"80_01__shaking hands"},
{"file":"@5\\80 assorted motions\\80_02__chopping onions.bvh","name":"80_02__chopping onions"},
{"file":"@5\\80 assorted motions\\80_03__shooting a gun.bvh","name":"80_03__shooting a gun"},
{"file":"@5\\80 assorted motions\\80_04__sewing.bvh","name":"80_04__sewing"},
{"file":"@5\\80 assorted motions\\80_05__digging a hole.bvh","name":"80_05__digging a hole"},
{"file":"@5\\80 assorted motions\\80_06__paying for something.bvh","name":"80_06__paying for something"},
{"file":"@5\\80 assorted motions\\80_08__picking up something.bvh","name":"80_08__picking up something"},
{"file":"@5\\80 assorted motions\\80_10__boxing.bvh","name":"80_10__boxing"},
{"file":"@5\\80 assorted motions\\80_11__putting on a sweater.bvh","name":"80_11__putting on a sweater"},
{"file":"@5\\80 assorted motions\\80_13__drumming.bvh","name":"80_13__drumming"},
{"file":"@5\\80 assorted motions\\80_22__putting on a hat.bvh","name":"80_22__putting on a hat"},
{"file":"@5\\80 assorted motions\\80_23__putting on a skirt.bvh","name":"80_23__putting on a skirt"},
{"file":"@5\\80 assorted motions\\80_25__answering a phone.bvh","name":"80_25__answering a phone"},
{"file":"@5\\80 assorted motions\\80_27__setting glass of water.bvh","name":"80_27__setting glass of water"},
{"file":"@5\\80 assorted motions\\80_28__drinking and smoking.bvh","name":"80_28__drinking and smoking"},
{"file":"@5\\80 assorted motions\\80_29__chugging.bvh","name":"80_29__chugging"},
{"file":"@5\\80 assorted motions\\80_40__drinking from bottle.bvh","name":"80_40__drinking from bottle"},
{"file":"@5\\80 assorted motions\\80_41__freezing.bvh","name":"80_41__freezing"},
{"file":"@5\\80 assorted motions\\80_43__happy.bvh","name":"80_43__happy"},
{"file":"@5\\80 assorted motions\\80_44__laughing.bvh","name":"80_44__laughing"},
{"file":"@5\\80 assorted motions\\80_47__Unknown.bvh","name":"80_47__Unknown"},
{"file":"@5\\80 assorted motions\\80_48__arguing.bvh","name":"80_48__arguing"},
{"file":"@5\\80 assorted motions\\80_56__chip monk.bvh","name":"80_56__chip monk"},
{"file":"@5\\80 assorted motions\\80_61__sweeping.bvh","name":"80_61__sweeping"},
{"file":"@5\\80 assorted motions\\80_71__chopping wood.bvh","name":"80_71__chopping wood"},
{"file":"@5\\80 assorted motions\\80_72__swimming.bvh","name":"80_72__swimming"},
{"file":"@5\\80 assorted motions\\80_73__shaking hands.bvh","name":"80_73__shaking hands"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_02__walk forward.bvh","name":"81_02__walk forward"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_03__walk.bvh","name":"81_03__walk"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_04__walk at a brisk pace.bvh","name":"81_04__walk at a brisk pace"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_07__pull heavy object.bvh","name":"81_07__pull heavy object"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_12__jump backwards off ledge.bvh","name":"81_12__jump backwards off ledge"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_13__jump backwards off ledge.bvh","name":"81_13__jump backwards off ledge"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_16__Unknown.bvh","name":"81_16__Unknown"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_17__walk forward.bvh","name":"81_17__walk forward"},
{"file":"@5\\81 pushing a box, jumping off a ledge, walks\\81_18__adjust hair walk forward.bvh","name":"81_18__adjust hair walk forward"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_01__Static pose.bvh","name":"82_01__Static pose"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_04__Jump off ledge.bvh","name":"82_04__Jump off ledge"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_06__Pushing on heavy object.bvh","name":"82_06__Pushing on heavy object"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_07__Pushing on heavy object.bvh","name":"82_07__Pushing on heavy object"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_10__sad walk forward.bvh","name":"82_10__sad walk forward"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_11__normal walk forward.bvh","name":"82_11__normal walk forward"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_12__happy or fast walk forward.bvh","name":"82_12__happy or fast walk forward"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_13__normal walk forward.bvh","name":"82_13__normal walk forward"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_14__walk forward and slow down.bvh","name":"82_14__walk forward and slow down"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_15__walk forward and turn sideways.bvh","name":"82_15__walk forward and turn sideways"},
{"file":"@5\\82 jumping, pushing, emotional walks\\82_18__static pose.bvh","name":"82_18__static pose"},
{"file":"@5\\83 steps\\83_01__large sidestep to right.bvh","name":"83_01__large sidestep to right"},
{"file":"@5\\83 steps\\83_02__sidestep to the right and up a ledge.bvh","name":"83_02__sidestep to the right and up a ledge"},
{"file":"@5\\83 steps\\83_03__large step to a short ledge.bvh","name":"83_03__large step to a short ledge"},
{"file":"@5\\83 steps\\83_04__large sidestep to right.bvh","name":"83_04__large sidestep to right"},
{"file":"@5\\83 steps\\83_05__very large sidestep to right.bvh","name":"83_05__very large sidestep to right"},
{"file":"@5\\83 steps\\83_06__very large sidestep to right and down.bvh","name":"83_06__very large sidestep to right and down"},
{"file":"@5\\83 steps\\83_07__short sidestep to right and down.bvh","name":"83_07__short sidestep to right and down"},
{"file":"@5\\83 steps\\83_08__medium step forward and down.bvh","name":"83_08__medium step forward and down"},
{"file":"@5\\83 steps\\83_09__short step forward and down.bvh","name":"83_09__short step forward and down"},
{"file":"@5\\83 steps\\83_10__medium step forward and down.bvh","name":"83_10__medium step forward and down"},
{"file":"@5\\83 steps\\83_11__static pose.bvh","name":"83_11__static pose"},
{"file":"@5\\83 steps\\83_12__medium sidestep to right and down.bvh","name":"83_12__medium sidestep to right and down"},
{"file":"@5\\83 steps\\83_13__large sidestep to right.bvh","name":"83_13__large sidestep to right"},
{"file":"@5\\83 steps\\83_14__short sidestep to left and down.bvh","name":"83_14__short sidestep to left and down"},
{"file":"@5\\83 steps\\83_15__short step forward.bvh","name":"83_15__short step forward"},
{"file":"@5\\83 steps\\83_16__medium sidestep to left and down.bvh","name":"83_16__medium sidestep to left and down"},
{"file":"@5\\83 steps\\83_17__medium step to left and down.bvh","name":"83_17__medium step to left and down"},
{"file":"@5\\83 steps\\83_18__short step to left and forward.bvh","name":"83_18__short step to left and forward"},
{"file":"@5\\83 steps\\83_19__medium sidestep to left.bvh","name":"83_19__medium sidestep to left"},
{"file":"@5\\83 steps\\83_20__medium step forward.bvh","name":"83_20__medium step forward"},
{"file":"@5\\83 steps\\83_21__large step to left and forward.bvh","name":"83_21__large step to left and forward"},
{"file":"@5\\83 steps\\83_23__short sidestep to left and up.bvh","name":"83_23__short sidestep to left and up"},
{"file":"@5\\83 steps\\83_24__medium step to left and up.bvh","name":"83_24__medium step to left and up"},
{"file":"@5\\83 steps\\83_25__short step forward and up.bvh","name":"83_25__short step forward and up"},
{"file":"@5\\83 steps\\83_26__medium step to left, forward, and up.bvh","name":"83_26__medium step to left, forward, and up"},
{"file":"@5\\83 steps\\83_27__walk forward stepping up stairs.bvh","name":"83_27__walk forward stepping up stairs"},
{"file":"@5\\83 steps\\83_28__walk forward stepping up stairs.bvh","name":"83_28__walk forward stepping up stairs"},
{"file":"@5\\83 steps\\83_29__walk forward stepping up stairs.bvh","name":"83_29__walk forward stepping up stairs"},
{"file":"@5\\83 steps\\83_30__walk forward stepping up stairs.bvh","name":"83_30__walk forward stepping up stairs"},
{"file":"@5\\83 steps\\83_31__walk forward stepping up stairs.bvh","name":"83_31__walk forward stepping up stairs"},
{"file":"@5\\83 steps\\83_32__walk forward stepping up stairs.bvh","name":"83_32__walk forward stepping up stairs"},
{"file":"@5\\83 steps\\83_34__walk forward and up stairs.bvh","name":"83_34__walk forward and up stairs"},
{"file":"@5\\83 steps\\83_35__walk forward and stepping up stairs.bvh","name":"83_35__walk forward and stepping up stairs"},
{"file":"@5\\83 steps\\83_36__walk forward turn 90 degrees left walk forward.bvh","name":"83_36__walk forward turn 90 degrees left walk forward"},
{"file":"@5\\83 steps\\83_37__walk forward turn 90 degrees right walk forward.bvh","name":"83_37__walk forward turn 90 degrees right walk forward"},
{"file":"@5\\83 steps\\83_38__walk forward turn 90 degrees left walk forward.bvh","name":"83_38__walk forward turn 90 degrees left walk forward"},
{"file":"@5\\83 steps\\83_39__walk forward turn 90 degrees right walk forward.bvh","name":"83_39__walk forward turn 90 degrees right walk forward"},
{"file":"@5\\83 steps\\83_40__hop forward.bvh","name":"83_40__hop forward"},
{"file":"@5\\83 steps\\83_41__hop forward.bvh","name":"83_41__hop forward"},
{"file":"@5\\83 steps\\83_42__long jump forward.bvh","name":"83_42__long jump forward"},
{"file":"@5\\83 steps\\83_43__long jump forward.bvh","name":"83_43__long jump forward"},
{"file":"@5\\83 steps\\83_44__medium step forward.bvh","name":"83_44__medium step forward"},
{"file":"@5\\83 steps\\83_45__hop forward.bvh","name":"83_45__hop forward"},
{"file":"@5\\83 steps\\83_46__medium hop forward.bvh","name":"83_46__medium hop forward"},
{"file":"@5\\83 steps\\83_47__long jump forward.bvh","name":"83_47__long jump forward"},
{"file":"@5\\83 steps\\83_48__short hop forward.bvh","name":"83_48__short hop forward"},
{"file":"@5\\83 steps\\83_49__medium hop forward.bvh","name":"83_49__medium hop forward"},
{"file":"@5\\83 steps\\83_50__long jump forward.bvh","name":"83_50__long jump forward"},
{"file":"@5\\83 steps\\83_51__hop turn 90 degrees left in air.bvh","name":"83_51__hop turn 90 degrees left in air"},
{"file":"@5\\83 steps\\83_52__hop turn 90 degrees left in air.bvh","name":"83_52__hop turn 90 degrees left in air"},
{"file":"@5\\83 steps\\83_53__hop turn 90 degrees left in air.bvh","name":"83_53__hop turn 90 degrees left in air"},
{"file":"@5\\83 steps\\83_54__hop turn 180 degrees left in air.bvh","name":"83_54__hop turn 180 degrees left in air"},
{"file":"@5\\83 steps\\83_55__medium sidestep to right.bvh","name":"83_55__medium sidestep to right"},
{"file":"@5\\83 steps\\83_56__hop turn left 180 degrees in air.bvh","name":"83_56__hop turn left 180 degrees in air"},
{"file":"@5\\83 steps\\83_57__hop turn left 180 degrees in air.bvh","name":"83_57__hop turn left 180 degrees in air"},
{"file":"@5\\83 steps\\83_58__hop turn left 270 degrees in air.bvh","name":"83_58__hop turn left 270 degrees in air"},
{"file":"@5\\83 steps\\83_59__hop turn left 270 degrees in air.bvh","name":"83_59__hop turn left 270 degrees in air"},
{"file":"@5\\83 steps\\83_60__hop turn left 270 degrees in air.bvh","name":"83_60__hop turn left 270 degrees in air"},
{"file":"@5\\83 steps\\83_61__hop turn 360 degrees left in air.bvh","name":"83_61__hop turn 360 degrees left in air"},
{"file":"@5\\83 steps\\83_62__hop turn left 360 degrees in air.bvh","name":"83_62__hop turn left 360 degrees in air"},
{"file":"@5\\83 steps\\83_63__large sidestep to right and forward.bvh","name":"83_63__large sidestep to right and forward"},
{"file":"@5\\83 steps\\83_64__hop and turn right 360 degrees in air.bvh","name":"83_64__hop and turn right 360 degrees in air"},
{"file":"@5\\83 steps\\83_65__hop and turn right 360 degrees in air.bvh","name":"83_65__hop and turn right 360 degrees in air"},
{"file":"@5\\83 steps\\83_66__short sidestep to right.bvh","name":"83_66__short sidestep to right"},
{"file":"@5\\83 steps\\83_67__short sidestep to the right.bvh","name":"83_67__short sidestep to the right"},
{"file":"@5\\83 steps\\83_68__medium sidestep to right.bvh","name":"83_68__medium sidestep to right"},
{"file":"@5\\84\\84_01.bvh","name":"84_01"},
{"file":"@5\\84\\84_02.bvh","name":"84_02"},
{"file":"@5\\84\\84_03.bvh","name":"84_03"},
{"file":"@5\\84\\84_04.bvh","name":"84_04"},
{"file":"@5\\84\\84_05.bvh","name":"84_05"},
{"file":"@5\\84\\84_06.bvh","name":"84_06"},
{"file":"@5\\84\\84_07.bvh","name":"84_07"},
{"file":"@5\\84\\84_08.bvh","name":"84_08"},
{"file":"@5\\84\\84_09.bvh","name":"84_09"},
{"file":"@5\\84\\84_10.bvh","name":"84_10"},
{"file":"@5\\84\\84_11.bvh","name":"84_11"},
{"file":"@5\\84\\84_12.bvh","name":"84_12"},
{"file":"@5\\84\\84_14.bvh","name":"84_14"},
{"file":"@5\\84\\84_15.bvh","name":"84_15"},
{"file":"@5\\84\\84_16.bvh","name":"84_16"},
{"file":"@5\\84\\84_17.bvh","name":"84_17"},
{"file":"@5\\84\\84_18.bvh","name":"84_18"},
{"file":"@5\\84\\84_19.bvh","name":"84_19"},
{"file":"@5\\84\\84_20.bvh","name":"84_20"},
{"file":"@5\\85 jumps, flips, breakdance\\85_01__JumpTwist.bvh","name":"85_01__JumpTwist"},
{"file":"@5\\85 jumps, flips, breakdance\\85_02__JumpTwist.bvh","name":"85_02__JumpTwist"},
{"file":"@5\\85 jumps, flips, breakdance\\85_06__KickFlip.bvh","name":"85_06__KickFlip"},
{"file":"@5\\85 jumps, flips, breakdance\\85_07__KickFlipStumble.bvh","name":"85_07__KickFlipStumble"},
{"file":"@5\\85 jumps, flips, breakdance\\85_08__Helicopter.bvh","name":"85_08__Helicopter"},
{"file":"@5\\85 jumps, flips, breakdance\\85_09__motorcycle pose.bvh","name":"85_09__motorcycle pose"},
{"file":"@5\\85 jumps, flips, breakdance\\85_10__EndofBreakDance.bvh","name":"85_10__EndofBreakDance"},
{"file":"@5\\87 acrobatics\\87_01__Jump with kick and spin.bvh","name":"87_01__Jump with kick and spin"},
{"file":"@5\\87 acrobatics\\87_02__T-Pose.bvh","name":"87_02__T-Pose"},
{"file":"@5\\87 acrobatics\\87_03__Backflip.bvh","name":"87_03__Backflip"},
{"file":"@5\\87 acrobatics\\87_04__backflip.bvh","name":"87_04__backflip"},
{"file":"@5\\87 acrobatics\\87_05__cartwheels.bvh","name":"87_05__cartwheels"},
{"file":"@5\\88 acrobatics\\88_01__backflip.bvh","name":"88_01__backflip"},
{"file":"@5\\88 acrobatics\\88_03__motorcycle pose.bvh","name":"88_03__motorcycle pose"},
{"file":"@5\\88 acrobatics\\88_05__cartwheel into backflip.bvh","name":"88_05__cartwheel into backflip"},
{"file":"@5\\88 acrobatics\\88_06__jump and spin kick.bvh","name":"88_06__jump and spin kick"},
{"file":"@5\\88 acrobatics\\88_07__cartwheel.bvh","name":"88_07__cartwheel"},
{"file":"@5\\88 acrobatics\\88_08__crouch and flip backward on hands.bvh","name":"88_08__crouch and flip backward on hands"},
{"file":"@5\\88 acrobatics\\88_09__stretch and cartwheel.bvh","name":"88_09__stretch and cartwheel"},
{"file":"@5\\88 acrobatics\\88_10__stretch and spin.bvh","name":"88_10__stretch and spin"},
{"file":"@5\\89 acrobatics\\89_02__motorcycle pose.bvh","name":"89_02__motorcycle pose"},
{"file":"@5\\89 acrobatics\\89_03__flip and stand on one hand.bvh","name":"89_03__flip and stand on one hand"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_01__bkwd summersult.bvh","name":"90_01__bkwd summersult"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_02__cartwheel.bvh","name":"90_02__cartwheel"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_03__cartwheel.bvh","name":"90_03__cartwheel"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_04__cartwheel.bvh","name":"90_04__cartwheel"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_05__jump kick.bvh","name":"90_05__jump kick"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_06__jump kick.bvh","name":"90_06__jump kick"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_07__jump kick.bvh","name":"90_07__jump kick"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_08__side flip.bvh","name":"90_08__side flip"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_09__Flip forward onto hands and back again.bvh","name":"90_09__Flip forward onto hands and back again"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_10__90_10.amc.bvh","name":"90_10__90_10"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_11__hand spring.bvh","name":"90_11__hand spring"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_12__bck flp twst fall.bvh","name":"90_12__bck flp twst fall"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_13__bck flp twst fall.bvh","name":"90_13__bck flp twst fall"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_14__front hand flip.bvh","name":"90_14__front hand flip"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_15__front hand flip.bvh","name":"90_15__front hand flip"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_16__fall on face.bvh","name":"90_16__fall on face"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_17__BannanaPeelSlip.bvh","name":"90_17__BannanaPeelSlip"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_18__RugPullFall.bvh","name":"90_18__RugPullFall"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_19__monkey backflip.bvh","name":"90_19__monkey backflip"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_22__straight walk.bvh","name":"90_22__straight walk"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_23__straight walk.bvh","name":"90_23__straight walk"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_24__ball mount.bvh","name":"90_24__ball mount"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_27__bwk ball walk.bvh","name":"90_27__bwk ball walk"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_28__breakdance.bvh","name":"90_28__breakdance"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_31__russian dance.bvh","name":"90_31__russian dance"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_32__moonwalk.bvh","name":"90_32__moonwalk"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_33__arm up wide leg roll.bvh","name":"90_33__arm up wide leg roll"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_34__wide leg roll.bvh","name":"90_34__wide leg roll"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_35__wide leg roll.bvh","name":"90_35__wide leg roll"},
{"file":"@5\\90 cartwheels, acrobatics, dances\\90_36__wide leg roll.bvh","name":"90_36__wide leg roll"},
{"file":"@5\\91 walks and turns\\91_06__Motorcycle Pose.bvh","name":"91_06__Motorcycle Pose"},
{"file":"@5\\91 walks and turns\\91_36__WalkStraight.bvh","name":"91_36__WalkStraight"},
{"file":"@5\\91 walks and turns\\91_37__Forward.bvh","name":"91_37__Forward"},
{"file":"@5\\91 walks and turns\\91_38__SmallForward.bvh","name":"91_38__SmallForward"},
{"file":"@5\\91 walks and turns\\91_39__JumpForward.bvh","name":"91_39__JumpForward"},
{"file":"@5\\91 walks and turns\\91_40__JumpForward.bvh","name":"91_40__JumpForward"},
{"file":"@5\\91 walks and turns\\91_41__JumpForward.bvh","name":"91_41__JumpForward"},
{"file":"@5\\91 walks and turns\\91_42__JumpForward.bvh","name":"91_42__JumpForward"},
{"file":"@5\\91 walks and turns\\91_43__JumpSmallForward.bvh","name":"91_43__JumpSmallForward"},
{"file":"@5\\91 walks and turns\\91_44__JumpSmallForward.bvh","name":"91_44__JumpSmallForward"},
{"file":"@5\\91 walks and turns\\91_45__JumpForward.bvh","name":"91_45__JumpForward"},
{"file":"@5\\91 walks and turns\\91_46__Jump Turn.bvh","name":"91_46__Jump Turn"},
{"file":"@5\\91 walks and turns\\91_47__Jump Turn.bvh","name":"91_47__Jump Turn"},
{"file":"@5\\91 walks and turns\\91_48__JumpTurn.bvh","name":"91_48__JumpTurn"},
{"file":"@5\\91 walks and turns\\91_49__Jump Turn.bvh","name":"91_49__Jump Turn"},
{"file":"@5\\91 walks and turns\\91_50__JumpTurn.bvh","name":"91_50__JumpTurn"},
{"file":"@5\\91 walks and turns\\91_51__FurtherJumpTurn.bvh","name":"91_51__FurtherJumpTurn"},
{"file":"@5\\91 walks and turns\\91_52__SmallJumpTurn.bvh","name":"91_52__SmallJumpTurn"},
{"file":"@5\\91 walks and turns\\91_53__180 degree jump.bvh","name":"91_53__180 degree jump"},
{"file":"@5\\91 walks and turns\\91_54__180.bvh","name":"91_54__180"},
{"file":"@5\\91 walks and turns\\91_55__180.bvh","name":"91_55__180"},
{"file":"@5\\91 walks and turns\\91_56__90.bvh","name":"91_56__90"},
{"file":"@5\\91 walks and turns\\91_57__WalkForward.bvh","name":"91_57__WalkForward"},
{"file":"@5\\91 walks and turns\\91_58__270.bvh","name":"91_58__270"},
{"file":"@5\\91 walks and turns\\91_59__360 smallStumble.bvh","name":"91_59__360 smallStumble"},
{"file":"@5\\91 walks and turns\\91_60__360.bvh","name":"91_60__360"},
{"file":"@5\\91 walks and turns\\91_61__360.bvh","name":"91_61__360"},
{"file":"@5\\93 Charleston Dance\\93_01__Motorcycle Pose.bvh","name":"93_01__Motorcycle Pose"},
{"file":"@5\\93 Charleston Dance\\93_03__charleston_01.bvh","name":"93_03__charleston_01"},
{"file":"@5\\93 Charleston Dance\\93_04__charleston_side_by_side_female.bvh","name":"93_04__charleston_side_by_side_female"},
{"file":"@5\\93 Charleston Dance\\93_05__charleston_side_by_side_male.bvh","name":"93_05__charleston_side_by_side_male"},
{"file":"@5\\93 Charleston Dance\\93_06__lindyHop2.bvh","name":"93_06__lindyHop2"},
{"file":"@5\\93 Charleston Dance\\93_07__Casual Walk.bvh","name":"93_07__Casual Walk"},
{"file":"@5\\93 Charleston Dance\\93_08__xtra fancY charleston.bvh","name":"93_08__xtra fancY charleston"},
{"file":"@6\\121\\121_01.bvh","name":"121_01"},
{"file":"@6\\121\\121_02.bvh","name":"121_02"},
{"file":"@6\\121\\121_03.bvh","name":"121_03"},
{"file":"@6\\121\\121_04.bvh","name":"121_04"},
{"file":"@6\\121\\121_05.bvh","name":"121_05"},
{"file":"@6\\121\\121_06.bvh","name":"121_06"},
{"file":"@6\\121\\121_07.bvh","name":"121_07"},
{"file":"@6\\121\\121_08.bvh","name":"121_08"},
{"file":"@6\\121\\121_09.bvh","name":"121_09"},
{"file":"@6\\121\\121_10.bvh","name":"121_10"},
{"file":"@6\\121\\121_11.bvh","name":"121_11"},
{"file":"@6\\121\\121_12.bvh","name":"121_12"},
{"file":"@6\\121\\121_13.bvh","name":"121_13"},
{"file":"@6\\121\\121_14.bvh","name":"121_14"},
{"file":"@6\\121\\121_15.bvh","name":"121_15"},
{"file":"@6\\121\\121_16.bvh","name":"121_16"},
{"file":"@6\\121\\121_17.bvh","name":"121_17"},
{"file":"@6\\121\\121_18.bvh","name":"121_18"},
{"file":"@6\\121\\121_19.bvh","name":"121_19"},
{"file":"@6\\121\\121_22.bvh","name":"121_22"},
{"file":"@6\\121\\121_23.bvh","name":"121_23"},
{"file":"@6\\121\\121_24.bvh","name":"121_24"},
{"file":"@6\\121\\121_27.bvh","name":"121_27"},
{"file":"@6\\121\\121_28.bvh","name":"121_28"},
{"file":"@6\\121\\121_31.bvh","name":"121_31"},
{"file":"@6\\121\\121_32.bvh","name":"121_32"},
{"file":"@6\\121\\121_33.bvh","name":"121_33"},
{"file":"@6\\121\\121_34.bvh","name":"121_34"},
{"file":"@6\\121\\121_35.bvh","name":"121_35"},
{"file":"@6\\121\\121_36.bvh","name":"121_36"},
{"file":"@6\\122 Varying Height and Length Steps\\122_01__clean.bvh","name":"122_01__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_02__clean.bvh","name":"122_02__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_03__clean.bvh","name":"122_03__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_04__clean.bvh","name":"122_04__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_05__clean.bvh","name":"122_05__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_06__clean.bvh","name":"122_06__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_07__clean.bvh","name":"122_07__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_08__clean.bvh","name":"122_08__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_09__clean.bvh","name":"122_09__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_10__clean.bvh","name":"122_10__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_11__Unknown.bvh","name":"122_11__Unknown"},
{"file":"@6\\122 Varying Height and Length Steps\\122_12__clean.bvh","name":"122_12__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_13__clean.bvh","name":"122_13__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_14__clean.bvh","name":"122_14__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_15__clean.bvh","name":"122_15__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_16__clean.bvh","name":"122_16__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_17__clean.bvh","name":"122_17__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_18__clean.bvh","name":"122_18__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_19__clean.bvh","name":"122_19__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_20__clean.bvh","name":"122_20__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_21__clean.bvh","name":"122_21__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_23__clean.bvh","name":"122_23__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_24__clean.bvh","name":"122_24__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_25__clean.bvh","name":"122_25__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_26__clean.bvh","name":"122_26__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_27__clean.bvh","name":"122_27__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_28__clean.bvh","name":"122_28__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_29__clean.bvh","name":"122_29__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_30__clean.bvh","name":"122_30__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_31__clean.bvh","name":"122_31__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_32__clean.bvh","name":"122_32__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_34__clean.bvh","name":"122_34__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_35__clean.bvh","name":"122_35__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_36__clean.bvh","name":"122_36__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_37__clean.bvh","name":"122_37__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_38__clean.bvh","name":"122_38__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_39__clean.bvh","name":"122_39__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_40__clean.bvh","name":"122_40__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_41__clean.bvh","name":"122_41__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_42__clean.bvh","name":"122_42__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_43__clean.bvh","name":"122_43__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_44__clean.bvh","name":"122_44__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_45__clean.bvh","name":"122_45__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_46__clean.bvh","name":"122_46__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_47__clean.bvh","name":"122_47__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_48__clean.bvh","name":"122_48__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_49__clean.bvh","name":"122_49__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_50__clean.bvh","name":"122_50__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_51__clean.bvh","name":"122_51__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_52__clean.bvh","name":"122_52__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_53__clean.bvh","name":"122_53__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_54__clean.bvh","name":"122_54__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_55__clean.bvh","name":"122_55__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_56__clean.bvh","name":"122_56__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_57__clean.bvh","name":"122_57__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_58__cleaned.bvh","name":"122_58__cleaned"},
{"file":"@6\\122 Varying Height and Length Steps\\122_59__clean.bvh","name":"122_59__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_60__clean.bvh","name":"122_60__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_61__clean.bvh","name":"122_61__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_62__clean.bvh","name":"122_62__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_63__clean.bvh","name":"122_63__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_64__clean.bvh","name":"122_64__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_65__clean.bvh","name":"122_65__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_66__clean.bvh","name":"122_66__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_67__clean.bvh","name":"122_67__clean"},
{"file":"@6\\122 Varying Height and Length Steps\\122_68__clean.bvh","name":"122_68__clean"},
{"file":"@6\\124 Sports Related Motions\\124_01__Baseball Pitch.bvh","name":"124_01__Baseball Pitch"},
{"file":"@6\\124 Sports Related Motions\\124_03__Basketball Shoot.bvh","name":"124_03__Basketball Shoot"},
{"file":"@6\\124 Sports Related Motions\\124_04__Basketball Free Throw.bvh","name":"124_04__Basketball Free Throw"},
{"file":"@6\\124 Sports Related Motions\\124_05__Basketball Jump Shot.bvh","name":"124_05__Basketball Jump Shot"},
{"file":"@6\\124 Sports Related Motions\\124_06__Basketball Lay Up.bvh","name":"124_06__Basketball Lay Up"},
{"file":"@6\\124 Sports Related Motions\\124_08__Baseball Bunt.bvh","name":"124_08__Baseball Bunt"},
{"file":"@6\\124 Sports Related Motions\\124_10__Motorcycle.bvh","name":"124_10__Motorcycle"},
{"file":"@6\\124 Sports Related Motions\\124_11__2 Foot Jump.bvh","name":"124_11__2 Foot Jump"},
{"file":"@6\\124 Sports Related Motions\\124_13__Underhand Fast Pitch.bvh","name":"124_13__Underhand Fast Pitch"},
{"file":"@6\\125 Swimming\\125_07__Motorcycle.bvh","name":"125_07__Motorcycle"},
{"file":"@6\\126 Swimming\\126_13__Motorcycle.bvh","name":"126_13__Motorcycle"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_01__Motorcycle.bvh","name":"127_01__Motorcycle"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_03__Run.bvh","name":"127_03__Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_04__Walk to Run.bvh","name":"127_04__Walk to Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_05__Run to Quick Stop.bvh","name":"127_05__Run to Quick Stop"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_06__Run.bvh","name":"127_06__Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_07__Run.bvh","name":"127_07__Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_08__Run.bvh","name":"127_08__Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_09__Run Right.bvh","name":"127_09__Run Right"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_10__Run Right.bvh","name":"127_10__Run Right"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_11__Run Left.bvh","name":"127_11__Run Left"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_12__Run Left.bvh","name":"127_12__Run Left"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_13__Run Side Step Left.bvh","name":"127_13__Run Side Step Left"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_14__Run Side Step Right.bvh","name":"127_14__Run Side Step Right"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_15__Run Turn Left.bvh","name":"127_15__Run Turn Left"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_16__Run Turn Right.bvh","name":"127_16__Run Turn Right"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_17__Run Stop Run.bvh","name":"127_17__Run Stop Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_18__Run Stop Run.bvh","name":"127_18__Run Stop Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_19__Run Quick Stop Run.bvh","name":"127_19__Run Quick Stop Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_20__Run Quick Stop Run.bvh","name":"127_20__Run Quick Stop Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_21__Run Jump Stop Run.bvh","name":"127_21__Run Jump Stop Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_22__Run Jump Stop Run.bvh","name":"127_22__Run Jump Stop Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_23__Run Dive Over Roll Run.bvh","name":"127_23__Run Dive Over Roll Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_24__Run Dive Over Roll Run.bvh","name":"127_24__Run Dive Over Roll Run"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_25__Run Jump Over.bvh","name":"127_25__Run Jump Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_26__Run Jump Over.bvh","name":"127_26__Run Jump Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_27__Run Jump Over.bvh","name":"127_27__Run Jump Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_28__Run Jump Over.bvh","name":"127_28__Run Jump Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_29__Run Duck Underneath.bvh","name":"127_29__Run Duck Underneath"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_30__Run Duck Underneath.bvh","name":"127_30__Run Duck Underneath"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_31__Run Duck Underneath.bvh","name":"127_31__Run Duck Underneath"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_32__Run Duck Underneath.bvh","name":"127_32__Run Duck Underneath"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_33__Run Over.bvh","name":"127_33__Run Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_34__Run Over.bvh","name":"127_34__Run Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_35__Run Over.bvh","name":"127_35__Run Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_36__Run Over.bvh","name":"127_36__Run Over"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_37__Run Duck Underneath.bvh","name":"127_37__Run Duck Underneath"},
{"file":"@6\\127 Action Adventure Obstacles, running, jumping, ducking, rolling\\127_38__Run Duck Underneath.bvh","name":"127_38__Run Duck Underneath"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_01__Motorcycle.bvh","name":"128_01__Motorcycle"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_02__Run Left.bvh","name":"128_02__Run Left"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_03__Run Right.bvh","name":"128_03__Run Right"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_04__Run Duck Underneath.bvh","name":"128_04__Run Duck Underneath"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_05__Run Stop Run.bvh","name":"128_05__Run Stop Run"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_06__Run Stop Run.bvh","name":"128_06__Run Stop Run"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_07__Run Stop Run.bvh","name":"128_07__Run Stop Run"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_08__Run Stop Run.bvh","name":"128_08__Run Stop Run"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_09__Run Roll Underneath.bvh","name":"128_09__Run Roll Underneath"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_10__Run Dive Over Roll Run.bvh","name":"128_10__Run Dive Over Roll Run"},
{"file":"@6\\128 Action Adventure Motions running, ducking, rolling, stopping\\128_11__Run Dive Over Roll Run.bvh","name":"128_11__Run Dive Over Roll Run"},
{"file":"@6\\132 Varying Weird Walks\\132_02__Walk With Arms Out, balancing.bvh","name":"132_02__Walk With Arms Out, balancing"},
{"file":"@6\\132 Varying Weird Walks\\132_07__Walk With Arms Out, balancing.bvh","name":"132_07__Walk With Arms Out, balancing"},
{"file":"@6\\132 Varying Weird Walks\\132_09__Walk With Arms Out, balancing.bvh","name":"132_09__Walk With Arms Out, balancing"},
{"file":"@6\\132 Varying Weird Walks\\132_17__Walk Fast.bvh","name":"132_17__Walk Fast"},
{"file":"@6\\132 Varying Weird Walks\\132_18__Walk Fast.bvh","name":"132_18__Walk Fast"},
{"file":"@6\\132 Varying Weird Walks\\132_19__Walk Fast.bvh","name":"132_19__Walk Fast"},
{"file":"@6\\132 Varying Weird Walks\\132_20__Walk Fast.bvh","name":"132_20__Walk Fast"},
{"file":"@6\\132 Varying Weird Walks\\132_21__Walk Fast.bvh","name":"132_21__Walk Fast"},
{"file":"@6\\132 Varying Weird Walks\\132_22__Walk Fast.bvh","name":"132_22__Walk Fast"},
{"file":"@6\\132 Varying Weird Walks\\132_23__Hop on left foot.bvh","name":"132_23__Hop on left foot"},
{"file":"@6\\132 Varying Weird Walks\\132_24__Hop on left foot.bvh","name":"132_24__Hop on left foot"},
{"file":"@6\\132 Varying Weird Walks\\132_25__Hop on left foot.bvh","name":"132_25__Hop on left foot"},
{"file":"@6\\132 Varying Weird Walks\\132_26__Hop on left foot.bvh","name":"132_26__Hop on left foot"},
{"file":"@6\\132 Varying Weird Walks\\132_27__Hop on left foot.bvh","name":"132_27__Hop on left foot"},
{"file":"@6\\132 Varying Weird Walks\\132_28__Hop on left foot.bvh","name":"132_28__Hop on left foot"},
{"file":"@6\\132 Varying Weird Walks\\132_29__Bouncy Walk.bvh","name":"132_29__Bouncy Walk"},
{"file":"@6\\132 Varying Weird Walks\\132_30__Bouncy Walk.bvh","name":"132_30__Bouncy Walk"},
{"file":"@6\\132 Varying Weird Walks\\132_31__Bouncy Walk.bvh","name":"132_31__Bouncy Walk"},
{"file":"@6\\132 Varying Weird Walks\\132_32__Bouncy Walk.bvh","name":"132_32__Bouncy Walk"},
{"file":"@6\\132 Varying Weird Walks\\132_33__Bouncy Walk.bvh","name":"132_33__Bouncy Walk"},
{"file":"@6\\132 Varying Weird Walks\\132_34__Bouncy Walk.bvh","name":"132_34__Bouncy Walk"},
{"file":"@6\\132 Varying Weird Walks\\132_38__Motorcycle.bvh","name":"132_38__Motorcycle"},
{"file":"@6\\132 Varying Weird Walks\\132_40__Walk With Stiff Arms.bvh","name":"132_40__Walk With Stiff Arms"},
{"file":"@6\\132 Varying Weird Walks\\132_42__Walk Swinging Shoulders.bvh","name":"132_42__Walk Swinging Shoulders"},
{"file":"@6\\132 Varying Weird Walks\\132_43__Walk Swinging Shoulders.bvh","name":"132_43__Walk Swinging Shoulders"},
{"file":"@6\\132 Varying Weird Walks\\132_46__Walk Slow.bvh","name":"132_46__Walk Slow"},
{"file":"@6\\132 Varying Weird Walks\\132_51__Tpose.bvh","name":"132_51__Tpose"},
{"file":"@6\\135 Martial Arts Walks\\135_08__Motorcycle.bvh","name":"135_08__Motorcycle"},
{"file":"@6\\136 Weird Walks\\136_01__Walk Bent Forward.bvh","name":"136_01__Walk Bent Forward"},
{"file":"@6\\136 Weird Walks\\136_02__Walk Bent Forward.bvh","name":"136_02__Walk Bent Forward"},
{"file":"@6\\136 Weird Walks\\136_03__Walk Backwards Bent Forward.bvh","name":"136_03__Walk Backwards Bent Forward"},
{"file":"@6\\136 Weird Walks\\136_05__Walk on Toes Bent Forward.bvh","name":"136_05__Walk on Toes Bent Forward"},
{"file":"@6\\136 Weird Walks\\136_06__Walk on Toes Bent Forward.bvh","name":"136_06__Walk on Toes Bent Forward"},
{"file":"@6\\136 Weird Walks\\136_07__Walk Backward on Toes Bent Forward.bvh","name":"136_07__Walk Backward on Toes Bent Forward"},
{"file":"@6\\136 Weird Walks\\136_09__Walk Crouched.bvh","name":"136_09__Walk Crouched"},
{"file":"@6\\136 Weird Walks\\136_14__Walk on Toes Crouched.bvh","name":"136_14__Walk on Toes Crouched"},
{"file":"@6\\136 Weird Walks\\136_19__Motorcycle.bvh","name":"136_19__Motorcycle"},
{"file":"@6\\136 Weird Walks\\136_20__Normal Walk.bvh","name":"136_20__Normal Walk"},
{"file":"@6\\136 Weird Walks\\136_21__Normal Walk.bvh","name":"136_21__Normal Walk"},
{"file":"@6\\136 Weird Walks\\136_22__Normal Walk.bvh","name":"136_22__Normal Walk"},
{"file":"@6\\136 Weird Walks\\136_23__Normal Walk.bvh","name":"136_23__Normal Walk"},
{"file":"@6\\136 Weird Walks\\136_24__Normal Walk.bvh","name":"136_24__Normal Walk"},
{"file":"@6\\136 Weird Walks\\136_27__Walk on Toes.bvh","name":"136_27__Walk on Toes"},
{"file":"@6\\136 Weird Walks\\136_28__Walk on Toes.bvh","name":"136_28__Walk on Toes"},
{"file":"@6\\136 Weird Walks\\136_29__Walk Backwards on Toes.bvh","name":"136_29__Walk Backwards on Toes"},
{"file":"@6\\136 Weird Walks\\136_33__Range of Motion.bvh","name":"136_33__Range of Motion"},
{"file":"@6\\137 Stylized Motions\\137_24__Graceful Lady Walk.bvh","name":"137_24__Graceful Lady Walk"},
{"file":"@6\\137 Stylized Motions\\137_25__Motorcycle.bvh","name":"137_25__Motorcycle"},
{"file":"@6\\137 Stylized Motions\\137_27__Normal Pick Up.bvh","name":"137_27__Normal Pick Up"},
{"file":"@6\\137 Stylized Motions\\137_29__Normal Walk.bvh","name":"137_29__Normal Walk"},
{"file":"@6\\137 Stylized Motions\\137_34__Range of Motion.bvh","name":"137_34__Range of Motion"},
{"file":"@6\\138 Marching, Walking and Talking\\138_01__Marching.bvh","name":"138_01__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_02__Marching.bvh","name":"138_02__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_03__Marching.bvh","name":"138_03__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_04__Marching.bvh","name":"138_04__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_05__Marching.bvh","name":"138_05__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_06__Marching.bvh","name":"138_06__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_07__Marching.bvh","name":"138_07__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_08__Marching.bvh","name":"138_08__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_09__Marching.bvh","name":"138_09__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_10__Marching.bvh","name":"138_10__Marching"},
{"file":"@6\\138 Marching, Walking and Talking\\138_11__Story.bvh","name":"138_11__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_12__Story.bvh","name":"138_12__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_13__Story.bvh","name":"138_13__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_14__Story.bvh","name":"138_14__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_15__Story.bvh","name":"138_15__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_16__Story.bvh","name":"138_16__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_17__Story.bvh","name":"138_17__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_18__Story.bvh","name":"138_18__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_19__Story.bvh","name":"138_19__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_20__Story.bvh","name":"138_20__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_21__Story.bvh","name":"138_21__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_22__Story.bvh","name":"138_22__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_23__Story.bvh","name":"138_23__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_24__Story.bvh","name":"138_24__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_25__Story.bvh","name":"138_25__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_26__Story.bvh","name":"138_26__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_27__Story.bvh","name":"138_27__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_28__Story.bvh","name":"138_28__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_29__Story.bvh","name":"138_29__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_30__Story.bvh","name":"138_30__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_31__Story.bvh","name":"138_31__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_32__Story.bvh","name":"138_32__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_33__Story.bvh","name":"138_33__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_34__Story.bvh","name":"138_34__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_35__Story.bvh","name":"138_35__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_36__Story.bvh","name":"138_36__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_37__Story.bvh","name":"138_37__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_38__Story.bvh","name":"138_38__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_39__Story.bvh","name":"138_39__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_40__Story.bvh","name":"138_40__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_41__Story.bvh","name":"138_41__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_42__Story.bvh","name":"138_42__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_43__Story.bvh","name":"138_43__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_44__Story.bvh","name":"138_44__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_45__Story.bvh","name":"138_45__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_46__Story.bvh","name":"138_46__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_47__Story.bvh","name":"138_47__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_48__Story.bvh","name":"138_48__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_49__Story.bvh","name":"138_49__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_50__Story.bvh","name":"138_50__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_51__Story.bvh","name":"138_51__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_52__Story.bvh","name":"138_52__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_53__Story.bvh","name":"138_53__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_54__Story.bvh","name":"138_54__Story"},
{"file":"@6\\138 Marching, Walking and Talking\\138_55__Story.bvh","name":"138_55__Story"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_01__Looking Around.bvh","name":"139_01__Looking Around"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_02__Shifting Weight.bvh","name":"139_02__Shifting Weight"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_03__Looking Around.bvh","name":"139_03__Looking Around"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_04__Looking Around.bvh","name":"139_04__Looking Around"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_05__Pulling a Gun.bvh","name":"139_05__Pulling a Gun"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_07__Poking Around On The Ground.bvh","name":"139_07__Poking Around On The Ground"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_08__Poking Around On The Ground.bvh","name":"139_08__Poking Around On The Ground"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_09__Ducking.bvh","name":"139_09__Ducking"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_10__Run.bvh","name":"139_10__Run"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_11__Run To Sneak.bvh","name":"139_11__Run To Sneak"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_12__Run in Circles.bvh","name":"139_12__Run in Circles"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_14__Sneak Sideways.bvh","name":"139_14__Sneak Sideways"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_15__Sneak Sideways.bvh","name":"139_15__Sneak Sideways"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_16__Get Up From Ground.bvh","name":"139_16__Get Up From Ground"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_17__Get Up From Ground.bvh","name":"139_17__Get Up From Ground"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_18__Get Up From Ground Laying on Back.bvh","name":"139_18__Get Up From Ground Laying on Back"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_19__Walk Wounded Leg.bvh","name":"139_19__Walk Wounded Leg"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_24__Walk Wounded Leg.bvh","name":"139_24__Walk Wounded Leg"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_25__Giving Directions.bvh","name":"139_25__Giving Directions"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_26__Looking Around.bvh","name":"139_26__Looking Around"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_27__Looking Around.bvh","name":"139_27__Looking Around"},
{"file":"@6\\139 Action Walks, sneaking, wounded, looking around\\139_34__Sneaking.bvh","name":"139_34__Sneaking"},
{"file":"@6\\140 Getting Up From Ground\\140_01__Get Up Face Down.bvh","name":"140_01__Get Up Face Down"},
{"file":"@6\\140 Getting Up From Ground\\140_02__Get Up Face Down.bvh","name":"140_02__Get Up Face Down"},
{"file":"@6\\140 Getting Up From Ground\\140_03__Get Up Laying on Side.bvh","name":"140_03__Get Up Laying on Side"},
{"file":"@6\\140 Getting Up From Ground\\140_04__Get Up Laying on Side.bvh","name":"140_04__Get Up Laying on Side"},
{"file":"@6\\140 Getting Up From Ground\\140_05__Motorcycle.bvh","name":"140_05__Motorcycle"},
{"file":"@6\\140 Getting Up From Ground\\140_08__Get Up From Ground Laying on Back.bvh","name":"140_08__Get Up From Ground Laying on Back"},
{"file":"@6\\140 Getting Up From Ground\\140_09__Get Up From Ground Laying on Back.bvh","name":"140_09__Get Up From Ground Laying on Back"},
{"file":"@6\\141 General Subject Capture\\141_01__Run.bvh","name":"141_01__Run"},
{"file":"@6\\141 General Subject Capture\\141_02__Run.bvh","name":"141_02__Run"},
{"file":"@6\\141 General Subject Capture\\141_03__Run.bvh","name":"141_03__Run"},
{"file":"@6\\141 General Subject Capture\\141_04__Jump Distances.bvh","name":"141_04__Jump Distances"},
{"file":"@6\\141 General Subject Capture\\141_05__Jump Sideways.bvh","name":"141_05__Jump Sideways"},
{"file":"@6\\141 General Subject Capture\\141_06__Jump Twist.bvh","name":"141_06__Jump Twist"},
{"file":"@6\\141 General Subject Capture\\141_07__Walk Up and Over.bvh","name":"141_07__Walk Up and Over"},
{"file":"@6\\141 General Subject Capture\\141_08__Steop On Walk Down.bvh","name":"141_08__Steop On Walk Down"},
{"file":"@6\\141 General Subject Capture\\141_09__Step Over.bvh","name":"141_09__Step Over"},
{"file":"@6\\141 General Subject Capture\\141_10__Toss and Catch.bvh","name":"141_10__Toss and Catch"},
{"file":"@6\\141 General Subject Capture\\141_11__Throw and Catch.bvh","name":"141_11__Throw and Catch"},
{"file":"@6\\141 General Subject Capture\\141_12__Dance, Twist.bvh","name":"141_12__Dance, Twist"},
{"file":"@6\\141 General Subject Capture\\141_13__Stretch and Yawn.bvh","name":"141_13__Stretch and Yawn"},
{"file":"@6\\141 General Subject Capture\\141_14__Punch and Kick.bvh","name":"141_14__Punch and Kick"},
{"file":"@6\\141 General Subject Capture\\141_15__Range of Motion.bvh","name":"141_15__Range of Motion"},
{"file":"@6\\141 General Subject Capture\\141_16__Wave Hello.bvh","name":"141_16__Wave Hello"},
{"file":"@6\\141 General Subject Capture\\141_17__Sit on Stool.bvh","name":"141_17__Sit on Stool"},
{"file":"@6\\141 General Subject Capture\\141_18__Peek a Boo.bvh","name":"141_18__Peek a Boo"},
{"file":"@6\\141 General Subject Capture\\141_19__Walk.bvh","name":"141_19__Walk"},
{"file":"@6\\141 General Subject Capture\\141_20__Waiting.bvh","name":"141_20__Waiting"},
{"file":"@6\\141 General Subject Capture\\141_21__Shrug.bvh","name":"141_21__Shrug"},
{"file":"@6\\141 General Subject Capture\\141_22__High Five.bvh","name":"141_22__High Five"},
{"file":"@6\\141 General Subject Capture\\141_23__Shake Hands.bvh","name":"141_23__Shake Hands"},
{"file":"@6\\141 General Subject Capture\\141_24__Around the world High Five Low.bvh","name":"141_24__Around the world High Five Low"},
{"file":"@6\\141 General Subject Capture\\141_25__Walk.bvh","name":"141_25__Walk"},
{"file":"@6\\141 General Subject Capture\\141_26__Curtsey.bvh","name":"141_26__Curtsey"},
{"file":"@6\\141 General Subject Capture\\141_27__Mope.bvh","name":"141_27__Mope"},
{"file":"@6\\141 General Subject Capture\\141_28__Slap Hands, Throw it Back.bvh","name":"141_28__Slap Hands, Throw it Back"},
{"file":"@6\\141 General Subject Capture\\141_29__Random Walk.bvh","name":"141_29__Random Walk"},
{"file":"@6\\141 General Subject Capture\\141_30__Random Walk.bvh","name":"141_30__Random Walk"},
{"file":"@6\\141 General Subject Capture\\141_31__Walk Backwards.bvh","name":"141_31__Walk Backwards"},
{"file":"@6\\141 General Subject Capture\\141_32__Walk Sideways, Cross Legs.bvh","name":"141_32__Walk Sideways, Cross Legs"},
{"file":"@6\\141 General Subject Capture\\141_33__Walk Sideways, Foot to Foot.bvh","name":"141_33__Walk Sideways, Foot to Foot"},
{"file":"@6\\141 General Subject Capture\\141_34__Run.bvh","name":"141_34__Run"},
{"file":"@6\\143 General Subject Capture\\143_01__Run.bvh","name":"143_01__Run"},
{"file":"@6\\143 General Subject Capture\\143_02__Run to Stop.bvh","name":"143_02__Run to Stop"},
{"file":"@6\\143 General Subject Capture\\143_03__Start to Run.bvh","name":"143_03__Start to Run"},
{"file":"@6\\143 General Subject Capture\\143_04__Run Figure 8.bvh","name":"143_04__Run Figure 8"},
{"file":"@6\\143 General Subject Capture\\143_05__Jumping Distances.bvh","name":"143_05__Jumping Distances"},
{"file":"@6\\143 General Subject Capture\\143_06__Jumping Heights.bvh","name":"143_06__Jumping Heights"},
{"file":"@6\\143 General Subject Capture\\143_07__Jumping Sideways.bvh","name":"143_07__Jumping Sideways"},
{"file":"@6\\143 General Subject Capture\\143_08__Jumping Twists.bvh","name":"143_08__Jumping Twists"},
{"file":"@6\\143 General Subject Capture\\143_09__Jumping Twists.bvh","name":"143_09__Jumping Twists"},
{"file":"@6\\143 General Subject Capture\\143_10__Walk And Pick up Tool Box.bvh","name":"143_10__Walk And Pick up Tool Box"},
{"file":"@6\\143 General Subject Capture\\143_11__Walk And Pick up Box.bvh","name":"143_11__Walk And Pick up Box"},
{"file":"@6\\143 General Subject Capture\\143_12__Walk And Pick up Toolbox.bvh","name":"143_12__Walk And Pick up Toolbox"},
{"file":"@6\\143 General Subject Capture\\143_13__Walk and Pick up Laundry Basket.bvh","name":"143_13__Walk and Pick up Laundry Basket"},
{"file":"@6\\143 General Subject Capture\\143_14__Walk And Step Over.bvh","name":"143_14__Walk And Step Over"},
{"file":"@6\\143 General Subject Capture\\143_15__Walk And Step Over.bvh","name":"143_15__Walk And Step Over"},
{"file":"@6\\143 General Subject Capture\\143_16__Walk And Step Over.bvh","name":"143_16__Walk And Step Over"},
{"file":"@6\\143 General Subject Capture\\143_17__Walk Up Stairs And Over.bvh","name":"143_17__Walk Up Stairs And Over"},
{"file":"@6\\143 General Subject Capture\\143_18__Sit Down And Get Up.bvh","name":"143_18__Sit Down And Get Up"},
{"file":"@6\\143 General Subject Capture\\143_19__Sit On Stool And Get Up.bvh","name":"143_19__Sit On Stool And Get Up"},
{"file":"@6\\143 General Subject Capture\\143_20__Catch And Throw.bvh","name":"143_20__Catch And Throw"},
{"file":"@6\\143 General Subject Capture\\143_22__Catch And Throw Football.bvh","name":"143_22__Catch And Throw Football"},
{"file":"@6\\143 General Subject Capture\\143_23__Punching.bvh","name":"143_23__Punching"},
{"file":"@6\\143 General Subject Capture\\143_24__Kicking.bvh","name":"143_24__Kicking"},
{"file":"@6\\143 General Subject Capture\\143_25__Waving.bvh","name":"143_25__Waving"},
{"file":"@6\\143 General Subject Capture\\143_26__Washing Window.bvh","name":"143_26__Washing Window"},
{"file":"@6\\143 General Subject Capture\\143_27__Washing Window.bvh","name":"143_27__Washing Window"},
{"file":"@6\\143 General Subject Capture\\143_28__Sweeping, Push Broom.bvh","name":"143_28__Sweeping, Push Broom"},
{"file":"@6\\143 General Subject Capture\\143_29__Pacing.bvh","name":"143_29__Pacing"},
{"file":"@6\\143 General Subject Capture\\143_30__Stretch And Yawn.bvh","name":"143_30__Stretch And Yawn"},
{"file":"@6\\143 General Subject Capture\\143_31__Hopscotch.bvh","name":"143_31__Hopscotch"},
{"file":"@6\\143 General Subject Capture\\143_32__Walk.bvh","name":"143_32__Walk"},
{"file":"@6\\143 General Subject Capture\\143_33__Peek A Boo.bvh","name":"143_33__Peek A Boo"},
{"file":"@6\\143 General Subject Capture\\143_34__Chicken Dance.bvh","name":"143_34__Chicken Dance"},
{"file":"@6\\143 General Subject Capture\\143_36__Airplane.bvh","name":"143_36__Airplane"},
{"file":"@6\\143 General Subject Capture\\143_37__Climb Up And Down Ladder.bvh","name":"143_37__Climb Up And Down Ladder"},
{"file":"@6\\143 General Subject Capture\\143_39__Walk Backwards.bvh","name":"143_39__Walk Backwards"},
{"file":"@6\\143 General Subject Capture\\143_40__Walk Sideways.bvh","name":"143_40__Walk Sideways"},
{"file":"@6\\143 General Subject Capture\\143_41__Sneak.bvh","name":"143_41__Sneak"},
{"file":"@6\\143 General Subject Capture\\143_42__Run.bvh","name":"143_42__Run"},
{"file":"@6\\144 punching female\\144_19__motorcycle pose.bvh","name":"144_19__motorcycle pose"},
];DATA['ambience']= [
    {
        "name": "airtone",
        "ext": "ogg"
    },
    {
        "name": "birds",
        "ext": "ogg"
    },
    {
        "name": "cafe",
        "ext": "ogg"
    },
    {
        "name": "dark",
        "ext": "ogg"
    },
    {
        "name": "industrial",
        "ext": "ogg"
    },
    {
        "name": "lofi",
        "ext": "ogg"
    },
    {
        "name": "loundry",
        "ext": "ogg"
    },
    {
        "name": "night",
        "ext": "ogg"
    },
    {
        "name": "noir",
        "ext": "ogg"
    },
    {
        "name": "outsiderestaurant",
        "ext": "ogg"
    },
    {
        "name": "rain",
        "ext": "ogg"
    },
    {
        "name": "rainindoor",
        "ext": "ogg"
    },
    {
        "name": "restaurant",
        "ext": "ogg"
    },
    {
        "name": "retroscifi",
        "ext": "ogg"
    },
    {
        "name": "suburban",
        "ext": "ogg"
    },
    {
        "name": "wind",
        "ext": "ogg"
    }
];DATA['sexposes']= [
    {
        "name": "69",
        "ext": "json"
    },
    {
        "name": "8 G Spot",
        "ext": "json"
    },
    {
        "name": "acrobat",
        "ext": "json"
    },
    {
        "name": "amazon",
        "ext": "json"
    },
    {
        "name": "asian cowgirl",
        "ext": "json"
    },
    {
        "name": "ballerina",
        "ext": "json"
    },
    {
        "name": "bassett hound",
        "ext": "json"
    },
    {
        "name": "bed handjob",
        "ext": "json"
    },
    {
        "name": "bed head",
        "ext": "json"
    },
    {
        "name": "bent spoon",
        "ext": "json"
    },
    {
        "name": "betty rocker",
        "ext": "json"
    },
    {
        "name": "blooming orchid",
        "ext": "json"
    },
    {
        "name": "bookends",
        "ext": "json"
    },
    {
        "name": "boss chair bj",
        "ext": "json"
    },
    {
        "name": "bouncing spoon",
        "ext": "json"
    },
    {
        "name": "bridge",
        "ext": "json"
    },
    {
        "name": "butterfly",
        "ext": "json"
    },
    {
        "name": "cinema bj",
        "ext": "json"
    },
    {
        "name": "coital alignment",
        "ext": "json"
    },
    {
        "name": "corner cowgirl",
        "ext": "json"
    },
    {
        "name": "cowgirl",
        "ext": "json"
    },
    {
        "name": "crab",
        "ext": "json"
    },
    {
        "name": "criss cross",
        "ext": "json"
    },
    {
        "name": "doctor bj",
        "ext": "json"
    },
    {
        "name": "doggy",
        "ext": "json"
    },
    {
        "name": "down stroke",
        "ext": "json"
    },
    {
        "name": "drill",
        "ext": "json"
    },
    {
        "name": "face fuck bj",
        "ext": "json"
    },
    {
        "name": "face to face",
        "ext": "json"
    },
    {
        "name": "fire hydrant",
        "ext": "json"
    },
    {
        "name": "intersection",
        "ext": "json"
    },
    {
        "name": "irish garden",
        "ext": "json"
    },
    {
        "name": "italian chandelier",
        "ext": "json"
    },
    {
        "name": "jellyfish",
        "ext": "json"
    },
    {
        "name": "jugghead",
        "ext": "json"
    },
    {
        "name": "kneeling bj",
        "ext": "json"
    },
    {
        "name": "kneeling",
        "ext": "json"
    },
    {
        "name": "lap dance",
        "ext": "json"
    },
    {
        "name": "launch pad",
        "ext": "json"
    },
    {
        "name": "leapfrog",
        "ext": "json"
    },
    {
        "name": "leg glider",
        "ext": "json"
    },
    {
        "name": "legs over shoulder",
        "ext": "json"
    },
    {
        "name": "lie back bj",
        "ext": "json"
    },
    {
        "name": "life raft",
        "ext": "json"
    },
    {
        "name": "lotus",
        "ext": "json"
    },
    {
        "name": "lunge",
        "ext": "json"
    },
    {
        "name": "man missionary",
        "ext": "json"
    },
    {
        "name": "missionary hanging",
        "ext": "json"
    },
    {
        "name": "missionary",
        "ext": "json"
    },
    {
        "name": "octopus",
        "ext": "json"
    },
    {
        "name": "pearly gates",
        "ext": "json"
    },
    {
        "name": "piston",
        "ext": "json"
    },
    {
        "name": "plumber bj",
        "ext": "json"
    },
    {
        "name": "pretzel",
        "ext": "json"
    },
    {
        "name": "prison",
        "ext": "json"
    },
    {
        "name": "quickie",
        "ext": "json"
    },
    {
        "name": "reverse cowgirl",
        "ext": "json"
    },
    {
        "name": "right angle",
        "ext": "json"
    },
    {
        "name": "sandwich",
        "ext": "json"
    },
    {
        "name": "scissor",
        "ext": "json"
    },
    {
        "name": "screw",
        "ext": "json"
    },
    {
        "name": "seesaw",
        "ext": "json"
    },
    {
        "name": "side ride",
        "ext": "json"
    },
    {
        "name": "sitting",
        "ext": "json"
    },
    {
        "name": "sofa",
        "ext": "json"
    },
    {
        "name": "spooning",
        "ext": "json"
    },
    {
        "name": "spread legs",
        "ext": "json"
    },
    {
        "name": "stairs",
        "ext": "json"
    },
    {
        "name": "stand and carry",
        "ext": "json"
    },
    {
        "name": "standing 69",
        "ext": "json"
    },
    {
        "name": "sybian",
        "ext": "json"
    },
    {
        "name": "teaspooning",
        "ext": "json"
    },
    {
        "name": "tug of love",
        "ext": "json"
    },
    {
        "name": "turtle",
        "ext": "json"
    },
    {
        "name": "viennese oyster",
        "ext": "json"
    },
    {
        "name": "washing machine",
        "ext": "json"
    },
    {
        "name": "wheelbarrow",
        "ext": "json"
    }
];